       IDENTIFICATION DIVISION.
       PROGRAM-ID. VFAT200.
      *
      * OGGETTO: Routine di annullamento fatture non contabilizzate.
      *
      **** rel 5.0
      * Ricompilato per variazione tracciato EFFETT
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'gribctsl'.
           COPY 'gribcrsl'.
           COPY 'grieffsl'.
           COPY 'grifatsl'.
      **** rel 1.2
           COPY 'gribfasl'.
      ************
           COPY 'gristasl'.
           COPY 'gritabsl'.
      **** rel 7.1
           COPY 'griaftsl'.
      ************
       DATA DIVISION.
       FILE SECTION.
           COPY 'gribct'.
           COPY 'gribcr'.
           COPY 'grieff'.
           COPY 'grifat'.
      **** rel 1.2
           COPY 'gribfa'.
      ************
           COPY 'grista'.
           COPY 'gritab'.
      **** rel 7.1
           COPY 'griaft'.
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-71'.
           COPY 'gritabrk'.
           COPY 'parzf'.
      **** rel 1.2
           COPY 'parer'.
           COPY 'parrb'.
      ************
      **** rel 5.1
           COPY 'pardag'.
           COPY 'parppar'.
      ************
      **** rel 6.3
           COPY 'parrd'.
      ************
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-BCT PIC X(15) VALUE 'bolcte'.
       01  ID-BCR PIC X(15) VALUE 'bolcri'.
       01  ID-EFF PIC X(15) VALUE 'effett'.
       01  ID-STA PIC X(15) VALUE 'statis'.
      **** rel 1.2
       01  ID-BFA PIC X(15) VALUE 'bolfat'.
      ************
      **** rel 7.1
       01  ID-AFT PIC X(15) VALUE 'appfat'.
      ************
       01  COMODI.
           05 SF-TAB   PIC XX.
           05 SF-BCT   PIC XX.
           05 SF-BCR   PIC XX.
           05 SF-EFF   PIC XX.
           05 SF-FAT   PIC XX.
      **** rel 1.2
           05 SF-BFA   PIC XX.
      ************
           05 SF-STA   PIC XX.
      **** rel 7.1
           05 SF-AFT   PIC XX.
      ************
           05 MESS     PIC X(40) VALUE SPACE.
      **** rel 1.2
      *    05 K        PIC 99 VALUE ZERO.
           05 K        PIC 9(4) VALUE ZERO.
      ************
           05 VPRE     PIC S9(11) VALUE ZERO.
      **** rel 4.0
           05 VPRE2    PIC S9(11)V99 VALUE ZERO.
           05 COMEURO  PIC 9(3).
      ************
      **** rel 1.2
      *    05 COMVAL   PIC S9(11)V9(4) VALUE ZERO.
      *    05 COEFF    PIC 9(4)V9(3).
      ************
           05 SCONTO   PIC 999V99.
           05 NOSTA    PIC 9 VALUE ZERO.
      **** rel 5.1-1 
           05 DTINT   PIC 9(5) VALUE ZERO.
           05 CLIINT  PIC 9(5) VALUE ZERO.
      ************** 
      **** rel 6.1
           05 TIP      PIC X(3) VALUE 'OLA'.
      ************
           COPY 'parcdt'.
       LINKAGE SECTION.
           01 ID-FAT PIC X(15).
           COPY 'paraf'.
       PROCEDURE DIVISION USING ID-FAT PARAF.
           COPY 'declxer1'.
           COPY 'dclbct'.
           COPY 'dclbcr'.
           COPY 'dcleff'.
           COPY 'dclfat'.
      **** rel 1.2
           COPY 'dclbfa'.
      ************
           COPY 'dclsta'.
           COPY 'dcltab'.
      **** rel 7.1
           COPY 'dclaft'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strsub'.
      **** rel 4.0
           CALL 'rveur' USING COMEURO.
      ************
      **** rel 5.0
           IF AF-FL = ZERO MOVE 'tabell' TO ID-TAB.
           IF AF-FL = 1    MOVE 'tabold' TO ID-TAB.
      ************
           OPEN INPUT TABELL.
           OPEN I-O BOLCTE BOLCRI EFFETT FATTUR STATIS.
      **** rel 1.2
           OPEN I-O BOLFAT.
      ************
      **** rel 7.1
           OPEN I-O APPFAT.
      ************
           IF SF-STA NOT = ZERO MOVE 1 TO NOSTA.
      *    DISPLAY SCRLOG.
      *INPUT DA PARAMETRI.
           MOVE AF-AZI    TO KFT-AZI.
           MOVE AF-TDOC   TO KFT-TDOC.
           MOVE AF-NUMFAT TO KFT-NUM.
           MOVE 9         TO AF-ST.
           READ FATTUR INVALID GO TO FINE.
      **** rel 1.2
           CALL 'rdbfa' USING FAT-CATT KEYFT PARRB.
      ************
      * -------- *
      *CONTROLLI SUI FILE BOLCTE,BOLCRI ED EFFETT.
      * -------- *
           MOVE 8 TO AF-ST.
           MOVE ZERO TO K.
       L030.
           ADD 1 TO K.
      **** rel 1.2
      *    IF K > 15 GO TO L040.
      *    IF FAT-TNUM(K) = ZERO GO TO L040.
      *    MOVE KFT-AZI     TO KBC-AZI.
      *    MOVE FAT-TNUM(K) TO KBC-NUM.
      *    MOVE FAT-NBOL(K) TO KBC-BOL.
           IF K > RB-ULTBOL GO TO L040.
           IF RB-TNUM(K) = ZERO GO TO L040.
           MOVE KFT-AZI    TO KBC-AZI.
           MOVE RB-TNUM(K) TO KBC-NUM.
           MOVE RB-NBOL(K) TO KBC-BOL.
      ************
           READ BOLCTE INVALID GO TO FINE.
           GO TO L030.
       L040.
      **** rel 6.1
      *    se la fattura fosse contabilizzata non butta gli effetti
           IF FAT-STATU = 1 GO TO L090.
      *************
           MOVE 7 TO AF-ST.
           MOVE KFT-AZI   TO KEF-AZI.
           MOVE FAT-TIPAG TO KEF-TIPO.
           MOVE ZERO TO KEF-NUM.
           START EFFETT KEY NOT < KEYEF INVALID GO TO L090.
       RDEFF.
           READ EFFETT NEXT AT END GO TO L090.
           IF SF-EFF = '9D' OR '9A' OR '35' GO TO RDEFF.
           IF KEF-AZI   NOT = KFT-AZI   GO TO L090.
           IF KEF-TIPO  NOT = FAT-TIPAG GO TO L090.
           IF EFF-DTFAT NOT = FAT-DATA  GO TO RDEFF.
           IF EFF-NUFAT NOT = KFT-NUM   GO TO L050.
      **** rel 6.2
           IF EFF-CATT  NOT = FAT-CATT GO TO RDEFF.
      ************
           IF EFF-NUFT2     = ZERO      GO TO L080.
           IF EFF-NUFT2 NOT = ZERO      GO TO FINE.
       L050.
           IF EFF-NUFT2 = KFT-NUM OR
              EFF-NUFT3 = KFT-NUM OR
              EFF-NUFT4 = KFT-NUM OR
              EFF-NUFT5 = KFT-NUM GO TO FINE.
              GO TO RDEFF.
       L080.
           IF EFF-STATU = 1 MOVE 6 TO AF-ST GO TO FINE.
      **** rel 5.1
           IF EFF-FLGDS > ZERO GO TO FINE.
      ************
           GO TO RDEFF.
      * -------- *
      *INIZIO PROCESSO DI ANNULLAMENTO.
      * -------- *
       L090.
           MOVE FAT-DATA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE ZERO TO K.
       L100.
           ADD 1 TO K.
      **** rel 1.2
      *    IF K > 15 GO TO L110.
      *    IF FAT-TNUM(K) = ZERO GO TO L110.
      *    MOVE 5 TO AF-ST.
      *    MOVE KFT-AZI     TO KBC-AZI.
      *    MOVE FAT-TNUM(K) TO KBC-NUM.
      *    MOVE FAT-NBOL(K) TO KBC-BOL.
           IF K > RB-ULTBOL GO TO L110.
           IF RB-TNUM(K) = ZERO GO TO L110.
           MOVE 5 TO AF-ST.
           MOVE KFT-AZI    TO KBC-AZI.
           MOVE RB-TNUM(K) TO KBC-NUM.
           MOVE RB-NBOL(K) TO KBC-BOL.
      ************
           READ BOLCTE INVALID GO TO FINE.
      **** rel 7.1
      *    MOVE ZERO TO BCT-FLGFT BCT-NUDOC BCT-NUFAT.
           MOVE ZERO TO BCT-FLGFT BCT-NUDOC BCT-NUFAT BCT-XML.
      ************
           REWRITE RF-BCT INVALID GO TO FINE.
      **** rel 6.1
           MOVE ZERO      TO PPAR-FUN.
           MOVE 'BOL'     TO PPAR-TARC.
           MOVE 'a'       TO PPAR-TOPE.
           MOVE KEYBC     TO PPAR-KEY.
           MOVE BCT-CATT  TO PPAR-CATT.
           CALL 'vsrv133' USING PARPPAR TIP.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore chiamata vsrv133. Errore ' PPAR-ERR
                      DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      ************
           IF NOSTA NOT = ZERO GO TO L100.
           IF BCT-TDOC  > 3    GO TO L100.
           MOVE 4 TO AF-ST.
           MOVE 4 TO KTB-TIP.
           MOVE FAT-CDPAG TO KTB-COD.
           READ TABELL INTO REKTAB INVALID KEY GO TO FINE.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T04-SCASS TO SCONTO.
      **** rel 1.2
      *    MOVE BCT-CAMGG TO COEFF.
      ************
           MOVE 5 TO AF-ST.
      * -------- *
      *CONTROLLA RIGHI BOLLA PER STATISTICHE.
      * -------- *
           MOVE KBC-AZI   TO KCR-AZI.
           MOVE KBC-NUM   TO KCR-NUM.
           MOVE KBC-BOL   TO KCR-BOL.
           MOVE ZERO      TO KCR-PGR.
           START BOLCRI KEY NOT < KEYCR INVALID KEY GO TO L100.
       BCNEXT. 
           READ BOLCRI NEXT AT END GO TO L100.
           IF SF-BCR = '9D' OR '9A' OR '35' GO TO BCNEXT.
           IF KCR-AZI NOT = KBC-AZI GO TO L100.
           IF KCR-NUM NOT = KBC-NUM GO TO L100.
           IF KCR-BOL NOT = KBC-BOL GO TO L100.
           IF NOT ( BCR-TCOR = ZERO OR BCR-TCOR = 4 OR BCR-TCOR = 5)
              GO TO BCNEXT.
           IF BCR-ART = SPACE GO TO BCNEXT.
      * -------- *
      *RIDUCE VALORI ARCHIVIO STATISTICHE. 
      * -------- *
           MOVE KBC-AZI  TO KST-AZI.
           MOVE BCT-CLI  TO KST-CLI.
           MOVE BCR-ART  TO KST-ART.
           MOVE BCT-CAGE TO KST-AGEN.
           MOVE BCT-ZONA TO KST-ZONA.
           MOVE AA4      TO KST-ANN.
           READ STATIS INVALID KEY GO TO BCNEXT.
           MOVE 3 TO AF-ST.
           IF BCT-TDOC = 3 
              ADD BCR-QTA TO STA-QMES (MM9)
              GO TO WR001.
           SUBTRACT BCR-QTA FROM STA-QMES (MM9).
       WR001.
      **** rel 4.0
      *    IF BCT-VALUT > 1 
      *       COMPUTE VPRE = BCR-NETRG * 100
      *    ELSE
      *       MOVE BCR-NETRG TO VPRE.
           IF BCT-VALUT = 1 
              MOVE BCR-NETRG TO VPRE
           ELSE
              COMPUTE VPRE = BCR-NETRG * 100.
      ************
           IF BCR-TCOR = 4 OR BCR-TCOR = 5 MOVE ZERO TO VPRE.
      **** rel 6.3
      *    COMPUTE VPRE = VPRE - ( VPRE * SCONTO ) / 100.
           COMPUTE RD-NUM = ( VPRE * SCONTO ) / 100.
           CALL 'vrround' USING NNN-M PARRD DEC-0.
           SUBTRACT RD-NUM FROM VPRE.
      ************
      **** rel 4.0
      *    IF BCT-VALUT = ZERO OR 1 GO TO WR002.
           IF BCT-VALUT = ZERO OR COMEURO 
              COMPUTE VPRE2 = VPRE / 100
              GO TO WR002.
      ************
      **** rel 1.2
      *    COMPUTE COMVAL = ( ( VPRE * COEFF ) + 0,5 ) / 100.
      *    MOVE COMVAL TO VPRE.
      **** rel 2.0
      *    MOVE VPRE      TO ER-IMPORTO.
      **** rel 4.0
      *    COMPUTE ER-IMPORTO = VPRE / 100.
           MOVE VPRE TO ER-IMPORTO.
           IF BCT-VALUT NOT = 1 COMPUTE ER-IMPORTO = VPRE / 100.
      ************
      ************
           MOVE BCT-CAMGG TO ER-CAMBIO.
      **** rel 4.0
      *    MOVE FAT-DATA  TO ER-DATA.
      ************
           MOVE BCT-VALUT TO ER-VALUT.
      **** rel 4.0
      *    CALL 'rcamimp' USING ER-IMPORTO VAL-LIR ER-VALUT
      *                         ER-CAMBIO  ER-DATA.
      *    MOVE ER-IMPORTO TO VPRE.
           CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT
                               ER-CAMBIO.
           MOVE ER-IMPORTO TO VPRE2.
      ************
      ************
       WR002.
           IF BCT-TDOC = 3
      **** rel 4.0
      *       ADD VPRE TO STA-VMES (MM9)
              ADD VPRE2 TO STA-VMES (MM9)
      ************
              GO TO WR003.
      **** rel 4.0
      *    SUBTRACT VPRE FROM STA-VMES (MM9).
           SUBTRACT VPRE2 FROM STA-VMES (MM9).
      ************
       WR003.
           REWRITE RF-STA INVALID GO TO FINE.
           MOVE 5 TO AF-ST.
           GO TO BCNEXT.
       L110.
           MOVE 2 TO AF-ST.
           IF NOT ( FAT-TIPAG = 1 OR 2 ) GO TO L130.
      **** rel 6.1
      *    se la fattura fosse contabilizzata non butta gli effetti
           IF FAT-STATU = 1 GO TO L130.
      *************
           MOVE KFT-AZI TO KEF-AZI.
           MOVE FAT-TIPAG TO KEF-TIPO.
           MOVE ZERO TO KEF-NUM.
           START EFFETT KEY NOT < KEYEF INVALID GO TO L130.
       RDAG.
           READ EFFETT NEXT AT END GO TO L130.
           IF SF-EFF = '9D' OR '9A' OR '35' GO TO RDAG.
           IF KEF-AZI   NOT = KFT-AZI   GO TO L130.
           IF KEF-TIPO  NOT = FAT-TIPAG GO TO L130.
           IF EFF-DTFAT NOT = FAT-DATA  GO TO RDAG.
           IF EFF-NUFAT NOT = KFT-NUM   GO TO RDAG.
      **** rel 6.2
           IF EFF-CATT  NOT = FAT-CATT  GO TO RDAG.
      ************
           DELETE EFFETT INVALID GO TO FINE.
           GO TO RDAG.
      * -------- *
      *ELIMINAZIONE DELLA FATTURA.
      * -------- *
       L130.
           MOVE 1 TO AF-ST.
      **** rel 1.2
      * eliminazione file di raggruppamento bolle per fattura
       DEL-BFA.
           MOVE FAT-CATT TO KBFA-CATT.
           MOVE KEYFT    TO KBFA-KEYFT.
           MOVE ZERO     TO KBFA-PRG.
           START BOLFAT KEY NOT < KEYBFA INVALID GO TO DEL-BFA-90.
       DEL-BFA-10.
           READ BOLFAT NEXT AT END GO TO DEL-BFA-90.
           IF KBFA-CATT  > FAT-CATT GO TO DEL-BFA-90.
           IF KBFA-KEYFT > KEYFT    GO TO DEL-BFA-90.
           DELETE BOLFAT INVALID GO TO FINE.
           GO TO DEL-BFA-10.
       DEL-BFA-90.
      ************
           DELETE FATTUR INVALID GO TO FINE.
      **** rel 7.1
           MOVE KEYFT TO KEYAFT.
           MOVE FAT-CATT TO KAFT-CATT.
           DELETE APPFAT.
      ************
      **** rel 5.1
           MOVE 'c'      TO DAG-FUN.
           MOVE KFT-AZI  TO DAG-AZI.
           MOVE 'FAT'    TO DAG-TIP.
           MOVE KEYFT    TO DAG-KFD.
           MOVE FAT-CATT TO DAG-KFD(10:1).
           CALL 'rdalg' USING PARDAG.
      *
           MOVE ZERO      TO PPAR-FUN.
           MOVE 'FAT'     TO PPAR-TARC.
           MOVE 'C'       TO PPAR-TOPE.
           MOVE KEYFT     TO PPAR-KEY.
           MOVE SPACE     TO PPAR-OPZ.
      **** rel 5.1-1 
      *    MOVE FAT-DATA  TO PPAR-OPZ(1:3).
      *    MOVE FAT-CDCLI TO PPAR-OPZ(4:3).
      *    MOVE FAT-CATT  TO PPAR-OPZ(7:1).
           MOVE FAT-DATA  TO DTINT.
           MOVE FAT-CDCLI TO CLIINT.
           MOVE DTINT     TO PPAR-OPZ(1:5).
           MOVE CLIINT    TO PPAR-OPZ(6:5).
           MOVE FAT-CATT  TO PPAR-CATT.
      ************** 
           CALL 'vsrv130' USING PARPPAR.
           IF PPAR-ERR > 1 
              MOVE SPACE TO MESS
              STRING 'Errore chiamata vsrv130. Errore ' PPAR-ERR
                      DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      ************
           MOVE ZERO TO AF-ST.
           GO TO FINE.
       ERRIO.
           COPY 'errsub'.
       FINE.
           IF NOSTA = ZERO CLOSE STATIS.
           CLOSE TABELL BOLCTE BOLCRI EFFETT FATTUR.
      **** rel 1.2
           CLOSE BOLFAT.
      ************
      **** rel 7.1
           CLOSE APPFAT.
      ************
           EXIT PROGRAM.
           STOP RUN.
           COPY 'gribcter'.
           COPY 'gribcrer'.
           COPY 'grieffer'.
           COPY 'grifater'.
      **** rel 1.2
           COPY 'gribfaer'.
      ************
           COPY 'gristaer'.
           COPY 'gritaber'.
      **** rel 7.1
           COPY 'griafter'.
      ************
           COPY 'grixxxer'.
