       IDENTIFICATION DIVISION.
       PROGRAM-ID. VFAT220.
      *
      * OGGETTO  :  Routine stampa fatture accompagnatorie (Mod. XABD)
      *
      * NOTA     :  Il bollettario e` > 6
      *
      **** rel 5.0
      * Ricompilato per variazione tracciato ANABAN
      ************
      **** rel 6.0
      * Ricompilato per variazione tracciato tabella pagamenti
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griclfsl'.
           COPY 'gribansl'.
           COPY 'gribctsl'.
           COPY 'gribcrsl'.
           COPY 'grifatsl'.
           COPY 'grilinsl'.
           COPY 'gritabsl'.
      **** rel 2.0
           COPY 'grincrsl'.
           COPY 'gripbrsl'.
      ************
      **** rel 5.0
           COPY 'griaimsl'.
           COPY 'griwsisl'.
      ************
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'griclf'.
           COPY 'griban'.
           COPY 'gribct'.
           COPY 'gribcr'.
           COPY 'grifat'.
           COPY 'grilin'.
           COPY 'gritab'.
      **** rel 2.0
           COPY 'grincr'.
           COPY 'gripbr'.
      ************
      **** rel 5.0
           COPY 'griaim'.
           COPY 'griwsi'.
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'gritabrk'.
           COPY 'griclfrk'.
           COPY 'griazirk'.
           COPY 'parzf'.
           COPY 'parcdt'.
      **** rel 1.2
      *    COPY 'parsv'.
      ************
           COPY 'parab'.
      **** rel 1.2
           COPY 'parer'.
           COPY 'parrb'.
      ************
      **** rel 4.0
           COPY 'parop'.
      ************
      **** rel 5.2
           COPY 'parpcfa'.
      ************
       01  ID-ARL PIC X(15) VALUE 'artlin'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-BAN PIC X(15) VALUE 'anaban'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-BCT PIC X(15) VALUE 'bolcte'.
       01  ID-BCR PIC X(15) VALUE 'bolcri'.
      **** rel 5.0
       01  ID-AIM PIC X(15) VALUE 'anaimb'.
       01  ID-WSI PIC X(15).
      ************
       01  ID-FAT.
           05 FILLER PIC X(6) VALUE 'fattur'.
           05 FATTIV PIC X    VALUE SPACE.
           05 FILLER PIC X(8) VALUE SPACE.
      **** rel 2.0
       01  ID-NCR PIC X(15) VALUE 'notbcr'.
       01  ID-PBR PIC X(15) VALUE 'probcr'.
      ************
       01  AREE-LAV.
           05 SF-ARL   PIC XX.
           05 SF-AZI   PIC XX.
           05 SF-CLF   PIC XX.
           05 SF-BAN   PIC XX.
           05 SF-TAB   PIC XX.
           05 SF-BCT   PIC XX.
           05 SF-BCR   PIC XX.
           05 SF-FAT   PIC XX.
      **** rel 2.0
           05 SF-NCR  PIC XX.
           05 SF-PBR  PIC XX.
      ************
      **** rel 5.0
           05 SF-AIM  PIC XX.
           05 SF-WSI  PIC XX.
      ************
           05 MESS     PIC X(40)  VALUE SPACE.
           05 K        PIC 99     VALUE ZERO.
           05 J        PIC 99     VALUE ZERO.
           05 VISTA    PIC 9      VALUE ZERO.
           05 VNTMER   PIC S9(11)V99 VALUE ZERO.
           05 VSCFIN   PIC S9(11)V99 VALUE ZERO.
      **** rel 4.0
      *    05 TOTACC   PIC S9(11) VALUE ZERO.
           05 TOTACC   PIC S9(11)V99 VALUE ZERO.
      ************
           05 SCONTO   PIC 999V99 VALUE ZERO.
           05 VALUT    PIC 999    VALUE ZERO.
           05 IMPON    PIC S9(11)V99 VALUE ZERO.
           05 IMPOS    PIC S9(11)V99 VALUE ZERO.
           05 ZERPK    PIC 9(5) COMP-3 VALUE ZERO.
           05 SC       PIC S99V99 VALUE ZERO.
           05 WNUM     PIC 9      VALUE ZERO.
           05 SW-CARTA PIC 9      VALUE ZERO.
           05 SWSTA    PIC 9      VALUE ZERO.
           05 CIFRA    PIC 9      VALUE ZERO.
           05 COMODO   PIC 999    VALUE ZERO.
           05 COMOD1   PIC 999    VALUE ZERO.
           05 GARANZ   PIC S9(11)V99 VALUE ZERO.
           05 NOSCON   PIC S9(11)V99 VALUE ZERO.
      **** rel 1.2
      *    05 OMAGG    PIC S9(11)V99 VALUE ZERO.
      *    05 SCMER    PIC S9(11)V99 VALUE ZERO.
           05 FSC      PIC 9.
           05 ESTPIVA  PIC 9.
      ************
           05 DTRA     PIC 9(6) VALUE ZERO.
      **** rel 2.0
           05 FLGSTA   PIC 9.
           05 INDICE   PIC 999.
           05 ULTIND   PIC 999.
      **** rel 4.0
      *    05 IMPIMB   PIC 9(9).
           05 IMPIMB   PIC 9(9)V99.
      ************
      **** rel 5.0
      *    05 VETIMB   PIC 999  OCCURS 10.
      *    05 VETQTA   PIC 9(5) OCCURS 10.
           05 PREPAL   PIC 9(5).
           05 PRECOL   PIC 9(5).
           05 PREIMB   PIC X(12).
           05 COMNIMB  PIC 9(3).
           05 VETIMB   PIC X(12) OCCURS 30.
           05 VETQTA   PIC 9(5)  OCCURS 30.
      ************
      ************
      **** rel 4.0
           05 COMEURO PIC 9(3).
      ************
       01  CODICE.
           05 MAS      PIC 99   VALUE ZERO.
           05 COD      PIC 9(5) VALUE ZERO.
       01  W-LINEE     PIC X(80) VALUE ALL '-'.

      **** rel 5.0
       01  PAR-P-MDT.
           05 P-MDT-AZI   PIC 999.
           05 P-MDT-TDOC  PIC 9.
           05 P-MDT-KEY   PIC X(15).
           05 P-MDT-FLGS  PIC 9.
           05 P-MDT-DATA  PIC 9(5).
           05 P-MDT-NCOL  PIC 99.
           05 P-MDT-TESTO PIC X(76).
           05 P-MDT-FLGE  PIC 9.
      ************
      *-------------------------------------------
      *    parametri per definire lunghezza modulo
      *    LMOD = 11 per modulo 11 pollici (default)
      *    LMOD = 12 per modulo 12 pollici
       01  PARMOD.
           05 LMOD     PIC 99 VALUE 11.
           05 NRIG00   PIC 99.
           05 NRIG01   PIC 99.
           05 SALT00   PIC 99.
           05 SALT01   PIC 99.
      *-------------------------------------------
       01  PARST.
           05 XCRR PIC 9 VALUE ZERO.
           05 RIGS PIC X(132) VALUE SPACE.
           05 RIG1 REDEFINES RIGS.
              10 FILLER PIC X(43).
              10 PRAG   PIC X(89).
           05 RIG2 REDEFINES RIGS.
              10 FILLER PIC XX.
              10 PTDOC  PIC X(9).
              10 PNFAT  PIC ZZZZ9.
              10 FILLER PIC XX.
              10 PDFAT  PIC X(10).
              10 PPAG   PIC Z9.
              10 PNOTA  PIC X(13).
              10 PCAP   PIC 99999-.
              10 PCIT   PIC X(83).
           05 RIG3 REDEFINES RIGS.
              10 FILLER PIC X.
              10 PCLI   PIC ZZZZ9.
              10 FILLER PIC XX.
              10 PFISC  PIC X(17).
              10 PPIVA  PIC X(12).
              10 PAGEN  PIC ZZ9.
              10 FILLER PIC X.
              10 PSPED  PIC X(24).
              10 PPORT  PIC X(67).
           05 RIG4 REDEFINES RIGS.
              10 FILLER PIC XX.
              10 PCPAG  PIC ZZ9.
              10 FILLER PIC XXX.
              10 PDPAG  PIC X(25).
              10 PSCON  PIC ZZ,ZZ.
              10 FILLER PIC XXX.
              10 PBAN   PIC X(40).
              10 PVAL   PIC X(51).
           05 RIG5 REDEFINES RIGS.
              10 FILLER PIC X(15).
              10 PAST   PIC XX.
              10 PCONF  PIC X(9).
              10 PNCONF PIC ZZZZ9-.
              10 PDEL   PIC X(4).
              10 PDCONF PIC X(96).
           05 RIG6 REDEFINES RIGS.
              10 FILLER PIC XX.
              10 PART   PIC X(13).
              10 PDES.
                 15 RDES1  PIC X(10).
                 15 SOUT   PIC ZZZZ9.
                 15 RDES2  PIC X(5).
                 15 SDEL   PIC X(10).
              10 PUNM REDEFINES PDES.
                 15 FILLER PIC X(26).
                 15 PBLANK PIC X.
                 15 PUNMIS PIC XXX.
              10 PQTA   PIC ZZZZZZ9-.
              10 PQTA1  REDEFINES PQTA PIC ZZZZ9,9-.
              10 PQTA2  REDEFINES PQTA PIC ZZZ9,99-.
              10 PPRZ   PIC ZZZZZZ9-.
              10 PPRZ1  REDEFINES PPRZ PIC ZZZ9,99-.
      **** rel 1.2
              10 PPRZ3  REDEFINES PPRZ PIC ZZ9,999-.
              10 PPRZ4  REDEFINES PPRZ PIC Z9,9999-.
              10 PPRZ5  REDEFINES PPRZ PIC 9,99999-.
      ************
      **** rel 4.0
              10 PPRZ6  REDEFINES PPRZ PIC ,999999-.
      ************
              10 DSPRZ.
                 15 PSCO   PIC Z9+.
                 15 PPNET  PIC ZZZZZZ9-.
                 15 PPNET1 REDEFINES PPNET PIC ZZZ9,99-.
      **** rel 2.0
                 15 PPNET3 REDEFINES PPNET PIC ZZ9,999-.
                 15 PPNET4 REDEFINES PPNET PIC Z9,9999-.
                 15 PPNET5 REDEFINES PPNET PIC 9,99999-.
      ************
      **** rel 4.0
                 15 PPNET6 REDEFINES PPNET PIC ,999999-.
      ************
                 15 PTNET  PIC ZZZ.ZZZ.ZZ9-.
                 15 PTNET1 REDEFINES PTNET PIC ZZZZ.ZZ9,99-.
              10 DSGRA REDEFINES DSPRZ PIC X(23).
              10 PCIVA  PIC ZZ9.
              10 FILLER PIC X(45).
           05 RIG7 REDEFINES RIGS.
              10 FILLER PIC X.
              10 PCDIVA PIC ZZ9.
              10 PIMP   PIC ZZZ.ZZZ.ZZ9-.
              10 PIMP1 REDEFINES PIMP PIC ZZZZ.ZZ9,99-.
              10 FILLER PIC X.
              10 PALI1  PIC X(19).
              10 PALI2  REDEFINES PALI1.
                 15 PALI   PIC X(10).
                 15 PIMIVA PIC ZZZZZZZ9-.
      **** rel 1.2
                 15 EPIMIVA REDEFINES PIMIVA PIC ZZZZ9,99-.
      ************
              10 FILLER PIC X.
              10 PSCAD  PIC X(9).
              10 PSCIMP PIC ZZ.ZZZ.ZZ9-.
              10 PSCIM2 REDEFINES PSCIMP PIC ZZZZZZ9,99-.
              10 FILLER PIC X.
              10 PSCOMO.
                 15 PSPESA PIC X(11).
                 15 PSCFIN REDEFINES PSPESA.
                    20 PSFIN PIC X(4).
                    20 PSPER PIC ZZ9,99.
                    20 FILPE PIC X.
                 15 FILLER PIC X.
                 15 FILLUN PIC XX.
              10 PSCOM1 REDEFINES PSCOMO.
                 15 PSCO1 PIC X(2).
                 15 PSCO2 PIC ZZZZ.ZZZ.ZZ9.
                 15 PSCO3 REDEFINES PSCO2 PIC Z.ZZZ.ZZ9,99.
              10 PTOT   PIC ZZZZ.ZZZ.ZZ9-.
              10 PTOT1 REDEFINES PTOT PIC Z.ZZZ.ZZ9,99-.
              10 FILLER PIC X(47).
           05 RIG7A REDEFINES RIGS.
              10 FILLER PIC X(2).
              10 RDSMO  PIC X(23).
              10 RDIMP  PIC ZZZ.ZZZ.ZZ9-.
              10 RDIMP1 REDEFINES RDIMP PIC ZZZZ.ZZ9,99-.
              10 RDSIV  PIC X(23).
              10 RDIVA  PIC ZZZ.ZZZ.ZZ9-.
      **** rel 1.2
              10 ERDIVA REDEFINES RDIVA PIC ZZZZ.ZZ9,99-.
      ************
              10 FILLER PIC X(60).
           05 RIG8 REDEFINES RIGS.
              10 FILLER PIC XX.
              10 PDEST  PIC X(41).
              10 PASPE  PIC X(25).
              10 PNCOL  PIC X(9).
              10 PPLOR  PIC ZZZZZ.
              10 FILLER PIC X.
              10 PNETT  PIC ZZZZZ.
              10 FILLER PIC X(44).
           05 RIG9 REDEFINES RIGS.
              10 FILLER PIC XX.
              10 PVETT  PIC X(24).
              10 PVIND  PIC X(31).
              10 PDRIT  PIC 99/99/99.
              10 FILLER PIC X.
              10 PORIT  PIC 99.99.
              10 FILLER PIC X(61).
           05 RI10 REDEFINES RIGS.
              10 FILLER PIC XX.
              10 PCAUT  PIC X(25).
              10 PDTRA  PIC 99/99/99.
              10 FILLER PIC X.
              10 POTRA  PIC 99.99.
              10 FILLER PIC X(91).
      **** rel 2.0
           05 RIG11  REDEFINES RIGS.
      **** rel 5.0
      *       10 FILLER PIC X(8).
      *       10 PCDIMB PIC ZZ9.
      *       10 FILLER PIC X(4).
      *       10 PDIMB PIC X(24).
      *       10 FILLER PIC X(8).
              10 FILLER PIC XX.
              10 PCDIMB PIC X(12).
              10 FILLER PIC X.
              10 PDIMB PIC X(30).
              10 FILLER PIC XX.
      ************
              10 PQTIMB PIC ZZZZ9-.
              10 PPZIMB PIC ZZZZZZ9-.
              10 PPZIMB1 REDEFINES PPZIMB PIC ZZZ9,99-.
              10 FILLER PIC X(11).
              10 PIMPNT PIC ZZZ.ZZZ.ZZ9-.
              10 PIMPNT1 REDEFINES PIMPNT PIC ZZZZ.ZZ9,99-.
              10 PIVAIM PIC ZZ9.
              10 FILLER PIC X(45).
           05 RIG12 REDEFINES RIGS.
              10 FILLER PIC X(15).
              10 PCONAI PIC X(117).
      ************
           05 NRGLF PIC 9(4)  VALUE ZERO.
           05 NRIG PIC 99     VALUE ZERO.
           05 NPAG PIC 9(5)   VALUE ZERO.
           05 SWOP PIC 9      VALUE ZERO.
           05 FILLER PIC X(6) VALUE ZERO.
           05 SALT PIC 99     VALUE ZERO.
      *-------------------------------------------
       LINKAGE SECTION.
           COPY 'parpfls'.
       PROCEDURE DIVISION USING PARPF.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclclf'.
           COPY 'dclban'.
           COPY 'dclbct'.
           COPY 'dclbcr'.
           COPY 'dclfat'.
           COPY 'dcllin'.
           COPY 'dcltab'.
      **** rel 2.0
           COPY 'dclncr'.
           COPY 'dclpbr'.
      ************
      **** rel 5.0
           COPY 'dclaim'.
           COPY 'dclwsi'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strsub'.
           MOVE PF-ATTIV TO FATTIV.
           IF FATTIV = '0' MOVE SPACE TO FATTIV.
      **** rel 5.0
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           OPEN OUTPUT WDSSIB.
           CLOSE WDSSIB.
           OPEN I-O WDSSIB.
      ************
           OPEN INPUT ANAAZI.
           OPEN INPUT TABELL.
           OPEN INPUT ANACLF.
           OPEN INPUT ANABAN.
           OPEN INPUT FATTUR.
           OPEN INPUT BOLCTE.
           OPEN INPUT BOLCRI.
      **** rel 2.0
           OPEN INPUT NOTBCR.
           OPEN INPUT PROBCR.
      ************
      **** rel 5.0
           OPEN INPUT ANAIMB.
      ************
           MOVE 1 TO KTB-COD KTB-TIP.
           READ TABELL INTO REKTAB INVALID KEY
                PERFORM INVK-TAB
                GO TO WARNING.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MCLI TO MAS.
           MOVE PF-AZI   TO KAZ-COD.
           MOVE 6666 TO NRGLF.
           MOVE 28   TO NRIG00.
           MOVE 31   TO NRIG01.
           MOVE 29   TO SALT00.
           MOVE 34   TO SALT01.
           IF LMOD = 12
              MOVE 7272 TO NRGLF
              MOVE 34   TO NRIG00
              MOVE 37   TO NRIG01
              MOVE 35   TO SALT00
              MOVE 40   TO SALT01.
           READ ANAAZI INTO REKAZI INVALID KEY
                PERFORM INVK-AZI
                GO TO WARNING.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
           MOVE ZERO TO WNUM.
           MOVE 1 TO PF-ST.
      **** rel 4.0
           CALL 'rveur' USING COMEURO.
      ************
       LRFT.
           ADD 1 TO WNUM.
           IF WNUM > PF-COPIE MOVE ZERO TO SW-CARTA GO TO FINE.
           MOVE ZERO TO SWSTA.
           MOVE ZERO TO KEYFT.
           MOVE KAZ-COD  TO KFT-AZI.
           MOVE PF-PRFAT TO KFT-NUM.
           MOVE PF-TDOC  TO KFT-TDOC.
           START FATTUR KEY NOT < KEYFT INVALID GO TO FINE.
       NEWFAT.
           READ FATTUR NEXT AT END GO TO FINE.
           IF SF-FAT = '9D' OR '9A' OR '35' GO TO NEWFAT.
           IF KFT-AZI  NOT = KAZ-COD GO TO FINE.
           IF KFT-TDOC NOT = PF-TDOC GO TO FINE.
           IF KFT-NUM > PF-ULFAT     GO TO FINE.

      **** rel 5.0
           PERFORM DL-LAV-IMB THRU EX-DL-LAV-IMB.
      ************
      **** rel 2.0
           MOVE ZERO TO ULTIND.
      *
      **** rel 4.0
      *    IF FAT-VALUT > 1
           IF NOT (FAT-VALUT = ZERO OR COMEURO)
      ************
              MOVE FAT-VALUT TO ER-VALUT
              CALL 'rvalut' USING ER-VALUT FAT-DATA CG-PAR
              IF CG-ST > ZERO PERFORM ERR-EURO
                              GO TO WARNING.
      ************
           MOVE PF-AZI       TO KBC-AZI.
      **** rel 1.2
      *    MOVE FAT-TNUM(1)  TO KBC-NUM.
      *    MOVE FAT-NBOL(1)  TO KBC-BOL.
           CALL 'rdbfa' USING FAT-CATT KEYFT PARRB.
           MOVE RB-TNUM(1)   TO KBC-NUM.
           MOVE RB-NBOL(1)   TO KBC-BOL.
      ************
           READ BOLCTE INVALID
                PERFORM INVK-BCT
                PERFORM VISK-FAT
                GO TO WARNING.
           IF BCT-FLGXAB NOT = 1
              MOVE 3 TO F-NMES
              MOVE 'Per eseguire la stampa e'' necessario' TO F-MES1
              MOVE 'che i dati  XAB siano  confermati in'  TO F-MES2
              MOVE 'modo definitivo.'                      TO F-MES3
              GO TO WARNING.
           MOVE BCT-VALUT TO VALUT.
      **** rel 1.2
           MOVE 10        TO KTB-TIP.
           MOVE BCT-VALUT TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE ZERO TO T10-FSC.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T10-FSC TO FSC.
      ************

           MOVE FAT-CDCLI TO COD.
           MOVE PF-AZI    TO KCF-AZI.
           MOVE CODICE    TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID KEY
                PERFORM INVK-CLF
                PERFORM VISK-FAT
                GO TO WARNING.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
      **** rel 1.2
           MOVE ZERO TO ESTPIVA.
           IF FAT-CDESE  = ZERO GO TO NOCALL-10.
           IF CLF-ENUIVA = ZERO GO TO NOCALL-10.
           MOVE 3         TO KTB-TIP.
           MOVE FAT-CDESE TO KTB-COD.
           READ TABELL INTO REKTAB INVALID GO TO NOCALL-10.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T03-TPIVA TO ESTPIVA.
       NOCALL-10.
      ************

           PERFORM A00-STAMPA-FATTURA THRU A99.

           GO TO FINE.

      *-------------*
       ERRIO.
           COPY 'errsub'.
           MOVE 9 TO PF-ST.
      *-------------*
       FINE.
           CLOSE FATTUR.
           CLOSE ANAAZI.
           CLOSE ANACLF.
           CLOSE ANABAN.
           CLOSE TABELL.
           CLOSE BOLCTE.
           CLOSE BOLCRI.
      **** rel 2.0
           CLOSE NOTBCR.
           CLOSE PROBCR.
      ************
      **** rel 5.0
           CLOSE ANAIMB.
           CLOSE WDSSIB.
           OPEN OUTPUT WDSSIB.
           CLOSE WDSSIB.
      ************
           EXIT PROGRAM.
      *------------------------------------------
       A00-STAMPA-FATTURA.
       A10.
           MOVE ZERO TO XCRR.
           CALL 'rstam' USING PARST.
           MOVE ZERO TO NPAG.
           MOVE ZERO TO NOSCON.
           PERFORM C00-STAMPA-TESTA THRU C99.
           PERFORM D00-STAMPA-CORPO THRU D99.
           PERFORM E00-STAMPA-PIEDE THRU E99.
           MOVE 9 TO XCRR.
           CALL 'rstam' USING PARST.
       A99.
           EXIT.
      *------------------------------------------
       C00-STAMPA-TESTA.
           MOVE ZERO TO XCRR.
           MOVE BCT-DRAG TO PRAG.
           CALL 'rstam' USING PARST.
           MOVE BCT-DRAG2 TO PRAG.
           MOVE 1 TO XCRR.
           CALL 'rstam' USING PARST.
           MOVE BCT-DIND TO PRAG.
           CALL 'rstam' USING PARST.
           MOVE BCT-DIND2 TO PRAG.
           CALL 'rstam' USING PARST.
           MOVE 'FATTURA' TO PTDOC.
           MOVE KFT-NUM   TO PNFAT.
           MOVE FAT-DATA  TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA    TO PDFAT.
           MOVE NPAG      TO PPAG.
           IF KFT-TDOC = 4 OR 6
      **** rel 7.2
      *       MOVE ' IN SOSPESO' TO PNOTA.
              IF FAT-DATA >= 42005
                 MOVE ' SCISS.PAG.' TO PNOTA
              ELSE
                 MOVE ' IN SOSPESO' TO PNOTA.
      ************
           MOVE BCT-DCAP TO PCAP.
           MOVE BCT-DCIT TO PCIT.
           CALL 'rstam' USING PARST.
           MOVE FAT-CDAGE TO PAGEN
           MOVE FAT-CDCLI TO PCLI
           MOVE CLF-CFISC TO PFISC
           IF CLF-PIVA > ZERO MOVE CLF-PIVA TO PPIVA.
           IF CLF-13IVA = 4 MOVE SPACE TO PFISC
                            MOVE CLF-CFISC TO PPIVA.
           MOVE 6        TO KTB-TIP.
           MOVE BCT-CSPE TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE SPACE TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO PSPED.
           MOVE 5        TO KTB-TIP.
           MOVE BCT-CPOR TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE SPACE TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO PPORT.
           MOVE 3 TO XCRR.
           CALL 'rstam' USING PARST.
           MOVE 2 TO XCRR.
           MOVE FAT-CDPAG TO PCPAG.
           MOVE 4         TO KTB-TIP.
           MOVE FAT-CDPAG TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE SPACE TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO PDPAG.
           MOVE FAT-SCBAS TO PSCON.
           MOVE FAT-CDBAN TO KBA-BAN.
           READ ANABAN INVALID MOVE SPACE TO BAN-RGSOC.
           MOVE BAN-RGSOC TO PBAN.
           MOVE T04-SCASS TO SCONTO.
           IF T04-1SCAD = ZERO MOVE 1 TO VISTA.
           IF VALUT = ZERO GO TO NWPG001.
           MOVE 10    TO KTB-TIP.
           MOVE VALUT TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE SPACE TO T10-DSINT.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T10-DSINT TO PVAL.
       NWPG001.
           CALL 'rstam' USING PARST.
           MOVE 3 TO XCRR.
       C99.
           EXIT.
      *------------------------------------------
       D00-STAMPA-CORPO.
           MOVE ZERO TO VNTMER.
           MOVE ZERO TO GARANZ.
      **** rel 1.2
      *    MOVE ZERO TO OMAGG SCMER.
      ************
           MOVE KBC-AZI TO KCR-AZI.
           MOVE KBC-NUM TO KCR-NUM.
           MOVE KBC-BOL TO KCR-BOL.
           MOVE 1       TO KCR-PGR.
           START BOLCRI KEY NOT < KEYCR INVALID GO TO D99.
       D10.
           READ BOLCRI NEXT AT END GO TO D99.
           IF SF-BCR = '9D' OR '9A' OR '35' GO TO D10.
           IF ( KCR-AZI NOT = KBC-AZI ) OR
              ( KCR-NUM NOT = KBC-NUM ) OR
              ( KCR-BOL NOT = KBC-BOL ) GO TO D99.
           IF NRIG > NRIG01 PERFORM C00-STAMPA-TESTA THRU C99.
           MOVE BCR-DESCR TO PDES.
           IF AZI-FLING = ZERO GO TO RIG10.
           IF CLF-FLING = ZERO GO TO RIG10.
           OPEN INPUT ARTLIN.
           MOVE PF-AZI  TO KAL-AZI.
           MOVE BCR-ART TO KAL-ART.
           READ ARTLIN INVALID GO TO RIG05.
           IF CLF-FLING = 1
              IF ARL-DES1 = SPACE GO TO RIG05
              ELSE     MOVE ARL-DES1 TO PDES.
           IF CLF-FLING = 2
              IF ARL-DES2 = SPACE GO TO RIG05
              ELSE     MOVE ARL-DES2 TO PDES.
           IF CLF-FLING = 3
              IF ARL-DES3 = SPACE GO TO RIG05
              ELSE     MOVE ARL-DES3 TO PDES.
       RIG05.
           CLOSE ARTLIN.
       RIG10.
           IF BCR-TCOR = 1 GO TO D40.
           IF BCR-TCOR = 3 GO TO D20.
           MOVE BCR-ART TO PART.
           MOVE SPACE   TO PBLANK.
           MOVE BCR-UM  TO PUNMIS.
           IF BCR-TQUAN = ZERO MOVE BCR-QTA TO PQTA
           ELSE IF BCR-TQUAN = 1 MOVE BCR-QTA TO PQTA1
                ELSE MOVE BCR-QTA TO PQTA2.
           IF BCR-TCOR = 6 GO TO D21.
      **** rel 1.2
      *    IF BCR-TPRZ = 1
      *       MOVE BCR-PZLOR TO PPRZ1
      *    ELSE
      *       MOVE BCR-PZLOR TO PPRZ.
      **** rel 4.0
      *    MOVE BCR-PZLOR TO ER-PREZZO.
      *    CALL 'rfscprz' USING ER-PREZZO BCR-TPRZ FSC ER-NDEC.
      *    MOVE ER-PREZZO TO PPRZ.
      *    IF ER-NDEC = 1 OR 2 MOVE ER-PREZZO TO PPRZ1.
      *    IF ER-NDEC = 3      MOVE ER-PREZZO TO PPRZ3.
      *    IF ER-NDEC = 4      MOVE ER-PREZZO TO PPRZ4.
      *    IF ER-NDEC = 5      MOVE ER-PREZZO TO PPRZ5.
           MOVE KCR-AZI     TO OP-AZI
           MOVE BCT-VALUT   TO OP-VALUT.
           MOVE BCR-PZLOR   TO OP-PREZZO.
           MOVE BCR-FSC     TO OP-FSC.
           CALL 'routprz' USING PAROP OP-VEN.
           MOVE OP-PREZZO   TO PPRZ.
           IF OP-NDEC = 2 MOVE OP-PREZZO TO PPRZ1.
           IF OP-NDEC = 3 MOVE OP-PREZZO TO PPRZ3.
           IF OP-NDEC = 4 MOVE OP-PREZZO TO PPRZ4.
           IF OP-NDEC = 5 MOVE OP-PREZZO TO PPRZ5.
           IF OP-NDEC = 6 MOVE OP-PREZZO TO PPRZ6.
      ************
           IF BCR-TCOR > 3 AND < 7 GO TO D21.
           MOVE BCR-SC1 TO SC.
           IF SC = ZERO MOVE BCR-SC2 TO SC
           ELSE IF BCR-SC2 NOT = ZERO
                MULTIPLY -1 BY SC GIVING PSCO
                CALL 'rstam' USING PARST
                MOVE 1 TO XCRR
                MOVE BCR-SC2 TO SC.
           IF SC NOT = ZERO
              MULTIPLY -1 BY SC GIVING PSCO.
      **** rel 2.0
      *    IF BCR-TPRZ = 1
      *       MOVE BCR-PZNET TO PPNET1
      *    ELSE
      *       MOVE BCR-PZNET TO PPNET.
      **** rel 4.0
      *    MOVE BCR-PZNET TO ER-PREZZO.
      *    CALL 'rfscprz' USING ER-PREZZO BCR-TPRZ FSC ER-NDEC.
      *    MOVE ER-PREZZO TO PPNET.
      *    IF ER-NDEC = 1 OR 2 MOVE ER-PREZZO TO PPNET1.
      *    IF ER-NDEC = 3      MOVE ER-PREZZO TO PPNET3.
      *    IF ER-NDEC = 4      MOVE ER-PREZZO TO PPNET4.
      *    IF ER-NDEC = 5      MOVE ER-PREZZO TO PPNET5.
           MOVE KCR-AZI     TO OP-AZI
           MOVE BCT-VALUT   TO OP-VALUT.
           MOVE BCR-PZNET   TO OP-PREZZO.
           MOVE BCR-FSC     TO OP-FSC.
           CALL 'routprz' USING PAROP OP-VEN.
           MOVE OP-PREZZO   TO PPNET.
           IF OP-NDEC = 2 MOVE OP-PREZZO TO PPNET1.
           IF OP-NDEC = 3 MOVE OP-PREZZO TO PPNET3.
           IF OP-NDEC = 4 MOVE OP-PREZZO TO PPNET4.
           IF OP-NDEC = 5 MOVE OP-PREZZO TO PPNET5.
           IF OP-NDEC = 6 MOVE OP-PREZZO TO PPNET6.
      ************
       D20.
      **** rel 4.0
      *    IF VALUT > 1
      *       MOVE BCR-NETRG TO PTNET1
      *    ELSE
      *       MOVE BCR-NETRG TO PTNET.
           MOVE BCR-NETRG TO PTNET1.
           IF VALUT = 1
              MOVE BCR-NETRG TO PTNET.
      ************
       D21.
           IF BCR-TCOR = 4 MOVE 'CESSIONE GRATUITA' TO DSGRA.
           IF BCR-TCOR = 5 MOVE 'SCONTO IN MERCE' TO DSGRA.
           IF BCR-TCOR = 6 MOVE 'CESSIONE IN GARANZIA' TO DSGRA.
           IF FAT-CDESE = ZERO GO TO D30.
           IF BCR-TCOR NOT = 3 GO TO D30.
           MOVE 11 TO KTB-TIP.
           MOVE BCR-SPESA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM INVK-TAB
                PERFORM VISK-BCR
                GO TO WARNING.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T11-SCONT > ZERO ADD BCR-NETRG TO NOSCON.
           IF FAT-CDESE = ZERO GO TO D30.
           IF BCR-IVA = ZERO GO TO D30.
           MOVE 3        TO KTB-TIP.
           MOVE T11-CIVA TO KTB-COD PCIVA.
           READ TABELL INTO REKTAB INVALID
                PERFORM INVK-TAB
                PERFORM VISK-BCR
                GO TO WARNING.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      **** rel 4.0
      *    IF VALUT > 1 GO TO D30.
           IF NOT (VALUT = ZERO OR COMEURO OR 1) GO TO D30.
      ************
           IF T03-ALIVA = ZERO GO TO D40.
       D30.
           IF BCR-TCOR = 4 OR 5 MOVE BCR-RIVGR TO PCIVA
              ELSE IF FAT-CDESE = ZERO MOVE BCR-IVA TO PCIVA
                   ELSE MOVE FAT-CDESE TO PCIVA.
      **** rel 1.2
      *    IF KFT-TDOC = 2 AND (BCR-TCOR = 4 OR 5 OR 6)
           IF VALUT NOT = ZERO AND
              FAT-CDESE NOT = ZERO AND (BCR-TCOR = 4 OR 5 OR 6)
      ************
                MOVE FAT-CDESE TO PCIVA.
       D40.
      **** rel 1.2
      *    IF BCR-TCOR = 6 AND KFT-TDOC = 2
           IF BCR-TCOR = 6 AND ESTPIVA = 3
      ************
                           ADD BCR-NETRG TO GARANZ.
      **** rel 1.2
      *    IF VALUT > 1 AND BCR-TCOR = 4 ADD BCR-NETRG TO OMAGG.
      *    IF VALUT > 1 AND BCR-TCOR = 5 ADD BCR-NETRG TO SCMER.
      ************
      **** rel 4.0
      *    IF VALUT > 1 AND BCR-TCOR < 4 ADD BCR-NETRG TO VNTMER.
           IF NOT (VALUT = ZERO OR COMEURO) AND BCR-TCOR < 4
              ADD BCR-NETRG TO VNTMER.
      ************
      **** rel 2.0
           MOVE 1 TO FLGSTA.
           IF BCR-SC1 = ZERO OR BCR-SC2 = ZERO
              CALL 'rstam' USING PARST
              MOVE ZERO TO FLGSTA
              MOVE 1 TO XCRR.
      *
      * stampa note aggiuntive
           MOVE KCR-AZI TO KNCR-AZI.
           MOVE KCR-NUM TO KNCR-NUM.
           MOVE KCR-BOL TO KNCR-BOL.
           MOVE KCR-PGR TO KNCR-PGR.
           MOVE ZERO    TO KNCR-PGRN.
           START NOTBCR KEY > KEYNCR INVALID GO TO D70.
       RDN-NCR.
           READ NOTBCR NEXT AT END GO TO D70.
           IF KNCR-AZI > KCR-AZI GO TO D70.
           IF KNCR-NUM > KCR-NUM GO TO D70.
           IF KNCR-BOL > KCR-BOL GO TO D70.
           IF KNCR-PGR > KCR-PGR GO TO D70.
           IF NRIG > NRIG01 PERFORM C00-STAMPA-TESTA THRU C99.
           MOVE NCR-DESCR TO PDES.
      ************
       D50.
           CALL 'rstam' USING PARST.
           MOVE 1 TO XCRR.
      **** rel 2.0
           MOVE ZERO TO FLGSTA.
           GO TO RDN-NCR.
      *
       D70.
      **** rel 5.2
           IF BCR-ART NOT = SPACE
              MOVE ZERO     TO PCFA-FUN
              MOVE KCR-AZI  TO PCFA-AZI
              MOVE 'C'      TO PCFA-TIP
              MOVE FAT-CDCLI TO PCFA-CLF
              MOVE BCR-ART TO PCFA-ART
              MOVE CLF-FLING TO PCFA-LIN
              CALL 'vrrcfa' USING PARPCFA
              IF PCFA-ST = ZERO
                 IF PCFA-DEST NOT = SPACE
                    IF NRIG > NRIG01
                       PERFORM C00-STAMPA-TESTA THRU C99
                    END-IF
                    MOVE PCFA-DEST TO PDES
                    CALL 'rstam' USING PARST
                    MOVE 1 TO XCRR
                    MOVE ZERO TO FLGSTA
                 END-IF
                 IF PCFA-DDIS NOT = SPACE
                    IF NRIG > NRIG01
                       PERFORM C00-STAMPA-TESTA THRU C99
                    END-IF
                    MOVE PCFA-DDIS TO PDES
                    CALL 'rstam' USING PARST
                    MOVE 1 TO XCRR
                    MOVE ZERO TO FLGSTA.
      ************
           IF FLGSTA = 1 CALL 'rstam' USING PARST
                         MOVE 1 TO XCRR.
      **** rel 5.0
      *    IF BCT-IMB = 1 PERFORM SOMMA-IMBALLI THRU EX-SOMMA-IMBALLI.
           IF BCT-IMB = 1 PERFORM WR-LAV-IMB THRU EX-WR-LAV-IMB.
      ************
      ************
           GO TO D10.
       D99.
           EXIT.
      *------------------------------------------
       E00-STAMPA-PIEDE.
      **** rel 5.0
           PERFORM H00-STAMPA-MESSAGG-BOLLA THRU H99.
           PERFORM SOMMA-IMBALLI THRU EX-SOMMA-IMBALLI.
      ************
      **** rel 2.0
           PERFORM G00-STAMPA-IMBALLI THRU G99.
           IF ESTPIVA NOT = 3 PERFORM STAMPA-CONAI THRU EX-STAMPA-CONAI.
      ************
           MOVE NRIG00 TO COMODO.
           MOVE SALT00 TO COMOD1.
           IF FAT-OMAGG > ZERO SUBTRACT 1 FROM COMODO COMOD1.
           IF FAT-SCONT > ZERO SUBTRACT 1 FROM COMODO COMOD1.
      **** rel 1.2
      *    IF GARANZ    > ZERO AND KFT-TDOC = 2
           IF GARANZ    > ZERO AND ESTPIVA = 3
      ************
                               SUBTRACT 1 FROM COMODO COMOD1.
      **** rel 1.2
      *    IF KFT-TDOC = 2 GO TO LPPIEDE.
      ************
      **** rel 7.2
           IF (KFT-TDOC = 6 OR KFT-TDOC = 4) AND
              FAT-DATA >= 42005 
              PERFORM J00-STAMPA-SPLITPAY THRU J99.
      ************
           IF FAT-CDESE = ZERO GO TO LPPIEDE.
           IF CLF-ENUIVA = ZERO GO TO LPPIEDE.
      **** rel 1.2
      *    MOVE 3 TO KTB-TIP.
      *    MOVE FAT-CDESE TO KTB-COD.
      *    READ TABELL INTO REKTAB INVALID GO TO LPPIEDE.
      *    IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      *    IF T03-TPIVA NOT = 6 GO TO LPPIEDE.
           IF ESTPIVA NOT = 6 GO TO LPPIEDE.
      ************
           IF NRIG > COMODO PERFORM C00-STAMPA-TESTA THRU C99.
           MOVE COMOD1 TO SALT.
           MOVE 'Non imp. IVA art 8/2  DPR 633' TO PDES.
           CALL 'rstam' USING PARST.
           MOVE 1 TO XCRR.
           MOVE 'del 26/10/72 e succ. modifiche' TO PDES.
           CALL 'rstam' USING PARST.
           MOVE 'Vs aut. N.' TO RDES1.
           MOVE CLF-ENUIVA TO SOUT.
           MOVE ' del' TO RDES2.
           MOVE CLF-EDTIVA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO SDEL.
           CALL 'rstam' USING PARST.
           MOVE 'Ns protoc.' TO RDES1.
           MOVE CLF-INUIVA TO SOUT.
           MOVE ' del' TO RDES2.
           MOVE CLF-IDTIVA TO AAGGG.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO SDEL.
           CALL 'rstam' USING PARST.
       LPPIEDE.
           COMPUTE COMODO = NRIG00 - COMODO.
           IF COMODO = ZERO GO TO LPPIE-99.
           COMPUTE COMOD1 = SALT00 + 4 - COMODO.
           COMPUTE COMODO = COMODO + NRIG00.
           ADD 4 TO COMODO.
           IF NRIG > COMODO PERFORM C00-STAMPA-TESTA THRU C99.
           MOVE COMOD1 TO SALT.
           IF FAT-OMAGG = ZERO GO TO LPPIE-20.
           MOVE 'Cessione gratuita    = ' TO RDSMO.
      **** rel 4.0
      *    IF VALUT > 1
      ************
      **** rel 1.2
      *       MOVE OMAGG TO RDIMP1
      **** rel 4.0
      *       MOVE FAT-EOMAGG TO RDIMP1
      ************
      ************
      **** rel 4.0
      *    ELSE
      *       MOVE FAT-OMAGG TO RDIMP.
      ************
      **** rel 4.0
           IF (VALUT = ZERO OR COMEURO)
              MOVE FAT-OMAGG TO RDIMP1
           ELSE
              MOVE FAT-EOMAGG TO RDIMP1.
           IF VALUT = 1 MOVE FAT-EOMAGG TO RDIMP.
      ************
      **** rel 1.2
      *    IF KFT-TDOC = 2 OR FAT-IVRIV = ZERO GO TO LPPIE-10.
      ************
           IF FAT-IVRIV = ZERO GO TO LPPIE-10.
           MOVE 'Iva a nostro carico  = ' TO RDSIV.
      **** rel 1.2
      *    MOVE FAT-IVRIV TO RDIVA.
      **** rel 4.0
      *    IF VALUT > 1
      *       MOVE FAT-EIVRIV TO ERDIVA
      *    ELSE
      *       MOVE FAT-IVRIV TO RDIVA.
           IF (VALUT = ZERO OR COMEURO)
              MOVE FAT-IVRIV TO ERDIVA
           ELSE
              MOVE FAT-EIVRIV TO ERDIVA.
           IF VALUT = 1 MOVE FAT-EIVRIV TO RDIVA.
      ************
      ************
       LPPIE-10.
           CALL 'rstam' USING PARST.
       LPPIE-20.
           IF FAT-SCONT = ZERO GO TO LPPIE-30.
           MOVE 'Sconto in merce      = ' TO RDSMO.
      **** rel 4.0
      *    IF VALUT > 1
      ************
      **** rel 1.2
      *       MOVE SCMER TO RDIMP1
      **** rel 4.0
      *       MOVE FAT-ESCONT TO RDIMP1
      ************
      ************
      **** rel 4.0
      *    ELSE
      *       MOVE FAT-SCONT TO RDIMP.
      ************
      **** rel 4.0
           IF (VALUT = ZERO OR COMEURO)
              MOVE FAT-SCONT TO RDIMP1
           ELSE
              MOVE FAT-ESCONT TO RDIMP1.
           IF VALUT = 1 MOVE FAT-ESCONT TO RDIMP.
      ************
      ************
           CALL 'rstam' USING PARST.
       LPPIE-30.
      **** rel 1.2
      *    IF GARANZ = ZERO OR KFT-TDOC NOT = 2 GO TO LPPIE-99.
           IF GARANZ = ZERO OR ESTPIVA NOT = 3 GO TO LPPIE-99.
      ************
           MOVE 'Valore ai fini doganali' TO RDSMO.
      **** rel 4.0
      *    IF VALUT > 1
      *       MOVE GARANZ TO RDIMP1
      *    ELSE
      *       MOVE GARANZ TO RDIMP.
           MOVE GARANZ TO RDIMP1.
           IF VALUT = 1 MOVE GARANZ TO RDIMP.
      ************
           CALL 'rstam' USING PARST.
       LPPIE-99.
      **** rel 1.2
      *    IF VALUT > 1
      *       COMPUTE VSCFIN = (VNTMER - NOSCON) * SCONTO / 100
      *       PERFORM SCAVAL THRU EX-SCAVAL.
      **** rel 4.0
      *    IF VALUT > 1
           IF NOT (VALUT = ZERO OR COMEURO)
      ************
              COMPUTE VSCFIN = (VNTMER - NOSCON) * SCONTO / 100.
      ************
           MOVE SALT01 TO SALT.
      **** rel 4.0
      *    IF VALUT > 1
      *        MOVE VNTMER TO PTOT1
      *    ELSE
      *        MOVE FAT-NTMER TO PTOT.
           IF VALUT = ZERO OR COMEURO
              MOVE FAT-NTMER TO PTOT1
           ELSE
              MOVE VNTMER    TO PTOT1.
           IF VALUT = 1 MOVE VNTMER TO PTOT.
      ************
           CALL 'rstam' USING PARST.
           MOVE 1 TO XCRR.
           MOVE ZERO TO IMPON IMPOS.
           MOVE ZERO TO K.
       LSCA.
           ADD 1 TO K.
           IF K > 6 GO TO GSCA.
      **** rel 1.2
      *    IF VALUT > 1 AND K > 1 GO TO GSCA.
      ************
           IF FAT-CDIVA (K) = ZERO GO TO GSCA.
           MOVE FAT-CDIVA (K) TO KTB-COD.
           MOVE 3             TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                MOVE 'IVA INESISTENTE' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE FAT-CDIVA (K) TO PCDIVA.
      **** rel 1.2
      *    IF VALUT > 1
      *       MOVE FAT-TOVAL TO PIMP1
      *       ADD  FAT-TOVAL TO IMPON
      *       MOVE TAB-DESCR TO PALI1
      *       GO TO GSCA.
      *    MOVE FAT-IMPON (K) TO PIMP.
      *    ADD  FAT-IMPON (K) TO IMPON.
      *    IF T03-ALIVA = ZERO MOVE TAB-DESCR TO PALI1
      *    ELSE MOVE T03-DSIVA TO PALI
      *         MOVE FAT-IMPOS (K) TO PIMIVA.
      *    ADD  FAT-IMPOS (K) TO IMPOS.
      **** rel 4.0
      *    IF VALUT > 1
      *       MOVE FAT-EIMPON(K) TO PIMP1
      *       MOVE FAT-EIMPOS(K) TO EPIMIVA
      *       ADD  FAT-EIMPON(K) TO IMPON
      *       ADD  FAT-EIMPOS(K) TO IMPOS
      *    ELSE
      *       MOVE FAT-IMPON(K) TO PIMP
      *       MOVE FAT-IMPOS(K) TO PIMIVA
      *       ADD  FAT-IMPON(K) TO IMPON
      *       ADD  FAT-IMPOS(K) TO IMPOS.
           IF VALUT = ZERO OR COMEURO
              MOVE FAT-IMPON(K) TO PIMP1
              MOVE FAT-IMPOS(K) TO EPIMIVA
              ADD  FAT-IMPON(K) TO IMPON
              ADD  FAT-IMPOS(K) TO IMPOS
           ELSE
              MOVE FAT-EIMPON(K) TO PIMP1
              MOVE FAT-EIMPOS(K) TO EPIMIVA
              ADD  FAT-EIMPON(K) TO IMPON
              ADD  FAT-EIMPOS(K) TO IMPOS.
           IF VALUT = 1
              MOVE FAT-EIMPON(K) TO PIMP
              MOVE FAT-EIMPOS(K) TO PIMIVA.
      ************
           IF T03-ALIVA = ZERO
              MOVE TAB-DESCR TO PALI1
           ELSE
              MOVE T03-DSIVA TO PALI.
      ************
       GSCA.
           IF K = 1 GO TO LRIE.
           IF K > 7 GO TO ESCA.
           SUBTRACT 1 FROM K.
           IF FAT-DTSCA (K) = ZERPK GO TO GSCA1.
           IF VISTA = 1 MOVE 'A VISTA' TO PSCAD
                        MOVE ZERO TO VISTA
                        GO TO GSCA0.
           MOVE FAT-DTSCA (K) TO AAGGG.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO PSCAD.
       GSCA0.
      **** rel 4.0
      *    MOVE FAT-IMPOR (K) TO PSCIMP.
      *    IF VALUT > 1
      ************
      **** rel 1.2
      **** rel 4.0
      *       MOVE FAT-EIMPOR(K) TO PSCIM2.
      ************
      *       IF SV-IMVAL(K) NOT = ZERO MOVE SV-IMVAL(K) TO PSCIM2.
      ************
      **** rel 4.0
           IF VALUT = ZERO OR COMEURO
              MOVE FAT-IMPOR (K) TO PSCIM2
           ELSE
              MOVE FAT-EIMPOR (K) TO PSCIM2.
           IF VALUT = 1
                 MOVE FAT-EIMPOR (K) TO PSCIMP.
      ************
       GSCA1.
           ADD 1 TO K.
       LRIE.
           IF K = 1 AND FAT-SCFIN > ZERO
               MOVE 'SC.' TO PSFIN
               MOVE SCONTO    TO PSPER
               MOVE '%' TO FILPE
               MOVE 'SU' TO FILLUN
               CALL 'rstam' USING PARST
               GO TO LSCA.
           IF K = 2 AND FAT-SCFIN > ZERO
      **** rel 4.0
              MOVE SPACE TO PSCO1
              IF VALUT = ZERO OR COMEURO
                 COMPUTE PSCO3 = FAT-NTMER - NOSCON
                 COMPUTE PTOT1 = - FAT-SCFIN
              ELSE
                  COMPUTE PSCO3 = VNTMER - NOSCON
                  COMPUTE PTOT1 = - VSCFIN
              END-IF
              IF VALUT = 1
                 COMPUTE PSCO2 = VNTMER - NOSCON
                 COMPUTE PTOT  = - VSCFIN.
      *        IF VALUT > 1
      *           MOVE SPACE TO PSCO1
      *           COMPUTE PSCO3 = VNTMER - NOSCON
      *           COMPUTE PTOT1 = - VSCFIN
      *        ELSE
      *           MOVE 'L.' TO PSCO1
      *           COMPUTE PSCO2 = FAT-NTMER - NOSCON
      *           COMPUTE PTOT  = - FAT-SCFIN.
      ************
           IF K = 4 AND FAT-SPBOL > ZERO
      **** rel 4.0
      *             AND VALUT <= 1
                    AND (VALUT = ZERO OR COMEURO)
      ************
               MOVE 'BOLLI' TO PSPESA
      **** rel 4.0
      *        MOVE FAT-SPBOL TO PTOT.
               MOVE FAT-SPBOL TO PTOT1.
      ************
      **** rel 4.0
           IF K = 4 AND FAT-ESPBOL > ZERO
                    AND VALUT = 1    MOVE 'BOLLI'    TO PSPESA
                                     MOVE FAT-ESPBOL TO PTOT.
      ************
      **** rel 1.2
      *    IF K = 6 AND FAT-SPBAN > ZERO
      *             AND VALUT <= 1
      *        MOVE 'SPESE BANCA' TO PSPESA
      *        MOVE FAT-SPBAN TO PTOT.
           IF K = 6 AND FAT-SPBAN > ZERO
              MOVE 'SPESE BANCA' TO PSPESA
      **** rel 4.0
      *       IF VALUT <= 1
      *          MOVE FAT-SPBAN TO PTOT
      *       ELSE
      *          MOVE FAT-ESPBAN TO PTOT1.
              IF VALUT = ZERO OR COMEURO
                 MOVE FAT-SPBAN TO PTOT1
              ELSE
                 MOVE FAT-ESPBAN TO PTOT1
              END-IF
              IF VALUT = 1 MOVE FAT-ESPBAN TO PTOT.
      ************
      ************
           CALL 'rstam' USING PARST.
           GO TO LSCA.
       ESCA.
      **** rel 4.0
      *    IF VALUT > 1
      *       MOVE IMPON TO PIMP1
      *    ELSE
      *       MOVE IMPON TO PIMP.
           MOVE IMPON TO PIMP1.
           IF VALUT = 1 MOVE IMPON TO PIMP.
      ************
      **** rel 4.0
      *    MOVE IMPOS TO PIMIVA.
      ************
      **** rel 1.2
      **** rel 4.0
      *    IF VALUT > 1 AND FAT-CDESE = ZERO
      *       MOVE IMPOS TO EPIMIVA.
      ************
      ************
      **** rel 4.0
           MOVE IMPOS TO EPIMIVA.
           IF VALUT = 1 MOVE IMPOS TO PIMIVA.
      ************
      **** rel 7.2
           IF (KFT-TDOC = 6 OR KFT-TDOC = 4) AND
              FAT-DATA >= 42005 
              GO TO NOSAC.
      ************
      **** rel 4.0
      *    IF KFT-TDOC NOT = 1 GO TO NOSAC.
      *    COMPUTE TOTACC = FAT-TOTFT - FAT-IMPOR(1)
      *                               - FAT-IMPOR(2)
      *                               - FAT-IMPOR(3)
      *                               - FAT-IMPOR(4)
      *                               - FAT-IMPOR(5)
      *                               - FAT-IMPOR(6).
           IF VALUT = ZERO OR COMEURO
              COMPUTE TOTACC = FAT-TOTFT - FAT-IMPOR(1)
                                         - FAT-IMPOR(2)
                                         - FAT-IMPOR(3)
                                         - FAT-IMPOR(4)
                                         - FAT-IMPOR(5)
                                         - FAT-IMPOR(6)
           ELSE
              COMPUTE TOTACC = FAT-TOVAL - FAT-EIMPOR(1)
                                         - FAT-EIMPOR(2)
                                         - FAT-EIMPOR(3)
                                         - FAT-EIMPOR(4)
                                         - FAT-EIMPOR(5)
                                         - FAT-EIMPOR(6).
      ************
           IF TOTACC > ZERO MOVE 'ACCONTO' TO PSCAD
      **** rel 4.0
                         MOVE TOTACC TO PSCIM2
                         IF VALUT = 1
      ************
                            MOVE TOTACC TO PSCIMP.
       NOSAC.
      **** rel 4.0
      *    IF VALUT > 1
      *       MOVE FAT-TOVAL TO PTOT1
      *    ELSE
      *       MOVE FAT-TOTFT TO PTOT.
           IF VALUT = ZERO OR COMEURO
              MOVE FAT-TOTFT TO PTOT1
           ELSE
              MOVE FAT-TOVAL TO PTOT1.
           IF VALUT = 1 MOVE FAT-TOVAL TO PTOT.
      ************
           CALL 'rstam' USING PARST.
           MOVE 2 TO XCRR.

           MOVE BCT-DEST TO PDEST.
           MOVE BCT-ASPE TO PASPE.
           MOVE BCT-NCOL TO PNCOL.
           MOVE BCT-PLOR TO PPLOR.
           MOVE BCT-PNET TO PNETT.
           CALL 'rstam' USING PARST.
           MOVE 2 TO XCRR.
           IF BCT-VRAG1 = SPACE MOVE 6 TO XCRR GO TO E50.
           MOVE BCT-VRAG1 TO PVETT.
           MOVE BCT-VIND1 TO PVIND.
           MOVE BCT-DTRA  TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA   TO DTRA.
           IF DTRA     NOT = ZERO MOVE DTRA     TO PDRIT.
           IF BCT-OTRA NOT = ZERO MOVE BCT-OTRA TO PORIT.
           CALL 'rstam' USING PARST.
           MOVE 4 TO XCRR.
       E50.
           MOVE BCT-CAUT TO PCAUT.
           IF BCT-VRAG1 NOT = SPACE GO TO E90.
           MOVE BCT-DTRA  TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA   TO DTRA.
           IF DTRA     NOT = ZERO MOVE DTRA     TO PDTRA.
           IF BCT-OTRA NOT = ZERO MOVE BCT-OTRA TO POTRA.
       E90.
           CALL 'rstam' USING PARST.
       E99.
           EXIT.
      *-------------------------------
      **** rel 1.2
      *SCAVAL.
      *    MOVE ZERO TO J.
      *SVAL10.
      *    ADD 1 TO J.
      *    IF J > 6 GO TO SVAL50.
      *    MOVE FAT-DTSCA(J) TO SV-DTSCA(J).
      *    MOVE FAT-IMPOR(J) TO SV-IMPOR(J).
      *    GO TO SVAL10.
      *SVAL50.
      *    MOVE FAT-DTVAL    TO SV-DTVAL.
      *    CALL 'vrscadv' USING PARSV.
      *EX-SCAVAL.
      *    EXIT.
      ************
      **** rel 2.0
      *-------------------------------
      **** rel 5.0
      *SOMMA-IMBALLI.
      *    IF NOT (BCR-TCOR = ZERO OR 2) GO TO EX-SOMMA-IMBALLI.
      *    MOVE KBC-AZI TO KPBR-AZI.
      *    MOVE KBC-NUM TO KPBR-TNUM.
      *    MOVE KBC-BOL TO KPBR-NBOL.
      *    MOVE KCR-PGR TO KPBR-RBOL.
      *    MOVE ZERO    TO KPBR-PGR.
      *    START PROBCR KEY NOT < KEYPBR INVALID GO TO EX-SOMMA-IMBALLI.
      *SOMM-IMB-10.
      *    READ PROBCR NEXT AT END GO TO EX-SOMMA-IMBALLI.
      *    IF SF-PBR = '9D' OR '9A' OR '35' GO TO SOMM-IMB-10.
      *    IF KBC-AZI  NOT = KPBR-AZI GO TO EX-SOMMA-IMBALLI.
      *    IF KBC-NUM NOT = KPBR-TNUM GO TO EX-SOMMA-IMBALLI.
      *    IF KBC-BOL NOT = KPBR-NBOL GO TO EX-SOMMA-IMBALLI.
      *    IF KCR-PGR NOT = KPBR-RBOL GO TO EX-SOMMA-IMBALLI.
      *
      *    MOVE ZERO TO INDICE.
      *RIPETI.
      *    ADD 1 TO INDICE.
      *    IF INDICE > ULTIND GO TO NEWIMB.
      *    IF PBR-IMB = VETIMB(INDICE)
      *       ADD PBR-NIMB TO VETQTA(INDICE)
      *       GO TO SOMM-IMB-10.
      *    GO TO RIPETI.
      *NEWIMB.
      *    ADD 1 TO ULTIND.
      *    IF ULTIND > 10 GO TO EX-SOMMA-IMBALLI.
      *    MOVE PBR-IMB  TO VETIMB(ULTIND).
      *    MOVE PBR-NIMB TO VETQTA(ULTIND).
      *    GO TO SOMM-IMB-10.
      *EX-SOMMA-IMBALLI.
      *    EXIT.
      ************
      *-------------------------------
       G00-STAMPA-IMBALLI.
           MOVE ZERO TO INDICE.
       REPEAT.
           ADD 1 TO INDICE.
           IF INDICE > ULTIND GO TO G99.
           IF NRIG > NRIG01 PERFORM C00-STAMPA-TESTA THRU C99.
      **** rel 5.0
      *    MOVE 80             TO KTB-TIP.
      *    MOVE VETIMB(INDICE) TO KTB-COD.
      *    READ TABELL INTO REKTAB INVALID KEY PERFORM INVK-TAB
      *                                        GO TO ERRIO.
      *    IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE KAZ-COD        TO KAIM-AZI.
           MOVE VETIMB(INDICE) TO KAIM-COD.
           READ ANAIMB INVALID PERFORM INVK-AIM
                               GO TO ERRIO.
      ************
           MOVE VETIMB(INDICE) TO PCDIMB.
      **** rel 5.0
      *    MOVE TAB-DESCR      TO PDIMB.
           MOVE AIM-DESC       TO PDIMB.
      ************
           MOVE VETQTA(INDICE) TO PQTIMB.
      **** rel 4.0
      *    IF VALUT > 1
      *       MOVE T80-COSU TO ER-IMPORTO
      *       CALL 'rtriimp' USING ER-IMPORTO LIR-VAL CG-PAR
      *       MOVE ER-IMPORTO TO PPZIMB1
      *       COMPUTE ER-IMPORTO = ER-IMPORTO * VETQTA(INDICE)
      *       MOVE ER-IMPORTO TO PIMPNT1
      *    ELSE
      *       MOVE T80-COSU TO PPZIMB
      *       COMPUTE IMPIMB = VETQTA(INDICE) * T80-COSU
      *       MOVE IMPIMB TO PIMPNT.
           IF VALUT = ZERO OR COMEURO
      **** rel 5.0
      *       MOVE T80-COSU TO PPZIMB1
      *       COMPUTE IMPIMB = VETQTA(INDICE) * T80-COSU
              MOVE AIM-COSU TO PPZIMB1
              COMPUTE IMPIMB = VETQTA(INDICE) * AIM-COSU
      ************
              MOVE IMPIMB TO PIMPNT1
           ELSE
      **** rel 5.0
      *       MOVE T80-COSU TO ER-IMPORTO
              MOVE AIM-COSU TO ER-IMPORTO
      ************
              MOVE CG-CAMBIO TO ER-CAMBIO
              MOVE CG-VALUT  TO ER-VALUT
              CALL 're2imp' USING ER-IMPORTO EUR-VAL ER-VALUT ER-CAMBIO
              MOVE ER-IMPORTO TO PPZIMB1
              IF VALUT = 1
                 MOVE ER-IMPORTO TO PPZIMB
              END-IF
              COMPUTE ER-IMPORTO = ER-IMPORTO * VETQTA(INDICE)
              ADD ER-IMPORTO TO VNTMER
              MOVE ER-IMPORTO TO PIMPNT1
              IF VALUT = 1
                 MOVE ER-IMPORTO TO PIMPNT.
      ************
           IF FAT-CDESE = ZERO
      **** rel 5.0
      *       MOVE T80-CDIVA TO PIVAIM
              MOVE AIM-CDIVA TO PIVAIM
      ************
           ELSE
              MOVE FAT-CDESE TO PIVAIM.
           MOVE 1 TO XCRR.
           CALL 'rstam' USING PARST.
           GO TO REPEAT.
       G99.
           EXIT.
      *-------------------------------
       STAMPA-CONAI.
           IF CLF-CONAI NOT = 1 GO TO EX-STAMPA-CONAI.
           IF NRIG > NRIG01
              PERFORM C00-STAMPA-TESTA THRU C99
           ELSE
              MOVE 2 TO XCRR.
           MOVE 'CONTRIBUTO CONAI ASSOLTO' TO PCONAI.
           CALL 'rstam' USING PARST.
       EX-STAMPA-CONAI.
           EXIT.
      ************
      *-------------------------------
           COPY 'errmes'.
      **** rel 2.0
           COPY 'erreur'.
      ************
           COPY 'griazier'.
           COPY 'griclfer'.
           COPY 'gribaner'.
           COPY 'gribcter'.
           COPY 'gribcrer'.
           COPY 'grifater'.
           COPY 'griliner'.
           COPY 'gritaber'.
      **** rel 2.0
           COPY 'grincrer'.
           COPY 'gripbrer'.
      ************
      **** rel 5.0
           COPY 'griaimer'.
      ************
           COPY 'grixxxer'.
      *-------------------------------
      **** rel 5.0
       WR-LAV-IMB.
           IF NOT (BCR-TCOR = ZERO OR 2) GO TO EX-WR-LAV-IMB.
           MOVE KBC-AZI TO KPBR-AZI.
           MOVE KBC-NUM TO KPBR-TNUM.
           MOVE KBC-BOL TO KPBR-NBOL.
           MOVE KCR-PGR TO KPBR-RBOL.
           MOVE ZERO    TO KPBR-PGR.
           START PROBCR KEY NOT < KEYPBR INVALID GO TO EX-WR-LAV-IMB.
       LAV-IMB-10.
           READ PROBCR NEXT AT END GO TO EX-WR-LAV-IMB.
           IF SF-PBR = '9D' OR '9A' OR '35' GO TO LAV-IMB-10.
           IF KBC-AZI NOT = KPBR-AZI GO TO EX-WR-LAV-IMB.
           IF KBC-NUM NOT = KPBR-TNUM GO TO EX-WR-LAV-IMB.
           IF KBC-BOL NOT = KPBR-NBOL GO TO EX-WR-LAV-IMB.
           IF KCR-PGR NOT = KPBR-RBOL GO TO EX-WR-LAV-IMB.
      *
           MOVE KBC-AZI TO KAIM-AZI.
           MOVE PBR-IMB TO KAIM-COD.
           READ ANAIMB INVALID PERFORM INVK-AIM
                               PERFORM VISK-PBR
                               GO TO ERRIO.
           IF AIM-FLGREND = 1 GO TO LAV-IMB-10.
      *
           MOVE PBR-NPAL TO KWSI-NPAL.
           MOVE PBR-NCOL TO KWSI-NCOL.
           MOVE PBR-IMB  TO KWSI-IMB.
           ADD 1         TO KWSI-PRG.
           MOVE PBR-NIMB TO WSI-NIMB.
           WRITE RF-WSI INVALID MOVE 'vfat220: WR-LAV WSI' TO MESS
                                GO TO ERRIO.
      *
           GO TO LAV-IMB-10.
       EX-WR-LAV-IMB.
           EXIT.
      *-------------------------------
       DL-LAV-IMB.
           CLOSE WDSSIB.
           OPEN OUTPUT WDSSIB.
           CLOSE WDSSIB.
           OPEN I-O WDSSIB.
           MOVE ZERO TO KWSI-PRG.
       EX-DL-LAV-IMB.
      *-------------------------------
       SOMMA-IMBALLI.
      * azzeramento vettore totali imballi
           MOVE 1 TO INDICE.
           PERFORM UNTIL INDICE > 30
              MOVE SPACE TO VETIMB(INDICE)
              MOVE ZERO  TO VETQTA(INDICE)
              ADD 1 TO INDICE
           END-PERFORM.
      *
           MOVE ZERO  TO PREPAL PRECOL.
           MOVE SPACE TO PREIMB.
           MOVE ZERO  TO ULTIND.
      *
           MOVE LOW-VALUE TO KEYWSI.
           START WDSSIB KEY > KEYWSI INVALID GO TO EX-SOMMA-IMBALLI.
       SOMMA-IMB-10.
           READ WDSSIB NEXT AT END GO TO EX-SOMMA-IMBALLI.
           IF KWSI-NCOL = ZERO
              MOVE WSI-NIMB TO COMNIMB
              GO TO SOMMA-IMB-20.
           IF KWSI-NPAL = PREPAL AND
              KWSI-NCOL = PRECOL AND
              KWSI-IMB  = PREIMB GO TO SOMMA-IMB-10.
           MOVE 1 TO COMNIMB.
       SOMMA-IMB-20.
           MOVE KWSI-NPAL TO PREPAL.
           MOVE KWSI-NCOL TO PRECOL.
           MOVE KWSI-IMB  TO PREIMB.
      *
           MOVE 1 TO INDICE.
           PERFORM UNTIL INDICE > 30
              IF VETIMB(INDICE) = SPACE
                 MOVE KWSI-IMB TO VETIMB(INDICE)
                 MOVE COMNIMB  TO VETQTA(INDICE)
                 MOVE INDICE TO ULTIND
                 MOVE 30 TO INDICE
              ELSE
                 IF VETIMB(INDICE) = KWSI-IMB
                     ADD COMNIMB TO VETQTA(INDICE)
                     MOVE 30 TO INDICE
                 END-IF
              END-IF
              ADD 1 TO INDICE
           END-PERFORM.
      *
           GO TO SOMMA-IMB-10.
       EX-SOMMA-IMBALLI.
           EXIT.
      *------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-WSI.
           STRING 'w0' PID DELIMITED SPACE INTO ID-WSI.
       EX-CREA-IDLAV.
           EXIT.
      *------------------
      ************
      **** rel 5.0
       H00-STAMPA-MESSAGG-BOLLA.
           MOVE 2 TO XCRR.
           MOVE KAZ-COD  TO P-MDT-AZI.
           MOVE 1        TO P-MDT-TDOC.
           MOVE KEYBC    TO P-MDT-KEY.
           MOVE 2        TO P-MDT-FLGS.
           MOVE BCT-DATA TO P-MDT-DATA.
           MOVE ZERO     TO P-MDT-FLGE.
       H10.
           CALL 'vrpmdt' USING PAR-P-MDT.
           IF P-MDT-FLGE NOT = 1 GO TO H99.
           IF NRIG > NRIG01 - XCRR + 1
                     PERFORM C00-STAMPA-TESTA THRU C99.
           STRING '* ' P-MDT-TESTO(1:P-MDT-NCOL) ' *'
                  DELIMITED SIZE INTO RIGS(2:).
           CALL 'rstam' USING PARST.
           MOVE 1 TO XCRR.
           GO TO H10.
       H90.
           IF P-MDT-TDOC = 1 MOVE 3  TO P-MDT-TDOC
                             GO TO H10.
       H99.
           EXIT.
      ************
      **** rel 7.2
       J00-STAMPA-SPLITPAY.
      *
           MOVE 2 TO XCRR.
           MOVE '- Scissione dei pagamenti -'  TO PDES.
           CALL 'rstam' USING PARST.
           MOVE 1 TO XCRR.
           MOVE 'Iva da versare a cura del'    TO PDES.
           CALL 'rstam' USING PARST.
           MOVE 'cessionario o committente ai' TO PDES.
           CALL 'rstam' USING PARST.
           MOVE 'sensi dell''Articolo 17-Ter'  TO PDES.
           CALL 'rstam' USING PARST.
           MOVE 'D.P.R n.633/1972 e '         TO PDES.
           CALL 'rstam' USING PARST.
           MOVE 'successive modifiche'         TO PDES.
           CALL 'rstam' USING PARST.
      *
       J99.
           EXIT.
      *-------------------------------
      ************
