       IDENTIFICATION DIVISION.
       PROGRAM-ID. VFAT500.
      *
      * OGGETTO: Esportazione Fatture PA 
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'gribctsl'.
           COPY 'griactsl'.
           COPY 'griaftsl'.
           COPY 'gribcrsl'.
           COPY 'griazisl'.
           COPY 'griaazsl'.
           COPY 'grifatsl'.
           COPY 'griclfsl'.
           COPY 'gritabsl'.
           COPY 'gritfesl'.
           COPY 'griordsl'.
           COPY 'grincrsl'.
           COPY 'griacfsl'.
      **** rel 7.1
           COPY 'gribansl'.
           COPY 'griabasl'.
      ************
      **** rel 7.2
           COPY 'grialgsl'.
      ************
       DATA DIVISION.
       FILE SECTION.
           COPY 'gribct'.
           COPY 'griact'.
           COPY 'griaft'.
           COPY 'gribcr'.
           COPY 'griazi'.
           COPY 'griaaz'.
           COPY 'grifat'.
           COPY 'griclf'.
           COPY 'gritab'.
           COPY 'gritfe'.
           COPY 'griord'.
           COPY 'grincr'.
           COPY 'griacf'.
      **** rel 7.1
           COPY 'griban'.
           COPY 'griaba'.
      ************
      **** rel 7.2
           COPY 'grialg'.
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griazirk'.
           COPY 'griclfrk'.
           COPY 'gritabrk'.
           COPY 'grit35rk'.
           COPY 'griordrk'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parbc'.
           COPY 'pardag'.
           COPY 'parpsct'.
           COPY 'parg'.
           COPY 'parrb'.
           COPY 'parsx'.
           COPY 'parwxml'.
           COPY 'parwtxt'.
           COPY 'parmb'.
      **** rel 7.2
           COPY 'parag'.
      ************
      **** rel 7.2
           COPY 'parrd'.
      ************
       01  PAR-D-MDT.
           05 D-MDT-AZI  PIC 999.
           05 D-MDT-TDOC PIC 9.
           05 D-MDT-KEY  PIC X(15).
       01  ID-AZI  PIC X(15) VALUE 'anaazi'.
       01  ID-BCT  PIC X(15) VALUE 'bolcte'.
       01  ID-BCR  PIC X(15) VALUE 'bolcri'.
       01  ID-FAT  PIC X(15) VALUE 'fattur'.
       01  ID-CLF  PIC X(15) VALUE 'anaclf'.
       01  ID-TAB  PIC X(15) VALUE 'tabell'.
       01  ID-ARI  PIC X(15) VALUE 'apprig'.
       01  ID-ACT  PIC X(15) VALUE 'appbct'.
       01  ID-AFT  PIC X(15) VALUE 'appfat'.
       01  ID-TFE  PIC X(15) VALUE 'tabfel'.
       01  ID-AAZ  PIC X(15) VALUE 'appazi'.
       01  ID-ORD  PIC X(15) VALUE 'ordcli'.
       01  ID-NCR  PIC X(15) VALUE 'notbcr'.
       01  ID-ACF  PIC X(15) VALUE 'appclf'.
      **** rel 7.1
       01  ID-BAN PIC X(15) VALUE 'anaban'.
       01  ID-ABA PIC X(15) VALUE 'appban'.
      ************
      **** rel 7.2
       01  ID-ALG PIC X(15) VALUE 'allega'.
      ************
       01  COMODI.
           05 SF-AZI   PIC XX.
           05 SF-BCT   PIC XX.
           05 SF-BCR   PIC XX.
           05 SF-FAT   PIC XX.
           05 SF-CLF   PIC XX.
           05 SF-TAB   PIC XX.
           05 SF-ARI   PIC XX.
           05 SF-ACT   PIC XX.
           05 SF-AFT   PIC XX.
           05 SF-TFE   PIC XX.
           05 SF-AAZ   PIC XX.
           05 SF-ORD   PIC XX.
           05 SF-NCR   PIC XX.
           05 SF-ACF   PIC XX.
      **** rel 7.1
           05 SF-BAN  PIC XX.
           05 SF-ABA  PIC XX.
      ************
      **** rel 7.2
           05 SF-ALG  PIC XX.
      ************
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 DAT1     PIC 9(5).
           05 DAT2     PIC 9(5).
           05 K        PIC 9(3).
           05 K1       PIC 99.
      **** rel 7.2
           05 K3       PIC 999.
           05 ENDFILE PIC 999.
           05 LUNGNOME PIC 999.
           05 NOMEFILE PIC X(150).
      ************
           05 CODCLI.
              10 CMAS   PIC 9(2).
              10 CCOD   PIC 9(5).
           05 PROG     PIC 9(5).
           05 NUMFAT   PIC 9(5).
           05 COMNUM   PIC 9(10)V9(6).
           05 CONT     PIC 9(5).
           05 COMCFISC PIC X(16).
           05 NFAT     PIC 9(5).
           05 NFATA    REDEFINES NFAT PIC ZZZZ9.
           05 ULFAT    PIC 9(5).
           05 ULFATA   REDEFINES ULFAT PIC ZZZZ9.
           05 SAVORD   PIC 9(5).
           05 COMVALUT PIC X(3).
      **** rel 7.1
           05 D-IBAN   PIC X(27).
           05 D-ABI    PIC X(5).
           05 D-CAB    PIC X(5).
      **** rel 7.2
      *    05 COM-DESC PIC X(100).
           05 COM-DESC PIC X(500).
           05 ALG-KEY.
              10 AF-NUM PIC 9.
              10 AF-BOL PIC 9(5).
              10 AF-CATT PIC X.
      ************
      **** rel 7.2
           05 FLGNOPAG PIC 9.
      ************
      **** rel 7.2
           05 CDIVA    PIC 9(3)V99 OCCURS 6.
           05 IMPON    PIC S9(11)V9(7) OCCURS 6.
           05 SAVPRZ   PIC S9(10)V9(6).
           05 IND      PIC 9.
           05 SCONTO   PIC 999V99 VALUE ZERO.
           05 SCONXX   PIC X(6).
           05 CALCNUM  PIC S9(11)V9(7).
           05 IVABL    PIC 9(3).
       01  NNN-X.
           05 FILLER PIC X VALUE 'N'.
           05 FILLER PIC X VALUE 'M'.
      ************
      *
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-CATT      PIC X.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D  PIC X(36).
           05 IF-TPDOC     PIC 9.
           05 IF-COD-1     PIC 9(5).
           05 IF-COD-2     PIC 9(5).
           05 IF-CLI-1     PIC 9(5).
           05 IF-CLI-2     PIC 9(5).
           05 IF-DAT-1     PIC 9(6).
           05 IF-DAT-2     PIC 9(6).
           05 IF-PERC      PIC X(100).
           05 IF-ATT       PIC X.
           05 IF-ATT-D     PIC X(24).
           05 IF-PROG      PIC 9(5).
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclbct'.
           COPY 'dclbcr'.
           COPY 'dclfat'.
           COPY 'dclclf'.
           COPY 'dcltab'.
           COPY 'dclact'.
           COPY 'dclaft'.
           COPY 'dcltfe'.
           COPY 'dclaaz'.
           COPY 'dclord'.
           COPY 'dclncr'.
           COPY 'dclacf'.
      **** rel 7.1
           COPY 'dclban'.
           COPY 'dclaba'.
      ************
      **** rel 7.2
           COPY 'dclalg'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vfat500: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI BOLCTE BOLCRI FATTUR
                 ANACLF TABELL APPBCT TABFEL
                 APPFAT APPAZI ORDCLI NOTBCR
                 APPCLF.
      **** rel 7.1
           CLOSE ANABAN APPBAN.
      ************
      **** rel 7.2
           CLOSE ALLEGA.
      ************
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'gribcter'.
           COPY 'gribcrer'.
           COPY 'grifater'.
           COPY 'griclfer'.
           COPY 'gritaber'.
           COPY 'griacter'.
           COPY 'griafter'.
           COPY 'gritfeer'.
           COPY 'griaazer'.
           COPY 'griorder'.
           COPY 'grincrer'.
           COPY 'griacfer'.
      **** rel 7.1
           COPY 'gribaner'.
           COPY 'griabaer'.
      ************
      **** rel 7.2
           COPY 'grialger'.
      ************
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           OPEN INPUT ANAAZI
                      ANACLF
                      TABELL
                      APPBCT
                      APPFAT
                      APPAZI
                      ORDCLI
                      NOTBCR
      **** rel 7.1
                      ANABAN 
                      APPBAN
      ************
      **** rel 7.2
                      ALLEGA
      ************
                      APPCLF
                      BOLCRI.
           OPEN I-O TABFEL BOLCTE.
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                                GO TO ERRIO.
           MOVE KEYAZ TO KEYAAZ.
           READ APPAZI.
           IF SF-AAZ NOT = ZERO 
              MOVE ZERO  TO RF-AAZ AAZ-DNA
              MOVE SPACE TO AAZ-RGSOC AAZ-CNA AAZ-PNA 
                            AAZ-SES
              MOVE KAZ-COD TO KAAZ-COD.
      *
           MOVE SPACE TO COMCFISC.
           IF AZI-CFISC = SPACE
              MOVE AZI-PIVA TO COMCFISC
           ELSE
              MOVE AZI-CFISC TO COMCFISC.
      *
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM INVK-TAB
                GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MCLI TO CMAS.
           MOVE KAZ-COD TO KTFE-AZI. 
           READ TABFEL INVALID
                PERFORM INVK-TFE
                GO TO ERRIO.
      *
      **** rel 7.2
           MOVE 14 TO KTB-TIP.
           MOVE 1 TO KTB-COD.
           READ TABELL INTO REKTAB INVALID KEY
                PERFORM INVK-TAB
                GO TO WARNING.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T14-IVABL TO IVABL.
      *************
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE AZRGSOC TO IF-AZI-D.
           MOVE 1       TO IF-TPDOC.
           MOVE ZERO    TO IF-COD-1
                           IF-COD-2.
           MOVE ZERO    TO IF-CLI-1
                           IF-DAT-1.
           MOVE 99999   TO IF-CLI-2.
           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO AAGGG.
           MOVE AA9 TO GG9.
           MOVE AAGGG TO AA9.
           MOVE GGMMAA TO IF-DAT-2.
           MOVE TFE-PERC TO IF-PERC.
           MOVE IF-CATT  TO IF-ATT.
           MOVE IF-ATT TO T35-CATT.
           MOVE 35     TO T35-TIP.
           MOVE IF-AZI TO T35-CDAZ.
           MOVE T35-KEYID  TO KEYTB.
           READ TABELL INTO REKT35 INVALID
                MOVE ALL '*' TO T35-DATT.
           MOVE T35-DATT TO IF-ATT-D.
           IF IF-ATT = ZERO
              MOVE 'ATTIVITA'' PRINCIPALE' TO IF-ATT-D.
           MOVE TFE-PROG TO IF-PROG.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
       V-TPDOC.
           MOVE 'IF-TPDOC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TPDOC.
           IF NOT (IF-TPDOC = 1 OR 2 OR 3 OR 4 OR 6)
              PERFORM ERR-RADIO
              GO TO V-ERROR.
       E-TPDOC.
      *
       V-COD-1.
           MOVE 'IF-COD-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-COD-1.
       E-COD-1.
      *
       V-COD-2.
           MOVE 'IF-COD-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-COD-2.
           IF IF-COD-2 < IF-COD-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-COD-2.
      *
       V-CLI-1.
           MOVE 'IF-CLI-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CLI-1.
       E-CLI-1.
      *
       V-CLI-2.
           MOVE 'IF-CLI-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CLI-2.
           IF IF-CLI-2 < IF-CLI-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-CLI-2.
      *
       V-ATT.
           MOVE 'IF-ATT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ATT.
           MOVE SPACE TO IF-ATT-D.
      *
           MOVE IF-ATT TO T35-CATT.
           MOVE 35     TO T35-TIP.
           MOVE IF-AZI TO T35-CDAZ.
           MOVE T35-KEYID  TO KEYTB.
           READ TABELL INTO REKT35 INVALID
                MOVE ALL '*' TO T35-DATT.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT35.
           IF IF-ATT = ZERO
              MOVE 'ATTIVITA'' PRINCIPALE' TO IF-ATT-D.
           IF T35-FELE = ZERO
              MOVE 'Su questo codice attivit non          ' TO F-MES1
              MOVE 'possibile generare fatture elettroniche ' TO F-MES2
              MOVE 2 TO F-NMES
              GO TO V-ERROR.
           MOVE T35-DATT TO IF-ATT-D.
       E-ATT.
      *
       V-DAT-1.
           MOVE 'IF-DAT-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DAT-1.
           MOVE 1 TO TIPOP1.
           MOVE IF-DAT-1 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 = 1
              MOVE ZERO TO DAT1
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE 1 TO TIPOP1.
           MOVE IF-DAT-1 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG      TO DAT1.
       E-DAT-1.
      *
       V-DAT-2.
           MOVE 'IF-DAT-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DAT-2.
           MOVE 1 TO TIPOP1.
           MOVE IF-DAT-2 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 = 1
              MOVE ZERO TO IF-DAT-2
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE 1 TO TIPOP1.
           MOVE IF-DAT-2 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG  TO DAT2.
           IF DAT2 < DAT1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-DAT-2.
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           IF IF-ATT NOT = ZERO
              STRING 'fattur' IF-ATT DELIMITED SPACE INTO ID-FAT.
           OPEN INPUT FATTUR.
      *
           MOVE TFE-PROG TO PROG.
      *
           MOVE ZERO TO KEYFT ULFAT NFAT.
           MOVE KAZ-COD  TO KFT-AZI.
           MOVE IF-TPDOC TO KFT-TDOC.
           MOVE IF-COD-1 TO KFT-NUM.
           START FATTUR KEY NOT < KEYFT INVALID GO TO ENDFAT.
       NEWFAT.
           READ FATTUR NEXT AT END GO TO ENDFAT.
           IF SF-FAT = '9D' OR '9A' OR '35' GO TO NEWFAT.
           IF KFT-AZI  > KAZ-COD  GO TO ENDFAT.
           IF KFT-TDOC > IF-TPDOC GO TO ENDFAT.
           IF KFT-NUM  > IF-COD-2 GO TO ENDFAT.
           IF FAT-CDCLI < IF-CLI-1 OR > IF-CLI-2 GO TO NEWFAT.
           IF FAT-DATA  < DAT1 OR > DAT2         GO TO NEWFAT.
           IF FAT-CATT NOT = IF-ATT              GO TO NEWFAT.
      *
           MOVE KFT-AZI  TO KAFT-AZI.
           MOVE KFT-TDOC TO KAFT-TDOC.
           MOVE KFT-NUM  TO KAFT-NUM.
           MOVE FAT-CATT TO KAFT-CATT.
           READ APPFAT INVALID 
                GO TO NEWFAT.
      *
      **** rel 7.1
           MOVE FAT-CDBAN TO KBA-BAN.
           READ ANABAN INVALID KEY MOVE SPACE TO BAN-RGSOC
                                                 BAN-CODAZ
                                                 BAN-CODSP.
           MOVE KEYBA TO KEYABA.
           READ APPBAN.
      *
      ************
           MOVE FAT-CDCLI TO CCOD.
           MOVE KAZ-COD   TO KCF-AZI.
           MOVE CODCLI    TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID KEY
                  GO TO NEWFAT.
           MOVE KEYCF TO KEYACF.
           READ APPCLF INVALID MOVE SPACE TO ACF-NAZIO.
      *
           CALL 'rdbfa' USING FAT-CATT KEYFT PARRB.
      * controllo se la bolla  gia stata esportata
           MOVE KFT-AZI    TO KBC-AZI.
           MOVE RB-TNUM(1) TO KBC-NUM.
           MOVE RB-NBOL(1) TO KBC-BOL.
           READ BOLCTE INVALID GO TO NEWFAT.
           IF BCT-XML NOT = ZERO GO TO NEWFAT.
      *
           ADD 1 TO PROG.
      *
      **** rel 7.2
           MOVE ZERO TO IND.
       AZZ-IMPO.
           ADD 1 TO IND.
           MOVE ZERO TO CDIVA(IND)
                        IMPON(IND).
           IF IND < 6 GO TO AZZ-IMPO.  
      
           MOVE FAT-CDPAG TO KTB-COD.
           MOVE 4 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
              MOVE ZERO TO T04-SCASS.
           MOVE T04-SCASS TO SCONTO.
      ************
           PERFORM ESPORTA-HEADER THRU EX-ESPORTA-HEADER.
           PERFORM CERCA-ORD THRU EX-CERCA-ORD.
           PERFORM INIZIO-BODY THRU EX-INIZIO-BODY.
           MOVE ZERO  TO K CONT.
       ALTRABOLLA.
           ADD 1 TO K.
           IF RB-TNUM(K) = ZERO OR
              RB-NBOL(K) = ZERO
              GO TO BASTABOLLA.
      *
           MOVE KFT-AZI    TO KBC-AZI.
           MOVE RB-TNUM(K) TO KBC-NUM.
           MOVE RB-NBOL(K) TO KBC-BOL.
           READ BOLCTE INVALID GO TO ALTRABOLLA.
      *
           MOVE KFT-AZI    TO KCR-AZI.
           MOVE RB-TNUM(K) TO KCR-NUM.
           MOVE RB-NBOL(K) TO KCR-BOL.
           MOVE ZERO       TO KCR-PGR. 
           START BOLCRI KEY NOT < KEYCR INVALID GO TO ENDBCR.
       NEWBCR.
           READ BOLCRI NEXT AT END GO TO ENDBCR.
           IF SF-BCR = '9D' OR '9A' OR '35' GO TO NEWBCR.
           IF KCR-AZI > KFT-AZI    GO TO ENDBCR.
           IF KCR-NUM > RB-TNUM(K) GO TO ENDBCR.
           IF KCR-BOL > RB-NBOL(K) GO TO ENDBCR.
           IF BCR-TCOR = 1 GO TO NEWBCR. 
      *
           ADD 1 TO CONT.
           PERFORM ESPORTA-DATI-BODY THRU EX-ESPORTA-DATI-BODY.
      *
           GO TO NEWBCR.
       ENDBCR.
      *
           MOVE 1 TO BCT-XML.
           REWRITE RF-BCT INVALID PERFORM INVK-BCT
                                  GO TO ERRIO.
           GO TO ALTRABOLLA.
       BASTABOLLA.
      *
           PERFORM FINE-BODY THRU EX-FINE-BODY.
      *
           MOVE 'E'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      *
           MOVE PROG TO TFE-PROG.
           REWRITE RF-TFE INVALID 
                PERFORM INVK-TFE
                GO TO ERRIO.
      *
           ADD 1 TO NFAT.
           MOVE KFT-NUM TO ULFAT.
           GO TO NEWFAT.
       ENDFAT.
           IF NFAT = ZERO
              MOVE 'Non  stato generato nessun file XML' TO F-MES1
              MOVE 1 TO F-NMES
              CALL 'vrmbox' USING PARMB
              GO TO EX-RUN-ELABORA.
           STRING 'Sono stati generati ' NFATA ' file XML.' 
                   DELIMITED SIZE INTO F-MES1.
           STRING 'Ultima fattura elaborata: ' ULFATA '.'
                   DELIMITED SIZE INTO F-MES2.
           MOVE 2 TO F-NMES.
           CALL 'vrmbox' USING PARMB.
           MOVE TFE-PROG TO IF-PROG.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       ESPORTA-HEADER.
           MOVE ZERO TO PARWXML.
           MOVE SPACE TO PWXM-NOMEFX.
           STRING TFE-PERC DELIMITED SPACE
                  TFE-CNAZ DELIMITED SPACE
                  COMCFISC DELIMITED SPACE
                  '_' DELIMITED SIZE
                  PROG DELIMITED SIZE
                  '.xml' DELIMITED SIZE INTO PWXM-NOMEFX.
           MOVE SPACE TO PWXM-FUN.
           MOVE SPACE TO PWXM-TAG.
           MOVE SPACE TO PWXM-ATTR.
           MOVE ZERO  TO PWXM-TIPO.
           MOVE SPACE TO PWXM-CAMPO.
           MOVE ZERO  TO PWXM-NUM.
           MOVE ZERO  TO PWXM-DATA.
      * Inizio XML
           MOVE '+'  TO PWXM-FUN.
           MOVE 'p:FatturaElettronica' TO PWXM-TAG.
      *
           MOVE 'xmlns:ds' TO PWXM-NATTR(1).
           MOVE 'http://www.w3.org/2000/09/xmldsig#' TO PWXM-VATTR(1).
      *
           MOVE 'xmlns:p' TO PWXM-NATTR(2).
           MOVE 'http://www.fatturapa.gov.it/sdi/fatturapa/v1.1'
                  TO PWXM-VATTR(2).
      *
           MOVE 'xmlns:xsi' TO PWXM-NATTR(3).
           MOVE 'http://www.w3.org/2001/XMLSchema-instance' 
                  TO PWXM-VATTR(3).
      *
           MOVE 'versione' TO PWXM-NATTR(4).
           MOVE '1.1' TO PWXM-VATTR(4).
           call 'vxml-wr' using parwxml.
      * Inizio Header
           MOVE '+'  TO PWXM-FUN.
           MOVE 'FatturaElettronicaHeader' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      * Inizio Dati Trasmissione
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DatiTrasmissione' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      *
           MOVE '+'  TO PWXM-FUN.
           MOVE 'IdTrasmittente' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'IdPaese' TO PWXM-TAG.
           MOVE TFE-NAZ TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'IdCodice' TO PWXM-TAG.
           MOVE TFE-CFISC TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'ProgressivoInvio' TO PWXM-TAG.
           MOVE PROG    TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'FormatoTrasmissione' TO PWXM-TAG.
           MOVE TFE-FORM  TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'CodiceDestinatario' TO PWXM-TAG.
           MOVE AFT-IPA   TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      * Fine Dati Trasmissione
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      * Inizio Cedente Prestatore
           MOVE '+'  TO PWXM-FUN.
           MOVE 'CedentePrestatore' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      * Inizio Dati Anagrafici
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DatiAnagrafici' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      *
           IF AZI-PIVA NOT = ZERO
              MOVE '+'  TO PWXM-FUN
              MOVE 'IdFiscaleIVA' TO PWXM-TAG
              call 'vxml-wr' using parwxml
      *
              MOVE 'IdPaese' TO PWXM-TAG
              IF TFE-CNAZ = SPACE
                 MOVE 'IT'  TO PWXM-CAMPO
              ELSE
                 MOVE TFE-CNAZ TO PWXM-CAMPO
              END-IF
              call 'vxml-wr' using parwxml
      *
              MOVE 'IdCodice' TO PWXM-TAG
              MOVE AZI-PIVA  TO PWXM-CAMPO
              call 'vxml-wr' using parwxml
      *
              MOVE '-'  TO PWXM-FUN
              call 'vxml-wr' using parwxml
           ELSE
              MOVE 'CodiceFiscale' TO PWXM-TAG
              MOVE AZI-CFISC TO PWXM-CAMPO
              call 'vxml-wr' using parwxml.
      *
           MOVE '+'  TO PWXM-FUN.
           MOVE 'Anagrafica' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      *
           IF AAZ-NOM = SPACE
              MOVE 'Denominazione' TO PWXM-TAG
              MOVE AZI-RGSOC       TO PWXM-CAMPO
              call 'vxml-wr' using parwxml
           ELSE
              MOVE 'Nome'  TO PWXM-TAG
              MOVE AAZ-NOM TO PWXM-CAMPO
              call 'vxml-wr' using parwxml
      *
              MOVE 'Cognome' TO PWXM-TAG
              MOVE AAZ-CGN   TO PWXM-CAMPO
              call 'vxml-wr' using parwxml.
      *
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'RegimeFiscale' TO PWXM-TAG.
           MOVE TFE-REGF        TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      * Fine Dati Anagrafici
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      * Inizio Sede
           MOVE '+'  TO PWXM-FUN.
           MOVE 'Sede' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'Indirizzo' TO PWXM-TAG.
           MOVE AZI-INDIR   TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'CAP' TO PWXM-TAG.
           MOVE AZI-CAP  TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'Comune' TO PWXM-TAG.
           MOVE AZI-CIT  TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           IF AZI-PRV NOT = SPACE
              MOVE 'Provincia' TO PWXM-TAG
              MOVE AZI-PRV  TO PWXM-CAMPO
              call 'vxml-wr' using parwxml.
      *
           MOVE 'Nazione' TO PWXM-TAG.
           MOVE TFE-CNAZ  TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      * Fine Sede
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      * Inizio IscrizioneREA
      **** rel 7.1
           IF TFE-NREA = SPACE OR
              TFE-UFFICIO = SPACE
              GO TO NOREA.
      ************
           MOVE '+'  TO PWXM-FUN.
           MOVE 'IscrizioneREA' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'Ufficio' TO PWXM-TAG.
           MOVE TFE-UFFICIO TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'NumeroREA' TO PWXM-TAG.
           MOVE TFE-NREA  TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
      **** rel 7.1
      *    MOVE 'CapitaleSociale' TO PWXM-TAG.
      *    MOVE TFE-CAPSOC TO COMNUM.
      *    PERFORM T-CIFRA THRU EX-T-CIFRA.
      *    STRING COMNUM(K1:10 - K1 + 1) '.00' 
      *           DELIMITED SIZE INTO PWXM-CAMPO.
      *    call 'vxml-wr' using parwxml.
           IF TFE-CAPSOC NOT = ZERO
              MOVE 'CapitaleSociale' TO PWXM-TAG
              MOVE TFE-CAPSOC TO COMNUM
              PERFORM T-CIFRA THRU EX-T-CIFRA
              STRING COMNUM(K1:10 - K1 + 1) '.00' 
                     DELIMITED SIZE INTO PWXM-CAMPO
              call 'vxml-wr' using parwxml.
      *
           MOVE 'SocioUnico' TO PWXM-TAG.
           MOVE TFE-SOCUNI TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'StatoLiquidazione' TO PWXM-TAG.
           MOVE TFE-STALIQ TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      * Fine IscrizioneREA
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      **** rel 7.1
       NOREA.
      ************
      * Fine Cedente Prestatore
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      * Inizio CessionarioCommittente
           MOVE '+'  TO PWXM-FUN.
           MOVE 'CessionarioCommittente' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      * Inizio Dati Anagrafici
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DatiAnagrafici' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      *
           IF CLF-PIVA NOT = ZERO
              MOVE '+'  TO PWXM-FUN
              MOVE 'IdFiscaleIVA' TO PWXM-TAG
              call 'vxml-wr' using parwxml
      *
              MOVE 'IdPaese' TO PWXM-TAG
              IF ACF-NAZIO = SPACE
                 MOVE 'IT'  TO PWXM-CAMPO
              ELSE
                 MOVE ACF-NAZIO TO PWXM-CAMPO
              END-IF
              call 'vxml-wr' using parwxml
      *
              MOVE 'IdCodice' TO PWXM-TAG
              MOVE CLF-PIVA  TO PWXM-CAMPO
              call 'vxml-wr' using parwxml
      *
              MOVE '-'  TO PWXM-FUN
              call 'vxml-wr' using parwxml
           ELSE
              MOVE 'CodiceFiscale' TO PWXM-TAG
              MOVE CLF-CFISC TO PWXM-CAMPO
              call 'vxml-wr' using parwxml.
      *
           MOVE '+'  TO PWXM-FUN.
           MOVE 'Anagrafica' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'Denominazione' TO PWXM-TAG.
           IF CLF-RGSOC2 NOT = SPACE
              MOVE CLF-XRGS        TO PWXM-CAMPO
           ELSE
              MOVE CLF-RGSOC      TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      *
      * Fine Dati Anagrafici
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      * Inizio Sede
           MOVE '+'  TO PWXM-FUN.
           MOVE 'Sede' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'Indirizzo' TO PWXM-TAG.
           IF CLF-INDIR2 NOT = SPACE
              MOVE CLF-XIND        TO PWXM-CAMPO
           ELSE
              MOVE CLF-INDIR      TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'CAP' TO PWXM-TAG.
           MOVE CLF-CAP  TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'Comune' TO PWXM-TAG.
           MOVE CLF-CIT  TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           IF CLF-PRV NOT = SPACE
              MOVE 'Provincia' TO PWXM-TAG
              MOVE CLF-PRV  TO PWXM-CAMPO
              call 'vxml-wr' using parwxml.
      *
           MOVE 'Nazione' TO PWXM-TAG.
           IF ACF-NAZIO = SPACE
              MOVE 'IT'  TO PWXM-CAMPO
           ELSE
              MOVE ACF-NAZIO TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      * Fine Sede
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      * Fine CessionarioCommittente
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      * Fine Header
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
       EX-ESPORTA-HEADER.
           EXIT.
      *------------------
       INIZIO-BODY.
      * Inizio Body
           MOVE '+'  TO PWXM-FUN.
           MOVE 'FatturaElettronicaBody' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      * Inizio DatiGenerali
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DatiGenerali' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      * Inizio DatiGeneraliDocumento
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DatiGeneraliDocumento' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'TipoDocumento' TO PWXM-TAG.
           IF KFT-TDOC = 1 OR 2 OR 4
              IF AFT-TIPO = ZERO
                 MOVE 'TD01' TO PWXM-CAMPO
              END-IF
              IF AFT-TIPO = 1
                 MOVE 'TD05' TO PWXM-CAMPO
              END-IF
              IF AFT-TIPO = 2
                 MOVE 'TD02' TO PWXM-CAMPO.
           IF KFT-TDOC = 3 OR 6
              MOVE 'TD04' TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           MOVE 10        TO KTB-TIP.
           MOVE FAT-VALUT TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE 'EUR' TO T10-DSINT.
           MOVE 'Divisa' TO PWXM-TAG.
           MOVE T10-DSINT TO PWXM-CAMPO COMVALUT.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'Data' TO PWXM-TAG.
           MOVE 2 TO TIPOP1.
           MOVE FAT-DATA TO AAGGG.
           CALL 'rdata' USING PARCDT.
           STRING AA4 '-' MM4 '-' GG4 DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           MOVE KFT-NUM TO NUMFAT.
           MOVE 'Numero' TO PWXM-TAG.
           STRING       KFT-AZI
                        IF-ATT
                        KFT-TDOC
                        AA9
                        NUMFAT
           DELIMITED SPACE INTO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
      **** rel 7.2
           IF FAT-SPBOL > ZERO 
      * Inizio DatiBollo
              MOVE '+'  TO PWXM-FUN
              MOVE 'DatiBollo' TO PWXM-TAG
              call 'vxml-wr' using parwxml
      *
              MOVE 'BolloVirtuale' TO PWXM-TAG
              MOVE 'SI'  TO PWXM-CAMPO
              call 'vxml-wr' using parwxml
      *
              MOVE 'ImportoBollo' TO PWXM-TAG
              IF FAT-VALUT = ZERO
                 MOVE FAT-SPBOL TO COMNUM
              ELSE
                 MOVE FAT-ESPBOL TO COMNUM
              END-IF
              PERFORM T-CIFRA THRU EX-T-CIFRA
              STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                     DELIMITED SIZE INTO PWXM-CAMPO
              call 'vxml-wr' using parwxml
      * Fine DatiBollo
              MOVE '-'  TO PWXM-FUN
              call 'vxml-wr' using parwxml.
      **** rel 7.2
      * ImportoTotaleDocumento
           MOVE 'ImportoTotaleDocumento' TO PWXM-TAG.
           IF FAT-VALUT = ZERO
              MOVE FAT-TOTFT TO COMNUM
           ELSE
              MOVE FAT-TOVAL TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                  DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
      ************
      ************
      * Fine DatiGeneraliDocumento
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      *
           MOVE KFT-AZI TO KOR-AZI.
           MOVE SAVORD  TO KOR-NUM.
           READ ORDCLI INTO REKORD INVALID KEY
                IF AFT-FAORD = SPACE
                   GO TO NOORD.
      * Inizio DatiOrdineAcquisto
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DatiOrdineAcquisto' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      *
           IF KOR-NUM NOT = ZERO
              MOVE 'IdDocumento' TO PWXM-TAG
              STRING ORD-VSORD ' NS: ' KOR-NUM 
                     DELIMITED SIZE INTO PWXM-CAMPO
              call 'vxml-wr' using parwxml
           ELSE
              MOVE 'IdDocumento' TO PWXM-TAG
              MOVE AFT-FAORD TO PWXM-CAMPO
              call 'vxml-wr' using parwxml.
      *
           IF AFT-FADTORD NOT = ZERO
              MOVE 'Data' TO PWXM-TAG
              MOVE 2 TO TIPOP1
              MOVE AFT-FADTORD TO AAGGG
              CALL 'rdata' USING PARCDT
              STRING AA4 '-' MM4 '-' GG4 DELIMITED SIZE INTO PWXM-CAMPO
              call 'vxml-wr' using parwxml.
      *
           IF AFT-CUP NOT = SPACE
              MOVE 'CodiceCUP' TO PWXM-TAG
              MOVE AFT-CUP TO PWXM-CAMPO
              call 'vxml-wr' using parwxml.
      *
           IF AFT-CIG NOT = SPACE
              MOVE 'CodiceCIG' TO PWXM-TAG
              MOVE AFT-CIG TO PWXM-CAMPO
              call 'vxml-wr' using parwxml.
      *
      * Fine DatiOrdineAcquisto
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
       NOORD.
           MOVE ZERO TO K.
       LOOPRB.
           ADD 1 TO K.
           IF RB-TNUM(K) = ZERO OR
              RB-NBOL(K) = ZERO
              GO TO NODDT.
           MOVE KFT-AZI    TO KBC-AZI.
           MOVE RB-TNUM(K) TO KBC-NUM.
           MOVE RB-NBOL(K) TO KBC-BOL.
           READ BOLCTE INVALID GO TO NODDT.
      **** rel 7.2
      *    IF KBC-NUM = 7 OR 8 OR 9 GO TO NODDT.
           IF KBC-NUM = 6 OR 7 OR 8 OR 9 GO TO NODDT.
      ************
      *    
      * Inizio DatiDDT
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DatiDDT' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'NumeroDDT' TO PWXM-TAG.
           STRING KBC-NUM '/' KBC-BOL DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'DataDDT' TO PWXM-TAG.
           MOVE 2 TO TIPOP1.
           MOVE BCT-DATA TO AAGGG.
           CALL 'rdata' USING PARCDT.
           STRING AA4 '-' MM4 '-' GG4 DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
      * Fine DatiDDT
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      *
           GO TO LOOPRB.
       NODDT.
      * Fine DatiGenerali
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      * Inizio DatiBeniServizi
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DatiBeniServizi' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
       EX-INIZIO-BODY.
           EXIT.
      *------------------
       ESPORTA-DATI-BODY.
      * Inizio DettaglioLinee
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DettaglioLinee' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'NumeroLinea' TO PWXM-TAG.
           MOVE CONT TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           IF BCR-TCOR = ZERO OR 2 GO TO NOCES.
      *
           MOVE 11           TO KTB-TIP.
           MOVE BCR-SPESA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
      **** rel 7.2
                    MOVE ZERO TO T11-SCONT
      ************
                    MOVE 1 TO T11-TACC.
      *
           MOVE 'TipoCessionePrestazione' TO PWXM-TAG.
           IF BCR-TCOR = 3
              IF T11-TACC = 1
                 MOVE 'AC' TO PWXM-CAMPO
              ELSE
                 MOVE 'SC' TO PWXM-CAMPO.
           IF BCR-TCOR = 4
              MOVE 'AB' TO PWXM-CAMPO.
           IF BCR-TCOR = 5
              MOVE 'SC' TO PWXM-CAMPO.
           IF BCR-TCOR = 6
              MOVE 'AB' TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
       NOCES.
           MOVE KEYCR TO KEYNCR.
      **** rel 7.1
      *     MOVE 1     TO KNCR-PGRN.
      *     READ NOTBCR INVALID MOVE SPACE TO NCR-DESCR. 
      *     MOVE 'Descrizione' TO PWXM-TAG.
      *     STRING BCR-DESCR ' ' NCR-DESCR DELIMITED 
      *            SIZE INTO PWXM-CAMPO.
      *     call 'vxml-wr' using parwxml.
      *
           MOVE BCR-DESCR TO PWXM-CAMPO COM-DESC.
           MOVE ZERO TO KNCR-PGRN.
           START NOTBCR KEY NOT < KEYNCR INVALID GO TO NOCES10.
       RDN-NCR.
           MOVE PWXM-CAMPO TO COM-DESC.
           READ NOTBCR NEXT AT END GO TO NOCES10.
           IF KNCR-AZI NOT = KCR-AZI GO TO NOCES10.
           IF KNCR-NUM NOT = KCR-NUM GO TO NOCES10.
           IF KNCR-BOL NOT = KCR-BOL GO TO NOCES10.
           IF KNCR-PGR NOT = KCR-PGR GO TO NOCES10.
           STRING COM-DESC DELIMITED BY '  ' ' ' 
                  NCR-DESCR DELIMITED BY SIZE 
                  INTO PWXM-CAMPO.
           GO TO RDN-NCR.
       NOCES10.
           MOVE COM-DESC TO PWXM-CAMPO.
           MOVE 'Descrizione' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      *
           IF BCR-QTA = ZERO GO TO NOCES20.
           MOVE 'Quantita' TO PWXM-TAG.
           MOVE BCR-QTA TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                  DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'UnitaMisura' TO PWXM-TAG.
           MOVE BCR-UM TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
       NOCES20.
      ************
           MOVE 'PrezzoUnitario' TO PWXM-TAG.
           MOVE BCR-PZLOR TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
      **** rel 7.2
      *    STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:6)
           IF BCR-TCOR = 3 AND T11-TACC NOT = 1
              STRING '-' COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:6)
                     DELIMITED SIZE INTO PWXM-CAMPO
           ELSE
              STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:6)
      *************
                  DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
      **** rel 7.2
           IF BCR-TCOR = 3 GO TO NOSCONTO.
           IF BCR-FPNET = 1 GO TO NOSCONTO.

           IF BCT-SCBAS NOT = ZERO
      * Inizio ScontoMaggiorazione Base
              MOVE '+'  TO PWXM-FUN
              MOVE 'ScontoMaggiorazione' TO PWXM-TAG
              call 'vxml-wr' using parwxml
              MOVE 'Tipo' TO PWXM-TAG
              MOVE 'SC' TO PWXM-CAMPO
              call 'vxml-wr' using parwxml
              MOVE 'Percentuale' TO PWXM-TAG
              MOVE BCT-SCBAS TO COMNUM
              PERFORM T-CIFRA THRU EX-T-CIFRA
              STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                     DELIMITED SIZE INTO PWXM-CAMPO
              call 'vxml-wr' using parwxml      
      *
      * Fine ScontoMaggiorazione Base
              MOVE '-'  TO PWXM-FUN
              call 'vxml-wr' using parwxml.

           IF BCR-SC1 NOT = ZERO
      * Inizio ScontoMaggiorazione Sconto 1
              MOVE '+'  TO PWXM-FUN
              MOVE 'ScontoMaggiorazione' TO PWXM-TAG
              call 'vxml-wr' using parwxml
              MOVE 'Tipo' TO PWXM-TAG
              MOVE 'SC' TO PWXM-CAMPO
              call 'vxml-wr' using parwxml
              MOVE 'Percentuale' TO PWXM-TAG
              MOVE BCR-SC1 TO COMNUM
              PERFORM T-CIFRA THRU EX-T-CIFRA
              STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                     DELIMITED SIZE INTO PWXM-CAMPO
              call 'vxml-wr' using parwxml
      *
      * Fine ScontoMaggiorazione Sconto 1
              MOVE '-'  TO PWXM-FUN
              call 'vxml-wr' using parwxml.

           IF BCR-SC2 NOT = ZERO
      * Inizio ScontoMaggiorazione Sconto 2
              MOVE '+'  TO PWXM-FUN
              MOVE 'ScontoMaggiorazione' TO PWXM-TAG
              call 'vxml-wr' using parwxml
              MOVE 'Tipo' TO PWXM-TAG
              MOVE 'SC' TO PWXM-CAMPO
              call 'vxml-wr' using parwxml
              MOVE 'Percentuale' TO PWXM-TAG
              MOVE BCR-SC2 TO COMNUM
              PERFORM T-CIFRA THRU EX-T-CIFRA
              STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                     DELIMITED SIZE INTO PWXM-CAMPO
              call 'vxml-wr' using parwxml
      *
      * Fine ScontoMaggiorazione Sconto 2
              MOVE '-'  TO PWXM-FUN
              call 'vxml-wr' using parwxml.

       NOSCONTO.
      * Ricalcolo Prezzo Totale Versione Pa 1.2
           IF BCR-TCOR = 3 
              MOVE BCR-PZLOR TO CALCNUM
              GO TO NO-RICALCOLO-SCONTI.
           IF BCR-TCOR > 3 AND < 7
            MOVE BCR-PZLOR TO CALCNUM
           ELSE
            COMPUTE CALCNUM = BCR-PZLOR - (BCR-PZLOR * BCT-SCBAS / 100).
           COMPUTE CALCNUM = CALCNUM - CALCNUM * BCR-SC1 / 100.
           COMPUTE CALCNUM = CALCNUM - CALCNUM * BCR-SC2 / 100.
           COMPUTE CALCNUM = CALCNUM * BCR-QTA.
       NO-RICALCOLO-SCONTI.
           MOVE CALCNUM TO RD-NUM.
           IF BCT-VALUT = 1 CALL 'vrround' USING NNN-X PARRD DEC-0
              ELSE          CALL 'vrround' USING NNN-X PARRD DEC-2.
      ************
           MOVE 'PrezzoTotale' TO PWXM-TAG.
      **** rel 7.2
      *    MOVE BCR-NETRG TO COMNUM.
           IF RD-NUM NOT = BCR-NETRG
              MOVE RD-NUM TO COMNUM
           ELSE
              MOVE BCR-NETRG TO COMNUM.
      ************
           PERFORM T-CIFRA THRU EX-T-CIFRA.
      **** rel 7.2
      *    STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:6)
      *           DELIMITED SIZE INTO PWXM-CAMPO.
           IF BCR-TCOR = 3 AND T11-TACC NOT = 1
              STRING '-' COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:6)
                     DELIMITED SIZE INTO PWXM-CAMPO
           ELSE
              STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:6)
                     DELIMITED SIZE INTO PWXM-CAMPO.
      *************
           call 'vxml-wr' using parwxml.
      *
      **** rel 7.2
           MOVE COMNUM TO SAVPRZ.
           IF BCR-TCOR = 3 AND T11-SCONT = 1
              MOVE ZERO TO SAVPRZ.
           IF BCR-TCOR = 3 AND T11-TACC NOT = 1
              COMPUTE SAVPRZ = SAVPRZ * ( -1 ).
      ************
           MOVE 'AliquotaIVA' TO PWXM-TAG.
           IF FAT-CDESE = ZERO
              MOVE BCR-IVA TO KTB-COD
           ELSE
              MOVE FAT-CDESE TO KTB-COD.
           MOVE 3 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
              MOVE ZERO TO T03-ALIVA.
      **** rel 7.2
           PERFORM RCDIVA THRU EX-RCDIVA.
      ************
           MOVE T03-ALIVA TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                  DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           IF T03-ALIVA = ZERO
              PERFORM NATURA THRU EX-NATURA.
      *
      * Fine DettaglioLinee
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
       EX-ESPORTA-DATI-BODY.
           EXIT.
      *------------------
       FINE-BODY.
      **** rel 7.2
           IF FAT-SCFIN = ZERO GO TO NO-SCFIN-PAG.
           MOVE ZERO TO IND.
       NO-SCFIN-PAG-0.
           ADD 1 TO IND.
           IF IND > 6 GO TO NO-SCFIN-PAG.
           IF IMPON (IND) = ZERO GO TO NO-SCFIN-PAG-0.
           COMPUTE RD-NUM = ( IMPON (IND) * SCONTO ) / 100.
           CALL 'vrround' USING NNN-X PARRD DEC-2.

           ADD 1 TO CONT.

      * Inizio DettaglioLinee x Sconto Pagamento
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DettaglioLinee' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'NumeroLinea' TO PWXM-TAG.
           MOVE CONT TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'TipoCessionePrestazione' TO PWXM-TAG.
           MOVE 'SC' TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           MOVE '.' TO SCONXX(4:1).
           MOVE SCONTO(1:3) TO SCONXX(1:3).
           MOVE SCONTO(4:2) TO SCONXX(5:2).
           IF SCONXX(1:1) = '0' MOVE SPACE TO SCONXX(1:1)
              IF SCONXX(2:1) = '0' MOVE SPACE TO SCONXX(2:1).
           STRING 'SCONTO ' SCONXX ' %' DELIMITED SIZE INTO PWXM-CAMPO.
           MOVE 'Descrizione' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'PrezzoUnitario' TO PWXM-TAG.
           MOVE RD-NUM TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           IF RD-NUM > ZERO
              STRING '-' COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:6)
                     DELIMITED SIZE INTO PWXM-CAMPO
              ELSE
              STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:6)
                     DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'PrezzoTotale' TO PWXM-TAG.
           MOVE RD-NUM TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           IF RD-NUM > ZERO
              STRING '-' COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:6)
                     DELIMITED SIZE INTO PWXM-CAMPO
              ELSE
              STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:6)
                     DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'AliquotaIVA' TO PWXM-TAG.
           MOVE CDIVA (IND) TO KTB-COD.
           MOVE 3 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
              MOVE ZERO TO T03-ALIVA.
           MOVE T03-ALIVA TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                  DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           IF T03-ALIVA = ZERO
              PERFORM NATURA THRU EX-NATURA.
      *
      * Fine DettaglioLinee
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
            
           GO TO NO-SCFIN-PAG-0.
       NO-SCFIN-PAG.
      ************
           PERFORM CASTELLETTO-IVA THRU EX-CASTELLETTO-IVA.
      * Fine DatiBeniServizi
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
           MOVE FAT-CDPAG TO KTB-COD.
      *
           MOVE FAT-CDPAG TO KTB-COD.
           MOVE 4 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
              MOVE ZERO TO T04-NRATE.
           IF T04-MPAG = '00'
              MOVE 'Attenzione non  stata selezionata la ' TO F-MES1
              STRING 'modalit di pagamento sul codice ' FAT-CDPAG 
                     DELIMITED SIZE INTO F-MES2
              MOVE 'La fattura verr esportata senza dati ' TO F-MES3
              MOVE 'di pagamento.(non obbligatori)        ' TO F-MES4
              MOVE 4 TO F-NMES
              CALL 'vrmbox' USING PARMB
              GO TO NOPAGAM.
      **** rel 7.2
           MOVE ZERO TO FLGNOPAG.
           MOVE 1 TO K.
           PERFORM UNTIL K = 13 OR FLGNOPAG = 1
               IF FAT-DTSCA(K) NOT = ZERO
                  MOVE 1 TO FLGNOPAG
               END-IF
               ADD 1 TO K.
           IF FLGNOPAG = ZERO
              GO TO NODETPAG.
      ************
      * Inizio DatiPagamento
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DatiPagamento' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'CondizioniPagamento' TO PWXM-TAG.
           IF T04-NRATE > 1
              MOVE 'TP01' TO PWXM-CAMPO.
           IF T04-NRATE = 1
              MOVE 'TP02' TO PWXM-CAMPO.
           IF AFT-TIPO = 2
              MOVE 'TP03' TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           MOVE 1 TO K.
           PERFORM UNTIL FAT-DTSCA(K) = ZERO
               PERFORM CASTELLETTO-RATA THRU EX-CASTELLETTO-RATA
               ADD 1 TO K.
      * Fine DatiPagamento
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      **** rel 7.2
       NODETPAG.
      * Allegati
           MOVE KBC-NUM  TO AF-NUM.
           MOVE KFT-NUM  TO AF-BOL.
           MOVE FAT-CATT TO AF-CATT.
      *
           MOVE 1          TO AG-FUN.
           MOVE KFT-AZI    TO AG-AZI.
           MOVE 'FAT'      TO AG-TIP.
           MOVE ALG-KEY    TO AG-KEY.
           CALL 'rkalg' USING PARAG.
           IF AG-ST > ZERO GO TO ERRIO.
      *
           MOVE KFT-AZI    TO KALG-AZI.
           MOVE 'FAT'      TO KALG-TIP.
           MOVE AG-KFD     TO KALG-KFD.
           MOVE SPACE      TO KALG-COD.
           START ALLEGA KEY NOT < KEYALG INVALID GO TO ENDALG.
       NEWALG.
           READ ALLEGA NEXT AT END GO TO ENDALG.
           IF SF-ALG = '9D' OR '9A' OR '35' GO TO NEWALG.
           IF KALG-AZI > KFT-AZI GO TO ENDALG.
           IF KALG-TIP > 'FAT'    GO TO ENDALG.
           IF KALG-KFD > AG-KFD   GO TO ENDALG.
           IF ALG-FATTPA = ZERO GO TO NEWALG.
      * Inizio Allegati
           MOVE '+'  TO PWXM-FUN.
           MOVE 'Allegati' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'NomeAttachment' TO PWXM-TAG.
           MOVE ZERO      TO PWXM-TIPO.
           PERFORM NMFILE THRU EX-NMFILE.
           STRING NOMEFILE(1:LUNGNOME) '.' ALG-TFILE DELIMITED
                  SIZE INTO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'FormatoAttachment' TO PWXM-TAG.
           MOVE ZERO      TO PWXM-TIPO.
           MOVE ALG-TFILE TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'DescrizioneAttachment' TO PWXM-TAG.
           MOVE ZERO      TO PWXM-TIPO.
           MOVE ALG-DESCR TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'Attachment' TO PWXM-TAG.
           MOVE 6         TO PWXM-TIPO.
           MOVE ALG-NFILE TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
      * Fine Allegati
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      *
           GO TO NEWALG.
       ENDALG.
      ************
       NOPAGAM.
      * Fine Body
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      * Fine XML
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
       EX-FINE-BODY.
           EXIT.
      *------------------
       T-CIFRA.
           MOVE 1 TO K1.
           PERFORM UNTIL COMNUM(K1:1) NOT = ZERO
             ADD 1 TO K1. 
           IF K1 > 10
              MOVE 10 TO K1. 
       EX-T-CIFRA.
           EXIT.
      *------------------
       CASTELLETTO-IVA.
           MOVE ZERO TO K.
       LOOPIVA.
           ADD 1 TO K.
           IF K > 6 GO TO EX-CASTELLETTO-IVA.
           IF FAT-CDIVA(K) = ZERO GO TO EX-CASTELLETTO-IVA.
           MOVE FAT-CDIVA(K) TO KTB-COD.
           MOVE 3 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                       GO TO LOOPIVA.
      **** rel 7.2
           IF FAT-SPBOL NOT > ZERO GO TO LOOPIVA-NO-BOLLO.
           IF FAT-CDIVA(K) NOT = IVABL GO TO LOOPIVA-NO-BOLLO.
                   
           IF COMVALUT = 'EUR'
              COMPUTE FAT-IMPON(K) = FAT-IMPON(K) - FAT-SPBOL
           ELSE
              COMPUTE FAT-EIMPON(K) = FAT-EIMPON(K) - FAT-ESPBOL.
           
           IF COMVALUT = 'EUR' AND FAT-IMPON(K) = ZERO
              GO TO LOOPIVA.
           IF COMVALUT NOT = 'EUR' AND FAT-EIMPON(K) = ZERO
              GO TO LOOPIVA.
 
       LOOPIVA-NO-BOLLO.
      *************
      * Inizio DatiRiepilogo
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DatiRiepilogo' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'AliquotaIVA' TO PWXM-TAG.
           MOVE T03-ALIVA TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                  DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           IF T03-ALIVA = ZERO
              PERFORM NATURA THRU EX-NATURA.
      *
           MOVE 'ImponibileImporto' TO PWXM-TAG.
           IF COMVALUT = 'EUR'
              MOVE FAT-IMPON(K) TO COMNUM
           ELSE
              MOVE FAT-EIMPON(K) TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
      **** rel 7.2
      *    STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
      *           DELIMITED SIZE INTO PWXM-CAMPO.
           IF FAT-IMPON(K) < ZERO
              STRING '-' COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                     DELIMITED SIZE INTO PWXM-CAMPO
           ELSE
              STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                     DELIMITED SIZE INTO PWXM-CAMPO.
      ************
           call 'vxml-wr' using parwxml.
      *
           MOVE 'Imposta' TO PWXM-TAG.
           IF COMVALUT = 'EUR'
              MOVE FAT-IMPOS(K) TO COMNUM
           ELSE
              MOVE FAT-EIMPOS(K) TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
      **** rel 7.2
      *    STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
      *           DELIMITED SIZE INTO PWXM-CAMPO.
           IF FAT-IMPOS(K) < ZERO
              STRING '-' COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                     DELIMITED SIZE INTO PWXM-CAMPO
           ELSE
              STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                     DELIMITED SIZE INTO PWXM-CAMPO.
      ************
           call 'vxml-wr' using parwxml.
      *
           MOVE 'EsigibilitaIVA' TO PWXM-TAG.
           IF KFT-TDOC = 4 OR 6 
              IF FAT-DATA >= 42005 AND AFT-MCIVA = ZERO 
                 MOVE 'S' TO PWXM-CAMPO
              ELSE
                 MOVE 'D' TO PWXM-CAMPO
              END-IF
           ELSE
              MOVE 'I' TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           IF T03-ALIVA = ZERO
              MOVE 'RiferimentoNormativo' TO PWXM-TAG
              MOVE TAB-DESCR TO PWXM-CAMPO
              call 'vxml-wr' using parwxml.
      * Fine DatiRiepilogo
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
      *
           GO TO LOOPIVA.
       EX-CASTELLETTO-IVA.
           EXIT.
      *------------------
       CASTELLETTO-RATA.
      * Inizio DettaglioPagamento
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DettaglioPagamento' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'ModalitaPagamento' TO PWXM-TAG.
           STRING 'MP' T04-MPAG DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'DataScadenzaPagamento' TO PWXM-TAG.
           MOVE 2 TO TIPOP1.
           MOVE FAT-DTSCA(K) TO AAGGG.
           CALL 'rdata' USING PARCDT.
           STRING AA4 '-' MM4 '-' GG4 DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'ImportoPagamento' TO PWXM-TAG.
           IF COMVALUT = 'EUR'
              MOVE FAT-IMPOR(K) TO COMNUM
           ELSE
              MOVE FAT-EIMPOR(K) TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                  DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
      **** rel 7.1
           MOVE SPACE TO D-ABI D-CAB.
           IF T04-MPAG NOT = 12 GO TO TIPAGFI.
           IF BAN-CODAZ NOT = '00000' MOVE BAN-CODAZ TO D-ABI.
           IF BAN-CODSP NOT = '00000000' MOVE BAN-CODSP TO D-CAB.
      *
           MOVE 'ABI' TO PWXM-TAG.
           MOVE D-ABI TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
      *
           MOVE 'CAB' TO PWXM-TAG.
           MOVE D-CAB TO PWXM-CAMPO.
           call 'vxml-wr' using parwxml.
           GO TO TIPAGFI.
      *
       TIPAGFI.
      ************
      * Fine DettaglioPagamento
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr' using parwxml.
       EX-CASTELLETTO-RATA.
           EXIT.
      *------------------
       CERCA-ORD.
           MOVE ZERO  TO K SAVORD.
       NEXTBCT.
           ADD 1 TO K.
           IF RB-TNUM(K) = ZERO OR
              RB-NBOL(K) = ZERO
              GO TO EX-CERCA-ORD.
      *
           MOVE KFT-AZI    TO KCR-AZI.
           MOVE RB-TNUM(K) TO KCR-NUM.
           MOVE RB-NBOL(K) TO KCR-BOL.
           MOVE ZERO       TO KCR-PGR. 
           START BOLCRI KEY NOT < KEYCR INVALID GO TO ENDBCR2.
       NEWBCR2.
           READ BOLCRI NEXT AT END GO TO ENDBCR2.
           IF SF-BCR = '9D' OR '9A' OR '35' GO TO NEWBCR2.
           IF KCR-AZI > KFT-AZI    GO TO ENDBCR2.
           IF KCR-NUM > RB-TNUM(K) GO TO ENDBCR2.
           IF KCR-BOL > RB-NBOL(K) GO TO ENDBCR2.
           IF BCR-TCOR = 1 GO TO NEWBCR2. 
      *
           MOVE BCR-NORD TO SAVORD.
      *
           IF SAVORD NOT = ZERO
              GO TO ENDBCR2.
           GO TO NEWBCR2.
       ENDBCR2.
      *
           GO TO NEXTBCT.
       EX-CERCA-ORD.
           EXIT.
      *------------------
       NATURA.
           IF T03-TPIVA = ZERO
      **** rel 7.2
      *       IF T03-TSAUE = 1
      *          MOVE 'N5' TO PWXM-CAMPO
      *       ELSE 
      *          GO TO EX-NATURA.
              IF T03-TSAUE = 1
                 MOVE 'N5' TO PWXM-CAMPO
              ELSE 
                 IF T03-ALIVA = ZERO
                    MOVE 'N6' TO PWXM-CAMPO
                 ELSE
                    GO TO EX-NATURA.
      ************
           IF T03-TPIVA = 1
              GO TO EX-NATURA.
           IF T03-TPIVA = 2
              MOVE 'N4' TO PWXM-CAMPO.
           IF T03-TPIVA = 3
              MOVE 'N3' TO PWXM-CAMPO.
           IF T03-TPIVA = 4
              MOVE 'N2' TO PWXM-CAMPO.
           IF T03-TPIVA = 5
              MOVE 'N1' TO PWXM-CAMPO.
           IF T03-TPIVA = 6
              MOVE 'N3' TO PWXM-CAMPO.
           IF T03-TPIVA = 7
              GO TO EX-NATURA.
           MOVE 'Natura' TO PWXM-TAG.
           call 'vxml-wr' using parwxml.
       EX-NATURA.
           EXIT.
      *------------------
      **** rel 7.2
       NMFILE.
          MOVE 150 TO K3 ENDFILE.
          MOVE ZERO TO LUNGNOME.
          PERFORM UNTIL K3 = ZERO
             IF ALG-NFILE(K3:1) = '.' AND ENDFILE = 150
                MOVE K3 TO ENDFILE
             END-IF 
             IF ALG-NFILE(K3:1)  = '\' OR '/'
                ADD 1 TO K3
                COMPUTE LUNGNOME = ENDFILE - K3
                MOVE ALG-NFILE(K3:LUNGNOME) TO NOMEFILE
                GO TO EX-NMFILE
             END-IF
             SUBTRACT 1 FROM K3.
       EX-NMFILE.
           EXIT.
      *------------------
       RCDIVA.
           MOVE ZERO TO IND.
       RCDIVA-1.
           ADD 1 TO IND.
           IF IND > 6 GO TO RCDIVA-6.
           IF CDIVA (IND) = ZERO
              MOVE SAVPRZ TO IMPON (IND)
              MOVE KTB-COD TO CDIVA (IND)
              GO TO EX-RCDIVA.
           IF KTB-COD = CDIVA (IND)
              ADD SAVPRZ TO IMPON (IND)
              GO TO EX-RCDIVA.
           GO TO RCDIVA-1.
       RCDIVA-6.
           MOVE 6 TO IND.
           ADD SAVPRZ TO IMPON (IND).
       EX-RCDIVA.
           EXIT.
      ************
