       IDENTIFICATION DIVISION.
       PROGRAM-ID. VRGAAZ. 
      *
      *    Interfaccia ANAAZI per scheda
      *
      **** rel 6.2
      * nuovo
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griprasl'.
      **** rel 6.2
           COPY 'griaazsl'.
      ************
           COPY 'gritabsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gripra'.
      **** rel 6.2
           COPY 'griaaz'.
      ************
           COPY 'gritab'.
       WORKING-STORAGE SECTION.
       01  RELPRIMULA.
           05 FILLER PIC X(50) VALUE
              '@(#)Primula NT rel 6.2     GR Informatica'.
           05 FILLER PIC X     VALUE LOW-VALUE.
           COPY 'griazirk'.
           COPY 'gritabrk'.
           COPY 'parzf'.
           COPY 'parcdt'.
      **** rel 1.2
      *    COPY 'rfisc'.
      *    COPY 'rpiva'.
           COPY 'prfisc'.
           COPY 'prpiva'.
      ************
      **** rel 5.0
           COPY 'parsa'.
      ************
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-PRA PIC X(15) VALUE 'proazi'.
      **** rel 6.2
       01  ID-AAZ PIC X(15) VALUE 'appazi'.
      ************
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  COMODI.
           05 SF-PRA   PIC XX.
           05 SF-AZI   PIC XX.
      **** rel 6.2
           05 SF-AAZ   PIC XX.
      ************
           05 SF-TAB   PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VKEY     PIC 9.
           05 VFLD     PIC 9.
           05 FLCK     PIC 9.
           05 FUN      PIC X.
           05 IDX      PIC 9.
           05 EOF      PIC 9.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 KRIFER   PIC X(50).
           05 IF-AZI   PIC 9(3).

           05 SW-CFISC PIC 9.

       LINKAGE SECTION.
           COPY 'griazirg'.
       01  IF-MESS    PIC X(204).
       PROCEDURE DIVISION USING RG-AZI-CTRL
                                RG-AZI-REC
                                RA-AZI-AGG
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclpra'.
      **** rel 6.2
           COPY 'dclaaz'.
      ************
           COPY 'dclazi'.
           COPY 'dcltab'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO RG-AZI-ST.
           MOVE SPACE TO IF-MESS.
           IF RG-AZI-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           IF (RG-AZI-FUN = 'N' OR 'n') AND
              (RG-AZI-EOF = 2 OR 3)     GO TO ESCI.
           IF (RG-AZI-FUN = 'P' OR 'p') AND
              (RG-AZI-EOF = 1 OR 2)     GO TO ESCI.
           MOVE RG-AZI-FUN   TO FUN.
           MOVE RG-AZI-IDX   TO IDX.
           MOVE RG-AZI-CAMPO TO CAMPO.
           MOVE ZERO TO FLCK.

           IF FUN = 'I' GO TO F-INIINS.
           IF FUN = 'K' GO TO F-KEYINS.
           IF FUN = 'X' GO TO F-ANNINS.
           IF FUN = 'R' OR
                    'r' PERFORM MOVE-KEY
                        MOVE ZERO TO RG-AZI-EOF
                        GO TO F-READ.
           IF FUN = 'N' OR
                    'n' OR
                    'P' OR
                    'p' PERFORM READ-N-P THRU EX-READ-N-P
                        GO TO F-READ.
           IF FUN = 'U' GO TO F-UNLOCK.
           IF FUN = 'S' GO TO F-SCRIVI.
           IF FUN = 'A' GO TO F-AGGIOR.
           IF FUN = 'D' GO TO F-DELETE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'E' GO TO F-EXIT.
           MOVE 'vrgaaz: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-INIINS.
           MOVE ZERO TO RG-AZI-EOF.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM AZZ-RG-RA THRU EX-AZZ-RG-RA.
           PERFORM INI-CAMPI THRU EX-INI-CAMPI.
           GO TO FINE.
      * - - - - - *
       F-KEYINS.
           PERFORM MOVE-KEY.
           PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI.
           IF VFLD > ZERO
              MOVE VCAMPO TO RG-AZI-CAMPO
              GO TO ERRFIELD.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY = ZERO
              PERFORM AZZ-REC THRU EX-AZZ-REC
              PERFORM ERR-CPRE
              GO TO WARNING.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM INS-OK  THRU EX-INS-OK.
           GO TO FINE.
      * - - - - - *
       F-ANNINS.
           IF FUN-PREC = 'X' GO TO FINE.
           PERFORM INS-NO THRU EX-INS-NO.
           GO TO FINE.
      * - - - - - *
       F-READ.
           IF FUN = 'r' MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM ERR-CINE
              GO TO WARNING.
           IF RG-AZI-ST = 7 GO TO FINE.
           IF FUN = 'r' PERFORM DB-STORNA THRU EX-DB-STORNA.
           PERFORM CARICA-RG THRU EX-CARICA-RG.
           PERFORM CARICA-RA THRU EX-CARICA-RA.
           GO TO FINE.
      * - - - - - *
       F-UNLOCK.
           IF FUN-PREC = 'U' GO TO FINE.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           UNLOCK ANAAZI.
           GO TO F-READ.
      * - - - - - *
       F-SCRIVI.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
      *    WRITE RF-AZI INVALID
      *       PERFORM INVK-AZI
      *       GO TO ERRIO.
      *    WRITE RF-PRA INVALID
      **** rel 6.2
      *       PERFORM INVK-AZI
      *       PERFORM INVK-PRA
      ************
      *       GO TO ERRIO.
      **** rel 6.2
           WRITE RF-AAZ INVALID
              PERFORM INVK-AAZ
              GO TO ERRIO.
      ************
           GO TO FINE.
      * - - - - - *
       F-AGGIOR.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
      *    REWRITE RF-AZI INVALID
      *       PERFORM INVK-AZI
      *       GO TO ERRIO.
           UNLOCK ANAAZI.

      *    IF SF-PRA = ZERO
      *      REWRITE RF-PRA INVALID PERFORM INVK-PRA 
      *                             GO TO ERRIO
      *    ELSE 
      *      WRITE RF-PRA INVALID PERFORM INVK-PRA 
      *                           GO TO ERRIO.
      **** rel 6.2
           IF SF-AAZ = ZERO
             REWRITE RF-AAZ INVALID PERFORM INVK-AAZ 
                                    GO TO ERRIO
           ELSE 
             WRITE RF-AAZ INVALID PERFORM INVK-AAZ 
                                  GO TO ERRIO.
      ************
           GO TO FINE.
      * - - - - - *
       F-DELETE.
           PERFORM MOVE-KEY.
           MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM INVK-AZI
              GO TO WARNING.
           IF RG-AZI-ST = 7 GO TO FINE.
           PERFORM DB-STORNA THRU EX-DB-STORNA.
      **** rel 5.0
           IF ERRIO-ST = 8 GO TO FINE.
      ************
      *    DELETE ANAAZI INVALID
      *       PERFORM INVK-AZI
      *       GO TO ERRIO.
           UNLOCK ANAAZI.
      *    IF SF-PRA = ZERO
      *       DELETE PROAZI INVALID PERFORM INVK-PRA 
      *                             GO TO ERRIO.      
      **** rel 6.2
           IF SF-AAZ = ZERO
              DELETE APPAZI INVALID PERFORM INVK-AAZ 
                                    GO TO ERRIO.      
      ************
           GO TO FINE.
      * - - - - - *
       F-WALIDA.
           IF FUN = 'V'
              PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI
              IF VFLD > ZERO GO TO F-W90.
           PERFORM V-DATI THRU EX-V-CHIAVE-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
       F-W90.
           MOVE VCAMPO TO RG-AZI-CAMPO
           GO TO ERRFIELD.
      * - - - - - *
       F-EXIT.
           UNLOCK ANAAZI.
           GO TO CHIUDI.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO RG-AZI-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI.
           CLOSE TABELL.
           CLOSE PROAZI.
      **** rel 6.2
           CLOSE APPAZI.
      ************
           MOVE ZERO TO SWINI.
       FINE.
           MOVE RG-AZI-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO RG-AZI-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'gripraer'.
      **** rel 6.2
           COPY 'griaazer'.
      ************
           COPY 'griazier'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (ins/mod/vis/canc + validazioni + aggiornamenti)
       INI-ELABORA.
           IF RG-AZI-FL = ZERO
              MOVE 'anaazi' TO ID-AZI
              MOVE 'tabell' TO ID-TAB
              MOVE 'proazi' TO ID-PRA
           ELSE
              MOVE 'anazol' TO ID-AZI
              MOVE 'tabold' TO ID-TAB
              MOVE 'proazi' TO ID-PRA.

           OPEN INPUT TABELL.
           OPEN I-O ANAAZI PROAZI.
      **** rel 6.2
           OPEN I-O APPAZI.
      ************

      *
           MOVE 1 TO SWINI.
           MOVE ZERO TO RG-AZI-EOF.
       EX-INI-ELABORA.
           EXIT.
      *------------------
       AZZ-REC.
           MOVE ZERO TO RF-AZI RF-PRA REKAZI.

           MOVE AZI-KEYID TO KEYAZ.
           MOVE KEYAZ TO AZI-KEYID KPR-COD.
           MOVE SPACE TO AZI-RGSOC AZI-INDIR
                AZI-DATT AZI-CITTA AZI-CFISC.
           MOVE SPACE TO PRA-FIRMA PRA-INTEN.
           MOVE SPACE TO PRA-COD.
           MOVE ZERO  TO PRA-DTAUT PRA-AUTOR 
      **** rel 2.0
                         PRA-DTLIG
      ************
                         PRA-DTALL.
      **** rel 5.0
           MOVE ZERO TO  PRA-LOGACC.
      ************
           MOVE ZERO TO AZI-RVDT  AZI-RVNRG AZI-NUMFT
                        AZI-RANRG AZI-NEFF
                        AZI-DTAPE
                        AZI-SZDT   AZI-PRCOR
                        AZI-MOVPR  AZI-PRSCA AZI-ULTDT
                        AZI-PIVA  
                        AZI-FLCOS
                        AZI-FLAMM
                        AZI-MOVMG  AZI-FLGIS.
           MOVE ZERO TO CODPIVA.
      **** rel 6.2
           MOVE ZERO  TO RF-AAZ AAZ-DNA.
           MOVE SPACE TO AAZ-RGSOC AAZ-CNA AAZ-PNA 
                         AAZ-SES.
           MOVE KEYAZ TO KAAZ-COD.
      ************
      *
           MOVE REKAZI TO RF-AZI.
       EX-AZZ-REC.
           EXIT.
      *------------------
       AZZ-RG-RA.
      *
      * salvataggio dei campi chiave fissi
      *    ( ed eventuali altri campi significativi passati in RG e RA )
      *

      * azzeramento aree interfaccia
           MOVE ZERO TO RG-AZI-REC.
           MOVE SPACE TO RG-AZI-RGSOC RG-AZI-INDIR RG-AZI-CIT 
                         RG-AZI-PRV RG-AZI-CFISC RG-AZI-DATT
                         RG-PRA-FIRMA RG-PRA-INTEN 
      **** rel 6.2
                         RG-AZI-CGN RG-AZI-NOM 
                         RG-AZI-CNA RG-AZI-PNA RG-AZI-SES
      ************
                         RG-PRA-COD.
      * ripristino dei campi chiave fissi
       EX-AZZ-RG-RA.
           EXIT.
      *------------------
      * inizializzazione campi non vuoti per inserimento (valori di
      * default di chiave o dati per aree di interfaccia)
       INI-CAMPI.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * aggiornamento dati legati a conferma inserimento
       INS-OK.
       EX-INS-OK.
           EXIT.
      *------------------
      * ripristino dati correlati x annullamento inserimento
       INS-NO.
       EX-INS-NO.
           EXIT.
      *------------------
       MOVE-KEY.
           MOVE RG-AZI-COD TO KAZ-COD.
           MOVE KEYAZ TO KRIFER.
      *------------------
       READ-K.
           MOVE ZERO TO VKEY.
           MOVE KRIFER TO KEYAZ.
           IF FLCK > ZERO GO TO RDK-10.
      *
           READ ANAAZI INTO REKAZI INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
            
           MOVE KEYAZ TO KEYPR.
           READ PROAZI.
           IF SF-PRA NOT = ZERO 
              MOVE ZERO TO RF-PRA
              MOVE KAZ-COD TO KPR-COD
              MOVE SPACE TO PRA-FIRMA PRA-INTEN
              MOVE SPACE TO PRA-COD
      **** rel 2.0
              MOVE ZERO  TO PRA-DTLIG
      ************
              MOVE ZERO  TO PRA-DTAUT PRA-AUTOR PRA-DTALL.
      **** rel 6.2
           MOVE KEYAZ TO KEYAAZ.
           READ APPAZI.
           IF SF-AAZ NOT = ZERO 
              MOVE ZERO  TO RF-AAZ AAZ-DNA
              MOVE SPACE TO AAZ-RGSOC AAZ-CNA AAZ-PNA 
                            AAZ-SES
              MOVE KAZ-COD TO KAAZ-COD.
      ************

           GO TO EX-READ-K.
      *
       RDK-10.
           READ ANAAZI INTO REKAZI KEPT LOCK INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           IF SF-AZI > ZERO MOVE 7 TO RG-AZI-ST.
      *
           MOVE KEYAZ TO KEYPR.
           READ PROAZI.
           IF SF-PRA NOT = ZERO 
              MOVE ZERO TO RF-PRA
              MOVE KAZ-COD TO KPR-COD
              MOVE SPACE TO PRA-FIRMA PRA-INTEN
              MOVE SPACE TO PRA-COD
      **** rel 2.0
              MOVE ZERO  TO PRA-DTLIG
      ************
              MOVE ZERO  TO PRA-DTAUT PRA-AUTOR PRA-DTALL.
      **** rel 6.2
           MOVE KEYAZ TO KEYAAZ.
           READ APPAZI.
           IF SF-AAZ NOT = ZERO 
              MOVE ZERO  TO RF-AAZ AAZ-DNA
              MOVE SPACE TO AAZ-RGSOC AAZ-CNA AAZ-PNA 
                            AAZ-SES
              MOVE KAZ-COD TO KAAZ-COD.
      ************

       EX-READ-K.
           EXIT.
      *------------------
       READ-N-P.
           MOVE ZERO TO EOF.
       RNP-10.
           IF FUN = 'P' OR 'p'
              READ ANAAZI PREVIOUS INTO REKAZI AT END MOVE 1 TO EOF
           ELSE
              READ ANAAZI NEXT INTO REKAZI AT END MOVE 3 TO EOF.
           IF EOF > ZERO GO TO RNP-80.
           IF EOF > ZERO GO TO RNP-80.
           IF RF-AZI = LOW-VALUE GO TO RNP-10.
      *
      *    ( inserire qui eventuali controlli sui tipi record:
      *      se record da non trattare go to RNP-10          )
      *

      * trovato record valido: reset EOF
           MOVE ZERO TO RG-AZI-EOF.
           MOVE KEYAZ TO KRIFER.
           GO TO RNP-90.

      * trovato EOF/BOF: set EOF e ripristina chiave iniziale
       RNP-80.
           ADD EOF TO RG-AZI-EOF.
           IF RG-AZI-EOF = 4 MOVE 2 TO RG-AZI-EOF.
           PERFORM MOVE-KEY.

      * continua elaborazione con funzione Read
       RNP-90.
           IF FUN = 'n' OR 'p'
              MOVE 'r' TO FUN
           ELSE
              MOVE 'R' TO FUN.
       EX-READ-N-P.
      *------------------
      * test End Of File logico
      *    Nota: testare anche chiave < (per read previous)
      *
       TEST-EOL.
       EX-TEST-EOL.
           EXIT.
      *------------------
       CARICA-REC.
           MOVE RG-AZI-COD   TO AZI-COD KPR-COD. 
           MOVE RG-AZI-RGSOC TO AZI-RGSOC.
           MOVE RG-AZI-INDIR TO AZI-INDIR.
           MOVE RG-AZI-CAP   TO AZI-CAP.
           MOVE RG-AZI-CIT   TO AZI-CIT.
           MOVE RG-AZI-PRV   TO AZI-PRV.
           MOVE RG-AZI-PIVA  TO AZI-PIVA.
           MOVE RG-AZI-CFISC TO AZI-CFISC.
           MOVE RG-AZI-CUIVA TO AZI-CUIVA.
           MOVE RG-AZI-CATT  TO AZI-CATT. 
           MOVE RG-AZI-DATT  TO AZI-DATT. 
           MOVE RG-AZI-RVDT TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO AZI-RVDT. 
           MOVE RG-AZI-RVNRG TO AZI-RVNRG. 
           MOVE RG-AZI-NUMFT TO AZI-NUMFT. 
           MOVE RG-AZI-DTAPE TO GGMMAA. 
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO AZI-DTAPE.
           MOVE RG-AZI-RANRG TO AZI-RANRG. 
           MOVE RG-AZI-NEFF  TO AZI-NEFF.  
           MOVE RG-AZI-FLSCC TO AZI-FLSCC. 
           MOVE RG-AZI-SZDT  TO AZI-SZDT. 
           MOVE RG-AZI-PRCOR TO AZI-PRCOR.
           MOVE RG-AZI-MOVPR TO AZI-MOVPR.
           MOVE RG-AZI-PRSCA TO AZI-PRSCA.
           MOVE RG-AZI-ULTDT TO GGMMAA. 
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO AZI-ULTDT.
           MOVE RG-AZI-FLCOS TO AZI-FLCOS.
           MOVE RG-AZI-MOVMG TO AZI-MOVMG.
           MOVE RG-AZI-FLCON TO AZI-FLCON.
           MOVE RG-AZI-FLING TO AZI-FLING.
           MOVE RG-AZI-FLGIS TO AZI-FLGIS.
           MOVE RG-AZI-FLAMM TO AZI-FLAMM.
           MOVE RG-PRA-FIRMA TO PRA-FIRMA.
           MOVE RG-PRA-INTEN TO PRA-INTEN.
           MOVE RG-PRA-AUTOR TO PRA-AUTOR.
           MOVE RG-PRA-DTAUT TO GGMMAA. 
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO PRA-DTAUT.
           MOVE RG-PRA-COD   TO PRA-COD.
           MOVE RG-PRA-DTALL TO GGMMAA. 
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO PRA-DTALL.
      **** rel 2.0
           MOVE RG-PRA-DTLIG TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO PRA-DTLIG.
      ************
      **** rel 5.0
           MOVE RG-PRA-LOGACC TO PRA-LOGACC.
      ************
      **** rel 5.0
           MOVE RG-PRA-FLSCA  TO PRA-FLSCA.
      ************
      **** rel 6.0
           MOVE RG-PRA-LCDART TO PRA-LCDART.
      **** end rel 6.0
      **** rel 6.2
           MOVE RG-AZI-COD   TO KAAZ-COD. 
           MOVE RG-AZI-CGN   TO AAZ-CGN.
           MOVE RG-AZI-NOM   TO AAZ-NOM.
           MOVE RG-AZI-CNA   TO AAZ-CNA.
           MOVE RG-AZI-PNA   TO AAZ-PNA.
           MOVE RG-AZI-DNA   TO GGMMAA. 
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG        TO AAZ-DNA.
           MOVE RG-AZI-SES   TO AAZ-SES.
      ************
           MOVE REKAZI TO RF-AZI.
       EX-CARICA-REC.
           EXIT.
      *------------------
       CARICA-RG.
           MOVE AZI-COD TO RG-AZI-COD.
           MOVE AZI-RGSOC TO RG-AZI-RGSOC.
           MOVE AZI-INDIR TO RG-AZI-INDIR.
           MOVE AZI-CAP   TO RG-AZI-CAP.
           MOVE AZI-CIT   TO RG-AZI-CIT.
           MOVE AZI-PRV   TO RG-AZI-PRV.
           MOVE AZI-PIVA  TO RG-AZI-PIVA.
           MOVE AZI-CFISC TO RG-AZI-CFISC.
           MOVE AZI-CUIVA TO RG-AZI-CUIVA.
           MOVE AZI-CATT  TO RG-AZI-CATT. 
           MOVE AZI-DATT  TO RG-AZI-DATT. 
           MOVE AZI-RVDT TO AAGGG. 
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA    TO RG-AZI-RVDT. 
           MOVE AZI-RVNRG TO RG-AZI-RVNRG. 
           MOVE AZI-NUMFT TO RG-AZI-NUMFT. 
           MOVE AZI-DTAPE TO AAGGG. 
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA    TO RG-AZI-DTAPE.
           MOVE AZI-RANRG TO RG-AZI-RANRG. 
           MOVE AZI-NEFF  TO RG-AZI-NEFF.  
           MOVE AZI-FLSCC TO RG-AZI-FLSCC. 
           MOVE AZI-SZDT  TO RG-AZI-SZDT. 
           MOVE AZI-PRCOR TO RG-AZI-PRCOR.
           MOVE AZI-MOVPR TO RG-AZI-MOVPR.
           MOVE AZI-PRSCA TO RG-AZI-PRSCA.
           MOVE AZI-ULTDT TO AAGGG. 
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA    TO RG-AZI-ULTDT.
           MOVE AZI-FLCOS TO RG-AZI-FLCOS.
           MOVE AZI-MOVMG TO RG-AZI-MOVMG.
           MOVE AZI-FLCON TO RG-AZI-FLCON.
           MOVE AZI-FLING TO RG-AZI-FLING.
           MOVE AZI-FLGIS TO RG-AZI-FLGIS.
           MOVE AZI-FLAMM TO RG-AZI-FLAMM.
           MOVE PRA-FIRMA TO RG-PRA-FIRMA.
           MOVE PRA-INTEN TO RG-PRA-INTEN.
           MOVE PRA-AUTOR TO RG-PRA-AUTOR.
           MOVE PRA-DTAUT TO AAGGG. 
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA    TO RG-PRA-DTAUT.
           MOVE PRA-COD   TO RG-PRA-COD.
           MOVE PRA-DTALL TO AAGGG. 
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA    TO RG-PRA-DTALL.
      **** rel 2.0
           MOVE PRA-DTLIG TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA    TO RG-PRA-DTLIG.
      ************
      **** rel 5.0
           MOVE PRA-LOGACC TO RG-PRA-LOGACC.
      ************
      **** rel 5.0
           MOVE PRA-FLSCA  TO RG-PRA-FLSCA.
      ************
      **** rel 6.0
           MOVE PRA-LCDART TO RG-PRA-LCDART.
      **** end rel 6.0
      **** rel 6.2
           MOVE AAZ-CGN    TO RG-AZI-CGN.
           MOVE AAZ-NOM    TO RG-AZI-NOM.
           MOVE AAZ-CNA    TO RG-AZI-CNA.
           MOVE AAZ-PNA    TO RG-AZI-PNA.
           MOVE AAZ-DNA    TO AAGGG. 
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA     TO RG-AZI-DNA.
           MOVE AAZ-SES    TO RG-AZI-SES.
      ************
       EX-CARICA-RG.
           EXIT.
      *------------------
       CARICA-RA.
       EX-CARICA-RA.
           EXIT.
      *------------------
      * validazione dei campi chiave (NB: di RG-YYY-REC)
       V-CHIAVE.
           MOVE ZERO TO VFLD.
      *
       V-COD.
           MOVE 'AZI-COD' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-COD.
           IF RG-AZI-COD = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-COD.
      *
           GO TO EX-V-CHIAVE-DATI.
      *------------------
      * validazione dei campi non chiave (NB: di RG-YYY-REC)
       V-DATI.
           MOVE ZERO TO VFLD SW-CFISC.

       V-RGSOC.
           MOVE 'AZI-RGSOC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-RGSOC.
           IF RG-AZI-RGSOC = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-RGSOC.
      *
       V-PIVA. 
           MOVE 'AZI-PIVA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PIVA.
           MOVE RG-AZI-PIVA TO CODPIVA.
           CALL 'rpiva' USING PARPIVA.
           MOVE CODPIVA TO RG-AZI-PIVA.
           IF RISPIVA = ZERO GO TO E-PIVA. 
           MOVE 'Partita IVA errata' TO MESS.
           GO TO V-ERROR.
       E-PIVA. 
      *
       V-CFISC.
           MOVE 'AZI-CFISC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CFISC.
           MOVE 2 TO RISPIVA.
           IF AZI-BLK = SPACE AND AZI-CFP NUMERIC
              MOVE AZI-CFP TO CODPIVA
              CALL 'rpiva' USING PARPIVA.
           IF RISPIVA = ZERO GO TO E-CFISC.
           IF RISPIVA = 1 
              MOVE 'Partita IVA errata' TO MESS   
              GO TO V-ERROR.   
           MOVE RG-AZI-CFISC TO COMFISC.
           CALL 'rfisc' USING PARFISC.
           IF RISPFISC = 1 MOVE 1 TO SW-CFISC.
           IF SW-CFISC = 1 AND FUN = 'V'
              MOVE 'Cod.fisc.errato' TO MESS  
              GO TO V-WARNING.
       E-CFISC.
      *
       V-FLGIS.
           MOVE 'AZI-FLGIS' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FLGIS.
           IF RG-AZI-FLGIS = 1 AND FUN = 'V'   
              MOVE 'La normativa Gennaio 1998' TO F-MES1
              MOVE 'impone che la numerazione' TO F-MES2
              MOVE 'sia unica  (valore 2)    ' TO F-MES3
              MOVE 3 TO F-NMES
              GO TO V-WARNING.
       E-FLGIS.
      *
       V-FLING.
           MOVE 'AZI-FLING' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FLING.
           IF RG-AZI-FLING > 1    
              PERFORM ERR-DINV
              GO TO V-ERROR.
       E-FLING.
      *
       V-FLAMM.
           MOVE 'AZI-FLAMM' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FLAMM.
           IF RG-AZI-FLAMM > 1    
              PERFORM ERR-DINV
              GO TO V-ERROR.
       E-FLAMM.
      *
       V-FLCOS.
           MOVE 'AZI-FLCOS' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FLCOS.
           IF RG-AZI-FLCOS > 1    
              PERFORM ERR-DINV
              GO TO V-ERROR.
       E-FLCOS.
      *
       V-FLSCC.
           MOVE 'AZI-FLSCC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FLSCC.
           IF RG-AZI-FLSCC > 1    
              PERFORM ERR-DINV
              GO TO V-ERROR.
       E-FLSCC.
      *
       V-DTAUT.
           MOVE 'AZI-DTAUT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTAUT.
           MOVE 1 TO TIPOP1.
           MOVE RG-PRA-DTAUT TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DTAUT.
      *
       V-DTALL.
           MOVE 'AZI-DTALL' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTALL.
           MOVE 1 TO TIPOP1.
           MOVE RG-PRA-DTALL TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DTALL.
      *
       V-RVDT.
           MOVE 'AZI-RVDT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-RVDT.
           MOVE 1 TO TIPOP1.
           MOVE RG-AZI-RVDT TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-RVDT.
      *
       V-DTAPE.
           MOVE 'AZI-DTAPE' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTAPE.
           MOVE 1 TO TIPOP1.
           MOVE RG-AZI-DTAPE TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DTAPE.
      *
       V-ULTDT.
           MOVE 'AZI-ULTDT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ULTDT.
           MOVE 1 TO TIPOP1.
           MOVE RG-AZI-ULTDT TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-ULTDT.
      **** rel 2.0
      *
       V-DTLIG.
           MOVE 'AZI-DTLIG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTLIG.
           MOVE 1 TO TIPOP1.
           MOVE RG-PRA-DTLIG TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DTLIG.
      **** rel 5.0
      *
       V-LOGAC.
           MOVE 'PRA-LOGAC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-LOGAC.
           IF RG-PRA-LOGACC = ZERO GO TO E-LOGAC.
           IF RG-PRA-LOGACC > 2
              MOVE 'Valore non ammesso' TO MESS
              GO TO V-ERROR.
       E-LOGAC.
      ************
      **** rel 6.0
      *
       V-LCDART.
           MOVE 'PRA-LCDART' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-LCDART.
           IF RG-PRA-LCDART > 18
              PERFORM ERR-DINV
              GO TO V-ERROR.
       E-LCDART.
      **** end rel 6.0
      **** rel 6.2
      *
       V-NOM.
           MOVE 'AZI-NOM' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-NOM.
           IF RG-AZI-NOM = SPACE AND RG-AZI-CGN NOT = SPACE
              PERFORM ERR-ZERO 
              GO TO V-ERROR.
           IF RG-AZI-CGN NOT = SPACE AND RG-AZI-SES = SPACE
              MOVE 'M' TO RG-AZI-SES.
       E-NOM.
      *
       V-DNA.
           MOVE 'AZI-DNA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DNA.
           MOVE 1 TO TIPOP1.
           MOVE RG-AZI-DNA TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DNA.
      ************
      *
      * esegue sempre
           IF FUN = 'W' AND SW-CFISC = 1
              MOVE 'Cod.fisc.errato' TO MESS  
              GO TO V-WARNING.
           GO TO EX-V-CHIAVE-DATI.
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-CHIAVE-DATI.
           EXIT.
      *------------------
      * storno dati correlati
       DB-STORNA.
      **** rel 5.0
           MOVE KAZ-COD    TO SA-AZI.
           MOVE EX-LOGNAME TO SA-UTE.
           CALL 'vrselaz' USING PARSA.
           IF SA-FLGABI = ZERO
              MOVE "Azienda non modificabile" TO MESS
              MOVE 8 TO ERRIO-ST.
      ************
       EX-DB-STORNA.
           EXIT.
      *------------------
      * aggiornamento dati correlati
       DB-AGGIORNA.
       EX-DB-AGGIORNA.
           EXIT.
      *------------------
