       IDENTIFICATION DIVISION.
       PROGRAM-ID. VBOLWRD.
      *
      * Routine stampa bolle XAB con MS-Word
      *
      * Versione per pubblicazione documenti
      *
      **** rel 5.1
      * nuovo: sostituisce VORD210W.CBL
      ************
      **** rel 6.1
      * spostata scrittura file D- nella routine VRWORD
      ************
      **** rel 6.2
      * ricompilato per copy parwd modificata
      * ricompilato per copy grincr             
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'gribctsl'.
           COPY 'gribcrsl'.
           COPY 'gritabsl'.
           COPY 'grintasl'.
           COPY 'grincrsl'.
      **** rel 6.2
           COPY 'grilmcsl'.
           COPY 'grilmssl'.
           COPY 'griartsl'.
           COPY 'gritprsl'.
           COPY 'gribansl'.
           COPY 'griabasl'.
      ************
      **** rel 6.3
           COPY 'griclfsl'.
      ************
      **** rel 7.1
           COPY 'griacfsl'.
           COPY 'griactsl'.
      ************
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gribct'.
           COPY 'gribcr'.
           COPY 'gritab'.
           COPY 'grinta'.
           COPY 'grincr'.
      **** rel 6.2
           COPY 'grilmc'.
           COPY 'grilms'.
           COPY 'griart'.
           COPY 'gritpr'.
           COPY 'griban'.
           COPY 'griaba'.
      ************
      **** rel 6.3
           COPY 'griclf'.
      ************
      **** rel 7.1
           COPY 'griacf'.
           COPY 'griact'.
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-71'.
           COPY 'gritabrk'.
           COPY 'griazirk'.
      **** rel 6.2
           COPY 'griartrk'.
           COPY 'gritpr11'.
      ************
      **** rel 7.1
           COPY 'griclfrk'.
      ************
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parab'.
           COPY 'parwo'.
           COPY 'parrm'.
           COPY 'parop'.
           COPY 'parpcfa'.
      **** rel 6.2
           COPY 'parpi'.
           COPY 'pariban'.
      ************
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-NTA PIC X(15) VALUE 'nottab'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-BCT PIC X(15) VALUE 'bolcte'.
       01  ID-BCR PIC X(15) VALUE 'bolcri'.
       01  ID-NCR PIC X(15) VALUE 'notbcr'.
      **** rel 6.2
       01  ID-LMC PIC X(15) VALUE 'limeca'.
       01  ID-LMS PIC X(15) VALUE 'limesc'.
       01  ID-ART PIC X(15) VALUE 'magart'.
       01  ID-TPR PIC X(15) VALUE 'tabpro'.
       01  ID-BAN PIC X(15) VALUE 'anaban'.
       01  ID-ABA PIC X(15) VALUE 'appban'.
      ************
      **** rel 6.3
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
      ************
      **** rel 7.1
       01  ID-ACF PIC X(15) VALUE 'appclf'.
       01  ID-ACT PIC X(15) VALUE 'appbct'.
      ************
      *
       01  COMODI.
           05 SF-AZI    PIC XX.
           05 SF-TAB    PIC XX.
           05 SF-NTA  PIC XX.
           05 SF-BCT     PIC XX.
           05 SF-BCR     PIC XX.
           05 SF-NCR     PIC XX.
      **** rel 6.2
           05 SF-LMC     PIC XX.
           05 SF-LMS     PIC XX.
           05 SF-ART     PIC XX.
           05 SF-TPR     PIC XX.
           05 SF-BAN     PIC XX.
           05 SF-ABA     PIC XX.
      ************
      **** rel 6.3
           05 SF-CLF     PIC XX.
      ************
      **** rel 7.1
           05 SF-ACF     PIC XX.
           05 SF-ACT     PIC XX.
      ************

           05 NPAG       PIC 999.
      **** rel 7.1
           05 MCLI       PIC 99.
           05 MFOR       PIC 99.
      ************
           05 MESS       PIC X(40) VALUE SPACE.
           05 DATBOL     PIC 9(6) VALUE ZERO.
           05 DTRA       PIC 9(6) VALUE ZERO.
           05 OTRA       PIC 9(4) VALUE ZERO.
           05 ORA REDEFINES OTRA.
              10 ORAOO PIC 99.
              10 ORAMM PIC 99.
           05 DESPOR     PIC X(24) VALUE SPACE.
           05 DESSPE     PIC X(24) VALUE SPACE.
           05 FLGTES     PIC 9     VALUE ZERO.
           05 KN         PIC 9(4)  VALUE ZERO.
      **** rel 6.3
           05 CODCLI PIC 9(6) VALUE ZERO.
           05 CODICE REDEFINES CODCLI.
              10 MAS        PIC 9(2).
              10 CLI        PIC 9(5).
      ************

       01  FLGPRI      PIC 9 VALUE ZERO.

       01  PAR-P-MDT.
           05 P-MDT-AZI   PIC 999.
           05 P-MDT-TDOC  PIC 9.
           05 P-MDT-KEY   PIC X(15).
           05 P-MDT-FLGS  PIC 9.
           05 P-MDT-DATA  PIC 9(5).
           05 P-MDT-NCOL  PIC 99.
           05 P-MDT-TESTO PIC X(76).
           05 P-MDT-FLGE  PIC 9.

           COPY 'vbolwrd.cpy'.
       LINKAGE SECTION.
           COPY 'parwbol'.
       PROCEDURE DIVISION USING PARWBOL PARCCD.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclbct'.
           COPY 'dclbcr'.
           COPY 'dclncr'.
           COPY 'dcltab'.
           COPY 'dclnta'.
      **** rel 6.2
           COPY 'dcllmc'.
           COPY 'dcllms'.
           COPY 'dclart'.
           COPY 'dcltpr'.
           COPY 'dclban'.
           COPY 'dclaba'.
      ************
      **** rel 6.3
           COPY 'dclclf'.
      ************
      **** rel 7.1
           COPY 'dclacf'.
           COPY 'dclact'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
      *
           MOVE ZERO TO PCCD-ERR.

      * Inizializza
           IF PCCD-FUN = 'T' OR 'I'
              PERFORM PGM-INI THRU EX-PGM-INI.

      * Esegue
           IF PCCD-FUN = 'T' OR 'R'
              PERFORM PGM-RUN THRU EX-PGM-RUN.

      * Chiude
           IF PCCD-FUN = 'T' OR 'E'
              PERFORM PGM-END THRU EX-PGM-END
              GO TO CHIUDI.

           GO TO FINE.
       ERRIO.
           COPY 'errsub'.
           MOVE 9 TO PCCD-ERR.
       CHIUDI.
           CLOSE ANAAZI TABELL BOLCTE BOLCRI NOTBCR.
           CLOSE NOTTAB.
      **** rel 6.2
           CLOSE LIMECA.
           CLOSE LIMESC.
           CLOSE MAGART.
           CLOSE TABPRO.
           CLOSE ANABAN.
           CLOSE APPBAN.
      ************
      **** rel 6.3
           CLOSE ANACLF.
      ************
      **** rel 7.1
           CLOSE APPCLF.
           CLOSE APPBCT.
      ************
           PERFORM WRD-CL.
       FINE.
           EXIT PROGRAM.
      *-------------------*
           COPY 'griwrd'.
      *-------------------*
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'gribcter'.
           COPY 'gribcrer'.
           COPY 'grincrer'.
           COPY 'gritaber'.
           COPY 'grintaer'.
      **** rel 6.2
           COPY 'grilmcer'.
           COPY 'grilmser'.
           COPY 'griarter'.
           COPY 'gritprer'.
           COPY 'gribaner'.
           COPY 'griabaer'.
      ************
      **** rel 6.3
           COPY 'griclfer'.
      ************
      **** rel 7.1
           COPY 'griacfer'.
           COPY 'griacter'.
      ************
           COPY 'grixxxer'.
      *------------------------------------------*
       PGM-END.
           PERFORM WRD-END.
       EX-PGM-END.
           EXIT.
      *------------------------------------------*
       PGM-INI.
      *
           OPEN I-O   BOLCTE.
           OPEN INPUT ANAAZI.
           OPEN INPUT TABELL.
           OPEN INPUT NOTTAB.
           OPEN INPUT NOTBCR.
           OPEN INPUT BOLCRI.
      **** rel 6.2
           OPEN INPUT LIMECA.
           OPEN INPUT LIMESC.
           OPEN INPUT MAGART.
           OPEN INPUT TABPRO.
           OPEN INPUT ANABAN.
           OPEN INPUT APPBAN.
      ************
      **** rel 7.1
           OPEN INPUT APPCLF.
           OPEN INPUT APPBCT.
      ************
      **** rel 6.3
           OPEN INPUT ANACLF.
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MCLI TO MCLI.
           MOVE T01-MFOR TO MFOR.
      *
      ************
      *
           MOVE PWBOL-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
      *
      **** rel 6.2
           MOVE PWBOL-AZI TO KTR-AZI.
           MOVE 11        TO KTR-TIP.
           READ TABPRO INTO REKTPR11 INVALID PERFORM INVK-TPR
                                             GO TO ERRIO.
           IF SF-TPR = '9A' OR '9D' OR '35' MOVE RF-TPR TO REKTPR11.
      ************
      *
           MOVE 'ddt'    TO WO-IDDOC.
           MOVE PWBOL-AZI TO WO-AZI.
           PERFORM WRD-INI.
      *
       EX-PGM-INI.
           EXIT.
      *------------------------------------------*
       PGM-RUN.
      *
           MOVE ZERO TO KEYBC.
           MOVE PWBOL-AZI  TO KBC-AZI.
           MOVE PWBOL-NUM  TO KBC-NUM.
           MOVE PWBOL-BOL  TO KBC-BOL.
           READ BOLCTE INVALID GO TO NOBOL.
      *
           IF SAVPATH = SPACE AND PCCD-PATH NOT = SPACE
              MOVE BCT-DATA TO AAGGG
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              STRING PCCD-PATH DELIMITED SPACE
                     '\bol'
                     KBC-AZI
                     AA9
                     KBC-NUM
                     KBC-BOL
                     '.doc'
                     DELIMITED SIZE INTO SAVPATH
              MOVE SAVPATH TO PCCD-PATH.

           MOVE BCT-DATA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO DATBOL.
      *
           MOVE ZERO TO NPAG.
           PERFORM C00-STAMPA-TESTA THRU C99.
           PERFORM D00-STAMPA-CORPO THRU D99.
      *
           PERFORM G00-STAMPA-IMBALLI THRU G99.
      **** rel 6.2
           IF TPR11-CFLSTA = 1
              PERFORM S00-SCARICO-LM THRU S99.
      ************
           PERFORM H00-STAMPA-MESSAGG THRU H99.
           IF FLGTES = ZERO SUBTRACT 1 FROM INDR.
      *
           PERFORM E00-STAMPA-PIEDE THRU E99.
           MOVE 1 TO BCT-STAMP.
           REWRITE RF-BCT INVALID PERFORM INVK-BCT
                                  GO TO ERRIO.
       NOBOL.

       EX-PGM-RUN.
           EXIT.
      *------------------------------------------*
       C00-STAMPA-TESTA.
           PERFORM WRD-AZZ.
      *
           ADD 1 TO NPAG.
      **** rel 7.1
      *    MOVE BCT-DRAG  TO D-RGSOC1.
      *    MOVE BCT-DRAG2 TO D-RGSOC2.
      *    MOVE BCT-DIND  TO D-INDIR1.
      *    MOVE BCT-DIND2 TO D-INDIR2.
           MOVE KBC-AZI TO KCF-AZI.
           IF BCT-TDOC = 6 OR 7
              MOVE MFOR TO CLF-MS
           ELSE
              MOVE MCLI TO CLF-MS
           END-IF
           MOVE BCT-CLI    TO CLF-CD.
           MOVE CLF-COD    TO KCF-COD. 
           READ ANACLF INTO REKCLF INVALID
                       PERFORM INVK-CLF
                       GO TO ERRIO.
      **** rel 7.1
           MOVE KEYCF TO KEYACF.
           READ APPCLF INVALID MOVE SPACE TO ACF-NAZIO.
           MOVE ACF-NAZIO TO D-NAZIO. 
           MOVE CLF-CFISC TO D-CFISC.
           IF CLF-PIVA > ZERO MOVE CLF-PIVA TO D-PIVA.
           IF CLF-13IVA = 4
              MOVE SPACE     TO D-CFISC
              MOVE CLF-CFISC TO D-PIVA.
      ************
           MOVE CLF-RGSOC  TO D-RGSOC1.
           MOVE CLF-RGSOC2 TO D-RGSOC2.
           MOVE CLF-INDIR  TO D-INDIR1.
           MOVE CLF-INDIR2 TO D-INDIR2.
           IF CLF-CAP NOT = ZERO 
              MOVE CLF-CAP TO D-CAPN
           ELSE
              MOVE SPACE TO D-CAP.
           MOVE CLF-CITTA TO D-CITTA.
           MOVE BCT-DRAG  TO D-LRGSOC1.
           MOVE BCT-DRAG2 TO D-LRGSOC2.
           MOVE BCT-DIND  TO D-LINDIR1.
           MOVE BCT-DIND2 TO D-LINDIR2.
           MOVE BCT-DEST  TO D-LDESDI.
      ************
           MOVE KBC-BOL   TO D-NUMBOL.
           MOVE DATBOL    TO D-DTBOL.
           MOVE NPAG TO D-NPAG.
           MOVE BCT-CLI   TO D-CDCLI.
      **** rel 7.1
      *    MOVE BCT-DCAP  TO D-LCAP.
      *    MOVE BCT-DCIT  TO D-CITTA.
           IF BCT-DCAP NOT = ZERO 
              MOVE BCT-DCAP TO D-LCAPN
           ELSE
              MOVE SPACE TO D-LCAP.
           MOVE BCT-DCIT  TO D-LCITTA.
           IF BCT-DRAG = SPACE AND BCT-DRAG2 = SPACE AND 
              BCT-DIND = SPACE AND BCT-DIND2 = SPACE AND
              BCT-DCAP = ZERO  AND BCT-DCIT = SPACE
              MOVE CLF-RGSOC  TO D-LRGSOC1
              MOVE CLF-RGSOC2 TO D-LRGSOC2
              MOVE CLF-INDIR  TO D-LINDIR1
              MOVE CLF-INDIR2 TO D-LINDIR2
              IF CLF-CAP NOT = ZERO 
                 MOVE CLF-CAP TO D-LCAPN
              ELSE
                 MOVE SPACE TO D-LCAP
              END-IF
              MOVE CLF-CITTA  TO D-LCITTA.
      ************
           MOVE BCT-DEST  TO D-DESTINAZ.
           MOVE BCT-CAUT  TO D-CAUTRA.
           MOVE BCT-DESSPE TO D-SPEDIZ.
      **** rel 7.1
           MOVE KBC-AZI TO KACT-AZI.
           MOVE KBC-NUM TO KACT-NUM.
           MOVE KBC-BOL TO KACT-BOL.
           READ APPBCT INVALID 
                MOVE SPACE TO ACT-IPA ACT-CIG ACT-CUP
                MOVE ZERO  TO ACT-TIPO.
           MOVE ACT-IPA TO D-IPA.
           MOVE ACT-CIG TO D-CIG.
           MOVE ACT-CUP TO D-CUP.
           MOVE SPACE   TO D-TIPO.
           IF BCT-TDOC = 1
              IF ACT-TIPO = ZERO
                 MOVE 'Fattura Normale' TO D-TIPO
              END-IF
              IF ACT-TIPO = 1
                 MOVE 'Nota di debito' TO D-TIPO
              END-IF
              IF ACT-TIPO = 2
                 MOVE 'Fattura di anticipo' TO D-TIPO.
      ************
           MOVE 6        TO KTB-TIP.
           MOVE BCT-CSPE TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE SPACE TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           PERFORM RD-NTA THRU EX-RD-NTA.
           MOVE BCT-DESPOR TO D-PORTO.
           MOVE 5        TO KTB-TIP.
           MOVE BCT-CPOR TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE SPACE TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           PERFORM RD-NTA THRU EX-RD-NTA.
      **** rel 6.2
           MOVE 4        TO KTB-TIP.
           MOVE BCT-CPAG TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE SPACE TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE BCT-CBAN TO KBA-BAN.
           READ ANABAN INVALID MOVE SPACE TO BAN-RGSOC.
           MOVE BAN-RGSOC TO D-BANCA.
           IF T04-TIPAG NOT = 5
              MOVE SPACE TO D-IBAN
              MOVE 1 TO KN
              IF BAN-CODAZ NOT = '00000'
                 STRING 'ABI: ' BAN-CODAZ ' ' DELIMITED SIZE
                        INTO D-IBAN POINTER KN
              END-IF
              IF BAN-CODSP NOT = '00000'
                 STRING 'CAB: ' BAN-CODSP DELIMITED SIZE
                        INTO D-IBAN POINTER KN
              END-IF
              GO TO NO-CCOR.
      **** rel 6.3
      *    MOVE KEYBA TO KEYABA.
           MOVE KBC-AZI TO KABA-AZI.
           MOVE KBA-BAN TO KABA-BAN.
      ************
           READ APPBAN INVALID MOVE SPACE TO ABA-CIBAN.
           MOVE ZERO      TO PARIBAN.
           MOVE ABA-CIBAN TO IBAN.
           CALL 'riban' USING PARIBAN PARBBAN.
           IF NOT (IBAN-FLG = 9)
              MOVE IBAN-P TO D-IBAN.
       NO-CCOR.
      ************
      ****
           MOVE WD-TIPS TO D-TIPS.
      ****
           MOVE 1          TO D-NCOP.
           MOVE SPACE      TO D-FAX.
           MOVE NPAG       TO D-TOTPAG.

           MOVE 1 TO INDR.
       C99. EXIT.
      *------------------
       D00-STAMPA-CORPO.
           MOVE KBC-AZI TO KCR-AZI.
           MOVE KBC-NUM TO KCR-NUM.
           MOVE KBC-BOL TO KCR-BOL.
           MOVE ZERO    TO KCR-PGR.
           START BOLCRI KEY NOT < KEYCR INVALID GO TO D99.
       D10.
           READ BOLCRI NEXT AT END GO TO D99.
           IF SF-BCR = '9D' OR '9A' OR '35' GO TO D10.
           IF ( KCR-AZI NOT = KBC-AZI ) OR
              ( KCR-NUM NOT = KBC-NUM ) OR
              ( KCR-BOL NOT = KBC-BOL ) GO TO D99.
           IF BCR-TCOR = 3 GO TO D10.
           IF BCR-TCOR = 1 AND
              BCR-FSC = 1 GO TO D10.
           IF INDR > (MAXR - 2)
              MOVE MAXR TO INDR
              MOVE '             (Continua ----->)' TO D-ART-D(INDR)
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM C00-STAMPA-TESTA THRU C99
              MOVE '(..... segue)' TO D-ART-D(INDR)
              ADD 1 TO INDR.
           MOVE BCR-DESCR TO D-ART-D(INDR).
           IF BCR-TCOR = 1 GO TO D20.
           MOVE BCR-ART TO D-ART(INDR).
           MOVE BCR-UM TO D-UM(INDR).
           IF BCR-TQUAN = 0 MOVE BCR-QTA TO PQTA(INDR)
           ELSE IF BCR-TQUAN = 1 MOVE BCR-QTA TO PQTA1(INDR)
                ELSE MOVE BCR-QTA TO PQTA2(INDR).

           MOVE KCR-AZI     TO OP-AZI.
           MOVE BCT-VALUT   TO OP-VALUT.
           MOVE BCR-PZLOR   TO OP-PREZZO.
           MOVE BCR-FSC     TO OP-FSC.
           CALL 'routprz' USING PAROP OP-VEN.
           MOVE OP-PREZZO   TO PZLOR(INDR).
           IF OP-NDEC = 2 MOVE OP-PREZZO TO PZLOR1(INDR).
           IF OP-NDEC = 3 MOVE OP-PREZZO TO PZLOR3(INDR).
           IF OP-NDEC = 4 MOVE OP-PREZZO TO PZLOR4(INDR).
           IF OP-NDEC = 5 MOVE OP-PREZZO TO PZLOR5(INDR).
           IF OP-NDEC = 6 MOVE OP-PREZZO TO PZLOR6(INDR).
       D20.
      **** rel 6.2
           IF BCR-TCOR = 1 SUBTRACT 1 FROM INDR.
      ************
      * stampa note aggiuntive
           MOVE KCR-AZI TO KNCR-AZI.
           MOVE KCR-NUM TO KNCR-NUM.
           MOVE KCR-BOL TO KNCR-BOL.
           MOVE KCR-PGR TO KNCR-PGR.
           MOVE ZERO    TO KNCR-PGRN.
           START NOTBCR KEY > KEYNCR INVALID GO TO B99.
       RDN-NCR.
           READ NOTBCR NEXT AT END GO TO B99.
           IF KNCR-AZI > KCR-AZI GO TO B99.
           IF KNCR-NUM > KCR-NUM GO TO B99.
           IF KNCR-BOL > KCR-BOL GO TO B99.
           IF KNCR-PGR > KCR-PGR GO TO B99.
           ADD 1 TO INDR.
           IF INDR > (MAXR - 2)
              MOVE MAXR TO INDR
              MOVE '             (Continua ----->)' TO D-ART-D(INDR)
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM C00-STAMPA-TESTA THRU C99
              MOVE '(..... segue)' TO D-ART-D(INDR)
              ADD 1 TO INDR.
           MOVE NCR-DESCR TO D-ART-D(INDR).
           GO TO RDN-NCR.
       B99.
      *
           ADD 1 TO INDR.
           IF BCR-ART NOT = SPACE
              MOVE ZERO     TO PCFA-FUN
              MOVE KCR-AZI  TO PCFA-AZI
              IF BCT-TDOC = 6 OR 7
                 MOVE 'F'      TO PCFA-TIP
              ELSE
                 MOVE 'C'      TO PCFA-TIP
              END-IF
              MOVE BCT-CLI TO PCFA-CLF
              MOVE BCR-ART TO PCFA-ART
              MOVE ZERO TO PCFA-LIN
      *       MOVE CLF-FLING TO PCFA-LIN
              CALL 'vrrcfa' USING PARPCFA
              IF PCFA-ST = ZERO
                 IF PCFA-DEST NOT = SPACE
                    IF INDR > MAXR 
                       PERFORM SCR-REC THRU EX-SCR-REC   
                       PERFORM C00-STAMPA-TESTA THRU C99
                    END-IF
                    MOVE PCFA-DEST TO D-ART-D(INDR)
                    ADD 1 TO INDR
                 END-IF
                 IF PCFA-DDIS NOT = SPACE
                    IF INDR > MAXR 
                       PERFORM SCR-REC THRU EX-SCR-REC   
                       PERFORM C00-STAMPA-TESTA THRU C99
                    END-IF
                    MOVE PCFA-DDIS TO D-ART-D(INDR)
                    ADD 1 TO INDR.
           GO TO D10.
       D99. EXIT.
      *------------------------------------------
       E00-STAMPA-PIEDE.
           MOVE BCT-ASPE TO D-ASPETTO.
           MOVE BCT-NCOL TO D-NCOLLI.
           MOVE BCT-PLOR TO D-PESOLOR.
           MOVE BCT-PNET TO D-PESONET.
           IF BCT-VRAG1 = SPACE GO TO E50.
           MOVE BCT-VRAG1 TO D-RGSOC-V1.
           MOVE BCT-DTRA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO DTRA.
           IF DTRA NOT = ZERO MOVE DTRA TO D-DATA-V1.
           MOVE BCT-OTRA TO OTRA.
           IF OTRA NOT = ZERO MOVE OTRA TO D-ORA-V1.
           MOVE BCT-VIND1 TO D-INDIR-V1.
       E50.
           MOVE BCT-NOT1 TO D-NOT1.
           IF BCT-VRAG1 NOT = SPACE GO TO E60.
           MOVE BCT-DTRA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO DTRA.
           IF DTRA NOT = ZERO MOVE DTRA TO D-DTTRA.
           MOVE BCT-OTRA TO OTRA.
           IF OTRA NOT = ZERO MOVE OTRA TO D-ORATRA.
       E60.
           IF BCT-NOT1 = SPACE GO TO E90.
           MOVE BCT-NOT2 TO D-NOT2.
           MOVE BCT-NOT3 TO D-NOT3.
           MOVE BCT-NOT4 TO D-NOT4.
           MOVE BCT-NOT5 TO D-NOT5.
       E90.
           PERFORM SCR-REC THRU EX-SCR-REC.
       E99.
           EXIT.
      *--------------*
       SCR-REC.
           MOVE SPACE TO D-FLGS.
           IF PCCD-FLGS = 0
              MOVE 'S' TO D-FLGS.
           MOVE PCCD-PATH TO D-IDDOC.
      *
           PERFORM WRD-WR.
       EX-SCR-REC.
      *-------------------------------
       G00-STAMPA-IMBALLI.
           MOVE ZERO TO FLGPRI.
           MOVE KBC-AZI    TO RM-AZI.
           MOVE BCT-DATA   TO RM-DTDOC.
           MOVE '2'        TO RM-TIPU.
           MOVE KBC-NUM    TO RM-NUM.
           MOVE KBC-BOL    TO RM-BOL.
           MOVE HIGH-VALUE TO RM-PRG.
       G10.
           CALL 'vrpimu' USING PARRM.
           IF RM-ERR = 9 GO TO G99.

           ADD 1 TO INDR.
           IF FLGPRI NOT = ZERO GO TO G20.
           IF INDR > (MAXR - 3)
              MOVE '             (Continua ----->)' TO D-ART-D(INDR)
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM C00-STAMPA-TESTA THRU C99
              MOVE '(..... segue)' TO D-ART-D(INDR)
              ADD 1 TO INDR.
           MOVE '- Specifica imballi:' TO D-ART-D(INDR).
           ADD 1 TO INDR.
           MOVE 1 TO FLGPRI.
       G20.
           IF INDR > (MAXR - 2)
              MOVE '             (Continua ----->)' TO D-ART-D(INDR)
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM C00-STAMPA-TESTA THRU C99
              MOVE '(..... segue)' TO D-ART-D(INDR)
              ADD 1 TO INDR.
           MOVE RM-IMB  TO D-ART(INDR).
           MOVE RM-DESC TO D-ART-D(INDR).
           MOVE 'Nr'    TO D-UM(INDR).
           MOVE RM-QTA  TO PQTA(INDR).
           GO TO G10.
       G99.
           EXIT.
      *------------------------------------------
       H00-STAMPA-MESSAGG.
           MOVE ZERO TO FLGTES.
           ADD 1 TO INDR.
           MOVE KBC-AZI  TO P-MDT-AZI.
           MOVE 1        TO P-MDT-TDOC.
           MOVE KEYBC    TO P-MDT-KEY.
           MOVE 1        TO P-MDT-FLGS.
           MOVE BCT-DATA TO P-MDT-DATA.
           MOVE ZERO     TO P-MDT-FLGE.
       H10.
           CALL 'vrpmdt' USING PAR-P-MDT.
           IF P-MDT-FLGE NOT = 1 GO TO H99.
           ADD 1 TO INDR.
           IF INDR > MAXR
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM C00-STAMPA-TESTA THRU C99.
           MOVE P-MDT-TESTO(1:P-MDT-NCOL) TO D-ART-D(INDR).
           MOVE 1 TO FLGTES.
           GO TO H10.
       H99.
           EXIT.
      *------------------------------------------
      * fase di lettura note 
       RD-NTA.
           MOVE ZERO TO KN.
      *
           MOVE TAB-TIP TO KNTA-TIP.
           MOVE TAB-COD TO KNTA-COD.
           MOVE ZERO    TO KNTA-PRG.
           START NOTTAB KEY >= KEYNTA INVALID GO TO RD-NTA-20.
       RD-NTA-10.
           READ NOTTAB NEXT AT END GO TO RD-NTA-20.
           IF KNTA-TIP > TAB-TIP GO TO RD-NTA-20.
           IF KNTA-COD > TAB-COD GO TO RD-NTA-20.
           ADD 1 TO KN.
           IF TAB-TIP = 5 MOVE NTA-DESCR TO D-NOTR(KN).
           IF TAB-TIP = 6 MOVE NTA-DESCR TO D-NOTS(KN).

           GO TO RD-NTA-10.
       RD-NTA-20.
      *
       EX-RD-NTA.
           EXIT.
      *-------------------------------
      **** rel 6.2
      *-----------------------
       S00-SCARICO-LM.
           MOVE ZERO TO FLGPRI.
      *
           MOVE KBC-AZI  TO KLMS-AZI.
           MOVE BCT-DATA TO LMS-DTDOC.
           MOVE KBC-NUM  TO LMS-NUM.
           MOVE KBC-BOL  TO LMS-BOL.
           MOVE ZERO     TO LMS-PRGC.
           MOVE ZERO     TO KLMS-PROG.
           START LIMESC KEY NOT < SKEYLMS4 INVALID GO TO S99.
       S10.
           READ LIMESC NEXT AT END GO TO S99.
           IF SF-LMS = '9D' OR '9A' OR '35' GO TO S10.
           IF ( KLMS-AZI  NOT = KBC-AZI  ) OR
              ( LMS-DTDOC NOT = BCT-DATA ) OR
              ( LMS-NUM   NOT = KBC-NUM  ) OR
              ( LMS-BOL   NOT = KBC-BOL  ) GO TO S99.

           IF FLGPRI NOT = ZERO GO TO S20.
           ADD 1 TO INDR.
           IF INDR > (MAXR - 3)
              MOVE '             (Continua ----->)' TO D-ART-D(INDR)
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM C00-STAMPA-TESTA THRU C99
              MOVE '(..... segue)' TO D-ART-D(INDR)
              ADD 1 TO INDR.
           MOVE '- Specifica scarico c/lavoro:' TO D-ART-D(INDR).
           MOVE 1 TO FLGPRI.
       S20.
           PERFORM Z00-STAMPA-SCARICO THRU Z99.
           GO TO S10.
       S99.
           EXIT.
      *-----------------------
       Z00-STAMPA-SCARICO.
           ADD 1 TO INDR.
           IF INDR > (MAXR - 2)
              MOVE MAXR TO INDR
              MOVE '             (Continua ----->)' TO D-ART-D(INDR)
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM C00-STAMPA-TESTA THRU C99
              MOVE '(..... segue)' TO D-ART-D(INDR)
              ADD 1 TO INDR.
 
           MOVE ZERO TO PARPI.
           MOVE KLMS-AZI TO PI-AZI.
           MOVE LMS-PROGC TO PI-PROGC.
           MOVE BCT-DATA TO PI-DT2.
           CALL 'vrsallim' USING PARPI.
 
           MOVE KLMS-AZI TO KLMC-AZI.
           MOVE LMS-PROGC TO KLMC-PROG.
           READ LIMECA INVALID PERFORM INVK-LMC
                               GO TO ERRIO.
           MOVE LMC-DTDOC TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
 
           IF PI-PSALDO NOT > ZERO STRING 'Saldo Vs DDT '
                                   LMC-NDOC ' ' GBMMBA
                                   DELIMITED SIZE INTO D-ART-D(INDR)
           ELSE                    STRING 'Acc. Vs DDT '
                                   LMC-NDOC ' ' GBMMBA
                                   DELIMITED SIZE INTO D-ART-D(INDR).
 
           ADD 1 TO INDR.
           IF INDR > (MAXR - 2)
              MOVE MAXR TO INDR
              MOVE '             (Continua ----->)' TO D-ART-D(INDR)
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM C00-STAMPA-TESTA THRU C99
              MOVE '(..... segue)' TO D-ART-D(INDR)
              ADD 1 TO INDR.
 
           MOVE KLMS-AZI TO KMA-AZI.
           MOVE LMS-ART TO KMA-ART.
           READ MAGART INTO REKART INVALID PERFORM INVK-ART
                                           GO TO ERRIO.
           IF SF-ART = '9A' OR '9D' MOVE RF-ART TO REKART.
           MOVE KMA-ART   TO D-ART(INDR).
           MOVE ART-DESCR TO D-ART-D(INDR).
           MOVE ART-UNMIS TO D-UM(INDR).
           IF ART-TQUAN = ZERO MOVE LMS-QTA TO PQTA(INDR).
           IF ART-TQUAN = 1    MOVE LMS-QTA TO PQTA1(INDR).
           IF ART-TQUAN = 2    MOVE LMS-QTA TO PQTA2(INDR).
       Z99.
           EXIT.
      *-----------------------
      ************
