       IDENTIFICATION DIVISION.
       PROGRAM-ID. VORD170.
      *
      * OGGETTO: Eliminazione bolle
      *
      **** rel 4.0
      * ricompilato
      ************
      **** rel 6.2
      * ricompilato per grincr
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'gribctsl'.
           COPY 'gribcrsl'.
      **** rel 2.0
           COPY 'gripbrsl'.
           COPY 'grincrsl'.
      ************
           COPY 'griobcsl'.
           COPY 'griazisl'.
      **** rel 7.1
           COPY 'griactsl'.
      ************
       DATA DIVISION.
       FILE SECTION.
           COPY 'gribct'.
           COPY 'gribcr'.
      **** rel 2.0
           COPY 'gripbr'.
           COPY 'grincr'.
      ************
           COPY 'griobc'.
           COPY 'griazi'.
      **** rel 7.1
           COPY 'griact'.
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-71'.
           COPY 'parzf'.
           COPY 'parcdt'.
      **** rel 5.0
           COPY 'parbc'.
      ************
      **** rel 5.1
           COPY 'pardag'.
      ************
      *** rel 5.0
       01  PAR-D-MDT.
           05 D-MDT-AZI  PIC 999.
           05 D-MDT-TDOC PIC 9.
           05 D-MDT-KEY  PIC X(15).
      ***********
       01  ID-AZI  PIC X(15) VALUE 'anaazi'.
       01  ID-BCT  PIC X(15) VALUE 'bolcte'.
       01  ID-BCR  PIC X(15) VALUE 'bolcri'.
      **** rel 2.0
       01  ID-PBR  PIC X(15) VALUE 'probcr'.
       01  ID-NCR  PIC X(15) VALUE 'notbcr'.
      ************
       01  ID-OBC  PIC X(15) VALUE 'bolord'.
      **** rel 7.1
       01  ID-ACT  PIC X(15) VALUE 'appbct'.
      ************
       01  COMODI.
           05 SF-TAB   PIC XX.
           05 SF-AZI   PIC XX.
           05 SF-BCT   PIC XX.
           05 SF-BCR   PIC XX.
      **** rel 2.0
           05 SF-PBR   PIC XX.
           05 SF-NCR   PIC XX.
      ************
           05 SF-OBC   PIC XX.
      **** rel 7.1
           05 SF-ACT   PIC XX.
      ************
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
      **** rel 5.0
           05 DATA1    PIC 9(5) COMP-3.
           05 DATA2    PIC 9(5) COMP-3.
      ************
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
           05 IF-COD-1     PIC 9(5).
           05 IF-COD-2     PIC 9(5).
           05 IF-TNU-1     PIC 9.
           05 IF-TNU-2     PIC 9.
           05 IF-TPELA     PIC 9.
      **** rel 5.0
           05 IF-DATA-1    PIC 9(6).
           05 IF-DATA-2    PIC 9(6).
      ************
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclbct'.
           COPY 'dclbcr'.
      **** rel 2.0
           COPY 'dclpbr'.
           COPY 'dclncr'.
      ************
           COPY 'dclobc'.
      **** rel 7.1
           COPY 'dclact'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vord170: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI BOLCTE BOLCRI BOLORD.
      **** rel 2.0
           CLOSE PROBCR NOTBCR.
      ************
      **** rel 7.1
           CLOSE APPBCT.
      ************
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'gribcter'.
           COPY 'gribcrer'.
      **** rel 2.0
           COPY 'gripbrer'.
           COPY 'grincrer'.
      ************
           COPY 'griobcer'.
      **** rel 7.1
           COPY 'griacter'.
      ************
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           OPEN INPUT ANAAZI.
           OPEN I-O   BOLCTE
                      BOLCRI
      **** rel 2.0
                      PROBCR
                      NOTBCR
      ************
      **** rel 7.1
                      APPBCT
      ************
                      BOLORD.
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INVALID PERFORM INVK-AZI
                               GO TO ERRIO.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE AZRGSOC TO IF-AZI-D.
           MOVE ZERO TO IF-COD-1
                        IF-COD-2
                        IF-TNU-1
                        IF-TNU-2
                        IF-TPELA.
      **** rel 5.0
           MOVE ZERO TO IF-DATA-1
                        IF-DATA-2
                        DATA1
                        DATA2.
      ************
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-COD-2.
           MOVE 'IF-COD-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-COD-2.
           IF IF-COD-2 < IF-COD-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-COD-2.
      *
       V-TNU-2.
           MOVE 'IF-TNU-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TNU-2.
           IF IF-TNU-2 < IF-TNU-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-TNU-2.
      *
      **** rel 5.0
       V-DATA-1.
           MOVE 'IF-DATA-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA-1.
           IF IF-DATA-1 = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA-1 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO DATA1.
       E-DATA-1.
      *
       V-DATA-2.
           MOVE 'IF-DATA-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA-2.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA-2 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO DATA2.
           IF DATA2 < DATA1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-DATA-2.
      *
      ************
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
      *  TESTATE  *
           MOVE ZERO     TO KBC-BOL.
           MOVE KAZ-COD  TO KBC-AZI.
           MOVE IF-TNU-1 TO KBC-NUM.
       L050.
           MOVE IF-COD-1 TO KBC-BOL.
       L060.
           START BOLCTE KEY NOT < KEYBC INVALID GO TO L070.
       LETTURA.
           READ BOLCTE NEXT AT END GO TO L070.
           IF SF-BCT = '9D' OR '9A' OR '35' GO TO LETTURA.
           IF KBC-AZI > KAZ-COD  GO TO L070.
           IF KBC-NUM > IF-TNU-2 GO TO L070.
           IF KBC-BOL < IF-COD-1 GO TO L050.
           IF KBC-BOL > IF-COD-2
              IF KBC-NUM = 9 GO TO L070
              ELSE ADD 1 TO KBC-NUM GO TO L050.
      **** rel 5.0
           IF BCT-DATA < DATA1 OR > DATA2 GO TO LETTURA.
      ************
           IF IF-TPELA = 1 GO TO DELBOL.
           IF BCT-FLGFT NOT = 1 ADD 1 TO KBC-BOL GO TO L060.
           IF BCT-FLGMG = ZERO  ADD 1 TO KBC-BOL GO TO L060.
       DELBOL.
      *  RIGHI  *
           MOVE KAZ-COD TO KCR-AZI.
           MOVE KBC-NUM TO KCR-NUM.
           MOVE KBC-BOL TO KCR-BOL.
           MOVE 1       TO KCR-PGR.
           START BOLCRI KEY NOT < KEYCR INVALID GO TO DLTES.
       LETT01.
           READ BOLCRI NEXT AT END GO TO DLTES.
           IF SF-BCR = '9D' OR '9A' OR '35' GO TO LETT01.
           IF KCR-AZI NOT = KBC-AZI GO TO DLTES.
           IF KCR-NUM NOT = KBC-NUM GO TO DLTES.
           IF KCR-BOL NOT = KBC-BOL GO TO DLTES.
           IF KCR-PGR = ZERO        GO TO DLTES.
           MOVE KCR-AZI TO KBO-AZI.
           MOVE BCT-DATA TO AAGGG.
           MOVE 2 TO TIPOP1
           CALL 'rdata' USING PARCDT.
           MOVE AA4 TO KBO-ANNO.
           MOVE KCR-NUM TO KBO-NUM.
           MOVE KCR-BOL TO KBO-BOL.
           MOVE KCR-PGR TO KBO-PRB.
           MOVE 1       TO KBO-PRG.
           READ BOLORD INVALID GO TO DLRIG.
           IF OBC-FORD  = 1 GO TO DLORD.
           MOVE 1 TO OBC-FBOL.
      *** rel 5.2
           MOVE BCT-DATA TO OBC-DATA.
      ***********
           REWRITE RF-OBC INVALID PERFORM INVK-OBC GO TO ERRIO.
      **** rel 5.0
           MOVE ZERO TO PARBC.
           MOVE 1 TO BC-FUNZ.
           CALL 'vrcbpc' USING KEYBO PARBC.
      ************
           GO TO DLRIG.
       DLORD.
      **** rel 5.0
           MOVE ZERO TO PARBC.
           MOVE 2 TO BC-FUNZ.
           CALL 'vrcbpc' USING KEYBO PARBC.
      ************
           DELETE BOLORD INVALID PERFORM INVK-OBC GO TO ERRIO.
       DLRIG.
      **** rel 2.0
           PERFORM DEL-PROBCR THRU EX-DEL-PROBCR.
           PERFORM DL-NOTE    THRU EX-DL-NOTE.
      ************
           DELETE BOLCRI INVALID KEY
                  PERFORM INVK-BCR GO TO ERRIO.
           GO TO LETT01.
       DLTES.
           DELETE BOLCTE INVALID KEY
                  PERFORM INVK-BCT GO TO ERRIO.
      **** rel 7.1
           MOVE KBC-AZI TO KACT-AZI.
           MOVE KBC-NUM TO KACT-NUM.
           MOVE KBC-BOL TO KACT-BOL.
           DELETE APPBCT.
      ************
      **** rel 5.1
           MOVE 'c'      TO DAG-FUN.
           MOVE KBC-AZI  TO DAG-AZI.
           IF KBC-NUM < 7 AND NOT (BCT-TDOC = 8 OR 9)
              MOVE 'BOL' TO DAG-TIP
           ELSE 
              MOVE 'FAT' TO DAG-TIP.
           MOVE KEYBC    TO DAG-KFD.
           MOVE BCT-CATT TO DAG-KFD(10:1).
           CALL 'rdalg' USING PARDAG.
      ************
      *** rel 5.0
           MOVE KBC-AZI TO D-MDT-AZI
           MOVE 1       TO D-MDT-TDOC
           MOVE KEYBC   TO D-MDT-KEY
           CALL 'vrdlmdt' USING PAR-D-MDT.
      ***********
           GO TO LETTURA.
       L070.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
      **** rel 2.0
       DEL-PROBCR.
           MOVE KCR-AZI TO KPBR-AZI.
           MOVE KCR-NUM TO KPBR-TNUM.
           MOVE KCR-BOL TO KPBR-NBOL.
           MOVE KCR-PGR TO KPBR-RBOL.
           MOVE ZERO    TO KPBR-PGR.
           START PROBCR KEY NOT < KEYPBR INVALID GO TO EX-DEL-PROBCR.
       RDPBR.
           READ PROBCR NEXT AT END GO TO EX-DEL-PROBCR.
           IF SF-PBR = '9D' OR '9A' OR '35' GO TO RDPBR.
           IF KPBR-AZI  NOT = KCR-AZI OR
              KPBR-TNUM NOT = KCR-NUM OR
              KPBR-NBOL NOT = KCR-BOL OR
              KPBR-RBOL NOT = KCR-PGR GO TO EX-DEL-PROBCR.

           DELETE PROBCR INVALID PERFORM INVK-PBR
                                 GO TO ERRIO.
           GO TO RDPBR.
       EX-DEL-PROBCR.
           EXIT.
      *------------------
      * cancellazione note aggiuntive rigo bolla cliente
       DL-NOTE.
           MOVE KCR-AZI TO KNCR-AZI.
           MOVE KCR-NUM TO KNCR-NUM.
           MOVE KCR-BOL TO KNCR-BOL.
           MOVE KCR-PGR TO KNCR-PGR.
           MOVE ZERO    TO KNCR-PGRN.
      *
           START NOTBCR KEY >= KEYNCR INVALID GO TO EX-DL-NOTE.
       DL-NOTE-10.
           READ NOTBCR NEXT AT END GO TO EX-DL-NOTE.
           IF KNCR-AZI > KCR-AZI GO TO EX-DL-NOTE.
           IF KNCR-NUM > KCR-NUM GO TO EX-DL-NOTE.
           IF KNCR-BOL > KCR-BOL GO TO EX-DL-NOTE.
           IF KNCR-PGR > KCR-PGR GO TO EX-DL-NOTE.
           DELETE NOTBCR INVALID PERFORM INVK-NCR
                                 GO TO V-ERROR.
           GO TO DL-NOTE-10.
       EX-DL-NOTE.
           EXIT.
      *------------------
      ************
