#
# Bolle clienti
#
# Programma: exp620
#
DSC  bolcli
FLD  D-BLT-AZI       3.0   NU  S  # Codice azienda
FLD  D-BLT-AZI-D     36   AN   S  # Ragione sociale azienda
FLD  D-BLT-NUM       1.0   NU  S  # Tipo numerazione bolla (1/9)
FLD  D-BLT-BOL       5.0   NU  S  # Numero bolla
FLD  D-BLT-DATA      8     AN  S  # Data bolla
FLD  D-BLT-CLI       5.0   NU  S  # Codice cliente
FLD  D-BLT-CLI-D     36    AN  S  # Ragione sociale cliente
FLD  D-BLT-CLI-D2    36    AN  S  # Ragione sociale cliente
FLD  D-BLT-TDOC      1.0   NU  S  # Tipo documento (1/2/3/4/5/6/7)
#                                 # Documenti da fatturare
#                                 # 1 = fattura normale/in sospeso
#                                 # 2 = fattura estero
#                                 # 3 = nota di accredito/in sospeso
#                                 # Documenti da non fatturare
#                                 # 4 = bolla clienti con passaggio depositi
#                                 # 5 = bolla clienti normale
#                                 # 6 = bolla fornit. con passaggio depositi
#                                 # 7 = bolla fornitori normale
FLD  D-BLT-TDOC-D    35    AN  S  # Descizione tipo documento
FLD  D-BLT-FLGFT     1.0   NU  S  # Flag fatturato (0/1)
#                                 # 0=da fatturare  1=fatturata
FLD  D-BLT-FLGFT-D   20    NU  S  # Descrizione flag fatturato
FLD  D-BLT-FLGMG     1.0   NU  S  # Flag aggiornamento magazzino (0/>0)
#                                 # 0=da aggiornare  >0=aggiornata
FLD  D-BLT-RAGGR     1.0   NU  S  # Flag raggruppamento (0/1)
#                                 # 0=da non raggruppare  1=da raggruppare
FLD  D-BLT-RAGGR-D   20    AN  S  # Descrizione Flag raggruppamento
FLD  D-BLT-CDEP      3.0   NU  S  # Codice deposito
FLD  D-BLT-CDEP-D    24    AN  S  # Descrizione deposito
FLD  D-BLT-CSPE      3.0   NU  S  # Codice spedizione
FLD  D-BLT-CPOR      3.0   NU  S  # Codice porto
FLD  D-BLT-CPAG      3.0   NU  S  # Codice pagamento
FLD  D-BLT-CPAG-D    24    AN  S  # Descrizione pagamento
FLD  D-BLT-TPAG      1.0   NU  S  # Tipo pagamento
FLD  D-BLT-TPAG-D    24    AN  S  # Descrizione tipo pagamento
FLD  D-BLT-SCBAS     5.2   NU  S  # Percentuale sconto base
FLD  D-BLT-CBAN      5.0   NU  S  # Codice banca
FLD  D-BLT-CBAN-D    36    AN  S  # Descrizione banca
FLD  D-BLT-ABI       5     AN  S  # ABI
FLD  D-BLT-CAB       8     AN  S  # CAB
FLD  D-BLT-IPA       6     AN  S  # Codice IPA
FLD  D-BLT-CIG       10    AN  S  # Codice CIG
FLD  D-BLT-CUP       15    AN  S  # Codice CUP
FLD  D-BLT-TIPO      20    AN  S  # Tipo fattura
FLD  D-BLT-ESIVA     3.0   NU  S  # Codice esenzione I.V.A.
FLD  D-BLT-ESIVA-D   24    AN  S  # Descrizione esenzione I.V.A.
FLD  D-BLT-VALUT     3.0   NU  S  # Codice valuta
FLD  D-BLT-VALUT-D   24    AN  S  # Descrizione valuta
FLD  D-BLT-CAMGG    12.6   NU  S  # Cambio di fatturazione
FLD  D-BLT-DSORD     10    AN  S  # Riferimento interno ordine
FLD  D-BLT-DSFAT     30    AN  S  # Note
FLD  D-BLT-ZONA      3     AN  S  # Codice zona
FLD  D-BLT-ZONA-D    24    AN  S  # Descrizione zona
FLD  D-BLT-SCIMP     7.0   NU  S  # Non gestito
FLD  D-BLT-CAGE      3.0   NU  S  # Codice agente
FLD  D-BLT-CAGE-D    24    AN  S  # Descrizione agente
FLD  D-BLT-PROVV     5.2   NU  S  # Percentuale povvigione testata
FLD  D-BLT-CAUS      3.0   NU  S  # Codice causale di scarico
FLD  D-BLT-CAUS-D    24    AN  S  # Descrizione causale di scarico
FLD  D-BLT-CDEP2     2.0   NU  S  # Codice secondo deposito
FLD  D-BLT-CDEP2-D   24    AN  S  # Descrizione secondo deposito
FLD  D-BLT-CAUC      3.0   NU  S  # Codice causale di carico per 2o deposito
FLD  D-BLT-CAUC-D    24    AN  S  # Descrizione causale di carico
FLD  D-BLT-CATT      1     AN  S  # Codice attivita'
FLD  D-BLT-CATT-D    24    AN  S  # Descrizione attivit
FLD  D-BLT-FLGIS     1.0   NU  S  # Flag fatture in sospeso (0/1)
#                                 # 0=non in sospeso  1=in sospeso
FLD  D-BLT-FLGIS-D   24    AN  S  # Descrizione flag fatture in sospeso
FLD  D-BLT-ACCON    15.2   NU  S  # Importo acconto versato 
#                                 # N.B.: ripetuto per ogni rigo ma valido
#                                 #       per l'intero documento
FLD  D-BLT-FLACC     1.0   NU  S  # Test acconti (0/1)
#                                 # 0 = da non contabilizzare
#                                 # 1 = da contabilizzare
FLD  D-BLT-NUDOC     1.0   NU  S  # Tipo documento della relativa fattura
FLD  D-BLT-NUFAT     5.0   NU  S  # Nr.della fattura relativa
FLD  D-BLT-TMODU     1.0   NU  S  # Tipo modulo (0/1)
#                                 # 0 = modulo normale
#                                 # 1 = modulo XABD
FLD  D-BLT-LISRF     3.0   NU  S  # Codice listino
FLD  D-BLT-LISRF-D   24    AN  S  # Descrizione listino
FLD  D-BLT-GGESC     2.0   NU  S  # Giorni esclusione mesi scadenze (ago./dic.)
FLD  D-BLT-DESPOR    24    AN  S  # Descrizione porto
FLD  D-BLT-DESSPE    24    AN  S  # Descrizione spedizione
FLD  D-BLT-LCONS     2.0   NU  S  # Codice destinatario diverso
FLD  D-BLT-DRAG      36    AN  S  # Rag.sociale destinatario diverso 
FLD  D-BLT-DRAG2     36    AN  S  # Seconda rag.sociale destinatario diverso 
FLD  D-BLT-DIND      24    AN  S  # Indirizzo destinatario diverso 
FLD  D-BLT-DIND2     24    AN  S  # Secondo indirizzo destinatario diverso 
FLD  D-BLT-DCAP      5.0   NU  S  # CAP         destinatario diverso 
FLD  D-BLT-DCIT      26    AN  S  # Citta`      destinatario diverso 
FLD  D-BLT-VCOD1     3.0   NU  S  # Codice      1. vettore
FLD  D-BLT-VRAG1     24    AN  S  # Rag.sociale 1. vettore
FLD  D-BLT-VIND1     30    AN  S  # Indirizzo   1. vettore
FLD  D-BLT-VCOD2     3.0   NU  S  # Codice      2. vettore (non gestito)
FLD  D-BLT-VRAG2     24    AN  S  # Rag.sociale 2. vettore (non gestito)
FLD  D-BLT-VIND2     30    AN  S  # Indirizzo   2. vettore (non gestito)
FLD  D-BLT-DEST      40    AN  S  # Luogo di destinazione 
FLD  D-BLT-ASPE      24    AN  S  # Aspetto esteriore dei beni 
FLD  D-BLT-NCOL      16    AN  S  # Numero colli
FLD  D-BLT-PLOR      8.2   NU  S  # Peso lordo
FLD  D-BLT-PNET      8.2   NU  S  # Peso netto
FLD  D-BLT-CAUT      24    AN  S  # Causale del trasporto
FLD  D-BLT-DTRA      8     AN  S  # Data inizio trasporto
FLD  D-BLT-OTRA      4.0   NU  S  # Ora inizio trasporto (hhmm) 
FLD  D-BLT-NOT1      24    AN  S  # 1. campo note
FLD  D-BLT-NOT2      24    AN  S  # 2. campo note
FLD  D-BLT-NOT3      24    AN  S  # 3. campo note
FLD  D-BLT-NOT4      24    AN  S  # 4. campo note
FLD  D-BLT-NOT5      24    AN  S  # 5. campo note
FLD  D-BLT-FLGXAB    1.0   NU  S  # Flag dati XAB provvisori/definitivi
#                                 # 0 = dati provvisori
#                                 # 1 = dati definitivi
FLD  D-BLT-PGR       3.0   NU  S  # Progressivo rigo
FLD  D-BLT-ART       18    AN  S  # Codice articolo (solo per righi 0/2/4/5/6)
FLD  D-BLT-GMERC     2.0   NU  S  # Gruppo merceologico
FLD  D-BLT-GMERC-D   24    AN  S  # Descrizione gruppo merceologico
FLD  D-BLT-GSTAT     2.0   NU  S  # Gruppo statistico
FLD  D-BLT-GSTAT-D   24    AN  S  # Descrizione gruppo statistico
FLD  D-BLT-TPART     1.0   NU  S  # Tipo articolo
#                                 # Esempio: 1=Prodotto finito
#                                 #          2=Semilavorato
#                                 #          3=Materia prima
FLD  D-BLT-TPART-D   24    AN  S  # Descrizione Tipo articolo
FLD  D-BLT-NORD      5.0   NU  S  # Numero ordine
FLD  D-BLT-PRORD     3.0   NU  S  # Numero progressivo ordine
FLD  D-BLT-TCOR      1.0   NU  S  # Tipo rigo (0/1/2/3/4/5/6)
#                                 # 0 = articolo
#                                 # 1 = descrittivo  
#                                 # 2 = occasionale  
#                                 # 3 = addeb./accred.
#                                 # 4 = omaggi
#                                 # 5 = sconto in merce
#                                 # 6 = merce in garanzia
FLD  D-BLT-TCOR-D    24    AN  S  # Descrizione Tipo rigo
FLD  D-BLT-SPESA     3.0   NU  S  # Codice spesa
FLD  D-BLT-DESCR     30    AN  S  # Descrizione rigo
FLD  D-BLT-UM        2     AN  S  # Unita' di misura
FLD  D-BLT-IVA       3.0   NU  S  # Codice I.V.A.
FLD  D-BLT-IVA-D     24    AN  S  # Descrizione I.V.A.
FLD  D-BLT-QTA       13.2  NS  S  # Quantita'
FLD  D-BLT-PZLOR     19.6  NS  S  # Prezzo lordo
FLD  D-BLT-PZLFSC    16.3  NS  S  # Prezzo lordo secondo fattore di scala
FLD  D-BLT-SC1       6.2   NS  S  # Percentuale 1o sconto
FLD  D-BLT-SC2       6.2   NS  S  # Percentuale 2o sconto
FLD  D-BLT-PZNET     19.6  NS  S  # Prezzo netto
FLD  D-BLT-PZNFSC    16.3  NS  S  # Prezzo netto secondo fattore di scala
FLD  D-BLT-NETRG     15.2  NS  S  # Netto rigo
FLD  D-BLT-RIVGR     3.0   NU  S  # Codice IVA cessioni in garanzia e sconti
FLD  D-BLT-FSC       1.0   NU  S  # Fattore di scala    
#                                 # in merce
FLD  D-BLT-RPROVV    5.2   NU  S  # Percentuale provvigioni di rigo
FLD  D-BLT-PERSPE    5.2   NU  S  # Percentuale voce di spesa
FLD  D-BLT-RIVAL     1.0   NU  S  # Test rivalsa I.V.A. (0=si 1=no)
FLD  D-BLT-IPROV    19.6   NU  S  # Importo provvigioni
FLD  D-BLT-CONTR     7.0   NU  S  # Codice contropartita ricavi contabilita'
FLD  D-BLT-CONTR-D   36    AN  S  # Descrizione contropartita
FLD  D-BLT-NMOV      5.0   NU  S  # Numero movimento di magazzino
FLD  D-BLT-DTORD     8     AN  S  # Data ordine
FLD  D-BLT-IMB       1.0   NU  S  # Flag Addebito imballi 0=no  1=si
FLD  D-BLT-ESCFAT    1.0   NU  S  # Flag Esclusione calcolo fatture 0=no  1=si
FLD  D-BLT-STAMP     1.0   NU  S  # Flag Bolla stampata 0=no  1=si
FLD  D-BLT-TAPPO     1     AN  S  # Carattere di fine record
