       IDENTIFICATION DIVISION.
       PROGRAM-ID. VFATWRD.
      *
      * Stampa fatture con MS-Word
      *
      * Versione per pubblicazione documenti
      *
      **** rel 5.1
      * nuovo: sostituisce VFAT210W.CBL
      ************
      **** rel 6.1
      * spostata scrittura file D- nella routine VRWORD
      ************
      **** rel 6.2
      * ricompilato per copy parwd modificata
      * ricompilato per copy grincr
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griclfsl'.
           COPY 'gribansl'.
      **** rel 6.2
           COPY 'griabasl'.
      ************
           COPY 'gribctsl'.
           COPY 'gribcrsl'.
           COPY 'grifatsl'.
           COPY 'grilinsl'.
           COPY 'gritabsl'.
           COPY 'grintasl'.
           COPY 'griaimsl'.
           COPY 'griwsisl'.
           COPY 'grincrsl'.
           COPY 'gripbrsl'.
      **** rel 6.2
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLAV STATUS SF-LAV.
      ************
      **** rel 6.3
           COPY 'griirisl'.
      ************
      **** rel 7.1
           COPY 'griacfsl'.
           COPY 'griaftsl'.
      **********
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'griclf'.
           COPY 'griban'.
      **** rel 6.2
           COPY 'griaba'.
      ************
           COPY 'gribct'.
           COPY 'gribcr'.
           COPY 'grifat'.
           COPY 'grilin'.
           COPY 'gritab'.
           COPY 'grinta'.
           COPY 'griaim'.
           COPY 'griwsi'.
           COPY 'grincr'.
           COPY 'gripbr'.
      **** rel 7.1
           COPY 'griacf'.
           COPY 'griaft'.
      **********
      **** rel 6.2
        FD  WDSLAV LABEL RECORD STANDARD
            VALUE OF FILE-ID ID-LAV
            RECORD 2005 DATA RECORD RF-LAV.
        01  RF-LAV.
            02 KEYLAV.
               05 KLAV-CONTA PIC 9(5).
            02 LAV-PARFAT  PIC X(1000).
            02 LAV-PARRB   PIC X(1000).
      ************
      **** rel 6.3
           COPY 'griiri'.
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'gritabrk'.
           COPY 'grit28rk'.
           COPY 'griclfrk'.
           COPY 'griazirk'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parer'.
           COPY 'parrb'.
           COPY 'parcf'.
           COPY 'parfat'.
           COPY 'parwo'.
           COPY 'parop'.
           COPY 'parpcfa'.
           COPY 'paracf'.
      **** rel 6.2
           COPY 'pariban'.
      ************
       01  ID-ARL PIC X(15) VALUE 'artlin'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-BAN PIC X(15) VALUE 'anaban'.
      **** rel 6.2
       01  ID-ABA PIC X(15) VALUE 'appban'.
      ************
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-NTA PIC X(15) VALUE 'nottab'.
       01  ID-AIM PIC X(15) VALUE 'anaimb'.
       01  ID-WSI PIC X(15).
       01  ID-BCT PIC X(15) VALUE 'bolcte'.
       01  ID-BCR PIC X(15) VALUE 'bolcri'.
       01  ID-NCR PIC X(15) VALUE 'notbcr'.
       01  ID-PBR PIC X(15) VALUE 'probcr'.
      **** rel 7.1
       01  ID-ACF PIC X(15) VALUE 'appclf'.
       01  ID-AFT PIC X(15) VALUE 'appfat'.
      **********
       01  ID-FAT.
           05 FILLER PIC X(6) VALUE 'fattur'.
           05 FATTIV PIC X    VALUE SPACE.
           05 FILLER PIC X(8) VALUE SPACE.
      **** rel 6.2
       01  ID-LAV PIC X(15).
      ************
      **** rel 6.3
       01  ID-IRI PIC X(15) VALUE 'indiri'.
      ************
      *
       01  COMODI.
           05 SF-ARL  PIC XX.
           05 SF-AZI  PIC XX.
           05 SF-CLF  PIC XX.
           05 SF-BAN  PIC XX.
      **** rel 6.2
           05 SF-ABA  PIC XX.
      ************
           05 SF-TAB  PIC XX.
           05 SF-NTA  PIC XX.
           05 SF-AIM  PIC XX.
           05 SF-WSI  PIC XX.
           05 SF-BCT  PIC XX.
           05 SF-BCR  PIC XX.
           05 SF-FAT  PIC XX.
           05 SF-NCR  PIC XX.
           05 SF-PBR  PIC XX.
      **** rel 7.1
           05 SF-ACF  PIC XX.
           05 SF-AFT  PIC XX.
      **********

      **** rel 6.2
           05 SF-LAV  PIC XX.
      ************
      **** rel 6.3
           05 SF-IRI  PIC XX.
      ************
           05 MESS       PIC X(40) VALUE SPACE.
           05 FSC        PIC 9.
           05 NPAG       PIC 9(3)      VALUE ZERO.
           05 FLGTES     PIC 9     VALUE ZERO.
           05 NFAT       PIC 9(5)  VALUE ZERO.
           05 K        PIC 9(4)      VALUE ZERO.
           05 VISTA    PIC 9         VALUE ZERO.
           05 VNTMER   PIC S9(11)V99 VALUE ZERO.
           05 VSCFIN   PIC S9(11)V99 VALUE ZERO.
           05 TOTACC   PIC S9(11)V99 VALUE ZERO.
           05 SCONTO   PIC 999V99    VALUE ZERO.
           05 VALUT    PIC 999       VALUE ZERO.
           05 DSVAL    PIC X(4)      VALUE SPACE.
           05 IMPON    PIC S9(11)V99 VALUE ZERO.
           05 IMPOS    PIC S9(11)V99 VALUE ZERO.
           05 IMPRIT   PIC S9(11)V99 VALUE ZERO.
           05 SC       PIC S99V99    VALUE ZERO.
           05 COMSC0D  PIC S99       VALUE ZERO.
           05 COMSC1D  PIC S99V9     VALUE ZERO.
           05 CIFRA    PIC 9         VALUE ZERO.
           05 GARANZ   PIC S9(11)V99 VALUE ZERO.
           05 NOSCON   PIC S9(11)V99 VALUE ZERO.
           05 NN       PIC 99.
           05 ESTPIVA  PIC 9.
           05 INDICE   PIC 999.
           05 ULTIND   PIC 999.
           05 IMPIMB   PIC 9(11)V99.
           05 PREPAL   PIC 9(5).
           05 PRECOL   PIC 9(5).
           05 PREIMB   PIC X(12).
           05 COMNIMB  PIC 9(3).
           05 VETIMB   PIC X(12) OCCURS 30.
           05 VETQTA   PIC 9(5)  OCCURS 30.
           05 TNUM-PF  PIC 9.
           05 JJ       PIC 999.
           05 COMEURO  PIC 9(3).
           05 RITE      PIC S9(11)V99 VALUE ZERO.
           05 NETAP     PIC S9(11)V99 VALUE ZERO.
           05 IMPO      PIC S9(11)V99 VALUE ZERO.
           05 COM-ALIVA PIC 9(3)V99   VALUE ZERO.
           05 KN       PIC 9(4)  VALUE ZERO.
      **** rel 7.1
           05 SAVKNTA.
              10 SAVK-TIP PIC 99.
              10 SAVK-COD PIC 999.
              10 SAVK-PRG PIC 999.
      ************
           05 VTMEX.
              10 FILLER PIC X(9) VALUE ' GENNAIO'.
              10 FILLER PIC X(9) VALUE 'FEBBRAIO'.
              10 FILLER PIC X(9) VALUE '  MARZO '.
              10 FILLER PIC X(9) VALUE ' APRILE'.
              10 FILLER PIC X(9) VALUE ' MAGGIO'.
              10 FILLER PIC X(9) VALUE ' GIUGNO'.
              10 FILLER PIC X(9) VALUE ' LUGLIO'.
              10 FILLER PIC X(9) VALUE ' AGOSTO'.
              10 FILLER PIC X(9) VALUE 'SETTEMBRE'.
              10 FILLER PIC X(9) VALUE 'OTTOBRE'.
              10 FILLER PIC X(9) VALUE 'NOVEMBRE'.
              10 FILLER PIC X(9) VALUE 'DICEMBRE'.
           05 VTMES REDEFINES VTMEX PIC X(9) OCCURS 12.
           05 FLGMCL   PIC 9 VALUE ZERO.
           05 J        PIC 99 VALUE ZERO.
      **** rel 6.2
           05 SWSIM    PIC 9.
           05 COMTPAG  PIC 9 VALUE ZERO.
      ************

       01  CODICE.
           05 MAS      PIC 99    VALUE ZERO.
           05 COD      PIC 9(5)  VALUE ZERO.

       01  WK-TESTA.
           05 WK-DATA  PIC 9(5) COMP-3.
           05 WK-CSPE  PIC 999.
           05 WK-CPOR  PIC 999.
           05 WK-DSORD PIC X(10).
           05 WK-DSFAT PIC X(30).
           05 WK-SCBAS PIC S99V99.

       01  KBOL.
           05 BOAZ PIC 999  VALUE ZERO.
           05 BONU PIC 9    VALUE ZERO.
           05 BOBO PIC 9(5) VALUE ZERO.

       01  PAR-P-MDT.
           05 P-MDT-AZI   PIC 999.
           05 P-MDT-TDOC  PIC 9.
           05 P-MDT-KEY   PIC X(15).
           05 P-MDT-FLGS  PIC 9.
           05 P-MDT-DATA  PIC 9(5).
           05 P-MDT-NCOL  PIC 99.
           05 P-MDT-TESTO PIC X(76).
           05 P-MDT-FLGE  PIC 9.

           COPY 'vfatwrd.cpy'.
       LINKAGE SECTION.
           COPY 'parwfat'.
       PROCEDURE DIVISION USING PARWFAT PARCCD.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclclf'.
           COPY 'dclban'.
      **** rel 6.2
           COPY 'dclaba'.
      ************
           COPY 'dclbct'.
           COPY 'dclbcr'.
           COPY 'dclfat'.
           COPY 'dcllin'.
           COPY 'dcltab'.
           COPY 'dclnta'.
           COPY 'dclaim'.
           COPY 'dclwsi'.
           COPY 'dclncr'.
           COPY 'dclpbr'.
      **** rel 6.3
           COPY 'dcliri'.
      ************
      **** rel 7.1
           COPY 'dclaft'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
      *
           MOVE ZERO TO PCCD-ERR.

      * Inizializza
           IF PCCD-FUN = 'T' OR 'I'
              PERFORM PGM-INI THRU EX-PGM-INI.

      * Esegue
           IF PCCD-FUN = 'T' OR 'R'
              PERFORM PGM-RUN THRU EX-PGM-RUN.

      * Chiude
           IF PCCD-FUN = 'T' OR 'E'
              PERFORM PGM-END THRU EX-PGM-END
              GO TO CHIUDI.

           GO TO FINE.
       ERRIO.
           COPY 'errsub'.
           MOVE 9 TO PCCD-ERR.
           PERFORM WRD-CL.
       CHIUDI.
           CLOSE FATTUR.
           CLOSE ANAAZI.
           CLOSE ANACLF.
           CLOSE ANABAN.
      **** rel 6.2
           CLOSE APPBAN.
      ************
           CLOSE TABELL.
           CLOSE NOTTAB.
           CLOSE BOLCTE.
           CLOSE BOLCRI.
           CLOSE ARTLIN.
           CLOSE NOTBCR.
           CLOSE PROBCR.
           CLOSE ANAIMB.
      **** rel 7.1
           CLOSE APPCLF.
           CLOSE APPFAT.
      **********
           CLOSE WDSSIB.
           OPEN OUTPUT WDSSIB.
           CLOSE WDSSIB.
      **** rel 6.2
           CLOSE WDSLAV.
      ************
      **** rel 6.3
           CLOSE INDIRI.
      ************
       FINE.
           EXIT PROGRAM.
      *-------------------*
           COPY 'griwrd'.
      *-------------------*
           COPY 'errmes'.
           COPY 'erreur'.
           COPY 'griazier'.
           COPY 'griclfer'.
           COPY 'gribaner'.
      **** rel 6.2
           COPY 'griabaer'.
      ************
           COPY 'gribcter'.
           COPY 'gribcrer'.
           COPY 'grifater'.
           COPY 'griliner'.
           COPY 'gritaber'.
           COPY 'grintaer'.
           COPY 'griaimer'.
           COPY 'grincrer'.
           COPY 'gripbrer'.
      **** rel 6.3
           COPY 'griirier'.
      ************
      **** rel 7.1
           COPY 'griacfer'.
           COPY 'griafter'.
      **********
           COPY 'grixxxer'.
      *------------------------------------------*
       PGM-END.
           PERFORM WRD-END.
       EX-PGM-END.
           EXIT.
      *------------------------------------------*
       PGM-INI.
      *
           MOVE PWFAT-CATT TO FATTIV.
           IF FATTIV = '0' MOVE SPACE TO FATTIV.

           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           OPEN OUTPUT WDSSIB.
           CLOSE WDSSIB.
           OPEN I-O WDSSIB.

           OPEN INPUT ANACLF ANAAZI ANABAN TABELL
                      NOTBCR PROBCR BOLCTE BOLCRI
                      ANAIMB FATTUR ARTLIN.
           OPEN INPUT NOTTAB.
      **** rel 6.2
           OPEN INPUT APPBAN.
      ************
      **** rel 6.3
           OPEN INPUT INDIRI.
      ************
      **** rel 7.1
           OPEN INPUT APPCLF.
           OPEN INPUT APPFAT.
      **********
      *
           MOVE 1 TO KTB-COD KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MCLI TO MAS.
      *
           MOVE PWFAT-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.

           MOVE 28     TO T28-TIP.
           MOVE PWFAT-AZI TO T28-COD.
           MOVE 'E'    TO T28-PRG.
           MOVE T28-KEYID TO KEYTB.
           READ TABELL INTO REKT28 INVALID MOVE ZERO TO T28-NUMPF.
           MOVE T28-NUMPF TO TNUM-PF.
      *
           CALL 'rveur' USING COMEURO.
      *
           MOVE 'I'      TO WO-FUN.
           MOVE 'fattur' TO WO-IDDOC.
           MOVE PWFAT-AZI TO WO-AZI.
           MOVE PWFAT-CATT TO WO-ATT.
           PERFORM WRD-INI.
      *
       EX-PGM-INI.
           EXIT.
      *------------------------------------------*
       PGM-RUN.
      *

      **** rel 6.2     
           MOVE ZERO TO SWSIM.
           OPEN INPUT WDSLAV.
           READ WDSLAV NEXT.
           IF SF-LAV = ZERO MOVE 1 TO SWSIM.
           IF SWSIM = 1
              MOVE PWFAT-NFAT TO KLAV-CONTA
              READ WDSLAV INVALID MOVE 'READ WDSLAV' TO MESS
                                  GO TO ERRIO
              END-READ
              MOVE LAV-PARFAT TO RF-FAT
              MOVE LAV-PARRB  TO PARRB
              GO TO OK-PROFORMA.
      ************
           IF NOT (PWFAT-TDOC = 8 OR 9) GO TO NO-PROFORMA.

      * fattura proforma
           MOVE PWFAT-AZI TO KBC-AZI.
           MOVE TNUM-PF   TO KBC-NUM.
           MOVE PWFAT-NFAT TO KBC-BOL.
           READ BOLCTE INVALID PERFORM INVK-BCT GO TO ERRIO.
           MOVE KBC-AZI     TO CF-AZI.
           MOVE BCT-GGESC   TO CF-GGESC.
           MOVE BCT-DATA    TO CF-DTFAT.
           MOVE PWFAT-CATT  TO CF-ATTIV.
           MOVE ZERO        TO CF-NUMFAT.
           MOVE 1           TO CF-SIMUL.
           MOVE ZERO        TO CF-VIDEO.
           MOVE 1 TO JJ.
           PERFORM UNTIL JJ > RB-MAXBOL
              MOVE ZERO TO RB-TNUM(JJ)
                           RB-NBOL(JJ)
              ADD 1 TO JJ
           END-PERFORM.
           MOVE KBC-NUM   TO RB-TNUM(1).
           MOVE KBC-BOL   TO RB-NBOL(1).
           MOVE 1         TO RB-ULTBOL.
           CALL 'vfat190' USING PARCF PARRB CFT-FAT.
           CANCEL 'vfat190'.
           IF ERRIO-ST = 9 GO TO ERRIO.
           IF CF-ST = 9
              MOVE 'ERRORE FAT. PROFORMA' TO MESS
              GO TO ERRIO.
           MOVE CFT-FAT TO RF-FAT.
           IF PWFAT-TDOC = 8
              MOVE 1 TO KFT-TDOC
           ELSE
              MOVE 2 TO KFT-TDOC.
           MOVE KBC-BOL TO KFT-NUM.
           GO TO OK-PROFORMA.

       NO-PROFORMA.
           MOVE ZERO TO KEYFT.
           MOVE PWFAT-AZI  TO KFT-AZI.
           MOVE PWFAT-TDOC TO KFT-TDOC.
           MOVE PWFAT-NFAT TO KFT-NUM.
           READ FATTUR INVALID GO TO NOFAT.

      *
           PERFORM DL-LAV-IMB THRU EX-DL-LAV-IMB.
      *
           CALL 'rdbfa' USING FAT-CATT KEYFT PARRB.

       OK-PROFORMA.
      *
           IF SAVPATH = SPACE AND PCCD-PATH NOT = SPACE
              MOVE FAT-DATA TO AAGGG
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE KFT-NUM TO NFAT
      **** rel 6.2
      *       STRING PCCD-PATH DELIMITED SPACE
      *              '\fat'
      *              KFT-AZI
      *              PWFAT-CATT
      *              KFT-TDOC
      *              AA9
      *              NFAT
      *              '.doc'
      *              DELIMITED SIZE INTO SAVPATH
              IF PWFAT-TDOC = 8 OR 9         *> proforma
                 STRING PCCD-PATH DELIMITED SPACE
                        '\fpf'
                        KFT-AZI
                        PWFAT-CATT
                        PWFAT-TDOC
                        AA9
                        NFAT
                        '.doc'
                        DELIMITED SIZE INTO SAVPATH
              ELSE                           *> fattura normale
                 STRING PCCD-PATH DELIMITED SPACE
                        '\fat'
                        KFT-AZI
                        PWFAT-CATT
                        KFT-TDOC
                        AA9
                        NFAT
                        '.doc'
                        DELIMITED SIZE INTO SAVPATH
              END-IF
      ************
              MOVE SAVPATH TO PCCD-PATH.

           MOVE ZERO TO NOSCON.
           MOVE ZERO TO ULTIND.
           IF NOT (FAT-VALUT = ZERO OR COMEURO)
              MOVE FAT-VALUT TO ER-VALUT
              CALL 'rvalut' USING ER-VALUT FAT-DATA CG-PAR
              IF CG-ST > ZERO PERFORM ERR-EURO
                              GO TO WARNING.
           PERFORM RDCL THRU EX-RDCL.
           MOVE ZERO TO ESTPIVA.
           IF FAT-CDESE  = ZERO GO TO NOCALL-10.
           IF CLF-ENUIVA = ZERO GO TO NOCALL-10.
           MOVE 3         TO KTB-TIP.
           MOVE FAT-CDESE TO KTB-COD.
           READ TABELL INTO REKTAB INVALID GO TO NOCALL-10.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T03-TPIVA TO ESTPIVA.
       NOCALL-10.
           MOVE ZERO TO KBOL VNTMER.
           MOVE ZERO TO GARANZ.
           MOVE KFT-AZI TO BOAZ.
           MOVE 1 TO K.
           PERFORM NEWBOL THRU EX-NEWBOL.
           MOVE FAT-CDBAN TO KBA-BAN.
           READ ANABAN INVALID KEY MOVE SPACE TO BAN-RGSOC
                                                 BAN-CODAZ
      **** rel 6.2
      *                                          BAN-CODSP
      *                                          BAN-CCOR 
      *                                          BAN-CINAZ.
                                                 BAN-CODSP.
      **** rel 6.3
      *    MOVE KEYBA TO KEYABA.
           MOVE KFT-AZI TO KABA-AZI.
           MOVE KBA-BAN TO KABA-BAN.
      ************
           READ APPBAN INVALID MOVE SPACE TO ABA-CIBAN.
      ************
           MOVE ZERO TO NPAG.
           MOVE BCT-DATA  TO WK-DATA.
           MOVE BCT-CSPE  TO WK-CSPE.
           MOVE BCT-CPOR  TO WK-CPOR.
           MOVE BCT-DSORD TO WK-DSORD.
           MOVE BCT-DSFAT TO WK-DSFAT.
           MOVE BCT-SCBAS TO WK-SCBAS.
      *
           PERFORM NWPG THRU EX-NWPG.
      *
           GO TO LSTR.
       NXTB.
           ADD 1 TO K.
           IF K > RB-ULTBOL GO TO LFIN.
           MOVE RB-TNUM(K) TO CIFRA.
           IF CIFRA = ZERO GO TO LFIN.
           PERFORM NEWBOL THRU EX-NEWBOL.
      * CAMBIO BOLLA *
       LSTR.
           IF KBC-NUM > 5 OR (BCT-TDOC = 8 OR 9) GO TO LP10.
           IF K > 1 ADD 2 TO INDR.
           IF INDR > MAXR
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM NWPG THRU EX-NWPG.
           MOVE '*'         TO PAST(INDR).
           MOVE 'D.D.T. N.' TO PCONF(INDR).
           MOVE KBC-NUM     TO PTNUM(INDR).
           MOVE '/'         TO PBARRA(INDR).
           MOVE KBC-BOL     TO PNCONF(INDR).
           MOVE 'DEL'       TO PDEL(INDR).
           MOVE BCT-DATA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO PDCONF(INDR).
           ADD 1 TO INDR.
       LP10.
           MOVE KBC-AZI TO KCR-AZI.
           MOVE KBC-NUM TO KCR-NUM.
           MOVE KBC-BOL TO KCR-BOL.
           MOVE ZERO    TO KCR-PGR.
           START BOLCRI KEY NOT < KEYCR INVALID GO TO END-TB.
       LART.
           READ BOLCRI NEXT AT END GO TO END-TB.
           IF SF-BCR = '9D' OR '9A' OR '35' GO TO LART.
           IF KCR-AZI > KBC-AZI GO TO END-TB.
           IF KCR-NUM > BONU GO TO END-TB.
           IF KCR-BOL > BOBO GO TO END-TB.
           IF BCR-TCOR = 1 AND BCR-FSC  = 2 GO TO LART.
           ADD 1 TO INDR.
           IF INDR > MAXR
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM NWPG THRU EX-NWPG.
           PERFORM B00-STAMPA-RIGO THRU B99.
           GO TO LART.
       END-TB.
           PERFORM H00-STAMPA-MESSAGG-BOLLA THRU H99.
           IF FLGTES = ZERO SUBTRACT 1 FROM INDR.
           GO TO NXTB.
       LFIN.
           PERFORM STAMPA-PIEDE THRU EX-STAMPA-PIEDE.
       NOFAT.

       EX-PGM-RUN.
           EXIT.
      *------------------------------------------*
      *-------------------------------
       SCR-REC.
           MOVE SPACE TO D-FLGS.
           IF PCCD-FLGS = 0
              MOVE 'S' TO D-FLGS.
           MOVE PCCD-PATH TO D-IDDOC.
      *
           PERFORM WRD-WR.
       EX-SCR-REC.
      *-------------------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-WSI.
           STRING 'w0' PID DELIMITED SPACE INTO ID-WSI.
      **** rel 6.2
           MOVE SPACE TO ID-LAV.
           STRING 'w3' PID DELIMITED SPACE INTO ID-LAV.
      ************
       EX-CREA-IDLAV.
           EXIT.
      *-------------------------------
       RDCL.
           MOVE FAT-CDCLI TO COD.
           MOVE KAZ-COD   TO KCF-AZI.
           MOVE CODICE    TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID KEY
                  PERFORM INVK-CLF
                  PERFORM VISK-FAT
                  GO TO WARNING.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
      **** rel 7.1
           MOVE KEYCF TO KEYACF.
           READ APPCLF INVALID MOVE SPACE TO ACF-NAZIO.
      **********
           MOVE KAZ-COD    TO RACF-AZI.
           MOVE CODICE     TO RACF-COD.
           CALL 'rrdacf' USING PARACF.
       EX-RDCL.
           EXIT.
      *-------------------------------
       NEWBOL.
           MOVE RB-NBOL(K) TO BOBO.
           MOVE RB-TNUM(K) TO BONU.
           MOVE KBOL TO KEYBC.
       L9D.
           READ BOLCTE INVALID
                  PERFORM INVK-BCT
                  PERFORM VISK-FAT
                  GO TO WARNING.
           IF SF-BCT = '9D' OR '9A' OR '35' GO TO L9D.
           MOVE BCT-VALUT TO VALUT.
           MOVE 10        TO KTB-TIP.
           MOVE BCT-VALUT TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE ZERO TO T10-FSC.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T10-FSC TO FSC.
       EX-NEWBOL.
           EXIT.
      *-------------------------------
       B00-STAMPA-RIGO.
           MOVE BCR-ART TO D-ART(INDR).
           MOVE BCR-DESCR TO D-ART-D(INDR).
           IF AZI-FLING = ZERO GO TO RIG10.
           IF CLF-FLING = ZERO GO TO RIG10.
           MOVE KAZ-COD   TO KAL-AZI.
           MOVE BCR-ART   TO KAL-ART.
           READ ARTLIN INVALID GO TO RIG10.
           IF CLF-FLING = 1
              IF ARL-DES1 = SPACE GO TO RIG10
              ELSE     MOVE ARL-DES1 TO D-ART-D(INDR).
           IF CLF-FLING = 2
              IF ARL-DES2 = SPACE GO TO RIG10
              ELSE     MOVE ARL-DES2 TO D-ART-D(INDR).
           IF CLF-FLING = 3
              IF ARL-DES3 = SPACE GO TO RIG10
              ELSE     MOVE ARL-DES3 TO D-ART-D(INDR).
       RIG10.
           IF BCR-TCOR = 1 GO TO B90.
           IF BCR-TCOR = 3 GO TO B75.
           MOVE BCR-UM  TO D-UM(INDR).
           MOVE BCR-QTA TO PQTA(INDR).
           IF BCR-TQUAN = 1 MOVE BCR-QTA TO PQTA1(INDR).
           IF BCR-TQUAN = 2 MOVE BCR-QTA TO PQTA2(INDR).
           IF BCR-TCOR = 6 GO TO B76.
           MOVE KCR-AZI     TO OP-AZI
           MOVE BCT-VALUT   TO OP-VALUT.
           MOVE BCR-PZLOR   TO OP-PREZZO.
           MOVE BCR-FSC     TO OP-FSC.
           CALL 'routprz' USING PAROP OP-VEN.
           MOVE OP-PREZZO   TO PPRZ(INDR).
           IF OP-NDEC = 2 MOVE OP-PREZZO TO PPRZ1(INDR).
           IF OP-NDEC = 3 MOVE OP-PREZZO TO PPRZ3(INDR).
           IF OP-NDEC = 4 MOVE OP-PREZZO TO PPRZ4(INDR).
           IF OP-NDEC = 5 MOVE OP-PREZZO TO PPRZ5(INDR).
           IF OP-NDEC = 6 MOVE OP-PREZZO TO PPRZ6(INDR).
           IF BCR-TCOR > 3 AND < 7 GO TO B76.
           MOVE BCR-SC1 TO SC.
           IF SC = ZERO MOVE BCR-SC2 TO SC
           ELSE IF BCR-SC2 NOT = ZERO
                MOVE SC TO COMSC0D COMSC1D
                IF SC = COMSC0D
                   MULTIPLY -1 BY SC GIVING PSCO(INDR)
                ELSE
                   IF SC = COMSC1D
                      MULTIPLY -1 BY SC GIVING PSCO1D(INDR)
                   ELSE
                      MULTIPLY -1 BY SC GIVING PSCO2D(INDR)
                   END-IF
                END-IF
                ADD 1 TO INDR
                IF INDR > MAXR
                   PERFORM SCR-REC THRU EX-SCR-REC
                   PERFORM NWPG THRU EX-NWPG
                END-IF
                MOVE BCR-SC2 TO SC.
           IF SC NOT = ZERO
              MOVE SC TO COMSC0D COMSC1D
              IF SC = COMSC0D
                 MULTIPLY -1 BY SC GIVING PSCO(INDR)
              ELSE
                 IF SC = COMSC1D
                    MULTIPLY -1 BY SC GIVING PSCO1D(INDR)
                 ELSE
                    MULTIPLY -1 BY SC GIVING PSCO2D(INDR).
           MOVE KCR-AZI     TO OP-AZI
           MOVE BCT-VALUT   TO OP-VALUT.
           MOVE BCR-PZNET   TO OP-PREZZO.
           MOVE BCR-FSC     TO OP-FSC.
           CALL 'routprz' USING PAROP OP-VEN.
           MOVE OP-PREZZO   TO PPNET(INDR).
           IF OP-NDEC = 2 MOVE OP-PREZZO TO PPNET1(INDR).
           IF OP-NDEC = 3 MOVE OP-PREZZO TO PPNET3(INDR).
           IF OP-NDEC = 4 MOVE OP-PREZZO TO PPNET4(INDR).
           IF OP-NDEC = 5 MOVE OP-PREZZO TO PPNET5(INDR).
           IF OP-NDEC = 6 MOVE OP-PREZZO TO PPNET6(INDR).
       B75.
           MOVE BCR-NETRG TO PTNET1(INDR).
           IF VALUT = 1 MOVE BCR-NETRG TO PTNET(INDR).
       B76.
           IF BCR-TCOR NOT = 3 GO TO B80.
           MOVE 11 TO KTB-TIP.
           MOVE BCR-SPESA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           PERFORM VISK-BCR
                                           GO TO WARNING.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T11-SCONT > ZERO ADD BCR-NETRG TO NOSCON.
           IF FAT-CDESE = ZERO GO TO B80.
           IF BCR-IVA = ZERO GO TO B80.
           MOVE BCR-IVA TO T11-CIVA.
           MOVE 3 TO KTB-TIP.
           MOVE T11-CIVA TO KTB-COD D-I(INDR).
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           PERFORM VISK-BCR
                                           GO TO WARNING.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF NOT (VALUT = ZERO OR COMEURO OR 1) GO TO B80.
           IF T03-ALIVA = ZERO GO TO B90.
       B80.
           IF BCR-TCOR = 4 OR 5 MOVE BCR-RIVGR TO D-I(INDR)
              ELSE IF FAT-CDESE = ZERO MOVE BCR-IVA TO D-I(INDR)
                   ELSE IF BCR-TCOR NOT = 3 MOVE FAT-CDESE TO D-I(INDR).
           IF VALUT NOT = ZERO AND
              FAT-CDESE NOT = ZERO AND (BCR-TCOR = 4 OR 5 OR 6)
                MOVE FAT-CDESE TO D-I(INDR).
       B90.
           IF BCR-TCOR = 6 AND ESTPIVA = 3
                           ADD BCR-NETRG TO GARANZ.
           IF NOT (VALUT = ZERO OR COMEURO) AND BCR-TCOR < 4
              ADD BCR-NETRG TO VNTMER.
           IF BCR-TCOR = 6
              ADD 1 TO INDR
              IF INDR > MAXR
                 PERFORM SCR-REC THRU EX-SCR-REC
                 PERFORM NWPG THRU EX-NWPG
              END-IF
              MOVE '* CESSIONE IN GARANZIA' TO D-ART-D(INDR).
           IF BCR-TCOR = 4
              ADD 1 TO INDR
              IF INDR > MAXR
                 PERFORM SCR-REC THRU EX-SCR-REC
                 PERFORM NWPG THRU EX-NWPG
              END-IF
              MOVE '* CESSIONE GRATUITA' TO D-ART-D(INDR).
           IF BCR-TCOR = 5
              ADD 1 TO INDR
              IF INDR > MAXR
                 PERFORM SCR-REC THRU EX-SCR-REC
                 PERFORM NWPG THRU EX-NWPG
              END-IF
              MOVE '* SCONTO IN MERCE' TO D-ART-D(INDR).

      **** rel 6.2
           IF BCR-TCOR = 1 SUBTRACT 1 FROM INDR.
      ************
      * stampa note aggiuntive
           MOVE KCR-AZI TO KNCR-AZI.
           MOVE KCR-NUM TO KNCR-NUM.
           MOVE KCR-BOL TO KNCR-BOL.
           MOVE KCR-PGR TO KNCR-PGR.
           MOVE ZERO    TO KNCR-PGRN.
           START NOTBCR KEY > KEYNCR INVALID GO TO B95.
       RDN-NCR.
           READ NOTBCR NEXT AT END GO TO B95.
           IF KNCR-AZI > KCR-AZI GO TO B95.
           IF KNCR-NUM > KCR-NUM GO TO B95.
           IF KNCR-BOL > KCR-BOL GO TO B95.
           IF KNCR-PGR > KCR-PGR GO TO B95.
           ADD 1 TO INDR.
           IF INDR > MAXR
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM NWPG THRU EX-NWPG.
           MOVE NCR-DESCR TO D-ART-D(INDR).
           GO TO RDN-NCR.
      *
       B95.
           IF BCR-ART NOT = SPACE
              MOVE ZERO     TO PCFA-FUN
              MOVE KCR-AZI  TO PCFA-AZI
              MOVE 'C'      TO PCFA-TIP
              MOVE FAT-CDCLI TO PCFA-CLF
              MOVE BCR-ART TO PCFA-ART
              MOVE CLF-FLING TO PCFA-LIN
              CALL 'vrrcfa' USING PARPCFA
              IF PCFA-ST = ZERO
                 IF PCFA-DEST NOT = SPACE
                    ADD 1 TO INDR
                    IF INDR > MAXR 
                       PERFORM SCR-REC THRU EX-SCR-REC   
                       PERFORM NWPG THRU EX-NWPG
                    END-IF
                    MOVE PCFA-DEST TO D-ART-D(INDR)
                 END-IF
                 IF PCFA-DDIS NOT = SPACE
                    ADD 1 TO INDR
                    IF INDR > MAXR 
                       PERFORM SCR-REC THRU EX-SCR-REC   
                       PERFORM NWPG THRU EX-NWPG
                    END-IF
                    MOVE PCFA-DDIS TO D-ART-D(INDR).
           IF BCT-IMB = 1 PERFORM WR-LAV-IMB THRU EX-WR-LAV-IMB.
       B99.
           EXIT.
      *-------------------------------
       WR-LAV-IMB.
           IF NOT (BCR-TCOR = ZERO OR 2) GO TO EX-WR-LAV-IMB.
           MOVE KBC-AZI TO KPBR-AZI.
           MOVE KBC-NUM TO KPBR-TNUM.
           MOVE KBC-BOL TO KPBR-NBOL.
           MOVE KCR-PGR TO KPBR-RBOL.
           MOVE ZERO    TO KPBR-PGR.
           START PROBCR KEY NOT < KEYPBR INVALID GO TO EX-WR-LAV-IMB.
       LAV-IMB-10.
           READ PROBCR NEXT AT END GO TO EX-WR-LAV-IMB.
           IF SF-PBR = '9D' OR '9A' OR '35' GO TO LAV-IMB-10.
           IF KBC-AZI  NOT = KPBR-AZI GO TO EX-WR-LAV-IMB.
           IF KBC-NUM NOT = KPBR-TNUM GO TO EX-WR-LAV-IMB.
           IF KBC-BOL NOT = KPBR-NBOL GO TO EX-WR-LAV-IMB.
           IF KCR-PGR NOT = KPBR-RBOL GO TO EX-WR-LAV-IMB.
      *
           MOVE KBC-AZI TO KAIM-AZI.
           MOVE PBR-IMB TO KAIM-COD.
           READ ANAIMB INVALID PERFORM INVK-AIM
                               PERFORM VISK-PBR
                               GO TO ERRIO.
           IF AIM-FLGREND = 1 GO TO LAV-IMB-10.
      *
           MOVE PBR-NPAL TO KWSI-NPAL.
           MOVE PBR-NCOL TO KWSI-NCOL.
           MOVE PBR-IMB  TO KWSI-IMB.
           ADD 1         TO KWSI-PRG.
           MOVE PBR-NIMB TO WSI-NIMB.
           WRITE RF-WSI INVALID MOVE 'vfat210: WR-LAV WSI' TO MESS
                                GO TO ERRIO.
      *
           GO TO LAV-IMB-10.
       EX-WR-LAV-IMB.
           EXIT.
      *-------------------------------
       DL-LAV-IMB.
           CLOSE WDSSIB.
           OPEN OUTPUT WDSSIB.
           CLOSE WDSSIB.
           OPEN I-O WDSSIB.
           MOVE ZERO TO KWSI-PRG.
       EX-DL-LAV-IMB.
      *-------------------------------
       SOMMA-IMBALLI.
      * azzeramento vettore totali imballi
           MOVE 1 TO INDICE.
           PERFORM UNTIL INDICE > 30
              MOVE SPACE TO VETIMB(INDICE)
              MOVE ZERO  TO VETQTA(INDICE)
              ADD 1 TO INDICE
           END-PERFORM.
      *
           MOVE ZERO  TO PREPAL PRECOL.
           MOVE SPACE TO PREIMB.
           MOVE ZERO  TO ULTIND.
      *
           MOVE LOW-VALUE TO KEYWSI.
           START WDSSIB KEY > KEYWSI INVALID GO TO EX-SOMMA-IMBALLI.
       SOMMA-IMB-10.
           READ WDSSIB NEXT AT END GO TO EX-SOMMA-IMBALLI.
           IF KWSI-NCOL = ZERO
              MOVE WSI-NIMB TO COMNIMB
              GO TO SOMMA-IMB-20.
           IF KWSI-NPAL = PREPAL AND
              KWSI-NCOL = PRECOL AND
              KWSI-IMB  = PREIMB GO TO SOMMA-IMB-10.
           MOVE 1 TO COMNIMB.
       SOMMA-IMB-20.
           MOVE KWSI-NPAL TO PREPAL.
           MOVE KWSI-NCOL TO PRECOL.
           MOVE KWSI-IMB  TO PREIMB.
      *
           MOVE 1 TO INDICE.
           PERFORM UNTIL INDICE > 30
              IF VETIMB(INDICE) = SPACE
                 MOVE KWSI-IMB TO VETIMB(INDICE)
                 MOVE COMNIMB  TO VETQTA(INDICE)
                 MOVE INDICE TO ULTIND
                 MOVE 30 TO INDICE
              ELSE
                 IF VETIMB(INDICE) = KWSI-IMB
                     ADD COMNIMB TO VETQTA(INDICE)
                     MOVE 30 TO INDICE
                 END-IF
              END-IF
              ADD 1 TO INDICE
           END-PERFORM.
      *
           GO TO SOMMA-IMB-10.
       EX-SOMMA-IMBALLI.
           EXIT.
      *-------------------------------
       G00-STAMPA-IMBALLI.
           MOVE ZERO TO INDICE.
       REPEAT.
           ADD 1 TO INDICE.
           IF INDICE > ULTIND GO TO G99.
           ADD 1 TO INDR.
           IF INDR > MAXR
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM NWPG THRU EX-NWPG.
           MOVE KAZ-COD        TO KAIM-AZI.
           MOVE VETIMB(INDICE) TO KAIM-COD.
           READ ANAIMB INVALID PERFORM INVK-AIM
                               GO TO ERRIO.
           MOVE VETIMB(INDICE) TO D-ART(INDR).
           MOVE AIM-DESC       TO D-ART-D(INDR).
           MOVE VETQTA(INDICE) TO PQTA(INDR).
           IF VALUT = ZERO OR COMEURO
              MOVE AIM-COSU TO PPRZ1(INDR)
              COMPUTE IMPIMB = VETQTA(INDICE) * AIM-COSU
              MOVE IMPIMB TO PTNET1(INDR)
           ELSE
              MOVE AIM-COSU TO ER-IMPORTO
              MOVE CG-CAMBIO TO ER-CAMBIO
              MOVE CG-VALUT  TO ER-VALUT
              CALL 're2imp' USING ER-IMPORTO EUR-VAL ER-VALUT ER-CAMBIO
              MOVE ER-IMPORTO TO PPRZ1(INDR)
              IF VALUT = 1
                 MOVE ER-IMPORTO TO PPRZ(INDR)
              END-IF
              COMPUTE ER-IMPORTO = ER-IMPORTO * VETQTA(INDICE)
              ADD ER-IMPORTO TO VNTMER
              MOVE ER-IMPORTO TO PTNET1(INDR)
              IF VALUT = 1
                 MOVE ER-IMPORTO TO PTNET(INDR).
           IF FAT-CDESE = ZERO
              MOVE AIM-CDIVA TO D-I(INDR)
           ELSE
              MOVE FAT-CDESE TO D-I(INDR).
           GO TO REPEAT.
       G99.
           EXIT.
      *-------------------------------
       STAMPA-CONAI.
           IF CLF-CONAI NOT = 1 GO TO EX-STAMPA-CONAI.
           ADD 2 TO INDR.
           IF INDR > MAXR
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM NWPG THRU EX-NWPG.
      **** rel 6.3
      *    MOVE 'CONTRIBUTO CONAI ASSOLTO' TO D-ART-D(INDR).
      **** rel 7.1
      *    MOVE 'CONTRIBUTO CONAI ASSOLTO OVE DOVUTO' TO D-ART-D(INDR).
           MOVE 'contributo conai assolto ove dovuto' TO D-ART-D(INDR).
      ************
      ************
       EX-STAMPA-CONAI.
           EXIT.
      *-------------------------------
       H00-STAMPA-MESSAGG-BOLLA.
           MOVE ZERO TO FLGTES.
           ADD 1 TO INDR.
           MOVE KAZ-COD  TO P-MDT-AZI.
           MOVE 1        TO P-MDT-TDOC.
           MOVE KEYBC    TO P-MDT-KEY.
           MOVE 2        TO P-MDT-FLGS.
           MOVE BCT-DATA TO P-MDT-DATA.
           MOVE ZERO     TO P-MDT-FLGE.
       H10.
           CALL 'vrpmdt' USING PAR-P-MDT.
           IF P-MDT-FLGE NOT = 1 GO TO H99.
           ADD 1 TO INDR.
           IF INDR > MAXR
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM NWPG THRU EX-NWPG.
           MOVE P-MDT-TESTO(1:P-MDT-NCOL) TO D-ART-D(INDR).
           MOVE 1 TO FLGTES.
           GO TO H10.
       H99.
           EXIT.
      *------------------
       F00-STAMPA-MESSAGG-FATT.
           MOVE ZERO TO FLGTES.
           ADD 1 TO INDR.
           MOVE KAZ-COD  TO P-MDT-AZI.
           MOVE 3        TO P-MDT-TDOC.
           MOVE KEYFT    TO P-MDT-KEY.
           MOVE ZERO     TO P-MDT-FLGS.
           MOVE FAT-DATA TO P-MDT-DATA.
           MOVE ZERO     TO P-MDT-FLGE.
       F10.
           CALL 'vrpmdt' USING PAR-P-MDT.
           IF P-MDT-FLGE NOT = 1 GO TO F99.
           ADD 1 TO INDR.
           IF INDR > MAXR
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM NWPG THRU EX-NWPG.
           MOVE P-MDT-TESTO(1:P-MDT-NCOL) TO D-ART-D(INDR).
           MOVE 1 TO FLGTES.
           GO TO F10.
       F99.
           EXIT.
      *-------------------------------
       NWPG.
           PERFORM WRD-AZZ.
      *
           ADD 1 TO NPAG.
           MOVE CLF-RGSOC  TO D-RGSOC1.
           MOVE CLF-RGSOC2 TO D-RGSOC2.
      **** rel 7.1
           MOVE ACF-NAZIO  TO D-NAZIO.
      **********
           MOVE CLF-INDIR  TO D-INDIR1.
           MOVE CLF-INDIR2 TO D-INDIR2.
           MOVE KFT-NUM    TO D-NUMFAT.
           MOVE FAT-DATA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA     TO D-DTFAT.
           MOVE NPAG       TO D-NPAG.
           IF KFT-TDOC = 1
              MOVE '    FATTURA'          TO D-TIPO.
           IF KFT-TDOC = 2
              MOVE '   FATTURA IN VALUTA' TO D-TIPO.
           IF KFT-TDOC = 3
              MOVE '   NOTA DI ACCREDITO' TO D-TIPO.
           IF KFT-TDOC = 4
      **** rel 7.1
      *       MOVE '  FATTURA IN SOSPESO' TO D-TIPO.
      **** rel 7.2
      *       MOVE 'FATTURA CON IVA AD ESIGIBILIT DIFFERITA' TO D-TIPO.
              IF FAT-DATA < 42005 
                 MOVE 'FATTURA CON IVA AD ESIGIBILIT DIFFERITA' 
                      TO D-TIPO
               ELSE
                 MOVE 'FATTURA SOGGETTA A SCISS. PAG.' TO D-TIPO.
      ************
      ************
           IF KFT-TDOC = 6
      **** rel 7.1
      *       MOVE ' N.ACCREDITO SOSPESO' TO D-TIPO.
      **** rel 7.2
      *       MOVE 'NOTA ACCREDITO CON IVA AD ESIGIBILIT DIFFERITA'
      *            TO D-TIPO.
              IF FAT-DATA < 42005 
                 MOVE 'NOTA ACCREDITO CON IVA AD ESIGIBILIT DIFFERITA'
                      TO D-TIPO
              ELSE
                 MOVE 'NOTA ACCREDITO SOGGETTA A SCISS. PAG.' 
                      TO D-TIPO.
      ************
           IF PWFAT-TDOC = 8 OR 9
              MOVE '    FATTURA PROFORMA' TO D-TIPO.
      **** rel 6.2
           IF SWSIM = 1
              MOVE '    SIMULAZIONE     ' TO D-TIPO.
      ************
           MOVE CLF-CAP   TO D-CAP.
           MOVE CLF-CITTA TO D-CITTA.
      **** rel 6.3
           IF FAT-IFAT = ZERO
              MOVE CLF-RGSOC  TO D-LRGSOC1
              MOVE CLF-RGSOC2 TO D-LRGSOC2
              MOVE CLF-INDIR  TO D-LINDIR1
              MOVE CLF-INDIR2 TO D-LINDIR2
              MOVE CLF-CAP    TO D-LCAP
              MOVE CLF-CITTA  TO D-LCITTA
              MOVE SPACE TO D-LDESDI
              GO TO NO-LCONS.
           MOVE KFT-AZI    TO KII-AZI.
           MOVE CODICE     TO KII-COD.
           MOVE FAT-IFAT   TO KII-PRG.
           READ INDIRI INVALID
              MOVE CLF-RGSOC TO D-LRGSOC1
              MOVE CLF-RGSOC2 TO D-LRGSOC2
              MOVE CLF-INDIR TO D-LINDIR1
              MOVE CLF-INDIR2 TO D-LINDIR2
              MOVE CLF-CAP  TO D-LCAP
              MOVE CLF-CITTA TO D-LCITTA
              MOVE SPACE TO D-LDESDI
              GO TO NO-LCONS.
           MOVE IRI-RGSOC  TO D-LRGSOC1.
           MOVE IRI-RGSOC2 TO D-LRGSOC2.
           MOVE IRI-INDIR  TO D-LINDIR1.
           MOVE IRI-INDIR2 TO D-LINDIR2.
           MOVE IRI-CAP    TO D-LCAP.
           MOVE IRI-CITTA  TO D-LCITTA.
           MOVE IRI-DESDI  TO D-LDESDI.
       NO-LCONS.
      ************
           MOVE FAT-CDCLI TO D-CDCLI.
           MOVE CLF-CFISC TO D-CFISC.
           IF CLF-PIVA > ZERO MOVE CLF-PIVA TO D-PIVA.
           IF CLF-13IVA = 4
              MOVE SPACE     TO D-CFISC
              MOVE CLF-CFISC TO D-PIVA.
           MOVE FAT-CDAGE TO D-CDAGE.
           MOVE 6        TO KTB-TIP.
           MOVE WK-CSPE  TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE SPACE TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO D-SPEDIZ.
           PERFORM RD-NTA THRU EX-RD-NTA.
           MOVE 5        TO KTB-TIP.
           MOVE WK-CPOR  TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE SPACE TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO D-PORTO.
           PERFORM RD-NTA THRU EX-RD-NTA.
           MOVE FAT-CDPAG TO D-CDPAG.
           MOVE 4         TO KTB-TIP.
           MOVE FAT-CDPAG TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE SPACE TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO D-PAGAM.
           PERFORM RD-NTA THRU EX-RD-NTA.
           MOVE FAT-SCBAS TO D-SCBAS.
           MOVE BAN-RGSOC TO D-BANCA.
           MOVE BAN-CODAZ TO D-ABI.
           MOVE BAN-CODSP TO D-CAB.
      **** rel 7.1
           MOVE KFT-AZI  TO KAFT-AZI.
           MOVE KFT-TDOC TO KAFT-TDOC.
           MOVE KFT-NUM  TO KAFT-NUM.
           MOVE FAT-CATT TO KAFT-CATT.
           READ APPFAT INVALID 
                MOVE SPACE TO AFT-IPA AFT-CIG AFT-CUP
                MOVE ZERO  TO AFT-TIPO.
           MOVE AFT-IPA TO D-IPA.
           MOVE AFT-CIG TO D-CIG.
           MOVE AFT-CUP TO D-CUP.
           MOVE SPACE   TO D-TIPOF.
           IF KFT-TDOC = 1
              IF AFT-TIPO = ZERO
                 MOVE 'Fattura Normale' TO D-TIPOF
              END-IF
              IF AFT-TIPO = 1
                 MOVE 'Nota di debito' TO D-TIPOF
              END-IF
              IF AFT-TIPO = 2
                 MOVE 'Fattura di anticipo' TO D-TIPOF.
      ************
           MOVE SPACE TO D-DSCOR D-DSCIN D-CCOR D-CINAZ.
      **** rel 6.2
      *    IF T04-TIPAG NOT = 5 GO TO NO-CCOR.
      *    IF BAN-CCOR NOT = SPACE  MOVE 'c/c'     TO D-DSCOR
      *                             MOVE BAN-CCOR  TO D-CCOR.
      *    IF BAN-CINAZ NOT = SPACE MOVE 'CIN'     TO D-DSCIN
      *                             MOVE BAN-CINAZ TO D-CINAZ.
           IF T04-TIPAG NOT = 5
              MOVE SPACE TO D-IBAN
              MOVE 1 TO J
              IF BAN-CODAZ NOT = '00000'
                 STRING 'ABI: ' BAN-CODAZ ' ' DELIMITED SIZE
                        INTO D-IBAN POINTER J
              END-IF
              IF BAN-CODSP NOT = '00000'
                 STRING 'CAB: ' BAN-CODSP DELIMITED SIZE
                        INTO D-IBAN POINTER J
              END-IF
              GO TO NO-CCOR.
           MOVE ZERO      TO PARIBAN.
           MOVE ABA-CIBAN TO IBAN.
           CALL 'riban' USING PARIBAN PARBBAN.
           IF IBAN-FLG = 9 
              GO TO NO-CCOR.
           MOVE BBAN-ABI TO D-ABI.
           MOVE BBAN-CAB TO D-CAB.
           IF BBAN-CONTO NOT = SPACE  MOVE 'c/c'       TO D-DSCOR
                                      MOVE BBAN-CONTO  TO D-CCOR.
           IF BBAN-CIN NOT = SPACE MOVE 'CIN'    TO D-DSCIN
                                   MOVE BBAN-CIN TO D-CINAZ.
           MOVE IBAN-P TO D-IBAN.
      **** rel 7.1
           STRING 'BIC/SWIFT: ' BAN-SWIFT DELIMITED SIZE INTO D-SWIFT.
      **********
      ************
       NO-CCOR.
           MOVE T04-SCASS TO SCONTO.
           IF T04-1SCAD = ZERO
              MOVE 1 TO VISTA
           ELSE
              MOVE ZERO TO VISTA.
      **** rel 6.2
      *    IF VALUT = ZERO MOVE SPACE TO DSVAL
      *                    GO TO NWPG001.
      ************
           MOVE 10    TO KTB-TIP.
           MOVE VALUT TO KTB-COD.
      **** rel 6.2
           IF VALUT = ZERO MOVE COMEURO TO KTB-COD.
      ************
           READ TABELL INTO REKTAB INVALID MOVE SPACE TO T10-DSINT.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T10-DSINT TO D-DIVISA.
           MOVE T10-DSINT TO DSVAL.
       NWPG001.
           MOVE ZERO TO FLGMCL J.
           MOVE 1 TO KN.
       VPG-0.
           IF KN > 12 GO TO VPG-1.
           IF RACF-ESCM(KN) = 1
              IF J = ZERO
                 ADD 1 TO J
              ELSE
                 ADD 10 TO J
              END-IF
              MOVE 1 TO FLGMCL
              MOVE VTMES(KN) TO D-MESIESC(J:10).
           ADD 1 TO KN.
           GO TO VPG-0.

       VPG-1.
           IF FLGMCL = 1 GO TO VPG-3.

           MOVE ZERO TO J.
           MOVE 1 TO KN.
       VPG-2.
           IF KN > 12 GO TO VPG-3.
           IF T04-ESCM(KN) = 1
              IF J = ZERO
                 ADD 1 TO J
              ELSE
                 ADD 10 TO J
              END-IF
              MOVE VTMES(KN) TO D-MESIESC(J:10).
           ADD 1 TO KN.
           GO TO VPG-2.
       VPG-3.
      ****
           MOVE WD-TIPS   TO D-TIPS.
      ****
           MOVE 1         TO D-NCOP.
           MOVE CLF-FAX   TO D-FAX.
           MOVE NPAG      TO D-TOTPAG.
      *
           MOVE 1 TO INDR.
       EX-NWPG.
           EXIT.
      *-------------------------------
      * STAMPA PIEDE FATTURA *
       STAMPA-PIEDE.
           PERFORM SOMMA-IMBALLI THRU EX-SOMMA-IMBALLI.
           PERFORM G00-STAMPA-IMBALLI THRU G99.
           IF ESTPIVA NOT = 3 PERFORM STAMPA-CONAI THRU EX-STAMPA-CONAI.
           PERFORM F00-STAMPA-MESSAGG-FATT THRU F99.
           IF FLGTES = ZERO SUBTRACT 1 FROM INDR.
           MOVE ZERO TO NN.
           ADD 2 TO INDR.
           IF FAT-OMAGG > ZERO
              ADD 1 TO NN
              IF ESTPIVA = 3 OR FAT-IVRIV NOT = ZERO
                 ADD 1 TO NN.
           IF FAT-SCONT > ZERO
              ADD 1 TO NN
              IF ESTPIVA = 3
                 ADD 1 TO NN.
           IF GARANZ > ZERO AND ESTPIVA = 3 ADD 2 TO NN.
      **** rel 7.1
           PERFORM I00-STAMPA-NOTEIVA THRU I99.
           IF FLGTES = ZERO SUBTRACT 1 FROM INDR.
      ************
      **** rel 7.2
           IF (KFT-TDOC = 6 OR KFT-TDOC = 4) AND
              FAT-DATA >= 42005 
              PERFORM J00-STAMPA-SPLITPAY THRU J99.
      ************
           IF FAT-CDESE = ZERO GO TO LPPIEDE.
           IF CLF-ENUIVA = ZERO GO TO LPPIEDE.
           IF ESTPIVA NOT = 6 GO TO LPPIEDE.
      * nota: il valore 4 sommato a INDR e a NN e' il numero di righe
      *       occorrenti per i rifer. alla lettera d'intento
           IF (INDR + NN + 4) > MAXR
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM NWPG THRU EX-NWPG.
           COMPUTE INDR = MAXR - 4 - NN.
           MOVE 'Non imp. IVA art 8/2  DPR 633' TO D-ART-D(INDR).
           ADD 1 TO INDR.
           MOVE 'del 26/10/72 e succ. modifiche' TO D-ART-D(INDR).
           ADD 1 TO INDR.
           MOVE 'Vs aut. N.' TO DES1(INDR).
           MOVE CLF-ENUIVA   TO SOUT(INDR).
           MOVE ' del'       TO DES2(INDR).
           MOVE CLF-EDTIVA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO SDEL(INDR).
           ADD 1 TO INDR.
           MOVE 'Ns protoc.' TO DES1(INDR).
           MOVE CLF-INUIVA   TO SOUT(INDR).
           MOVE ' del'       TO DES2(INDR).
           MOVE CLF-IDTIVA TO AAGGG.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO SDEL(INDR).
       LPPIEDE.
           IF NN = ZERO GO TO LPPIE-99.
           IF (INDR + NN) > MAXR
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM NWPG THRU EX-NWPG.
           COMPUTE INDR = MAXR - NN.
           IF FAT-OMAGG = ZERO GO TO LPPIE-20.
           ADD 1 TO INDR.
           MOVE 'Cessione gratuita = ' TO RDSMO(INDR).
           IF (VALUT = ZERO OR COMEURO)
              MOVE FAT-OMAGG  TO RDIMP1(INDR)
           ELSE
              MOVE FAT-EOMAGG TO RDIMP1(INDR).
           IF VALUT = 1 MOVE FAT-EOMAGG TO RDIMP(INDR).
           IF ESTPIVA = 3
              ADD 1 TO INDR
              MOVE 'Valore ai soli fini Doganali' TO D-ART-D(INDR)
              GO TO LPPIE-10.
           IF FAT-IVRIV = ZERO GO TO LPPIE-10.
           ADD 1 TO INDR.
           MOVE 'Iva nostro carico = ' TO RDSIV(INDR).
           IF (VALUT = ZERO OR COMEURO)
              MOVE FAT-IVRIV TO ERDIVA(INDR)
           ELSE
              MOVE FAT-EIVRIV TO ERDIVA(INDR).
           IF VALUT = 1 MOVE FAT-EIVRIV TO RDIVA(INDR).
       LPPIE-10.
       LPPIE-20.
           IF FAT-SCONT = ZERO GO TO LPPIE-30.
           ADD 1 TO INDR.
           MOVE 'Sconto in merce   = ' TO RDSMO(INDR).
           IF  (VALUT = ZERO OR COMEURO)
              MOVE FAT-SCONT  TO RDIMP1(INDR)
           ELSE
              MOVE FAT-ESCONT TO RDIMP1(INDR).
           IF VALUT = 1 MOVE FAT-ESCONT TO RDIMP(INDR).
           IF ESTPIVA = 3
              ADD 1 TO INDR
              MOVE 'Valore ai soli fini Doganali' TO D-ART-D(INDR).
       LPPIE-30.
           IF GARANZ = ZERO OR ESTPIVA NOT = 3 GO TO LPPIE-99.
           ADD 1 TO INDR.
           MOVE 'Cess. in garanzia = ' TO RDSMO(INDR).
           MOVE GARANZ TO RDIMP1(INDR).
           IF VALUT = 1 MOVE GARANZ TO RDIMP(INDR).
           ADD 1 TO INDR.
           MOVE 'Valore ai soli fini Doganali' TO D-ART-D(INDR).
       LPPIE-99.
           IF NOT (VALUT = ZERO OR COMEURO)
              COMPUTE VSCFIN = (VNTMER - NOSCON) * SCONTO / 100.
           IF (VALUT = ZERO OR COMEURO)
               MOVE FAT-NTMER TO PNET1
           ELSE
               MOVE VNTMER TO PNET1.
           IF VALUT = 1 MOVE VNTMER TO PNET.
           MOVE ZERO TO IMPON IMPOS.
           MOVE ZERO TO IMPRIT.
           MOVE ZERO TO K.
       LSCA.
           ADD 1 TO K.
           IF K > 6 GO TO GSCA.
           IF FAT-CDIVA (K) = ZERO GO TO GSCA.
           MOVE FAT-CDIVA (K) TO KTB-COD.
           MOVE 3 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                       MOVE 'IVA INESISTENTE' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE FAT-CDIVA (K) TO D-CI(K).
           IF VALUT = ZERO OR COMEURO
              MOVE FAT-IMPON(K) TO PIMP1(K)
              MOVE FAT-IMPOS(K) TO EPIMIVA(K)
              ADD  FAT-IMPON(K) TO IMPON
      **** rel 6.3
      *       IF T03-TPIVA = ZERO
              IF T03-TPIVA NOT = 5
      ************
                 ADD  FAT-IMPON(K) TO IMPRIT
              END-IF
              ADD  FAT-IMPOS(K) TO IMPOS
           ELSE
              MOVE FAT-EIMPON(K) TO PIMP1(K)
              MOVE FAT-EIMPOS(K) TO EPIMIVA(K)
              ADD  FAT-EIMPON(K) TO IMPON
      **** rel 6.3
      *       IF T03-TPIVA = ZERO
              IF T03-TPIVA NOT = 5
      ************
                 ADD  FAT-EIMPON(K) TO IMPRIT
              END-IF
              ADD  FAT-EIMPOS(K) TO IMPOS.
           IF VALUT = 1
              MOVE FAT-EIMPON(K) TO PIMP(K)
              MOVE FAT-EIMPOS(K) TO PIMIVA(K).
           IF T03-ALIVA = ZERO
              MOVE TAB-DESCR TO D-ALIQ(K)
           ELSE
              MOVE T03-DSIVA TO D-ALIQ(K).
       GSCA.
           IF K = 1 GO TO LRIE.
           IF K > 7 GO TO ESCA.
      **** rel 6.1
      *    SUBTRACT 1 FROM K.
      *    IF FAT-DTSCA (K) = ZERO GO TO GSCA1.
      *    IF VISTA = 1 MOVE 'A VISTA' TO D-DTSCA(K)
      *                 MOVE ZERO TO VISTA
      *                 GO TO GSCA0.
      *    MOVE FAT-DTSCA (K) TO AAGGG.
      *    CALL 'rdata' USING PARCDT.
      *    MOVE GBMMBA TO D-DTSCA(K).
      *GSCA0.
      *
      *    IF VALUT = ZERO OR COMEURO
      *       MOVE FAT-IMPOR(K)  TO PSCIM2(K)
      *    ELSE
      *       MOVE FAT-EIMPOR(K) TO PSCIM2(K).
      *    IF VALUT = 1 MOVE FAT-EIMPOR(K) TO PSCIMP(K).
      *GSCA1.
      *    ADD 1 TO K.
      ************
       LRIE.
           IF K = 1 AND FAT-SCFIN > ZERO
               MOVE 'sc.' TO PSFIN
               MOVE SCONTO    TO PSPER
               MOVE '%'  TO FILPE
               MOVE 'su' TO FILLUN
               GO TO LSCA.
           IF K = 2 AND FAT-SCFIN > ZERO
              MOVE SPACE TO PSCO1
              IF VALUT = ZERO OR COMEURO
                 COMPUTE PSCO3 = FAT-NTMER - NOSCON
                 COMPUTE SPSCF1 = - FAT-SCFIN
              ELSE
                  COMPUTE PSCO3 = VNTMER - NOSCON
                  COMPUTE SPSCF1 = - VSCFIN
              END-IF
              IF VALUT = 1
                 COMPUTE PSCO2 = VNTMER - NOSCON
                 COMPUTE SPSCF = - VSCFIN.
           IF K = 4 AND FAT-SPBOL > ZERO
                    AND (VALUT = ZERO OR COMEURO)
               MOVE 'BOLLI' TO D-BOLLI
               MOVE FAT-SPBOL TO D-IMPBOLLI.
           IF K = 4 AND FAT-ESPBOL > ZERO
                    AND VALUT = 1    MOVE 'BOLLI'    TO D-BOLLI
                                     MOVE FAT-ESPBOL TO D-LIMPBOLLI.
           IF K = 6 AND FAT-SPBAN > ZERO
              MOVE 'SPESE BANCA' TO D-DSPBANCA
              IF VALUT = ZERO OR COMEURO
                 MOVE FAT-SPBAN TO PIBAN1
              ELSE
                 MOVE FAT-ESPBAN TO PIBAN1
              END-IF
              IF VALUT = 1 MOVE FAT-ESPBAN TO PIBAN.
           GO TO LSCA.
       ESCA.
      **** rel 6.1
      *    MOVE 6 TO K.
           MOVE ZERO TO K.
      ************
       LPK.
           ADD 1 TO K.
           IF K > 12 GO TO END-SC.
           IF FAT-DTSCA (K) = ZERO GO TO LPK.
      **** rel 6.1
      *    MOVE FAT-DTSCA (K) TO AAGGG.
      *    CALL 'rdata' USING PARCDT.
      *    MOVE GBMMBA TO D-DTSCA(K).
           IF VISTA = 1
              MOVE 'A VISTA' TO D-DTSCA(K)
              MOVE ZERO TO VISTA
           ELSE
              MOVE FAT-DTSCA (K) TO AAGGG
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE GBMMBA TO D-DTSCA(K).
      ************
           IF VALUT = ZERO OR COMEURO
              MOVE FAT-IMPOR(K)  TO PSCIM2(K)
           ELSE
              MOVE FAT-EIMPOR(K) TO PSCIM2(K).
           IF VALUT = 1 MOVE FAT-EIMPOR(K) TO PSCIMP(K).
      **** rel 6.2
           MOVE SPACE TO D-TPAG(K).
           MOVE FAT-TPAG(K) TO COMTPAG.
           IF T04-NRATE NOT = ZERO MOVE T04-TIPAG TO COMTPAG.
      *
           IF COMTPAG = 1 MOVE 'TR' TO D-TPAG(K).
           IF COMTPAG = 2 MOVE 'RB' TO D-TPAG(K).
           IF COMTPAG = 3 MOVE 'RD' TO D-TPAG(K).
           IF COMTPAG = 4 MOVE 'CE' TO D-TPAG(K).
           IF COMTPAG = 5 MOVE 'BO' TO D-TPAG(K).
           IF COMTPAG = 6 MOVE 'LC' TO D-TPAG(K).
           IF COMTPAG = 9 MOVE 'AV' TO D-TPAG(K).
      ************
      **** rel 6.1
           GO TO LPK.
      ************
       END-SC.
           MOVE IMPON TO PTIM1.
           IF VALUT = 1 MOVE IMPON TO PTIM.
           MOVE IMPOS TO PTIV1.
           IF VALUT = 1
              MOVE IMPOS TO PTIV.
      **** rel 7.2
           IF (KFT-TDOC = 6 OR KFT-TDOC = 4) AND
              FAT-DATA >= 42005 
              GO TO NOSAC.
      ************
           IF FAT-VALUT = ZERO OR COMEURO
              COMPUTE TOTACC = FAT-TOTFT - FAT-IMPOR(1)
                                         - FAT-IMPOR(2)
                                         - FAT-IMPOR(3)
                                         - FAT-IMPOR(4)
                                         - FAT-IMPOR(5)
                                         - FAT-IMPOR(6)
                                         - FAT-IMPOR(7)
                                         - FAT-IMPOR(8)
                                         - FAT-IMPOR(9)
                                         - FAT-IMPOR(10)
                                         - FAT-IMPOR(11)
                                         - FAT-IMPOR(12)
           ELSE
              COMPUTE TOTACC = FAT-TOVAL - FAT-EIMPOR(1)
                                         - FAT-EIMPOR(2)
                                         - FAT-EIMPOR(3)
                                         - FAT-EIMPOR(4)
                                         - FAT-EIMPOR(5)
                                         - FAT-EIMPOR(6)
                                         - FAT-EIMPOR(7)
                                         - FAT-EIMPOR(8)
                                         - FAT-EIMPOR(9)
                                         - FAT-EIMPOR(10)
                                         - FAT-EIMPOR(11)
                                         - FAT-EIMPOR(12).
           IF TOTACC > ZERO MOVE 'ACCONTO' TO D-DACCONTO
                            MOVE TOTACC    TO D-ACCONTO2
                            IF VALUT = 1
                            MOVE TOTACC    TO D-ACCONTO.
       NOSAC.

           IF VALUT = ZERO OR COMEURO
      **** rel 6.2
              MOVE DSVAL TO D-DESVAL
      ************
              MOVE FAT-TOTFT TO PTOT1
           ELSE
              MOVE DSVAL TO D-DESVAL
              MOVE FAT-TOVAL TO PTOT1.
           IF VALUT = 1 MOVE FAT-TOVAL TO PTOT.
           MOVE ZERO TO D-TFTEUR.
      *
           IF (BCT-PBASE = ZERO) AND (BCT-PRACC = ZERO) GO TO NORITE.
           COMPUTE IMPO = (IMPRIT / 100) * BCT-PBASE.
           MOVE IMPO      TO ER-IMPORTO.
           MOVE ZERO      TO ER-VALUT.
           MOVE BCT-PRACC TO COM-ALIVA.
           CALL 're2iva' USING ER-IMPORTO ER-VALUT COM-ALIVA
           MOVE ER-IMPORTO TO RITE.
           MOVE 'Ritenuta d''acconto' TO PDICI.
           MOVE BCT-PRACC TO PRACC.
           MOVE '%'   TO FILPE1.
           MOVE '(sul' TO PDICI1.
           MOVE BCT-PBASE TO PBASE.
           MOVE '%'  TO FILPE2.
           MOVE 'dell''imponibile)' TO PDICI2.
           MOVE '-'  TO PSEG.
           MOVE RITE TO PRIT1.
           IF VALUT = 1 MOVE RITE TO PRIT.
           MOVE 'NETTO A PAGARE' TO PDICI3.
           COMPUTE NETAP = FAT-TOTFT - RITE.
           MOVE NETAP TO PNETAP1.
           IF VALUT = 1 MOVE NETAP TO PNETAP.
       NORITE.
      **** rel 7.2
           IF FAT-DATA < 42005 GO TO NOSPLIT.
           IF KFT-TDOC NOT = 4 AND KFT-TDOC NOT = 6 GO TO NOSPLIT.
           MOVE 'NETTO A PAGARE' TO PDICI3.
           COMPUTE NETAP = IMPON.
           MOVE NETAP TO PNETAP1.
       NOSPLIT.
      ************
           PERFORM SCR-REC THRU EX-SCR-REC.
       EX-STAMPA-PIEDE.
           EXIT.
      *-------------------------------
      * fase di lettura note
       RD-NTA.
           MOVE ZERO TO KN.
      *
           MOVE TAB-TIP TO KNTA-TIP.
           MOVE TAB-COD TO KNTA-COD.
           MOVE ZERO    TO KNTA-PRG.
           START NOTTAB KEY >= KEYNTA INVALID GO TO RD-NTA-20.
       RD-NTA-10.
           READ NOTTAB NEXT AT END GO TO RD-NTA-20.
           IF KNTA-TIP > TAB-TIP GO TO RD-NTA-20.
           IF KNTA-COD > TAB-COD GO TO RD-NTA-20.
           ADD 1 TO KN.
           IF TAB-TIP = 4 MOVE NTA-DESCR TO D-NOTP(KN).
           IF TAB-TIP = 5 MOVE NTA-DESCR TO D-NOTR(KN).
           IF TAB-TIP = 6 MOVE NTA-DESCR TO D-NOTS(KN).

           GO TO RD-NTA-10.
       RD-NTA-20.
      *
       EX-RD-NTA.
           EXIT.
      *-------------------------------
      **** rel 7.1
       I00-STAMPA-NOTEIVA.
           MOVE ZERO TO FLGTES.
           ADD 1 TO INDR.
      *
           IF FAT-CDESE = ZERO GO TO I20.
      *
           MOVE 3       TO KNTA-TIP.
           MOVE FAT-CDESE TO KNTA-COD.
           MOVE ZERO    TO KNTA-PRG.
           START NOTTAB KEY >= KEYNTA INVALID GO TO I20.
       I10.
           READ NOTTAB NEXT AT END GO TO I20.
           IF KNTA-TIP > 3         GO TO I20.
           IF KNTA-COD > FAT-CDESE GO TO I20.
      *
           IF INDR > MAXR
              MOVE ZERO TO SAVKNTA
              MOVE KEYNTA TO SAVKNTA
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM NWPG THRU EX-NWPG
              MOVE SAVKNTA TO KEYNTA
              READ NOTTAB.
      *
           MOVE NTA-DESCR TO D-ART-D(INDR).
      *
           ADD 1 TO INDR.
      *
           MOVE 1 TO FLGTES.
      *
           GO TO I10.
       I20.
      *
           IF FLGTES = 1 GO TO I99.
           MOVE ZERO TO K.
      *
       LCIVA.
      *
           ADD 1 TO K.
           IF K > 6 GO TO I99.
      *
           IF FAT-CDIVA (K) = ZERO GO TO I99.
      *
           MOVE FAT-CDIVA (K) TO KNTA-COD.
           MOVE 3             TO KNTA-TIP.
           MOVE ZERO    TO KNTA-PRG.
           START NOTTAB KEY >= KEYNTA INVALID GO TO I98.
       I15.
           READ NOTTAB NEXT AT END GO TO I98.
           IF KNTA-TIP > 3         GO TO I98.
           IF KNTA-COD > FAT-CDIVA (K) GO TO I98.
      *
           IF INDR > MAXR
              MOVE ZERO TO SAVKNTA
              MOVE KEYNTA TO SAVKNTA
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM NWPG THRU EX-NWPG
              MOVE SAVKNTA TO KEYNTA
              READ NOTTAB.
      *
           MOVE NTA-DESCR TO D-ART-D(INDR).
           ADD 1 TO INDR.
           MOVE 1 TO FLGTES.
      *
           GO TO I15.
      *
       I98.
      *
           GO TO LCIVA.
       I99.
           EXIT.
      *------------------
      ************
      **** rel 7.2
       J00-STAMPA-SPLITPAY.
      *
           ADD 1 TO INDR.
           IF INDR > MAXR
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM NWPG THRU EX-NWPG.
           MOVE '- Scissione dei pagamenti -'    TO D-ART-D(INDR).
      *
           ADD 1 TO INDR.
           IF INDR > MAXR
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM NWPG THRU EX-NWPG.
           MOVE 'Iva da versare a cura del'    TO D-ART-D(INDR).
           ADD 1 TO INDR.
           IF INDR > MAXR
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM NWPG THRU EX-NWPG.
           MOVE 'cessionario o committente ai' TO D-ART-D(INDR).
           ADD 1 TO INDR.
           IF INDR > MAXR
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM NWPG THRU EX-NWPG.
           MOVE 'sensi dell''Articolo 17-Ter'  TO D-ART-D(INDR).
           ADD 1 TO INDR.
           IF INDR > MAXR
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM NWPG THRU EX-NWPG.
           MOVE 'D.P.R n.633/1972 e '         TO D-ART-D(INDR).
           ADD 1 TO INDR.
           IF INDR > MAXR
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM NWPG THRU EX-NWPG.
           MOVE 'successive modifiche'         TO D-ART-D(INDR).
      *
       J99.
           EXIT.
      *-------------------------------
      ************
