      $SET LINKCOUNT"128"
       IDENTIFICATION DIVISION.
       PROGRAM-ID. VORDG30.
      *
      *    Interfaccia BOLCTE per scheda
      *
      *-------------------------------------------------------------
      * Note:
      * - RG-BCT-ST : oltre ai valori soliti, puo' essere restituito
      *               ST = 4 nel caso di bolla gia' fatturata o non
      *               gestibile.
      *-------------------------------------------------------------
      **** rel NT 0.0
      * manca:
      *         segnalazioni di errori di aggiornamento archivi secondari
      ***************
      **** rel 5.0
      * Ricompilato per variazione tracciato ANABAN
      ************
      **** rel 6.0a
      * Ricompilato per inversione campi tracciato BOLCTE
      *************
      **** rel 6.2
      * Ricompilata per grincr
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griclfsl'.
           COPY 'griordsl'.
           COPY 'gririgsl'.
           COPY 'gribctsl'.
           COPY 'gribcrsl'.
      **** rel 1.2
      *    COPY 'gricggsl'.
      ************
           COPY 'griartsl'.
           COPY 'griardsl'.
           COPY 'griobcsl'.
           COPY 'gribansl'.
           COPY 'griaccsl'.
      **** rel 2.0
           COPY 'griporsl'.
           COPY 'gripbrsl'.
           COPY 'grincrsl'.
      ************
           COPY 'gritabsl'.
      **** rel 6.3
           COPY 'griirisl'.
      ************
      **** rel 7.1
           COPY 'griaorsl'.
           COPY 'griactsl'.
      ************
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'griclf'.
           COPY 'griord'.
           COPY 'gririg'.
           COPY 'gribct'.
           COPY 'gribcr'.
      **** rel 1.2
      *    COPY 'gricgg'.
      ************
           COPY 'griart'.
           COPY 'griard'.
           COPY 'griobc'.
           COPY 'griban'.
           COPY 'griacc'.
      **** rel 2.0
           COPY 'gripor'.
           COPY 'gripbr'.
           COPY 'grincr'.
      ************
           COPY 'gritab'.
      **** rel 6.3
           COPY 'griiri'.
      ************
      **** rel 7.1
           COPY 'griaor'.
           COPY 'griact'.
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griclfrk'.
           COPY 'griazirk'.
           COPY 'griordrk'.
           COPY 'gririgrk'.
           COPY 'griartrk'.
           COPY 'griardrk'.
           COPY 'gritabrk'.
           COPY 'rekt23'.
           COPY 'grit25rk'.
           COPY 'grit28rk'.
           COPY 'grit35rk'.
      **** rel 5.2
           COPY 'grit30rk'.
      ************
           COPY 'rekt52'.
           COPY 'parmag'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parim'.
           COPY 'parrd'.
      **** rel 1.2
           COPY 'parer'.
           COPY 'parlk'.
      ************
      **** rel 2.0
           COPY 'parmb'.
      ************
      **** rel 5.0
           COPY 'parmu'.
           COPY 'parbc'.
           COPY 'paroc'.
      ************
      **** rel 5.1
           COPY 'parve'.
           COPY 'parppar'.
      ************
      **** rel 6.0
           COPY 'paracf'.
      ************
      **** rel 6.1
           COPY 'parfat'.
      ************
      **** rel 6.3
           COPY 'parrb'.
           COPY 'parxcd'.
           COPY 'parlpd'.
           COPY 'parpint'.
      ************
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-ORD PIC X(15) VALUE 'ordcli'.
       01  ID-RIG PIC X(15) VALUE 'ordrig'.
       01  ID-BCT PIC X(15) VALUE 'bolcte'.
       01  ID-BCR PIC X(15) VALUE 'bolcri'.
       01  ID-ART PIC X(15) VALUE 'magart'.
       01  ID-ARD PIC X(15) VALUE 'magard'.
      **** rel 1.2
      *01  ID-CGG PIC X(15) VALUE 'camgio'.
      ************
       01  ID-OBC PIC X(15) VALUE 'bolord'.
       01  ID-BAN PIC X(15) VALUE 'anaban'.
       01  ID-ACC PIC X(15) VALUE 'accont'.
      **** rel 2.0
       01  ID-POR PIC X(15) VALUE 'prorig'.
       01  ID-PBR PIC X(15) VALUE 'probcr'.
       01  ID-NCR PIC X(15) VALUE 'notbcr'.
      ************
      **** rel 6.3
       01  ID-IRI PIC X(15) VALUE 'indiri'.
      ************
      **** rel 7.1
       01  ID-AOR PIC X(15) VALUE 'appord'.
       01  ID-ACT PIC X(15) VALUE 'appbct'.
      ************
       01  COMODI.
           05 SF-AZI PIC XX.
           05 SF-CLF PIC XX.
           05 SF-TAB PIC XX.
           05 SF-ORD PIC XX.
           05 SF-RIG PIC XX.
           05 SF-BCT PIC XX.
           05 SF-BCR PIC XX.
           05 SF-ART PIC XX.
           05 SF-ARD PIC XX.
      **** rel 1.2
      *    05 SF-CGG PIC XX.
      ************
           05 SF-OBC PIC XX.
           05 SF-BAN PIC XX.
           05 SF-ACC PIC XX.
      **** rel 2.0
           05 SF-POR PIC XX.
           05 SF-PBR PIC XX.
           05 SF-NCR PIC XX.
      ************
      **** rel 6.3
           05 SF-IRI PIC XX.
      ************
      **** rel 7.1
           05 SF-AOR PIC XX.
           05 SF-ACT PIC XX.
      ************
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VKEY     PIC 9.
           05 VFLD     PIC 9.
           05 FLCK     PIC 9.
           05 FUN      PIC X.
           05 IDX      PIC 9.
           05 EOF      PIC 9.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 KRIFER   PIC X(30).
           05 IF-AZI   PIC 9(3).
           05 IF-TDOC  PIC 9.
           05 IF-NUM   PIC 9.
           05 IF-TMODU PIC 9.
      **** rel 2.0
           05 IF-CATT  PIC X.
      ************
           05 MCLI     PIC 99.
           05 MFOR     PIC 99.
           05 CODICE.
              10 MAS    PIC 99.
              10 COD    PIC 9(5).
           05 DTAIVA   PIC 9(5) COMP-3 VALUE ZERO.
           05 DATIVB   PIC X(8)        VALUE SPACE.
           05 RESID    PIC S9(10)V999  VALUE ZERO.
           05 SCBAS    PIC 99V99       VALUE ZERO.
           05 COMVALUT PIC 999         VALUE ZERO.
           05 OLDDATA  PIC 9(5).
           05 OLDANNO  PIC 9(4).
           05 NEWANNO  PIC 9(4).
           05 COMDAT   PIC 9(6).
           05 SWTEST   PIC 9.
           05 SWERR    PIC 9.
           05 SWDGEST  PIC 9.
           05 COMBOL   PIC 9(5).
      **** rel 1.2
           05 SWERG00  PIC 9.
      ************
      **** rel 2.0
      * flgagg: aggiornamento archivi per fatture proforma
           05 FLGAGG  PIC 9.
      ************
      **** rel 4.0
           05 COMEURO PIC 9(3) VALUE ZERO.
      ************
      **** rel 5.1
           05 VALUT   PIC 9(3) VALUE ZERO.
      ************
      **** rel 5.1-1
           05 DTINT   PIC 9(5) VALUE ZERO.
           05 CLIINT  PIC 9(5) VALUE ZERO.
      **************
      **** rel 6.0
           05 K       PIC 99   VALUE ZERO.
      ************
      **** rel 6.2
           05 XNFAT    PIC XXX.
           05 NFAT REDEFINES XNFAT PIC 9(5) COMP-3.
           05 FLG8D    PIC 9 VALUE ZERO.
      ************
      **** rel 6.3
           05 INDB    PIC 99   VALUE ZERO.
           05 XNUFAT.
              10 NUFAT   PIC 9(5) COMP-3.
      ************
      **** rel 7.1
           05 W-BCT-VETT PIC 9(03) VALUE ZERO.
      ************
      *
       01  PAR-LMS.
           05 PLMS-AZI     PIC 999.
           05 PLMS-FUNZ    PIC 9.
           05 PLMS-NUM     PIC 9.
           05 PLMS-BOL     PIC 9(5).
           05 PLMS-PRG     PIC 999.
           05 PLMS-DTOLD   PIC 9(5).
      *
       01  VETBOL.
           05 FILLER PIC X(39) VALUE 'fattura normale'.
      **** rel 1.2
      *    05 FILLER PIC X(39) VALUE 'fattura estero'.
           05 FILLER PIC X(39) VALUE 'fattura in valuta'.
      ************
           05 FILLER PIC X(39) VALUE 'nota accredito'.
           05 FILLER PIC X(39) VALUE
             'bolla cliente con trasfer. tra depositi'.
           05 FILLER PIC X(39) VALUE 'bolla cliente normale'.
           05 FILLER PIC X(39) VALUE
             'bolla fornit. con trasfer. tra depositi'.
           05 FILLER PIC X(39) VALUE 'bolla fornit. normale'.
      **** rel 2.0
           05 FILLER PIC X(39) VALUE 'fattura proforma normale'.
           05 FILLER PIC X(39) VALUE 'fattura proforma in valuta'.
      ************
       01  FILLER REDEFINES VETBOL.
      **** rel 2.0
           05 ELVBOL PIC X(39) OCCURS 9.
      *    05 ELVBOL PIC X(39) OCCURS 7.
      ************
      *
       01  RKT14F.
           05 T14FKEYID.
              10 T14F-TIP PIC 99.
              10 T14F-COD PIC 999.
           05 T14F-CAVC   PIC 9(3).
           05 T14F-CARC   PIC 9(3).
           05 T14F-CAOC   PIC 9(3).
           05 T14F-CASC   PIC 9(3).
           05 T14F-CAGC   PIC 9(3).
           05 T14F-CAAF   PIC 9(3).
           05 T14F-CARF   PIC 9(3).
           05 FILLER      PIC X(46).
      **** rel 5.0
       01  PAR-D-MDT.
           05 D-MDT-AZI  PIC 999.
           05 D-MDT-TDOC PIC 9.
           05 D-MDT-KEY  PIC X(15).
      ************
       LINKAGE SECTION.
           COPY 'gribctrg'.
       01  IF-MESS    PIC X(204).
       PROCEDURE DIVISION USING RG-BCT-CTRL
                                RG-BCT-REC
                                RA-BCT-AGG
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclclf'.
           COPY 'dcltab'.
           COPY 'dclord'.
           COPY 'dclrig'.
           COPY 'dclbct'.
           COPY 'dclbcr'.
           COPY 'dclart'.
           COPY 'dclard'.
           COPY 'dclobc'.
      **** rel 1.2
      *    COPY 'dclcgg'.
      ************
           COPY 'dclban'.
           COPY 'dclacc'.
      **** rel 2.0
           COPY 'dclpor'.
           COPY 'dclpbr'.
           COPY 'dclncr'.
      ************
      **** rel 6.3
           COPY 'dcliri'.
      ************
      **** rel 7.1
           COPY 'dclaor'.
           COPY 'dclact'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO RG-BCT-ST.
      **** rel 5.0
           MOVE ZERO TO RG-BCT-IMU-SW.
           MOVE ZERO TO RG-BCT-IMU-TUTTI.
      ************
           MOVE SPACE TO IF-MESS.
           IF RG-BCT-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE RG-BCT-FUN   TO FUN.
           MOVE RG-BCT-IDX   TO IDX.
           MOVE RG-BCT-CAMPO TO CAMPO.
           MOVE ZERO TO FLCK.

           IF FUN = 'I' GO TO F-INIINS.
           IF FUN = 'K' GO TO F-KEYINS.
           IF FUN = 'X' GO TO F-ANNINS.
           IF FUN = 'R' OR
                    'r' PERFORM MOVE-KEY
                        MOVE ZERO TO RG-BCT-EOF
                        GO TO F-READ.
           IF FUN = 'N' OR
                    'n' OR
                    'P' OR
                    'p' PERFORM READ-N-P THRU EX-READ-N-P
                        GO TO F-READ.
           IF FUN = 'U' GO TO F-UNLOCK.
           IF FUN = 'S' GO TO F-SCRIVI.
           IF FUN = 'A' GO TO F-AGGIOR.
           IF FUN = 'D' GO TO F-DELETE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'E' GO TO F-EXIT.
      **** rel 5.0
           IF FUN = 'v' GO TO F-VISUAL.
      ************
           MOVE 'vordg30: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-INIINS.
           MOVE ZERO TO RG-BCT-EOF.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM AZZ-RG-RA THRU EX-AZZ-RG-RA.
           PERFORM INI-CAMPI THRU EX-INI-CAMPI.
           GO TO FINE.
      * - - - - - *
       F-KEYINS.
           PERFORM MOVE-KEY.
           PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI.
           IF VFLD > ZERO
              MOVE VCAMPO TO RG-BCT-CAMPO
              GO TO ERRFIELD.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY = ZERO
              PERFORM AZZ-REC THRU EX-AZZ-REC
              PERFORM ERR-CPRE
              GO TO WARNING.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM INS-OK  THRU EX-INS-OK.
           GO TO FINE.
      * - - - - - *
       F-ANNINS.
           IF FUN-PREC = 'X' GO TO FINE.
           PERFORM INS-NO THRU EX-INS-NO.
           GO TO FINE.
      * - - - - - *
       F-READ.
           IF FUN = 'r' MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM ERR-CINE
              GO TO WARNING.
           IF RG-BCT-ST = 7 GO TO FINE.
      **** rel 2.0
           MOVE ZERO TO FLGAGG.
           IF RG-BCT-TDOC = 8 OR 9 MOVE 1 TO FLGAGG.
      ************
      *    IF FUN = 'r' PERFORM DB-STORNA THRU EX-DB-STORNA.
           PERFORM CARICA-RG THRU EX-CARICA-RG.
           PERFORM CARICA-RA THRU EX-CARICA-RA.
           IF FUN = 'r' PERFORM DB-STORNA THRU EX-DB-STORNA
                        IF SWDGEST NOT = ZERO
      **** rel 2.0
                           UNLOCK BOLCTE
      ************
                           MOVE 4 TO ERRIO-ST
                           GO TO GEN-MESS.
           GO TO FINE.
      * - - - - - *
       F-UNLOCK.
           IF FUN-PREC = 'U' GO TO FINE.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           UNLOCK BOLCTE.
           GO TO F-READ.
      * - - - - - *
       F-SCRIVI.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
      *    PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           WRITE RF-BCT INVALID
              PERFORM INVK-BCT
              GO TO ERRIO.
      **** rel 7.1
           MOVE KBC-AZI TO KACT-AZI.
           MOVE KBC-NUM TO KACT-NUM.
           MOVE KBC-BOL TO KACT-BOL.
           WRITE RF-ACT INVALID
              PERFORM INVK-ACT
              GO TO ERRIO.
      ************
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
      **** rel 5.0
           MOVE ZERO  TO MU-FUNZ.
           PERFORM G-IMU THRU EX-G-IMU.
      ************
      **** rel 7.1
           MOVE 'I' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-BCT.
      ************
           GO TO FINE.
      * - - - - - *
       F-AGGIOR.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
      *    PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           REWRITE RF-BCT INVALID
              PERFORM INVK-BCT
              GO TO ERRIO.
      **** rel 7.1
           MOVE KBC-AZI TO KACT-AZI.
           MOVE KBC-NUM TO KACT-NUM.
           MOVE KBC-BOL TO KACT-BOL.
           REWRITE RF-ACT INVALID
              PERFORM CREA-APPBCT THRU EX-CREA-APPBCT.
      ************
      **** rel 2.0
           MOVE ZERO TO FLGAGG.
           IF BCT-TDOC = 8 OR 9 MOVE 1 TO FLGAGG.
      ************
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           PERFORM E00-VAR-RIG THRU E99.
      **** rel 5.1
           IF BCT-VALUT = VALUT
              PERFORM MOD-LVE-RIG THRU EX-MOD-LVE-RIG.
      ************
      **** rel 5.0
           MOVE ZERO  TO MU-FUNZ.
           PERFORM G-IMU THRU EX-G-IMU.
      ************
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-BCT.
      ************
           UNLOCK BOLCTE.
           GO TO FINE.
      * - - - - - *
       F-DELETE.
           PERFORM MOVE-KEY.
           MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM INVK-BCT
              GO TO WARNING.
           IF RG-BCT-ST = 7 GO TO FINE.
           PERFORM DB-STORNA THRU EX-DB-STORNA.
           IF SWDGEST NOT = ZERO UNLOCK BOLCTE
                                 MOVE 4 TO ERRIO-ST
                                 GO TO GEN-MESS.
      **** rel 2.0
           MOVE ZERO TO FLGAGG.
           IF BCT-TDOC = 8 OR 9 MOVE 1 TO FLGAGG.
      ************
           PERFORM C00-DEL-RIG THRU C99.
      **** rel 5.0
      * campi che servono poi all'interfaccia per richiamare rximu
           MOVE BCT-DATA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA  TO RG-BCT-DATA.
           MOVE BCT-CLI TO RG-BCT-CLI.
      ************
           DELETE BOLCTE INVALID
              PERFORM INVK-BCT
              GO TO ERRIO.
      **** rel 7.1
           MOVE KBC-AZI TO KACT-AZI.
           MOVE KBC-NUM TO KACT-NUM.
           MOVE KBC-BOL TO KACT-BOL.
           DELETE APPBCT.
      ************
      **** rel 5.0
           MOVE 1 TO MU-FUNZ.
           PERFORM G-IMU THRU EX-G-IMU.

           MOVE KBC-AZI TO D-MDT-AZI
           MOVE 1       TO D-MDT-TDOC
           MOVE KEYBC   TO D-MDT-KEY
           CALL 'vrdlmdt' USING PAR-D-MDT.
      ************
           UNLOCK BOLCTE.
      **** rel 7.1
           MOVE BCT-DATA  TO DTINT.
           MOVE 'C' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-BCT.
      ************
      **** rel 5.1
           MOVE ZERO      TO PPAR-FUN.
           MOVE 'BOL'     TO PPAR-TARC.
           MOVE 'C'       TO PPAR-TOPE.
           MOVE KEYBC     TO PPAR-KEY.
           MOVE SPACE     TO PPAR-OPZ.
      **** rel 5.1-1
      *    MOVE BCT-DATA  TO PPAR-OPZ(1:3).
      *    MOVE BCT-CLI   TO PPAR-OPZ(4:3).
           MOVE BCT-DATA  TO DTINT.
           MOVE BCT-CLI   TO CLIINT.
           MOVE DTINT     TO PPAR-OPZ(1:5).
           MOVE CLIINT    TO PPAR-OPZ(6:5).
           MOVE ZERO      TO PPAR-CATT.
      **************
           CALL 'vsrv130' USING PARPPAR.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore chiamata vsrv130. Errore ' PPAR-ERR
                      DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      ************
      **** rel 6.2
           IF NOT (BCT-TDOC = 8 OR 9) GO TO NOPROF.

           MOVE ZERO      TO PPAR-FUN.
           MOVE 'FAT'     TO PPAR-TARC.
           MOVE 'C'       TO PPAR-TOPE.

           MOVE KBC-AZI   TO PPAR-KEY(1:3).
           MOVE BCT-TDOC  TO PPAR-KEY(4:1).
           MOVE KBC-BOL   TO NFAT.
           MOVE XNFAT     TO PPAR-KEY(5:3).
           MOVE SPACE     TO PPAR-OPZ.
           MOVE BCT-DATA  TO DTINT.
           MOVE BCT-CLI   TO CLIINT.
           MOVE DTINT     TO PPAR-OPZ(1:5).
           MOVE CLIINT    TO PPAR-OPZ(6:5).
           MOVE BCT-CATT  TO PPAR-CATT.

           CALL 'vsrv130' USING PARPPAR.
           IF PPAR-ERR > 1 
              MOVE SPACE TO MESS
              STRING 'Errore chiamata vsrv130. Errore ' PPAR-ERR
                      DELIMITED SIZE INTO MESS
              GO TO ERRIO.
       NOPROF.
      ************
           GO TO FINE.
      **** rel 5.0
      * - - - - - *
       F-VISUAL.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           MOVE ZERO TO MU-FUNZ.
           PERFORM G-IMU THRU EX-G-IMU.
           GO TO FINE.
      ************
      * - - - - - *
       F-WALIDA.
           IF FUN = 'V'
              PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI
              IF VFLD > ZERO GO TO F-W90.
           PERFORM V-DATI THRU EX-V-CHIAVE-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
       F-W90.
           MOVE VCAMPO TO RG-BCT-CAMPO
           GO TO ERRFIELD.
      * - - - - - *
       F-EXIT.
           UNLOCK BOLCTE.
           GO TO CHIUDI.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO RG-BCT-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI
                 ANABAN
                 TABELL
                 ANACLF
      **** rel 1.2
      *          CAMGIO
      ************
                 ORDRIG
                 BOLCTE
                 BOLCRI
                 MAGART
                 MAGARD
      **** rel 2.0
                 NOTBCR
                 PROBCR
                 PRORIG
      ************
      **** rel 5.0-1
                 ORDCLI
      ************
      **** rel 6.3
                 INDIRI
      ************
      **** rel 7.1
                 APPORD
                 APPBCT
      ************
                 BOLORD.
           MOVE ZERO TO SWINI.
       FINE.
           MOVE RG-BCT-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO RG-BCT-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
      **** rel 1.2
           COPY 'erreur'.
      ************
           COPY 'griazier'.
           COPY 'griclfer'.
           COPY 'griorder'.
           COPY 'gririger'.
           COPY 'gribcter'.
           COPY 'gribcrer'.
      **** rel 1.2
      *    COPY 'gricgger'.
      ************
           COPY 'griarter'.
           COPY 'griarder'.
           COPY 'griobcer'.
           COPY 'gribaner'.
           COPY 'griaccer'.
           COPY 'gritaber'.
      **** rel 2.0
           COPY 'griporer'.
           COPY 'gripbrer'.
           COPY 'grincrer'.
      ************
      **** rel 6.3
           COPY 'griirier'.
      ************
      **** rel 7.1
           COPY 'griaorer'.
           COPY 'griacter'.
      ************
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione
      *    (ins/mod/vis/canc + validazioni + aggiornamenti)
       INI-ELABORA.
           OPEN I-O ANAAZI
                    TABELL
                    BOLCTE
                    BOLCRI
                    MAGART
                    MAGARD
                    ORDRIG
      **** rel 2.0
                    NOTBCR
                    PROBCR
                    PRORIG
      ************
      **** rel 7.1
                    APPBCT
      ************
                    BOLORD.
           OPEN INPUT ANACLF
      **** rel 5.0-1
                      ORDCLI
      ************
      **** rel 1.2
                      ANABAN.
      *               ANABAN
      *               CAMGIO.
      ************
      **** rel 6.3
           OPEN INPUT INDIRI.
      ************
      **** rel 7.1
           OPEN INPUT APPORD.
      ************
      *
           MOVE RG-BCT-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID
                PERFORM INVK-AZI
                GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
      *
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM INVK-TAB
                GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MFOR TO MFOR.
           MOVE T01-MCLI TO MCLI.
      *
           MOVE 14 TO KTB-TIP.
           MOVE 6  TO KTB-COD.
           READ TABELL INTO RKT14F INVALID
                PERFORM INVK-TAB GO TO ERRIO.
           IF RG-BCT-NUM < 7 GO TO INI10.
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '0'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID
                       PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE T25-DUP TO DTAIVA.
           MOVE 2 TO TIPOP1.
           MOVE DTAIVA TO AAGGG.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO DATIVB.
      **** rel 6.2
      *> legge se la numerazione tra bolle e fatture 
      *> deve essere disgiunta.
           MOVE 28         TO T28-TIP.
           MOVE KAZ-COD    TO T28-COD.
           MOVE 8          TO T28-PRG.
           MOVE T28-KEYID  TO KEYTB.
           READ TABELL INTO REKT28 INVALID  
                                   PERFORM INVK-TAB
                                   GO TO ERRIO.
           MOVE T28-8NDISG TO FLG8D.
      ************
      *
       INI10.
      **** rel 6.3
           CALL 'vrpint' USING PARPINT.
      ************
      **** rel 4.0
           CALL 'rveur' USING COMEURO.
      *
      ************
           MOVE 1 TO SWINI.
           MOVE ZERO TO RG-BCT-EOF.
       EX-INI-ELABORA.
           EXIT.
      *------------------
       AZZ-REC.
           MOVE ZERO TO RF-BCT.
           MOVE ZERO TO  BCT-DATA   BCT-CLI    BCT-CDEP  BCT-CSPE
                         BCT-CPOR   BCT-CPAG   BCT-CAMGG BCT-CBAN
                         BCT-ESIVA  BCT-VALUT  BCT-DTORD BCT-SCIMP
                         BCT-CAGE   BCT-ACCON  BCT-NUFAT BCT-LISRF
                         BCT-GGESC  BCT-DTRA   BCT-CATT.
      **** rel 5.2
           MOVE ZERO TO  BCT-PBASE BCT-PRACC.
      ************
      **** rel 7.1
           MOVE ZERO TO  ACT-TIPO.
      ************
           MOVE SPACE TO BCT-DSORD  BCT-DSFAT  BCT-ZONA  BCT-DESPOR
                         BCT-DESSPE BCT-DRAG   BCT-DIND  BCT-DRAG2
                         BCT-DIND2  BCT-DCIT   BCT-VRAG1 BCT-VIND1
                         BCT-VRAG2  BCT-VIND2  BCT-DEST  BCT-ASPE
                         BCT-NCOL   BCT-CAUT   BCT-NOT1  BCT-NOT2
                         BCT-NOT3   BCT-NOT4   BCT-NOT5.
      **** rel 7.1
           MOVE SPACE TO ACT-IPA ACT-CIG ACT-CUP.
      ************
      **** rel 7.2
           MOVE SPACE TO ACT-FAORD.
      ************
      *
       EX-AZZ-REC.
           EXIT.
      *------------------
       AZZ-RG-RA.
      *
      * salvataggio dei campi chiave fissi
      *    ( ed eventuali altri campi significativi passati in RG e RA )
      *
           MOVE RG-BCT-AZI   TO IF-AZI.
           MOVE RG-BCT-TDOC  TO IF-TDOC.
           MOVE RG-BCT-NUM   TO IF-NUM.
           MOVE RG-BCT-TMODU TO IF-TMODU.
      **** rel 2.0
           MOVE RG-BCT-CATT  TO IF-CATT.
      ************

      * azzeramento aree interfaccia
           MOVE ZERO  TO RG-BCT-REC.
           MOVE SPACE TO RG-BCT-DSORD  RG-BCT-DSFAT  RG-BCT-ZONA.
      **** rel 7.1
           MOVE SPACE TO RG-BCT-IPA RG-BCT-CIG RG-BCT-CUP.
      ************
      **** rel 7.2
           MOVE SPACE TO RG-BCT-FAORD.
      ************
           MOVE ZERO  TO RA-BCT-AGG.
           MOVE SPACE TO RA-BCT-TDOC-D   RA-BCT-CATT-D  RA-BCT-CDCLI-D1
                         RA-BCT-CDCLI-D2 RA-BCT-VALUT-D RA-BCT-CDEP-D
                         RA-BCT-CAUS-D   RA-BCT-ZONA-D  RA-BCT-CAGE-D
                         RA-BCT-CPAG-D   RA-BCT-CBAN-D  RA-BCT-CSPE-D
                         RA-BCT-CPOR-D   RA-BCT-CESE-D  RA-BCT-LISRF-D
      **** rel 6.3
                         RA-BCT-IFAT-D
      ************
                         RA-BCT-LISRF-D1.

      * ripristino dei campi chiave fissi
           MOVE IF-AZI   TO RG-BCT-AZI.
           MOVE IF-TDOC  TO RG-BCT-TDOC.
           MOVE IF-NUM   TO RG-BCT-NUM.
           MOVE IF-TMODU TO RG-BCT-TMODU.
      **** rel 2.0
           MOVE IF-CATT  TO RG-BCT-CATT.
      ************
       EX-AZZ-RG-RA.
           EXIT.
      *------------------
      * inizializzazione campi non vuoti per inserimento (valori di
      * default di chiave o dati per aree di interfaccia)
       INI-CAMPI.
           ACCEPT GGMMAA FROM DATE.
           MOVE GG9    TO AAGGG.
           MOVE AA9    TO GG9.
           MOVE AAGGG  TO AA9.
           MOVE GGMMAA TO RG-BCT-DATA.

      **** rel 5.2
           MOVE 30         TO T30-TIP.
           MOVE RG-BCT-AZI TO T30-COD.
           MOVE '0'        TO T30-PRG.
           MOVE T30-KEYID TO KEYTB.
           READ TABELL INTO REKT30 INVALID MOVE ZERO TO T30-DEPCA
                                           MOVE ZERO TO T30-DEPSC.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT30.
           MOVE T30-DEPSC TO RG-BCT-CDEP.
      ************
      *
      **** rel 2.0
      *    IF RG-BCT-TDOC < 4 AND RG-BCT-CATT = SPACE
      *       MOVE '0' TO RG-BCT-CATT.
           IF RG-BCT-TDOC < 4 OR > 7
              IF RG-BCT-CATT = SPACE
                 MOVE '0' TO RG-BCT-CATT.
           MOVE ZERO TO FLGAGG.
           IF RG-BCT-TDOC = 8 OR 9 MOVE 1 TO FLGAGG.
      ************
      *
      **** rel 2.0
      *    IF RG-BCT-TDOC = 1 OR 2 MOVE T14F-CAVC TO RG-BCT-CAUS.
           IF RG-BCT-TDOC = 1 OR 2 OR 8 OR 9
              MOVE T14F-CAVC TO RG-BCT-CAUS.
      ************
           IF RG-BCT-TDOC = 3      MOVE T14F-CARC TO RG-BCT-CAUS.
           MOVE RG-BCT-CAUS TO KTB-COD.
           MOVE 7           TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                MOVE ALL '*' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-BCT-CAUS-D.
      *
      **** rel 7.1
      *    IF RG-BCT-TDOC > 3 MOVE 1 TO RG-BCT-FLGFT.
           IF RG-BCT-TDOC > 3 MOVE 1 TO RG-BCT-FLGFT
                              MOVE 1 TO RG-BCT-XML.
      ************
           IF RG-BCT-NUM = 7  MOVE 1 TO RG-BCT-FLGIS.
      *
           PERFORM NUM-LEGGI THRU EX-NUM-LEGGI.
           PERFORM CARICA-RA THRU EX-CARICA-RA.
      *
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * aggiornamento dati legati a conferma inserimento
       INS-OK.
           PERFORM NUM-SCRIV THRU EX-NUM-SCRIV.
       EX-INS-OK.
           EXIT.
      *------------------
      * ripristino dati correlati x annullamento inserimento
       INS-NO.
           MOVE RG-BCT-BOL TO COMBOL.
           PERFORM NUM-LEGGI   THRU EX-NUM-LEGGI.
           PERFORM NUM-RISCRIV THRU EX-NUM-RISCRIV.
       EX-INS-NO.
           EXIT.
      *------------------
       MOVE-KEY.
           MOVE RG-BCT-AZI TO KBC-AZI.
           MOVE RG-BCT-NUM TO KBC-NUM.
           MOVE RG-BCT-BOL TO KBC-BOL.
           MOVE KEYBC TO KRIFER.
      *------------------
       READ-K.
           MOVE ZERO TO VKEY.
           MOVE KRIFER TO KEYBC.
           IF FLCK > ZERO GO TO RDK-10.
      *
           READ BOLCTE INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
      **** rel 7.1
           MOVE KBC-AZI TO KACT-AZI.
           MOVE KBC-NUM TO KACT-NUM.
           MOVE KBC-BOL TO KACT-BOL.
           READ APPBCT INVALID 
                PERFORM CREA-APPBCT THRU EX-CREA-APPBCT.
      ************
           GO TO EX-READ-K.
      *
       RDK-10.
           READ BOLCTE KEPT LOCK INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
      **** rel 7.1
           MOVE KBC-AZI TO KACT-AZI.
           MOVE KBC-NUM TO KACT-NUM.
           MOVE KBC-BOL TO KACT-BOL.
           READ APPBCT INVALID 
                PERFORM CREA-APPBCT THRU EX-CREA-APPBCT.
      ************
           IF SF-BCT > ZERO MOVE 7 TO RG-BCT-ST.
      *
       EX-READ-K.
           EXIT.
      *------------------
      * posizionamento su chiave secondaria per successive
      * read next/previous
      *
       SET-KEYSEC.
           MOVE KEYBC TO KRIFER.
           START BOLCTE KEY >= SKEYBC1 INVALID GO TO SET-90.
       SET-10.
           READ BOLCTE NEXT AT END GO TO SET-90.
           IF KEYBC = KRIFER GO TO EX-SET-KEYSEC.
           GO TO SET-10.
       SET-90.
           MOVE 'vordg30: errore di posizionamento su' TO F-MES1.
           MOVE 'chiave secondaria'                    TO F-MES2.
           MOVE 2 TO F-NMES.
           GO TO ERRIO.
       EX-SET-KEYSEC.
           EXIT.
      *------------------
       READ-N-P.
           MOVE ZERO TO EOF.
           IF IDX > 1 PERFORM SET-KEYSEC THRU EX-SET-KEYSEC.
       RNP-10.
           IF FUN = 'P' OR 'p'
              READ BOLCTE PREVIOUS AT END MOVE 1 TO EOF
           ELSE
              READ BOLCTE NEXT AT END MOVE 3 TO EOF.
      **** rel 7.1
           MOVE KBC-AZI TO KACT-AZI.
           MOVE KBC-NUM TO KACT-NUM.
           MOVE KBC-BOL TO KACT-BOL.
           READ APPBCT INVALID 
                PERFORM CREA-APPBCT THRU EX-CREA-APPBCT.
      ************
           IF EOF > ZERO GO TO RNP-80.
           PERFORM TEST-EOL THRU EX-TEST-EOL.
           IF EOF > ZERO GO TO RNP-80.
           IF RF-BCT = LOW-VALUE GO TO RNP-10.
      *
      *    ( inserire qui eventuali controlli sui tipi record:
      *      se record da non trattare go to RNP-10          )
      *
           IF KBC-AZI NOT = RG-BCT-AZI GO TO RNP-10.
           IF KBC-NUM NOT = RG-BCT-NUM GO TO RNP-10.

      * trovato record valido: reset EOF
           MOVE ZERO TO RG-BCT-EOF.
           MOVE KEYBC TO KRIFER.
           GO TO RNP-90.

      * trovato EOF/BOF: set EOF e ripristina chiave iniziale
       RNP-80.
           ADD EOF TO RG-BCT-EOF.
           IF RG-BCT-EOF = 4 MOVE 2 TO RG-BCT-EOF.
           PERFORM MOVE-KEY.

      * continua elaborazione con funzione Read
       RNP-90.
           IF FUN = 'n' OR 'p'
              MOVE 'r' TO FUN
           ELSE
              MOVE 'R' TO FUN.
       EX-READ-N-P.
      *------------------
      * test End Of File logico
      *    Nota: testare anche chiave < (per read previous)
      *
       TEST-EOL.
           IF RF-BCT = LOW-VALUE GO TO EX-TEST-EOL.
           IF IDX > 1 GO TO TEST-EOL-IDX2.
           IF KBC-AZI = RG-BCT-AZI AND
              KBC-NUM = RG-BCT-NUM GO TO EX-TEST-EOL.
           IF FUN = 'P' OR 'p'
              MOVE 1 TO EOF
           ELSE
              MOVE 3 TO EOF.
           GO TO EX-TEST-EOL.
       TEST-EOL-IDX2.
           IF BCT-CLI = RG-BCT-CLI GO TO EX-TEST-EOL.
           IF FUN = 'P' OR 'p'
              MOVE 1 TO EOF
           ELSE
              MOVE 3 TO EOF.
       EX-TEST-EOL.
           EXIT.
      *------------------
       CARICA-REC.
           MOVE RG-BCT-AZI       TO KBC-AZI.
           MOVE RG-BCT-NUM       TO KBC-NUM.
           MOVE RG-BCT-BOL       TO KBC-BOL.
           MOVE RG-BCT-DATA TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO BCT-DATA.
           MOVE RG-BCT-CLI       TO BCT-CLI.
           MOVE RG-BCT-TDOC      TO BCT-TDOC.
           MOVE RG-BCT-FLGFT     TO BCT-FLGFT.
           MOVE RG-BCT-FLGMG     TO BCT-FLGMG.
           MOVE RG-BCT-RAGGR     TO BCT-RAGGR.
           MOVE RG-BCT-CDEP      TO BCT-CDEP.
           MOVE RG-BCT-CSPE      TO BCT-CSPE.
           MOVE RG-BCT-CPOR      TO BCT-CPOR.
           MOVE RG-BCT-CPAG      TO BCT-CPAG.
           MOVE RG-BCT-SCBAS     TO BCT-SCBAS.
           MOVE RG-BCT-CBAN      TO BCT-CBAN.
           MOVE RG-BCT-ESIVA     TO BCT-ESIVA.
           MOVE RG-BCT-VALUT     TO BCT-VALUT.
           MOVE RG-BCT-CAMGG     TO BCT-CAMGG.
           MOVE RG-BCT-NORD      TO BCT-NORD.
           MOVE RG-BCT-DTORD TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO BCT-DTORD.
           MOVE RG-BCT-DSORD     TO BCT-DSORD.
           MOVE RG-BCT-DSFAT     TO BCT-DSFAT.
           MOVE RG-BCT-ZONA      TO BCT-ZONA.
           MOVE RG-BCT-SCIMP     TO BCT-SCIMP.
           MOVE RG-BCT-CAGE      TO BCT-CAGE.
           MOVE RG-BCT-PROVV     TO BCT-PROVV.
           MOVE RG-BCT-CAUS      TO BCT-CAUS.
           MOVE RG-BCT-CDEP2     TO BCT-CDEP2.
           MOVE RG-BCT-CAUC      TO BCT-CAUC.
           MOVE RG-BCT-CATT      TO BCT-CATT.
           MOVE RG-BCT-FLGIS     TO BCT-FLGIS.
           MOVE RG-BCT-ACCON     TO BCT-ACCON.
           MOVE RG-BCT-FLACC     TO BCT-FLACC.
           MOVE RG-BCT-NUDOC     TO BCT-NUDOC.
           MOVE RG-BCT-NUFAT     TO BCT-NUFAT.
           MOVE RG-BCT-TMODU     TO BCT-TMODU.
           MOVE RG-BCT-LISRF     TO BCT-LISRF.
           MOVE RG-BCT-GGESC     TO BCT-GGESC.
           MOVE RG-BCT-LCONS     TO BCT-LCONS.
      **** rel 6.3
           MOVE RG-BCT-IFAT      TO BCT-IFAT.
      ************
      **** rel 7.1
           MOVE W-BCT-VETT       TO BCT-VCOD1.
      ************
      **** rel 2.0
           MOVE RG-BCT-IMB       TO BCT-IMB.
           MOVE RG-BCT-ESCFAT    TO BCT-ESCFAT.
           MOVE RG-BCT-STAMP     TO BCT-STAMP.
           MOVE RA-BCT-CSPE-D    TO BCT-DESSPE.
           MOVE RA-BCT-CPOR-D    TO BCT-DESPOR.
      ************
      **** rel 5.2
           MOVE RG-BCT-PBASE     TO BCT-PBASE.
           MOVE RG-BCT-PRACC     TO BCT-PRACC.
      ************
      **** rel 7.1
           MOVE RG-BCT-TIPO      TO ACT-TIPO. 
           MOVE RG-BCT-IPA       TO ACT-IPA.
           MOVE RG-BCT-CIG       TO ACT-CIG.
           MOVE RG-BCT-CUP       TO ACT-CUP.
           MOVE RG-BCT-XML       TO BCT-XML.
      ************
      **** rel 7.2
           MOVE RG-BCT-FAORD     TO ACT-FAORD.
           MOVE RG-BCT-FADTORD TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG            TO ACT-FADTORD.
      ************
      *
           MOVE 2 TO BCT-FLGMG.
      **** rel 7.1
      *    IF RG-BCT-TDOC > 3 MOVE 1 TO BCT-FLGFT.
           IF RG-BCT-TDOC > 3 MOVE 1 TO BCT-FLGFT
                              MOVE 1 TO BCT-XML.
      ************
           IF RG-BCT-NUM = 7  MOVE 1 TO BCT-FLGIS.
           IF RG-BCT-NUM = 8 OR 9 MOVE ZERO TO BCT-FLGIS.
       EX-CARICA-REC.
           EXIT.
      *------------------
       CARICA-RG.
           MOVE KBC-AZI       TO RG-BCT-AZI.
           MOVE KBC-NUM       TO RG-BCT-NUM.
           MOVE KBC-BOL       TO RG-BCT-BOL.
           MOVE BCT-DATA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-BCT-DATA.
           MOVE BCT-CLI       TO RG-BCT-CLI.
           MOVE BCT-TDOC      TO RG-BCT-TDOC.
           MOVE BCT-FLGFT     TO RG-BCT-FLGFT.
      **** rel 7.1
           MOVE BCT-XML       TO RG-BCT-XML.
      ************
           MOVE BCT-FLGMG     TO RG-BCT-FLGMG.
           MOVE BCT-RAGGR     TO RG-BCT-RAGGR.
           MOVE BCT-CDEP      TO RG-BCT-CDEP.
           MOVE BCT-CSPE      TO RG-BCT-CSPE.
           MOVE BCT-CPOR      TO RG-BCT-CPOR.
           MOVE BCT-CPAG      TO RG-BCT-CPAG.
           MOVE BCT-SCBAS     TO RG-BCT-SCBAS.
           MOVE BCT-CBAN      TO RG-BCT-CBAN.
           MOVE BCT-ESIVA     TO RG-BCT-ESIVA.
           MOVE BCT-VALUT     TO RG-BCT-VALUT.
           MOVE RG-BCT-VALUT TO COMVALUT.
           MOVE BCT-CAMGG     TO RG-BCT-CAMGG.
           MOVE BCT-NORD      TO RG-BCT-NORD.
           MOVE BCT-DTORD TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-BCT-DTORD.
           MOVE BCT-DSORD     TO RG-BCT-DSORD.
           MOVE BCT-DSFAT     TO RG-BCT-DSFAT.
           MOVE BCT-ZONA      TO RG-BCT-ZONA.
           MOVE BCT-SCIMP     TO RG-BCT-SCIMP.
           MOVE BCT-CAGE      TO RG-BCT-CAGE.
           MOVE BCT-PROVV     TO RG-BCT-PROVV.
           MOVE BCT-CAUS      TO RG-BCT-CAUS.
           MOVE BCT-CDEP2     TO RG-BCT-CDEP2.
           MOVE BCT-CAUC      TO RG-BCT-CAUC.
           MOVE BCT-CATT      TO RG-BCT-CATT.
           MOVE BCT-FLGIS     TO RG-BCT-FLGIS.
           MOVE BCT-ACCON     TO RG-BCT-ACCON.
           MOVE BCT-FLACC     TO RG-BCT-FLACC.
           MOVE BCT-NUDOC     TO RG-BCT-NUDOC.
           MOVE BCT-NUFAT     TO RG-BCT-NUFAT.
           MOVE BCT-TMODU     TO RG-BCT-TMODU.
           MOVE BCT-LISRF     TO RG-BCT-LISRF.
           MOVE BCT-GGESC     TO RG-BCT-GGESC.
           MOVE BCT-LCONS     TO RG-BCT-LCONS.
      **** rel 6.3
           MOVE BCT-IFAT      TO RG-BCT-IFAT.
      ************
      **** rel 7.1
           MOVE BCT-VCOD1     TO W-BCT-VETT.
      ************
      **** rel 2.0
           MOVE BCT-IMB       TO RG-BCT-IMB.
           MOVE BCT-ESCFAT    TO RG-BCT-ESCFAT.
           MOVE BCT-STAMP     TO RG-BCT-STAMP.
      ************
      **** rel 5.2
           MOVE BCT-PBASE     TO RG-BCT-PBASE.
           MOVE BCT-PRACC     TO RG-BCT-PRACC.
      ************
      **** rel 7.1
           MOVE ACT-TIPO      TO RG-BCT-TIPO. 
           MOVE ACT-IPA       TO RG-BCT-IPA.
           MOVE ACT-CIG       TO RG-BCT-CIG.
           MOVE ACT-CUP       TO RG-BCT-CUP.
      ************
      **** rel 7.2
           MOVE ACT-FAORD     TO RG-BCT-FAORD.
           MOVE ACT-FADTORD TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-BCT-FADTORD.
      ************
       EX-CARICA-RG.
           EXIT.
      *------------------
       CARICA-RA.
           MOVE ELVBOL(RG-BCT-TDOC) TO RA-BCT-TDOC-D.
      *
      **** rel 7.1
           MOVE ZERO     TO RA-BCT-FELE.
      ************
      **** rel 2.0
      *    IF RG-BCT-TDOC > 3 GO TO A20-VIS-DAT.
           IF RG-BCT-TDOC > 3 AND < 8 GO TO A20-VIS-DAT.
      ************
           MOVE RG-BCT-CATT TO T35-CATT.
           IF T35-CATT = ZERO OR SPACE MOVE
              "ATTIVITA' PRINCIPALE" TO RA-BCT-CATT-D
              GO TO A20-VIS-DAT.
           MOVE 35         TO T35-TIP.
           MOVE RG-BCT-AZI TO T35-CDAZ.
           MOVE T35-KEYID  TO KEYTB.
           READ TABELL INTO REKT35 INVALID
                MOVE ALL '*' TO T35-DATT.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT35.
           MOVE T35-DATT TO RA-BCT-CATT-D.
      **** rel 7.1
           MOVE T35-FELE TO RA-BCT-FELE.
      ************
       A20-VIS-DAT.
           IF RG-BCT-CDEP = ZERO
              MOVE SPACE TO RA-BCT-CDEP-D
              GO TO A30.
           MOVE RG-BCT-CDEP TO KTB-COD.
           MOVE 12          TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                MOVE ALL '*' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-BCT-CDEP-D.
       A30.
           IF RG-BCT-CLI = ZERO
              MOVE SPACE TO RA-BCT-CDCLI-D1
                            RA-BCT-CDCLI-D2
              GO TO A35.
           IF RG-BCT-TDOC = 6 OR 7
              MOVE MFOR TO MAS
           ELSE
              MOVE MCLI TO MAS.
           MOVE RG-BCT-CLI TO COD.
           MOVE RG-BCT-AZI TO KCF-AZI.
           MOVE CODICE     TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID
                MOVE ALL '*' TO CLF-RGS
                MOVE SPACE   TO CLF-RGS2
      **** rel 5.1
                MOVE ZERO    TO CLF-VAL
      ************
                MOVE ZERO    TO CLF-LIS.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
           MOVE CLF-RGS  TO RA-BCT-CDCLI-D1.
           MOVE CLF-RGS2 TO RA-BCT-CDCLI-D2.
      **** rel 5.1
           MOVE CLF-VAL  TO VALUT.
      ************
       A35.
      *
           IF RG-BCT-VALUT = ZERO
              MOVE SPACE TO RA-BCT-VALUT-D
              GO TO A50.
      **** rel 1.2
      *    MOVE RG-BCT-VALUT TO KTB-COD.
      *    MOVE 10           TO KTB-TIP.
      *    READ TABELL INTO REKTAB INVALID
      *         MOVE ALL '*' TO T10-DSINT.
      *    IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      *    MOVE TAB-DESCR TO RA-BCT-VALUT-D.
           MOVE RG-BCT-VALUT TO ER-VALUT.
           MOVE RG-BCT-DATA TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO ER-DATA
           CALL 'rvalut' USING ER-VALUT ER-DATA CG-PAR.
           IF CG-ST > ZERO
              MOVE ALL '*' TO RA-BCT-VALUT-D
           ELSE
              MOVE CG-DESCR TO RA-BCT-VALUT-D.
      ************
           IF RG-BCT-VALUT = BCT-VALUT GO TO A50.
           MOVE ZERO TO RG-BCT-CAMGG AAGGG.
      **** rel 1.2
      *    IF RG-BCT-VALUT = 1 MOVE 1 TO RG-BCT-CAMGG
      **** rel 4.0
      *    IF RG-BCT-VALUT = 1 MOVE CG-CAMBIO TO RG-BCT-CAMGG
           IF RG-BCT-VALUT = COMEURO
                               MOVE CG-CAMBIO TO RG-BCT-CAMGG
      ************
      ************
                               MOVE ZERO TO RA-BCT-DTCGG
                               GO TO A50.
      **** rel 1.2
      *    MOVE RG-BCT-DATA TO GGMMAA.
      *    MOVE 1 TO TIPOP1.
      *    CALL 'rdata' USING PARCDT.
      *    MOVE AAGGG TO COMDAT.
      *    MOVE ZERO TO RG-BCT-CAMGG.
      *    MOVE KTB-COD TO KCG-VAL.
      *    MOVE ZERO    TO KCG-GIO.
      *    START CAMGIO KEY NOT < KEYCG INVALID GO TO A50.
      *A30-10.
      *    READ CAMGIO NEXT AT END GO TO A50.
      *    IF KCG-VAL > RG-BCT-VALUT GO TO A50.
      *    COMPUTE AAGGG = 99999 - KCG-GIO.
      *    IF AAGGG > COMDAT GO TO A30-10.
      *    MOVE CGG-CAMBIO TO RG-BCT-CAMGG.
           MOVE CG-CAMBIO  TO RG-BCT-CAMGG.
           MOVE CG-DTCAM   TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RA-BCT-DTCGG.
      ************
       A50.
           IF RG-BCT-CDEP = ZERO
              MOVE SPACE TO RA-BCT-CDEP-D
              GO TO A60.
           MOVE RG-BCT-CDEP TO KTB-COD.
           MOVE 12          TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                MOVE ALL '*' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-BCT-CDEP-D.
       A60.
           IF RG-BCT-CAUS = ZERO
              MOVE SPACE TO RA-BCT-CAUS-D
              GO TO A70.
           MOVE RG-BCT-CAUS TO KTB-COD.
           MOVE 7           TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                MOVE ALL '*' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-BCT-CAUS-D.
       A70.
           IF RG-BCT-CDEP2 = ZERO
              MOVE SPACE TO RA-BCT-CDEP2-D
              GO TO A80.
           MOVE RG-BCT-CDEP2 TO KTB-COD.
           MOVE 12           TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                MOVE ALL '*' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-BCT-CDEP2-D.
       A80.
           IF RG-BCT-CAUC = ZERO
              MOVE SPACE TO RA-BCT-CAUC-D
              GO TO A90.
           MOVE RG-BCT-CAUC TO KTB-COD.
           MOVE 7           TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                MOVE ALL '*' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-BCT-CAUC-D.
       A90.
       B00-VIS-CLI.
           IF RG-BCT-ZONA = SPACE
              MOVE SPACE TO RA-BCT-ZONA-D
              GO TO B10.
           MOVE 17          TO T17-TIP.
           MOVE RG-BCT-ZONA TO T17-COD.
           MOVE T17-KEYID   TO KEYTB.
           READ TABELL INTO REKTAB INVALID
                MOVE ALL '*' TO T17-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T17-DESCR TO RA-BCT-ZONA-D.
       B10.
           IF RG-BCT-CAGE = ZERO
              MOVE SPACE TO RA-BCT-CAGE-D
              GO TO B20.
           MOVE RG-BCT-CAGE TO KTB-COD.
           MOVE 9           TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                MOVE ALL '*' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-BCT-CAGE-D.
           IF KBC-AZI = ZERO AND RG-BCT-NORD = ZERO
              MOVE T09-XCPR TO RG-BCT-PROVV.
       B20.
           IF RG-BCT-CPAG = ZERO
              MOVE SPACE TO RA-BCT-CPAG-D
              GO TO B30.
           MOVE RG-BCT-CPAG TO KTB-COD.
           MOVE 4           TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                MOVE ALL '*' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-BCT-CPAG-D.
       B30.
           IF RG-BCT-CBAN = ZERO
              MOVE SPACE TO RA-BCT-CBAN-D
              GO TO B40.
           MOVE RG-BCT-CBAN TO KBA-BAN.
           READ ANABAN INVALID
                MOVE ALL '*' TO BAN-RGSOC.
           MOVE BAN-RGSOC TO RA-BCT-CBAN-D.
       B40.
           IF RG-BCT-ESIVA = ZERO
              MOVE 'SOGGETTO AD IVA' TO RA-BCT-CESE-D
              GO TO B50.
           MOVE RG-BCT-ESIVA TO KTB-COD.
           MOVE 3            TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                MOVE ALL '*' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T03-ALIVA NOT = ZERO MOVE 'SOGGETTO AD IVA' TO TAB-DESCR.
           MOVE TAB-DESCR TO RA-BCT-CESE-D.
       B50.
           IF RG-BCT-CSPE = ZERO
              MOVE SPACE TO RA-BCT-CSPE-D
              GO TO B60.
           MOVE RG-BCT-CSPE TO KTB-COD.
           MOVE 6           TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                MOVE ALL '*' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-BCT-CSPE-D.
       B60.
           IF RG-BCT-CPOR = ZERO
              MOVE SPACE TO RA-BCT-CPOR-D
              GO TO B70.
           MOVE RG-BCT-CPOR TO KTB-COD.
           MOVE 5           TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                MOVE ALL '*' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-BCT-CPOR-D.
       B70.
           IF RG-BCT-LISRF NOT > 3
              MOVE SPACE TO RA-BCT-LISRF-D
                            RA-BCT-LISRF-D1
              GO TO B80.
           MOVE RG-BCT-LISRF TO KTB-COD.
           MOVE 52           TO KTB-TIP.
           READ TABELL INTO REKT52 INVALID
                MOVE ALL '*' TO RA-BCT-LISRF-D
                                RA-BCT-LISRF-D1
                GO TO B80.
           MOVE SPACE TO RA-BCT-LISRF-D1.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT52.
      **** rel 4.0
      *    IF RG-BCT-VALUT NOT > 1 AND T52-VALUT = ZERO
           IF (RG-BCT-VALUT = ZERO OR COMEURO) AND T52-VALUT = ZERO
      ************
              MOVE SPACE TO RA-BCT-LISRF-D
                            RA-BCT-LISRF-D1
              GO TO B75.
           MOVE 10        TO KTB-TIP.
           MOVE T52-VALUT TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE SPACE TO T10-DSINT.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T10-DSINT TO RA-BCT-LISRF-D.
       B75.
           IF T52-DTDEC = ZERO AND T52-DTVAL = ZERO
      **** rel 4.1a
      *       MOVE SPACE TO RA-BCT-LISRF-D1
              MOVE T52-DESCR TO RA-BCT-LISRF-D1
      ************
              GO TO B80.
           MOVE RG-BCT-DATA TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF AAGGG  < T52-DTDEC OR > T52-DTVAL
              MOVE '* NON IN VIGORE *' TO RA-BCT-LISRF-D1
      **** rel 4.1a
      *    ELSE  MOVE SPACE TO RA-BCT-LISRF-D1.
           ELSE  MOVE T52-DESCR TO RA-BCT-LISRF-D1.
      ************
       B80.
      **** rel 6.1
           MOVE ZERO TO RA-BCT-DTFAT.
           IF BCT-NUFAT NOT = ZERO
      **** rel 6.3
      *       MOVE KBC-AZI   TO CFT-AZI
      *       MOVE BCT-NUDOC TO CFT-TDOC
      *       MOVE BCT-NUFAT TO CFT-NUM
      *       MOVE BCT-CATT  TO CFT-CATT
      *       CALL 'rdfat' USING CFT-FAT
      *       IF KBC-AZI NOT = ZERO
      *          MOVE CFT-DATA TO AAGGG
      *          MOVE 2        TO TIPOP1
      *          CALL 'rdata' USING PARCDT
      *          MOVE GGMMAA  TO RA-BCT-DTFAT.
              IF KBC-AZI NOT = ZERO
                 MOVE KBC-AZI   TO CFT-AZI
                 MOVE BCT-NUDOC TO CFT-TDOC
                 MOVE BCT-NUFAT TO CFT-NUM
                 MOVE BCT-CATT  TO CFT-CATT
                 CALL 'rdfat' USING CFT-FAT
                 MOVE 1 TO INDB
                 IF CFT-NUM NOT = ZERO
                    CALL 'rdbfa' USING CFT-CATT CFT-FT PARRB
                    PERFORM UNTIL INDB = ZERO OR INDB > RB-ULTBOL
                       IF KBC-NUM = RB-TNUM(INDB) AND
                          KBC-BOL = RB-NBOL(INDB)
                             MOVE ZERO TO INDB
                       ELSE
                          ADD 1 TO INDB
                    END-PERFORM
                 END-IF
                 IF INDB = ZERO
                    MOVE CFT-DATA TO AAGGG
                    MOVE 2        TO TIPOP1
                    CALL 'rdata' USING PARCDT
                    MOVE GGMMAA  TO RA-BCT-DTFAT
                 ELSE
                    MOVE ZERO        TO PARLPD
                    MOVE 'R'         TO PLPD-FUN
                    MOVE 'FAT'       TO PLPD-TDOC
                    MOVE KBC-AZI     TO PLPD-AZI
                    IF PINT-I-AZI NOT = SPACE
                       MOVE PINT-I-AZI TO PLPD-AZI
                    END-IF
                    MOVE 'INT'       TO PLPD-TIPO
                    MOVE BCT-DATA  TO AAGGG
                    MOVE 2 TO TIPOP1
                    CALL 'rdata' USING PARCDT
                    MOVE AA4         TO PLPD-ANNO
                    MOVE SPACE       TO PLPD-KEY
                    MOVE KBC-AZI     TO PLPD-KEY(1:3)
                    IF BCT-TDOC = 8 OR 9
                       MOVE BCT-TDOC TO PLPD-KEY(4:1)
                       MOVE KBC-BOL  TO NUFAT
                       MOVE XNUFAT   TO PLPD-KEY(5:)
                    ELSE
                       MOVE BCT-KFATT TO PLPD-KEY(4:)
                    END-IF
                    MOVE BCT-CATT    TO PLPD-CATT
                    CALL 'vrc-lpd' USING PARXCD PARLPD
                    IF PLPD-PROG NOT = ZERO
                       MOVE PLPD-DTDOC TO AAGGG
                       MOVE 2        TO TIPOP1
                       CALL 'rdata' USING PARCDT
                       MOVE GGMMAA  TO RA-BCT-DTFAT.
      *
      **** rel 6.3
           IF RG-BCT-IFAT = ZERO
              MOVE SPACE TO RA-BCT-IFAT-D
              GO TO RVID-30.
           MOVE RG-BCT-AZI  TO KII-AZI.
           MOVE MCLI        TO KII-MS.
           MOVE RG-BCT-CLI  TO KII-CD.
           MOVE RG-BCT-IFAT TO KII-PRG.
           READ INDIRI INVALID KEY
                MOVE 'D' TO IRI-TIPO
                MOVE ALL '*' TO IRI-RGSOC.
           IF IRI-TIPO = 'D' MOVE IRI-RGSOC TO RA-BCT-IFAT-D
              ELSE IF IRI-TIPO = 'L' MOVE IRI-DESDI TO RA-BCT-IFAT-D
                   ELSE MOVE ALL '*' TO RA-BCT-IFAT-D.
       RVID-30.
      ************
      ************
      ************
      *
       EX-CARICA-RA.
           EXIT.
      *------------------
      * validazione dei campi chiave (NB: di RG-BCT-REC)
       V-CHIAVE.
           MOVE ZERO TO VFLD.
      *
       V-BOL.
           MOVE 'BCT-BOL' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-BOL.
           IF RG-BCT-BOL = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-BOL.
      *
           GO TO EX-V-CHIAVE-DATI.
      *------------------
      * validazione dei campi non chiave (NB: di RG-BCT-REC)
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-DATA.
           MOVE 'BCT-DATA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA.
           MOVE 1 TO TIPOP1.
           MOVE RG-BCT-DATA TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           IF RG-BCT-NUM < 7 GO TO E-DATA.
           IF AAGGG NOT > DTAIVA
                        MOVE 2 TO F-NMES
                        MOVE 'Totali IVA aggiornati al' TO F-MES1
                        MOVE DATIVB TO F-MES2
                        GO TO V-ERROR.
       E-DATA.
      *
       V-CATT.
           MOVE 'BCT-CATT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CATT.
      **** rel 2.0
      *    IF RG-BCT-NUM > 6 OR RG-BCT-TDOC > 3 GO TO E-CATT.
           IF RG-BCT-NUM > 6 OR (RG-BCT-TDOC > 3 AND < 8) GO TO E-CATT.
      ************
      **** rel 5.0-2
           IF RG-BCT-NORD = ZERO GO TO NO-ORD.
           MOVE RG-BCT-AZI  TO KOR-AZI.
           MOVE RG-BCT-NORD TO KOR-NUM.
           READ ORDCLI INTO REKORD INVALID KEY
                MOVE 'Ordine inesistente' TO MESS
                GO TO V-ERROR.
           IF SF-ORD = '9D' OR '9A' OR '35' MOVE RF-ORD TO REKORD.
           IF ORD-CATT NOT = RG-BCT-CATT
              MOVE 2 TO F-NMES
              MOVE "Codice attivita' diverso da" TO F-MES1
              MOVE "quello caricato sull'ordine" TO F-MES2
              GO TO V-ERROR.
       NO-ORD.
      **************
      **** rel 7.1
           MOVE ZERO     TO RA-BCT-FELE.
      ************
           IF RG-BCT-CATT = ZERO
              MOVE 'ATTIVITA'' PRINCIPALE' TO RA-BCT-CATT-D
              GO TO E-CATT.
           MOVE 35          TO T35-TIP.
           MOVE RG-BCT-AZI  TO T35-CDAZ.
           MOVE RG-BCT-CATT TO T35-CATT.
           MOVE T35-KEYID TO KEYTB.
           READ TABELL INTO REKT35 INVALID KEY
                MOVE SPACE TO RA-BCT-CATT-D
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT35.
           MOVE T35-DATT TO RA-BCT-CATT-D.
      **** rel 7.1
           MOVE T35-FELE TO RA-BCT-FELE.
      ************
       E-CATT.
      *
      *
       V-NORD.
           MOVE 'BCT-NORD' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-NORD.
      **** rel 2.0
      *    IF RG-BCT-TDOC > 2 GO TO E-NORD.
      **** rel 6.1
      *    IF RG-BCT-TDOC > 2 AND < 8 GO TO E-NORD.
           IF RG-BCT-TDOC = 3 OR 6 OR 7 GO TO E-NORD.
      ************
      ************
      **** rel 3.0b
           IF KBC-AZI NOT = ZERO GO TO E-NORD.
      ************
           IF RG-BCT-NORD = ZERO
              MOVE ZERO TO RG-BCT-DTORD
                           RG-BCT-LCONS
      **** rel 7.1
      **** rel 6.3
      *                    RG-BCT-IFAT
      ************
      ************
              GO TO E-NORD.
           MOVE ZERO        TO KEYOR.
           MOVE RG-BCT-AZI  TO KOR-AZI.
           MOVE RG-BCT-NORD TO KOR-NUM.
      **** rel 5.0-1
      *    OPEN INPUT ORDCLI.
      ************
           READ ORDCLI INTO REKORD INVALID KEY
      **** rel 5.0-1
      *         CLOSE ORDCLI
      ************
                MOVE 'Ordine inesistente' TO MESS
                GO TO V-ERROR.
           IF SF-ORD = '9D' OR '9A' OR '35' MOVE RF-ORD TO REKORD.
      **** rel 5.0-1
      *    CLOSE ORDCLI.
      ************
      **** rel 2.0
      *    IF RG-BCT-TDOC = 2 AND ORD-VALUT = ZERO
           IF (RG-BCT-TDOC = 2 OR 9) AND ORD-VALUT = ZERO
      ************
              MOVE "Manca codice divisa sull'ordine" TO MESS
              GO TO V-ERROR.
      **** rel 2.0
      *    IF ( RG-BCT-TDOC < 2 OR > 3 ) AND ORD-VALUT > ZERO
           IF NOT (RG-BCT-TDOC = 2 OR 3 OR 9) AND ORD-VALUT > ZERO
      ************
              MOVE 'Ordine in valuta' TO MESS
              GO TO V-ERROR.
      **** rel 5.0-2
      *    IF ORD-CATT NOT = RG-BCT-CATT
      *       MOVE 2 TO F-NMES
      *       MOVE "Codice attivita' diverso da" TO F-MES1
      *       MOVE "quello caricato sull'ordine" TO F-MES2
      *       GO TO V-ERROR.
      **************
      **** rel 6.2
      * per le fatture accompagnatorie il controllo sulla attivit 
      * deve essere fatto altrimenti le testate non vengono presentate
      * correttamente nello zoom
           IF RG-BCT-NUM = 8 OR 9
              IF ORD-CATT NOT = RG-BCT-CATT
                 MOVE 2 TO F-NMES
                 MOVE "Codice attivita' diverso da" TO F-MES1
                 MOVE "quello caricato sull'ordine" TO F-MES2
                 GO TO V-ERROR.
      ************
           IF FUN NOT = 'V' GO TO E-NORD.
      **** rel 7.1
           MOVE KOR-AZI TO KAOR-AZI.
           MOVE KOR-NUM TO KAOR-NUM.
           READ APPORD INVALID
      **** rel 7.2
      *         MOVE SPACE TO AOR-IPA AOR-CIG AOR-CUP. 
                MOVE SPACE TO AOR-IPA AOR-CIG AOR-CUP AOR-FAORD
                MOVE ZERO TO AOR-FADTORD.
      ************
      ************
           MOVE ORD-DAT TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA    TO RG-BCT-DTORD.
           MOVE ORD-CDCLI TO RG-BCT-CLI.
           MOVE ORD-VALUT TO RG-BCT-VALUT.
           MOVE ORD-CDEP  TO RG-BCT-CDEP.
           MOVE ORD-CDSPE TO RG-BCT-CSPE.
           MOVE ORD-CDPOR TO RG-BCT-CPOR.
           MOVE ORD-CDPAG TO RG-BCT-CPAG.
           MOVE ORD-PERSC TO RG-BCT-SCBAS.
           MOVE ORD-CDBAN TO RG-BCT-CBAN.
           MOVE ORD-CDESE TO RG-BCT-ESIVA.
           MOVE ORD-ZONA  TO RG-BCT-ZONA.
           MOVE ORD-CDAGE TO RG-BCT-CAGE.
           MOVE ORD-VSORD TO RG-BCT-DSORD.
           MOVE ORD-SCONT TO RG-BCT-SCIMP.
           MOVE ORD-PROVV TO RG-BCT-PROVV.
           MOVE ORD-LISRF TO RG-BCT-LISRF.
           MOVE ORD-LCONS TO RG-BCT-LCONS.
      **** rel 7.1
           MOVE AOR-IPA TO RG-BCT-IPA.
           MOVE AOR-CIG TO RG-BCT-CIG.
           MOVE AOR-CUP TO RG-BCT-CUP.
      ************
      **** rel 7.2
           MOVE AOR-FAORD   TO RG-BCT-FAORD.
           MOVE AOR-FADTORD TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA    TO RG-BCT-FADTORD.
      ************
      **** rel 6.3
           MOVE RG-BCT-AZI TO KII-AZI.
           MOVE MCLI       TO KII-MS.
           MOVE RG-BCT-CLI TO KII-CD.
           MOVE ORD-IFAT   TO RG-BCT-IFAT KII-PRG.
           READ INDIRI INVALID MOVE SPACE TO IRI-RGSOC
                                             IRI-DESDI
                                             RA-BCT-IFAT-D
                               MOVE ZERO TO  RG-BCT-IFAT
                                             GO TO NO-IFAT.
      *
           IF IRI-TIPO = 'D' MOVE IRI-RGSOC TO RA-BCT-IFAT-D
              ELSE IF IRI-TIPO = 'L' MOVE IRI-DESDI TO RA-BCT-IFAT-D
                   ELSE MOVE SPACE TO RA-BCT-IFAT-D
                        MOVE 'Tipo indirizzo non valido' TO MESS
                        GO TO V-ERROR.
       NO-IFAT.
      ************
      **** rel 5.0-2
           MOVE ORD-CATT  TO RG-BCT-CATT.
      **************
      **** rel 7.1
           MOVE ORD-VETT  TO W-BCT-VETT.
      ************
      **** rel 1.2
           IF RG-BCT-TDOC = 6 OR 7
              MOVE MFOR TO MAS
           ELSE
              MOVE MCLI TO MAS.
           MOVE RG-BCT-CLI TO COD.
           MOVE RG-BCT-AZI TO KCF-AZI.
           MOVE CODICE     TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID
                IF MAS = MFOR
                   MOVE 'Fornitore inesistente' TO MESS
                ELSE
                   MOVE 'Cliente inesistente'   TO MESS
                GO TO V-ERROR.
      **** rel 6.0
           MOVE RG-BCT-AZI TO RACF-AZI.
           MOVE CODICE     TO RACF-COD.
           CALL 'rrdacf' USING PARACF.
      ************
           IF NOT (RG-BCT-TDOC = 6 OR 7)
              MOVE CLF-RBOL TO RG-BCT-RAGGR.
      ************
           PERFORM A20-VIS-DAT THRU EX-CARICA-RA.
           IF RG-BCT-VALUT NOT = ZERO
              PERFORM G00-RD-CAMBI THRU G99.
       E-NORD.
      *
       V-CLI.
           MOVE 'BCT-CLI' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CLI.
           IF RG-BCT-NORD NOT = ZERO GO TO E-CLI.
           IF RG-BCT-CLI = ZERO
              MOVE SPACE TO RA-BCT-CDCLI-D1
                            RA-BCT-CDCLI-D2
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           IF RG-BCT-CLI = BCT-CLI GO TO E-CLI.
           IF RG-BCT-TDOC = 6 OR 7
              MOVE MFOR TO MAS
           ELSE
              MOVE MCLI TO MAS.
           MOVE RG-BCT-CLI TO COD.
           MOVE RG-BCT-AZI TO KCF-AZI.
           MOVE CODICE     TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID
                MOVE SPACE TO RA-BCT-CDCLI-D1
                              RA-BCT-CDCLI-D2
                MOVE ZERO  TO CLF-VAL
                PERFORM ERR-CINE
                GO TO V-ERROR.
      **** rel 6.0
           MOVE RG-BCT-AZI TO RACF-AZI.
           MOVE CODICE     TO RACF-COD.
           CALL 'rrdacf' USING PARACF.
      ************
           MOVE CLF-RGS  TO RA-BCT-CDCLI-D1.
           MOVE CLF-RGS2 TO RA-BCT-CDCLI-D2.
      **** rel 5.1
           MOVE CLF-VAL  TO VALUT.
      ************
           IF FUN NOT = 'V' GO TO E-CLI.
           IF NOT (RG-BCT-TDOC = 6 OR 7)
              MOVE CLF-RBOL TO RG-BCT-RAGGR.
           IF AZI-FLGIS NOT = ZERO AND
              RG-BCT-NUM    = 7    AND
              CLF-FLGIS NOT = 1
                  MOVE 'Non prevede fatture in sospeso' TO MESS
                  GO TO V-ERROR.
      **** rel 2.0
      *    IF RG-BCT-TDOC = 2 OR
           IF RG-BCT-TDOC = 2 OR 9 OR
      ************
              (RG-BCT-TDOC = 3 AND RG-BCT-NUM NOT = 7)
               MOVE CLF-VAL TO RG-BCT-VALUT.
           IF RG-BCT-VALUT NOT = ZERO
              PERFORM G00-RD-CAMBI THRU G99.
           IF RG-BCT-NORD NOT = ZERO GO TO E-CLI.
           MOVE CLF-MSPE TO RG-BCT-CSPE.
           MOVE CLF-PORT TO RG-BCT-CPOR.
           MOVE CLF-CPAG TO RG-BCT-CPAG.
           MOVE CLF-SCBS TO RG-BCT-SCBAS.
           MOVE CLF-BANC TO RG-BCT-CBAN.
      **** rel 5.2
           PERFORM RD-CDPAG THRU EX-RD-CDPAG.
      ************
           MOVE CLF-ESEN TO RG-BCT-ESIVA.
           MOVE CLF-ZONA TO RG-BCT-ZONA.
           MOVE CLF-AGEN TO RG-BCT-CAGE.
           MOVE CLF-LIS  TO RG-BCT-LISRF.
      **** rel 7.1
           MOVE CLF-VETT TO W-BCT-VETT.
      ************
           IF RG-BCT-LISRF = ZERO MOVE CLF-TPRZ TO RG-BCT-LISRF.
           PERFORM B00-VIS-CLI THRU EX-CARICA-RA.
      **** rel 6.3
           IF CLF-IFAT = ZERO 
              MOVE SPACE TO RA-BCT-IFAT-D
              GO TO E-CLI.
           MOVE RG-BCT-AZI TO KII-AZI.
           MOVE MCLI       TO KII-MS.
           MOVE RG-BCT-CLI TO KII-CD.
           MOVE CLF-IFAT TO RG-BCT-IFAT KII-PRG.
           READ INDIRI INVALID MOVE SPACE TO IRI-RGSOC IRI-DESDI
                                             RA-BCT-IFAT-D
                               MOVE ZERO TO RG-BCT-IFAT
                                             GO TO E-CLI.
           IF IRI-TIPO = 'D' MOVE IRI-RGSOC TO RA-BCT-IFAT-D
              ELSE IF IRI-TIPO = 'L' MOVE IRI-DESDI TO RA-BCT-IFAT-D
                   ELSE MOVE SPACE TO RA-BCT-IFAT-D
                        MOVE 'Tipo indirizzo non valido' TO MESS
                        GO TO V-ERROR.
      ************
       E-CLI.
      *
       V-VALUT.
           MOVE 'BCT-VALUT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-VALUT.
           IF RG-BCT-VALUT = ZERO
      **** rel 2.0
      *       IF RG-BCT-TDOC = 2
              IF RG-BCT-TDOC = 2 OR 9
      ************
                 PERFORM ERR-ZERO
                 GO TO V-ERROR
              ELSE
              MOVE SPACE TO RA-BCT-VALUT-D
              MOVE ZERO  TO RG-BCT-CAMGG
                            RA-BCT-DTCGG
              GO TO V-VALUT-20.
      **** rel 2.0
      *    IF (RG-BCT-TDOC < 2 OR > 3) OR
           IF NOT (RG-BCT-TDOC = 2 OR 3 OR 9) OR
      ************
              (RG-BCT-TDOC = 3 AND RG-BCT-NUM = 7)
              IF RG-BCT-VALUT NOT = ZERO
                 MOVE 'Documento non in valuta' TO MESS
                 GO TO V-ERROR.
      *
      **** rel 1.2
      *    MOVE 10 TO KTB-TIP.
      *    MOVE RG-BCT-VALUT TO KTB-COD.
      *    READ TABELL INTO REKTAB INVALID
      *         MOVE SPACE TO RA-BCT-VALUT-D
      *         PERFORM ERR-CINE
      *         GO TO V-ERROR.
      *    IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      *    MOVE TAB-DESCR TO RA-BCT-VALUT-D.
      ************
           PERFORM G00-RD-CAMBI THRU G99.
      **** rel 1.2
           IF SWERG00 = 1 GO TO V-ERROR.
           MOVE CG-DESCR TO RA-BCT-VALUT-D.
      ************
       V-VALUT-20.
           MOVE RG-BCT-VALUT TO COMVALUT.
      **** rel 1.2
      **** rel 4.0
      *    IF RG-BCT-VALUT < 2 GO TO E-VALUT.
           IF RG-BCT-VALUT = ZERO GO TO E-VALUT.
      * solo per periodo transitorio
           IF RG-BCT-VALUT = 1    GO TO E-VALUT.
      ************
           IF RG-BCT-ESIVA NOT = ZERO GO TO E-VALUT.
      **** rel 4.0
      *    CALL 'rveur' USING ER-VALUT.
      *    IF RG-BCT-VALUT NOT = ER-VALUT
      **** rel 4.0-2
      *    IF RG-BCT-VALUT NOT = COMEURO
      ************
      ************
      **** rel 4.0-2
      *       MOVE 'Soggetto ad IVA, Divisa non valida' TO MESS
      *       GO TO V-ERROR.
      ************
      ************
       E-VALUT.
      *
       V-CAMGG.
           MOVE 'BCT-CAMGG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CAMGG.
           IF RG-BCT-VALUT NOT = COMVALUT
              MOVE 'Divisa non valida' TO MESS
              MOVE ZERO  TO RG-BCT-CAMGG
                            RA-BCT-DTCGG
              MOVE COMVALUT TO RG-BCT-VALUT
              GO TO V-ERROR.
      **** rel 4.0
      *    IF RG-BCT-VALUT < 2 GO TO E-CAMGG.
           IF (RG-BCT-VALUT = ZERO OR COMEURO) GO TO E-CAMGG.
      ************
      **** rel 1.2
           MOVE RG-BCT-VALUT TO ER-VALUT.
           MOVE RA-BCT-DTCGG TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO ER-DATA.
           CALL 'rvalut' USING ER-VALUT ER-DATA CG-PAR.
           IF CG-ST > ZERO
              PERFORM ERR-EURO
              GO TO V-ERROR.
           MOVE CG-CAMBIO TO RG-BCT-CAMGG.
      ************
           MOVE RG-BCT-DATA TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO COMDAT.
           MOVE RA-BCT-DTCGG TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF AAGGG > COMDAT
                 MOVE 'Data cambio maggiore di data documento' TO MESS
                 GO TO V-ERROR.
      **** rel 4.0
           MOVE RG-BCT-CAMGG TO EC-CAMBIO.
           CALL 're2cam' USING EC-PAR.
           IF EC-CAMBIO NOT = RG-BCT-CAMGG
              PERFORM ERR-CAMB
              GO TO V-ERROR.
      ************
       E-CAMGG.
      *
       V-CDEP.
           MOVE 'BCT-CDEP' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CDEP.
           MOVE SPACE TO RA-BCT-CDEP-D.
           IF RG-BCT-CDEP = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE RG-BCT-CDEP TO KTB-COD.
           MOVE 12          TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-BCT-CDEP-D.
       E-CDEP.
      *
       V-CAUS.
           MOVE 'BCT-CAUS' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CAUS.
           MOVE SPACE TO RA-BCT-CAUS-D.
           IF RG-BCT-CAUS = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE RG-BCT-CAUS TO KTB-COD.
           MOVE 7           TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF RG-BCT-NUM < 7
              IF (RG-BCT-TDOC = 4 OR 6) AND T07-DUPL = ZERO
                  MOVE 'Causale non di trasferimento' TO MESS
                  GO TO V-ERROR.
           IF RG-BCT-NUM < 7
              IF NOT (RG-BCT-TDOC = 4 OR 6) AND T07-DUPL > ZERO
                      MOVE 'Causale di trasferimento' TO MESS
                      GO TO V-ERROR.
           IF RG-BCT-TDOC NOT = 3
              IF T07-AGGES NOT = '-'
                 MOVE 'Causale non di scarico' TO MESS
                 GO TO V-ERROR.
           MOVE TAB-RST TO RA-BCT-CAUS-D.
       E-CAUS.
      *
       V-CDEP2.
           MOVE 'BCT-CDEP2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CDEP2.
           MOVE SPACE TO RA-BCT-CDEP2-D.
           IF NOT (RG-BCT-TDOC = 4 OR 6)
              IF RG-BCT-CDEP2 NOT = ZERO
                 PERFORM ERR-DINV
                 GO TO V-ERROR
              ELSE GO TO E-CDEP2.
           IF RG-BCT-CDEP2 = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           IF RG-BCT-CDEP2 = RG-BCT-CDEP
              PERFORM ERR-DINC
              GO TO V-ERROR.
           MOVE RG-BCT-CDEP2 TO KTB-COD.
           MOVE 12           TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-BCT-CDEP2-D.
      *
       E-CDEP2.
      *
       V-CAUC.
           MOVE 'BCT-CAUC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CAUC.
           MOVE SPACE TO RA-BCT-CAUC-D.
           IF NOT (RG-BCT-TDOC = 4 OR 6)
              IF RG-BCT-CAUC NOT = ZERO
                 PERFORM ERR-DINV
                 GO TO V-ERROR
              ELSE GO TO E-CAUC.
           IF RG-BCT-CAUC = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           IF RG-BCT-CAUC = RG-BCT-CAUS
              PERFORM ERR-DINC
              GO TO V-ERROR.
           MOVE 7           TO KTB-TIP.
           MOVE RG-BCT-CAUC TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T07-DUPL = ZERO
                  MOVE 'Causale non di trasferimento' TO MESS
                  GO TO V-ERROR.
           IF T07-AGGES NOT = '+'
                     MOVE 'Causale non di carico' TO MESS
                     GO TO V-ERROR.
           MOVE TAB-RST TO RA-BCT-CAUC-D.
       E-CAUC.
      *
       V-FLGFT.
           MOVE 'BCT-FLGFT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FLGFT.
           IF RG-BCT-FLGFT > 1
              PERFORM ERR-DINV
              GO TO V-ERROR.
       E-FLGFT.
      *
       V-ZONA.
           MOVE 'BCT-ZONA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ZONA.
           MOVE SPACE TO RA-BCT-ZONA-D.
           IF RG-BCT-ZONA = SPACE
              GO TO E-ZONA.
           MOVE 17          TO T17-TIP.
           MOVE RG-BCT-ZONA TO T17-COD.
           MOVE T17-KEYID   TO KEYTB.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T17-DESCR TO RA-BCT-ZONA-D.
       E-ZONA.
      *
       V-CAGE.
           MOVE 'BCT-CAGE' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CAGE.
           MOVE SPACE TO RA-BCT-CAGE-D.
           IF RG-BCT-CAGE = ZERO
      **** rel 5.2
              IF RG-BCT-TDOC = 6 OR 7
                 MOVE SPACE TO RA-BCT-CAGE-D
                 GO TO E-CAGE
              ELSE
      ************
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE RG-BCT-CAGE TO KTB-COD.
           MOVE 9           TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-BCT-CAGE-D.
           IF FUN NOT = 'V' GO TO E-CAGE.
           IF KBC-AZI = ZERO AND RG-BCT-NORD = ZERO
              MOVE T09-XCPR TO RG-BCT-PROVV.
       E-CAGE.
      *
       V-CPAG.
           MOVE 'BCT-CPAG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CPAG.
           MOVE SPACE TO RA-BCT-CPAG-D.
           IF RG-BCT-CPAG = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE RG-BCT-CPAG TO KTB-COD.
           MOVE 4           TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-BCT-CPAG-D.
      **** rel 6.0
      *    IF T04-ESCMM = ZERO OR RG-BCT-NUM < 7
      *       MOVE ZERO TO RG-BCT-GGESC.
           MOVE 1 TO K.
       VPG.
           IF K > 12 GO TO VPG1.
           IF RACF-ESCM(K) = ZERO
              ADD 1 TO K
              GO TO VPG.

           GO TO VPG4.
      *
       VPG1.
           MOVE 1 TO K.
       VPG2.
           IF K > 12 GO TO VPG3.
           IF T04-ESCM(K) = ZERO
              ADD 1 TO K
              GO TO VPG2.
           GO TO VPG4.
       VPG3.
           IF RG-BCT-NUM < 7
              MOVE ZERO TO RG-BCT-GGESC.
       VPG4.
      ************
      **** rel 5.2
           IF FUN NOT = 'V' GO TO E-CPAG.
           IF T04-TIPAG = 1 OR 2
              MOVE CLF-BANC TO RG-BCT-CBAN
           ELSE
              IF CLF-BANCF NOT = ZERO
                 MOVE CLF-BANCF TO RG-BCT-CBAN.
           IF RG-BCT-CBAN = ZERO
              MOVE SPACE TO RA-BCT-CBAN-D
              GO TO E-CPAG.
           MOVE RG-BCT-CBAN TO KBA-BAN.
           READ ANABAN INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           MOVE BAN-RGSOC TO RA-BCT-CBAN-D.
      ************
       E-CPAG.
      *
       V-GGESC.
           MOVE 'BCT-GGESC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-GGESC.
      **** rel 1.2
      *    IF RG-BCT-GGESC = ZERO GO TO E-GGESC.
      *    IF RG-BCT-NUM < 7
      *       MOVE 2 TO F-NMES
      *       MOVE 'Il pagamento selezionato non gestisce' TO F-MES1
      *       MOVE 'il n. giorni di  spostamento scadenze' TO F-MES2
      *       GO TO V-ERROR.
      *    IF RG-BCT-GGESC > 31
      *       PERFORM ERR-DINV
      *       GO TO V-ERROR.
           IF RG-BCT-NUM < 7
              IF RG-BCT-GGESC = ZERO
                 GO TO E-GGESC
              ELSE
                 MOVE 2 TO F-NMES
                 MOVE 'Il pagamento selezionato non gestisce' TO F-MES1
                 MOVE 'il n. giorni di  spostamento scadenze' TO F-MES2
                 GO TO V-ERROR.
      ************
           IF RG-BCT-CPAG = ZERO GO TO E-GGESC.
           MOVE RG-BCT-CPAG TO KTB-COD.
           MOVE 4           TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID GO TO E-GGESC.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      **** rel 1.2
      *    IF T04-ESCMM = ZERO
      *       MOVE 2 TO F-NMES
      *       MOVE '      Dato invalido'       TO F-MES1
      *       MOVE 'Non gestito dal pagamento' TO F-MES2
      *       GO TO V-ERROR.
      **** rel 6.0
      *    IF T04-ESCMM = ZERO
      *       IF RG-BCT-GGESC = ZERO
      *          GO TO E-GGESC
      *       ELSE
      *          MOVE 2 TO F-NMES
      *          MOVE '      Dato invalido'       TO F-MES1
      *          MOVE 'Non gestito dal pagamento' TO F-MES2
      *          GO TO V-ERROR.
           MOVE 1 TO K.
       GES.
           IF K > 12 GO TO GES1.
           IF RACF-ESCM(K) = ZERO
              ADD 1 TO K
              GO TO GES.

           GO TO E-GGESC.
      *
       GES1.
           MOVE 1 TO K.
       GES2.
           IF K > 12 GO TO GES3.
           IF T04-ESCM(K) = ZERO
              ADD 1 TO K
              GO TO GES2.
           GO TO E-GGESC.
       GES3.
           IF RG-BCT-GGESC = ZERO
              GO TO E-GGESC
           ELSE
              MOVE 3 TO F-NMES
              MOVE '      Dato invalido'       TO F-MES1
              MOVE 'Non gestito dal pagamento' TO F-MES2
              MOVE 'o dal cliente.           ' TO F-MES3
              GO TO V-ERROR.
      ************
           IF RG-BCT-GGESC > 31 OR = ZERO
              PERFORM ERR-DINV
              GO TO V-ERROR.
      ************
       E-GGESC.
      *
       V-CBAN.
           MOVE 'BCT-CBAN' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CBAN.
           MOVE SPACE TO RA-BCT-CBAN-D.
           IF RG-BCT-CBAN = ZERO
              IF T04-TIPAG = 1 OR T04-TIPAG = 2
                 PERFORM ERR-ZERO
                 GO TO V-ERROR
              ELSE GO TO E-CBAN.
           MOVE RG-BCT-CBAN TO KBA-BAN.
           READ ANABAN INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           MOVE BAN-RGSOC TO RA-BCT-CBAN-D.
       E-CBAN.
      *
       V-ESIVA.
           MOVE 'BCT-ESIVA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ESIVA.
           MOVE SPACE TO RA-BCT-CESE-D.
      **** rel 1.2
      **** rel 4.0
      *    CALL 'rveur' USING ER-VALUT.
      ************
      ************
           IF RG-BCT-ESIVA = ZERO
      **** rel 1.2
      *       IF RG-BCT-VALUT > ZERO
      *          PERFORM ERR-DINV
      **** rel 4.0
      *       IF NOT (RG-BCT-VALUT = ZERO OR 1 OR ER-VALUT)
      **** rel 4.0-2
      *       IF NOT (RG-BCT-VALUT = ZERO OR 1 OR COMEURO)
      ************
      ************
      **** rel 4.0-2
      *          MOVE 'Con la divisa selezionata non e''' TO F-MES1
      *          MOVE 'consentito emettere un documento'  TO F-MES2
      *          MOVE 'soggetto ad IVA'                   TO F-MES3
      *          MOVE 3 TO F-NMES
      ************
      ************
      **** rel 4.0-2
      *          GO TO V-ERROR
      *       ELSE
      ************
                 MOVE 'SOGGETTO AD IVA' TO RA-BCT-CESE-D
                 GO TO E-ESIVA.
           MOVE RG-BCT-ESIVA TO KTB-COD.
           MOVE 3            TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T03-ALIVA NOT = ZERO
              MOVE 'Codice IVA errato ' TO MESS
              GO TO V-ERROR.
           MOVE TAB-DESCR TO RA-BCT-CESE-D.
       E-ESIVA.
      *
       V-CSPE.
           MOVE 'BCT-CSPE' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CSPE.
           MOVE SPACE TO RA-BCT-CSPE-D.
           IF RG-BCT-CSPE = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE RG-BCT-CSPE TO KTB-COD.
           MOVE 6           TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-BCT-CSPE-D.
       E-CSPE.
      *
       V-CPOR.
           MOVE 'BCT-CPOR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CPOR.
           MOVE SPACE TO RA-BCT-CPOR-D.
           IF RG-BCT-CPOR = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE RG-BCT-CPOR TO KTB-COD.
           MOVE 5           TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO RA-BCT-CPOR-D.
       E-CPOR.
      *
       V-LISRF.
           MOVE 'BCT-LISRF' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-LISRF.
           MOVE SPACE TO RA-BCT-LISRF-D
                         RA-BCT-LISRF-D1.
           IF RG-BCT-LISRF NOT > 3 GO TO E-LISRF.
           MOVE RG-BCT-LISRF TO KTB-COD.
           MOVE 52           TO KTB-TIP.
           READ TABELL INTO REKT52 INVALID
                MOVE ALL '*' TO RA-BCT-LISRF-D
                                RA-BCT-LISRF-D1
                GO TO E-LISRF.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT52.
      **** rel 4.0
      *    IF (RG-BCT-VALUT > 1 AND T52-VALUT NOT = RG-BCT-VALUT) OR
      *       (RG-BCT-VALUT < 2 AND T52-VALUT NOT = ZERO)
           IF ( NOT (RG-BCT-VALUT = ZERO OR COMEURO) AND
                    (T52-VALUT NOT = RG-BCT-VALUT))   OR
              (RG-BCT-VALUT = ZERO OR COMEURO) AND T52-VALUT NOT = ZERO
      ************
                  MOVE 'Valuta diversa su listino' TO MESS
                  GO TO V-ERROR.
      **** rel 4.0
      *    IF RG-BCT-VALUT NOT > 1 AND T52-VALUT = ZERO
           IF (RG-BCT-VALUT = ZERO OR COMEURO) AND T52-VALUT = ZERO
      ************
              GO TO V-LISRF-10.
           MOVE 10        TO KTB-TIP.
           MOVE T52-VALUT TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE SPACE TO T10-DSINT.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T10-DSINT TO RA-BCT-LISRF-D.
       V-LISRF-10.
           IF T52-DTDEC = ZERO AND T52-DTVAL = ZERO
      **** rel 4.1a
              MOVE T52-DESCR TO RA-BCT-LISRF-D1
      ************
              GO TO E-LISRF.
           MOVE RG-BCT-DATA TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF AAGGG  < T52-DTDEC OR > T52-DTVAL
              MOVE '* NON IN VIGORE *' TO RA-BCT-LISRF-D1
      **** rel 4.1a
      *    ELSE  MOVE SPACE TO RA-BCT-LISRF-D1.
           ELSE  MOVE T52-DESCR TO RA-BCT-LISRF-D1.
      ************
       E-LISRF.
      *
      **** rel 7.1
       V-IPA.
           MOVE 'BCT-IPA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IPA.
           IF RA-BCT-FELE = ZERO
              GO TO E-IPA.
           IF RG-BCT-IPA = SPACE OR ZERO OR LOW-VALUE
              PERFORM ERR-ZERO
              GO TO V-ERROR. 
       E-IPA.
      *
      ************
      **** rel 7.2
       V-FAORD.
           MOVE 'BCT-FAORD' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FAORD.
           IF RG-BCT-CIG = SPACE AND
              RG-BCT-CUP = SPACE
              GO TO E-FAORD.
      *
           IF RG-BCT-FAORD = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-FAORD.
      *
       V-FADTORD.
           MOVE 'BCT-FADTORD' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FADTORD.
           IF RG-BCT-FADTORD = ZERO
              GO TO E-FADTORD.
      *
           MOVE 1 TO TIPOP1.
           MOVE RG-BCT-FADTORD TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-FADTORD.
      *
      ************
      **** rel 6.3
       V-IFAT.
           MOVE 'BCT-IFAT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IFAT.
           IF RG-BCT-IFAT = ZERO 
              MOVE SPACE TO RA-BCT-IFAT-D
              GO TO E-IFAT.
      *
           MOVE RG-BCT-AZI  TO KII-AZI.
           MOVE MCLI        TO KII-MS.
           MOVE RG-BCT-CLI  TO KII-CD.
           MOVE RG-BCT-IFAT TO KII-PRG.
           READ INDIRI INVALID MOVE SPACE TO RA-BCT-IFAT-D
                               MOVE ZERO TO RG-BCT-IFAT
                               PERFORM ERR-CINE
                               GO TO V-ERROR.
           IF IRI-TIPO = 'D' MOVE IRI-RGSOC TO RA-BCT-IFAT-D
              ELSE IF IRI-TIPO = 'L' MOVE IRI-DESDI TO RA-BCT-IFAT-D
                   ELSE MOVE SPACE TO RA-BCT-IFAT-D
                        MOVE 'Tipo indirizzo non valido' TO MESS
                        GO TO V-ERROR.
      *
       E-IFAT.
      ************
       V-ACCON.
           MOVE 'BCT-ACCON' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ACCON.
           IF RG-BCT-ACCON = ZERO GO TO E-ACCON.
      **** rel 4.0
      *    IF RG-BCT-TDOC NOT = 1 OR RG-BCT-FLGIS NOT = ZERO
           IF RG-BCT-FLGIS NOT = ZERO
      ************
              PERFORM ERR-DINV
              GO TO V-ERROR.
       E-ACCON.
      *
       V-FLGIS.
           MOVE 'BCT-FLGIS' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FLGIS.
           IF FUN = 'V' GO TO E-FLGIS.
           IF RG-BCT-NUM > 6   OR
              AZI-FLGIS = ZERO OR
              CLF-FLGIS = ZERO OR
              NOT (RG-BCT-TDOC = 1 OR 3) GO TO E-FLGIS.
           IF RG-BCT-TDOC = 3 AND RG-BCT-VALUT NOT = ZERO
              MOVE ZERO TO RG-BCT-FLGIS
              GO TO E-FLGIS.
           IF RG-BCT-ACCON NOT = ZERO
              MOVE ZERO TO RG-BCT-FLGIS
              GO TO E-FLGIS.
      * --- forza da interfaccia richiesta flag in sospeso.
           GO TO V-QUESTION.
       E-FLGIS.
      *
           GO TO EX-V-CHIAVE-DATI.
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-CHIAVE-DATI.
           EXIT.
      *------------------
      * storno dati correlati
       DB-STORNA.
      **** rel 2.0
      *    MOVE ZERO TO SWDGEST.
      *    IF BCT-FLGFT NOT = ZERO AND BCT-TDOC < 4
      *       MOVE "Bolla gia' fatturata" TO MESS
      *       MOVE 1 TO SWDGEST
      *       GO TO EX-DB-STORNA.
      *    IF BCT-FLGMG NOT = 2
      *       MOVE 'Bolla non gestibile' TO MESS
      *       MOVE 1 TO SWDGEST
      *       GO TO EX-DB-STORNA.
      ************
           MOVE ZERO TO PARMAG M-ODAT M-NDAT.
           MOVE SPACE TO M-NBOF.
           MOVE 'V' TO M-TIPO.
           MOVE KBC-AZI   TO M-AZI.
           MOVE BCT-TDOC  TO M-TDOC.
           MOVE KBC-NUM   TO M-TNUM.
           MOVE KBC-BOL   TO M-NBOL.
           MOVE BCT-DATA  TO M-ODAT M-NDAT.
           MOVE BCT-CLI   TO COD.
           MOVE CODICE    TO M-CLFO.
           MOVE BCT-CDEP  TO M-DEP1.
           MOVE BCT-CDEP2 TO M-DEP2.
           MOVE BCT-CAUS  TO M-NCA1.
           MOVE BCT-CAUC  TO M-NCA2.
           MOVE BCT-CPAG  TO M-NPAG.
           MOVE BCT-VALUT TO M-NVAL.
           MOVE BCT-CAMGG TO M-NCAM.
           MOVE BCT-SCBAS TO SCBAS.
      **** rel 2.0
           MOVE ZERO TO SWDGEST.
           IF BCT-FLGFT NOT = ZERO AND BCT-TDOC < 4
              MOVE "Bolla gia' fatturata" TO MESS
              MOVE 1 TO SWDGEST
              GO TO EX-DB-STORNA.
           IF BCT-FLGMG NOT = 2
              MOVE 'Bolla non gestibile' TO MESS
              MOVE 1 TO SWDGEST
              GO TO EX-DB-STORNA.
      ************
       EX-DB-STORNA.
           EXIT.
      *------------------
      * aggiornamento dati correlati
       DB-AGGIORNA.
           PERFORM AGG-ACC THRU EX-AGG-ACC.
      *
       EX-DB-AGGIORNA.
           EXIT.
      *------------------
       NUM-LEGGI.
      **** rel 6.2
      *    IF RG-BCT-NUM > 6 GO TO NUML-FAT.
      * slegato l'inserimento delle fatture interattive di attivit <> 0
      * il numero bolla con il numero fattuta
           IF RG-BCT-NUM = 8 AND FLG8D = 1
              GO TO NUML-BOL.
      *    IF RG-BCT-NUM > 6 AND RG-BCT-NUM NOT = 8
           IF RG-BCT-NUM > 6 AND (RG-BCT-NUM NOT = 8 OR FLG8D = ZERO)
              GO TO NUML-FAT.
      *
       NUML-BOL.
      ************
      *
      * numerazione bolle
      *
           MOVE 28         TO T28-TIP.
           MOVE KAZ-COD    TO T28-COD.
           MOVE RG-BCT-NUM TO T28-PRG.
           MOVE T28-KEYID  TO KEYTB.
       LPLCK.
           READ TABELL INTO REKT28 KEPT LOCK INVALID
                                 PERFORM INVK-TAB
                                 GO TO ERRIO.
           IF SF-TAB > ZERO
              PERFORM REC-LOCK
              GO TO LPLCK.

           MOVE T28-NBOLC TO RG-BCT-BOL.
           GO TO NUML99.
      *
      * numerazione fatture
      *
       NUML-FAT.
           IF RG-BCT-NUM NOT = 7 GO TO NFL-NOGIS.
           IF AZI-FLGIS = 2      GO TO NFL-NOGIS.
           MOVE 23        TO T23-TIP.
           MOVE KAZ-COD   TO T23-COD.
           MOVE T23-KEYID TO KEYTB.
       NUML-FAT10.
           READ TABELL INTO REKT23 KEPT LOCK INVALID KEY
                                 PERFORM INVK-TAB
                                 GO TO ERRIO.
           IF SF-TAB > ZERO
              PERFORM REC-LOCK
              GO TO NUML-FAT10.
           MOVE T23-FTSOS TO RG-BCT-BOL.
           GO TO NUML99.
       NFL-NOGIS.
           IF RG-BCT-CATT NOT = '0' GO TO NFL-ATTNO0.
           READ ANAAZI INTO REKAZI KEPT LOCK INVALID KEY
                PERFORM INVK-AZI
                GO TO ERRIO.
           IF SF-AZI > ZERO
              PERFORM REC-LOCK
              GO TO NFL-NOGIS.
           MOVE AZI-NUMFT TO RG-BCT-BOL.
           GO TO NUML99.
       NFL-ATTNO0.
      **** rel 7.1
           MOVE ZERO     TO RA-BCT-FELE.
      ************
           MOVE 35          TO T35-TIP.
           MOVE KAZ-COD     TO T35-CDAZ.
           MOVE RG-BCT-CATT TO T35-CATT.
           MOVE T35-KEYID   TO KEYTB.
           READ TABELL INTO REKT35 KEPT LOCK INVALID KEY
                                 PERFORM INVK-TAB
                                 GO TO ERRIO.
           IF SF-TAB > ZERO
              PERFORM REC-LOCK
              GO TO NFL-ATTNO0.
           MOVE T35-NUMFT TO RG-BCT-BOL.
      **** rel 7.1
           MOVE T35-FELE TO RA-BCT-FELE.
      ************
       NUML99.
           ADD 1 TO RG-BCT-BOL.
       EX-NUM-LEGGI.
           EXIT.
      *------------------
       NUM-SCRIV.
      **** rel 6.2
      *    IF RG-BCT-NUM > 6 GO TO NUMS-FAT.
      * slegato l'inserimento delle fatture interattive di attivit <> 0
      * il numero bolla con il numero fattuta
           IF RG-BCT-NUM = 8 AND FLG8D = 1
              GO TO NUMS-BOL.
      *    IF RG-BCT-NUM > 6 AND RG-BCT-NUM NOT = 8
           IF RG-BCT-NUM > 6 AND (RG-BCT-NUM NOT = 8 OR FLG8D = ZERO)
              GO TO NUMS-FAT.
      *
       NUMS-BOL.
      ************
      *
      * numerazione bolle
      *
           IF RG-BCT-BOL > T28-NBOLC MOVE RG-BCT-BOL TO T28-NBOLC.
           REWRITE RF-TAB FROM REKT28 INVALID
                          PERFORM INVK-TAB GO TO ERRIO.
           UNLOCK TABELL.
           GO TO EX-NUM-SCRIV.
      *
      * numerazione fatture
      *
       NUMS-FAT.
           IF RG-BCT-NUM NOT = 7 GO TO NFS-NOGIS.
           IF AZI-FLGIS = 2 GO TO NFS-NOGIS.
           IF RG-BCT-BOL > T23-FTSOS MOVE RG-BCT-BOL TO T23-FTSOS.
           REWRITE RF-TAB FROM REKT23 INVALID
                          PERFORM INVK-TAB GO TO ERRIO.
           UNLOCK TABELL.
           GO TO EX-NUM-SCRIV.
       NFS-NOGIS.
           IF RG-BCT-CATT NOT = '0' GO TO NFS-ATTNO0.
           IF RG-BCT-BOL > AZI-NUMFT MOVE RG-BCT-BOL TO AZI-NUMFT.
           REWRITE RF-AZI FROM REKAZI INVALID
                          PERFORM INVK-AZI GO TO ERRIO.
           UNLOCK ANAAZI.
           GO TO EX-NUM-SCRIV.
       NFS-ATTNO0.
           IF RG-BCT-BOL > T35-NUMFT MOVE RG-BCT-BOL TO T35-NUMFT.
           REWRITE RF-TAB FROM REKT35 INVALID
                          PERFORM INVK-TAB GO TO ERRIO.
           UNLOCK TABELL.
       EX-NUM-SCRIV.
           EXIT.
      *------------------
       NUM-RISCRIV.
      **** rel 6.2
      *    IF RG-BCT-NUM > 6 GO TO NUMR-FAT.
      * slegato l'inserimento delle fatture interattive di attivit <> 0
      * il numero bolla con il numero fattuta
           IF RG-BCT-NUM = 8 AND FLG8D = 1
              GO TO NUMR-BOL.
      *    IF RG-BCT-NUM > 6 AND RG-BCT-NUM NOT = 8
      **** rel 7.1
      *    IF RG-BCT-NUM > 6 AND (RG-BCT-NUM NOT = 8 OR FLG8D NOT ZERO)
           IF RG-BCT-NUM > 6 AND (RG-BCT-NUM NOT = 8 OR FLG8D = ZERO)
      ************
              GO TO NUMR-FAT.
      *
       NUMR-BOL.
      ************
      *
      * numerazione bolle
      *
           IF COMBOL NOT = T28-NBOLC UNLOCK TABELL
                                     GO TO EX-NUM-RISCRIV.
           SUBTRACT 1 FROM T28-NBOLC.
           REWRITE RF-TAB FROM REKT28 INVALID
                          PERFORM INVK-TAB GO TO ERRIO.
           UNLOCK TABELL.
           GO TO EX-NUM-RISCRIV.
      *
      * numerazione fatture
      *
       NUMR-FAT.
           IF RG-BCT-NUM NOT = 7 GO TO NFR-NOGIS.
           IF AZI-FLGIS = 2 GO TO NFR-NOGIS.
           IF COMBOL NOT = T23-FTSOS UNLOCK TABELL
                                     GO TO EX-NUM-RISCRIV.
           SUBTRACT 1 FROM T23-FTSOS.
           REWRITE RF-TAB FROM REKT23 INVALID
                          PERFORM INVK-TAB GO TO ERRIO.
           UNLOCK TABELL.
           GO TO EX-NUM-RISCRIV.
       NFR-NOGIS.
           IF RG-BCT-CATT NOT = '0' GO TO NFR-ATTNO0.
           IF COMBOL NOT = AZI-NUMFT UNLOCK ANAAZI
                                     GO TO EX-NUM-RISCRIV.
           SUBTRACT 1 FROM AZI-NUMFT.
           REWRITE RF-AZI FROM REKAZI INVALID
                          PERFORM INVK-AZI GO TO ERRIO.
           UNLOCK ANAAZI.
           GO TO EX-NUM-RISCRIV.
      *
       NFR-ATTNO0.
           IF COMBOL NOT = T35-NUMFT UNLOCK TABELL
                                     GO TO EX-NUM-RISCRIV.
           SUBTRACT 1 FROM T35-NUMFT.
           REWRITE RF-TAB FROM REKT35 INVALID
                          PERFORM INVK-TAB GO TO ERRIO.
           UNLOCK TABELL.
       EX-NUM-RISCRIV.
           EXIT.
      *------------------
       AGG-ACC.
      **** rel 2.0
           IF FLGAGG NOT = ZERO GO TO EX-AGG-ACC.
      ************
           IF BCT-ACCON = ZERO OR BCT-FLACC = ZERO GO TO EX-AGG-ACC.
           OPEN I-O ACCONT.
           MOVE KBC-AZI TO KAC-AZI.
           MOVE KBC-NUM TO KAC-NUM.
           MOVE KBC-BOL TO KAC-BOL.
           MOVE ZERO TO ACC-IMPOR.
      **** la write deve essere senza invalid
           WRITE RF-ACC.
           CLOSE ACCONT.
       EX-AGG-ACC.
           EXIT.
      *------------------
       E00-VAR-RIG.
           IF BCT-DATA = M-ODAT GO TO E05.
      **** rel 5.0
      * Modifica data bolla su file IMBUSC
           IF FLGAGG NOT = ZERO
              MOVE ZERO TO RG-BCT-IMU-SW
              MOVE ZERO TO RG-BCT-IMU-TUTTI
              GO TO E02.
           MOVE KAZ-COD TO MU-AZI.
           MOVE 2       TO MU-FUNZ.
           IF BCT-TDOC = 6 OR = 7 MOVE MFOR TO MAS
           ELSE                   MOVE MCLI TO MAS.
           MOVE BCT-CLI TO COD.
           MOVE CODICE   TO MU-CLF.
           MOVE '2'      TO MU-TIPU.
           MOVE KBC-NUM  TO MU-NUM.
           MOVE KBC-BOL  TO MU-BOL.
           MOVE ZERO     TO MU-PRG.
           MOVE BCT-DATA TO MU-DTDOC.
           MOVE M-ODAT   TO MU-DTOLD.
           CALL 'vrcimu' USING PARMU.
           CANCEL 'vrcimu'.
           MOVE MU-RXIMU TO RG-BCT-IMU-SW.
           MOVE MU-TUTTI TO RG-BCT-IMU-TUTTI.
       E02.
      ************
      * Modifica data bolla su file LIMESC
           MOVE KAZ-COD  TO PLMS-AZI.
           MOVE 2        TO PLMS-FUNZ.
           MOVE KBC-NUM  TO PLMS-NUM.
           MOVE KBC-BOL  TO PLMS-BOL.
           MOVE ZERO     TO PLMS-PRG.
           MOVE M-ODAT   TO PLMS-DTOLD.
      **** rel 2.0
      *    CALL 'vrclms' USING PAR-LMS.
           IF FLGAGG = ZERO
              CALL 'vrclms' USING PAR-LMS.
      ************
           CANCEL 'vrclms'.
      **** rel 5.0
      * Modifica data bolla su file BOLOPC
           IF FLGAGG NOT = ZERO
              GO TO E05.
           MOVE KBC-AZI TO KBO-AZI.
           MOVE KBC-NUM TO KBO-NUM.
           MOVE KBC-BOL TO KBO-BOL.
           MOVE ZERO    TO PARBC.
           MOVE 3       TO BC-FUNZ.
           MOVE M-ODAT  TO BC-DTOLD.
           CALL 'vrcbpc' USING KEYBO PARBC.
      ************
       E05.
      *
           MOVE ZERO TO SWTEST.
           MOVE BCT-DATA TO OLDDATA.
           IF BCT-DATA NOT  = M-ODAT MOVE 1 TO SWTEST
                                     MOVE M-ODAT TO OLDDATA
                                     MOVE BCT-DATA TO M-NDAT.
           IF BCT-CAUS NOT  = M-NCA1 MOVE 1 TO SWTEST
                                     MOVE BCT-CAUS TO M-NCA1.
           IF BCT-CAUC NOT  = M-NCA2 MOVE 1 TO SWTEST
                                     MOVE BCT-CAUC TO M-NCA2.
           IF BCT-CPAG NOT  = M-NPAG MOVE 1 TO SWTEST
                                     MOVE BCT-CPAG TO M-NPAG.
           IF BCT-CAMGG NOT = M-NCAM MOVE 1 TO SWTEST
                                     MOVE BCT-CAMGG TO M-NCAM.
           IF BCT-SCBAS NOT = SCBAS  MOVE 1 TO SWTEST.
      **** rel 4.0-2
           IF BCT-TDOC = 6 OR 7
              MOVE MFOR TO MAS
           ELSE
              MOVE MCLI TO MAS.
           MOVE BCT-CLI TO COD.
           IF CODICE NOT = M-CLFO MOVE 1 TO SWTEST
                                  MOVE CODICE TO M-CLFO.
      ************
           IF SWTEST = ZERO GO TO E99.
           MOVE KAZ-COD TO KCR-AZI.
           MOVE KBC-NUM TO KCR-NUM.
           MOVE KBC-BOL TO KCR-BOL.
           MOVE ZERO TO KCR-PGR.
           START BOLCRI KEY NOT < KEYCR INVALID GO TO E99.
       E10.
           READ BOLCRI NEXT AT END GO TO E99.
           IF SF-BCR = '9D' OR '9A' OR '35' GO TO E10.
           IF KCR-AZI NOT = KAZ-COD OR
              KCR-NUM NOT = KBC-NUM OR
              KCR-BOL NOT = KBC-BOL GO TO E99.
           IF BCR-TCOR  = 2 OR
              ( ( BCR-TCOR = 4 OR 5 ) AND BCR-ART = SPACE )
              IF BCT-SCBAS = SCBAS GO TO E10
                             ELSE  GO TO E15.
      **** rel 2.0
           IF BCR-TCOR = 1 OR 3 GO TO E10.
           IF BCR-TCOR = 2 OR
              BCR-NMOV = ZERO GO TO E15.
      *    IF ( BCR-TCOR > ZERO AND < 4 ) OR
      *         BCR-NMOV = ZERO GO TO E10.
      ************
           MOVE BCR-NMOV   TO M-ONUM.
           MOVE BCR-ART    TO M-ART.
           MOVE BCR-UM     TO M-UNM.
           MOVE BCR-TCOR   TO M-TCOR.
           MOVE BCR-NETRG  TO M-NIMP.
           MOVE BCR-QTA    TO M-NQTA.
           MOVE ZERO       TO M-STAT.
      **** rel 2.0
      *    IF BCT-SCBAS = SCBAS CALL 'vrmvmag' USING PARMAG
      *                         IF ERRIO-ST = 9 GO TO ERRIO
      *                         ELSE            GO TO E20.
           IF BCT-SCBAS = SCBAS
              IF FLGAGG = ZERO
                 CALL 'vrmvmag' USING PARMAG
                 IF ERRIO-ST = 9
                    GO TO ERRIO
                 ELSE
                    IF ERRIO-ST = 8
                       MOVE ZERO TO ERRIO-ST
                       CALL 'vrmbox' USING PARMB
                    END-IF
                    GO TO E20
                 END-IF
              ELSE
                 MOVE ZERO TO M-NMOV
                 GO TO E20.
      ************
       E15.

           MOVE "V"       TO IM-TIPO.
           MOVE BCR-PZLOR TO IM-PZLOR.
           MOVE BCR-QTA   TO IM-QTA.
           MOVE BCT-SCBAS TO IM-SCBAS.
           MOVE BCR-SC1   TO IM-SC1.
           MOVE BCR-SC2   TO IM-SC2.
           MOVE BCT-VALUT TO IM-VALUT.
           MOVE BCR-TCOR  TO IM-TCOR.
           MOVE BCR-TQUAN TO IM-TQUAN.
      **** rel 4.0
      *    MOVE BCR-TPRZ  TO IM-TPRZ.
           MOVE BCR-FSC   TO IM-FSC.
      ************
           MOVE BCR-FPNET TO IM-FPNET.
           CALL 'vrimpor' USING PARIM.
           IF ERRIO-ST = 9 GO TO ERRIO.
           MOVE IM-PZNET  TO BCR-PZNET.
           MOVE IM-NETRG  TO BCR-NETRG.
           IF BCR-TCOR  = 2  OR
              ( ( BCR-TCOR = 4 OR 5 ) AND BCR-ART = SPACE )
                                                  GO TO E25.
      **** rel 2.0
           IF BCR-TCOR = 2 OR
              BCR-NMOV = ZERO GO TO E25.
      ************
           MOVE BCR-NETRG TO M-NIMP.
      **** rel 2.0
      *    CALL 'vrmvmag' USING PARMAG.
      *    IF ERRIO-ST = 9 GO TO ERRIO.
           IF FLGAGG = ZERO
              CALL 'vrmvmag' USING PARMAG
              IF ERRIO-ST = 9
                 GO TO ERRIO
              ELSE
                 IF ERRIO-ST = 8
                    MOVE ZERO TO ERRIO-ST
                    CALL 'vrmbox' USING PARMB
                 END-IF
              END-IF
           ELSE
              MOVE ZERO TO M-NMOV.
      ************
       E20.
           IF M-STAT = ZERO MOVE M-NMOV TO BCR-NMOV.
       E25.
           REWRITE RF-BCR INVALID PERFORM INVK-BCR
                                                GO TO ERRIO.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-BCR.
      ************
      * se cambio anno aggiorno file legami bolle/ordini
           MOVE OLDDATA TO AAGGG.
           MOVE 2 TO TIPOP1
           CALL 'rdata' USING PARCDT.
           MOVE AA4 TO OLDANNO.
           MOVE BCT-DATA TO AAGGG.
           MOVE 2 TO TIPOP1
           CALL 'rdata' USING PARCDT.
           MOVE AA4 TO NEWANNO.
           IF OLDANNO = NEWANNO OR (BCR-TCOR = 1 OR 3) GO TO CTRA-10.
      **** rel 2.0
           IF FLGAGG NOT = ZERO GO TO CTRA-10.
      ************
           MOVE KAZ-COD TO KBO-AZI.
           MOVE OLDANNO TO KBO-ANNO.
           MOVE KCR-NUM TO KBO-NUM.
           MOVE KCR-BOL TO KBO-BOL.
           MOVE KCR-PGR TO KBO-PRB.
           MOVE 1       TO KBO-PRG.
           READ BOLORD INVALID GO TO CTRA-10.
           DELETE BOLORD.
           MOVE NEWANNO TO KBO-ANNO OBC-ANNO.
           WRITE RF-OBC INVALID PERFORM INVK-OBC GO TO ERRIO.
       CTRA-10.
           GO TO E10.
       E99.
           EXIT.
      *------------------
       C00-DEL-RIG.
           MOVE KAZ-COD TO KCR-AZI KRI-AZI KMA-AZI KAD-AZI.
           MOVE KBC-BOL TO KCR-BOL.
           MOVE KBC-NUM TO KCR-NUM.
           MOVE ZERO TO KCR-PGR.
           START BOLCRI KEY NOT < KEYCR INVALID GO TO C99.
       C10.
           READ BOLCRI NEXT AT END GO TO C99.
           IF SF-BCR = '9D' OR '9A' OR '35' GO TO C10.
           IF KCR-AZI NOT = KAZ-COD OR
              KCR-NUM NOT = KBC-NUM OR
              KCR-BOL NOT = KBC-BOL GO TO C99.
           IF BCR-TCOR = 1 OR 3
              DELETE BOLCRI
      **** rel 2.0
              PERFORM DEL-PROBCR THRU EX-DEL-PROBCR
              PERFORM DL-NOTE    THRU EX-DL-NOTE
      ************
      **** rel 7.1
              MOVE 'C' TO PPAR-TOPE
              PERFORM CALL-VSRV133-BCR
      ************
              GO TO C10.
           MOVE BCT-CDEP TO KAD-DEP.
           MOVE BCR-ART TO KMA-ART KAD-ART.
           MOVE KAZ-COD TO KBO-AZI.
           MOVE BCT-DATA TO AAGGG.
           MOVE 2 TO TIPOP1
           CALL 'rdata' USING PARCDT.
           MOVE AA4 TO KBO-ANNO.
           MOVE KCR-NUM TO KBO-NUM.
           MOVE KCR-BOL TO KBO-BOL.
           MOVE KCR-PGR TO KBO-PRB.
           MOVE 1       TO KBO-PRG.
           READ BOLORD INVALID GO TO C30.
      **** rel 5.0
           IF FLGAGG = ZERO
              MOVE ZERO     TO PARBC
              MOVE 2        TO BC-FUNZ
              MOVE 1        TO BC-FLG
              MOVE BCT-CDEP TO BC-DEP
              MOVE BCR-ART  TO BC-ART
              CALL 'vrcbpc' USING KEYBO PARBC.
      ************
      **** rel 2.0
      *    DELETE BOLORD.
           IF FLGAGG = ZERO DELETE BOLORD.
      ************
       C30.
           IF BCR-NORD = ZERO GO TO C40.
      **** rel 5.0
           IF FLGAGG = ZERO
              MOVE KAZ-COD  TO OC-AZI
              MOVE BCR-NORD TO OC-NUM
              CALL 'vrvopc' USING PAROC
              IF OC-FLG = 1
                 GO TO C40.
      ************
           PERFORM D00-STO-ORD THRU D99.
       C40.
           IF NOT (BCR-TCOR = ZERO OR 4 OR 5 OR 6) OR BCR-ART = SPACE
                   DELETE BOLCRI
      **** rel 2.0
                   PERFORM DEL-PROBCR THRU EX-DEL-PROBCR
                   PERFORM DL-NOTE    THRU EX-DL-NOTE
      ************
      **** rel 7.1
                   MOVE 'C' TO PPAR-TOPE
                   PERFORM CALL-VSRV133-BCR
      ************
                   GO TO C10.
           MOVE BCR-ART    TO M-ART.
           MOVE BCR-NMOV   TO M-ONUM.
           MOVE BCR-UM     TO M-UNM.
           MOVE BCR-TCOR   TO M-TCOR.
           MOVE ZERO       TO M-NQTA.
           MOVE BCR-NETRG  TO M-NIMP.
      **** rel 5.0
           IF BCR-NMOV = ZERO GO TO NO-NMOV.
      ************
      **** rel 2.0
      *    CALL 'vrmvmag' USING PARMAG.
      *    IF ERRIO-ST = 9 GO TO ERRIO.
           IF FLGAGG = ZERO
              CALL 'vrmvmag' USING PARMAG
              IF ERRIO-ST = 9
                 GO TO ERRIO
              ELSE
                 IF ERRIO-ST = 8
                    MOVE ZERO TO ERRIO-ST
                    CALL 'vrmbox' USING PARMB.
      **** rel 5.0
       NO-NMOV.
      ************
           PERFORM DEL-PROBCR THRU EX-DEL-PROBCR.
           PERFORM DL-NOTE    THRU EX-DL-NOTE.
      ************
           DELETE BOLCRI.
      *
      **** rel 7.1
           MOVE 'C' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-BCR.
      ************
           MOVE 1 TO PLMS-FUNZ.
           PERFORM G-LMS THRU EX-G-LMS.
      *
           GO TO C10.
       C99.
           EXIT.
      *------------------
       D00-STO-ORD.
      **** rel 2.0
           IF FLGAGG NOT = ZERO GO TO D99.
      ************
           MOVE ZERO TO SWERR.
           PERFORM F00-RDLCK THRU F99.
      **** rel NT 0.0
      *    IF SWERR = 1 MOVE 'ORDINE NON AGGIORNATO' TO F-MES1
      *                 MOVE 11 TO F-FUN
      *                 CALL 'rzfunz' USING PARF
      *                 GO TO D99.
           IF SWERR = 1 GO TO D99.
      ***************
           MOVE ZERO TO SWERR.
           COMPUTE RESID = RIG-QUANT - RIG-QSPED.
           COMPUTE RIG-QSPED = RIG-QSPED - BCR-QTA.
           COMPUTE RESID = RESID + BCR-QTA.
           IF RESID < ZERO MOVE ZERO TO RESID.
           IF BCR-ART = SPACE GO TO D30.
           IF RIG-SALDO = ZERO
              ADD BCR-QTA TO ART-IMPCL ARD-CIMPE
              ELSE
              ADD RESID TO ART-IMPCL ARD-CIMPE.
       D30.
           MOVE ZERO TO RIG-SALDO.
           IF RIG-QSPED NOT < RIG-QUANT MOVE 1 TO RIG-SALDO.
           IF ( BCR-TCOR > ZERO AND < 4 ) OR BCR-TCOR > 6
                                               GO TO D40.
           IF BCR-ART = SPACE GO TO D40.
           REWRITE RF-ART FROM REKART INVALID
      **** rel NT 0.0
      *           MOVE 'ERRORE SCRITTURA ARTICOLO' TO F-MES1
      *           MOVE 11 TO F-FUN
      *           CALL 'rzfunz' USING PARF
      ***************
                  MOVE 1 TO SWERR
                  UNLOCK MAGART
                  UNLOCK MAGARD
                  UNLOCK ORDRIG
                  GO TO D99.
           UNLOCK MAGART.
           REWRITE RF-ARD FROM REKARD INVALID
      **** rel NT 0.0
      *           MOVE 'ERRORE SCRITTURA DEPOSITO' TO F-MES1
      *           MOVE 11 TO F-FUN
      *           CALL 'rzfunz' USING PARF
      ***************
                  MOVE 1 TO SWERR
                  UNLOCK MAGARD
                  UNLOCK ORDRIG
                  GO TO D99.
           UNLOCK MAGARD.
       D40.
           PERFORM SETTA-TQP-RIG THRU EX-SETTA-TQP-RIG.
           REWRITE RF-RIG FROM REKRIG INVALID
      **** rel NT 0.0
      *           MOVE 'ERRORE SCRITTURA ORDINE' TO F-MES1
      *           MOVE 11 TO F-FUN
      *           CALL 'rzfunz' USING PARF
      ***************
                  MOVE 1 TO SWERR
                  UNLOCK ORDRIG
                  GO TO D99.
           UNLOCK ORDRIG.
      **** rel 7.1
           MOVE 'M' TO PPAR-TOPE.
           PERFORM CALL-VSRV133-RIG.
      ************
       D99.
           EXIT.
      *------------------
       F00-RDLCK.
           MOVE KAZ-COD   TO KRI-AZI.
           MOVE BCR-NORD  TO KRI-NUM.
           MOVE BCR-PRORD TO KRI-PRG.
           READ ORDRIG INTO REKRIG KEPT LOCK INVALID KEY
      **** rel NT 0.0
      *         MOVE 'MANCA RIGO ORDINE' TO F-MES1
      *         MOVE 11 TO F-FUN
      *         CALL 'rzfunz' USING PARF
      ***************
                MOVE 1 TO SWERR
                GO TO F99.
           IF SF-RIG > ZERO
              PERFORM REC-LOCK
              GO TO F00-RDLCK.
      **** rel 5.0
       F05.
           MOVE KRI-AZI TO KOR-AZI.
           MOVE KRI-NUM TO KOR-NUM.
           READ ORDCLI INTO REKORD INVALID KEY
                MOVE 1 TO SWERR
                GO TO F99.
      **** rel 5.0-1
      *    IF SF-ORD > ZERO
      *       PERFORM REC-LOCK
      *       GO TO F05.
           IF SF-ORD = '9D' OR '9A' OR '35' MOVE RF-ORD TO REKORD.
      ************
      ************
           IF NOT (BCR-TCOR = ZERO OR 4 OR 5 OR 6) GO TO F99.
           IF BCR-ART = SPACE GO TO F99.
       F10.
           READ MAGART INTO REKART KEPT LOCK INVALID KEY
             PERFORM INVK-ART
             PERFORM VISK-BCR
             GO TO ERRIO.
           IF SF-ART > ZERO
              PERFORM REC-LOCK
              GO TO F10.
       F20.
      **** rel 5.0
           MOVE ORD-CDEP  TO KAD-DEP.
      ************
           READ MAGARD INTO REKARD KEPT LOCK INVALID KEY
             PERFORM INVK-ARD
             PERFORM VISK-BCR
             GO TO ERRIO.
           IF SF-ARD > ZERO
              PERFORM REC-LOCK
              GO TO F20.
       F99.
           EXIT.
      *------------------
       G00-RD-CAMBI.
      **** rel 1.2
           MOVE ZERO TO SWERG00.
      ************

      **** rel 1.2
      *    IF RG-BCT-VALUT = 1 MOVE 1 TO RG-BCT-CAMGG
      *                        MOVE ZERO TO RA-BCT-DTCGG
      *                        GO TO G99.
      ************
           MOVE ZERO TO RG-BCT-CAMGG
                        RA-BCT-DTCGG.
      *
           MOVE RG-BCT-DATA TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
      **** rel 1.2
      *    MOVE AAGGG TO COMDAT.
      *
      *    MOVE RG-BCT-VALUT TO KCG-VAL.
      *    MOVE ZERO         TO KCG-GIO.
      *    START CAMGIO KEY NOT < KEYCG INVALID GO TO G99.
      *G20.
      *    READ CAMGIO NEXT AT END   GO TO G99.
      *    IF KCG-VAL > RG-BCT-VALUT GO TO G99.
      *    COMPUTE AAGGG = 99999 - KCG-GIO.
      *    IF AAGGG > COMDAT GO TO G20.
      *    MOVE CGG-CAMBIO TO RG-BCT-CAMGG.
           MOVE AAGGG         TO ER-DATA.
           MOVE RG-BCT-VALUT  TO ER-VALUT.
           CALL 'rvalut' USING ER-VALUT ER-DATA CG-PAR.
           IF CG-ST > ZERO PERFORM ERR-EURO
                           MOVE 1 TO SWERG00
                           GO TO G99.

      **** rel 4.0
      *    IF RG-BCT-VALUT = 1 MOVE 1 TO RG-BCT-CAMGG
           IF RG-BCT-VALUT = COMEURO
                               MOVE CG-CAMBIO TO RG-BCT-CAMGG
      ************
                               MOVE ZERO TO RA-BCT-DTCGG
                               GO TO G99.

           MOVE CG-CAMBIO TO RG-BCT-CAMGG.
           MOVE CG-DTCAM TO AAGGG.
      ************
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RA-BCT-DTCGG.
       G99.
           EXIT.
      *------------------
       REC-LOCK.
      **** rel 1.2
           CALL 'rlock' USING PARLK.
      ************
           EXIT.
      *------------------
      * setta RIG-TQUAN e RIG-TPRZ per righi occasionali ORDINE
       SETTA-TQP-RIG.
           IF NOT ((RIG-TPRIG = 2)  OR
                  ((RIG-TPRIG = 4 OR 5) AND RIG-ARTIC = SPACE))
                    GO TO EX-SETTA-TQP-RIG.
      *
           MOVE RIG-QUANT TO RD-NUM.
           CALL 'vrround' USING QTA-SET PARRD RD-TIPO.
           MOVE RD-TIPO TO RIG-TQUAN.
      *
           MOVE RIG-QSPED TO RD-NUM.
           CALL 'vrround' USING QTA-SET PARRD RD-TIPO.
           IF RD-TIPO > RIG-TQUAN
              MOVE RD-TIPO TO RIG-TQUAN.
      *
      **** rel 4.0
      *    MOVE RIG-PREZZ TO RD-NUM.
      *    CALL 'vrround' USING PRZ-SET PARRD RD-TIPO.
      *    MOVE RD-TIPO TO RIG-TPRZ.
      *
      *    IF ORD-VALUT > 1 MOVE 1 TO RIG-TPRZ.
      ************
       EX-SETTA-TQP-RIG.
           EXIT.
      *------------------
       G-LMS.
      **** rel 2.0
           IF FLGAGG NOT = ZERO GO TO EX-G-LMS.
      ************
           MOVE KAZ-COD  TO PLMS-AZI.
           MOVE KBC-NUM  TO PLMS-NUM.
           MOVE KBC-BOL  TO PLMS-BOL.
           MOVE KCR-PGR  TO PLMS-PRG.
           MOVE ZERO     TO PLMS-DTOLD.
           CALL 'vrclms' USING PAR-LMS.
           CANCEL 'vrclms'.
       EX-G-LMS.
           EXIT.
      *------------------*
      **** rel 2.0
       DEL-PROBCR.
           IF FLGAGG NOT = ZERO GO TO EX-DEL-PROBCR.
           MOVE KCR-AZI TO KPBR-AZI.
           MOVE KCR-NUM TO KPBR-TNUM.
           MOVE KCR-BOL TO KPBR-NBOL.
           MOVE KCR-PGR TO KPBR-RBOL.
           MOVE ZERO    TO KPBR-PGR.
           START PROBCR KEY NOT < KEYPBR INVALID GO TO EX-DEL-PROBCR.
       RDPBR.
           READ PROBCR NEXT AT END GO TO EX-DEL-PROBCR.
           IF SF-PBR = '9D' OR '9A' OR '35' GO TO RDPBR.
           IF KPBR-AZI  NOT = KCR-AZI OR
              KPBR-TNUM NOT = KCR-NUM OR
              KPBR-NBOL NOT = KCR-BOL OR
              KPBR-RBOL NOT = KCR-PGR GO TO EX-DEL-PROBCR.

           DELETE PROBCR INVALID PERFORM INVK-PBR
                                 GO TO ERRIO.

           MOVE KPBR-AZI  TO KPOR-AZI.
           MOVE PBR-NORD  TO KPOR-NORD.
           MOVE PBR-RORD  TO KPOR-RORD.
           MOVE PBR-PORD  TO KPOR-PGR .
           READ PRORIG INVALID GO TO RDPBR.
           IF POR-SPED NOT = 9 GO TO RDPBR.

           MOVE 1 TO POR-SPED.
           REWRITE RF-POR INVALID PERFORM INVK-POR
                                  GO TO ERRIO.

           GO TO RDPBR.
       EX-DEL-PROBCR.
           EXIT.
      *------------------
      * cancellazione note aggiuntive rigo bolla cliente
       DL-NOTE.
           MOVE KCR-AZI TO KNCR-AZI.
           MOVE KCR-NUM TO KNCR-NUM.
           MOVE KCR-BOL TO KNCR-BOL.
           MOVE KCR-PGR TO KNCR-PGR.
           MOVE ZERO    TO KNCR-PGRN.
      *
           START NOTBCR KEY >= KEYNCR INVALID GO TO EX-DL-NOTE.
       DL-NOTE-10.
           READ NOTBCR NEXT AT END GO TO EX-DL-NOTE.
           IF KNCR-AZI > KCR-AZI GO TO EX-DL-NOTE.
           IF KNCR-NUM > KCR-NUM GO TO EX-DL-NOTE.
           IF KNCR-BOL > KCR-BOL GO TO EX-DL-NOTE.
           IF KNCR-PGR > KCR-PGR GO TO EX-DL-NOTE.
           DELETE NOTBCR INVALID PERFORM INVK-NCR
                                 GO TO V-ERROR.
           GO TO DL-NOTE-10.
       EX-DL-NOTE.
           EXIT.
      *------------------
      ************
      **** rel 5.0
       G-IMU.
           IF FLGAGG NOT = ZERO
              MOVE ZERO TO RG-BCT-IMU-SW
              MOVE ZERO TO RG-BCT-IMU-TUTTI
              GO TO EX-G-IMU.
           MOVE KAZ-COD TO MU-AZI.
           IF BCT-TDOC = 6 OR = 7 MOVE MFOR TO MAS
           ELSE                   MOVE MCLI TO MAS.
           MOVE BCT-CLI TO COD.
           MOVE CODICE   TO MU-CLF.
           MOVE '2'      TO MU-TIPU.
           MOVE KBC-NUM  TO MU-NUM.
           MOVE KBC-BOL  TO MU-BOL.
           MOVE ZERO     TO MU-PRG.
           MOVE BCT-DATA TO MU-DTDOC.
           MOVE ZERO     TO MU-DTOLD.
           CALL 'vrcimu' USING PARMU.
           CANCEL 'vrcimu'.
           MOVE MU-RXIMU TO RG-BCT-IMU-SW.
           MOVE MU-TUTTI TO RG-BCT-IMU-TUTTI.
       EX-G-IMU.
           EXIT.
      *------------------*
      ************
      **** rel 5.1
       MOD-LVE-RIG.
           IF FLGAGG NOT = ZERO GO TO EX-MOD-LVE-RIG.
           IF BCT-TDOC > 3 GO TO EX-MOD-LVE-RIG.

           MOVE KAZ-COD TO KCR-AZI.
           MOVE KBC-NUM TO KCR-NUM.
           MOVE KBC-BOL TO KCR-BOL.
           MOVE ZERO    TO KCR-PGR.
           START BOLCRI KEY NOT < KEYCR INVALID GO TO EX-MOD-LVE-RIG.
       LVE-10.
           READ BOLCRI NEXT AT END GO TO EX-MOD-LVE-RIG.
           IF SF-BCR = '9D' OR '9A' OR '35' GO TO LVE-10.
           IF KCR-AZI NOT = KAZ-COD OR
              KCR-NUM NOT = KBC-NUM OR
              KCR-BOL NOT = KBC-BOL GO TO EX-MOD-LVE-RIG.
           IF BCR-TCOR NOT = ZERO GO TO LVE-10.
           IF BCR-NORD NOT = ZERO GO TO LVE-10.

           PERFORM G00-AGGLVE THRU G999.

           GO TO LVE-10.
       EX-MOD-LVE-RIG.
           EXIT.
      *------------------
       G00-AGGLVE.
           MOVE KCR-AZI    TO VE-AZI.
           MOVE BCR-ART    TO VE-ART.
           MOVE BCT-CLI    TO VE-CLI.
           MOVE 'B'        TO VE-ORIG.
           MOVE KBC-BOL    TO VE-NDOC.
           MOVE BCT-DATA   TO VE-DTDOC.
           MOVE BCR-QTA    TO VE-QTA.
           MOVE BCR-PZLOR  TO VE-PRZ.
           MOVE BCR-SC1    TO VE-SC1.
           MOVE BCR-SC2    TO VE-SC2.
      **** rel 1.2
           MOVE BCT-SCBAS  TO VE-SCBAS.
           MOVE BCR-FPNET  TO VE-FPNET.
      ************
           MOVE ZERO       TO VE-ST.
           CALL 'vrlsven' USING PARVE.
           CANCEL 'vrlsven'.
       G999.
           EXIT.
      *------------------
      ************
      **** rel 5.2
       RD-CDPAG.
           MOVE RG-BCT-CPAG TO KTB-COD.
           MOVE 4 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID GO TO EX-RD-CDPAG.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T04-TIPAG = 1 OR 2 GO TO EX-RD-CDPAG.
           IF CLF-BANCF NOT = ZERO MOVE CLF-BANCF TO RG-BCT-CBAN.
       EX-RD-CDPAG.
           EXIT.
      *------------------*
      ************
      **** rel 7.1
       CREA-APPBCT.
           MOVE ZERO TO RF-ACT.
           MOVE KBC-AZI TO KACT-AZI.
           MOVE KBC-NUM TO KACT-NUM.
           MOVE KBC-BOL TO KACT-BOL.
           MOVE SPACE TO ACT-CIG ACT-CUP ACT-IPA.
      **** rel 7.2
           MOVE SPACE TO ACT-FAORD.
      ************
           WRITE RF-ACT INVALID PERFORM INVK-ACT
                                GO TO ERRIO. 
       EX-CREA-APPBCT.
           EXIT.
      *------------------*
       CALL-VSRV133-RIG.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'RIG'   TO PPAR-TARC.
           MOVE KEYRI   TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           MOVE SPACE   TO PPAR-OPZ.
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 RIG ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *------------------*
       CALL-VSRV133-BCT.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'BCT'   TO PPAR-TARC.
           MOVE KEYBC   TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           MOVE SPACE   TO PPAR-OPZ.
           IF PPAR-TOPE = 'C'
              MOVE DTINT TO PPAR-OPZ(1:5).
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 BCT ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *------------------*
       CALL-VSRV133-BCR.
           MOVE ZERO    TO PPAR-FUN.
           MOVE 'BCR'   TO PPAR-TARC.
           MOVE KEYCR   TO PPAR-KEY.
           MOVE ZERO    TO PPAR-CATT.
           MOVE SPACE   TO PPAR-OPZ.
           CALL 'vsrv133' USING PARPPAR 'DSV'.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore vsrv133 BCR ' PPAR-ERR
                         DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      *------------------*
      ************
