       IDENTIFICATION DIVISION.
       PROGRAM-ID. C72AFT.
      *
      * Conversione file APPFAT azzeramento campo AFT-FAORD
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griaftsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griaft'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY '_parzf'.
           COPY 'parcdt'.
       01  ID-AFT     PIC X(15) VALUE 'appfat'.
       01  AREE-MS.
           05 MESS     PIC X(40) VALUE SPACE.
           05 IDE-DES  PIC X(20) VALUE SPACE.
      *
           05 SAV-IPA     PIC X(6).
           05 SAV-CIG     PIC X(10).
           05 SAV-CUP     PIC X(15).
           05 SAV-TIPO    PIC 9.
      *
           05 SF-AFT   PIC XX.
       SCREEN SECTION.
           COPY '_scrlog'.
       PROCEDURE DIVISION.
           COPY 'declxer1'.
      *
           COPY '_gridcl' REPLACING ==(SIGLA)== BY ==AFT==
                                   ==NFILE== BY ==APPFAT==.
           COPY '_dclxer2'.
       INIZIO.
      *
      *    COPY 'strcal'.
           OPEN I-O APPFAT.
      *
           MOVE LOW-VALUE TO KEYAFT.
           START APPFAT KEY > KEYAFT INVALID GO TO END-AFT.
       LOOP-AFT.
           READ APPFAT NEXT AT END GO TO END-AFT. 
           IF SF-AFT = '9D' OR '9A' OR '35' GO TO LOOP-AFT.
      *
           MOVE AFT-IPA      TO SAV-IPA.
           MOVE AFT-CIG      TO SAV-CIG.
           MOVE AFT-CUP      TO SAV-CUP.
           MOVE AFT-TIPO     TO SAV-TIPO.
      *
           MOVE ZERO  TO REKAFT.
           MOVE SAV-IPA      TO AFT-IPA.
           MOVE SAV-CIG      TO AFT-CIG.
           MOVE SAV-CUP      TO AFT-CUP.
           MOVE SAV-TIPO     TO AFT-TIPO.
           MOVE SPACE        TO AFT-FAORD.
           MOVE ZERO         TO AFT-FADTORD.
           REWRITE RF-AFT INVALID PERFORM INVK-AFT
                                  GO TO ERRIO.
           GO TO LOOP-AFT.
       END-AFT.
           PERFORM CLOSE-FILE.
           GO TO FINE.
      *------------------*
       CLOSE-FILE.
           CLOSE APPFAT.
      *------------------*
       ERRIO.
           COPY '_errio'.
           PERFORM CLOSE-FILE.
           STOP RUN. 
      *------------------*
       FINE.
           EXIT PROGRAM.
           STOP RUN. 
      *------------------*
           COPY 'griafter'.
           COPY 'grixxxer'.
      *------------------
