       IDENTIFICATION DIVISION.
       PROGRAM-ID. CONCSTR.
      *
      * Concatena stringa
      *
      * Concatena un campo ad una stringa
      *
      **** rel 6.1
      * nuovo
      *************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
           COPY 'grirel-62'.
           COPY 'parcdt'.
       01  COMODI.
           05 IND      PIC 999 VALUE ZERO.
           05 IND1     PIC 999 VALUE ZERO.
           05 INDN     PIC 999 VALUE ZERO.
           05 MAX      PIC 999 VALUE ZERO.
           05 MAX1     PIC 999 VALUE ZERO.
           05 MAXN     PIC 999 VALUE ZERO.
           05 NINT     PIC 99  VALUE ZERO.
           05 MAXDEC   PIC 99  VALUE 7.
           05 NDEC     PIC 99  VALUE ZERO.
           05 NEND     PIC 99  VALUE ZERO.
           05 NUM      PIC X(25).
           05 Zp9v9  REDEFINES NUM PIC ZZ.ZZZ.ZZZ.ZZ9,9999999.
           05 Z9v9   REDEFINES NUM PIC ZZZZZZZZZZ9,9999999.
           05 9p9v9  REDEFINES NUM PIC 99.999.999.999,9999999.
           05 99v9   REDEFINES NUM PIC 99999999999,9999999.
      **** rel 6.2
           05 CAR      PIC X.
      *************

       LINKAGE SECTION.
           COPY 'parpcns71'.
       PROCEDURE DIVISION USING PARPCNS.
       INIZIO.
           MOVE ZERO TO PCNS-ULT.

           MOVE LENGTH OF PCNS-STR TO MAX1.
           MOVE LENGTH OF PCNS-CAMPO TO MAX.
           MOVE LENGTH OF NUM TO MAXN.

           MOVE 1 TO IND1.
           PERFORM UNTIL PCNS-STR(IND1:) = SPACE OR IND1 > MAX
                   IF PCNS-STR(IND1:1) NOT = SPACE
                      MOVE IND1 TO PCNS-ULT
                   END-IF
                   ADD 1 TO IND1.

           IF PCNS-FLGB = ZERO AND IND1 > 1 ADD 1 TO IND1.

           IF PCNS-FLGN NOT = 1 GO TO NO-NUM.
      * formatta numero.
           MOVE SPACE TO PCNS-CAMPO.
           MOVE SPACE TO NUM.

       LPN.
      **** rel 6.2
           IF PCNS-SEGNO = 'N' AND
              PCNS-NUM < ZERO
                 MULTIPLY -1 BY PCNS-NUM
                 MOVE '0' TO PCNS-SEGNO.
      ************
           IF PCNS-NINT = ZERO
      **** rel 6.2
      *       IF PCNS-FLGM = 0
              IF PCNS-FLGM = 0 OR 2
      ************
                 MOVE PCNS-NUM TO Zp9v9
              ELSE
                 MOVE PCNS-NUM TO Z9v9
           ELSE
      **** rel 6.2
      *       IF PCNS-FLGM = 0
              IF PCNS-FLGM = 0 OR 2
      ************
                 MOVE PCNS-NUM TO 9p9v9
              ELSE
                 MOVE PCNS-NUM TO 99v9.

           IF NUM = SPACE
              MOVE ZERO TO PCNS-NINT PCNS-NDEC PCNS-SEGNO PCNS-FLGM
              GO TO LPN.

      * verifica decimali
           MOVE MAXDEC TO NDEC.
           MOVE ZERO TO NEND.
           MOVE MAXN TO INDN.
           PERFORM UNTIL NUM(INDN:1) = ','
              IF NUM(INDN:) = SPACE
                 MOVE INDN TO NEND
                 SUBTRACT 1 FROM NEND
              ELSE
                 IF NUM(INDN:(NEND - INDN + 1)) = ZERO
                    SUBTRACT 1 FROM NDEC
                 END-IF
              END-IF
              SUBTRACT 1 FROM INDN.

           IF PCNS-NDEC > NDEC MOVE PCNS-NDEC TO NDEC.
           IF NDEC > ZERO COMPUTE INDN = INDN + 1 + NDEC.
           MOVE SPACE TO NUM(INDN:).

      * verifica numero cifre intere
           IF PCNS-NINT = ZERO GO TO NO-INT.
           MOVE ZERO TO NINT.
           MOVE 1 TO INDN.
           PERFORM UNTIL NUM(INDN:) = SPACE OR NUM(INDN:1)=','
              IF NUM(INDN:1) NUMERIC
                 ADD 1 TO NINT
              END-IF
              ADD 1 TO INDN.

           MOVE 1 TO INDN.
           PERFORM UNTIL NINT NOT > PCNS-NINT
              IF NUM(INDN:1) NUMERIC
                 SUBTRACT 1 FROM NINT
              END-IF
              MOVE SPACE TO NUM(INDN:1)
              ADD 1 TO INDN.
       NO-INT.

           MOVE 1 TO IND.
           IF PCNS-SEGNO = 'n' OR 'p'
              IF PCNS-NUM < ZERO
                 STRING '-' DELIMITED SIZE
                        INTO PCNS-CAMPO POINTER IND
              ELSE
                 IF PCNS-SEGNO = 'p'
                    STRING '+' DELIMITED SIZE
                           INTO PCNS-CAMPO POINTER IND.

           MOVE 1 TO INDN.
           PERFORM UNTIL NUM(INDN:) = SPACE
      **** rel 6.2
      *       IF NUM(INDN:1) NOT = SPACE
      *          STRING NUM(INDN:1) DELIMITED SIZE
      *                 INTO PCNS-CAMPO POINTER IND
              MOVE NUM(INDN:1) TO CAR
              IF CAR NOT = SPACE
      * notazione "," migliaia / "." decimale
                 IF (PCNS-FLGM = 2 OR 3)
                    IF CAR = '.'
                       MOVE ',' TO CAR
                    ELSE
                       IF CAR = ','
                          MOVE '.' TO CAR
                       END-IF
                    END-IF
                 END-IF
                 STRING CAR DELIMITED SIZE
                        INTO PCNS-CAMPO POINTER IND
      ************
              END-IF
              ADD 1 TO INDN.

           IF PCNS-SEGNO = '0' OR 'P'
              IF PCNS-NUM < ZERO
                 STRING '-' DELIMITED SIZE
                        INTO PCNS-CAMPO POINTER IND
              ELSE
                 IF PCNS-SEGNO = 'P'
                    STRING '+' DELIMITED SIZE
                           INTO PCNS-CAMPO POINTER IND.

       NO-NUM.
      **** rel 6.2
           IF PCNS-FLGN NOT = 2 GO TO NO-DATA.

      * formatta data
           MOVE SPACE TO PCNS-CAMPO.
           MOVE PCNS-DATA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.

           IF PCNS-FLGD = ZERO MOVE GBMMBA  TO PCNS-CAMPO.
           IF PCNS-FLGD = 1    MOVE GBMMBA4 TO PCNS-CAMPO.
           IF PCNS-FLGD = 2    MOVE GGMMAA  TO PCNS-CAMPO.
           IF PCNS-FLGD = 3    MOVE GGMMAA4 TO PCNS-CAMPO.
           IF PCNS-FLGD = 4
              STRING AA9 '/' MM9 '/' GG9
              DELIMITED SIZE INTO PCNS-CAMPO.
           IF PCNS-FLGD = 5
              STRING AA4 '/' MM9 '/' GG9
              DELIMITED SIZE INTO PCNS-CAMPO.
           IF PCNS-FLGD = 6
              STRING AA9 MM9 GG9
              DELIMITED SIZE INTO PCNS-CAMPO.
           IF PCNS-FLGD = 7
              STRING AA4 MM9 GG9
              DELIMITED SIZE INTO PCNS-CAMPO.
           IF PCNS-FLGD = 8    MOVE GMMMA   TO PCNS-CAMPO.
           IF PCNS-FLGD = 9    MOVE GMMMA4  TO PCNS-CAMPO.
           IF PCNS-FLGD = 10
              STRING AA4 '-' MM9 '-' GG9
              DELIMITED SIZE INTO PCNS-CAMPO.
       NO-DATA.
      ************

           MOVE 1 TO IND.
           PERFORM UNTIL PCNS-CAMPO(IND:) = SPACE OR IND > MAX
                   IF PCNS-CAMPO(1:IND) NOT = SPACE OR
                      PCNS-FLGS NOT = ZERO
                         MOVE PCNS-CAMPO(IND:1) TO PCNS-STR(IND1:1)
                         IF PCNS-STR(IND1:1) NOT = SPACE
                            MOVE IND1 TO PCNS-ULT
                         END-IF
                         ADD 1 TO IND1
                   END-IF
                   ADD 1 TO IND.
      *
           MOVE ZERO TO PCNS-PARAM.
           MOVE ZERO TO PCNS-NUM.
           MOVE SPACE TO PCNS-CAMPO.
      **** rel 6.2
           MOVE ZERO TO PCNS-DATA.
      ************
       ESCI.
           EXIT PROGRAM.
      *--------*
