       IDENTIFICATION DIVISION.
       PROGRAM-ID. VFACWRD.
      *
      * Routine stampa fatture accompagnatorie (XABD) con MS-Word
      *
      * Versione per pubblicazione documenti
      *
      **** rel 5.1
      * nuovo: sostituisce VFAT220W.CBL
      ************
      **** rel 6.1
      * spostata scrittura file D- nella routine VRWORD
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griclfsl'.
           COPY 'gribansl'.
           COPY 'gribctsl'.
           COPY 'gribcrsl'.
           COPY 'grifatsl'.
           COPY 'grilinsl'.
           COPY 'gritabsl'.
           COPY 'grintasl'.
           COPY 'grincrsl'.
           COPY 'gripbrsl'.
           COPY 'griaimsl'.
           COPY 'griwsisl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'griclf'.
           COPY 'griban'.
           COPY 'gribct'.
           COPY 'gribcr'.
           COPY 'grifat'.
           COPY 'grilin'.
           COPY 'gritab'.
           COPY 'grinta'.
           COPY 'grincr'.
           COPY 'gripbr'.
           COPY 'griaim'.
           COPY 'griwsi'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'gritabrk'.
           COPY 'grit28rk'.
           COPY 'griclfrk'.
           COPY 'griazirk'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parer'.
           COPY 'parmb'.
           COPY 'parr4'.
           COPY 'parrb'.
           COPY 'parcf'.
           COPY 'parfat'.
           COPY 'parwo'.
           COPY 'parop'.
           COPY 'parpcfa'.
           COPY 'paracf'.
       01  ID-ARL PIC X(15) VALUE 'artlin'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-BAN PIC X(15) VALUE 'anaban'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-NTA PIC X(15) VALUE 'nottab'.
       01  ID-BCT PIC X(15) VALUE 'bolcte'.
       01  ID-BCR PIC X(15) VALUE 'bolcri'.
       01  ID-NCR PIC X(15) VALUE 'notbcr'.
       01  ID-PBR PIC X(15) VALUE 'probcr'.
       01  ID-AIM PIC X(15) VALUE 'anaimb'.
       01  ID-WSI PIC X(15).
       01  ID-FAT.
           05 FILLER PIC X(6) VALUE 'fattur'.
           05 FATTIV PIC X    VALUE SPACE.
           05 FILLER PIC X(8) VALUE SPACE.
      *
       01  COMODI.
           05 SF-ARL  PIC XX.
           05 SF-AZI  PIC XX.
           05 SF-CLF  PIC XX.
           05 SF-BAN  PIC XX.
           05 SF-TAB  PIC XX.
           05 SF-NTA  PIC XX.
           05 SF-BCT  PIC XX.
           05 SF-BCR  PIC XX.
           05 SF-FAT  PIC XX.
           05 SF-NCR  PIC XX.
           05 SF-PBR  PIC XX.
           05 SF-AIM  PIC XX.
           05 SF-WSI  PIC XX.

           05 MESS     PIC X(40)  VALUE SPACE.
           05 K        PIC 99     VALUE ZERO.
           05 J        PIC 99     VALUE ZERO.
           05 VISTA    PIC 9      VALUE ZERO.
           05 VNTMER   PIC S9(11)V99 VALUE ZERO.
           05 VSCFIN   PIC S9(11)V99 VALUE ZERO.
           05 TOTACC   PIC S9(11)V99 VALUE ZERO.
           05 SCONTO   PIC 999V99 VALUE ZERO.
           05 VALUT    PIC 999    VALUE ZERO.
           05 IMPON    PIC S9(11)V99 VALUE ZERO.
           05 IMPOS    PIC S9(11)V99 VALUE ZERO.
           05 SC       PIC S99V99 VALUE ZERO.
           05 WNUM     PIC 9      VALUE ZERO.
           05 SWSTA    PIC 9      VALUE ZERO.
           05 CIFRA    PIC 9      VALUE ZERO.
           05 COMODO   PIC 999    VALUE ZERO.
           05 COMOD1   PIC 999    VALUE ZERO.
           05 GARANZ   PIC S9(11)V99 VALUE ZERO.
           05 NOSCON   PIC S9(11)V99 VALUE ZERO.
           05 NPAG     PIC 9(3)      VALUE ZERO.
           05 DSVAL    PIC X(4)      VALUE SPACE.
           05 FSC      PIC 9.
           05 ESTPIVA  PIC 9.
           05 DTRA     PIC 9(6) VALUE ZERO.
           05 FLGSTA   PIC 9.
           05 INDICE   PIC 999.
           05 ULTIND   PIC 999.
           05 IMPIMB   PIC 9(9)V99.
           05 PREPAL   PIC 9(5).
           05 PRECOL   PIC 9(5).
           05 PREIMB   PIC X(12).
           05 COMNIMB  PIC 9(3).
           05 VETIMB   PIC X(12) OCCURS 30.
           05 VETQTA   PIC 9(5)  OCCURS 30.
           05 FLGTES   PIC 9     VALUE ZERO.
           05 NFAT     PIC 9(5)  VALUE ZERO.
           05 NN       PIC 99.
           05 JJ       PIC 999.
           05 COMEURO PIC 9(3).
           05 KN       PIC 9(4)  VALUE ZERO.
           05 VTMEX.
              10 FILLER PIC X(9) VALUE ' GENNAIO'.
              10 FILLER PIC X(9) VALUE 'FEBBRAIO'.
              10 FILLER PIC X(9) VALUE '  MARZO '.
              10 FILLER PIC X(9) VALUE ' APRILE'.
              10 FILLER PIC X(9) VALUE ' MAGGIO'.
              10 FILLER PIC X(9) VALUE ' GIUGNO'.
              10 FILLER PIC X(9) VALUE ' LUGLIO'.
              10 FILLER PIC X(9) VALUE ' AGOSTO'.
              10 FILLER PIC X(9) VALUE 'SETTEMBRE'.
              10 FILLER PIC X(9) VALUE 'OTTOBRE'.
              10 FILLER PIC X(9) VALUE 'NOVEMBRE'.
              10 FILLER PIC X(9) VALUE 'DICEMBRE'.
           05 VTMES REDEFINES VTMEX PIC X(9) OCCURS 12.
           05 FLGMCL   PIC 9 VALUE ZERO.
       01  CODICE.
           05 MAS      PIC 99   VALUE ZERO.
           05 COD      PIC 9(5) VALUE ZERO.

       01  WK-TESTA.
           05 WK-DATA  PIC 9(5) COMP-3.
           05 WK-CSPE  PIC 999.
           05 WK-CPOR  PIC 999.
           05 WK-DSORD PIC X(10).
           05 WK-DSFAT PIC X(30).
           05 WK-SCBAS PIC S99V99.
       01  KBOL.
           05 BOAZ PIC 999  VALUE ZERO.
           05 BONU PIC 9    VALUE ZERO.
           05 BOBO PIC 9(5) VALUE ZERO.

       01  PAR-P-MDT.
           05 P-MDT-AZI   PIC 999.
           05 P-MDT-TDOC  PIC 9.
           05 P-MDT-KEY   PIC X(15).
           05 P-MDT-FLGS  PIC 9.
           05 P-MDT-DATA  PIC 9(5).
           05 P-MDT-NCOL  PIC 99.
           05 P-MDT-TESTO PIC X(76).
           05 P-MDT-FLGE  PIC 9.

           COPY 'vfacwrd.cpy'.
       LINKAGE SECTION.
           COPY 'parwfat'.
       PROCEDURE DIVISION USING PARWFAT PARCCD.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclclf'.
           COPY 'dclban'.
           COPY 'dclbct'.
           COPY 'dclbcr'.
           COPY 'dclfat'.
           COPY 'dcllin'.
           COPY 'dcltab'.
           COPY 'dclnta'.
           COPY 'dclncr'.
           COPY 'dclpbr'.
           COPY 'dclaim'.
           COPY 'dclwsi'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
      *
           MOVE ZERO TO PCCD-ERR.

      * Inizializza
           IF PCCD-FUN = 'T' OR 'I'
              PERFORM PGM-INI THRU EX-PGM-INI.

      * Esegue
           IF PCCD-FUN = 'T' OR 'R'
              PERFORM PGM-RUN THRU EX-PGM-RUN.

      * Chiude
           IF PCCD-FUN = 'T' OR 'E'
              PERFORM PGM-END THRU EX-PGM-END
              GO TO CHIUDI.

           GO TO FINE.
       ERRIO.
           COPY 'errsub'.
           MOVE 9 TO PCCD-ERR.
           PERFORM WRD-CL.
       CHIUDI.
           CLOSE FATTUR.
           CLOSE ANAAZI.
           CLOSE ANACLF.
           CLOSE ANABAN.
           CLOSE TABELL.
           CLOSE NOTTAB.
           CLOSE BOLCTE.
           CLOSE BOLCRI.
           CLOSE NOTBCR.
           CLOSE PROBCR.
           CLOSE ANAIMB.
           CLOSE WDSSIB.
           OPEN OUTPUT WDSSIB.
           CLOSE WDSSIB.
       FINE.
           EXIT PROGRAM.
      *-------------------*
           COPY 'griwrd'.
      *-------------------*
           COPY 'errmes'.
           COPY 'erreur'.
           COPY 'griazier'.
           COPY 'griclfer'.
           COPY 'gribaner'.
           COPY 'gribcter'.
           COPY 'gribcrer'.
           COPY 'grifater'.
           COPY 'griliner'.
           COPY 'gritaber'.
           COPY 'grintaer'.
           COPY 'grincrer'.
           COPY 'gripbrer'.
           COPY 'griaimer'.
           COPY 'grixxxer'.
      *------------------------------------------*
       PGM-END.
           PERFORM WRD-END.
       EX-PGM-END.
           EXIT.
      *------------------------------------------*
       PGM-INI.
      *
           MOVE PWFAT-CATT TO FATTIV.
           IF FATTIV = '0' MOVE SPACE TO FATTIV.

           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           OPEN OUTPUT WDSSIB.
           CLOSE WDSSIB.
           OPEN I-O WDSSIB.

           OPEN INPUT ANACLF ANAAZI ANABAN TABELL
                      NOTBCR PROBCR BOLCTE BOLCRI
                      ANAIMB FATTUR ARTLIN.
           OPEN INPUT NOTTAB.
      *
           MOVE 1 TO KTB-COD KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MCLI TO MAS.
      *
           MOVE PWFAT-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
      *
           CALL 'rveur' USING COMEURO.
      *
           MOVE 'fatacc' TO WO-IDDOC.
           MOVE PWFAT-AZI TO WO-AZI.
           MOVE PWFAT-CATT TO WO-ATT.
           PERFORM WRD-INI.
      *
       EX-PGM-INI.
           EXIT.
      *------------------------------------------*
       PGM-RUN.
      *
           MOVE ZERO TO KEYFT.
           MOVE PWFAT-AZI  TO KFT-AZI.
           MOVE PWFAT-TDOC TO KFT-TDOC.
           MOVE PWFAT-NFAT TO KFT-NUM.
           READ FATTUR INVALID GO TO NOFAT.
      *
           PERFORM DL-LAV-IMB THRU EX-DL-LAV-IMB.
      *
           CALL 'rdbfa' USING FAT-CATT KEYFT PARRB.
           MOVE PWFAT-AZI    TO KBC-AZI.
           MOVE RB-TNUM(1)   TO KBC-NUM.
           MOVE RB-NBOL(1)   TO KBC-BOL.
           READ BOLCTE INVALID PERFORM INVK-BCT
                               PERFORM VISK-FAT
                               GO TO WARNING.
           IF BCT-FLGXAB NOT = 1
              MOVE 3 TO F-NMES
              MOVE 'Per eseguire la stampa e'' necessario' TO F-MES1
              MOVE 'che i dati  XAB siano  confermati in'  TO F-MES2
              MOVE 'modo definitivo.'                      TO F-MES3
              CALL 'vrmbox' USING PARMB
              GO TO NOFAT.
      *
           IF SAVPATH = SPACE AND PCCD-PATH NOT = SPACE
              MOVE FAT-DATA TO AAGGG
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE KFT-NUM TO NFAT
              STRING PCCD-PATH DELIMITED SPACE
                     '\fac'
                     KFT-AZI
                     PWFAT-CATT
                     KFT-TDOC
                     AA9
                     NFAT
                     '.doc'
                     DELIMITED SIZE INTO SAVPATH
              MOVE SAVPATH TO PCCD-PATH.

           MOVE ZERO TO NOSCON.
           MOVE ZERO TO ULTIND.
           IF NOT (FAT-VALUT = ZERO OR COMEURO)
              MOVE FAT-VALUT TO ER-VALUT
              CALL 'rvalut' USING ER-VALUT FAT-DATA CG-PAR
              IF CG-ST > ZERO PERFORM ERR-EURO
                              GO TO WARNING.
      *---------------------------------------------------*
           MOVE BCT-VALUT TO VALUT.
           MOVE 10        TO KTB-TIP.
           MOVE BCT-VALUT TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE ZERO TO T10-FSC.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T10-FSC TO FSC.

           PERFORM RDCL THRU EX-RDCL.

           MOVE ZERO TO ESTPIVA.
           IF FAT-CDESE  = ZERO GO TO NOCALL-10.
           IF CLF-ENUIVA = ZERO GO TO NOCALL-10.
           MOVE 3         TO KTB-TIP.
           MOVE FAT-CDESE TO KTB-COD.
           READ TABELL INTO REKTAB INVALID GO TO NOCALL-10.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T03-TPIVA TO ESTPIVA.
       NOCALL-10.
           MOVE ZERO TO NPAG.
           MOVE ZERO TO NOSCON.
           PERFORM C00-STAMPA-TESTA THRU C99.
           PERFORM D00-STAMPA-CORPO THRU D99.
           PERFORM E00-STAMPA-PIEDE THRU E99.
       NOFAT.

       EX-PGM-RUN.
           EXIT.
      *------------------------------------------*
       C00-STAMPA-TESTA.
           PERFORM WRD-AZZ.
      *
           ADD 1 TO NPAG.
           MOVE BCT-DRAG  TO D-RGSOC1.
           MOVE BCT-DRAG2 TO D-RGSOC2.
           MOVE BCT-DIND  TO D-INDIR1.
           MOVE BCT-DIND2 TO D-INDIR2.
           MOVE 'FATTURA ACCOMPAGNATORIA' TO D-TIPO.
           MOVE KFT-NUM   TO D-NUMFAT.
           MOVE FAT-DATA  TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA    TO D-DTFAT.
           MOVE NPAG      TO D-NPAG.
           IF KFT-TDOC = 4 OR 6
      **** rel 7.2
      *       MOVE ' IN SOSPESO' TO D-NOTA.
              IF FAT-DATA >= 42005
                 MOVE ' SCISS.PAG.' TO D-NOTA
              ELSE
                 MOVE ' IN SOSPESO' TO D-NOTA.
      ************
           MOVE BCT-DCAP  TO D-CAP.
           MOVE BCT-DCIT  TO D-CITTA.
           MOVE FAT-CDAGE TO D-CDAGE.
           MOVE FAT-CDCLI TO D-CDCLI.
           MOVE CLF-CFISC TO D-CFISC.
           IF CLF-PIVA > ZERO MOVE CLF-PIVA TO D-PIVA.
           IF CLF-13IVA = 4
              MOVE SPACE     TO D-CFISC
              MOVE CLF-CFISC TO D-PIVA.
           MOVE 6        TO KTB-TIP.
           MOVE BCT-CSPE TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE SPACE TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO D-SPEDIZ.
           PERFORM RD-NTA THRU EX-RD-NTA.
           MOVE 5        TO KTB-TIP.
           MOVE BCT-CPOR TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE SPACE TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO D-PORTO.
           PERFORM RD-NTA THRU EX-RD-NTA.
           MOVE FAT-CDPAG TO D-CDPAG.
           MOVE 4         TO KTB-TIP.
           MOVE FAT-CDPAG TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE SPACE TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO D-PAGAM.
           PERFORM RD-NTA THRU EX-RD-NTA.
           MOVE FAT-SCBAS TO D-SCBAS.
           MOVE FAT-CDBAN TO KBA-BAN.
           READ ANABAN INVALID MOVE SPACE TO BAN-RGSOC.
           MOVE BAN-RGSOC TO D-BANCA.
           MOVE T04-SCASS TO SCONTO.
           IF T04-1SCAD = ZERO MOVE 1 TO VISTA.
           IF VALUT = ZERO MOVE SPACE TO DSVAL
                           GO TO NWPG001.
           MOVE 10    TO KTB-TIP.
           MOVE VALUT TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE SPACE TO T10-DSINT.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T10-DSINT TO D-DIVISA.
           MOVE T10-DSINT TO DSVAL.
       NWPG001.
           MOVE ZERO TO FLGMCL J.
           MOVE 1 TO KN.
       VPG-0.
           IF KN > 12 GO TO VPG-1.
           IF RACF-ESCM(KN) = 1
              IF J = ZERO 
                 ADD 1 TO J 
              ELSE
                 ADD 10 TO J    
              END-IF
              MOVE 1 TO FLGMCL
              MOVE VTMES(KN) TO D-MESIESC(J:10).
           ADD 1 TO KN.
           GO TO VPG-0.

       VPG-1.
           IF FLGMCL = 1 GO TO VPG-3.

           MOVE ZERO TO J.
           MOVE 1 TO KN.
       VPG-2.
           IF KN > 12 GO TO VPG-3.
           IF T04-ESCM(KN) = 1
              IF J = ZERO 
                 ADD 1 TO J 
              ELSE
                 ADD 10 TO J    
              END-IF
              MOVE VTMES(KN) TO D-MESIESC(J:10).
           ADD 1 TO KN.
           GO TO VPG-2.
       VPG-3.
      ****
           MOVE WD-TIPS TO D-TIPS.
      ****
           MOVE 1         TO D-NCOP.
           MOVE SPACE     TO D-FAX.
           MOVE NPAG      TO D-TOTPAG.
      *
           MOVE 1 TO INDR.
       C99.
           EXIT.
      *------------------------------------------
       D00-STAMPA-CORPO.
           MOVE ZERO TO VNTMER.
           MOVE ZERO TO GARANZ.
           MOVE KBC-AZI TO KCR-AZI.
           MOVE KBC-NUM TO KCR-NUM.
           MOVE KBC-BOL TO KCR-BOL.
           MOVE 1       TO KCR-PGR.
           START BOLCRI KEY NOT < KEYCR INVALID GO TO D99.
       D10.
           READ BOLCRI NEXT AT END GO TO D99.
           IF SF-BCR = '9D' OR '9A' OR '35' GO TO D10.
           IF ( KCR-AZI NOT = KBC-AZI ) OR
              ( KCR-NUM NOT = KBC-NUM ) OR
              ( KCR-BOL NOT = KBC-BOL ) GO TO D99.
           IF INDR > MAXR
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM C00-STAMPA-TESTA THRU C99.
           MOVE BCR-DESCR TO D-ART-D(INDR).
           IF AZI-FLING = ZERO GO TO RIG10.
           IF CLF-FLING = ZERO GO TO RIG10.
           OPEN INPUT ARTLIN.
           MOVE PWFAT-AZI TO KAL-AZI.
           MOVE BCR-ART TO KAL-ART.
           READ ARTLIN INVALID GO TO RIG05.
           IF CLF-FLING = 1
              IF ARL-DES1 = SPACE GO TO RIG05
              ELSE     MOVE ARL-DES1 TO D-ART-D(INDR).
           IF CLF-FLING = 2
              IF ARL-DES2 = SPACE GO TO RIG05
              ELSE     MOVE ARL-DES2 TO D-ART-D(INDR).
           IF CLF-FLING = 3
              IF ARL-DES3 = SPACE GO TO RIG05
              ELSE     MOVE ARL-DES3 TO D-ART-D(INDR).
       RIG05.
           CLOSE ARTLIN.
       RIG10.
           IF BCR-TCOR = 1 GO TO D40.
           IF BCR-TCOR = 3 GO TO D20.
           MOVE BCR-ART TO D-ART(INDR).
           MOVE BCR-UM  TO D-UM(INDR).
           IF BCR-TQUAN = ZERO MOVE BCR-QTA TO PQTA(INDR)
           ELSE IF BCR-TQUAN = 1 MOVE BCR-QTA TO PQTA1(INDR)
                ELSE MOVE BCR-QTA TO PQTA2(INDR).
           IF BCR-TCOR = 6 GO TO D21.
           MOVE KCR-AZI     TO OP-AZI
           MOVE BCT-VALUT   TO OP-VALUT.
           MOVE BCR-PZLOR   TO OP-PREZZO.
           MOVE BCR-FSC     TO OP-FSC.
           CALL 'routprz' USING PAROP OP-VEN.
           MOVE OP-PREZZO   TO PPRZ(INDR).
           IF OP-NDEC = 2 MOVE OP-PREZZO TO PPRZ1(INDR).
           IF OP-NDEC = 3 MOVE OP-PREZZO TO PPRZ3(INDR).
           IF OP-NDEC = 4 MOVE OP-PREZZO TO PPRZ4(INDR).
           IF OP-NDEC = 5 MOVE OP-PREZZO TO PPRZ5(INDR).
           IF OP-NDEC = 6 MOVE OP-PREZZO TO PPRZ6(INDR).

           IF BCR-TCOR > 3 AND < 7 GO TO D21.
           MOVE BCR-SC1 TO SC.
           IF SC = ZERO MOVE BCR-SC2 TO SC
           ELSE IF BCR-SC2 NOT = ZERO
                MULTIPLY -1 BY SC GIVING PSCO(INDR)
                ADD 1 TO INDR
                IF INDR > MAXR
                   PERFORM SCR-REC THRU EX-SCR-REC
                   PERFORM C00-STAMPA-TESTA THRU C99
                END-IF
                MOVE BCR-SC2 TO SC.
           IF SC NOT = ZERO
              MULTIPLY -1 BY SC GIVING PSCO(INDR).
           MOVE KCR-AZI     TO OP-AZI
           MOVE BCT-VALUT   TO OP-VALUT.
           MOVE BCR-PZNET   TO OP-PREZZO.
           MOVE BCR-FSC     TO OP-FSC.
           CALL 'routprz' USING PAROP OP-VEN.
           MOVE OP-PREZZO   TO PPNET(INDR).
           IF OP-NDEC = 2 MOVE OP-PREZZO TO PPNET1(INDR).
           IF OP-NDEC = 3 MOVE OP-PREZZO TO PPNET3(INDR).
           IF OP-NDEC = 4 MOVE OP-PREZZO TO PPNET4(INDR).
           IF OP-NDEC = 5 MOVE OP-PREZZO TO PPNET5(INDR).
           IF OP-NDEC = 6 MOVE OP-PREZZO TO PPNET6(INDR).
       D20.
           MOVE BCR-NETRG TO PTNET1(INDR).
           IF VALUT = 1 MOVE BCR-NETRG TO PTNET(INDR).
       D21.
           IF BCR-TCOR = 4
              ADD 1 TO INDR
              IF INDR > MAXR
                 PERFORM SCR-REC THRU EX-SCR-REC
                 PERFORM C00-STAMPA-TESTA THRU C99
              END-IF
              MOVE '* CESSIONE GRATUITA' TO D-ART-D(INDR).
           IF BCR-TCOR = 5
              ADD 1 TO INDR
              IF INDR > MAXR
                 PERFORM SCR-REC THRU EX-SCR-REC
                 PERFORM C00-STAMPA-TESTA THRU C99
              END-IF
              MOVE '* SCONTO IN MERCE' TO D-ART-D(INDR).
           IF BCR-TCOR = 6
              ADD 1 TO INDR
              IF INDR > MAXR
                 PERFORM SCR-REC THRU EX-SCR-REC
                 PERFORM C00-STAMPA-TESTA THRU C99
              END-IF
              MOVE '* CESSIONE IN GARANZIA' TO D-ART-D(INDR).
           IF FAT-CDESE = ZERO GO TO D30.
           IF BCR-TCOR NOT = 3 GO TO D30.
           MOVE 11 TO KTB-TIP.
           MOVE BCR-SPESA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM INVK-TAB
                PERFORM VISK-BCR
                GO TO WARNING.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T11-SCONT > ZERO ADD BCR-NETRG TO NOSCON.
           IF FAT-CDESE = ZERO GO TO D30.
           IF BCR-IVA = ZERO GO TO D30.
           MOVE 3        TO KTB-TIP.
           MOVE T11-CIVA TO KTB-COD D-I(INDR).
           READ TABELL INTO REKTAB INVALID
                PERFORM INVK-TAB
                PERFORM VISK-BCR
                GO TO WARNING.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF NOT (VALUT = ZERO OR COMEURO OR 1) GO TO D30.
           IF T03-ALIVA = ZERO GO TO D40.
       D30.
           IF BCR-TCOR = 4 OR 5 MOVE BCR-RIVGR TO D-I(INDR)
              ELSE IF FAT-CDESE = ZERO MOVE BCR-IVA TO D-I(INDR)
                   ELSE MOVE FAT-CDESE TO D-I(INDR).
           IF VALUT NOT = ZERO AND
              FAT-CDESE NOT = ZERO AND (BCR-TCOR = 4 OR 5 OR 6)
                MOVE FAT-CDESE TO D-I(INDR).
       D40.
           IF BCR-TCOR = 6 AND ESTPIVA = 3
                           ADD BCR-NETRG TO GARANZ.
           IF NOT (VALUT = ZERO OR COMEURO) AND BCR-TCOR < 4
              ADD BCR-NETRG TO VNTMER.
           MOVE 1 TO FLGSTA.
      * stampa note aggiuntive
           MOVE KCR-AZI TO KNCR-AZI.
           MOVE KCR-NUM TO KNCR-NUM.
           MOVE KCR-BOL TO KNCR-BOL.
           MOVE KCR-PGR TO KNCR-PGR.
           MOVE ZERO    TO KNCR-PGRN.
           START NOTBCR KEY > KEYNCR INVALID GO TO D70.
       RDN-NCR.
           READ NOTBCR NEXT AT END GO TO D70.
           IF KNCR-AZI > KCR-AZI GO TO D70.
           IF KNCR-NUM > KCR-NUM GO TO D70.
           IF KNCR-BOL > KCR-BOL GO TO D70.
           IF KNCR-PGR > KCR-PGR GO TO D70.
           ADD 1 TO INDR.
           IF INDR > MAXR
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM C00-STAMPA-TESTA THRU C99.
           MOVE NCR-DESCR TO D-ART-D(INDR).
       D50.
           MOVE ZERO TO FLGSTA.
           GO TO RDN-NCR.
      *
       D70.
           IF BCR-ART NOT = SPACE
              MOVE ZERO     TO PCFA-FUN
              MOVE KCR-AZI  TO PCFA-AZI
              MOVE 'C'      TO PCFA-TIP
              MOVE FAT-CDCLI TO PCFA-CLF
              MOVE BCR-ART TO PCFA-ART
              MOVE CLF-FLING TO PCFA-LIN
              CALL 'vrrcfa' USING PARPCFA
              IF PCFA-ST = ZERO
                 IF PCFA-DEST NOT = SPACE
                    ADD 1 TO INDR
                    IF INDR > MAXR 
                       PERFORM SCR-REC THRU EX-SCR-REC   
                       PERFORM C00-STAMPA-TESTA THRU C99
                    END-IF
                    MOVE PCFA-DEST TO D-ART-D(INDR)
                 END-IF
                 IF PCFA-DDIS NOT = SPACE
                    ADD 1 TO INDR
                    IF INDR > MAXR 
                       PERFORM SCR-REC THRU EX-SCR-REC   
                       PERFORM C00-STAMPA-TESTA THRU C99
                    END-IF
                    MOVE PCFA-DDIS TO D-ART-D(INDR).
           IF BCT-IMB = 1 PERFORM WR-LAV-IMB THRU EX-WR-LAV-IMB.
           ADD 1 TO INDR.
           GO TO D10.
       D99.
           EXIT.
      *------------------------------------------
       E00-STAMPA-PIEDE.
           PERFORM H00-STAMPA-MESSAGG-BOLLA THRU H99.
           IF FLGTES = ZERO SUBTRACT 1 FROM INDR.
           PERFORM SOMMA-IMBALLI THRU EX-SOMMA-IMBALLI.
           PERFORM G00-STAMPA-IMBALLI THRU G99.
           IF ESTPIVA NOT = 3 PERFORM STAMPA-CONAI THRU EX-STAMPA-CONAI.
           MOVE ZERO TO NN.
           ADD 2 TO INDR.
           IF FAT-OMAGG > ZERO
              ADD 1 TO NN
              IF FAT-IVRIV NOT = ZERO
                 ADD 1 TO NN.
           IF FAT-SCONT > ZERO
              ADD 1 TO NN
              IF ESTPIVA = 3
                 ADD 1 TO NN.
           IF GARANZ > ZERO AND ESTPIVA = 3 ADD 2 TO NN.
      **** rel 7.2
           IF (KFT-TDOC = 6 OR KFT-TDOC = 4) AND
              FAT-DATA >= 42005 
              PERFORM J00-STAMPA-SPLITPAY THRU J99.
      ************
           IF FAT-CDESE = ZERO GO TO LPPIEDE.
           IF CLF-ENUIVA = ZERO GO TO LPPIEDE.
           IF ESTPIVA NOT = 6 GO TO LPPIEDE.
      * nota: il valore 4 sommato a INDR e a NN e' il numero di righe
      *       occorrenti per i rifer. alla lettera d'intento
           IF (INDR + NN + 4) > MAXR
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM C00-STAMPA-TESTA THRU C99.
           COMPUTE INDR = MAXR - 4 - NN.
           MOVE 'Non imp. IVA art 8/2  DPR 633' TO D-ART-D(INDR).
           ADD 1 TO INDR.
           MOVE 'del 26/10/72 e succ. modifiche' TO D-ART-D(INDR).
           ADD 1 TO INDR.
           MOVE 'Vs aut. N.' TO DES1(INDR).
           MOVE CLF-ENUIVA TO SOUT(INDR).
           MOVE ' del' TO DES2(INDR).
           MOVE CLF-EDTIVA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO SDEL(INDR).
           ADD 1 TO INDR.
           MOVE 'Ns protoc.' TO DES1(INDR).
           MOVE CLF-INUIVA TO SOUT(INDR).
           MOVE ' del' TO DES2(INDR).
           MOVE CLF-IDTIVA TO AAGGG.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO SDEL(INDR).
       LPPIEDE.
           IF NN = ZERO GO TO LPPIE-99.
           IF (INDR + NN) > MAXR
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM C00-STAMPA-TESTA THRU C99.
           COMPUTE INDR = MAXR - NN.
           IF FAT-OMAGG = ZERO GO TO LPPIE-20.
           ADD 1 TO INDR.
           MOVE 'Cessione gratuita = ' TO RDSMO(INDR).
           IF (VALUT = ZERO OR COMEURO)
              MOVE FAT-OMAGG TO RDIMP1(INDR)
           ELSE
              MOVE FAT-EOMAGG TO RDIMP1(INDR).
           IF VALUT = 1 MOVE FAT-EOMAGG TO RDIMP(INDR).
           IF FAT-IVRIV = ZERO GO TO LPPIE-10.
           ADD 1 TO INDR.
           MOVE 'Iva nostro carico = ' TO RDSIV(INDR).
           IF (VALUT = ZERO OR COMEURO)
              MOVE FAT-IVRIV TO ERDIVA(INDR)
           ELSE
              MOVE FAT-EIVRIV TO ERDIVA(INDR).
           IF VALUT = 1 MOVE FAT-EIVRIV TO RDIVA(INDR).
       LPPIE-10.
       LPPIE-20.
           IF FAT-SCONT = ZERO GO TO LPPIE-30.
           ADD 1 TO INDR.
           MOVE 'Sconto in merce   = ' TO RDSMO(INDR).
           IF (VALUT = ZERO OR COMEURO)
              MOVE FAT-SCONT TO RDIMP1(INDR)
           ELSE
              MOVE FAT-ESCONT TO RDIMP1(INDR).
           IF VALUT = 1 MOVE FAT-ESCONT TO RDIMP(INDR).
       LPPIE-30.
           IF GARANZ = ZERO OR ESTPIVA NOT = 3 GO TO LPPIE-99.
           ADD 1 TO INDR.
           MOVE 'Valore ai fini doganali' TO D-ART-D(INDR).
           MOVE GARANZ TO RDIMP1(INDR).
           IF VALUT = 1 MOVE GARANZ TO RDIMP(INDR).
       LPPIE-99.
           IF NOT (VALUT = ZERO OR COMEURO)
              COMPUTE VSCFIN = (VNTMER - NOSCON) * SCONTO / 100.
           IF VALUT = ZERO OR COMEURO
              MOVE FAT-NTMER TO PNET1
           ELSE
              MOVE DSVAL     TO D-DESVAL
              MOVE VNTMER    TO PNET1.
           IF VALUT = 1 MOVE VNTMER TO PNET.
           MOVE ZERO TO IMPON IMPOS.
           MOVE ZERO TO K.
       LSCA.
           ADD 1 TO K.
           IF K > 6 GO TO GSCA.
           IF FAT-CDIVA (K) = ZERO GO TO GSCA.
           MOVE FAT-CDIVA (K) TO KTB-COD.
           MOVE 3             TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                MOVE 'IVA INESISTENTE' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE FAT-CDIVA (K) TO D-CI(K).
           IF VALUT = ZERO OR COMEURO
              MOVE FAT-IMPON(K) TO PIMP1(K)
              MOVE FAT-IMPOS(K) TO EPIMIVA(K)
              ADD  FAT-IMPON(K) TO IMPON
              ADD  FAT-IMPOS(K) TO IMPOS
           ELSE
              MOVE FAT-EIMPON(K) TO PIMP1(K)
              MOVE FAT-EIMPOS(K) TO EPIMIVA(K)
              ADD  FAT-EIMPON(K) TO IMPON
              ADD  FAT-EIMPOS(K) TO IMPOS.
           IF VALUT = 1
              MOVE FAT-EIMPON(K) TO PIMP(K)
              MOVE FAT-EIMPOS(K) TO PIMIVA(K).
           IF T03-ALIVA = ZERO
              MOVE TAB-DESCR TO D-ALIQ(K)
           ELSE
              MOVE T03-DSIVA TO D-ALIQ(K).
       GSCA.
           IF K = 1 GO TO LRIE.
           IF K > 7 GO TO ESCA.
      **** rel 6.1
      *    SUBTRACT 1 FROM K.
      *    IF FAT-DTSCA (K) = ZERO GO TO GSCA1.
      *    IF VISTA = 1 MOVE 'A VISTA' TO D-DTSCA(K)
      *                 MOVE ZERO TO VISTA
      *                 GO TO GSCA0.
      *    MOVE FAT-DTSCA (K) TO AAGGG.
      *    CALL 'rdata' USING PARCDT.
      *    MOVE GBMMBA TO D-DTSCA(K).
      *GSCA0.
      *    IF VALUT = ZERO OR COMEURO
      *       MOVE FAT-IMPOR (K) TO PSCIM2(K)
      *    ELSE
      *       MOVE FAT-EIMPOR (K) TO PSCIM2(K).
      *    IF VALUT = 1
      *          MOVE FAT-EIMPOR (K) TO PSCIMP(K).
      *GSCA1.
      *    ADD 1 TO K.
      ************
       LRIE.
           IF K = 1 AND FAT-SCFIN > ZERO
               MOVE 'sc.' TO PSFIN
               MOVE SCONTO    TO PSPER
               MOVE '%' TO FILPE
               MOVE 'su' TO FILLUN
               GO TO LSCA.
           IF K = 2 AND FAT-SCFIN > ZERO
              MOVE SPACE TO PSCO1
              IF VALUT = ZERO OR COMEURO
                 COMPUTE PSCO3  = FAT-NTMER - NOSCON
                 COMPUTE SPSCF1 = - FAT-SCFIN
              ELSE
                 COMPUTE PSCO3  = VNTMER - NOSCON
                 COMPUTE SPSCF1 = - VSCFIN
              END-IF
              IF VALUT = 1
                 COMPUTE PSCO2 = VNTMER - NOSCON
                 COMPUTE SPSCF = - VSCFIN.
           IF K = 4 AND FAT-SPBOL > ZERO
                    AND (VALUT = ZERO OR COMEURO)
               MOVE 'BOLLI' TO D-BOLLI
               MOVE FAT-SPBOL TO D-IMPBOLLI2.
           IF K = 4 AND FAT-ESPBOL > ZERO
                    AND VALUT = 1    MOVE 'BOLLI'    TO D-BOLLI
                                     MOVE FAT-ESPBOL TO D-IMPBOLLI.
           IF K = 6 AND FAT-SPBAN > ZERO
              MOVE 'SPESE BANCA' TO D-DSPBANCA
              IF VALUT = ZERO OR COMEURO
                 MOVE FAT-SPBAN TO PIBAN1
              ELSE
                 MOVE FAT-ESPBAN TO PIBAN1
              END-IF
              IF VALUT = 1 MOVE FAT-ESPBAN TO PIBAN.
           GO TO LSCA.
       ESCA.
      **** rel 6.1
      *    MOVE 6 TO K.
           MOVE ZERO TO K.
      ************
       LPK.
           ADD 1 TO K.
           IF K > 12 GO TO END-SC.
           IF FAT-DTSCA (K) = ZERO GO TO LPK.
      **** rel 6.1
      *    MOVE FAT-DTSCA (K) TO AAGGG.
      *    CALL 'rdata' USING PARCDT.
      *    MOVE GBMMBA TO D-DTSCA(K).
           IF VISTA = 1
              MOVE 'A VISTA' TO D-DTSCA(K)
              MOVE ZERO TO VISTA
           ELSE
              MOVE FAT-DTSCA (K) TO AAGGG
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE GBMMBA TO D-DTSCA(K).
      ************
           IF VALUT = ZERO OR COMEURO
              MOVE FAT-IMPOR(K)  TO PSCIM2(K)
           ELSE
              MOVE FAT-EIMPOR(K) TO PSCIM2(K).
           IF VALUT = 1 MOVE FAT-EIMPOR(K) TO PSCIMP(K).
      **** rel 6.1
           GO TO LPK.
      ************
       END-SC.
           MOVE IMPON TO PTIM1.
           IF VALUT = 1 MOVE IMPON TO PTIM.
           MOVE IMPOS TO PTIV1.
           IF VALUT = 1 MOVE IMPOS TO PTIV.
      **** rel 7.2
           IF (KFT-TDOC = 6 OR KFT-TDOC = 4) AND
              FAT-DATA >= 42005 
              GO TO NOSAC.
      ************
           IF VALUT = ZERO OR COMEURO
              COMPUTE TOTACC = FAT-TOTFT - FAT-IMPOR(1)
                                         - FAT-IMPOR(2)
                                         - FAT-IMPOR(3)
                                         - FAT-IMPOR(4)
                                         - FAT-IMPOR(5)
                                         - FAT-IMPOR(6)
                                         - FAT-IMPOR(7)
                                         - FAT-IMPOR(8)
                                         - FAT-IMPOR(9)
                                         - FAT-IMPOR(10)
                                         - FAT-IMPOR(11)
                                         - FAT-IMPOR(12)
           ELSE
              COMPUTE TOTACC = FAT-TOVAL - FAT-EIMPOR(1)
                                         - FAT-EIMPOR(2)
                                         - FAT-EIMPOR(3)
                                         - FAT-EIMPOR(4)
                                         - FAT-EIMPOR(5)
                                         - FAT-EIMPOR(6)
                                         - FAT-EIMPOR(7)
                                         - FAT-EIMPOR(8)
                                         - FAT-EIMPOR(9)
                                         - FAT-EIMPOR(10)
                                         - FAT-EIMPOR(11)
                                         - FAT-EIMPOR(12).
           IF TOTACC > ZERO MOVE 'ACCONTO' TO D-DACCONTO
                            MOVE TOTACC TO D-ACCONTO2
                            IF VALUT = 1
                            MOVE TOTACC TO D-ACCONTO.
       NOSAC.
           IF VALUT = ZERO OR COMEURO
              MOVE FAT-TOTFT TO PTOT1
           ELSE
              MOVE FAT-TOVAL TO PTOT1.
           IF VALUT = 1 MOVE FAT-TOVAL TO PTOT.
           MOVE ZERO TO D-TFTEUR.
           MOVE BCT-DEST TO D-DESTINAZ.
           MOVE BCT-ASPE TO D-ASPETTO.
           MOVE BCT-NCOL TO D-NCOLLI.
           MOVE BCT-PLOR TO D-PESOLOR.
           MOVE BCT-PNET TO D-PESONET.
           IF BCT-VRAG1 = SPACE GO TO E50.
           MOVE BCT-VRAG1 TO D-RGSOC-V1.
           MOVE BCT-VIND1 TO D-INDIR-V1.
           MOVE BCT-DTRA  TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA   TO DTRA.
           IF DTRA     NOT = ZERO MOVE DTRA     TO D-DATA-V1
           IF BCT-OTRA NOT = ZERO MOVE BCT-OTRA TO D-ORA-V1.
       E50.
           MOVE BCT-CAUT TO D-CAUTRA.
           IF BCT-VRAG1 NOT = SPACE GO TO E90.
           MOVE BCT-DTRA  TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA   TO DTRA.
           IF DTRA     NOT = ZERO MOVE DTRA     TO D-DTTRA
           IF BCT-OTRA NOT = ZERO MOVE BCT-OTRA TO D-ORATRA.
       E90.
           MOVE BCT-NOT1 TO D-NOT1.
           MOVE BCT-NOT2 TO D-NOT2.
           MOVE BCT-NOT3 TO D-NOT3.
           MOVE BCT-NOT4 TO D-NOT4.
           MOVE BCT-NOT5 TO D-NOT5.
           PERFORM SCR-REC THRU EX-SCR-REC.
       E99.
           EXIT.
      *-------------------------------
       RDCL.
           MOVE FAT-CDCLI TO COD.
           MOVE KAZ-COD   TO KCF-AZI.
           MOVE CODICE    TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID KEY
                  PERFORM INVK-CLF
                  PERFORM VISK-FAT
                  GO TO WARNING.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
           MOVE KAZ-COD    TO RACF-AZI.
           MOVE CODICE     TO RACF-COD.
           CALL 'rrdacf' USING PARACF.
       EX-RDCL.
           EXIT.
      *-------------------------------
       G00-STAMPA-IMBALLI.
           MOVE ZERO TO INDICE.
       REPEAT.
           ADD 1 TO INDICE.
           IF INDICE > ULTIND GO TO G99.
           ADD 1 TO INDR.
           IF INDR > MAXR
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM C00-STAMPA-TESTA THRU C99.
           MOVE KAZ-COD        TO KAIM-AZI.
           MOVE VETIMB(INDICE) TO KAIM-COD.
           READ ANAIMB INVALID PERFORM INVK-AIM
                               GO TO ERRIO.
           MOVE VETIMB(INDICE) TO D-ART(INDR).
           MOVE AIM-DESC       TO D-ART-D(INDR).
           MOVE VETQTA(INDICE) TO PQTA(INDR).
           IF VALUT = ZERO OR COMEURO
              MOVE AIM-COSU TO PPRZ1(INDR)
              COMPUTE IMPIMB = VETQTA(INDICE) * AIM-COSU
              MOVE IMPIMB TO PTNET1(INDR)
           ELSE
              MOVE AIM-COSU TO ER-IMPORTO
              MOVE CG-CAMBIO TO ER-CAMBIO
              MOVE CG-VALUT  TO ER-VALUT
              CALL 're2imp' USING ER-IMPORTO EUR-VAL ER-VALUT ER-CAMBIO
              MOVE ER-IMPORTO TO PPRZ1(INDR)
              IF VALUT = 1
                 MOVE ER-IMPORTO TO PPRZ(INDR)
              END-IF
              COMPUTE ER-IMPORTO = ER-IMPORTO * VETQTA(INDICE)
              ADD ER-IMPORTO TO VNTMER
              MOVE ER-IMPORTO TO PTNET1(INDR)
              IF VALUT = 1
                 MOVE ER-IMPORTO TO PTNET(INDR).
           IF FAT-CDESE = ZERO
              MOVE AIM-CDIVA TO D-I(INDR)
           ELSE
              MOVE FAT-CDESE TO D-I(INDR).
           GO TO REPEAT.
       G99.
           EXIT.
      *-------------------------------
       STAMPA-CONAI.
           IF CLF-CONAI NOT = 1 GO TO EX-STAMPA-CONAI.
           ADD 2 TO INDR.
           IF INDR > MAXR
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM C00-STAMPA-TESTA THRU C99.
      **** rel 6.3
      *    MOVE 'CONTRIBUTO CONAI ASSOLTO' TO D-ART-D(INDR).
      **** rel 7.2
      *    MOVE 'CONTRIBUTO CONAI ASSOLTO OVE DOVUTO' TO D-ART-D(INDR).
           MOVE 'contributo conai assolto ove dovuto' TO D-ART-D(INDR).
      ************
      ************
       EX-STAMPA-CONAI.
           EXIT.
      *-------------------------------
       SCR-REC.
           MOVE SPACE TO D-FLGS.
           IF PCCD-FLGS = 0
              MOVE 'S' TO D-FLGS.
           MOVE PCCD-PATH TO D-IDDOC.
      *
           PERFORM WRD-WR.
       EX-SCR-REC.
      *-------------------------------
       WR-LAV-IMB.
           IF NOT (BCR-TCOR = ZERO OR 2) GO TO EX-WR-LAV-IMB.
           MOVE KBC-AZI TO KPBR-AZI.
           MOVE KBC-NUM TO KPBR-TNUM.
           MOVE KBC-BOL TO KPBR-NBOL.
           MOVE KCR-PGR TO KPBR-RBOL.
           MOVE ZERO    TO KPBR-PGR.
           START PROBCR KEY NOT < KEYPBR INVALID GO TO EX-WR-LAV-IMB.
       LAV-IMB-10.
           READ PROBCR NEXT AT END GO TO EX-WR-LAV-IMB.
           IF SF-PBR = '9D' OR '9A' OR '35' GO TO LAV-IMB-10.
           IF KBC-AZI NOT = KPBR-AZI  GO TO EX-WR-LAV-IMB.
           IF KBC-NUM NOT = KPBR-TNUM GO TO EX-WR-LAV-IMB.
           IF KBC-BOL NOT = KPBR-NBOL GO TO EX-WR-LAV-IMB.
           IF KCR-PGR NOT = KPBR-RBOL GO TO EX-WR-LAV-IMB.
      *
           MOVE KBC-AZI TO KAIM-AZI.
           MOVE PBR-IMB TO KAIM-COD.
           READ ANAIMB INVALID PERFORM INVK-AIM
                               PERFORM VISK-PBR
                               GO TO ERRIO.
           IF AIM-FLGREND = 1 GO TO LAV-IMB-10.
      *
           MOVE PBR-NPAL TO KWSI-NPAL.
           MOVE PBR-NCOL TO KWSI-NCOL.
           MOVE PBR-IMB  TO KWSI-IMB.
           ADD 1         TO KWSI-PRG.
           MOVE PBR-NIMB TO WSI-NIMB.
           WRITE RF-WSI INVALID MOVE 'vfat220w: WR-LAV WSI' TO MESS
                                GO TO ERRIO.
      *
           GO TO LAV-IMB-10.
       EX-WR-LAV-IMB.
           EXIT.
      *-------------------------------
       DL-LAV-IMB.
           CLOSE WDSSIB.
           OPEN OUTPUT WDSSIB.
           CLOSE WDSSIB.
           OPEN I-O WDSSIB.
           MOVE ZERO TO KWSI-PRG.
       EX-DL-LAV-IMB.
      *-------------------------------
       SOMMA-IMBALLI.
      * azzeramento vettore totali imballi
           MOVE 1 TO INDICE.
           PERFORM UNTIL INDICE > 30
              MOVE SPACE TO VETIMB(INDICE)
              MOVE ZERO  TO VETQTA(INDICE)
              ADD 1 TO INDICE
           END-PERFORM.
      *
           MOVE ZERO  TO PREPAL PRECOL.
           MOVE SPACE TO PREIMB.
           MOVE ZERO  TO ULTIND.
      *
           MOVE LOW-VALUE TO KEYWSI.
           START WDSSIB KEY > KEYWSI INVALID GO TO EX-SOMMA-IMBALLI.
       SOMMA-IMB-10.
           READ WDSSIB NEXT AT END GO TO EX-SOMMA-IMBALLI.
           IF KWSI-NCOL = ZERO
              MOVE WSI-NIMB TO COMNIMB
              GO TO SOMMA-IMB-20.
           IF KWSI-NPAL = PREPAL AND
              KWSI-NCOL = PRECOL AND
              KWSI-IMB  = PREIMB GO TO SOMMA-IMB-10.
           MOVE 1 TO COMNIMB.
       SOMMA-IMB-20.
           MOVE KWSI-NPAL TO PREPAL.
           MOVE KWSI-NCOL TO PRECOL.
           MOVE KWSI-IMB  TO PREIMB.
      *
           MOVE 1 TO INDICE.
           PERFORM UNTIL INDICE > 30
              IF VETIMB(INDICE) = SPACE
                 MOVE KWSI-IMB TO VETIMB(INDICE)
                 MOVE COMNIMB  TO VETQTA(INDICE)
                 MOVE INDICE TO ULTIND
                 MOVE 30 TO INDICE
              ELSE
                 IF VETIMB(INDICE) = KWSI-IMB
                     ADD COMNIMB TO VETQTA(INDICE)
                     MOVE 30 TO INDICE
                 END-IF
              END-IF
              ADD 1 TO INDICE
           END-PERFORM.
      *
           GO TO SOMMA-IMB-10.
       EX-SOMMA-IMBALLI.
           EXIT.
      *-------------------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-WSI.
           STRING 'w0' PID DELIMITED SPACE INTO ID-WSI.
       EX-CREA-IDLAV.
           EXIT.
      *-------------------------------
       H00-STAMPA-MESSAGG-BOLLA.
           MOVE ZERO TO FLGTES.
           ADD 1 TO INDR.
           MOVE KAZ-COD  TO P-MDT-AZI.
           MOVE 1        TO P-MDT-TDOC.
           MOVE KEYBC    TO P-MDT-KEY.
           MOVE 2        TO P-MDT-FLGS.
           MOVE BCT-DATA TO P-MDT-DATA.
           MOVE ZERO     TO P-MDT-FLGE.
       H10.
           CALL 'vrpmdt' USING PAR-P-MDT.
           IF P-MDT-FLGE NOT = 1 GO TO H99.
           ADD 1 TO INDR.
           IF INDR > MAXR
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM C00-STAMPA-TESTA THRU C99.
           MOVE P-MDT-TESTO(1:P-MDT-NCOL) TO D-ART-D(INDR).
           MOVE 1 TO FLGTES.
           GO TO H10.
       H90.
           IF P-MDT-TDOC = 1 MOVE 3  TO P-MDT-TDOC
                             GO TO H10.
       H99.
           EXIT.
      *-------------------------------
      * fase di lettura note 
       RD-NTA.
           MOVE ZERO TO KN.
      *
           MOVE TAB-TIP TO KNTA-TIP.
           MOVE TAB-COD TO KNTA-COD.
           MOVE ZERO    TO KNTA-PRG.
           START NOTTAB KEY >= KEYNTA INVALID GO TO RD-NTA-20.
       RD-NTA-10.
           READ NOTTAB NEXT AT END GO TO RD-NTA-20.
           IF KNTA-TIP > TAB-TIP GO TO RD-NTA-20.
           IF KNTA-COD > TAB-COD GO TO RD-NTA-20.
           ADD 1 TO KN.
           IF TAB-TIP = 4 MOVE NTA-DESCR TO D-NOTP(KN).
           IF TAB-TIP = 5 MOVE NTA-DESCR TO D-NOTR(KN).
           IF TAB-TIP = 6 MOVE NTA-DESCR TO D-NOTS(KN).
           GO TO RD-NTA-10.
       RD-NTA-20.
      *
       EX-RD-NTA.
           EXIT.
      *-------------------------------
      **** rel 7.2
       J00-STAMPA-SPLITPAY.
      *
           ADD 1 TO INDR.
           IF INDR > MAXR
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM C00-STAMPA-TESTA THRU C99.
           MOVE '- Scissione dei pagamenti -'    TO D-ART-D(INDR).
      *
           ADD 1 TO INDR.
           IF INDR > MAXR
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM C00-STAMPA-TESTA THRU C99.
           MOVE 'Iva da versare a cura del'    TO D-ART-D(INDR).
           ADD 1 TO INDR.
           IF INDR > MAXR
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM C00-STAMPA-TESTA THRU C99.
           MOVE 'cessionario o committente ai' TO D-ART-D(INDR).
           ADD 1 TO INDR.
           IF INDR > MAXR
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM C00-STAMPA-TESTA THRU C99.
           MOVE 'sensi dell''Articolo 17-Ter'  TO D-ART-D(INDR).
           ADD 1 TO INDR.
           IF INDR > MAXR
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM C00-STAMPA-TESTA THRU C99.
           MOVE 'D.P.R n.633/1972 e '         TO D-ART-D(INDR).
           ADD 1 TO INDR.
           IF INDR > MAXR
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM C00-STAMPA-TESTA THRU C99.
           MOVE 'successive modifiche'         TO D-ART-D(INDR).
      *
       J99.
           EXIT.
      *-------------------------------
      ************
