       IDENTIFICATION DIVISION.
       PROGRAM-ID. VTXT-WR.
      *
      * OGGETTO: scrive file sequenziale generico
      *
      **** rel 6.2
      * nuovo
      ************ 
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
      *
           SELECT FILEFX ASSIGN TO PWTX-NOMEFX  
                  ORGANIZATION SEQUENTIAL.
      *
       DATA DIVISION.
       FILE SECTION.
      *
       FD  FILEFX LABEL RECORD OMITTED DATA RECORD RF-FFX.
       01  RF-FFX PIC X.
      *
       WORKING-STORAGE SECTION.
           COPY 'grirel-62'.
      *
       01  COMODI.
           05 T-CR     PIC XX    VALUE X'0D'.
           05 T-LF     PIC XX    VALUE X'0A'.
           05 S-TAB    PIC X     VALUE X'09'.
           05 IND      PIC 999   VALUE ZERO.
           05 INDR     PIC 999   VALUE ZERO.
           05 FLG-OPEN PIC 9     VALUE ZERO.
           05 FLG-REC  PIC 9     VALUE ZERO.
      *
       LINKAGE SECTION.
           COPY 'parwtxt'.
      *
       PROCEDURE DIVISION USING PARWTXT.
      *
       INIZIO.
      *
           IF PWTX-NOMEFX = SPACE GO TO FINE.
      *
           IF PWTX-FUN = 'W' OR 'w'
              PERFORM FUN-W THRU EX-FUN-W.

           IF PWTX-FUN = 'C'
              PERFORM FUN-C THRU EX-FUN-C.

           IF PWTX-FUN = 'E' PERFORM FUN-E.

           GO TO FINE.
      * 
       FINE.
           EXIT PROGRAM.
      *------------------
       APRI-FILE.
           IF PWTX-FUN = 'w'
              OPEN OUTPUT FILEFX
           ELSE
              OPEN EXTEND FILEFX.
           MOVE 1 TO FLG-OPEN.
           MOVE ZERO TO FLG-REC.
           MOVE ZERO TO PWTX-INDS.
      *------------------
       FUN-E.
           IF FLG-OPEN NOT = ZERO
              IF FLG-REC NOT = ZERO OR
                 (PWTX-CAMPO NOT = SPACE OR PWTX-LEN NOT = ZERO)
                     PERFORM FUN-C THRU EX-FUN-C
              END-IF
              CLOSE FILEFX
              MOVE ZERO TO FLG-OPEN.
              MOVE ZERO TO FLG-REC.
      *------------------
       WR-CAMPO.
           IF PWTX-LEN = ZERO
              MOVE 500 TO IND
              PERFORM UNTIL PWTX-CAMPO(IND:1) NOT = SPACE OR IND = ZERO
                      SUBTRACT 1 FROM IND
           ELSE
              MOVE PWTX-LEN TO IND.

           MOVE 1 TO INDR.
           PERFORM UNTIL INDR > IND
                   MOVE PWTX-CAMPO(INDR:1) TO RF-FFX
                   WRITE RF-FFX
                   ADD 1 TO INDR.
           MOVE SPACE TO PWTX-CAMPO.
           MOVE ZERO TO PWTX-LEN.
           MOVE 1 TO FLG-REC.
      *------------------
       CAR-SEP.
           IF PWTX-SEP NOT = SPACE
              MOVE PWTX-SEP TO PWTX-CAMPO
              IF PWTX-SEP = 'T'
                 MOVE S-TAB TO PWTX-CAMPO
              END-IF
              MOVE 1 TO PWTX-LEN
              PERFORM WR-CAMPO.
      *------------------
      * write campo su record
       FUN-W.
           IF FLG-OPEN = ZERO PERFORM APRI-FILE.
           PERFORM SCRIVE-CAMPO.
           PERFORM CAR-SEP.
       EX-FUN-W.
           EXIT.
      *------------------
       SCRIVE-CAMPO.
           PERFORM WR-CAMPO.
           ADD 1 TO PWTX-INDS.
      *------------------
      * chiusura record
       FUN-C.

      * scrive eventuale ultimo campo
           IF PWTX-CAMPO NOT = SPACE OR PWTX-LEN NOT = ZERO
              PERFORM SCRIVE-CAMPO.

           IF FLG-REC = ZERO GO TO EX-FUN-C.

           IF PWTX-EOR NOT = 9
              IF PWTX-EOR = ZERO OR 1
                 MOVE T-CR TO PWTX-CAMPO
                 MOVE 1 TO PWTX-LEN
                 PERFORM WR-CAMPO
              END-IF
              IF PWTX-EOR = ZERO OR 2
                 MOVE T-LF TO PWTX-CAMPO
                 MOVE 1 TO PWTX-LEN
                 PERFORM WR-CAMPO
              END-IF
           MOVE ZERO TO FLG-REC.
           MOVE ZERO TO PWTX-INDS.
       EX-FUN-C.
           EXIT.
      *------------------
