       IDENTIFICATION DIVISION.
       PROGRAM-ID. VCON113.
      *
      * OGGETTO: Generazione mastrini e aggiornamento contabile
      *
      * Nota: il chiamante dopo la call deve testare
      *       errio-st distinguendo: 9 per errore bloccante
      *                              8 per warning
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griconsl'.
           COPY 'griclfsl'.
           COPY 'grimovsl'.
           COPY 'grimszsl'.
           COPY 'griparsl'.
           COPY 'grifcdsl'.
           COPY 'griscasl'.
           COPY 'griftssl'.
           COPY 'gritabsl'.
      **** rel 6.2
           COPY 'griautsl'.
           COPY 'grinscsl'.
      ************
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gricon'.
           COPY 'griclf'.
           COPY 'grimov'.
           COPY 'grimsz'.
           COPY 'gripar'.
           COPY 'grifcd'.
           COPY 'grisca'.
           COPY 'grifts'.
           COPY 'gritab'.
      **** rel 6.2
           COPY 'griaut'.
           COPY 'grinsc'.
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griazirk'.
           COPY 'griconrk'.
           COPY 'gritabrk'.
           COPY 'grit14g'.
           COPY 'grit25rk'.
           COPY 'grit20rk'.
           COPY 'griclfrk'.
           COPY 'grimovrk'.
           COPY 'griparrk'.
           COPY 'grit35rk'.
           COPY 'rekt23'.
           COPY 'parcdt'.
           COPY 'parzf'.
      **** rel 1.2
           COPY 'parlk'.
      ************
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-MSZ PIC X(15) VALUE 'movsez'.
       01  ID-FCD PIC X(15) VALUE 'forncd'.
       01  ID-PAR PIC X(15) VALUE 'partit'.
       01  ID-SCA PIC X(15) VALUE 'anasca'.
       01  ID-FTS PIC X(15) VALUE 'fatsos'.
      **** rel 6.2
       01  ID-AUT PIC X(15) VALUE 'anaaut'.
       01  ID-NSC PIC X(15) VALUE 'notsca'.
      ************
       01  AREE-MS.
           05 SF-AZI PIC XX.
           05 SF-CON PIC XX.
           05 SF-CLF PIC XX.
           05 SF-TAB PIC XX.
           05 SF-MOV PIC XX.
           05 SF-MSZ PIC XX.
           05 SF-FCD PIC XX.
           05 SF-PAR PIC XX.
           05 SF-SCA PIC XX.
           05 SF-FTS PIC XX.
      **** rel 6.2
           05 SF-AUT  PIC XX.
           05 SF-NSC  PIC XX.
      ************
           05 MESS    PIC X(40) VALUE SPACE.
           05 RISP    PIC 9     VALUE ZERO.
       01  AREE-LAV.
           05 CAN PIC 9(17) VALUE ZERO.
           05 CCC REDEFINES CAN.
              10 TIPO PIC 9.
              10 CLFO PIC 9(5).
              10 ANNO PIC 9(4).
              10 PART PIC 9(5).
              10 NUME PIC 99.
           05 KMX  PIC 99 VALUE 6.
           05 K    PIC 99 VALUE ZERO.
           05 I    PIC 99 VALUE ZERO.
           05 L    PIC 99 VALUE ZERO.
           05 CDAT PIC 9(5) VALUE ZERO.
           05 DESMV.
              10 FILLER PIC X(17) VALUE 'REGISTRAZIONI IN'.
              10 DAVE PIC X.
              10 AVER PIC X(4).
           05 ZERPK PIC 9(5) COMP-3 VALUE ZERO.
           05 CIVASO PIC 9(7).
      **** rel 4.0
      *    05 FTSIMP PIC S9(11) OCCURS 6.
      *    05 FTSIVA PIC S9(11) OCCURS 6.
           05 FTSIMP PIC S9(11)V99 OCCURS 6.
           05 FTSIVA PIC S9(11)V99 OCCURS 6.
      ************
           05 FTCIVA PIC 999    OCCURS 6.
           05 FLGIS  PIC 9 VALUE ZERO.
           05 AFLGIS PIC 9 VALUE ZERO.
           05 CIVAVE PIC 9(7).
           05 CIVACQ PIC 9(7).
           05 CATCON PIC 9 VALUE ZERO.
           05 WCRPCL PIC 9(7).
           05 WCRPFR PIC 9(7).
           05 CRPCL  PIC 9(7) OCCURS 9.
           05 CRPFR  PIC 9(7) OCCURS 9.
           05 MCLI   PIC 99.
           05 MFOR   PIC 99.
           05 WNRG   PIC 9(5) COMP-3.
           05 CLV1   PIC S9(13).
      **** rel 4.0
      *    05 CLV2   PIC S9(13).
      *    05 CLIV   PIC S9(13).
      *    05 CLNI   PIC S9(13).
           05 CLIV   PIC S9(13)V99.
           05 CLNI   PIC S9(13)V99.
      ************
           05 CLV5   PIC S9(5).
           05 NMOV   PIC 9(5) VALUE ZERO.
           05 NREG   PIC 9(5) VALUE ZERO.
           05 SEGNO  PIC 9 VALUE ZERO.
           05 M1     PIC S9 VALUE -1.
           05 SWEN   PIC 9 VALUE ZERO.
           05 ATTR   PIC 9.
           05 TIPOP  PIC 99.
           05 NOPNI  PIC S9(5).
      **** rel 4.0
      *    05 IMPON  PIC S9(11).
      *    05 NIMPO  PIC S9(11).
      *    05 ESENT  PIC S9(11).
      *    05 IMIVA  PIC S9(11).
      *    05 TACCR  PIC S9(11).
           05 IMPON  PIC S9(11)V99.
           05 NIMPO  PIC S9(11)V99.
           05 ESENT  PIC S9(11)V99.
           05 IMIVA  PIC S9(11)V99.
           05 TACCR  PIC S9(11)V99.
      ************
           05 CAUS   PIC 999.
           05 SWER   PIC 9 VALUE ZERO.
           05 PMAX   PIC 99 VALUE ZERO.
           05 WFLGEC PIC 9 VALUE ZERO.
           05 PRSCA  PIC 9(7) VALUE ZERO.
           05 DAV    PIC X VALUE SPACE.
      **** rel 3.0a
      *    05 COMREKAZI PIC X(200) VALUE SPACE.
      *************
      **** rel 4.0
           05 COMEURO  PIC 9(3) VALUE ZERO.
      ************
      **** rel 6.2
           05 VRI     PIC 9(3)   VALUE ZERO.
           05 RED     PIC 9(3)   VALUE ZERO.
           05 PAD     PIC 9(3)   VALUE ZERO.
           05 FLAUT   PIC 9      VALUE ZERO.
      ************
      **** rel 7.2
           05 TOTIVA  PIC S9(11)V9(6).
           05 K3      PIC 9(6).
           05 FLGSOT  PIC 9.
           05 GISO    PIC 999.
      ************
       01  AREEK.
      **** rel 4.0
      *    05 CLAV  PIC S9(15).
      *    05 CLAV1 PIC S9(15).
      *    05 CLAV2 PIC S9(15).
      *    05 CLAV3 PIC S9(15).
           05 CLAV  PIC S9(15)V99.
           05 CLAV1 PIC S9(15)V99.
           05 CLAV2 PIC S9(15)V99.
           05 CLAV3 PIC S9(15)V99.
      ************
           05 CVAV  PIC S9(13)V99.
       01  STAT116  PIC 99 VALUE ZERO.
      **** rel 6.2
       01  PARLINK-114.
           05 DTCON-114  PIC 9(5) COMP-3.
           05 FL-114     PIC 9.
           05 CDAZ-114   PIC 9(3).
           05 NREG-114   PIC 9(5).
      *
       01  RT-PAR.
           05  RT-CDAZ     PIC 999.
           05  RT-DAZI     PIC X(36).
           05  RT-WPART    PIC 9(7).
           05  RT-WDSAUT   PIC X(36).
           05  RT-WCAUSA   PIC 9(3).
           05  RT-WTIPRG   PIC 9.
           05  RT-WSEGNO   PIC 9.
           05  RT-WTIPOP   PIC 99.
           05  RT-WDTDOC   PIC 9(5) COMP-3.
           05  RT-WDOCUM   PIC 9(5).
           05  RT-WNPRGI   PIC 9(5).
           05  RT-WIMPOR   PIC S9(11)V99.
           05  RT-WIMPON   PIC S9(11)V99.
           05  RT-WNIMPO   PIC S9(11)V99.
           05  RT-WIMPIV   PIC S9(11)V99.
           05  RT-WNREG    PIC 9(5).
           05  RT-WDESAG   PIC X(30).
      ************
       LINKAGE SECTION.
       01  SWOPN  PIC X.
       01  DTCON  PIC 9(5) COMP-3.
       01  PARM   PIC XXX.
       01  ID-AZI PIC X(15).
       01  ID-CON PIC X(15).
       01  ID-MOV PIC X(15).
      **** rel 5.0
       01  MNREG  PIC 9(5).
      ************
           COPY 'wrklav'.
       PROCEDURE DIVISION USING SWOPN DTCON WRKLAV WRKSCA
      **** rel 5.0
      *                         PARM ID-AZI ID-CON ID-MOV.
                                PARM ID-AZI ID-CON ID-MOV MNREG.
      ************
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclcon'.
           COPY 'dclclf'.
           COPY 'dclmov'.
           COPY 'dclmsz'.
           COPY 'dclpar'.
           COPY 'dclfcd'.
           COPY 'dclsca'.
           COPY 'dclfts'.
           COPY 'dcltab'.
      **** rel 6.2
           COPY 'dclaut'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strsub'.
      **** rel 4.0
            CALL 'rveur' USING COMEURO.
      ************
           IF PARM = SPACE MOVE 'tabell' TO ID-TAB
                           MOVE 'anaclf' TO ID-CLF
                           MOVE 'forncd' TO ID-FCD
                           MOVE 'movsez' TO ID-MSZ.

           IF PARM = 'OLD' MOVE 'tabold' TO ID-TAB
                           MOVE 'anacfx' TO ID-CLF
                           MOVE 'forncx' TO ID-FCD
                           MOVE 'movsol' TO ID-MSZ.
      **** rel 6.2
           MOVE ZERO TO FLAUT.
           OPEN INPUT ANAAUT.
           IF SF-AUT NOT = ZERO
                     MOVE ZERO TO VRI RED PAD 
                     MOVE 2 TO FLAUT GO TO AUT-00.
           MOVE ZERO TO KAT-AZI.
           MOVE 1 TO KAT-COD.
           READ ANAAUT INVALID MOVE ZERO TO AUT-VRI AUT-RED AUT-PAD.
           MOVE AUT-VRI TO VRI.
           MOVE AUT-RED TO RED.
           MOVE AUT-PAD TO PAD.
           CLOSE ANAAUT.
       AUT-00.
           MOVE ZERO TO RT-WIMPON RT-WIMPIV.
      ************
           OPEN I-O TABELL.
           MOVE ZERO TO REKMOV.
           OPEN I-O ANAAZI.
       RLET.
           MOVE CDAZ TO KAZ-COD.
           READ ANAAZI INTO REKAZI KEPT LOCK INVALID PERFORM INVK-AZI
                                                     GO TO ERRIO.
           IF SF-AZI NOT = ZERO PERFORM REC-LOCK
                                GO TO RLET.
      **** rel 6.2
           MOVE CDAZ    TO RT-CDAZ.
           MOVE AZRGSOC TO RT-DAZI.
      ************
           IF AZI-FLCON = ZERO GO TO LP10.
      *
           MOVE 'Registrazione precedente errata' TO MESS.
           GO TO ERRIO.
      *
       LP10.
           MOVE 20 TO KTB-TIP.
           MOVE 1  TO KTB-COD
           READ TABELL INTO RKTB20 INVALID PERFORM INVK-TAB
                                           CLOSE TABELL
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO RKTB20.
      **** rel 7.2
           MOVE 14 TO KTB-TIP.
           MOVE  5 TO KTB-COD.
           READ TABELL INTO REKTAB INVALID GO TO FINE.
           MOVE T14-GISO TO GISO.
      ************
           MOVE 14 TO KTB-TIP.
           MOVE  7 TO KTB-COD.
           READ TABELL INTO RKTB14G INVALID PERFORM INVK-TAB
                                            CLOSE TABELL
                                            GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO RKTB14G.
           MOVE 1 TO KTB-COD KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           CLOSE TABELL
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           CLOSE TABELL.
           MOVE 1 TO AZI-FLCON.
           MOVE AZI-FLGIS TO AFLGIS.
           REWRITE RF-AZI FROM REKAZI.
           IF AZI-MOVPR > 99900 MOVE ZERO TO AZI-MOVPR.
           OPEN I-O ANACLF ANACON.
           OPEN I-O MOVIME.
           OPEN I-O PARTIT FORNCD.
           MOVE T01-CIVAQ TO CIVACQ.
           MOVE T01-CIVAV TO CIVAVE.
           MOVE T01-CIVSO TO CIVASO.

           MOVE T01-CRPCL TO CRPCL(1).
           MOVE T01-CRPC1 TO CRPCL(2).
           MOVE T01-CRPC2 TO CRPCL(3).
           MOVE T14-CRPC3 TO CRPCL(4).
           MOVE T14-CRPC4 TO CRPCL(5).
           MOVE T14-CRPC5 TO CRPCL(6).
           MOVE T14-CRPC6 TO CRPCL(7).
           MOVE T14-CRPC7 TO CRPCL(8).
           MOVE T14-CRPC8 TO CRPCL(9).

           MOVE T01-CRPFR TO CRPFR(1).
           MOVE T01-CRPF1 TO CRPFR(2).
           MOVE T01-CRPF2 TO CRPFR(3).
           MOVE T14-CRPF3 TO CRPFR(4).
           MOVE T14-CRPF4 TO CRPFR(5).
           MOVE T14-CRPF5 TO CRPFR(6).
           MOVE T14-CRPF6 TO CRPFR(7).
           MOVE T14-CRPF7 TO CRPFR(8).
           MOVE T14-CRPF8 TO CRPFR(9).

           MOVE T01-MCLI TO MCLI.
           MOVE T01-MFOR TO MFOR.
           MOVE WDATA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AA4 TO ANNO.
           MOVE ZERO TO RISP.
           MOVE ZERO TO NREG.
           MOVE AZI-MOVPR TO NMOV.
      **** rel NT 0.0
      * visualizzava progressivo mov. in generazione
      *    DISPLAY SCRAGG.
      ***************
           MOVE ZERO TO I.
           MOVE 6 TO KMX.
       LOPW.
           IF TREG = 4 OR 5 GO TO FATT.
           ADD 1 TO I.
           IF I > 8 GO TO ENDW.
           IF WCOR (I) = ZERO GO TO ENDW.
           IF TREG = 1 PERFORM RCOGE THRU EX-RCOGE.
           IF TREG > 1 PERFORM RSEZ THRU EX-RSEZ
                       IF SWER = 1 GO TO ENDW.
           GO TO LOPW.
       FATT.
           MOVE 54 TO KMX.
           IF TREG = 4 MOVE 2 TO TREG
           ELSE        MOVE 3 TO TREG.
           PERFORM RSEZ THRU EX-RSEZ.
       ENDW.
           MOVE NMOV TO AZI-MOVPR.
           MOVE ZERO TO AZI-FLCON.
      **** rel 3.0a
           REWRITE RF-AZI FROM REKAZI INVALID PERFORM INVK-AZI
                                              GO TO ERRIO.
           UNLOCK ANAAZI.
           CLOSE ANAAZI.
           IF WFLAG = ZERO GO TO FINE.
      *    IF WFLAG = ZERO GO TO ENDW1.
      *************
           OPEN INPUT TABELL.
           IF TREG > 1
              MOVE 2 TO KTB-TIP
              MOVE WCAUS TO KTB-COD
              READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                              CLOSE TABELL
                                              GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           CLOSE TABELL.
      **** rel 3.0a
      *    IF PARM NOT = 'OLD' GO TO AZI10.
      *    MOVE REKAZI TO COMREKAZI.
      *    CLOSE ANAAZI.
      *************
           MOVE 'anaazi' TO ID-AZI.
           OPEN I-O ANAAZI.
       AZI1.
           READ ANAAZI INTO REKAZI KEPT LOCK INVALID PERFORM INVK-AZI
                                                     CLOSE ANAAZI
                                                     GO TO ERRIO.
           IF SF-AZI NOT = ZERO PERFORM REC-LOCK
                                GO TO AZI1.
           MOVE AZI-PRSCA TO PRSCA.
           MOVE ZERO TO L.
      **** rel 3.0a
      *    GO TO SCA05.
      *AZI10.
      *    MOVE AZI-PRSCA TO PRSCA.
      *    MOVE ZERO TO L.
      *SCA05.
      *************
           OPEN I-O ANASCA.
      **** rel 6.2
           OPEN I-O NOTSCA.
      ************
       SCA10.
           ADD 1 TO L.
           IF L > 12 GO TO SCA90.
           IF WTPAG (L) = ZERO GO TO SCA90.
      **** rel 7.1
           MOVE ZERO TO RF-SCA.
      ************
           MOVE KAZ-COD TO KSC-AZI.
           MOVE WFLAG   TO KSC-TIPO.
           MOVE WDTSCA (L) TO KSC-DTSCA KS2-DTSCA KS3-DTSCA.
      **** rel 5.0
           MOVE WDTSCA (L) TO SCA-DTSCAO.
      ************
           ADD 1 TO PRSCA.
           MOVE PRSCA  TO KSC-PRG.
           MOVE WPART  TO KS2-CODCF.
           MOVE WNDOC  TO SCA-NDOC.
           MOVE WDATA  TO SCA-DTDOC.
           MOVE WTDOC  TO SCA-IMPOR.
           MOVE WIMVAL TO SCA-VALDOC.
           MOVE WCAMGG TO SCA-CAMDOC.
           MOVE WVALUT TO SCA-CDVAL.
           MOVE ZERO   TO SCA-CAMPAG.
           IF TREG = 2 GO TO SCA20.
           IF T02-D-A = 'D' MULTIPLY -1 BY SCA-IMPOR SCA-VALDOC.
           IF T02-D-A = 'A' AND SEGNO = 1
                            MULTIPLY -1 BY SCA-IMPOR SCA-VALDOC.
           GO TO SCA30.
       SCA20.
           IF T02-D-A = 'A' MULTIPLY -1 BY SCA-IMPOR SCA-VALDOC.
           IF T02-D-A = 'D' AND SEGNO = 1
                            MULTIPLY -1 BY SCA-IMPOR SCA-VALDOC.
       SCA30.
           MOVE WCDPAG       TO SCA-CDPAG.
           MOVE WTPAG (L)    TO SCA-TPAG.
           MOVE L            TO SCA-NRATA.
           MOVE WNRATE       TO SCA-RATE.
      **** rel 6.1
      **** rel 6.2
      *    IF L > WNRATE 
           IF L > WNRATE AND WNRATE NOT = ZERO
      ************
              MOVE ZERO TO SCA-CDPAG
              COMPUTE SCA-NRATA = L - WNRATE.
      ************
           MOVE WIMRATA (L)  TO SCA-IMRATA.
           MOVE WVALRATA (L) TO SCA-VALRATA.
           MOVE ZERO         TO SCA-VALPAG.
           MOVE ZERO         TO SCA-PAGATO.
           MOVE SPACE        TO SCA-STATO.
           IF TREG > 1 AND T02-FLGSC = 3
              MOVE 'R' TO SCA-STATO.
           MOVE WCATT  TO SCA-CATT.
           MOVE WNPRGI TO SCA-NPROT.
           MOVE ZERO   TO SCA-SOLL.
      **** rel 5.0
      *    MOVE ZERO   TO SCA-FILL.
           MOVE SPACE  TO SCA-CODCFL.
      ************
           MOVE SPACE  TO SCA-NOTE.
      **** rel 6.2
           MOVE WNOTE(L) TO SCA-NOTE.
      ************
           MOVE WCDBAN TO KS3-BAN.
      **** rel 5.0
           MOVE NREG   TO SCA-NREG.
      ************
      **** rel 7.1
           IF SCA-TPAG = 9
                MOVE 'P' TO SCA-STATO
                MOVE SCA-IMRATA TO SCA-PAGATO. 
      ************
           WRITE RF-SCA INVALID PERFORM INVK-SCA
                                CLOSE ANASCA
                                GO TO ERRIO.
      **** rel 6.2
           MOVE ZERO  TO RF-NSC.
           MOVE KSC-AZI   TO KNSC-AZI.
           MOVE KSC-TIPO  TO KNSC-TIPO.
           MOVE KSC-DTSCA TO KNSC-DTSCA.
           MOVE KSC-PRG   TO KNSC-PRG.
           MOVE 1         TO KNSC-PRGN.
           MOVE WNOTEA(L) TO NSC-DESCR.
           WRITE RF-NSC INVALID PERFORM INVK-NSC
                                CLOSE NOTSCA
                                GO TO ERRIO.
      ************
           GO TO SCA10.
       SCA90.
           CLOSE ANASCA.
      **** rel 6.2
           CLOSE NOTSCA.
      ************
           MOVE PRSCA TO AZI-PRSCA.
      **** rel 3.0a
      *    IF PARM NOT = 'OLD' GO TO ENDW1.
      *************
           REWRITE RF-AZI FROM REKAZI INVALID PERFORM INVK-AZI
                                              CLOSE ANAAZI
                                              GO TO ERRIO.
           UNLOCK ANAAZI.
           CLOSE ANAAZI.
      **** rel 3.0a
           IF PARM = 'OLD' MOVE 'anazol' TO ID-AZI.
      *    MOVE 'anazol' TO ID-AZI.
      *    OPEN I-O ANAAZI.
      *    MOVE COMREKAZI TO REKAZI.
      *ENDW1.
      *    REWRITE RF-AZI FROM REKAZI INVALID PERFORM INVK-AZI
      *                                       GO TO ERRIO.
      *    UNLOCK ANAAZI.
      *************
           GO TO FINE.
      * - - - - - *
       RMOV.
           MOVE AZI-COD TO MOV-AZI.
           MOVE DTCON   TO MOV-DAT.
           MOVE NMOV    TO MOV-NUM.
           MOVE DAVE    TO MOV-D-A.
           MOVE TREG    TO MOV-TREG.
           MOVE CLAV    TO MOV-IMPO.
           MOVE WNDOC   TO MOV-NDOC.
           MOVE WDATA   TO MOV-DTDOC.
           MOVE WDTSCD  TO MOV-DTSCD.
           MOVE WNPRGI  TO MOV-NPRGI.
           MOVE WPART   TO MOV-PART.
           IF MOV-FLAG = ZERO
              MOVE WCATT TO MOV-CATT
           ELSE
              MOVE '0' TO MOV-CATT.
           IF NREG = ZERO MOVE NMOV TO NREG.
           MOVE NREG TO MOV-NREG.
      **** rel 5.0
           MOVE NREG TO MNREG.
      ************
       EX-RMOV.
           EXIT.
       RNXP.
           ADD 1 TO NMOV.
      **** rel NT 0.0
      *    DISPLAY SUPMZZ.
      ***************
           PERFORM RMOV THRU EX-RMOV.
      **** rel 4.0
           MOVE ZERO TO MOV-FLGE2.
      ************
           WRITE RF-MOV FROM REKMOV INVALID PERFORM INVK-MOV
                                            GO TO ERRIO.
       EX-RNXP.
           EXIT.
      * - - - - - *
       RCHGG.
           MOVE AZI-COD TO MOV-AZI.
           MOVE DTCON   TO MOV-DAT.
           MOVE 'ARE'   TO AVER.
           IF DAVE = 'A' ADD 1 TO CLV1 MOVE 'VERE' TO AVER.
           MOVE CLV1 TO MOV-NUM.
           MOVE MOV-KEYID TO KEYMV.
           READ MOVIME INVALID GO TO WRMRP.
           MOVE RF-MOV TO REKMOV.
           GO TO RWMRP.
       WRMRP.
           IF WCAUS = T20-CDSOC OR T20-CASOC OR
                      T20-CDCLC OR T20-CACLC OR
                      T20-CDFOC OR T20-CAFOC
                      IF DAVE = 'A'
                         MOVE T20-CASOC TO MOV-CAUS
                         GO TO WRMRP1
                      ELSE
                         MOVE T20-CDSOC TO MOV-CAUS
                         GO TO WRMRP1.
           IF WCAUS = T20-CDSOA OR T20-CASOA OR
                      T20-CDCLA OR T20-CACLA OR
                      T20-CDFOA OR T20-CAFOA
                      IF DAVE = 'A'
                         MOVE T20-CASOA TO MOV-CAUS
                         GO TO WRMRP1
                      ELSE
                         MOVE T20-CDSOA TO MOV-CAUS
                         GO TO WRMRP1.
           MOVE 999 TO MOV-CAUS.
       WRMRP1.
           MOVE DAVE  TO MOV-D-A.
           MOVE 1     TO MOV-TREG.
           MOVE DTCON TO MOV-DTDOC.
           MOVE ZERO TO MOV-NDOC MOV-IMPO MOV-DTSCD MOV-NPRGI MOV-PART.
           MOVE 1 TO MOV-FLAG MOVE DESMV TO MOV-DSAGG.
           MOVE SPACE TO MOV-CCOST.
           MOVE '0' TO MOV-CATT.
      **** rel 4.0
           MOVE ZERO TO MOV-FLGE2.
      ************
           WRITE RF-MOV FROM REKMOV INVALID PERFORM INVK-MOV
                                            GO TO ERRIO.
       RWMRP.
           ADD CLAV TO MOV-IMPO.
           REWRITE RF-MOV FROM REKMOV INVALID PERFORM INVK-MOV
                                              GO TO ERRIO.
       EX-RCHGG.
           EXIT.
      * - - - - - *
       RCONW.
           MOVE AZI-COD TO KPC-AZI.
           READ ANACON INTO REKCON INVALID KEY PERFORM INVK-CON
                                               GO TO ERRIO.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
           IF DAVE = 'D'
              ADD CLAV TO CON-SP-D
              ADD CLAV TO CON-SE-D
              GO TO RWCON.
           ADD CLAV TO CON-SP-A.
           ADD CLAV TO CON-SE-A.
           GO TO RWCON.
       RWCON.
           REWRITE RF-CON FROM REKCON INVALID KEY PERFORM INVK-CON
                                                  GO TO ERRIO.
       EX-RCONW.
           EXIT.
      * - - - - - *
       RCOGE.
           MOVE ZERO     TO WPART.
           MOVE WCOR (I) TO WCORP.
           MOVE ZERO TO K.
       LCG1.
           ADD 1 TO K.
           IF K > 6 GO TO EX-RCOGE.
           IF WCOD (K) = ZERO GO TO EX-RCOGE.
           MOVE WDES (K) TO WDESC.
           MOVE 2 TO KTB-TIP.
           MOVE WCOD (K) TO KTB-COD.
           OPEN INPUT TABELL.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           CLOSE TABELL
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           CLOSE TABELL.
           MOVE T02-D-A   TO DAVE.
           MOVE T02-SEGNO TO SEGNO.
           MOVE WCON (K)  TO MOV-CON.
           MOVE WCOD (K)  TO MOV-CAUS CAUS.
           MOVE WIMP (K)  TO CLAV.
           MOVE WFEV (K)  TO MOV-FEV.
           IF SEGNO > ZERO COMPUTE CLAV = CLAV * M1.
           MOVE 1 TO MOV-FLAG.
           MOVE WDESC TO MOV-DSAGG.
           IF WD-A (K) NOT = ZERO MOVE WD-A (K) TO DAVE.
           MOVE WCCOST(K) TO MOV-CCOST.
           PERFORM RNXP THRU EX-RNXP.
           MOVE WCON (K) TO KPC-COD.
           PERFORM RCONW THRU EX-RCONW.
           GO TO LCG1.
       EX-RCOGE.
           EXIT.
      * - - - - - *
       RSEZ.
           MOVE ZERO TO L.
       RSE-00.
           ADD 1 TO L.
           MOVE ZERO TO FTSIMP(L) FTSIVA(L) FTCIVA(L).
           IF L < 6 GO TO RSE-00.
           MOVE ZERO TO SWER.
           MOVE WNPRGI TO WNRG.
           OPEN I-O TABELL.
           MOVE 2 TO KTB-TIP.
           MOVE WCAUS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           CLOSE TABELL
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T02-FLGIS TO FLGIS.
           IF FLGIS NOT = 1 GO TO RSE-10.
           MOVE 23   TO KTB-TIP.
           MOVE CDAZ TO KTB-COD.
           READ TABELL INTO REKT23 INVALID PERFORM INVK-TAB
                                           CLOSE TABELL
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT23.
           IF T23-PRSOS < WNRG MOVE WNRG TO T23-PRSOS.
           REWRITE RF-TAB FROM REKT23 INVALID PERFORM INVK-TAB
                                              CLOSE TABELL
                                              GO TO ERRIO.
           IF AFLGIS = 2 MOVE WNDOC TO WNRG
                         GO TO RSE-10.
           GO TO LS0-1.
       RSE-10.
           IF WCATT = '0' GO TO LS0-0.
           MOVE 35    TO T35-TIP.
           MOVE CDAZ  TO T35-CDAZ.
           MOVE WCATT TO T35-CATT.
           MOVE T35-KEYID TO KEYTB.
           READ TABELL INTO REKT35 INVALID KEY PERFORM INVK-TAB
                                               CLOSE TABELL
                                               GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT35.
           IF TREG = 2 AND T35-RVNRG < WNRG MOVE WNRG TO T35-RVNRG.
           IF TREG = 3 AND T35-RANRG < WNRG MOVE WNRG TO T35-RANRG.
           REWRITE RF-TAB FROM REKT35 INVALID KEY PERFORM INVK-TAB
                                                  GO TO ERRIO.
           IF AFLGIS = 2 MOVE WNPRGI TO WNRG.
           GO TO LS0-1.
       LS0-0.
           IF TREG = 2 AND AZI-RVNRG < WNRG MOVE WNRG TO AZI-RVNRG.
           IF TREG = 3 AND AZI-RANRG < WNRG MOVE WNRG TO AZI-RANRG.
           IF AFLGIS = 2 MOVE WNPRGI TO WNRG.
       LS0-1.
           MOVE 2     TO KTB-TIP.
           MOVE WCAUS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           CLOSE TABELL
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           CLOSE TABELL.
           MOVE T02-FLGEC TO WFLGEC.
           MOVE T02-D-A   TO DAVE.
           MOVE T02-ATTRN TO ATTR.
           MOVE T02-SEGNO TO SEGNO.
           MOVE T02-TIPOP TO TIPOP.
           MOVE WPART     TO MOV-CON.
           MOVE WPART     TO KCF-COD.
           MOVE KCF-COD   TO CLF-COD.
           MOVE WCAUS     TO MOV-CAUS.
           MOVE WTDOC     TO CLAV.
           IF SEGNO > ZERO COMPUTE CLAV = CLAV * M1.
           MOVE WIMVAL TO CVAV.
           IF SEGNO > ZERO COMPUTE CVAV = CVAV * M1.
           MOVE KAZ-COD TO KPA-AZI PAR-AZI KCF-AZI.
           MOVE TREG TO TIPO.
           IF WCAUS = T20-CDSOC OR T20-CASOC OR
                      T20-CDCLC OR T20-CACLC OR
                      T20-CDFOC OR T20-CAFOC OR
                      T20-CDSOA OR T20-CASOA OR
                      T20-CDCLA OR T20-CACLA OR
                      T20-CDFOA OR T20-CAFOA GO TO LS03-1.
           IF WFLGEC = 1 GO TO LS03-1.
           MOVE CLF-CD TO CLFO.
           MOVE WNDOC  TO PART.
           MOVE 1      TO NUME.
           MOVE CAN    TO KPA-CAN.
           READ PARTIT INTO REKPAR INVALID
                MOVE ZERO TO PAR-DESCR
                MOVE ZERO TO PAR-VSALD PAR-VALUT PAR-CADOC
                MOVE ZERO TO PAR-SALDO PAR-NUMPA
                GO TO LS0-A.
           IF SF-PAR = '9D' OR '9A' OR '35' MOVE RF-PAR TO REKPAR.
       LS0-A.
           MOVE 98 TO PMAX.
           IF WDESC    NOT = SPACE SUBTRACT 1 FROM PMAX.
           IF WDSC (1) NOT = ZERO  SUBTRACT 1 FROM PMAX.
           IF PAR-NUMPA < PMAX GO TO LS00.
           IF PAR-NUMPA = PMAX
              MOVE 'Ultima reg.partita' TO MESS
              MOVE 8 TO ERRIO-ST
              GO TO LS00.
           MOVE ZERO TO FLGIS RISP.
           MOVE 'Partita completa: movimento non registrato!' TO MESS.
           MOVE 8 TO ERRIO-ST.
           MOVE 9 TO RISP.
           MOVE 1 TO SWER.
           GO TO EX-RSEZ.
       LS00.
           MOVE CAN TO PAR-CAN.
           MOVE 1   TO PAR-TIP.
      **** rel 7.2
           PERFORM CALCOLA-IVA THRU EX-CALCOLA-IVA.
      ************
           IF T02-D-A = 'D'
              ADD CLAV TO PAR-SALDO
           ELSE
              SUBTRACT CLAV FROM PAR-SALDO.
           IF T02-D-A = 'D'
              ADD CVAV TO PAR-VSALD
           ELSE
              SUBTRACT CVAV FROM PAR-VSALD.
           IF SF-PAR = ZERO GO TO LS01.
           MOVE WVALUT TO PAR-VALUT.
           MOVE WCAMGG TO PAR-CADOC.
           WRITE RF-PAR FROM REKPAR INVALID KEY PERFORM INVK-PAR
                                                GO TO ERRIO.
           GO TO LS02.
       LS01.
           REWRITE RF-PAR FROM REKPAR INVALID KEY PERFORM INVK-PAR
                                                  GO TO ERRIO.
           MOVE PAR-NUMPA TO NUME.
       LS02.
           ADD 1 TO NUME.
           MOVE CAN TO KPA-CAN.
           READ PARTIT INVALID KEY GO TO LS03.
           IF NUME = 99 MOVE 'Overflow partita' TO MESS
                        GO TO ERRIO.
           GO TO LS02.
       LS03.
           MOVE CAN       TO PAR-CAN.
           MOVE 2         TO PAR-TIP.
           MOVE DTCON     TO PAR-DTCON.
           MOVE WCAUS     TO PAR-CAUS.
           MOVE T02-TIPOP TO PAR-TIPOP.
           MOVE WDTSCD    TO PAR-DTSCA.
           MOVE WNDOC     TO PAR-NDOC.
           MOVE WDATA     TO PAR-DTDOC.
           MOVE CLAV      TO PAR-IMPOR.
           MOVE CVAV      TO PAR-VIMPO.
           MOVE WCAMGG    TO PAR-CAMGG.
           MOVE DAVE      TO PAR-D-A.
           MOVE WNPRGI    TO PAR-NPIVA.
           WRITE RF-PAR FROM REKPAR INVALID KEY PERFORM INVK-PAR
                                                GO TO ERRIO.
       LS03-1.
           MOVE WPART TO MOV-CON.
           MOVE WCAUS TO MOV-CAUS.
           MOVE WCAUS TO CAUS.
           ADD 1 TO NMOV.
      **** rel NT 0.0
      *    DISPLAY SUPMZZ.
      ***************
           PERFORM RMOV THRU EX-RMOV.
           MOVE 1        TO MOV-FLAG.
           MOVE WDESC    TO MOV-DSAGG.
      **** rel 4.1a-1
      *    MOVE WCON (1) TO MOV-PART.
           IF T02-TIPRG = 3
              PERFORM CERCA-CP THRU EX-CERCA-CP
              MOVE WCON (K) TO MOV-PART
           ELSE
              MOVE WCON (1) TO MOV-PART.
      **************
           MOVE SPACE    TO MOV-CCOST.
      **** rel 4.0
      *    IF WVALUT > 1
           IF NOT (WVALUT = ZERO OR COMEURO)
      ************
              MOVE WVALUT TO MOV-VALUT
              MOVE WCAMGG TO MOV-CAMGG
              MOVE CVAV   TO MOV-IMVAL
           ELSE
              MOVE ZERO TO MOV-VALUT MOV-CAMGG MOV-IMVAL.
           OPEN I-O MOVSEZ.
      **** rel 4.0
           MOVE ZERO TO MOV-FLGE2.
      ************
           WRITE RF-MSZ FROM REKMOV INVALID PERFORM INVK-MSZ
                                            CLOSE MOVSEZ
                                            GO TO ERRIO.
           CLOSE MOVSEZ.
      * dopo aver scritto il movimento di sezionale azzero i
      * campi relativi alla valuta estera per i mov. contabili.
           MOVE ZERO TO MOV-VALUT MOV-CAMGG MOV-IMVAL.
       LKCLI.
           READ ANACLF INTO REKCLF KEPT LOCK INVALID PERFORM INVK-CLF
                                                     GO TO ERRIO.
           IF SF-CLF NOT = ZERO PERFORM REC-LOCK
                                GO TO LKCLI.
      **** rel 6.2
           IF FLAUT = 2 OR TIPO = 2 OR CLF-FLAUT = ZERO
                                        GO TO RSE-70-00.
           IF TIPOP = 0 OR 3 OR TIPOP > 8 GO TO RSE-70-00.
           MOVE 1 TO FLAUT.
           MOVE ZERO  TO PARLINK-114.
           MOVE DTCON TO DTCON-114.
           IF PARM = 'OLD' MOVE 1 TO FL-114.
           MOVE AZI-COD TO CDAZ-114.
           MOVE NREG    TO NREG-114.
           MOVE WPART   TO RT-WPART.
           MOVE CLF-RGS TO RT-WDSAUT.
           MOVE WCAUS   TO RT-WCAUSA.
           MOVE TIPOP   TO RT-WTIPOP.
           MOVE TREG    TO RT-WTIPRG.
           MOVE SEGNO   TO RT-WSEGNO.
           MOVE WDATA   TO RT-WDTDOC.
           MOVE WNDOC   TO RT-WDOCUM.
           MOVE CLAV    TO RT-WIMPOR.
           MOVE SPACE   TO RT-WDESAG.
           MOVE NREG-114 TO RT-WNREG.
       RSE-70-00.
      ************
           MOVE CLF-CATCON TO CATCON.
           IF CATCON = ZERO MOVE 1 TO CATCON.
           MOVE CRPCL (CATCON) TO WCRPCL.
           MOVE CRPFR (CATCON) TO WCRPFR.
           IF WCAUS = T20-CDSOC OR T20-CASOC OR
                      T20-CDCLC OR T20-CACLC OR
                      T20-CDFOC OR T20-CAFOC OR
                      T20-CDSOA OR T20-CASOA OR
                      T20-CDCLA OR T20-CACLA OR
                      T20-CDFOA OR T20-CAFOA GO TO LKCLI1.
           IF TIPO = 2 MOVE WCRPCL TO MOV-CON
                       MOVE 99991  TO CLV1
                       PERFORM RCHGG THRU EX-RCHGG.
           IF TIPO = 3 MOVE WCRPFR TO MOV-CON
                       MOVE 99993 TO CLV1
                       PERFORM RCHGG THRU EX-RCHGG.
           GO TO LKCLI2.
       LKCLI1.
           IF TIPO = 2 MOVE WCRPCL TO MOV-CON
                       MOVE 99995 TO CLV1
                       PERFORM RCHGG THRU EX-RCHGG.
           IF TIPO = 3 MOVE WCRPFR TO MOV-CON
                       MOVE 99997 TO CLV1
                       PERFORM RCHGG THRU EX-RCHGG.
       LKCLI2.
           MOVE MOV-CON TO KPC-COD.
           PERFORM RCONW THRU EX-RCONW.
           IF WCAUS = T20-CDSOC OR T20-CASOC OR
                      T20-CDCLC OR T20-CACLC OR
                      T20-CDFOC OR T20-CAFOC OR
                      T20-CDSOA OR T20-CASOA OR
                      T20-CDCLA OR T20-CACLA OR
                      T20-CDFOA OR T20-CAFOA GO TO LS06-1.
           IF WFLGEC = 1 GO TO LS06-1.
           IF WDESC = SPACE GO TO LS04.
           ADD 1 TO NUME.
           MOVE CAN   TO PAR-CAN.
           MOVE 3     TO PAR-TIP.
           MOVE WDESC TO PAR-DESCR.
           WRITE RF-PAR FROM REKPAR INVALID KEY PERFORM INVK-PAR
                                                GO TO ERRIO.
       LS04.
           MOVE 1 TO K.
           IF WDSC (K) = ZERPK GO TO LS06.
       LS05.
           MOVE WDSC (K) TO PAR-DT (K).
           MOVE WISC (K) TO PAR-LT (K).
           MOVE WVSC (K) TO PAR-VT (K).
           ADD 1 TO K.
           IF K < 7 GO TO LS05.
           ADD 1 TO NUME.
           MOVE CAN TO PAR-CAN.
           MOVE 4 TO PAR-TIP.
           WRITE RF-PAR FROM REKPAR INVALID KEY PERFORM INVK-PAR
                                                GO TO ERRIO.
       LS06.
           MOVE NUME TO CLV5.
           MOVE 1 TO NUME.
           MOVE CAN TO KPA-CAN.
           READ PARTIT INTO REKPAR INVALID KEY PERFORM INVK-PAR
                                               GO TO ERRIO.
           IF SF-PAR = '9D' OR '9A' OR '35' MOVE RF-PAR TO REKPAR.
           MOVE CLV5 TO PAR-NUMPA.
           REWRITE RF-PAR FROM REKPAR INVALID KEY PERFORM INVK-PAR
                                                  GO TO ERRIO.
       LS06-1.
           IF DAVE = 'D'
              ADD CLAV TO CLF-SP-D
              ADD CLAV TO CLF-SE-D GO TO LS07.
           ADD CLAV TO CLF-SP-A.
           ADD CLAV TO CLF-SE-A.
           GO TO LS07.
       LS07.
           MOVE WDATA TO CDAT.
      **** rel 4.0-2
      *    ADD 400    TO CDAT.
      ************
           IF WCAUS = T20-CDSOC OR T20-CASOC OR
                      T20-CDCLC OR T20-CACLC OR
                      T20-CDFOC OR T20-CAFOC OR
                      T20-CDSOA OR T20-CASOA OR
                      T20-CDCLA OR T20-CACLA OR
                      T20-CDFOA OR T20-CAFOA GO TO LS13.
           IF TREG NOT = 3 GO TO LS10.
           IF NOT ( T02-TIPOP = 1 OR 8 ) GO TO LS10.
      **** rel 4.0-2
      *    IF CDAT > DTCON GO TO LS10.
           MOVE DTCON TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE 01 TO MM9 GG9.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF CDAT >= AAGGG GO TO LS10.
      ************
           MOVE KEYCF TO KEYFD.
           READ FORNCD INVALID GO TO LS07-1.
       LS07-1.
           IF SF-FCD = ZERO GO TO LS08.
           MOVE ZERO TO RF-FCD.
           MOVE ZERO TO FCD-IMPON FCD-NIMPO FCD-ESENT
                        FCD-IMIVA FCD-TACCR.
           MOVE KEYCF TO KEYFD.
           WRITE RF-FCD INVALID PERFORM INVK-FCD GO TO ERRIO.
       LS08.
           MOVE FCD-IMPON TO IMPON.
           MOVE FCD-NIMPO TO NIMPO.
           MOVE FCD-ESENT TO ESENT.
           MOVE FCD-IMIVA TO IMIVA.
           MOVE FCD-NOPNI TO NOPNI.
           MOVE FCD-TACCR TO TACCR.
           IF T02-CTRFT = ZERO GO TO LS09.
           IF SEGNO = ZERO
              ADD 1 TO FCD-NFATT
           ELSE
              SUBTRACT 1 FROM FCD-NFATT.
       LS09.
           IF T02-CTRAC = ZERO GO TO LS13.
           IF SEGNO = ZERO
              ADD 1 TO FCD-NACCR
           ELSE
              SUBTRACT 1 FROM FCD-NACCR.
           GO TO LS13.
       LS10.
           MOVE CLF-IMPON TO IMPON.
           MOVE CLF-NIMPO TO NIMPO.
           MOVE CLF-ESENT TO ESENT.
           MOVE CLF-IMIVA TO IMIVA.
           MOVE CLF-NOPNI TO NOPNI.
           MOVE CLF-TACCR TO TACCR.
           IF T02-CTRFT = ZERO GO TO LS11.
           IF SEGNO = ZERO
              ADD 1 TO CLF-NFATT
           ELSE
              SUBTRACT 1 FROM CLF-NFATT.
       LS11.
           IF T02-CTRAC = ZERO GO TO LS12.
           IF SEGNO = ZERO
              ADD 1 TO CLF-NACCR
           ELSE
              SUBTRACT 1 FROM CLF-NACCR.
       LS12.
           IF T02-CTRIN = ZERO GO TO LS13.
           IF SEGNO = ZERO
              ADD 1 TO CLF-NINS
           ELSE
              SUBTRACT 1 FROM CLF-NINS.
           ADD CLAV TO CLF-LINS.
       LS13.
           MOVE 'A' TO DAVE.
           IF T02-D-A = 'A' MOVE 'D' TO DAVE.
           MOVE DAVE TO DAV.
           IF TREG = 3 MOVE WCOR (I) TO WCORP.
           MOVE ZERO TO K.
       LS14.
           ADD 1 TO K.
           IF K > KMX GO TO LS22.
           MOVE WDES (K) TO WDESC.
           IF TREG = 2
           IF WD-A (K) = 'D' OR 'A'
              MOVE WD-A (K) TO DAVE
           ELSE
              MOVE DAV TO DAVE.
      **** rel 5.1
           IF TREG = 3
              IF WIMP (K) < ZERO
                 IF WD-A (K) = 'D' OR 'A'
                    MOVE WD-A (K) TO DAVE
                    COMPUTE WIMP (K) = WIMP (K) * M1
                 ELSE
                    MOVE DAV TO DAVE
                 END-IF
              ELSE
                 MOVE DAV TO DAVE.
      ************
           IF SWEN > ZERO AND WCOD (K) = ZERO
              IF WIMP (K) NOT = ZERO
                 GO TO LS15
              ELSE
                 IF WCON (K) NOT = ZERO
                    GO TO LS14.
           MOVE ZERO TO SWEN.
           IF ATTR = ZERO GO TO LS20.
           IF WCOD (K) = ZERO  AND WCON (K) = ZERO GO TO LS22.
           IF WCOD (K) = ZERO GO TO LS14.
           MOVE 3        TO KTB-TIP.
           MOVE WCOD (K) TO KTB-COD.
           OPEN INPUT TABELL.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           CLOSE TABELL
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE ZERO    TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           CLOSE TABELL
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           CLOSE TABELL.
           IF FLGIS NOT = 1 GO TO LS15.
           MOVE ZERO TO L.
       LS14-00.
           ADD 1 TO L.
           IF FTCIVA(L) = ZERO MOVE WCOD(K) TO FTCIVA(L).
           IF FTCIVA(L) = WCOD(K) GO TO LS14-05.
           IF L < 6 GO TO LS14-00.
           MOVE WCOD(K) TO FTCIVA(L).
       LS14-05.
           MOVE WIVA(K) TO CLAV2.
           MOVE WIMP(K) TO CLAV3.
           IF SEGNO > ZERO COMPUTE CLAV2 = CLAV2 * M1
                           COMPUTE CLAV3 = CLAV3 * M1.
           ADD CLAV2 TO FTSIVA(L).
           ADD CLAV3 TO FTSIMP(L).
       LS15.
           MOVE WCAUS    TO MOV-CAUS.
      **** rel 7.2
      * X Y sono movimenti inerenti allo splitpay
      *    IF WFIL(K) = 'X' OR = 'Y'
           IF WFIL(K) = 'Y'
              MOVE GISO TO MOV-CAUS.
           IF WFIL(K) = 'Y'
              PERFORM MOV-CLI THRU EX-MOV-CLI
              GO TO LS14.
      ************
           MOVE WCON (K) TO MOV-CON.
           MOVE WIVA (K) TO CLIV.
           MOVE ZERO     TO CLNI.
           IF T03-TPIVA = 1 MOVE CLIV TO CLNI
                            MOVE ZERO TO CLIV.
      **** rel 6.2
      *    IF T03-TPIVA = 7 COMPUTE CLIV = CLIV / 2
           IF T03-TPIVA = 7 AND T03-PERIVA = ZERO
              MOVE 50 TO T03-PERIVA.
      *
           IF T03-TPIVA = 7 COMPUTE CLIV = CLIV / 100 * 
                                    (100 - T03-PERIVA)
      ************
                            COMPUTE CLNI = WIVA (K) - CLIV.
           MOVE WIMP(K)  TO CLAV CLAV1.
           MOVE WFEV (K) TO MOV-FEV.
           ADD CLNI TO CLAV.
           IF SEGNO > ZERO COMPUTE CLAV = CLAV * M1
                           COMPUTE CLAV1 = CLAV1 * M1.
           MOVE 1 TO MOV-FLAG.
           IF WCON (K) = 9999999 MOVE 1 TO SWEN
                                 GO TO LS16.
           MOVE WDESC TO MOV-DSAGG.
           IF WD-A (K) = '*' MOVE 'D' TO DAVE.
           MOVE WCCOST(K) TO MOV-CCOST.
           PERFORM RNXP THRU EX-RNXP.
           MOVE WCON (K) TO KPC-COD.
           PERFORM RCONW THRU EX-RCONW.
           IF WD-A (K) = '*' MOVE 'A' TO DAVE.
       LS16.
           IF WNPRGI = ZERO GO TO LS14.
           IF SWEN > 1 GO TO LS14.
           IF TIPOP = 8 ADD CLAV1 TO TACCR
                        COMPUTE CLAV1 = CLAV1 * M1.
           IF T03-TPIVA < 2 OR  T03-TPIVA = 7 ADD CLAV1 TO IMPON.
      **** rel 5.0
      *    IF T03-TPIVA > 1 AND T03-TPIVA < 5 ADD CLAV1 TO ESENT.
           IF T03-TPIVA > 1 AND T03-TPIVA < 6 ADD CLAV1 TO ESENT.
      ************
           IF T03-TPIVA = 6 ADD CLAV1 TO NIMPO
              IF SEGNO = ZERO
                 ADD 1 TO NOPNI
              ELSE
                 SUBTRACT 1 FROM NOPNI.
           MOVE CIVAVE TO MOV-CON.
           MOVE CIVAVE TO KPC-COD.
           IF FLGIS = 1 MOVE CIVASO TO MOV-CON KPC-COD.
           IF TREG  = 3 MOVE CIVACQ TO MOV-CON
                        MOVE CIVACQ TO KPC-COD.
           MOVE WCAUS TO MOV-CAUS.
           MOVE CLIV  TO CLAV CLAV1.
           ADD CLNI   TO CLAV1.
           IF SEGNO > ZERO COMPUTE CLAV = CLAV * M1
                           COMPUTE CLAV1 = CLAV1 * M1.
           MOVE ZERO     TO MOV-FLAG.
           MOVE WCOD (K) TO MOV-IVA.
           MOVE WPART    TO MOV-ACF.
           MOVE TREG     TO MOV-TIP.
           MOVE WIMP (K) TO MOV-IMP.
           MOVE WFEV (K) TO MOV-FEV.
           MOVE WPLAFO (K) TO MOV-PLAF.
           MOVE CLNI TO MOV-IVN.
           IF SEGNO = 1 COMPUTE MOV-IMP = MOV-IMP * M1
                        COMPUTE MOV-IVN = MOV-IVN * M1.
      **** rel 6.2
           IF TREG = 3
              ADD CLAV1 TO RT-WIMPIV
              IF T03-TPIVA > 3 AND < 6 ADD WIMP(K) TO RT-WNIMPO
                                  ELSE ADD WIMP(K) TO RT-WIMPON.
      ************
           MOVE WCCOST(K) TO MOV-CCOST.
           PERFORM RNXP THRU EX-RNXP.
           IF TREG    NOT = 2 GO TO RSI-15.
           IF T25-PER NOT = 2 GO TO RSI-15.
           IF T03-TSOPE   = 7 GO TO RSI-15.
           MOVE ZERO TO STAT116.
           CALL 'vcon116' USING STAT116 REKMOV.
           CANCEL 'vcon116'.
           IF ERRIO-ST NOT = ZERO GO TO ERRIO.
       RSI-15.
           IF TIPOP = 8
              SUBTRACT CLAV1 FROM IMIVA
           ELSE
              ADD CLAV1 TO IMIVA.
           IF SWEN = 1 MOVE 2 TO SWEN.
           PERFORM RCONW THRU EX-RCONW.
           GO TO LS14.
       LS20.
           IF WIVA (K) = ZERO GO TO LS22.
           MOVE WCAUS    TO MOV-CAUS.
           MOVE WCON (K) TO MOV-CON.
           MOVE WIVA (K) TO CLAV.
           IF SEGNO > ZERO COMPUTE CLAV = CLAV * M1.
           MOVE 1         TO MOV-FLAG.
           MOVE WDESC     TO MOV-DSAGG.
           MOVE WCCOST(K) TO MOV-CCOST.
           PERFORM RNXP THRU EX-RNXP.
           MOVE WCON (K) TO KPC-COD.
           PERFORM RCONW THRU EX-RCONW.
           GO TO LS14.
       LS22.
           IF WCAUS = T20-CDSOC OR T20-CASOC OR
                      T20-CDCLC OR T20-CACLC OR
                      T20-CDFOC OR T20-CAFOC OR
                      T20-CDSOA OR T20-CASOA OR
                      T20-CDCLA OR T20-CACLA OR
                      T20-CDFOA OR T20-CAFOA GO TO LS26.
           IF TREG NOT = 3 GO TO LS24.
           ADD 1 TO I.
           IF I < 9 AND WCOR (I) NOT = ZERO
                        MOVE WCOR (I) TO WCORP
                        MOVE ZERO TO K
                        GO TO LS14.
      **** rel 4.0-2
      *    IF CDAT > DTCON GO TO LS24.
           MOVE DTCON TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE 01 TO MM9 GG9.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF CDAT >= AAGGG GO TO LS24.
      ************
           MOVE 2     TO KTB-TIP.
           MOVE WCAUS TO KTB-COD.
           OPEN INPUT TABELL.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           CLOSE TABELL
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           CLOSE TABELL.
           IF NOT ( T02-TIPOP = 1 OR 8 ) GO TO LS24.
           MOVE IMPON TO FCD-IMPON.
           MOVE IMIVA TO FCD-IMIVA.
           MOVE ESENT TO FCD-ESENT.
           MOVE NIMPO TO FCD-NIMPO.
           MOVE NOPNI TO FCD-NOPNI.
           MOVE TACCR TO FCD-TACCR.
           REWRITE RF-FCD INVALID PERFORM INVK-FCD GO TO ERRIO.
           GO TO LS26.
       LS24.
           MOVE IMPON TO CLF-IMPON.
           MOVE IMIVA TO CLF-IMIVA.
           MOVE ESENT TO CLF-ESENT.
           MOVE NIMPO TO CLF-NIMPO.
           MOVE NOPNI TO CLF-NOPNI.
           MOVE TACCR TO CLF-TACCR.
       LS26.
           REWRITE RF-CLF FROM REKCLF INVALID KEY PERFORM INVK-CLF
                                                  GO TO ERRIO.
           IF FLGIS NOT = 1 GO TO LS99.
           OPEN I-O FATSOS.
           MOVE CDAZ  TO KFS-AZI.
           MOVE WPART TO KFS-CLI.
           MOVE WCATT TO KFS-CATT.
           MOVE WNDOC TO KFS-NFAT.
           MOVE WDATA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AA4 TO KFS-ANNO.
           READ FATSOS INVALID GO TO FTS-00.
           GO TO FTS-10.
       FTS-00.
           MOVE WNPRGI TO FTS-NREG.
           MOVE ZERO TO FTS-TDOC
                        FTS-ULPAG FTS-ULIVA FTS-FLAG FTS-FILL.
           MOVE ZERO TO L.
       FTS-05.
           ADD 1 TO L.
           MOVE ZERO TO FTS-IMPON(L) FTS-IMIVA(L) FTS-CDIVA(L)
                        FTS-IMPAG(L) FTS-IVPAG(L).
           IF L < 6 GO TO FTS-05.
           WRITE RF-FTS INVALID PERFORM RFTSO THRU EX-RFTSO
                                GO TO FTS-20.
       FTS-10.
           MOVE WDATA TO FTS-DTDOC.
           MOVE ZERO  TO FTS-TDOC.
           IF TIPOP = 8 MOVE 1 TO FTS-TDOC.
           MOVE ZERO TO L.
       FTS-15.
           ADD 1 TO L.
           ADD FTSIMP(L)  TO FTS-IMPON(L).
           ADD FTSIVA(L)  TO FTS-IMIVA(L).
           MOVE FTCIVA(L) TO FTS-CDIVA(L).
      **** rel 7.2
           IF FLGSOT = 1
              MOVE 1      TO  FTS-FLAG
              MOVE FTSIVA(L) TO FTS-IVPAG(L).
      ************
           IF L < 6 GO TO FTS-15.
           REWRITE RF-FTS INVALID PERFORM RFTSO THRU EX-RFTSO.
       FTS-20.
           MOVE ZERO TO FLGIS.
           CLOSE FATSOS.
       LS99.
           UNLOCK ANACLF.
      **** rel 6.2
           IF FLAUT = 1
              PERFORM CHIAMA-VRIT185 THRU EX-CHIAMA-VRIT185.
      ************
       EX-RSEZ.
           EXIT.
      *-----------*
       ERRIO.
           COPY 'errsub'.
       FINE.
           CLOSE MOVIME.
           CLOSE PARTIT FORNCD.
           CLOSE ANACON ANACLF.
           CLOSE ANAAZI.
       FINEPG.
           EXIT PROGRAM.
           STOP RUN.
           COPY 'griazier'.
           COPY 'griconer'.
           COPY 'griclfer'.
           COPY 'grimover'.
           COPY 'grimszer'.
           COPY 'griparer'.
           COPY 'grifcder'.
           COPY 'griscaer'.
      **** rel 6.2
           COPY 'grinscer'.
      ************
           COPY 'griftser'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *-----------*
       RFTSO.
           MOVE 'Errore su archivio fatture in sospeso !' TO MESS.
           MOVE 8 TO ERRIO-ST.
           MOVE ZERO TO FLGIS RISP.
       EX-RFTSO.
           EXIT.
      *-----------*
       REC-LOCK.
      **** rel 1.2
           CALL 'rlock' USING PARLK.
      ************
           EXIT.
      *-----------*
       CERCA-CP.
           MOVE 6 TO K.
       CCP1.
           ADD 1 TO K.
           IF K > 54 GO TO EX-CERCA-CP.
           IF NOT WCOD (K) = ZERO GO TO CCP1.
       EX-CERCA-CP.
           EXIT.
      * - - - - - *
      **** rel 6.2
       CHIAMA-VRIT185.
           CLOSE ANACLF ANACON MOVIME FORNCD.
           CALL 'vrit185' USING PARLINK-114 RT-PAR.
           CANCEL 'vrit185'.
           OPEN I-O ANACLF ANACON MOVIME FORNCD.
           MOVE ZERO TO FLAUT.
       EX-CHIAMA-VRIT185.
           EXIT.
      * - - - - - *
      ************
      **** rel 7.2
       MOV-CLI.
      * Aggiornamento partitario
           MOVE KAZ-COD TO KPA-AZI PAR-AZI.
           MOVE TREG TO TIPO.
           IF WCAUS = T20-CDSOC OR T20-CASOC OR
                      T20-CDCLC OR T20-CACLC OR
                      T20-CDFOC OR T20-CAFOC OR
                      T20-CDSOA OR T20-CASOA OR
                      T20-CDCLA OR T20-CACLA OR
                      T20-CDFOA OR T20-CAFOA GO TO NO-PARTI.
           IF WFLGEC = 1 GO TO NO-PARTI.
           MOVE CLF-CD TO CLFO.
           MOVE WNDOC  TO PART.
           MOVE 1      TO NUME.
           MOVE CAN    TO KPA-CAN.
           READ PARTIT INTO REKPAR INVALID
                MOVE ZERO TO PAR-DESCR
                MOVE ZERO TO PAR-VSALD PAR-VALUT PAR-CADOC
                MOVE ZERO TO PAR-SALDO PAR-NUMPA
                GO TO LS1.
           IF SF-PAR = '9D' OR '9A' OR '35' MOVE RF-PAR TO REKPAR.
       LS1.
           MOVE 98 TO PMAX.
           IF WDESC    NOT = SPACE SUBTRACT 1 FROM PMAX.
           IF WDSC (1) NOT = ZERO  SUBTRACT 1 FROM PMAX.
           IF PAR-NUMPA < PMAX GO TO LS2.
           IF PAR-NUMPA = PMAX
              MOVE 'Ultima reg.partita' TO MESS
              MOVE 8 TO ERRIO-ST
              GO TO LS2.
           MOVE ZERO TO FLGIS RISP.
           MOVE 'Partita completa: movimento non registrato!' TO MESS.
           MOVE 8 TO ERRIO-ST.
           MOVE 9 TO RISP.
           MOVE 1 TO SWER.
           GO TO EX-MOV-CLI.
       LS2.
           MOVE CAN TO PAR-CAN.
           MOVE 1   TO PAR-TIP.
      **** rel 7.2
           PERFORM CALCOLA-IVA THRU EX-CALCOLA-IVA.
      ************
           IF T02-D-A = 'D'
              ADD CLAV TO PAR-SALDO
           ELSE
              SUBTRACT CLAV FROM PAR-SALDO.
           IF T02-D-A = 'D'
              ADD CVAV TO PAR-VSALD
           ELSE
              SUBTRACT CVAV FROM PAR-VSALD.
           IF SF-PAR = ZERO GO TO LS3.
           MOVE WVALUT TO PAR-VALUT.
           MOVE WCAMGG TO PAR-CADOC.
           WRITE RF-PAR FROM REKPAR INVALID KEY PERFORM INVK-PAR
                                                GO TO ERRIO.
           GO TO LS4.
       LS3.
           REWRITE RF-PAR FROM REKPAR INVALID KEY PERFORM INVK-PAR
                                                  GO TO ERRIO.
           MOVE PAR-NUMPA TO NUME.
       LS4.
           ADD 1 TO NUME.
           MOVE CAN TO KPA-CAN.
           READ PARTIT INVALID KEY GO TO LS5.
           IF NUME = 99 MOVE 'Overflow partita' TO MESS
                        GO TO ERRIO.
           GO TO LS4.
       LS5.
           MOVE CAN       TO PAR-CAN.
           MOVE 2         TO PAR-TIP.
           MOVE DTCON     TO PAR-DTCON.
           MOVE MOV-CAUS  TO PAR-CAUS.
           MOVE T02-TIPOP TO PAR-TIPOP.
           MOVE WDTSCD    TO PAR-DTSCA.
           MOVE WNDOC     TO PAR-NDOC.
           MOVE WDATA     TO PAR-DTDOC.
           MOVE CLAV      TO PAR-IMPOR.
           MOVE CVAV      TO PAR-VIMPO.
           MOVE WCAMGG    TO PAR-CAMGG.
           MOVE DAVE      TO PAR-D-A.
           MOVE WNPRGI    TO PAR-NPIVA.
           WRITE RF-PAR FROM REKPAR INVALID KEY PERFORM INVK-PAR
                                                GO TO ERRIO.
        NO-PARTI.
      * movimento contabile
           ADD 1 TO NMOV.
           PERFORM RMOV THRU EX-RMOV.
           MOVE 1        TO MOV-FLAG.
           MOVE WDESC    TO MOV-DSAGG.
      **** p1501
      *    IF TREG = 2 
      *       MOVE WCPART TO MOV-PART
      *    ELSE
              MOVE WCON (1) TO MOV-PART.
           MOVE WPART    TO MOV-CON.
           MOVE SPACE    TO MOV-CCOST.
           IF NOT (WVALUT = ZERO OR COMEURO)
              MOVE WVALUT  TO MOV-VALUT
              MOVE WCAMGG  TO MOV-CAMGG
              MOVE WIMP(K) TO MOV-IMVAL
           ELSE
              MOVE ZERO TO MOV-VALUT MOV-CAMGG MOV-IMVAL.
           OPEN I-O MOVSEZ.
           MOVE ZERO TO MOV-FLGE2.
           WRITE RF-MSZ FROM REKMOV INVALID PERFORM INVK-MSZ
                                            CLOSE MOVSEZ
                                            GO TO ERRIO.
      *
           MOVE CLF-CATCON TO CATCON.
           IF CATCON = ZERO MOVE 1 TO CATCON.
           MOVE CRPCL (CATCON) TO WCRPCL.
           MOVE CRPFR (CATCON) TO WCRPFR.
           MOVE WCRPCL TO MOV-CON MOV-PART.
           MOVE 99991  TO CLV1.
           PERFORM RCHGG THRU EX-RCHGG.
      *
           IF DAVE = 'D'
              ADD CLAV TO CLF-SP-D
              ADD CLAV TO CLF-SE-D
           ELSE
              ADD CLAV TO CLF-SP-A
              ADD CLAV TO CLF-SE-A.
      *
           REWRITE RF-CLF FROM REKCLF INVALID KEY PERFORM INVK-CLF
                                                  GO TO ERRIO.
      *
           MOVE MOV-CON TO KPC-COD.
           PERFORM RCONW THRU EX-RCONW.
      *
       NO-FATSOS.
           CLOSE FATSOS.
      *
       EX-MOV-CLI.
           EXIT.
      * - - - - - *
       CALCOLA-IVA.
           MOVE ZERO TO TOTIVA K3 FLGSOT.
       RIPROVA.
           ADD 1 TO K3.
           IF K3 = 55 GO TO EX-CALCOLA-IVA.
      *
           ADD WIVA(K3) TO TOTIVA.
           IF WFIL(K3) = 'X' OR = 'Y'
              MOVE 1 TO FLGSOT.
           GO TO RIPROVA.
       EX-CALCOLA-IVA.
           EXIT.
      * - - - - - *
      ************
