       IDENTIFICATION DIVISION.
       PROGRAM-ID. VFAT119.
      *
      * OGGETTO   :   PAGAMENTI MISTI 
      *
      **** rel 6.2
      * Nuovo
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'gritabsl'.
           COPY 'griclfsl'.
           COPY 'grifatsl'.
           COPY 'gribctsl'.
           COPY 'grieffsl'.
      **** rel 7.1
           COPY 'griaftsl'.
      ************
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gritab'.
           COPY 'griclf'.
           COPY 'grifat'.
           COPY 'gribct'.
           COPY 'grieff'.
      **** rel 7.1
           COPY 'griaft'.
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-71'.
           COPY 'gritabrk'.
           COPY 'griazirk'.
           COPY 'griclfrk'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parer'.
           COPY 'parlk'.
           COPY 'parmb'.
           COPY 'parpsca'.
           COPY 'parrb'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-EFF PIC X(15) VALUE 'effett'.
       01  ID-BCT PIC X(15) VALUE 'bolcte'.
      **** rel 7.1
       01  ID-AFT PIC X(15) VALUE 'appfat'.
      ************
       01  ID-FAT.
           05 FILLER PIC X(6) VALUE 'fattur'.
           05 FATTIV PIC X    VALUE SPACE.
           05 FILLER PIC X(8) VALUE SPACE.
       01  COMODI.
           05 SF-AZI   PIC XX.
           05 SF-TAB   PIC XX.
           05 SF-CLF   PIC XX.
           05 SF-EFF   PIC XX.
           05 SF-FAT   PIC XX.
           05 SF-BCT   PIC XX.
      **** rel 7.1
           05 SF-AFT   PIC XX.
      ************
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 K        PIC 99.
           05 KK       PIC 99.
           05 MCLI     PIC 99         VALUE ZERO.
           05 MFOR     PIC 99         VALUE ZERO.
           05 CODICE.
              10 MAS    PIC 99.
              10 COD    PIC 9(5).
           05 COMBOL  PIC 9(14) VALUE ZERO.
           05 COMBOLR REDEFINES COMBOL.
              10 FILLER PIC 9(12).
              10 ULT2   PIC 99.
           05 SWRB    PIC 9 VALUE ZERO.
           05 OLDBOL  PIC 9(14) VALUE ZERO.
           05 TOTBOL  PIC S9(11) VALUE ZERO.
           05 COMX    PIC S9(11) VALUE ZERO.
           05 COMXR  REDEFINES COMX.
              10 FILLER PIC 9(8).
              10 ULT3   PIC 9(3).
           05 NUMEFF  PIC 9(5) VALUE ZERO.
           05 PERCB   PIC 9(3)V99 VALUE ZERO.
           05 COMEURO  PIC 999.
           05 COMSCAD1 PIC 99999.
       01  RTABRB.
           05 TRB PIC S9(11) OCCURS 6.
       01  RTABBL.
           05 TBL PIC S9(7) OCCURS 6.
       01  RRB1.
           05 TRB1 PIC S9(11) OCCURS 6.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-CATT      PIC X.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
           05 IF-IDXVET    PIC 99.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
           05 IF-CDCLI     PIC 9(5).
           05 IF-CDCLI-D   PIC X(36).
           05 IF-TDOC      PIC 9.
           05 IF-FATT      PIC 9(5).
           05 IF-TOTFT     PIC S9(11)V99.
           05 IF-DESP1     PIC X(30).
           05 IF-DESP2     PIC X(30).
           05 IF-DESP3     PIC X(30).
           05 IF-TOTSCA    PIC S9(11)V99.
           05 IF-TOTSCAV   PIC S9(11)V99.
           05 IF-VALUT     PIC 9(3).
           05 IF-VALUT-D   PIC X(4).
           05 IF-DIFSCA    PIC S9(11)V99.
           05 IF-DIFSCAV   PIC S9(11)V99.
           05 IF-CPAG      PIC 9(3).
           05 IF-DT1SCA    PIC 9(6).
           05 IF-FLSC1     PIC 9.
           05 IF-TOTACC    PIC S9(11)V99.
      *
       01  IF-REC-SCA.
           05 IF-SCA OCCURS 12.
              10 IF-SC-TPAG    PIC 9.
              10 IF-SC-DTSCA   PIC 9(6).
              10 IF-SC-IMRATA  PIC S9(11)V99.
              10 IF-SC-VALRAT  PIC S9(11)V99.
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-REC-SCA
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dcltab'.
           COPY 'dclclf'.
           COPY 'dclfat'.
           COPY 'dcleff'.
      **** rel 7.1
           COPY 'dclaft'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vfat119: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI.
           CLOSE TABELL.
           CLOSE ANACLF.
           CLOSE FATTUR.
           CLOSE BOLCTE.
           CLOSE EFFETT.
      **** rel 7.1
           CLOSE APPFAT.
      ************
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'erreur'.
           COPY 'griazier'.
           COPY 'gritaber'.
           COPY 'griclfer'.
           COPY 'grifater'.
           COPY 'gribcter'.
           COPY 'grieffer'.
      **** rel 7.1
           COPY 'griafter'.
      ************
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           MOVE IF-CATT TO FATTIV.
           IF FATTIV = '0' MOVE SPACE TO FATTIV.
      *
           OPEN INPUT TABELL.
           OPEN INPUT ANACLF.
           OPEN INPUT BOLCTE.
           OPEN I-O   ANAAZI.
           OPEN I-O   FATTUR.
           OPEN I-O   EFFETT.
      **** rel 7.1
           OPEN I-O   APPFAT.
      ************
      *
       RD-AZI.
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI KEPT LOCK INVALID KEY
                PERFORM INVK-AZI GO TO WARNING.
           IF SF-AZI NOT = ZERO 
              PERFORM REC-LOCK
              GO TO RD-AZI.
           MOVE AZI-NEFF TO NUMEFF.
      *
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID
              PERFORM INVK-TAB
              GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MCLI TO MCLI.
           MOVE T01-MFOR TO MFOR.
      *
           MOVE 14 TO KTB-TIP.
           MOVE 3 TO KTB-COD.
           READ TABELL INTO REKTAB INVALID KEY
                PERFORM INVK-TAB
                GO TO WARNING.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T14-ALIQ TO PERCB.
           MOVE ZERO TO K.
       CRBOL.
           ADD 1 TO K.
           IF K > 6 GO TO FBOL.
           COMPUTE TRB1(K) = T14-IMPS(K) * 100.
           COMPUTE TRB(K)  = T14-IMPS(K) * 100.
           COMPUTE TBL(K)  = T14-IMPB(K) * 100.
           IF T14-IMPS(K) = 9999999,99
                    MOVE  99999999999 TO TRB1(K) TRB(K)
                    GO TO CRBOL.
           SUBTRACT TBL(K) FROM TRB(K).
           GO TO CRBOL.
       FBOL.
      *
           MOVE IF-AZI   TO KFT-AZI.
           MOVE IF-TDOC  TO KFT-TDOC.
           MOVE IF-FATT  TO KFT-NUM.
       LP-FAT.
           READ FATTUR KEPT LOCK INVALID
                MOVE 'Fattura inesistente' TO MESS
                GO TO ERRIO.
           IF SF-FAT NOT = ZERO 
              PERFORM REC-LOCK
              GO TO LP-FAT.
      **** rel 7.1
           MOVE KFT-AZI  TO KAFT-AZI.
           MOVE KFT-TDOC TO KAFT-TDOC.
           MOVE KFT-NUM  TO KAFT-NUM.
           MOVE FAT-CATT TO KAFT-CATT.
           READ APPFAT INVALID
                MOVE SPACE TO AFT-CIG AFT-CUP.
      ************ 
      *
           MOVE 4 TO KTB-TIP.
           MOVE FAT-CDPAG TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB. 
           IF T04-NRATE NOT = ZERO 
              MOVE 'Tipo pagamento non ammesso' TO MESS
              GO TO ERRIO.
      *
           MOVE TAB-DESCR TO IF-DESP1.
           MOVE 1 TO K.
           PERFORM UNTIL K > 12
              MOVE ZERO TO FAT-TPAG(K)
              ADD 1 TO K.
      *
           CALL 'rveur' USING COMEURO.
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE AZRGSOC TO IF-AZI-D.
      *
           MOVE ZERO TO IF-CPAG IF-DT1SCA IF-FLSC1.
      **** rel 6.3
           MOVE ZERO TO K.
           PERFORM UNTIL K = 12
              ADD 1 TO K
              MOVE ZERO TO IF-SC-TPAG(K)
              MOVE ZERO TO IF-SC-DTSCA(K)
              MOVE ZERO TO IF-SC-IMRATA(K)
              MOVE ZERO TO IF-SC-VALRAT(K).
      **********
      *
           PERFORM A00-CARICA THRU A99.
      *
           PERFORM CALC-SC-DIFF THRU EX-CALC-SC-DIFF.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-CPAG.
           MOVE 'IF-CPAG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CPAG.
           IF IF-CPAG = ZERO GO TO E-CPAG.
      *
           MOVE 4 TO KTB-TIP.
           MOVE IF-CPAG TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM ERR-CINE
                                           GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB. 
           IF T04-TIPAG = 9 
              MOVE 'Tipo pagamento non ammesso' TO MESS
              GO TO V-ERROR.
           IF T04-1SCAD = 5
              MOVE 1 TO IF-FLSC1
           ELSE
              IF FUN = 'V'
                 PERFORM GEN-SCAD THRU EX-GEN-SCAD.
      *
       E-CPAG.
      *
       V-DT1SCA.
           MOVE 'IF-DT1SCA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DT1SCA.
      *
           MOVE 1 TO TIPOP1.
           MOVE IF-DT1SCA TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO COMSCAD1.
      *
           IF FUN = 'V'
              PERFORM GEN-SCAD THRU EX-GEN-SCAD.
       E-DT1SCA.
      *
       V-SC-TPAG.
           MOVE 'IF-SC-TPAG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-SC-TPAG.
           MOVE ZERO TO K.
       V-SC-TPAG-10.
           ADD 1 TO K.
           IF K > 12 GO TO E-SC-TPAG.
           IF FUN = 'W'
              MOVE K TO IF-IDXVET
           ELSE
              IF K NOT = IF-IDXVET
                 GO TO V-SC-TPAG-10.
           IF IF-SC-TPAG(K) = ZERO
              MOVE ZERO TO IF-SC-DTSCA(K)
                           IF-SC-IMRATA(K)
                           IF-SC-VALRAT(K)
           ELSE 
              IF IF-SC-TPAG(K) = 9
                 MOVE 'Tipo pagamento non ammesso !' TO MESS
                 GO TO V-ERROR
              END-IF
              IF NOT (IF-SC-TPAG(K) = 1 OR 2 OR 3 OR 4 OR 5 OR 6)
                    PERFORM ERR-DINV
                    GO TO V-ERROR.
           GO TO V-SC-TPAG-10.
       E-SC-TPAG.
      *
       V-SC-DTSCA.
           MOVE 'IF-SC-DTSCA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-SC-DTSCA.
           MOVE ZERO TO K.
       V-SC-DTSCA-10.
           ADD 1 TO K.
           IF K > 12 GO TO E-SC-DTSCA.
           IF FUN = 'W'
              MOVE K TO IF-IDXVET
           ELSE
              IF K NOT = IF-IDXVET
                 GO TO V-SC-DTSCA-10.
           MOVE IF-SC-DTSCA(K) TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
      *
           IF AAGGG NOT = ZERO AND AAGGG < FAT-DATA
              PERFORM ERR-DINV
              GO TO V-ERROR.
      *
           GO TO V-SC-DTSCA-10.
       E-SC-DTSCA.
      *
       V-SC-IMRATA.
           MOVE 'IF-SC-IMRATA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-SC-IMRATA.
           MOVE ZERO TO K.
       V-SC-IMRATA-10.
           ADD 1 TO K.
           IF K > 12 GO TO E-SC-IMRATA.
           IF FUN = 'W'
              MOVE K TO IF-IDXVET
           ELSE
              IF K NOT = IF-IDXVET
                 GO TO V-SC-IMRATA-10.
           IF (FAT-VALUT = ZERO OR COMEURO) GO TO V-SC-IMRATA-10.
           IF FUN NOT = 'V' GO TO V-SC-IMRATA-10.
           IF IF-SC-IMRATA(K) NOT = ZERO
              MOVE IF-SC-IMRATA(K) TO ER-IMPORTO
              MOVE FAT-VALUT TO ER-VALUT
              MOVE FAT-CADOC TO ER-CAMBIO
              CALL 're2imp' USING ER-IMPORTO EUR-VAL ER-VALUT
                                  ER-CAMBIO
              MOVE ER-IMPORTO TO IF-SC-VALRAT(K).
           GO TO V-SC-IMRATA-10.
       E-SC-IMRATA.
      *
      * esegue sempre se 'V' o 'W'.
      *
           PERFORM CALC-SC-DIFF THRU EX-CALC-SC-DIFF.
      *
           IF FUN = 'W' AND IF-DIFSCA > ZERO 
              MOVE "La somma delle scadenze e' " TO F-MES1
              MOVE "inferiore al totale della " TO F-MES2
              MOVE "fattura.Correggere gli importi." TO F-MES3
              MOVE 3 TO F-NMES
              MOVE 1 TO IF-IDXVET
              GO TO V-ERROR.
           IF FUN = 'W' AND IF-DIFSCA < ZERO
              MOVE "La somma delle scadenze e'" TO F-MES1
              MOVE "superiore al totale della fattura." TO F-MES2
              MOVE "Correggere gli importi.           " TO F-MES3
              MOVE 3 TO F-NMES
              MOVE 1 TO IF-IDXVET
              GO TO V-ERROR.
           IF FUN = 'W' AND IF-DIFSCAV > ZERO 
              MOVE "La somma delle scadenze in valuta e' " TO F-MES1
              MOVE "inferiore al totale della " TO F-MES2
              MOVE "fattura.Correggere gli importi." TO F-MES3
              MOVE 3 TO F-NMES
              MOVE 1 TO IF-IDXVET
              GO TO V-ERROR.
           IF FUN = 'W' AND IF-DIFSCAV < ZERO
              MOVE "La somma delle scadenze in valuta e'" TO F-MES1
              MOVE "superiore al totale della fattura." TO F-MES2
              MOVE "Correggere gli importi.           " TO F-MES3
              MOVE 3 TO F-NMES
              MOVE 1 TO IF-IDXVET
              GO TO V-ERROR.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           MOVE 1 TO K.
           PERFORM UNTIL K > 12
              MOVE IF-SC-DTSCA(K)  TO GGMMAA
              MOVE 1 TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE AAGGG           TO FAT-DTSCA(K)
              MOVE IF-SC-TPAG(K)   TO FAT-TPAG(K)
              MOVE IF-SC-IMRATA(K) TO FAT-IMPOR(K)
              MOVE IF-SC-VALRAT(K) TO FAT-EIMPOR(K)
              ADD 1 TO K.

           REWRITE RF-FAT INVALID
              PERFORM INVK-FAT GO TO ERRIO.
           UNLOCK FATTUR.

           IF NOT (FAT-VALUT = ZERO OR COMEURO) GO TO EX-FINEFT.
           IF KFT-TDOC = 3 OR 6 GO TO EX-FINEFT.
           MOVE ZERO TO K.
       LPEFF1.
           ADD 1 TO K.
           IF K > 12 GO TO EX-FINEFT.
           IF FAT-IMPOR (K) = ZERO GO TO EX-FINEFT.
           IF FAT-TPAG (K) = ZERO OR FAT-TPAG (K) > 2
                 GO TO LPEFF1.
           MOVE KFT-AZI   TO KEF-AZI.
           MOVE FAT-TPAG(K) TO KEF-TIPO.
       LPEFF2.
           ADD 1 TO NUMEFF.
           MOVE NUMEFF TO KEF-NUM.
           READ EFFETT INVALID KEY GO TO CAREF.
           GO TO LPEFF2.
       CAREF.
           MOVE ZERO TO RESTOEF.
           MOVE ZERO TO EFF-IMPOR
                        EFF-IMBOL
                        EFF-DTSCA
                        EFF-DTFAT
                        EFF-DTCON
                        EFF-TOTFT.
           MOVE ZERO TO EFF-DTFT2 
                        EFF-DTFT3
                        EFF-DTFT4
                        EFF-DTFT5.
           MOVE K TO EFF-NRRAT.
           MOVE T04-NRATE TO EFF-NTRAT.
           MOVE FAT-IMPOR (K) TO EFF-IMPOR.
           MOVE FAT-DTSCA (K) TO EFF-DTSCA.
           MOVE KFT-TDOC  TO EFF-TDOCF.
           MOVE KFT-NUM   TO EFF-NUFAT.
           MOVE FAT-DATA  TO EFF-DTFAT.
           MOVE FAT-TOTFT TO EFF-TOTFT.
           MOVE FAT-CDCLI TO EFF-CDCLI.
           MOVE FAT-CDBAN TO EFF-CDBAN.
           MOVE FAT-CDPAG TO EFF-CDPAG.
           MOVE FAT-CATT  TO EFF-CATT.
      **** rel 7.1
      *    MOVE AFT-CIG   TO EFF-CIG.
      *    MOVE AFT-CUP   TO EFF-CUP.
      ************
           IF FAT-TPAG(K) = 2 GO TO EFFRB.
           MOVE 1 TO SWRB.
           PERFORM RTRAT THRU EX-RTRAT.
           COMPUTE EFF-IMBOL = COMBOL / 100.
           GO TO WREFF.
       EFFRB.
           MOVE 1 TO SWRB.
           PERFORM RIBAN THRU EX-RIBAN.
           COMPUTE EFF-IMBOL = TOTBOL / 100.
       WREFF.
           WRITE RF-EFF INVALID KEY 
                 PERFORM INVK-EFF
                 GO TO WARNING.
           GO TO LPEFF1.
       EX-FINEFT.

           MOVE NUMEFF TO AZI-NEFF.
           REWRITE RF-AZI FROM REKAZI INVALID
                   PERFORM INVK-AZI
                   GO TO WARNING.
           UNLOCK ANAAZI.

       EX-RUN-ELABORA.
           EXIT.
      *------------------
       A00-CARICA.
           MOVE FAT-VALUT TO ER-VALUT IF-VALUT.
           CALL 'rvalut' USING ER-VALUT FAT-DATA CG-PAR.
           IF CG-ST > ZERO MOVE ALL '*' TO CG-DSINT.
           MOVE CG-DSINT TO IF-VALUT-D.
           IF KFT-TDOC = 6 OR = 7 MOVE MFOR TO MAS
              ELSE MOVE MCLI TO MAS.
           MOVE FAT-CDCLI TO COD IF-CDCLI.
           MOVE KFT-AZI TO KCF-AZI.
           MOVE CODICE TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID PERFORM INVK-CLF
                                           GO TO ERRIO.
           MOVE CLF-RGS TO IF-CDCLI-D.
           IF (FAT-VALUT = ZERO OR COMEURO) 
              MOVE FAT-TOTFT TO IF-TOTFT
           ELSE
              MOVE FAT-TOVAL TO IF-TOTFT.
      *
           MOVE 1 TO K.
           PERFORM UNTIL K > 12
              IF FAT-DTSCA(K) NOT = ZERO
                 MOVE FAT-DTSCA(K) TO AAGGG
                 MOVE 2 TO TIPOP1
                 CALL 'rdata' USING PARCDT
                 MOVE GGMMAA        TO IF-SC-DTSCA(K)
                 MOVE FAT-TPAG(K)   TO IF-SC-TPAG(K)
                 MOVE FAT-IMPOR(K)  TO IF-SC-IMRATA(K)
                 MOVE FAT-EIMPOR(K) TO IF-SC-VALRAT(K)
              END-IF
              ADD 1 TO K.
      *
           MOVE ZERO TO IF-TOTACC.
           CALL 'rdbfa' USING FAT-CATT KEYFT PARRB.
           MOVE ZERO TO K.
       RDACC.
           ADD 1 TO K.
           IF K > RB-ULTBOL GO TO FIBOL.
           IF RB-TNUM(K) = ZERO AND RB-NBOL(K) = ZERO GO TO FIBOL.
           MOVE KFT-AZI    TO KBC-AZI.
           MOVE RB-TNUM(K) TO KBC-NUM.
           MOVE RB-NBOL(K) TO KBC-BOL.
           READ BOLCTE INVALID GO TO RDACC.
           IF BCT-ACCON = ZERO GO TO RDACC.
      *
           ADD BCT-ACCON TO IF-TOTACC.
           GO TO RDACC.
       FIBOL.
      *
       A99. EXIT.
      *------------------
       REC-LOCK.
           CALL 'rlock' USING PARLK.
           EXIT.
      *------------------
       RIBAN.
           IF SWRB = 1 MOVE ZERO TO TOTBOL GO TO LPEFB.
           MOVE ZERO TO K.
           MOVE ZERO TO TOTBOL.
       LPRBA1.
           ADD 1 TO K.
           IF K > 12 GO TO EX-RIBAN.
           IF FAT-IMPOR (K) = ZERO GO TO EX-RIBAN.
       LPEFB.
           MOVE ZERO TO KK.
           MOVE FAT-IMPOR (K) TO COMBOL.
       LPRBA2.
           ADD 1 TO KK.
           IF KK > 6 MOVE 6 TO KK GO TO CARBA.
           IF SWRB = 1 GO TO TEST1.
           IF COMBOL NOT > TRB (KK) GO TO CARBA.
           GO TO LPRBA2.
       TEST1.
           IF COMBOL NOT > TRB1 (KK) GO TO CARBA.
           GO TO LPRBA2.
       CARBA.
           COMPUTE TOTBOL = TOTBOL + TBL (KK).
           IF SWRB = 1 GO TO EX-RIBAN.
           GO TO LPRBA1.
       EX-RIBAN.
           EXIT.
      *-----------------------*
       RTRAT.
           IF SWRB = 1 GO TO LPEFF.
           MOVE ZERO TO COMBOL OLDBOL.
           MOVE ZERO TO TOTBOL.
           MOVE ZERO TO K.
       LPTRA1.
           ADD 1 TO K.
           IF K > 12 GO TO EX-RTRAT.
           IF FAT-IMPOR (K) = ZERO GO TO EX-RTRAT.
       LPEFF.
           MOVE FAT-IMPOR (K) TO COMX.
      *    IF FAT-VALUT = ER-VALUT MULTIPLY 10 BY COMX.
           IF FAT-VALUT = ZERO OR COMEURO  MULTIPLY 10 BY COMX.
       LPEF1.
           MOVE COMBOL TO OLDBOL.
           ADD 999 TO COMX.
           MOVE ZERO TO ULT3.
           COMPUTE COMBOL = COMX * PERCB.
           COMPUTE COMBOL = COMBOL / 1000.
           COMPUTE COMBOL = COMBOL + 99.
           MOVE ZERO TO ULT2.
           IF SWRB = 1
              IF FAT-VALUT = ZERO OR COMEURO  DIVIDE 10 INTO COMBOL
              END-IF
              GO TO EX-RTRAT.
           IF COMBOL = OLDBOL
              IF FAT-VALUT = ZERO OR COMEURO  DIVIDE 10 INTO COMBOL
              END-IF
              COMPUTE TOTBOL = TOTBOL + COMBOL
              GO TO LPTRA1.
           MOVE FAT-IMPOR (K) TO COMX.
           IF FAT-VALUT = ZERO OR COMEURO  MULTIPLY 10 BY COMX.
           ADD COMBOL TO COMX.
           GO TO LPEF1.
       EX-RTRAT.
           EXIT.
      *------------------*
       CALC-SC-DIFF.
           MOVE ZERO TO IF-TOTSCA
                        IF-TOTSCAV.
           MOVE 1 TO K.
           PERFORM UNTIL K > 12
              ADD IF-SC-IMRATA(K) TO IF-TOTSCA
              ADD IF-SC-VALRAT(K) TO IF-TOTSCAV
              ADD 1 TO K
           END-PERFORM.
      *
           COMPUTE IF-DIFSCA  = FAT-TOTFT  - IF-TOTSCA.
      *
           MOVE ZERO TO IF-DIFSCAV.
           IF NOT (FAT-VALUT = ZERO OR COMEURO) 
              COMPUTE IF-DIFSCAV  = FAT-TOVAL  - IF-TOTSCAV.
      *
      * sottraggo acconto
           IF NOT (FAT-VALUT = ZERO OR COMEURO)
              COMPUTE IF-DIFSCAV  = IF-DIFSCAV - IF-TOTACC
      *
              MOVE IF-TOTACC TO PSCA-TOTACV
              MOVE IF-TOTACC TO ER-IMPORTO
              MOVE FAT-VALUT TO ER-VALUT
              MOVE FAT-CADOC TO ER-CAMBIO
              CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT
                                  ER-CAMBIO
              COMPUTE IF-DIFSCA  = IF-DIFSCA - ER-IMPORTO
           ELSE
              COMPUTE IF-DIFSCA  = IF-DIFSCA - IF-TOTACC.
       EX-CALC-SC-DIFF.
           EXIT.
      *------------------
       GEN-SCAD.
           MOVE ZERO      TO PARPSCA.
           MOVE FAT-DATA  TO PSCA-DATDOC.
           CALL 'rdbfa' USING FAT-CATT KEYFT PARRB.
      *
           MOVE KFT-AZI    TO KBC-AZI.
           MOVE RB-TNUM(1) TO KBC-NUM.
           MOVE RB-NBOL(1) TO KBC-BOL.
           READ BOLCTE INVALID MOVE ZERO TO BCT-DATA.
      *
           MOVE BCT-DATA  TO PSCA-1SCAD.
           IF IF-FLSC1 = 1 MOVE COMSCAD1 TO PSCA-1SCAD.
      *
           MOVE IF-CPAG    TO PSCA-CDPAG.
           MOVE CLF-GSFM   TO PSCA-GSFM.
           MOVE CLF-GSESC  TO PSCA-GSESC.
      *
           MOVE FAT-TOTFT  TO PSCA-TOTDOC.
           MOVE IF-TOTACC  TO PSCA-TOTACC.
           MOVE FAT-TOVAL  TO PSCA-TOTDCV.
           MOVE ZERO       TO PSCA-TOTIVV.
           MOVE ZERO       TO PSCA-TOTACV.
           IF NOT (FAT-VALUT = ZERO OR COMEURO)
              MOVE IF-TOTACC TO PSCA-TOTACV
              MOVE IF-TOTACC TO ER-IMPORTO
              MOVE FAT-VALUT TO ER-VALUT
              MOVE FAT-CADOC TO ER-CAMBIO
              CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT
                                  ER-CAMBIO
              MOVE ER-IMPORTO TO PSCA-TOTACC.
      *
           MOVE KAZ-COD TO RACF-AZI.
           MOVE KCF-COD TO RACF-COD.
           CALL 'rrdacf' USING PARACF.
      *
           CALL 'vrcscad' USING PARPSCA PARACF.
      *
           MOVE ZERO TO K.
           PERFORM UNTIL K = 12
              ADD 1 TO K
              MOVE PSCA-TPAG(K)  TO IF-SC-TPAG(K)
              MOVE PSCA-DTSCA(K) TO IF-SC-DTSCA(K)
              MOVE PSCA-RATA(K)  TO IF-SC-IMRATA(K)
              MOVE PSCA-RATAV(K) TO IF-SC-VALRAT(K).
      *    
       EX-GEN-SCAD.
           EXIT.
      *------------------
