       IDENTIFICATION DIVISION.
       PROGRAM-ID. VFAT190.
      *
      * OGGETTO   :   Routine di calcolo fattura ed effetti
      *
      **** rel 5.0
      * Ricompilato per variazione tracciato EFFETT
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griclfsl'.
           COPY 'gribctsl'.
           COPY 'gribcrsl'.
      **** rel 2.0
           COPY 'gripbrsl'.
      ************
           COPY 'grifatsl'.
           COPY 'grieffsl'.
           COPY 'gristasl'.
      **** rel 1.2
      *    COPY 'gricggsl'.
           COPY 'gribfasl'.
      ************
           COPY 'gritabsl'.
      **** rel 5.0
           COPY 'griaimsl'.
           COPY 'griwsisl'.
      ************
      **** rel 7.1
           COPY 'griactsl'.
           COPY 'griaftsl'.
      ************
      **** rel 6.2
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLAV STATUS SF-LAV.
      ************
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'griclf'.
           COPY 'gribct'.
           COPY 'gribcr'.
      **** rel 2.0
           COPY 'gripbr'.
      ************
           COPY 'grifat'.
           COPY 'grieff'.
           COPY 'grista'.
           COPY 'gritab'.
      **** rel 1.2
      *    COPY 'gricgg'.
           COPY 'gribfa'.
      ************
      **** rel 5.0
           COPY 'griaim'.
           COPY 'griwsi'.
      ************
      **** rel 7.1
           COPY 'griact'.
           COPY 'griaft'.
      ************
      **** rel 6.2
       FD  WDSLAV LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LAV
           RECORD 2005 DATA RECORD RF-LAV.
       01  RF-LAV.
           02 KEYLAV.
             05 KLAV-CONTA PIC 9(5).
           02 LAV-PARFAT  PIC X(1000).
           02 LAV-PARRB   PIC X(1000).
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'parzf'.
           COPY 'gritabrk'.
           COPY 'grit35rk'.
           COPY 'griazirk'.
           COPY 'griclfrk'.
           COPY 'parcdt'.
           COPY 'rekt23'.
           COPY 'parmag'.
      **** rel 1.2
           COPY 'parer'.
           COPY 'parlk'.
      ************
      **** rel 5.1
           COPY 'parrd'.
      ************
      **** rel 6.0
           COPY 'paracf'.
      ************
      **** rel 6.1
           COPY 'parppar'.
      ************
      **** rel 6.2
           COPY 'parpf'.
      ************
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-BCT PIC X(15) VALUE 'bolcte'.
       01  ID-BCR PIC X(15) VALUE 'bolcri'.
      **** rel 2.0
       01  ID-PBR PIC X(15) VALUE 'probcr'.
      ************
       01  ID-EFF PIC X(15) VALUE 'effett'.
       01  ID-STA PIC X(15) VALUE 'statis'.
      **** rel 1.2
      *01  ID-CGG PIC X(15) VALUE 'camgio'.
       01  ID-BFA PIC X(15) VALUE 'bolfat'.
      ************
      **** rel 7.1
       01  ID-ACT PIC X(15) VALUE 'appbct'.
       01  ID-AFT PIC X(15) VALUE 'appfat'.
      ************
      **** rel 5.0
       01  ID-AIM PIC X(15) VALUE 'anaimb'.
       01  ID-WSI PIC X(15).
      ************
       01  ID-FAT.
           05 FILLER PIC X(6) VALUE 'fattur'.
           05 FATTIV PIC X    VALUE SPACE.
           05 FILLER PIC X(8) VALUE SPACE.
      **** rel 6.2
       01  ID-LAV PIC X(15) VALUE SPACE.
      ************
       01  COMODI.
           05 SF-TAB  PIC XX.
           05 SF-AZI  PIC XX.
           05 SF-CLF  PIC XX.
           05 SF-BCT  PIC XX.
           05 SF-BCR  PIC XX.
      **** rel 2.0
           05 SF-PBR  PIC XX.
      ************
           05 SF-FAT  PIC XX.
           05 SF-EFF  PIC XX.
           05 SF-STA  PIC XX.
      **** rel 1.2
      *    05 SF-CGG  PIC XX.
           05 SF-BFA  PIC XX.
      ************
      **** rel 7.1
           05 SF-ACT  PIC XX.
           05 SF-AFT  PIC XX.
      ************
      **** rel 5.0
           05 SF-AIM  PIC XX.
           05 SF-WSI  PIC XX.
      ************
      **** rel 6.2
           05 SF-LAV  PIC XX.
      ************
           05 MESS    PIC X(40) VALUE SPACE.
           05 OLDNETRG PIC S9(11).
      **** rel 4.0
      *    05 PREZ0   PIC S9(13) VALUE ZERO.
      *    05 PREZ2   REDEFINES PREZ0 PIC S9(11)V99.
      ************
           05 ESIVA   PIC 999 VALUE ZERO.
           05 VALUT   PIC 999 VALUE ZERO.
      **** rel 1.2
      *    05 COEFF   PIC 9(4)V9(3) VALUE ZERO.
      ************
           05 NUMEFF  PIC 9(5) VALUE ZERO.
           05 NUMFAT  PIC 9(5) VALUE ZERO.
           05 NUMSOS  PIC 9(5) VALUE ZERO.
           05 IVACAU  PIC 9(5) VALUE ZERO.
           05 ZERPK   PIC 9(5) COMP-3 VALUE ZERO.
           05 SCONTO  PIC 999V99 VALUE ZERO.
           05 CODCLI.
              10 MAS PIC 99.
              10 COD PIC 9(5).
           05 CPAG   PIC 999 VALUE ZERO.
           05 IVABAN PIC 9(3) VALUE ZERO.
           05 DTFAT  PIC 9(5) COMP-3 VALUE ZERO.
           05 PRZNT  PIC S9(9) VALUE ZERO.
           05 PREZZ  PIC S9(9) VALUE ZERO.
           05 COMPRZ PIC S9(12) VALUE ZERO.
           05 IND    PIC 99 VALUE ZERO.
           05 COMORD PIC 9(5) VALUE ZERO.
           05 DATSCA PIC 9(6) VALUE ZERO.
           05 COMA   PIC S9(11) VALUE ZERO.
      **** rel 4.0
      *    05 COMAV1 REDEFINES COMA PIC S9(10)V9.
      *    05 COMAV2 REDEFINES COMA PIC S9(9)V99.
      *    05 COMAV3 REDEFINES COMA PIC S9(8)V999.
      *    05 COMAV4 REDEFINES COMA PIC S9(7)V9999.
      ************
           05 QUANT  PIC S9(9) VALUE ZERO.
           05 COMIVA PIC 9(3) VALUE ZERO.
           05 COMX   PIC S9(11) VALUE ZERO.
           05 COMXR  REDEFINES COMX.
              10 FILLER PIC 9(8).
              10 ULT3   PIC 9(3).
      **** rel 4.0
      *    05 COMB   PIC S9(13)V99 VALUE ZERO.
      *    05 COM99  PIC 9V99 VALUE 0,99.
      *    05 M1     PIC S9 VALUE -1.
           05 COMB0  PIC S9(13)    VALUE ZERO.
      ************
           05 COMFAT PIC S9(11) VALUE ZERO.
           05 TOTACC PIC S9(11) VALUE ZERO.
           05 TOTIVA PIC S9(11) VALUE ZERO.
           05 COMR   PIC S9(11) VALUE ZERO.
           05 COMUR  PIC S9(11) VALUE ZERO.
           05 COM1   PIC 9(3) VALUE ZERO.
           05 DTSCA  PIC 9(5) COMP-3 VALUE ZERO.
           05 NUMGG  PIC 9(5) VALUE ZERO.
           05 COMBOL PIC 9(14) VALUE ZERO.
           05 COMBOLR REDEFINES COMBOL.
              10 FILLER PIC 9(12).
              10 ULT2   PIC 99.
           05 COMROT PIC X(25) VALUE SPACE.
           05 SWRB   PIC 9 VALUE ZERO.
           05 TOTBOL PIC S9(11) VALUE ZERO.
      **** rel 5.2
           05 IMPBOL PIC S9(11) VALUE ZERO.
           05 IMPSCA PIC S9(11) VALUE ZERO.
      ************
      **** rel 1.2
      *    05 K      PIC 99 VALUE ZERO.
           05 K      PIC 9(4) VALUE ZERO.
      ************
           05 Z      PIC 99 VALUE ZERO.
           05 IMPCON PIC S9(11) VALUE ZERO.
           05 TNUM   PIC 9    VALUE ZERO.
           05 BOLLA  PIC 9(5) VALUE ZERO.
           05 COMMER PIC S9(11) VALUE ZERO.
           05 GGESC  PIC 99 VALUE 15.
           05 CLAV1  PIC 99.
           05 CLAV2  PIC 99.
           05 SCVEN   PIC S9(11) VALUE ZERO.
           05 VENT    PIC S9(11) VALUE ZERO.
           05 TOTVENT PIC S9(11) VALUE ZERO.
           05 VPRE   PIC S9(11) VALUE ZERO.
      **** rel 4.0
           05 VPRE2  PIC S9(11)V99 VALUE ZERO.
      ************
      **** rel 1.2
      *    05 COMVAL PIC S9(11)V9(4) VALUE ZERO.
      ************
           05 NOSTA   PIC 9     VALUE ZERO.
           05 INVA    PIC 9     VALUE ZERO.
           05 PARAM   PIC X(4).
           05 ATTIV   PIC X.
           05 FLGIS   PIC 9     VALUE ZERO.
           05 CSGR    PIC 9(7)  VALUE ZERO.
           05 IVGR    PIC 9(7)  VALUE ZERO.
           05 SCON    PIC 9(7)  VALUE ZERO.
           05 COMRIV  PIC S9(11) VALUE ZERO.
           05 OMAGGI  PIC S9(11) VALUE ZERO.
           05 IMPRIV  PIC S9(11) OCCURS 6.
           05 OMAGIV  PIC S9(11) OCCURS 6.
           05 SPAGG   PIC S9(11) VALUE ZERO.
           05 SPAGIV  PIC S9(11) OCCURS 6.
           05 SPACON  PIC S9(11) OCCURS 15.
           05 PERCB   PIC 9(3)V99 VALUE ZERO.
           05 OLDBOL  PIC 9(14) VALUE ZERO.
           05 SPARR   PIC S9(11) VALUE ZERO.
           05 SPSRR   PIC S9(11) VALUE ZERO.
           05 SPARIV  PIC S9(11) VALUE ZERO.
           05 SPSGIV  PIC S9(11) VALUE ZERO.
           05 SCONT1  PIC 999V99 VALUE ZERO.
           05 IVRIV   PIC S9(11) OCCURS 6.
           05 ZONA    PIC X(3)   VALUE SPACE.
           05 CAGE    PIC 9(3)   VALUE ZERO.
      **** rel 2.0
           05 SWIMB   PIC 9.
      ************
      **** rel 1.2
      **** rel 4.0
      *    05 DELTA    PIC S9(11).
           05 DELTA    PIC S9(11)V99.
      ************
           05 ETOT1    PIC S9(11)V99.
      **** rel 4.0
      *    05 TOT1     PIC S9(11).
      *    05 TOT2     PIC S9(11).
      *    05 TOT3     PIC S9(11).
      *    05 TOT4     PIC S9(11).
           05 TOT1     PIC S9(11)V99.
      ************
           05 W-EIMPCP PIC S9(11)V99 COMP-3 OCCURS 15.
           05 W-IVRIV  PIC S9(11)V99        OCCURS 6.
      **** rel 2.0
           05 W-OMAGIV PIC S9(11)V99        OCCURS 6.
      ************
      ************
      **** rel 5.0
           05 PREPAL   PIC 9(5).
           05 PRECOL   PIC 9(5).
           05 PREIMB   PIC X(12).
           05 COMNIMB  PIC 9(3).
           05 VETIMB   PIC X(12) OCCURS 30.
           05 VETQTA   PIC 9(5)  OCCURS 30.
           05 INDICE   PIC 999.
           05 ULTIND   PIC 999.
      ************
      **** rel 3.0
           05 SAVCONTR PIC 9(7).
           05 ESTPIVA  PIC 9.
      ************
      **** rel 4.0
           05 COMEURO  PIC 9(3).
      ************
      **** rel 5.0
           05 ADBOL    PIC 9 VALUE ZERO.
      ************
      **** rel 6.0
           05 FLGMCL   PIC 9 VALUE ZERO.
      ************
      **** rel 6.1
           05 COMGG    PIC 99.
           05 TIP      PIC X(3) VALUE 'OLA'.
      * per ritenute
           05 RITE      PIC S9(11)V99 VALUE ZERO.
           05 IMPRIT    PIC S9(11)V99 VALUE ZERO.
           05 COM-ALIVA PIC 9(3)V99   VALUE ZERO.
           05 PBASE     PIC 999V99.
           05 PRACC     PIC 99V99.
           05 COMRR     PIC S9(11)V99 VALUE ZERO.
           05 COMURR    PIC S9(11)V99 VALUE ZERO.
           05 COM1R     PIC 9(3) VALUE ZERO.
      ************
      **** rel 6.2
           05 CONTA    PIC 9(5).
      ************
      **** rel 7.1
           05 COMTIPO  PIC 9.
           05 COMIPA   PIC X(6).
           05 COMCIG   PIC X(10).
           05 COMCUP   PIC X(15).
      ************
      **** rel 7.2
           05 COMFAORD   PIC X(20).
           05 COMFADTORD PIC 9(5).
      ************
       01  SW         PIC 9 VALUE ZERO.
       01  CONT    PIC 999.
       01  TABMESI PIC X(24) VALUE '312831303130313130313031'.
       01  TBMESI  REDEFINES TABMESI.
           05 GIO  PIC 99 OCCURS 12.
       01  RTABRB.
           05 TRB PIC S9(11) OCCURS 6.
       01  RTABBL.
           05 TBL PIC S9(7) OCCURS 6.
       01  RRB1.
           05 TRB1 PIC S9(11) OCCURS 6.
       LINKAGE SECTION.
           COPY 'parcfls'.
      **** rel 1.2
           COPY 'parrb'.
      ************
           COPY 'parfat'.
      *--------------------*
      **** rel 1.2
      *PROCEDURE DIVISION USING PARCFSL CFT-FAT.
       PROCEDURE DIVISION USING PARCFSL PARRB CFT-FAT.
      ************
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclclf'.
           COPY 'dclbct'.
           COPY 'dclbcr'.
      **** rel 2.0
           COPY 'dclpbr'.
      ************
           COPY 'dclfat'.
           COPY 'dcleff'.
           COPY 'dclsta'.
           COPY 'dcltab'.
      **** rel 1.2
      *    COPY 'dclcgg'.
           COPY 'dclbfa'.
      ************
      **** rel 7.1
           COPY 'dclact'.
           COPY 'dclaft'.
      ************
      **** rel 5.0
           COPY 'dclaim'.
           COPY 'dclwsi'.
      ************
      **** rel 6.2
           COPY 'dcllav'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strsub'.
      **** rel 4.0
           CALL 'rveur' USING COMEURO.
      ************
      **** rel 5.0
           IF CF-FL = ZERO MOVE 'tabell' TO ID-TAB
                           MOVE 'anaclf' TO ID-CLF.
           IF CF-FL = 1    MOVE 'tabold' TO ID-TAB
                           MOVE 'anacfx' TO ID-CLF.
      ************
           MOVE CF-ATTIV TO ATTIV FATTIV.
           IF FATTIV = '0' MOVE SPACE TO FATTIV.
           IF ATTIV  = SPACE MOVE '0' TO ATTIV.
           OPEN I-O   ANAAZI.
           OPEN I-O   BOLCTE.
           OPEN I-O   BOLCRI.
           OPEN I-O   FATTUR.
           OPEN I-O   EFFETT.
           OPEN I-O   STATIS.
           OPEN I-O   TABELL.
      **** rel 1.2
      *    OPEN INPUT CAMGIO.
           OPEN I-O   BOLFAT.
      ************
      **** rel 7.1
           OPEN I-O   APPFAT.
           OPEN I-O   APPBCT.
      ************
           OPEN INPUT ANACLF.
      **** rel 2.0
           OPEN INPUT PROBCR.
      ************
      **** rel 5.0
           OPEN INPUT ANAIMB.
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
      ************
      **** rel 6.2
           IF CF-SIMUL = 9 OPEN I-O WDSLAV.
           MOVE ZERO TO CONTA.
      ************
           IF SW NOT = ZERO GO TO LPINIZ.
           MOVE 1 TO SW.
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID KEY
                PERFORM INVK-TAB GO TO WARNING.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MCLI TO MAS.
           MOVE 14 TO KTB-TIP.
           MOVE 1 TO KTB-COD.
           READ TABELL INTO REKTAB INVALID KEY
                PERFORM INVK-TAB
                GO TO WARNING.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T14-IVABL TO IVACAU.
           MOVE T14-IVABA TO IVABAN.
           MOVE 14 TO KTB-TIP.
           MOVE 2 TO KTB-COD.
           READ TABELL INTO REKTAB INVALID KEY
                PERFORM INVK-TAB
                GO TO WARNING.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T14-CSGR TO CSGR.
           MOVE T14-IVGR TO IVGR.
           MOVE T14-SCON TO SCON.
           MOVE 14 TO KTB-TIP.
           MOVE 3 TO KTB-COD.
           READ TABELL INTO REKTAB INVALID KEY
                PERFORM INVK-TAB
                GO TO WARNING.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T14-ALIQ TO PERCB.
      **** rel 5.2
           COMPUTE IMPBOL  = T14-IMBOL * 100.
           COMPUTE IMPSCA  = T14-IMPSC * 100.
      ************
           MOVE ZERO TO K.
       CRBOL.
           ADD 1 TO K.
           IF K > 6 GO TO LPINIZ.
      **** rel 4.0
      *    MOVE T14-IMPS(K) TO TRB1(K) TRB(K).
      *    MOVE T14-IMPB(K) TO TBL(K).
           COMPUTE TRB1(K) = T14-IMPS(K) * 100.
           COMPUTE TRB(K)  = T14-IMPS(K) * 100.
           COMPUTE TBL(K)  = T14-IMPB(K) * 100.
      ************
      **** rel 4.0
      *    IF T14-IMPS(K) = 999999999
           IF T14-IMPS(K) = 9999999,99
      ************
                    MOVE  99999999999 TO TRB1(K) TRB(K)
                    GO TO CRBOL.
           SUBTRACT TBL(K) FROM TRB(K).
           GO TO CRBOL.
       LPINIZ.
           IF CF-VIDEO = 2 GO TO LPINI0.
           MOVE ZERO TO TNUM BOLLA KFT-NUM KFT-TDOC.
           IF CF-VIDEO = 1 MOVE 2 TO CF-VIDEO.
       LPINI0.
           MOVE ZERO      TO CF-ST.
           MOVE CF-AZI    TO KAZ-COD.
      **** rel 4.1a-1
      *    MOVE CF-GGESC  TO GGESC.
           IF CF-GGESC NOT = ZERO
              MOVE CF-GGESC  TO GGESC.
      *************
      **** rel 7.2
       RIPROVA-AZI.
           IF ATTIV = SPACE MOVE '0' TO ATTIV.
           READ ANAAZI INTO REKAZI KEPT LOCK INVALID KEY
                PERFORM INVK-AZI GO TO WARNING.
           IF SF-AZI NOT = ZERO
              PERFORM REC-LOCK
              GO TO RIPROVA-AZI.
      ************
           MOVE CF-DTFAT  TO DTFAT.
           MOVE CF-NUMFAT TO NUMFAT.
           MOVE ZERO      TO CF-ST.
           IF CF-SIMUL NOT = ZERO MOVE ZERO TO NUMFAT
                                         GO TO LPINI9.
           PERFORM Z00-RD-NUM THRU Z99.
       LPINI9.
           MOVE ZERO TO K.
       LOOPVE.
           ADD 1 TO K.
      **** rel 1.2
      *    IF K > 15 GO TO LPFAT1.
      *    IF CF-VTNUM (K) = ZERO GO TO LPFAT1.
      *    MOVE KAZ-COD TO KBC-AZI KCR-AZI.
      *    MOVE CF-VTNUM (K) TO KBC-NUM KCR-NUM TNUM.
      *    MOVE CF-VNBOL (K) TO KBC-BOL KCR-BOL BOLLA.
           IF K > RB-ULTBOL GO TO LPFAT1.
           IF RB-TNUM(K) = ZERO GO TO LPFAT1.
           MOVE KAZ-COD TO KBC-AZI KCR-AZI.
           MOVE RB-TNUM(K) TO KBC-NUM KCR-NUM TNUM.
           MOVE RB-NBOL(K) TO KBC-BOL KCR-BOL BOLLA.
      ************
           READ BOLCTE INVALID PERFORM INVK-BCT GO TO WARNING.
      **** rel 6.3
           MOVE BCT-ZONA TO ZONA.
      ************
           IF K > 1 GO TO RDRIG.
           MOVE BCT-ESIVA TO ESIVA.
      **** rel 6.3
      *    MOVE BCT-ZONA TO ZONA.
      ************
           MOVE BCT-CAGE TO CAGE.
           MOVE BCT-VALUT TO VALUT.
      **** rel 6.1
           MOVE BCT-PBASE TO PBASE.
           MOVE BCT-PRACC TO PRACC.
      ************
      **** rel 1.2
      **** rel 4.0
      *    IF VALUT = ZERO OR 1 MOVE ZERO TO CG-CAMBIO
           IF VALUT = ZERO OR COMEURO  MOVE ZERO TO CG-CAMBIO
      ************
                                       GO TO BT001.
           CALL 'rvalut' USING VALUT DTFAT CG-PAR.
           IF CG-ST > ZERO PERFORM ERR-EURO
                           GO TO WARNING.

      *    IF VALUT = ZERO OR 1 MOVE ZERO TO COEFF
      *                                GO TO BT001.
      *    IF KBC-NUM > 6 MOVE BCT-CAMGG TO COEFF
      *                               GO TO BT001.
      *    MOVE VALUT TO KCG-VAL.
      *    MOVE ZERO TO KCG-GIO.
      *    START CAMGIO KEY NOT < KEYCG INVALID GO TO RDC-20.
      *RDC-10.
      *    READ CAMGIO NEXT AT END GO TO RDC-20.
      *    IF SF-CGG = '9D' OR '9A' OR '35' GO TO RDC-10.
      *    IF KCG-VAL > VALUT GO TO RDC-20.
      *    COMPUTE AAGGG = 99999 - KCG-GIO.
      *    IF AAGGG > DTFAT GO TO RDC-10.
      *    MOVE CGG-CAMBIO TO COEFF.
      *    GO TO BT001.
      *RDC-20.
      *    MOVE 'Errore su cambi' TO MESS.
      *    GO TO WARNING.
      ************
       BT001.
           MOVE BCT-CLI TO COD.
           MOVE KAZ-COD TO KCF-AZI.
           MOVE CODCLI  TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID KEY
                PERFORM INVK-CLF
                PERFORM VISK-BCT
                GO TO WARNING.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
      **** rel 6.0
           MOVE KAZ-COD    TO RACF-AZI.
           MOVE CODCLI     TO RACF-COD.
           CALL 'rrdacf' USING PARACF.
      ************
           PERFORM RAZFAT THRU EX-RAZFAT.
           PERFORM CARFAT THRU EX-CARFAT.
       RDRIG.
      **** rel 2.0
           MOVE ZERO TO SWIMB.
      ************
           MOVE ZERO TO COMMER.
      **** rel 4.0
      *    ADD BCT-ACCON TO TOTACC.
           IF VALUT = 1
              ADD BCT-ACCON TO TOTACC
           ELSE
              COMPUTE TOTACC = TOTACC + (BCT-ACCON * 100).
      ************
      **** rel 1.2
      *    MOVE KBC-BOL TO CFT-NBOL (K).
      *    MOVE KBC-NUM TO CFT-TNUM (K).
      ************
           MOVE ZERO TO KCR-PGR.
           START BOLCRI KEY NOT < KEYCR INVALID GO TO CALCIVA.
       BCNEXT.
           READ BOLCRI NEXT AT END GO TO CALCIVA.
           IF SF-BCR = '9D' OR '9A' OR '35' GO TO BCNEXT.
           IF KCR-AZI NOT = KBC-AZI GO TO CALCIVA.
           IF KCR-NUM NOT = KBC-NUM GO TO CALCIVA.
           IF KCR-BOL NOT = KBC-BOL GO TO CALCIVA.
      **** rel 2.0
           IF BCT-IMB = 1 AND SWIMB = ZERO
      **** rel 3.0
      *       PERFORM SOMMA-IMBALLI THRU EX-SOMMA-IMBALLI.
              MOVE BCR-CONTR TO SAVCONTR
      **** rel 5.0
              PERFORM WR-LAV-IMB THRU EX-WR-LAV-IMB
      ************
              PERFORM SOMMA-IMBALLI THRU EX-SOMMA-IMBALLI
      **** rel 5.0
              PERFORM ADDEBITA-IMBALLI THRU EX-ADDEBITA-IMBALLI
      ************
              MOVE SAVCONTR TO BCR-CONTR.
      ************
      ************
      **** rel 4.0
      *    IF VALUT > 1
      *       COMPUTE OLDNETRG = BCR-NETRG * 100
      *    ELSE
      *       MOVE BCR-NETRG TO OLDNETRG.
           IF VALUT = 1
              MOVE BCR-NETRG TO OLDNETRG
           ELSE
              COMPUTE OLDNETRG = BCR-NETRG * 100.
      ************
           MOVE ZERO TO SPAGG SPARR SPSRR.
           IF BCR-TCOR = 3 PERFORM A00-SPESA-AGG THRU A99
                           PERFORM RCONT THRU EX-RCONT.
           IF BCR-TCOR = 1  GO TO BCNEXT.
           IF BCR-TCOR = 6
             IF CFT-TDOC = 2 GO TO SOTTO
                        ELSE GO TO BCNEXT.
           IF BCR-TCOR = 4 ADD OLDNETRG TO CFT-OMAGG.
           IF BCR-TCOR = 5 ADD OLDNETRG TO CFT-SCONT.
           IF BCR-TCOR = ZERO OR BCR-TCOR = 2
               ADD OLDNETRG TO CFT-NTMER
               ADD OLDNETRG TO COMMER
           PERFORM RCONT THRU EX-RCONT.
           IF NOT (BCR-TCOR = 4 OR 5) MOVE ZERO TO OMAGGI
                                             GO TO BCN-00.
           MOVE OLDNETRG TO OMAGGI.
           MOVE ZERO TO COMA.
           MOVE 3 TO KTB-TIP.
           MOVE BCR-RIVGR TO KTB-COD COMIVA.
           READ TABELL INTO REKTAB INVALID
                PERFORM INVK-TAB
                PERFORM VISK-BCR
                GO TO WARNING.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T03-ALIVA = ZERO GO TO ALTRO-00.
           IF ESIVA NOT = ZERO
               MOVE ESIVA TO COMIVA
               ELSE MOVE BCR-RIVGR TO COMIVA.
           GO TO ALTRO-00.
       BCN-00.
           IF BCR-TCOR NOT = 3 GO TO SOTTO.
           MOVE 11 TO KTB-TIP.
           MOVE BCR-SPESA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM INVK-TAB
                PERFORM VISK-BCR
                GO TO WARNING.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF BCR-IVA = ZERO
                        ADD SPARR TO SPARIV
                        ADD SPSRR TO SPSGIV
                        GO TO BCNEXT
                     ELSE
                        MOVE BCR-IVA TO T11-CIVA.
           IF ESIVA = ZERO GO TO SOTTO.
           MOVE 3 TO KTB-TIP.
           MOVE T11-CIVA TO KTB-COD COMIVA.
           READ TABELL INTO REKTAB INVALID
                PERFORM INVK-TAB
                PERFORM VISK-BCR
                GO TO WARNING.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T03-ALIVA = ZERO GO TO ALTRO.
       SOTTO.
           IF ESIVA NOT = ZERO
               MOVE ESIVA TO COMIVA
               ELSE MOVE BCR-IVA TO COMIVA.
       ALTRO.
           MOVE OLDNETRG TO COMA VPRE.
           IF BCR-TCOR = 6 MOVE ZERO TO COMA VPRE.
       ALTRO-00.
           MOVE ZERO TO COMRIV.
           IF BCR-TCOR = 4 AND BCR-RIVAL = 1
              AND IVGR > ZERO AND ESIVA = ZERO
                          MOVE OLDNETRG TO COMRIV.
           PERFORM RIVA THRU EX-RIVA.
           IF NOT (BCR-TCOR = ZERO OR BCR-TCOR = 4
                                   OR BCR-TCOR = 5)
                                      GO TO BCNEXT.
           IF BCR-ART = SPACE GO TO BCNEXT.
           IF BCR-TCOR = 4 OR BCR-TCOR = 5 MOVE ZERO TO VPRE.
           IF NOSTA = ZERO
                   IF CF-SIMUL = ZERO OR 2
                      PERFORM STATISTI THRU EX-STATISTI.
           GO TO BCNEXT.
       CALCIVA.
           PERFORM IVACAL THRU EX-IVACAL.
           GO TO LOOPVE.
       LPFAT1.
           IF K NOT = ZERO  PERFORM FINEFT THRU EX-FINEFT.
           IF CF-SIMUL NOT = ZERO  GO TO CHIUDI.
           IF CF-NUMFAT NOT = ZERO GO TO LPFAT2.
           IF AZI-FLGIS NOT = 1 GO TO LPFAT1-1.
           MOVE 23 TO T23-TIP.
           MOVE KAZ-COD TO T23-COD.
           MOVE T23-KEYID TO KEYTB.
           READ TABELL INTO REKT23 INVALID KEY
                PERFORM INVK-TAB
                GO TO WARNING.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT23.
           MOVE NUMSOS TO T23-FTSOS.
           REWRITE RF-TAB FROM REKT23 INVALID KEY
                   PERFORM INVK-TAB
                   GO TO WARNING.
       LPFAT1-1.
           IF ATTIV = '0' MOVE NUMFAT TO AZI-NUMFT GO TO LPFAT2.
           MOVE 35 TO T35-TIP.
           MOVE KAZ-COD TO T35-CDAZ.
           MOVE ATTIV TO T35-CATT.
           MOVE T35-KEYID TO KEYTB.
           READ TABELL INTO REKT35 INVALID KEY
                PERFORM INVK-TAB
                GO TO WARNING.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT35.
           MOVE NUMFAT TO T35-NUMFT.
           REWRITE RF-TAB FROM REKT35 INVALID KEY
                   PERFORM INVK-TAB
                   GO TO WARNING.
       LPFAT2.
           MOVE NUMEFF TO AZI-NEFF.
           REWRITE RF-AZI FROM REKAZI INVALID
                   PERFORM INVK-AZI
                   GO TO WARNING.
           UNLOCK ANAAZI.
           PERFORM V00-AGG-BOL THRU V99.
      **** rel 4.0
      *    IF CFT-VALUT > 1 PERFORM D00-AGG-MAG THRU D99.
           IF NOT (CFT-VALUT = ZERO OR COMEURO)
              PERFORM D00-AGG-MAG THRU D99.
      ************
           GO TO CHIUDI.
      *--------------------*
       RAZFAT.
           MOVE ZERO     TO CFT-FAT KEYFT.
           MOVE KAZ-COD  TO CFT-AZI KFT-AZI.
           MOVE BCT-TDOC TO CFT-TDOC KFT-TDOC.
           IF AZI-FLGIS = ZERO MOVE ZERO      TO FLGIS
                          ELSE MOVE BCT-FLGIS TO FLGIS.
           IF FLGIS = ZERO GO TO RAZF-05.
           ADD 3 TO KFT-TDOC CFT-TDOC.
           IF CF-NUMFAT > ZERO GO TO RAZF-05.
           IF AZI-FLGIS = 1 ADD 1 TO NUMSOS
                            MOVE NUMSOS TO CFT-NUM KFT-NUM
                            GO TO RAZF-10.
           ADD 1 TO NUMFAT.
           MOVE NUMFAT TO CFT-NUM KFT-NUM.
           GO TO RAZF-10.
       RAZF-05.
           IF CF-NUMFAT = ZERO ADD 1 TO NUMFAT.
           MOVE NUMFAT TO CFT-NUM KFT-NUM.
       RAZF-10.
           IF CF-SIMUL NOT = ZERO MOVE ZERO TO CFT-NUM KFT-NUM.
           IF CF-SIMUL = 2 MOVE CF-NUMFAT TO KFT-NUM.
           IF CF-SIMUL = 2 MOVE ZERO TO KFT-NUM.
           IF CF-SIMUL NOT = ZERO GO TO RAZF-25.
           READ FATTUR INVALID KEY GO TO RAZF-25.
           MOVE 'Fattura gia'' esistente' TO MESS.
           GO TO WARNING.
       RAZF-25.
           MOVE ZERO TO CFT-DATA CFT-DTPAG CFT-NTMER
              CFT-SPBAN CFT-SCFIN CFT-STATU
              CFT-TOTFT CFT-SPBOL CFT-SCBAS CFT-CDAGE
              CFT-OMAGG CFT-SCONT CFT-IVRIV SPAGG SPARR
              SPARIV SPSGIV
              CFT-CDESE CFT-TIPAG CFT-CDBAN CFT-CDPAG CFT-CDCLI
              CFT-FLGPR CFT-FIL.
      **** rel 1.2
           MOVE ZERO TO CFT-ENTMER CFT-EIVRIV CFT-ESPBOL CFT-ESPBAN
                        CFT-ESCFIN CFT-EOMAGG CFT-ESCONT CFT-ECONV.
      ************
           MOVE ZERO TO CFT-TOVAL CFT-VALUT CFT-CADOC.
           MOVE ZERO TO TOTACC TOTIVA.
           MOVE ZERO TO IND.
       RAZF-30.
           ADD 1 TO IND.
           IF IND > 15 GO TO EX-RAZFAT.
           MOVE ZERO TO CFT-CPART (IND) CFT-IMPCP (IND).
      **** rel 1.2
      *    MOVE ZERO TO CFT-TNUM (IND) CFT-NBOL (IND).
      ************
           MOVE ZERO TO SPACON (IND).
      **** rel 1.2
      *    IF IND > 6 GO TO RAZF-30.
      *    MOVE ZERO TO CFT-CDIVA (IND) CFT-IMPON (IND) CFT-IMPOS (IND)
      *                 CFT-DTSCA (IND) CFT-IMPOR (IND).
           IF IND > 6 GO TO RAZF-40.
           MOVE ZERO TO CFT-CDIVA (IND) CFT-IMPON (IND) CFT-IMPOS (IND).
           MOVE ZERO TO CFT-EIMPON(IND) CFT-EIMPOS(IND).
      ************
           MOVE ZERO TO IMPRIV (IND) OMAGIV (IND) SPAGIV (IND).
           MOVE ZERO TO IVRIV (IND).
      **** rel 1.2
       RAZF-40.
           IF IND > 12 GO TO RAZF-30.
           MOVE ZERO TO CFT-EIMPOR(IND)
                        CFT-DTSCA (IND)
                        CFT-IMPOR (IND).
      ************
           GO TO RAZF-30.
       EX-RAZFAT.
           EXIT.
      *------------------*
       RIVA.
           MOVE ZERO TO IND.
       LPIVA1.
           ADD 1 TO IND.
           IF IND > 6 GO TO LPIVA6.
           IF CFT-CDIVA (IND) = ZERO
              MOVE COMIVA TO CFT-CDIVA (IND)
              MOVE COMA TO CFT-IMPON (IND)
              MOVE COMRIV TO IMPRIV (IND)
              MOVE OMAGGI TO OMAGIV (IND)
              MOVE SPAGG  TO SPAGIV (IND)
              MOVE ZERO TO COMRIV OMAGGI
              GO TO EX-RIVA.
           IF COMIVA = CFT-CDIVA (IND)
              MOVE CFT-IMPON (IND) TO COMPRZ
              ADD COMA TO COMPRZ
              MOVE COMPRZ TO CFT-IMPON (IND)
              ADD COMRIV TO IMPRIV (IND)
              ADD OMAGGI TO OMAGIV (IND)
              ADD SPAGG  TO SPAGIV (IND)
              MOVE ZERO TO COMRIV OMAGGI
              GO TO EX-RIVA.
           GO TO LPIVA1.
       LPIVA6.
           MOVE 6 TO IND.
           MOVE CFT-IMPON (IND) TO COMPRZ.
           ADD COMA TO COMPRZ.
           MOVE COMPRZ TO CFT-IMPON (IND).
           ADD COMRIV TO IMPRIV (IND).
           ADD OMAGGI TO OMAGIV (IND).
           ADD SPAGG  TO SPAGIV (IND).
           MOVE ZERO TO COMRIV OMAGGI.
       EX-RIVA.
           EXIT.
      *------------------*
       CARFAT.
           MOVE KAZ-COD TO CFT-AZI.
           MOVE BCT-CLI TO CFT-CDCLI.
           MOVE BCT-VALUT TO CFT-VALUT.
      **** rel 1.2
      *    MOVE COEFF TO CFT-CADOC.
           MOVE CG-CAMBIO TO CFT-CADOC.
      ************
           MOVE DTFAT TO CFT-DATA.
           MOVE BCT-CBAN TO CFT-CDBAN.
           MOVE BCT-CPAG TO CFT-CDPAG.
           MOVE 4 TO KTB-TIP.
           MOVE BCT-CPAG TO KTB-COD CPAG.
           READ TABELL INTO REKTAB INVALID KEY
                PERFORM INVK-TAB
                PERFORM VISK-BCT
                GO TO WARNING.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T04-SCASS TO SCONTO.
           MOVE T04-TIPAG TO CFT-TIPAG.
           MOVE BCT-DATA TO CFT-DTPAG.
           IF T04-1SCAD NOT = 5 GO TO CAR1.
           IF CF-SIMUL = 2
              MOVE CF-DTFAT  TO CFT-DTPAG
           ELSE
              MOVE CF-DT1SCA TO CFT-DTPAG.
       CAR1.
           MOVE BCT-ESIVA TO CFT-CDESE.
           MOVE BCT-CAGE TO CFT-CDAGE.
           MOVE BCT-SCBAS TO CFT-SCBAS.
      **** rel 7.1
           MOVE KBC-AZI TO KACT-AZI.
           MOVE KBC-NUM TO KACT-NUM.
           MOVE KBC-BOL TO KACT-BOL.
           READ APPBCT INVALID 
                MOVE ZERO TO ACT-TIPO
                MOVE SPACE TO ACT-IPA ACT-CIG ACT-CUP.
           MOVE ACT-TIPO TO COMTIPO.
           MOVE ACT-IPA  TO COMIPA.
           MOVE ACT-CIG  TO COMCIG.
           MOVE ACT-CUP  TO COMCUP.
           MOVE ACT-FAORD   TO COMFAORD.
           MOVE ACT-FADTORD TO COMFADTORD.
      ************
       EX-CARFAT.
           EXIT.
      *-------------------*
       IVACAL.
           MOVE 3 TO KTB-TIP.
           MOVE ZERO TO IND.
       LPIMPS.
           ADD 1 TO IND.
           IF IND > 6 GO TO EX-IVACAL.
           IF CFT-CDIVA (IND) = ZERO GO TO EX-IVACAL.
           MOVE CFT-CDIVA (IND) TO KTB-COD.
           READ TABELL INTO REKTAB INVALID KEY
                PERFORM INVK-TAB
                GO TO WARNING.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE CFT-IMPON (IND) TO COMA.
      **** rel 4.0
      *    COMPUTE COMB = (COMA * T03-ALIVA) / 100.
      *    IF COMA < ZERO
      *            COMPUTE COMB = COMB - COM99
      *            ELSE
      *    COMPUTE COMB = COMB + COM99.
      *    MOVE COMB TO CFT-IMPOS (IND).
           COMPUTE ER-IMPORTO = CFT-IMPON(IND) / 100.
           MOVE CFT-VALUT TO ER-VALUT.
           CALL 're2iva' USING ER-IMPORTO ER-VALUT T03-ALIVA.
           COMPUTE COMB0 = ER-IMPORTO * 100.
           MOVE COMB0 TO CFT-IMPOS (IND).
      ************
           IF IMPRIV (IND) = ZERO GO TO LPIMPS.
           MOVE IMPRIV (IND) TO COMA.
      **** rel 4.0
      *    COMPUTE COMB = (COMA * T03-ALIVA) / 100.
      *    IF COMA < ZERO
      *            COMPUTE COMB = COMB - COM99
      *            ELSE
      *    COMPUTE COMB = COMB + COM99.
      *    MOVE COMB TO IVRIV (IND).
           COMPUTE ER-IMPORTO = IMPRIV (IND) / 100.
           MOVE CFT-VALUT TO ER-VALUT.
           CALL 're2iva' USING ER-IMPORTO ER-VALUT T03-ALIVA.
           COMPUTE COMB0 = ER-IMPORTO * 100.
           MOVE COMB0 TO IVRIV (IND).
      ************
           GO TO LPIMPS.
       EX-IVACAL.
           EXIT.
      *-------------------*
       RSCAD.
           IF T04-1SCAD < 3  MOVE CFT-DATA TO DTSCA
                            ELSE MOVE CFT-DTPAG TO DTSCA.
           IF T04-1SCAD NOT = ZERO GO TO RCAL1.
       FORSE0.
           MOVE 20 TO NUMGG.
           CALL 'radd30' USING DTSCA NUMGG.
       RCAL1.
           PERFORM RCALR THRU EX-RCALR.
           MOVE ZERO TO IND.
       LOOPR1.
           ADD 1 TO IND.
           IF IND > T04-NRATE GO TO FINEL1.
           IF CFT-IMPOR (IND) = ZERO GO TO FINEL1.
           IF T04-FLGIVA = ZERO OR 2
              IF IND = 1 MOVE T04-NG1SC TO NUMGG
              ELSE       MOVE T04-NGSSC TO NUMGG.
           IF T04-FLGIVA = 1
              IF IND = 1 MOVE T04-NGIVA TO NUMGG
              ELSE IF IND = 2 MOVE T04-NG1SC TO NUMGG
                      IF T04-1SCAD < 3 MOVE CFT-DATA TO DTSCA
                      ELSE MOVE CFT-DTPAG TO DTSCA
                   ELSE MOVE T04-NGSSC TO NUMGG.
           CALL 'radd30' USING DTSCA NUMGG.
           MOVE DTSCA TO CFT-DTSCA (IND).
           GO TO LOOPR1.
       FINEL1.
           MOVE ZERO TO IND.
       LOOPR2.
           ADD 1 TO IND.
           IF IND > T04-NRATE GO TO FINEL2.
           IF CFT-DTSCA (IND) = ZERPK GO TO FINEL2.
           IF CFT-IMPOR (IND) = ZERO GO TO FINEL2.
           IF T04-1SCAD = 2 OR T04-1SCAD = 4 GO TO XCONT.
           GO TO FINEL2.
       XCONT.
           MOVE CFT-DTSCA (IND) TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           DIVIDE AA9 BY 4 GIVING CLAV1 REMAINDER CLAV2.
           IF CLAV2 = ZERO      MOVE 29 TO GIO(2)
                           ELSE MOVE 28 TO GIO(2).
           MOVE GIO(MM9) TO GG9.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO CFT-DTSCA (IND).
           GO TO LOOPR2.
       FINEL2.
      **** rel 5.0
      **** rel 5.0-2
      *    IF CLF-GSFM NOT = ZERO PERFORM SOMMA-GG THRU EX-SOMMA-GG.
           IF CLF-GSFM  NOT = ZERO OR
              CLF-GSESC NOT = ZERO
              PERFORM SOMMA-GG THRU EX-SOMMA-GG.
      **************
      ************
      **** rel 6.0
      *    IF T04-ESCMM = ZERO GO TO EX-RSCAD.
           MOVE ZERO TO FLGMCL.
           MOVE 1 TO K.
       VPG.
           IF K > 12 GO TO VPG1.
           IF RACF-ESCM(K) = ZERO
              ADD 1 TO K
              GO TO VPG.
           MOVE 1 TO FLGMCL.
           GO TO VPG4.
      *
       VPG1.
           MOVE 1 TO K.
       VPG2.
           IF K > 12 GO TO VPG3.
           IF T04-ESCM(K) = ZERO
              ADD 1 TO K
              GO TO VPG2.
           GO TO VPG4.
       VPG3.
           GO TO EX-RSCAD.
       VPG4.
      ************
           MOVE ZERO TO IND.
       LOOPR3.
           ADD 1 TO IND.
           IF IND > T04-NRATE GO TO EX-RSCAD.
           IF CFT-IMPOR (IND) = ZERO GO TO EX-RSCAD.
      **** rel 6.1
      * se data in input
           IF CFT-DTSCA (IND) = ZERO GO TO LOOPR3.
      ************
           MOVE CFT-DTSCA (IND) TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
      **** rel 6.0
      *    IF MM9 NOT = 8 GO TO FORI2.
      *    IF T04-ESCMM = 1 OR T04-ESCMM = 3 GO TO LPMOV.
           IF (FLGMCL = 1 AND RACF-ESCM(MM9) = 1) OR
              (FLGMCL = ZERO AND T04-ESCM(MM9) = 1)
                 GO TO LPMOV.
      ************
           GO TO LOOPR3.
       LPMOV.
      **** rel 2.0
      *    MOVE GGESC TO GG9.
           IF CLF-GSESC NOT = ZERO
              MOVE CLF-GSESC TO GG9
           ELSE
              MOVE GGESC TO GG9.
      ************
           IF GG9 > 30 MOVE 30 TO GG9.
      **** rel 6.0
      *    MOVE 9 TO MM9.
      *    GO TO XDATA.
      *FORI2.
      *    IF MM9 NOT = 12 GO TO LOOPR3.
      *    IF T04-ESCMM = 2 GO TO LPMOV1.
      *    IF T04-ESCMM = 3 GO TO LPMOV1.
      *    GO TO LOOPR3.
      ************
       LPMOV1.
      **** rel 2.0
      *    MOVE GGESC TO GG9.
      **** rel 6.0
      *    IF CLF-GSESC NOT = ZERO
      *       MOVE CLF-GSESC TO GG9
      *    ELSE
      *       MOVE GGESC TO GG9.
      ************
      ************
      **** rel 6.0
      *    MOVE 1 TO MM9.
      *    ADD 1 TO AA9.
      *XDATA.
           IF MM9 = 12
              MOVE 1 TO MM9
              ADD 1  TO AA9
           ELSE
              ADD 1 TO MM9.

           IF (FLGMCL = 1 AND RACF-ESCM(MM9) = 1) OR
              (FLGMCL = ZERO AND T04-ESCM(MM9) = 1)
                 GO TO LPMOV1.
      ************
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO CFT-DTSCA (IND).
           GO TO LOOPR3.
       EX-RSCAD.
           EXIT.
      *-------------------*
       RCALR.
           MOVE 4 TO KTB-TIP.
           MOVE CFT-CDPAG TO KTB-COD.
           READ TABELL INTO REKTAB INVALID KEY
                PERFORM INVK-TAB
                GO TO WARNING.
      **** rel 7.2
          IF FLGIS NOT = ZERO AND DTFAT >= 42005 
              MOVE ZERO TO T04-FLGIVA.
      ************
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T04-FLGIVA = 1 PERFORM RCALR1 THRU EX-RCALR1
                             GO TO EX-RCALR.
           IF T04-FLGIVA = 2 PERFORM RCALR2 THRU EX-RCALR2
                             GO TO EX-RCALR.
           COMPUTE COMFAT = CFT-TOTFT - TOTACC.
           IF COMFAT < ZERO MOVE ZERO TO COMFAT.
      **** rel 7.2
          IF FLGIS NOT = ZERO AND DTFAT >= 42005 
              SUBTRACT TOTIVA FROM COMFAT.
      ************
           COMPUTE COMR = COMFAT / T04-NRATE.
           COMPUTE COM1 = T04-NRATE - 1.
           COMPUTE COMUR = COMFAT - (COMR * COM1).
           MOVE ZERO TO IND.
       LCALR.
           ADD 1 TO IND.
           IF IND > T04-NRATE GO TO EX-RCALR.
           MOVE COMUR TO CFT-IMPOR (IND).
           IF IND < T04-NRATE
               MOVE COMR TO CFT-IMPOR (IND).
           GO TO LCALR.
       EX-RCALR.
           EXIT.
      *------------------*
       RCALR1.
           COMPUTE COMFAT = CFT-TOTFT - TOTIVA - TOTACC.
           IF COMFAT < ZERO MOVE ZERO TO COMFAT.
           COMPUTE COMR = COMFAT / ( T04-NRATE - 1 ).
           COMPUTE COM1 = T04-NRATE - 2.
           COMPUTE COMUR = COMFAT - (COMR * COM1).
           MOVE ZERO TO IND.
       LCALR1.
           ADD 1 TO IND.
           IF IND > T04-NRATE GO TO EX-RCALR1.
           IF IND = 1 MOVE TOTIVA TO CFT-IMPOR(IND) GO TO LCALR1.
           MOVE COMUR TO CFT-IMPOR (IND).
           IF IND < T04-NRATE
               MOVE COMR TO CFT-IMPOR (IND).
           GO TO LCALR1.
       EX-RCALR1.
           EXIT.
      *------------------*
       RCALR2.
           COMPUTE COMFAT = CFT-TOTFT - TOTIVA - TOTACC.
           IF COMFAT < ZERO MOVE ZERO TO COMFAT.
           COMPUTE COMR = COMFAT / T04-NRATE.
           COMPUTE COM1 = T04-NRATE - 1.
           COMPUTE COMUR = COMFAT - (COMR * COM1).
           MOVE ZERO TO IND.
       LCALR2.
           ADD 1 TO IND.
           IF IND > T04-NRATE GO TO EX-RCALR2.
           IF IND = 1 COMPUTE CFT-IMPOR(1) = COMR + TOTIVA
                              GO TO LCALR2.
           MOVE COMUR TO CFT-IMPOR (IND).
           IF IND < T04-NRATE
               MOVE COMR TO CFT-IMPOR (IND).
           GO TO LCALR2.
       EX-RCALR2.
           EXIT.
      *------------------*
       RTRAT.
      **** rel 2.0
      * rata arrotondata all'unita' di euro superiore
      * importo bollo arrotondato al decimo di euro.
      **** rel 4.0
      *    CALL 'rveur' USING ER-VALUT.
      ************
      ************
           IF SWRB = 1 GO TO LPEFF.
           MOVE ZERO TO COMBOL OLDBOL.
           MOVE ZERO TO TOTBOL.
           MOVE ZERO TO IND.
       LPTRA1.
           ADD 1 TO IND.
      **** rel 1.2
      *    IF IND > 6 GO TO EX-RTRAT.
           IF IND > 12 GO TO EX-RTRAT.
      ************
           IF CFT-IMPOR (IND) = ZERO GO TO EX-RTRAT.
       LPEFF.
           MOVE CFT-IMPOR (IND) TO COMX.
      **** rel 2.0
      * rata arrotondata all'unita' di euro superiore
      * importo bollo arrotondato al decimo di euro.
      **** rel 4.0
      *    IF VALUT = ER-VALUT MULTIPLY 10 BY COMX.
           IF VALUT = ZERO OR COMEURO  MULTIPLY 10 BY COMX.
      ************
      ************
       LPEF1.
           MOVE COMBOL TO OLDBOL.
           ADD 999 TO COMX.
           MOVE ZERO TO ULT3.
           COMPUTE COMBOL = COMX * PERCB.
           COMPUTE COMBOL = COMBOL / 1000.
           COMPUTE COMBOL = COMBOL + 99.
           MOVE ZERO TO ULT2.
      **** rel 2.0
      *    IF SWRB = 1 GO TO EX-RTRAT.
      *    IF COMBOL = OLDBOL COMPUTE TOTBOL = TOTBOL + COMBOL
      *                                           GO TO LPTRA1.
      * rata arrotondata all'unita' di euro superiore
      * importo bollo arrotondato al decimo di euro.
           IF SWRB = 1
      **** rel 4.0
      *       IF VALUT = ER-VALUT DIVIDE 10 INTO COMBOL
              IF VALUT = ZERO OR COMEURO  DIVIDE 10 INTO COMBOL
      ************
              END-IF
              GO TO EX-RTRAT.
           IF COMBOL = OLDBOL
      **** rel 4.0
      *       IF VALUT = ER-VALUT DIVIDE 10 INTO COMBOL
              IF VALUT = ZERO OR COMEURO  DIVIDE 10 INTO COMBOL
      ************
              END-IF
              COMPUTE TOTBOL = TOTBOL + COMBOL
              GO TO LPTRA1.
      ************
           MOVE CFT-IMPOR (IND) TO COMX.
      **** rel 2.0
      * rata arrotondata all'unita' di euro superiore
      * importo bollo arrotondato al decimo di euro.
      **** rel 4.0
      *    IF VALUT = ER-VALUT MULTIPLY 10 BY COMX.
           IF VALUT = ZERO OR COMEURO  MULTIPLY 10 BY COMX.
      ************
      ************
           ADD COMBOL TO COMX.
           GO TO LPEF1.
       EX-RTRAT.
           EXIT.
      *------------------*
       RIBAN.
           IF SWRB = 1 MOVE ZERO TO TOTBOL GO TO LPEFB.
           MOVE ZERO TO IND.
           MOVE ZERO TO TOTBOL.
       LPRBA1.
           ADD 1 TO IND.
      **** rel 1.2
      *    IF IND > 6 GO TO EX-RIBAN.
           IF IND > 12 GO TO EX-RIBAN.
      ************
           IF CFT-IMPOR (IND) = ZERO GO TO EX-RIBAN.
       LPEFB.
           MOVE ZERO TO K.
           MOVE CFT-IMPOR (IND) TO COMBOL.
       LPRBA2.
           ADD 1 TO K.
           IF K > 6 MOVE 6 TO K GO TO CARBA.
           IF SWRB = 1 GO TO TEST1.
           IF COMBOL NOT > TRB (K) GO TO CARBA.
           GO TO LPRBA2.
       TEST1.
           IF COMBOL NOT > TRB1 (K) GO TO CARBA.
           GO TO LPRBA2.
       CARBA.
           COMPUTE TOTBOL = TOTBOL + TBL (K).
           IF SWRB = 1 GO TO EX-RIBAN.
           GO TO LPRBA1.
       EX-RIBAN.
           EXIT.
      *-----------------------*
       FINEFT.
           PERFORM VENTILA THRU EX-VENTILA.
           PERFORM IVACAL  THRU EX-IVACAL.
      **** rel 1.2
      *    IF VALUT > 1 MOVE ZERO TO CLF-SBAN
      *                      GO TO BYBAN.
      ************
           IF CLF-SBAN = ZERO GO TO BYBAN.
           MOVE 4 TO KTB-TIP.
           MOVE CFT-CDPAG TO KTB-COD.
           READ TABELL INTO REKTAB INVALID KEY
                PERFORM INVK-TAB
                GO TO WARNING.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      **** rel 1.2
      *    COMPUTE COMX = T04-SPESE * T04-NRATE.
      **** rel 4.0
      *    IF VALUT > 1
           IF NOT (VALUT = ZERO OR COMEURO)
      ************
              MOVE T04-SPESE TO ER-IMPORTO
      **** rel 4.0
      *       CALL 'rtriimp' USING ER-IMPORTO LIR-VAL CG-PAR
              MOVE CG-VALUT  TO ER-VALUT
              MOVE CG-CAMBIO TO ER-CAMBIO
              CALL 're2imp' USING ER-IMPORTO EUR-VAL ER-VALUT ER-CAMBIO
      ************
              COMPUTE ER-IMPORTO = ER-IMPORTO * T04-NRATE * 100
              MOVE ER-IMPORTO TO COMX
           ELSE
      **** rel 4.0
      *       COMPUTE COMX = T04-SPESE * T04-NRATE.
              COMPUTE COMX = T04-SPESE * T04-NRATE * 100.
           IF VALUT = 1 DIVIDE 100 INTO COMX.
      ************
      ************
           IF COMX = ZERO GO TO BYBAN.
           MOVE COMX TO COMA.
           MOVE IVABAN TO COMIVA.
      **** rel 6.2
      *    IF CFT-CDESE NOT = ZERO AND IVABAN NOT = IVACAU
           IF CFT-CDESE NOT = ZERO
      ************
                MOVE CFT-CDESE TO COMIVA.
           PERFORM RIVA THRU EX-RIVA.
           MOVE COMX TO CFT-SPBAN.
       BYBAN.
           PERFORM IVACAL THRU EX-IVACAL.
           MOVE ZERO TO IND.
           MOVE ZERO TO COMFAT.
           MOVE ZERO TO TOTIVA.
       LPTOT1.
           ADD 1 TO IND.
           IF IND > 6 GO TO LPRATE.
           MOVE CFT-IMPON (IND) TO COMA.
           MOVE CFT-IMPOS (IND) TO COMX.
           COMPUTE COMFAT = COMFAT + COMA + COMX.
           COMPUTE TOTIVA = TOTIVA + COMX.
           ADD IVRIV (IND) TO CFT-IVRIV.
           GO TO LPTOT1.
       LPRATE.
           COMPUTE COMFAT = COMFAT -
                           (CFT-IVRIV + CFT-OMAGG + CFT-SCONT).
           COMPUTE TOTIVA = TOTIVA - CFT-IVRIV.
      **** rel 3.0
           MOVE ZERO TO ESTPIVA.
      **** rel 5.0
           MOVE ZERO TO ADBOL.
      ************
           IF CFT-CDESE  = ZERO GO TO NO-RDIVA.
           MOVE 3         TO KTB-TIP.
           MOVE CFT-CDESE TO KTB-COD.
           READ TABELL INTO REKTAB INVALID GO TO NO-RDIVA.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T03-TPIVA TO ESTPIVA.
      **** rel 5.0
           MOVE T03-BOLLI TO ADBOL.
      ************
       NO-RDIVA.
      ************
           MOVE 4 TO KTB-TIP.
           MOVE CFT-CDPAG TO KTB-COD.
           READ TABELL INTO REKTAB INVALID KEY
                PERFORM INVK-TAB
                GO TO WARNING.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE COMFAT TO CFT-TOTFT.
           PERFORM RSCAD THRU EX-RSCAD.
      **** rel 1.2
      *    IF VALUT > 1 MOVE ZERO TO CLF-SBOL
      *                         GO TO FINECAL.
      **** rel 3.0
      *    IF ESIVA NOT = ZERO MOVE ZERO TO CLF-SBOL
      *                        GO TO FINECAL.
           IF ESTPIVA = 3 MOVE ZERO TO CLF-SBOL
                          GO TO FINECAL.
      ************
      ************
           IF CLF-SBOL = ZERO GO TO FINECAL.
           IF T04-TIPAG = 1 MOVE ZERO TO SWRB
               PERFORM RTRAT THRU EX-RTRAT GO TO SOMFAT.
      **** rel 1.2
      **** rel 4.0
      *    IF VALUT > 1 GO TO FINECAL.
           IF NOT (VALUT = ZERO OR COMEURO) GO TO FINECAL.
      ************
      ************
           IF T04-TIPAG = 2 MOVE ZERO TO SWRB
               PERFORM RIBAN THRU EX-RIBAN GO TO SOMFAT.
           GO TO FINECAL.
       SOMFAT.
           IF TOTBOL = ZERO GO TO SOMFA1.
           MOVE IVACAU TO COMIVA.
           MOVE TOTBOL TO COMA.
           PERFORM RIVA THRU EX-RIVA.
           PERFORM IVACAL THRU EX-IVACAL.
       SOMFA1.
           MOVE TOTBOL TO CFT-SPBOL.
           MOVE ZERO TO COMFAT.
           MOVE ZERO TO TOTIVA.
           MOVE ZERO TO IND.
       LPTOT2.
           ADD 1 TO IND.
           IF IND > 6 GO TO LPRAT1.
           MOVE CFT-IMPON (IND) TO COMA.
           MOVE CFT-IMPOS (IND) TO COMX.
           COMPUTE COMFAT = COMFAT + COMA + COMX.
           COMPUTE TOTIVA = TOTIVA + COMX.
           GO TO LPTOT2.
       LPRAT1.
           COMPUTE COMFAT = COMFAT -
                           (CFT-IVRIV + CFT-OMAGG + CFT-SCONT).
           COMPUTE TOTIVA = TOTIVA - CFT-IVRIV.
           MOVE COMFAT TO CFT-TOTFT.
           PERFORM RCALR THRU EX-RCALR.
       FINECAL.
      **** rel 5.0
           IF ADBOL = ZERO GO TO NO-BOLLI.
           MOVE ZERO TO ADBOL TOTBOL.
           IF VALUT = ZERO OR COMEURO
      **** rel 5.1
      *       IF COMFAT >= 7747 MOVE 129 TO TOTBOL.
      **** rel 5.2
      *       IF CFT-TOTFT >= 7747 MOVE 129 TO TOTBOL.
              IF CFT-TOTFT >= IMPSCA MOVE IMPBOL TO TOTBOL.
      ************
      ************
      **** rel 5.2
      *    IF VALUT = 1
      **** rel 5.1
      *       IF COMFAT >= 150000 MOVE 2500 TO TOTBOL.
      *       IF CFT-TOTFT >= 150000 MOVE 2500 TO TOTBOL.
      ************
      ************
      **** rel 5.1
           IF CFT-TDOC = 3
              COMPUTE TOTBOL = TOTBOL * - 1.
      ************
           IF TOTBOL NOT = ZERO GO TO SOMFAT.
       NO-BOLLI.
      ************
      **** rel 4.0
      *    IF VALUT = ZERO OR 1 GO TO WR003.
           IF VALUT = ZERO OR COMEURO
              PERFORM FTEURO THRU EX-FTEURO
              GO TO WR003.
           IF VALUT = 1
              PERFORM FTLIRE THRU EX-FTLIRE
              GO TO LPCNT8.
      ************
      **** rel 1.2
      *    COMPUTE COMVAL = ( ( CFT-NTMER * COEFF ) + 0,5 ) / 100.
      *    MOVE COMVAL TO CFT-NTMER.
      *    COMPUTE COMVAL = ( ( CFT-SPBOL * COEFF ) + 0,5 ) / 100.
      *    MOVE COMVAL TO CFT-SPBOL.
      *    COMPUTE COMVAL = ( ( CFT-SPBAN * COEFF ) + 0,5 ) / 100.
      *    MOVE COMVAL TO CFT-SPBAN.
      *    COMPUTE COMVAL = ( ( CFT-SCFIN * COEFF ) + 0,5 ) / 100.
      *    MOVE COMVAL TO CFT-SCFIN.
      *    COMPUTE COMVAL = ( ( CFT-OMAGG * COEFF ) + 0,5 ) / 100.
      *    MOVE COMVAL TO CFT-OMAGG.
      *    COMPUTE COMVAL = ( ( CFT-SCONT * COEFF ) + 0,5 ) / 100.
      *    MOVE COMVAL TO CFT-SCONT.
      *    MOVE CFT-TOTFT TO PREZ0.
      *    MOVE PREZ2 TO CFT-TOVAL.
      *    COMPUTE COMVAL = ( ( CFT-TOTFT * COEFF ) + 0,5 ) / 100.
      *    MOVE COMVAL TO CFT-TOTFT.
      *    MOVE ZERO TO CONT.
      *    MOVE ZERO TO COMFAT.
      *LPCNT1.
      *    ADD 1 TO CONT.
      *    IF CONT > 6 GO TO LPCNT2.
      *    COMPUTE COMVAL = ( ( CFT-IMPON(CONT) * COEFF ) + 0,5 ) / 100.
      *    MOVE COMVAL TO CFT-IMPON(CONT).
      *    COMPUTE COMFAT = COMFAT + CFT-IMPON(CONT).
      *    GO TO LPCNT1.
      *LPCNT2.
      *    COMPUTE COMFAT = COMFAT - (CFT-OMAGG + CFT-SCONT).
      *    COMPUTE CFT-IMPON(1) = CFT-IMPON(1) + ( CFT-TOTFT - COMFAT ).
      *    MOVE ZERO TO CONT.
      *    MOVE ZERO TO COMFAT.
      *LPCNT3.
      *    ADD 1 TO CONT.
      *    IF CONT > 6 GO TO LPCNT4.
      *    IF CFT-IMPOR (CONT) = ZERO GO TO LPCNT4.
      *    COMPUTE COMVAL = ( ( CFT-IMPOR(CONT) * COEFF ) + 0,5 ) / 100.
      *    MOVE COMVAL TO CFT-IMPOR(CONT).
      *    COMPUTE COMFAT = COMFAT + CFT-IMPOR(CONT).
      *    GO TO LPCNT3.
      *LPCNT4.
      *    IF CONT > 1 SUBTRACT 1 FROM CONT
      *    COMPUTE CFT-IMPOR(CONT) =
      *            CFT-IMPOR(CONT) + ( CFT-TOTFT - COMFAT )
      *    ELSE
      *    COMPUTE CFT-IMPOR(1) = CFT-IMPOR(1) + ( CFT-TOTFT - COMFAT ).
      *    MOVE ZERO TO CONT.
      *    MOVE ZERO TO COMFAT.
      *LPCNT5.
      *    ADD 1 TO CONT.
      *    IF CONT > 15 GO TO LPCNT6.
      *    COMPUTE COMVAL = ( ( CFT-IMPCP(CONT) * COEFF ) + 0,5 ) / 100.
      *    MOVE COMVAL TO CFT-IMPCP(CONT).
      *    COMPUTE COMFAT = COMFAT + CFT-IMPCP(CONT).
      *    GO TO LPCNT5.
      *LPCNT6.
      *    COMPUTE CFT-IMPCP(1) = CFT-IMPCP(1) + ( CFT-TOTFT - COMFAT ).
      *    COMPUTE CFT-SCFIN = CFT-SCFIN + ( ( CFT-NTMER - CFT-SCFIN ) -
      *            ( CFT-TOTFT + CFT-SPBOL + CFT-SPBAN ) ).

      *
      * caricamento campi di parfat in valuta
      *
           DIVIDE CFT-TOTFT BY 100 GIVING CFT-TOVAL.
      *
           DIVIDE CFT-NTMER BY 100 GIVING CFT-ENTMER.
           DIVIDE CFT-IVRIV BY 100 GIVING CFT-EIVRIV.
           DIVIDE CFT-SPBOL BY 100 GIVING CFT-ESPBOL.
           DIVIDE CFT-SPBAN BY 100 GIVING CFT-ESPBAN.
           DIVIDE CFT-SCFIN BY 100 GIVING CFT-ESCFIN.
           DIVIDE CFT-OMAGG BY 100 GIVING CFT-EOMAGG.
           DIVIDE CFT-SCONT BY 100 GIVING CFT-ESCONT.
      *
           MOVE 1 TO IND.
           PERFORM UNTIL IND > 6
              DIVIDE CFT-IMPON(IND) BY 100 GIVING CFT-EIMPON(IND)
              DIVIDE CFT-IMPOS(IND) BY 100 GIVING CFT-EIMPOS(IND)
              ADD 1 TO IND
           END-PERFORM.
      *
           MOVE 1 TO IND.
           PERFORM UNTIL IND > 12
              DIVIDE CFT-IMPOR(IND) BY 100 GIVING CFT-EIMPOR(IND)
              ADD 1 TO IND
           END-PERFORM.
      *
           MOVE 1 TO IND.
           PERFORM UNTIL IND > 15
              DIVIDE CFT-IMPCP(IND) BY 100 GIVING W-EIMPCP(IND)
              ADD 1 TO IND
           END-PERFORM.
      * vettore di comodo in memoria
           MOVE 1 TO IND.
           PERFORM UNTIL IND > 6
              DIVIDE IVRIV(IND) BY 100 GIVING W-IVRIV(IND)
      **** rel 2.0
              DIVIDE OMAGIV(IND) BY 100 GIVING W-OMAGIV(IND)
      ************
              ADD 1 TO IND
           END-PERFORM.
      **** rel 4.0
       LPCNT8.
      ************
      *
      * conversione in Euro campi tot.fattura, spese, ecc.
      *
      **** rel 2.0
      *    MOVE CFT-TOVAL TO ER-IMPORTO.
      *    CALL 'rtriimp' USING ER-IMPORTO VAL-LIR CG-PAR.
      *    MOVE ER-IMPORTO TO CFT-TOTFT.
      ************

           MOVE CFT-ENTMER TO ER-IMPORTO.
      **** rel 4.0
      *    CALL 'rtriimp' USING ER-IMPORTO VAL-LIR CG-PAR.
           MOVE CG-VALUT  TO ER-VALUT.
           MOVE CG-CAMBIO TO ER-CAMBIO.
           CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT ER-CAMBIO.
      ************
           MOVE ER-IMPORTO TO CFT-NTMER.

           MOVE CFT-EIVRIV TO ER-IMPORTO.
      **** rel 4.0
      *    CALL 'rtriimp' USING ER-IMPORTO VAL-LIR CG-PAR.
           MOVE CG-VALUT  TO ER-VALUT.
           MOVE CG-CAMBIO TO ER-CAMBIO.
           CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT ER-CAMBIO.
      ************
           MOVE ER-IMPORTO TO CFT-IVRIV.

           MOVE CFT-ESPBOL TO ER-IMPORTO.
      **** rel 4.0
      *    CALL 'rtriimp' USING ER-IMPORTO VAL-LIR CG-PAR.
           MOVE CG-VALUT  TO ER-VALUT.
           MOVE CG-CAMBIO TO ER-CAMBIO.
           CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT ER-CAMBIO.
      ************
           MOVE ER-IMPORTO TO CFT-SPBOL.

           MOVE CFT-ESPBAN TO ER-IMPORTO.
      **** rel 4.0
      *    CALL 'rtriimp' USING ER-IMPORTO VAL-LIR CG-PAR.
           MOVE CG-VALUT  TO ER-VALUT.
           MOVE CG-CAMBIO TO ER-CAMBIO.
           CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT ER-CAMBIO.
      ************
           MOVE ER-IMPORTO TO CFT-SPBAN.

           MOVE CFT-ESCFIN TO ER-IMPORTO.
      **** rel 4.0
      *    CALL 'rtriimp' USING ER-IMPORTO VAL-LIR CG-PAR.
           MOVE CG-VALUT  TO ER-VALUT.
           MOVE CG-CAMBIO TO ER-CAMBIO.
           CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT ER-CAMBIO.
      ************
           MOVE ER-IMPORTO TO CFT-SCFIN.

           MOVE CFT-EOMAGG TO ER-IMPORTO.
      **** rel 4.0
      *    CALL 'rtriimp' USING ER-IMPORTO VAL-LIR CG-PAR.
           MOVE CG-VALUT  TO ER-VALUT.
           MOVE CG-CAMBIO TO ER-CAMBIO.
           CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT ER-CAMBIO.
      ************
           MOVE ER-IMPORTO TO CFT-OMAGG.

           MOVE CFT-ESCONT TO ER-IMPORTO.
      **** rel 4.0
      *    CALL 'rtriimp' USING ER-IMPORTO VAL-LIR CG-PAR.
           MOVE CG-VALUT  TO ER-VALUT.
           MOVE CG-CAMBIO TO ER-CAMBIO.
           CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT ER-CAMBIO.
      ************
           MOVE ER-IMPORTO TO CFT-SCONT.
      **** rel 2.0
      *
      * calcolo dell'importo IVA in Lire tramite scorporo
      *
      *>   somma imponibili e IVA in valuta
      *    MOVE ZERO TO ETOT1.
      *    MOVE 1 TO IND.
      *    PERFORM UNTIL IND > 6
      *       ADD CFT-EIMPON(IND) TO ETOT1
      *       ADD CFT-EIMPOS(IND) TO ETOT1
      *       ADD 1 TO IND
      *    END-PERFORM.
      *>   converte somma imponibili e IVA in euro
      *    MOVE ETOT1 TO ER-IMPORTO.
      *    CALL 'rtriimp' USING ER-IMPORTO VAL-LIR CG-PAR.
      *    MOVE ER-IMPORTO TO TOT1.
      *>   calcola imponibile + IVA in euro per aliquota
      *>      tramite ripartizione proporzionale
      *    MOVE TOT1 TO TOT2.
      *    MOVE 1 TO IND.
      *    PERFORM UNTIL IND > 6
      *       COMPUTE CFT-IMPON(IND) = (TOT1 / ETOT1) *
      *                     (CFT-EIMPON(IND) + CFT-EIMPOS(IND))
      *       SUBTRACT CFT-IMPON(IND) FROM TOT2
      *       ADD 1 TO IND
      *    END-PERFORM.
      *    ADD TOT2 TO CFT-IMPON(1).
      *>   scorpora singole aliquote
      *    MOVE ZERO TO IND.
      *LPCNT0-10.
      *    ADD 1 TO IND.
      *    IF IND > 6 GO TO LPCNT0-20.
      *    IF CFT-CDIVA (IND) = ZERO GO TO LPCNT0-20.
      *    MOVE CFT-CDIVA (IND) TO KTB-COD.
      *    MOVE 3               TO KTB-TIP.
      *    READ TABELL INTO REKTAB INVALID KEY
      *         PERFORM INVK-TAB
      *         GO TO WARNING.
      *    IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      *    MOVE CFT-IMPON(IND) TO TOT2.
      *    COMPUTE CFT-IMPON(IND) = TOT2 / ((100 + T03-ALIVA) / 100).
      *    COMPUTE CFT-IMPOS(IND) = TOT2 - CFT-IMPON(IND).
      *    GO TO LPCNT0-10.
      *LPCNT0-20.
      *>   per fatture di sola IVA (omaggi con rivalsa)
      *>   forza totale fattura in euro = iva calcolata
      *    COMPUTE ETOT1 =   CFT-EIMPOS(1) + CFT-EIMPOS(2)
      *                    + CFT-EIMPOS(3) + CFT-EIMPOS(4)
      *                    + CFT-EIMPOS(5) + CFT-EIMPOS(6).
      *    IF ETOT1 = CFT-TOVAL
      *       COMPUTE DELTA =   CFT-IMPOS(1) + CFT-IMPOS(2)
      *                       + CFT-IMPOS(3) + CFT-IMPOS(4)
      *                       + CFT-IMPOS(5) + CFT-IMPOS(6)
      *                       - CFT-TOTFT
      *       ADD DELTA TO CFT-TOTFT
      *    ELSE
      *       MOVE ZERO TO DELTA.

      *>   converte in euro imponibili IVA e imposta
           MOVE 1 TO IND.
           PERFORM UNTIL IND > 6
              MOVE CFT-EIMPON(IND) TO ER-IMPORTO
      **** rel 4.0
      *       CALL 'rtriimp' USING ER-IMPORTO VAL-LIR CG-PAR
              MOVE CG-VALUT  TO ER-VALUT
              MOVE CG-CAMBIO TO ER-CAMBIO
              CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT ER-CAMBIO
      ************
              MOVE ER-IMPORTO TO CFT-IMPON(IND)
              MOVE CFT-EIMPOS(IND) TO ER-IMPORTO
      **** rel 4.0
      *       CALL 'rtriimp' USING ER-IMPORTO VAL-LIR CG-PAR
              MOVE CG-VALUT  TO ER-VALUT
              MOVE CG-CAMBIO TO ER-CAMBIO
              CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT ER-CAMBIO
      ************
              MOVE ER-IMPORTO TO CFT-IMPOS(IND)
              ADD 1 TO IND
           END-PERFORM.

      *>   calcola l'importo in euro del totale fattura
           MOVE ZERO TO CFT-TOTFT.
           MOVE 1 TO IND.
           PERFORM UNTIL IND > 6
      **** rel 4.0
      *       COMPUTE ER-IMPORTO = CFT-EIMPON(IND) - W-OMAGIV(IND)
      *       CALL 'rtriimp' USING ER-IMPORTO VAL-LIR CG-PAR
              MOVE CFT-EIMPON(IND) TO ER-IMPORTO
              MOVE CG-VALUT  TO ER-VALUT
              MOVE CG-CAMBIO TO ER-CAMBIO
              CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT ER-CAMBIO
      ************
              ADD ER-IMPORTO TO CFT-TOTFT
      **** rel 4.0
      *       COMPUTE ER-IMPORTO = CFT-EIMPOS(IND) - W-IVRIV(IND)
      *       CALL 'rtriimp' USING ER-IMPORTO VAL-LIR CG-PAR
              MOVE CFT-EIMPOS(IND) TO ER-IMPORTO
              MOVE CG-VALUT  TO ER-VALUT
              MOVE CG-CAMBIO TO ER-CAMBIO
              CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT ER-CAMBIO
      ************
              ADD ER-IMPORTO TO CFT-TOTFT
      **** rel 4.0
              MOVE W-OMAGIV(IND) TO ER-IMPORTO
              MOVE CG-CAMBIO TO ER-CAMBIO
              MOVE CG-VALUT  TO ER-VALUT
              CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT ER-CAMBIO
              SUBTRACT ER-IMPORTO FROM CFT-TOTFT
              MOVE W-IVRIV(IND) TO ER-IMPORTO
              MOVE CG-VALUT  TO ER-VALUT
              MOVE CG-CAMBIO TO ER-CAMBIO
              CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT ER-CAMBIO
              SUBTRACT ER-IMPORTO FROM CFT-TOTFT
      ************
              ADD 1 TO IND
           END-PERFORM.
      ************
      *
      * conversione in euro delle scadenze
      *
           MOVE ZERO  TO IND.
           MOVE ZERO  TO ETOT1 TOT1.
       LPCNT3.
           ADD 1 TO IND.
           IF IND > 12 GO TO LPCNT4.
           IF CFT-EIMPOR(IND) = ZERO GO TO LPCNT4.
           MOVE CFT-EIMPOR(IND) TO ER-IMPORTO.
      **** rel 4.0
      *    CALL 'rtriimp' USING ER-IMPORTO VAL-LIR CG-PAR.
           MOVE CG-VALUT  TO ER-VALUT.
           MOVE CG-CAMBIO TO ER-CAMBIO.
           CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT ER-CAMBIO.
      ************
           MOVE ER-IMPORTO TO CFT-IMPOR(IND).
           ADD CFT-EIMPOR(IND) TO ETOT1.
           ADD CFT-IMPOR(IND)  TO TOT1.
           GO TO LPCNT3.
       LPCNT4.
      *>   carica su ultima scadenza la eventuale differenza
           MOVE ETOT1 TO ER-IMPORTO.
      **** rel 4.0
      *    CALL 'rtriimp' USING ER-IMPORTO VAL-LIR CG-PAR.
           MOVE CG-VALUT  TO ER-VALUT.
           MOVE CG-CAMBIO TO ER-CAMBIO.
           CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT ER-CAMBIO.
      ************
      **** rel 2.0
           IF TOTACC = ZERO MOVE CFT-TOTFT TO ER-IMPORTO.
      ************
           IF IND > 1 SUBTRACT 1 FROM IND.
      **** rel 2.0
      *    COMPUTE CFT-IMPOR(IND) = CFT-IMPOR(IND) + ER-IMPORTO + DELTA
           COMPUTE CFT-IMPOR(IND) = CFT-IMPOR(IND) + ER-IMPORTO
      ************
                                    - TOT1.
      *
      * conversione in euro delle contropartite
      *
           MOVE ZERO TO IND.
           MOVE ZERO TO TOT1 ETOT1.
       LPCNT5.
           ADD 1 TO IND.
           IF IND > 15 GO TO LPCNT6.
           MOVE W-EIMPCP(IND) TO ER-IMPORTO.
      **** rel 4.0
      *    CALL 'rtriimp' USING ER-IMPORTO VAL-LIR CG-PAR.
           MOVE CG-VALUT  TO ER-VALUT.
           MOVE CG-CAMBIO TO ER-CAMBIO.
           CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT ER-CAMBIO.
      ************
           MOVE ER-IMPORTO TO CFT-IMPCP(IND).
           ADD W-EIMPCP(IND)  TO ETOT1.
           ADD CFT-IMPCP(IND) TO TOT1.
           GO TO LPCNT5.
       LPCNT6.
      *>   carica sulla prima c/p la eventuale differenza
           MOVE ETOT1 TO ER-IMPORTO.
      **** rel 4.0
      *    CALL 'rtriimp' USING ER-IMPORTO VAL-LIR CG-PAR.
           MOVE CG-VALUT  TO ER-VALUT.
           MOVE CG-CAMBIO TO ER-CAMBIO.
           CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT ER-CAMBIO.
      ************
           COMPUTE CFT-IMPCP(1) = CFT-IMPCP(1) + ER-IMPORTO - TOT1.

      **** rel 2.0
      *
      * quadratura tra castelletto IVA e IVA omaggi
      *
      *    MOVE ZERO TO TOT3 TOT4 ETOT1.
      *    MOVE 1 TO IND.
      *    PERFORM UNTIL IND > 6
      *       IF W-IVRIV(IND) NOT = ZERO
      *          IF W-IVRIV(IND) = CFT-EIMPOS(IND)
      *             ADD CFT-IMPOS(IND)  TO TOT3
      *             ADD CFT-IMPON(IND)  TO TOT4
      *             ADD CFT-EIMPON(IND) TO ETOT1
      *          ELSE
      *             MOVE 6 TO IND
      *          END-IF
      *       END-IF
      *       ADD 1 TO IND
      *    END-PERFORM.
      *    IF CFT-EOMAGG NOT = ZERO
      *       IF CFT-EOMAGG = ETOT1
      *          MOVE TOT3 TO CFT-IVRIV
      *          MOVE TOT4 TO CFT-OMAGG.
      ************

      *
      * quadratura generale della fattura basata sulla formula:
      *      s(IMPON) + s(IMPOS) - OMAGG - SCONT - IVRIV
      *    = s(IMPCP) + s(IMPOS) - IVRIV + SPBOL + SPBAN
      *    = NTMER + SPBOL + SPBAN + s(IMPOS) - IVRIV - SCFIN
      *    = TOTFT
      *

      **** rel 2.0
      *    COMPUTE DELTA =   CFT-IMPON(1) + CFT-IMPON(2)
      *                    + CFT-IMPON(3) + CFT-IMPON(4)
      *                    + CFT-IMPON(5) + CFT-IMPON(6)
      *                    + CFT-IMPOS(1) + CFT-IMPOS(2)
      *                    + CFT-IMPOS(3) + CFT-IMPOS(4)
      *                    + CFT-IMPOS(5) + CFT-IMPOS(6)
      *                    - CFT-OMAGG    - CFT-SCONT - CFT-IVRIV
      *                    - CFT-TOTFT.
      *    IF CFT-SCONT NOT = ZERO
      *       ADD DELTA TO CFT-SCONT
      *    ELSE
      *       ADD DELTA TO CFT-OMAGG.
      ************

           COMPUTE DELTA =   CFT-TOTFT
                           - CFT-IMPCP(1)  - CFT-IMPCP(2)
                           - CFT-IMPCP(3)  - CFT-IMPCP(4)
                           - CFT-IMPCP(5)  - CFT-IMPCP(6)
                           - CFT-IMPCP(7)  - CFT-IMPCP(8)
                           - CFT-IMPCP(9)  - CFT-IMPCP(10)
                           - CFT-IMPCP(11) - CFT-IMPCP(12)
                           - CFT-IMPCP(13) - CFT-IMPCP(14)
                           - CFT-IMPCP(15)
                           - CFT-IMPOS(1)  - CFT-IMPOS(2)
                           - CFT-IMPOS(3)  - CFT-IMPOS(4)
                           - CFT-IMPOS(5)  - CFT-IMPOS(6)
                           + CFT-IVRIV
                           - CFT-SPBOL     - CFT-SPBAN.
           ADD DELTA TO CFT-IMPCP(1).

           COMPUTE DELTA =   CFT-TOTFT
                           - CFT-NTMER - CFT-SPBOL - CFT-SPBAN
                           - CFT-IMPOS(1) - CFT-IMPOS(2)
                           - CFT-IMPOS(3) - CFT-IMPOS(4)
                           - CFT-IMPOS(5) - CFT-IMPOS(6)
                           + CFT-IVRIV    + CFT-SCFIN.
           IF CFT-SCFIN NOT = ZERO
              SUBTRACT DELTA FROM CFT-SCFIN
           ELSE
              ADD DELTA TO CFT-NTMER.
      ************
       WR003.
           MOVE ATTIV TO CFT-CATT.
      **** rel 6.2
      *    IF CF-SIMUL NOT = ZERO GO TO EX-FINEFT.
           IF CF-SIMUL NOT = ZERO AND NOT = 9 GO TO EX-FINEFT.
           IF CF-SIMUL = 9
              PERFORM CERCA-CONTA THRU EX-CERCA-CONTA
              ADD 1 TO CONTA
              MOVE CONTA TO KLAV-CONTA
              MOVE CONTA TO CFT-NUM
              MOVE CFT-FAT TO LAV-PARFAT
              MOVE PARRB TO LAV-PARRB
              WRITE RF-LAV INVALID
                 MOVE 'WRITE WDSLAV' TO MESS
                 GO TO ERRIO
              END-WRITE
              GO TO EX-FINEFT.
      ************
           WRITE RF-FAT FROM CFT-FAT INVALID KEY PERFORM INVK-FAT
                                                 GO TO WARNING.
      **** rel 7.2
           MOVE ZERO TO RF-AFT.
      ************
      **** rel 7.1
           MOVE CFT-AZI   TO KAFT-AZI.
           MOVE CFT-TDOC  TO KAFT-TDOC.
           MOVE CFT-NUM   TO KAFT-NUM.
           MOVE FAT-CATT  TO KAFT-CATT.
           MOVE COMTIPO   TO AFT-TIPO.
           MOVE COMIPA    TO AFT-IPA.
           MOVE COMCIG    TO AFT-CIG.
           MOVE COMCUP    TO AFT-CUP. 
           MOVE COMFAORD   TO AFT-FAORD.
           MOVE COMFADTORD TO AFT-FADTORD.
           WRITE RF-AFT INVALID KEY PERFORM INVK-AFT
                                       GO TO WARNING.
      ************
      **** rel 1.2
      * scrittura bolle raggruppate per fattura
           MOVE ZERO TO K.
       WRBFA.
           ADD 1 TO K.
           IF K > RB-ULTBOL     GO TO WRBFA-90.
           IF RB-TNUM(K) = ZERO GO TO WRBFA-90.
           MOVE ZERO       TO RF-BFA.
           MOVE FAT-CATT   TO KBFA-CATT.
           MOVE KEYFT      TO KBFA-KEYFT.
           MOVE K          TO KBFA-PRG.
           MOVE RB-TNUM(K) TO BFA-TNUM.
           MOVE RB-NBOL(K) TO BFA-NBOL.
           WRITE RF-BFA INVALID PERFORM INVK-BFA
                                GO TO WARNING.
           GO TO WRBFA.
       WRBFA-90.
      ************
      **** rel 1.2
           MOVE 4 TO KTB-TIP.
           MOVE BCT-CPAG TO KTB-COD.
           READ TABELL INTO REKTAB INVALID KEY
               PERFORM INVK-TAB
               GO TO WARNING.
      **** rel 2.0 - 27.01.99
      *    IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      ***********************
      ************
      **** rel 6.2
      * se definitivo e nr.rate 0 non calcola effetti xche' gestito da vfat119
           IF CF-SIMUL = ZERO AND T04-NRATE = ZERO GO TO EX-FINEFT.
      ************
           IF T04-TIPAG = ZERO OR T04-TIPAG > 2 GO TO EX-FINEFT.
      **** rel 1.2
      *    IF VALUT > 1 GO TO EX-FINEFT.
      **** rel 4.0
      *    CALL 'rveur' USING ER-VALUT.
      *    IF NOT (VALUT = ZERO OR 1 OR ER-VALUT) GO TO EX-FINEFT.
           IF NOT (VALUT = ZERO OR 1 OR COMEURO) GO TO EX-FINEFT.
      ************
      ************
           IF CFT-TDOC = 3 OR 6 GO TO EX-FINEFT.
           MOVE ZERO TO IND.
       LPEFF1.
      **** rel 6.1
           PERFORM CALC-RITENUTA THRU EX-CALC-RITENUTA.
      ************
           OPEN I-O EFFETT.
           ADD 1 TO IND.
      **** rel 1.2
      *    IF IND > 6 GO TO EX-FINEFT.
           IF IND > 12 GO TO EX-FINEFT.
      ************
           IF CFT-IMPOR (IND) = ZERO GO TO EX-FINEFT.
           MOVE KAZ-COD TO KEF-AZI.
           MOVE T04-TIPAG TO KEF-TIPO.
       LPEFF2.
           ADD 1 TO NUMEFF.
           MOVE NUMEFF TO KEF-NUM.
           READ EFFETT INVALID KEY GO TO CAREF.
           GO TO LPEFF2.
       CAREF.
           MOVE ZERO TO RESTOEF.
           MOVE ZERO TO EFF-IMPOR
                        EFF-IMBOL
                        EFF-DTSCA
                        EFF-DTFAT
                        EFF-DTCON
                        EFF-TOTFT.
           MOVE ZERO TO EFF-DTFT2
                        EFF-DTFT3
                        EFF-DTFT4
                        EFF-DTFT5.
           MOVE IND TO EFF-NRRAT.
           MOVE T04-NRATE TO EFF-NTRAT.
           MOVE CFT-IMPOR (IND) TO EFF-IMPOR.
      **** rel 6.1
           IF RITE NOT = ZERO
              IF IND < T04-NRATE
                  SUBTRACT COMRR  FROM EFF-IMPOR
              ELSE
                  SUBTRACT COMURR FROM EFF-IMPOR.
      ************
           MOVE CFT-DTSCA (IND) TO EFF-DTSCA.
           MOVE CFT-TDOC TO EFF-TDOCF.
           MOVE CFT-NUM TO EFF-NUFAT.
           MOVE CFT-DATA TO EFF-DTFAT.
           MOVE CFT-TOTFT TO EFF-TOTFT.
           MOVE CFT-CDCLI TO EFF-CDCLI.
           MOVE CFT-CDBAN TO EFF-CDBAN.
           MOVE CFT-CDPAG TO EFF-CDPAG.
           MOVE CFT-CATT  TO EFF-CATT.
      **** rel 7.1
      *    MOVE COMCIG   TO EFF-CIG.
      *    MOVE COMCUP   TO EFF-CUP.
      ************
           IF T04-TIPAG = 2 GO TO EFFRB.
           MOVE 1 TO SWRB.
           PERFORM RTRAT THRU EX-RTRAT.
      **** rel 4.0
      *    MOVE COMBOL TO EFF-IMBOL.
           COMPUTE EFF-IMBOL = COMBOL / 100.
      ************
           GO TO WREFF.
       EFFRB.
           MOVE 1 TO SWRB.
           PERFORM RIBAN THRU EX-RIBAN.
      **** rel 4.0
      *    MOVE TOTBOL TO EFF-IMBOL.
           COMPUTE EFF-IMBOL = TOTBOL / 100.
      ************
       WREFF.
           WRITE RF-EFF INVALID KEY
                 PERFORM INVK-EFF
                 CLOSE EFFETT
                 GO TO WARNING.
           CLOSE EFFETT.
           GO TO LPEFF1.
       EX-FINEFT.
           EXIT.
      *-----------------------*
       RCONT.
           MOVE ZERO TO IND.
       LPCPA.
           ADD 1 TO IND.
           IF IND > 15 MOVE 15 TO IND GO TO LOOP25.
           MOVE CFT-IMPCP (IND) TO COMPRZ.
           IF COMPRZ = ZERO
              AND SPACON    (IND) = ZERO
              AND CFT-CPART (IND) = ZERO
              MOVE BCR-CONTR TO CFT-CPART (IND)
              MOVE OLDNETRG  TO CFT-IMPCP (IND)
              ADD  SPSRR     TO CFT-IMPCP (IND)
              MOVE SPAGG     TO SPACON    (IND)
              ADD  SPARR     TO SPACON    (IND)
              GO TO EX-RCONT.
           IF BCR-CONTR = CFT-CPART (IND)
              ADD OLDNETRG TO COMPRZ
              MOVE COMPRZ TO CFT-IMPCP (IND)
              ADD  SPSRR  TO CFT-IMPCP (IND)
              ADD  SPAGG     TO SPACON (IND)
              ADD  SPARR     TO SPACON (IND)
              GO TO EX-RCONT.
           GO TO LPCPA.
       LOOP25.
           MOVE CFT-IMPCP (IND) TO COMPRZ.
           ADD OLDNETRG TO COMPRZ.
           MOVE COMPRZ TO CFT-IMPCP (IND).
           ADD  SPSRR  TO CFT-IMPCP (IND).
           ADD  SPAGG     TO SPACON (IND).
           ADD  SPARR     TO SPACON (IND).
       EX-RCONT.
           EXIT.
      *-----------------------*
       ERRIO.
           COPY 'errsub'.
           MOVE 9 TO CF-ST.
       CHIUDI.
           CLOSE STATIS.
           CLOSE TABELL.
           CLOSE ANAAZI.
           CLOSE ANACLF.
           CLOSE BOLCTE.
           CLOSE BOLCRI.
      **** rel 2.0
           CLOSE PROBCR.
      ************
           CLOSE FATTUR.
      **** rel 1.2
      *    CLOSE CAMGIO.
           CLOSE BOLFAT.
      ************
           CLOSE EFFETT.
      **** rel 6.2
           IF CF-SIMUL = 9 CLOSE WDSLAV.
      ************
      **** rel 5.0
           CLOSE ANAIMB.
           CLOSE WDSSIB.
           OPEN OUTPUT WDSSIB.
           CLOSE WDSSIB.
      ************
           EXIT PROGRAM.
           STOP RUN.
      *----------------------*
       A00-SPESA-AGG.
           MOVE 11 TO KTB-TIP.
           MOVE BCR-SPESA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM INVK-TAB
                PERFORM VISK-BCR
                GO TO WARNING.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T11-TIMP = ZERO AND T11-TACC = 1 GO TO A90.
           IF T11-TIMP = ZERO MOVE OLDNETRG TO COMA
           ELSE COMPUTE COMA = COMMER * BCR-PROVV / 100.
           IF T11-TACC = 2 AND COMA > ZERO MULTIPLY -1 BY COMA.
      **** rel 4.0
      *    IF VALUT > 1
      *       COMPUTE BCR-NETRG = COMA / 100
      *    ELSE
      *       MOVE COMA TO BCR-NETRG.
           IF VALUT = 1
              MOVE COMA TO BCR-NETRG
           ELSE
              COMPUTE BCR-NETRG = COMA / 100.
      ************
           MOVE BCR-NETRG TO BCR-PZLOR BCR-PZNET.
           MOVE COMA TO OLDNETRG.
      **** rel 5.0-2
      **** rel 5.2
      *    IF CF-SIMUL NOT = ZERO  GO TO A90.
           IF CF-SIMUL = 1
              IF NOT (BCT-TDOC = 8 OR 9) GO TO A90.
      **************
      **************
           REWRITE RF-BCR INVALID
                PERFORM INVK-BCR GO TO WARNING.
       A90.
           IF BCR-IVA > ZERO AND T11-SCONT = ZERO
                       ADD OLDNETRG TO CFT-NTMER
                       MOVE ZERO TO SPAGG SPARR SPSRR.
           IF BCR-IVA > ZERO AND T11-SCONT > ZERO
                           MOVE OLDNETRG TO SPAGG
                           MOVE ZERO TO OLDNETRG SPARR SPSRR.
           IF BCR-IVA = ZERO AND T11-SCONT = ZERO
                           MOVE OLDNETRG TO SPSRR
                           MOVE ZERO TO OLDNETRG SPAGG SPARR.
           IF BCR-IVA = ZERO AND T11-SCONT > ZERO
                           MOVE OLDNETRG TO SPARR
                           MOVE ZERO TO OLDNETRG SPAGG SPSRR.
       A99. EXIT.
      *----------------------*
       VENTILA.
           IF SCONTO = ZERO ADD SPSGIV TO CFT-NTMER
                                        GO TO OMG00.
      **** rel 5.1
      *    COMPUTE SCVEN = ( CFT-NTMER * SCONTO ) / 100.
           COMPUTE RD-NUM = ( CFT-NTMER * SCONTO ) / 100.
           CALL 'vrround' USING NNN-M PARRD DEC-0.
           MOVE RD-NUM TO SCVEN.
      ************
           MOVE ZERO TO IND TOTVENT.
       VEN10.
           ADD 1 TO IND.
           IF IND > 6 GO TO VEN20.
           IF CFT-IMPON (IND) = ZERO GO TO VEN10.
      **** rel 5.1
      *    COMPUTE VENT = ( SCONTO * CFT-IMPON (IND) ) / 100.
           COMPUTE RD-NUM = ( SCONTO * CFT-IMPON (IND) ) / 100.
           CALL 'vrround' USING NNN-M PARRD DEC-0.
           MOVE RD-NUM TO VENT.
      ************
           SUBTRACT VENT FROM CFT-IMPON (IND).
           ADD VENT TO TOTVENT.
           GO TO VEN10.
       VEN20.
           IF SCVEN = TOTVENT GO TO VEN29.
           MOVE ZERO TO IND.
       VEN25.
           ADD 1 TO IND.
           IF IND > 6 MOVE 6 TO IND GO TO VEN27.
           IF CFT-IMPON (IND) = ZERO GO TO VEN25.
       VEN27.
            COMPUTE
            CFT-IMPON (IND) = CFT-IMPON (IND) - ( SCVEN - TOTVENT ).
       VEN29.
           IF SPSGIV NOT = ZERO
              ADD SPSGIV TO CFT-NTMER
      **** rel 5.1
      *       COMPUTE SCVEN = ( CFT-NTMER * SCONTO ) / 100.
              COMPUTE RD-NUM = ( CFT-NTMER * SCONTO ) / 100
              CALL 'vrround' USING NNN-M PARRD DEC-0
              MOVE RD-NUM TO SCVEN.
      ************
           MOVE ZERO TO IND TOTVENT.
       VEN30.
           ADD 1 TO IND.
           IF IND > 15 GO TO VEN40.
           IF CFT-IMPCP (IND) = ZERO GO TO VEN30.
      **** rel 5.1
      *    COMPUTE VENT = ( SCONTO * CFT-IMPCP (IND) ) / 100.
           COMPUTE RD-NUM = ( SCONTO * CFT-IMPCP (IND) ) / 100.
           CALL 'vrround' USING NNN-M PARRD DEC-0.
           MOVE RD-NUM TO VENT.
      ************
           SUBTRACT VENT FROM CFT-IMPCP (IND).
           ADD VENT TO TOTVENT.
           GO TO VEN30.
       VEN40.
           IF SCVEN = TOTVENT MOVE SCVEN TO CFT-SCFIN
                                          GO TO OMG00.
           MOVE ZERO TO IND.
       VEN45.
           ADD 1 TO IND.
           IF IND > 15 MOVE 15 TO IND GO TO VEN50.
           IF CFT-IMPCP (IND) = ZERO GO TO VEN45.
       VEN50.
           COMPUTE
           CFT-IMPCP (IND) = CFT-IMPCP (IND) - ( SCVEN - TOTVENT ).
           MOVE SCVEN TO CFT-SCFIN.
       OMG00.
           MOVE ZERO TO IND.
       OMG10.
           ADD 1 TO IND.
           IF IND > 6 GO TO SPG00.
           MOVE ZERO TO IMPRIV (IND).
           IF OMAGIV (IND) = ZERO GO TO OMG10.
           ADD OMAGIV (IND) TO CFT-IMPON (IND).
           GO TO OMG10.
       SPG00.
           MOVE ZERO TO IND.
       SPG10.
           ADD 1 TO IND.
           IF IND > 6 GO TO SPG20.
           IF SPAGIV (IND) = ZERO GO TO SPG10.
           ADD SPAGIV (IND) TO CFT-IMPON (IND).
           MOVE ZERO TO SPAGIV (IND).
           GO TO SPG10.
       SPG20.
           MOVE ZERO TO IND.
       SPG30.
           ADD 1 TO IND.
           IF IND > 15 GO TO VSP00.
           IF SPACON (IND) = ZERO GO TO SPG30.
           ADD SPACON (IND) TO CFT-IMPCP (IND) CFT-NTMER.
           MOVE ZERO TO SPACON (IND).
           GO TO SPG30.
       VSP00.
           IF SPSGIV = ZERO AND SPARIV = ZERO GO TO EX-VENTILA.
           IF SPSGIV NOT = ZERO
              IF SCONTO  NOT =  ZERO
      **** rel 5.1
      *       COMPUTE SPSGIV = SPSGIV - (( SPSGIV * SCONTO ) / 100 ).
              COMPUTE RD-NUM = (( SPSGIV * SCONTO ) / 100 )
              CALL 'vrround' USING NNN-M PARRD DEC-0
              SUBTRACT RD-NUM FROM SPSGIV.
      ************
           ADD SPSGIV TO SPARIV.
           MOVE ZERO TO SPSGIV SPAGG IND CFT-TOTFT.
       VSP05.
           ADD 1 TO IND.
           COMPUTE CFT-TOTFT = CFT-TOTFT + CFT-IMPCP (IND).
           IF IND < 15 GO TO VSP05.
           COMPUTE CFT-TOTFT = CFT-TOTFT + CFT-OMAGG + CFT-SCONT.
           MOVE ZERO TO IND.
       VSP10.
           ADD 1 TO IND.
           IF IND > 6 GO TO VSP20.
           IF CFT-IMPON (IND) = ZERO GO TO VSP10.
           ADD CFT-IMPON (IND) TO SPAGG.
           MOVE 3 TO KTB-TIP.
           MOVE CFT-CDIVA (IND) TO KTB-COD.
           READ TABELL INTO REKTAB INVALID GO TO VSP10.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF NOT ( T03-TPIVA = 0 OR = 3 OR = 6 ) GO TO VSP10.
           ADD CFT-IMPON (IND) TO SPAGIV (IND) SPSGIV.
           GO TO VSP10.
       VSP20.
           COMPUTE SPARIV = SPARIV + ( CFT-TOTFT - ( SPAGG + SPARIV )).
           MOVE ZERO TO SPAGG CFT-TOTFT
                        VENT TOTVENT IND.
       VSP30.
           ADD 1 TO IND.
           IF IND > 6 GO TO VSP40.
           IF CFT-IMPON (IND) = ZERO GO TO VSP30.
           IF SPSGIV = ZERO ADD SPARIV TO CFT-IMPON (IND)
                            MOVE ZERO TO SPARIV GO TO VSP40.
           IF SPAGIV (IND) = ZERO GO TO VSP30.
           IF SPAGIV (IND) = SPSGIV ADD SPARIV TO CFT-IMPON (IND)
                             MOVE ZERO TO SPARIV GO TO VSP40.
           COMPUTE VENT = ( SPARIV * SPAGIV (IND) ) / SPSGIV.
           ADD VENT TO TOTVENT CFT-IMPON (IND).
           GO TO VSP30.
       VSP40.
           IF SPARIV = TOTVENT GO TO EX-VENTILA.
           COMPUTE SPARIV = ( SPARIV - TOTVENT ).
           MOVE ZERO TO IND.
       VSP50.
           ADD 1 TO IND.
           IF IND > 6 MOVE 6 TO IND ADD SPARIV TO CFT-IMPON (IND)
                                               GO TO EX-VENTILA.
           IF SPAGIV (IND) = ZERO GO TO VSP50.
           ADD SPARIV TO CFT-IMPON (IND).
           MOVE ZERO TO SPARIV VENT TOTVENT.
       EX-VENTILA. EXIT.
      *----------------------*
       STATISTI.
           MOVE DTFAT TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF CFT-TDOC > 6 GO TO EX-STATISTI.
           MOVE ZERO TO INVA.
           MOVE KAZ-COD TO KST-AZI.
           MOVE BCT-CLI TO KST-CLI.
           MOVE BCR-ART TO KST-ART.
           MOVE CAGE    TO KST-AGEN.
           MOVE ZONA    TO KST-ZONA.
           MOVE AA4     TO KST-ANN.
           READ STATIS INVALID KEY
                       MOVE 1 TO INVA
                       GO TO STA00.
           GO TO STA20.
       STA00.
           MOVE ZERO TO RF-STA.
           MOVE KAZ-COD TO KST-AZI KS2-AZI.
           MOVE BCT-CLI TO KST-CLI KS2-CLI.
           MOVE BCR-ART TO KST-ART KS2-ART .
           MOVE AA4     TO KST-ANN KS2-ANN.
           MOVE CAGE    TO KST-AGEN KS2-AGEN.
           MOVE ZONA    TO KST-ZONA KS2-ZONA.
           MOVE ZERO TO Z.
       STA10.
           ADD 1 TO Z.
           MOVE ZERO TO STA-QMES (Z) STA-VMES (Z).
           IF Z < 12 GO TO STA10.
       STA20.
           IF CFT-TDOC = 3 OR 6
               SUBTRACT BCR-QTA FROM STA-QMES (MM9)
               GO TO WR001.
           ADD BCR-QTA TO STA-QMES (MM9).
       WR001.
      **** rel 5.1
      *    COMPUTE VPRE = VPRE - ( VPRE * SCONTO ) / 100.
           COMPUTE RD-NUM = ( VPRE * SCONTO ) / 100.
           CALL 'vrround' USING NNN-M PARRD DEC-0.
           SUBTRACT RD-NUM FROM VPRE.
      ************
      **** rel 4.0
      *    IF VALUT = ZERO OR 1 GO TO WR002.
           IF VALUT = ZERO OR COMEURO
              COMPUTE VPRE2 = VPRE / 100
              GO TO WR002.
      ************
      **** rel 1.2
      *    COMPUTE COMVAL = ( ( VPRE * COEFF ) + 0,5 ) / 100.
      *    MOVE COMVAL TO VPRE.
      **** rel 2.0
      *    MOVE VPRE      TO ER-IMPORTO.
      **** rel 4.0-2
      *    COMPUTE ER-IMPORTO = VPRE / 100.
           IF VALUT = 1
              MOVE VPRE TO ER-IMPORTO
           ELSE
              COMPUTE ER-IMPORTO = VPRE / 100.
      ************
      ************
           MOVE CG-CAMBIO TO ER-CAMBIO.
      **** rel 4.0
      *    MOVE DTFAT     TO ER-DATA.
      ************
           MOVE BCT-VALUT TO ER-VALUT.
      **** rel 4.0
      *    CALL 'rcamimp' USING ER-IMPORTO VAL-LIR ER-VALUT
      *                         ER-CAMBIO  ER-DATA.
           CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT ER-CAMBIO.
      ************
      **** rel 2.0
      *    COMPUTE ER-IMPORTO = ER-IMPORTO / 100.
      ************
      **** rel 4.0
      *    MOVE ER-IMPORTO TO VPRE.
           MOVE ER-IMPORTO TO VPRE2.
      ************
      ************
       WR002.
           IF CFT-TDOC = 3 OR 6
      **** rel 4.0
      *        SUBTRACT VPRE FROM STA-VMES (MM9)
               SUBTRACT VPRE2 FROM STA-VMES (MM9)
      ************
               GO TO WR004.
      **** rel 4.0
      *    ADD VPRE TO STA-VMES (MM9).
           ADD VPRE2 TO STA-VMES (MM9).
      ************
       WR004.
           IF INVA = 1
              WRITE RF-STA INVALID KEY
                    PERFORM INVK-STA GO TO WARNING.
           IF INVA = 0
              REWRITE RF-STA INVALID KEY
                      PERFORM INVK-STA GO TO WARNING.
       EX-STATISTI.
           EXIT.
      *----------------------*
       D00-AGG-MAG.
           MOVE ZERO TO K.
       D10.
           ADD 1 TO K.
      **** rel 1.2
      *    IF K > 15 GO TO D99.
      *    IF CF-VTNUM (K) = ZERO GO TO D99.
           IF K > RB-ULTBOL GO TO D99.
           IF RB-TNUM(K) = ZERO GO TO D99.
      ************
      **** rel 5.1
           MOVE LOW-VALUE TO KEYCR.
      ************
           MOVE KAZ-COD TO KBC-AZI KCR-AZI.
      **** rel 1.2
      *    MOVE CF-VTNUM (K) TO KBC-NUM KCR-NUM.
      *    MOVE CF-VNBOL (K) TO KBC-BOL KCR-BOL.
           MOVE RB-TNUM(K) TO KBC-NUM KCR-NUM.
           MOVE RB-NBOL(K) TO KBC-BOL KCR-BOL.
      ************
           READ BOLCTE INVALID
                PERFORM INVK-BCT GO TO WARNING.
      **** rel 4.0
      *    IF BCT-VALUT = 0 OR 1 GO TO D10.
           IF BCT-VALUT = 0 OR COMEURO GO TO D10.
      ************
           MOVE ZERO TO PARMAG M-ODAT M-NDAT.
           MOVE 'V'       TO M-TIPO.
           MOVE KBC-AZI   TO M-AZI.
           MOVE BCT-TDOC  TO M-TDOC.
           MOVE KBC-NUM   TO M-TNUM.
           MOVE KBC-BOL   TO M-NBOL.
           MOVE BCT-CLI   TO COD.
           MOVE CODCLI    TO M-CLFO.
           MOVE BCT-CDEP  TO M-DEP1.
           MOVE BCT-DATA  TO M-ODAT M-NDAT.
           MOVE BCT-CAUS  TO M-NCA1.
           MOVE BCT-VALUT TO M-NVAL.
           MOVE BCT-CAMGG TO M-NCAM.
           MOVE BCT-CPAG  TO M-NPAG.
           START BOLCRI KEY NOT < KEYCR INVALID GO TO D10.
       D20.
           READ BOLCRI NEXT AT END GO TO D10.
           IF SF-BCR = '9D' OR '9A' OR '35' GO TO D20.
           IF KCR-AZI NOT = KBC-AZI GO TO D10.
           IF KCR-NUM NOT = KBC-NUM GO TO D10.
           IF KCR-BOL NOT = KBC-BOL GO TO D10.
           IF BCR-TCOR > 0 AND < 4 GO TO D20.
           IF BCR-TCOR > 6 GO TO D20.
           IF BCR-ART = SPACE GO TO D20.
           MOVE BCR-TCOR  TO M-TCOR.
           MOVE BCR-ART   TO M-ART.
           MOVE BCR-UM    TO M-UNM.
           MOVE BCR-NMOV  TO M-ONUM.
           MOVE BCR-QTA   TO M-NQTA.
           MOVE BCR-NETRG TO M-NIMP.
           MOVE ZERO      TO M-STAT.
           CALL 'vrmvmag' USING PARMAG.
           GO TO D20.
       D99.
           EXIT.
      * ---------------- *
       V00-AGG-BOL.
           MOVE ZERO TO K.
       V10.
           ADD 1 TO K.
      **** rel 1.2
      *    IF K > 15 GO TO V99.
      *    IF CF-VTNUM (K) = ZERO GO TO V99.
      *    MOVE KAZ-COD TO KBC-AZI.
      *    MOVE CF-VTNUM (K) TO KBC-NUM.
      *    MOVE CF-VNBOL (K) TO KBC-BOL.
           IF K > RB-ULTBOL GO TO V99.
           IF RB-TNUM(K) = ZERO GO TO V99.
           MOVE KAZ-COD TO KBC-AZI.
           MOVE RB-TNUM(K) TO KBC-NUM.
           MOVE RB-NBOL(K) TO KBC-BOL.
      ************
      **** rel 5.1
       RD-BCT.
      *    READ BOLCTE INVALID
           READ BOLCTE KEPT LOCK INVALID
      ************
                PERFORM INVK-BCT GO TO WARNING.
      **** rel 5.1
           IF SF-BCT NOT = ZERO
              PERFORM REC-LOCK
              GO TO RD-BCT.
      ************
           MOVE 1 TO BCT-FLGFT.
           MOVE CFT-TDOC TO BCT-NUDOC.
           MOVE CFT-NUM  TO BCT-NUFAT.
      **** rel 1.2
      *    MOVE COEFF TO BCT-CAMGG.
           MOVE CG-CAMBIO TO BCT-CAMGG.
      ************
           REWRITE RF-BCT INVALID PERFORM INVK-BCT
                                  GO TO WARNING.
      **** rel 5.1
           UNLOCK BOLCTE.
      ************
      **** rel 6.1
           MOVE ZERO      TO PPAR-FUN.
           MOVE 'BOL'     TO PPAR-TARC.
           MOVE 'A'       TO PPAR-TOPE.
           MOVE KEYBC     TO PPAR-KEY.
           MOVE BCT-CATT  TO PPAR-CATT.
           CALL 'vsrv133' USING PARPPAR TIP.
           IF PPAR-ERR > 1
              MOVE SPACE TO MESS
              STRING 'Errore chiamata vsrv133. Errore ' PPAR-ERR
                      DELIMITED SIZE INTO MESS
              GO TO ERRIO.
      ************
           GO TO V10.
       V99.
           EXIT.
      * ---------------- *
       Z00-RD-NUM.
      **** rel 7.2
      *    IF ATTIV = SPACE MOVE '0' TO ATTIV.
      *    READ ANAAZI INTO REKAZI KEPT LOCK INVALID KEY
      *         PERFORM INVK-AZI GO TO WARNING.
      *    IF SF-AZI NOT = ZERO
      *       PERFORM REC-LOCK
      *       GO TO Z00-RD-NUM.
      ************
           MOVE AZI-NEFF TO NUMEFF.
           IF NUMFAT NOT = ZERO GO TO Z99.
           IF AZI-FLGIS NOT = 1 GO TO Z10.
           MOVE 23 TO T23-TIP.
           MOVE KAZ-COD TO T23-COD.
           MOVE T23-KEYID TO KEYTB.
           READ TABELL INTO REKT23 INVALID KEY
                PERFORM INVK-TAB GO TO WARNING.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT23.
           MOVE T23-FTSOS TO NUMSOS.
       Z10.
           IF ATTIV = '0' MOVE AZI-NUMFT TO NUMFAT GO TO Z99.
           MOVE 35 TO T35-TIP.
           MOVE KAZ-COD TO T35-CDAZ.
           MOVE ATTIV TO T35-CATT.
           MOVE T35-KEYID TO KEYTB.
           READ TABELL INTO REKT35 INVALID KEY
                PERFORM INVK-TAB GO TO WARNING.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT35.
           MOVE T35-NUMFT TO NUMFAT.
       Z99.
           EXIT.
      * ---------------- *
       REC-LOCK.
      **** rel 1.2
           CALL 'rlock' USING PARLK.
      ************
           EXIT.
      * ---------------- *
       SOMMA-GG.
           IF NOT ( T04-1SCAD = 2 OR 4 ) GO TO EX-SOMMA-GG.
           MOVE ZERO TO IND.
       SOM10.
           ADD 1 TO IND.
           IF IND > T04-NRATE GO TO EX-SOMMA-GG.
           IF CFT-DTSCA (IND) = ZERPK GO TO EX-SOMMA-GG.
      **** rel 5.0-2
      *    ADD CLF-GSFM TO CFT-DTSCA (IND).
      **** rel 6.0
      *    IF T04-ESCMM = ZERO
      *       ADD CLF-GSFM TO CFT-DTSCA (IND)
      *    ELSE
      *       MOVE CFT-DTSCA (IND) TO AAGGG
      *       MOVE 2 TO TIPOP1
      *       CALL 'rdata' USING PARCDT
      *       IF (T04-ESCMM = 1 OR 3) AND MM9 = 8
      *          ADD CLF-GSESC TO CFT-DTSCA (IND)
      *       ELSE
      *          IF (T04-ESCMM = 2 OR 3) AND MM9 = 12
      *             ADD CLF-GSESC TO CFT-DTSCA (IND)
      *          ELSE
      *             ADD CLF-GSFM TO CFT-DTSCA (IND).
      ************
      **************
      **** rel 6.0
           MOVE ZERO TO FLGMCL.
           MOVE 1 TO K.
       VPG-0.
           IF K > 12 GO TO VPG-1.
           IF RACF-ESCM(K) = ZERO
              ADD 1 TO K
              GO TO VPG-0.
           MOVE 1 TO FLGMCL.
           GO TO VPG-4.
      *
       VPG-1.
           MOVE 1 TO K.
       VPG-2.
           IF K > 12 GO TO VPG-4.
           IF T04-ESCM(K) = ZERO
              ADD 1 TO K
              GO TO VPG-2.
      *
       VPG-4.
           MOVE CFT-DTSCA (IND) TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
      **** rel 6.1
           MOVE 1 TO COMGG.
           IF MM9 < 12 ADD MM9 TO COMGG.
      ************
           IF FLGMCL = 1
              IF RACF-ESCM(MM9) = 1
      **** rel 6.1
      *          IF CLF-GSESC NOT > GIO(MM9 + 1)
                 IF CLF-GSESC NOT > GIO(COMGG)
      ************
                    ADD CLF-GSESC TO CFT-DTSCA (IND)
                 ELSE
      **** rel 6.1
      *             ADD GIO(MM9 + 1)  TO CFT-DTSCA (IND)
                    ADD GIO(COMGG)  TO CFT-DTSCA (IND)
      ************
                 END-IF
              ELSE
                 ADD CLF-GSFM TO CFT-DTSCA (IND).

           IF FLGMCL = ZERO
              IF T04-ESCM(MM9) = 1
      **** rel 6.1
      *          IF CLF-GSESC NOT > GIO(MM9 + 1)
                 IF CLF-GSESC NOT > GIO(COMGG)
      ************
                    ADD CLF-GSESC TO CFT-DTSCA (IND)
                 ELSE
      **** rel 6.1
      *             ADD GIO(MM9 + 1)  TO CFT-DTSCA (IND)
                    ADD GIO(COMGG)  TO CFT-DTSCA (IND)
      ************
                 END-IF
              ELSE
                 ADD CLF-GSFM TO CFT-DTSCA (IND).
      ************
           GO TO SOM10.
       EX-SOMMA-GG.
           EXIT.
      * ---------------- *
           COPY 'errmes'.
      **** rel 1.2
           COPY 'erreur'.
      ************
           COPY 'griazier'.
           COPY 'griclfer'.
           COPY 'gribcter'.
           COPY 'gribcrer'.
      **** rel 2.0
           COPY 'gripbrer'.
      ************
           COPY 'grifater'.
           COPY 'grieffer'.
           COPY 'gristaer'.
      **** rel 1.2
      *    COPY 'gricgger'.
           COPY 'gribfaer'.
      ************
           COPY 'gritaber'.
      **** rel 5.0
           COPY 'griaimer'.
      ************
      **** rel 7.1
           COPY 'griafter'.
           COPY 'griacter'.
      ************
           COPY 'grixxxer'.
      * ---------------- *
      **** rel 5.0
       WR-LAV-IMB.
           OPEN OUTPUT WDSSIB.
           CLOSE WDSSIB.
           OPEN I-O WDSSIB.
           MOVE ZERO TO KWSI-PRG.
      *
           MOVE KBC-AZI TO KPBR-AZI.
           MOVE KBC-NUM TO KPBR-TNUM.
           MOVE KBC-BOL TO KPBR-NBOL.
           MOVE ZERO    TO KPBR-RBOL.
           MOVE ZERO    TO KPBR-PGR.
           START PROBCR KEY NOT < KEYPBR INVALID GO TO EX-WR-LAV-IMB.
       LAV-IMB-10.
           READ PROBCR NEXT AT END GO TO EX-WR-LAV-IMB.
           IF SF-PBR = '9D' OR '9A' OR '35' GO TO LAV-IMB-10.
           IF KBC-AZI  NOT = KPBR-AZI GO TO EX-WR-LAV-IMB.
           IF KBC-NUM NOT = KPBR-TNUM GO TO EX-WR-LAV-IMB.
           IF KBC-BOL NOT = KPBR-NBOL GO TO EX-WR-LAV-IMB.
           IF PBR-IMB = ZERO OR SPACE GO TO LAV-IMB-10.
      *
           MOVE KBC-AZI TO KAIM-AZI.
           MOVE PBR-IMB TO KAIM-COD.
           READ ANAIMB INVALID PERFORM INVK-AIM
                               PERFORM VISK-PBR
                               GO TO ERRIO.
           IF AIM-FLGREND = 1 GO TO LAV-IMB-10.
      *
           MOVE PBR-NPAL TO KWSI-NPAL.
           MOVE PBR-NCOL TO KWSI-NCOL.
           MOVE PBR-IMB  TO KWSI-IMB.
           ADD 1         TO KWSI-PRG.
           MOVE PBR-NIMB TO WSI-NIMB.
           WRITE RF-WSI INVALID MOVE 'vfat190: WR-LAV WSI' TO MESS
                                GO TO ERRIO.
      *
           GO TO LAV-IMB-10.
       EX-WR-LAV-IMB.
           EXIT.
      *-----------------
       SOMMA-IMBALLI.
      * azzeramento vettore totali imballi
           MOVE 1 TO INDICE.
           PERFORM UNTIL INDICE > 30
              MOVE SPACE TO VETIMB(INDICE)
              MOVE ZERO  TO VETQTA(INDICE)
              ADD 1 TO INDICE
           END-PERFORM.
      *
           MOVE ZERO  TO PREPAL PRECOL.
           MOVE SPACE TO PREIMB.
           MOVE ZERO  TO ULTIND.
      *
           MOVE LOW-VALUE TO KEYWSI.
           START WDSSIB KEY > KEYWSI INVALID GO TO SOMMA-IMB-90.
       SOMMA-IMB-10.
           READ WDSSIB NEXT AT END GO TO SOMMA-IMB-90.
           IF KWSI-NCOL = ZERO
              MOVE WSI-NIMB TO COMNIMB
              GO TO SOMMA-IMB-20.
           IF KWSI-NPAL = PREPAL AND
              KWSI-NCOL = PRECOL AND
              KWSI-IMB  = PREIMB GO TO SOMMA-IMB-10.
           MOVE 1 TO COMNIMB.
       SOMMA-IMB-20.
           MOVE KWSI-NPAL TO PREPAL.
           MOVE KWSI-NCOL TO PRECOL.
           MOVE KWSI-IMB  TO PREIMB.
      *
           MOVE 1 TO INDICE.
           PERFORM UNTIL INDICE > 30
              IF VETIMB(INDICE) = SPACE
                 MOVE KWSI-IMB TO VETIMB(INDICE)
                 MOVE COMNIMB  TO VETQTA(INDICE)
                 MOVE INDICE TO ULTIND
                 MOVE 30 TO INDICE
              ELSE
                 IF VETIMB(INDICE) = KWSI-IMB
                     ADD COMNIMB TO VETQTA(INDICE)
                     MOVE 30 TO INDICE
                 END-IF
              END-IF
              ADD 1 TO INDICE
           END-PERFORM.
      *
           GO TO SOMMA-IMB-10.
       SOMMA-IMB-90.
           CLOSE WDSSIB.
       EX-SOMMA-IMBALLI.
           EXIT.
      *-----------------
       ADDEBITA-IMBALLI.
           MOVE ZERO TO SPSRR SPAGG SPARR.
           MOVE ZERO TO COMRIV OMAGGI.
      *
           MOVE ZERO TO INDICE.
       ADD-IMB-10.
           ADD 1 TO INDICE.
           IF INDICE > ULTIND        GO TO ADD-IMB-90.
           IF VETIMB(INDICE) = SPACE GO TO ADD-IMB-90.
      *
           MOVE KBC-AZI        TO KAIM-AZI.
           MOVE VETIMB(INDICE) TO KAIM-COD.
           READ ANAIMB INVALID PERFORM INVK-AIM
                               GO TO ERRIO.
      *
      **** rel 4.0
      *    IF VALUT > 1
           IF NOT (VALUT = ZERO OR COMEURO)
      ************
              MOVE AIM-COSU TO ER-IMPORTO
      **** rel 4.0
      *       CALL 'rtriimp' USING ER-IMPORTO LIR-VAL CG-PAR
              MOVE CG-VALUT  TO ER-VALUT
              MOVE CG-CAMBIO TO ER-CAMBIO
              CALL 're2imp' USING ER-IMPORTO EUR-VAL ER-VALUT ER-CAMBIO
      ************
      **** rel 4.0
      *       COMPUTE ER-IMPORTO = ER-IMPORTO * 100
              IF VALUT NOT = 1
                 COMPUTE ER-IMPORTO = ER-IMPORTO * 100
              END-IF
      ************
              COMPUTE OLDNETRG =  ER-IMPORTO * VETQTA(INDICE)
           ELSE
      **** rel 4.0
      *       COMPUTE OLDNETRG =  AIM-COSU * VETQTA(INDICE).
              COMPUTE OLDNETRG =  AIM-COSU * VETQTA(INDICE) * 100.
      ************
           MOVE AIM-CONTR TO BCR-CONTR.
           PERFORM RCONT THRU EX-RCONT.
      *
           MOVE OLDNETRG TO COMA.
           IF BCT-ESIVA NOT = ZERO
              MOVE BCT-ESIVA TO COMIVA
           ELSE
              MOVE AIM-CDIVA TO COMIVA.
      *
           PERFORM RIVA THRU EX-RIVA.
      *
           ADD OLDNETRG TO CFT-NTMER.
           GO TO ADD-IMB-10.
       ADD-IMB-90.
           MOVE 1 TO SWIMB.
       EX-ADDEBITA-IMBALLI.
           EXIT.
      *-----------------
       CREA-IDLAV.
           MOVE SPACE TO ID-WSI.
           STRING 'w0' PID DELIMITED SPACE INTO ID-WSI.
      **** rel 6.2
           MOVE SPACE TO ID-LAV.
           STRING 'w3' PID DELIMITED SPACE INTO ID-LAV.
      ************
       EX-CREA-IDLAV.
           EXIT.
      ************
      **** rel 2.0
      **** rel 5.0
      *SOMMA-IMBALLI.
      *    MOVE ZERO TO SPSRR SPAGG SPARR.
      *    MOVE ZERO TO COMRIV OMAGGI.
      *    MOVE KBC-AZI TO KPBR-AZI.
      *    MOVE KBC-NUM TO KPBR-TNUM.
      *    MOVE KBC-BOL TO KPBR-NBOL.
      *    MOVE ZERO    TO KPBR-RBOL.
      *    MOVE ZERO    TO KPBR-PGR.
      *    START PROBCR KEY NOT < KEYPBR INVALID GO TO SOMMA90.
      *SOMMA10.
      *    READ PROBCR NEXT AT END GO TO SOMMA90.
      *    IF SF-PBR = '9D' OR '9A' OR '35' GO TO SOMMA10.
      *    IF KBC-AZI  NOT = KPBR-AZI GO TO SOMMA90.
      *    IF KBC-NUM NOT = KPBR-TNUM GO TO SOMMA90.
      *    IF KBC-BOL NOT = KPBR-NBOL GO TO SOMMA90.
      *    IF PBR-IMB = ZERO GO TO SOMMA10.
      *    MOVE 80      TO KTB-TIP.
      *    MOVE PBR-IMB TO KTB-COD.
      *    READ TABELL INTO REKTAB INVALID KEY PERFORM INVK-TAB
      *                                        GO TO ERRIO.
      *    IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      *    IF VALUT > 1
      *       MOVE T80-COSU TO ER-IMPORTO
      *       CALL 'rtriimp' USING ER-IMPORTO LIR-VAL CG-PAR
      *       COMPUTE ER-IMPORTO = ER-IMPORTO * 100
      *       COMPUTE OLDNETRG =  ER-IMPORTO * PBR-NIMB
      *    ELSE
      *       COMPUTE OLDNETRG =  T80-COSU * PBR-NIMB.
      *    MOVE T80-CONTR TO BCR-CONTR.
      *    PERFORM RCONT THRU EX-RCONT.
      *    MOVE OLDNETRG TO COMA.
      *    IF BCT-ESIVA NOT = ZERO MOVE BCT-ESIVA TO COMIVA
      *    ELSE                    MOVE T80-CDIVA TO COMIVA.
      *    PERFORM RIVA THRU EX-RIVA.
      *    ADD OLDNETRG TO CFT-NTMER.
      *    GO TO SOMMA10.
      *SOMMA90.
      *    MOVE 1 TO SWIMB.
      *EX-SOMMA-IMBALLI.
      *    EXIT.
      * ---------------- *
      ************
      **** rel 4.0
      * fattura in Euro
       FTEURO.
           DIVIDE 100 INTO CFT-NTMER.
           DIVIDE 100 INTO CFT-IVRIV.
           DIVIDE 100 INTO CFT-SPBOL.
           DIVIDE 100 INTO CFT-SPBAN.
           DIVIDE 100 INTO CFT-SCFIN.
           DIVIDE 100 INTO CFT-OMAGG.
           DIVIDE 100 INTO CFT-SCONT.
           DIVIDE 100 INTO CFT-TOTFT.
      *
           MOVE 1 TO IND.
           PERFORM UNTIL IND > 6
              DIVIDE 100 INTO CFT-IMPON(IND)
              DIVIDE 100 INTO CFT-IMPOS(IND)
              ADD 1 TO IND
           END-PERFORM.
      *
           MOVE 1 TO IND.
           PERFORM UNTIL IND > 12
              DIVIDE 100 INTO CFT-IMPOR(IND)
              ADD 1 TO IND
           END-PERFORM.
      *
           MOVE 1 TO IND.
           PERFORM UNTIL IND > 15
              DIVIDE 100 INTO CFT-IMPCP(IND)
              ADD 1 TO IND
           END-PERFORM.
      *
       EX-FTEURO.
           EXIT.
      * ---------------- *
      * caricamento campi di parfat in valuta (solo per fattura Lire)
       FTLIRE.
           MOVE CFT-TOTFT TO CFT-TOVAL.
           MOVE CFT-NTMER TO CFT-ENTMER.
           MOVE CFT-IVRIV TO CFT-EIVRIV.
           MOVE CFT-SPBOL TO CFT-ESPBOL.
           MOVE CFT-SPBAN TO CFT-ESPBAN.
           MOVE CFT-SCFIN TO CFT-ESCFIN.
           MOVE CFT-OMAGG TO CFT-EOMAGG.
           MOVE CFT-SCONT TO CFT-ESCONT.
      *
           MOVE 1 TO IND.
           PERFORM UNTIL IND > 6
              MOVE CFT-IMPON(IND) TO CFT-EIMPON(IND)
              MOVE CFT-IMPOS(IND) TO CFT-EIMPOS(IND)
              ADD 1 TO IND
           END-PERFORM.
      *
           MOVE 1 TO IND.
           PERFORM UNTIL IND > 12
              MOVE CFT-IMPOR(IND) TO CFT-EIMPOR(IND)
              ADD 1 TO IND
           END-PERFORM.
      *
           MOVE 1 TO IND.
           PERFORM UNTIL IND > 15
              MOVE CFT-IMPCP(IND) TO W-EIMPCP(IND)
              ADD 1 TO IND
           END-PERFORM.
      * vettore di comodo in memoria
           MOVE 1 TO IND.
           PERFORM UNTIL IND > 6
              MOVE IVRIV(IND)  TO W-IVRIV(IND)
              MOVE OMAGIV(IND) TO W-OMAGIV(IND)
              ADD 1 TO IND
           END-PERFORM.
       EX-FTLIRE.
           EXIT.
      ************
      **** rel 6.1
      * ---------------- *
       CALC-RITENUTA.
           MOVE ZERO TO RITE.
           IF PBASE = ZERO OR PRACC = ZERO GO TO EX-CALC-RITENUTA.
      *
           MOVE ZERO TO K IMPRIT.
       LSCA.
           ADD 1 TO K.
           IF K > 6 GO TO GSCA.
           IF CFT-CDIVA (K) = ZERO GO TO GSCA.
           MOVE CFT-CDIVA (K) TO KTB-COD.
           MOVE 3 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T03-TPIVA NOT = ZERO GO TO LSCA.
           IF VALUT = ZERO OR COMEURO
              ADD  CFT-IMPON(K)  TO IMPRIT
           ELSE
              ADD  CFT-EIMPON(K) TO IMPRIT.
           GO TO LSCA.
       GSCA.
           COMPUTE RD-NUM = (IMPRIT / 100) * PBASE.
           MOVE RD-NUM TO ER-IMPORTO.
           MOVE ZERO   TO ER-VALUT.
           MOVE PRACC  TO COM-ALIVA.
           CALL 're2iva' USING ER-IMPORTO ER-VALUT COM-ALIVA.
           MOVE ER-IMPORTO TO RITE.
      *
           MOVE 4 TO KTB-TIP.
           MOVE CFT-CDPAG TO KTB-COD.
           READ TABELL INTO REKTAB INVALID KEY
                PERFORM INVK-TAB
                GO TO WARNING.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      *
           COMPUTE RD-NUM = RITE / T04-NRATE.
           CALL 'vrround' USING NNN-E PARRD DEC-2.
           MOVE RD-NUM TO COMRR.
           COMPUTE COM1R = T04-NRATE - 1.
           COMPUTE COMURR = RITE - (COMRR * COM1R).
       EX-CALC-RITENUTA.
           EXIT.
      ************
      **** rel 6.2
      *------------------
       CERCA-CONTA.
           MOVE ZERO TO CONTA.
           MOVE LOW-VALUE TO KEYLAV.
           START WDSLAV KEY > KEYLAV INVALID GO TO EX-CERCA-CONTA.
       RDN-LAV.
           READ WDSLAV NEXT AT END GO TO EX-CERCA-CONTA.
           MOVE KLAV-CONTA TO CONTA.
           GO TO RDN-LAV.
       EX-CERCA-CONTA.
           EXIT.
      ************
