       IDENTIFICATION DIVISION.
       PROGRAM-ID. VRXT50. 
      *
      *    Interfaccia TABELL per list box (t50)
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'gritabsl'.   
       DATA DIVISION.
       FILE SECTION.
           COPY 'gritab'.   
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.   
           COPY 'grit50rk'.    
           COPY 'parzf'.
           COPY 'parmc'.
       01  ID-TAB  PIC X(15) VALUE 'tabell'.
       01  SF-TAB  PIC XX.
       01  AREE.
           05 MESS    PIC X(40).
           05 FUN     PIC X.
           05 IDX     PIC 9.
           05 SEZ     PIC 9.
           05 NUM     PIC 999.
           05 NUMC    PIC 999.
           05 EOF     PIC 9.
           05 LETTI   PIC 999.
           05 RIGRIF  PIC 999.
           05 NR      PIC 999.
           05 K1      PIC 999.
           05 KMAX    PIC 999   VALUE ZERO.
           05 TABK    PIC X(3)  OCCURS 100.
           05 KRIFER  PIC X(30).
           05 LNSEZ   PIC 999.
           05 INCR    PIC S9.
           05 LF      PIC X     VALUE X'0A'.
           05 SWTROVA PIC 9.
       LINKAGE SECTION.
           COPY 'gritabrx'.
       01  IF-BUFF.
           05 SEZ1.
              10 RIG1 OCCURS 100.
                 15 CODF1   PIC X(2).
                 15 COD1    PIC 9(2).
                 15 FILLER  PIC X.
                 15 DESCR   PIC X(50).
                 15 LF1     PIC X.
       01  IF-MESS    PIC X(204).
       PROCEDURE DIVISION USING GS-TAB-SHARED
                                RX-TAB-CTRL
                                IF-BUFF
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dcltab'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO RX-TAB-ST RX-TAB-LETTI RX-TAB-NBYTE.
           MOVE SPACE TO IF-MESS.
           MOVE GS-TAB-FUN TO FUN.
      *
      * funzioni che trattano record
           IF FUN = 'X'
              PERFORM CONTROLLA-POS
              MOVE ZERO TO GS-TAB-SEL
              MOVE TABK(RX-TAB-POS) TO GS-TAB-COX
              IF TABK(RX-TAB-POS) NUMERIC
                 MOVE TABK(RX-TAB-POS) TO GS-TAB-COD
              ELSE
                 MOVE ZERO             TO GS-TAB-COD
              END-IF
              GO TO ESCI.
      *       
           IF FUN NOT = 'Z' MOVE ZERO TO RX-TAB-EOF.
      *
      * funzioni che restituiscono buffer
           MOVE ZERO  TO RX-TAB-POS.
           MOVE GS-TAB-IDX TO IDX.
           MOVE GS-TAB-SEZ TO SEZ.
           MOVE RX-TAB-NUM TO NUM.
      **** rel 1.2
           IF FUN = 'F' OR 'L' OR 'C'
              MOVE ZERO TO SWTROVA.
           IF FUN = 'K'
              MOVE 1   TO SWTROVA
              MOVE 'F' TO FUN.
           IF SWTROVA > ZERO
              MOVE 20  TO NUM.
      ************
           IF NOT (FUN = 'F' OR 'L' OR 'C' OR 'B' OR 'T' OR 'Z')
              MOVE 'F' TO FUN.
           IF (FUN = 'B' OR 'T' OR 'Z') PERFORM CONTROLLA-KMAX.
           IF NOT (IDX = 1) MOVE 1 TO IDX.
           IF SEZ = ZERO MOVE 1    TO SEZ.
           IF NUM = ZERO MOVE 80   TO NUM.
           IF FUN = 'T'  MOVE 1    TO RIGRIF.
           IF FUN = 'B'  MOVE KMAX TO RIGRIF.
           IF FUN = 'T' OR 'L'
              MOVE NUM TO NR
           ELSE
              MOVE 1   TO NR.
           MOVE NUM TO NUMC.
           IF FUN = 'C' COMPUTE NUMC = NUM / 2 + 1.

           IF GS-TAB-FL = 1
              MOVE 'tabold' TO ID-TAB
           ELSE
              MOVE 'tabell' TO ID-TAB.
      **** rel 4.1
           IF GS-TAB-FL = 2 MOVE 'tabold' TO ID-TAB.
      ************
           OPEN INPUT TABELL.
           IF FUN = 'Z' PERFORM CAMBIA-SEZ THRU EX-CAMBIA-SEZ
                        GO TO QUIT1.
       INI00.
           MOVE ZERO TO EOF LETTI.
           IF FUN = 'T' OR 'L'
              MOVE -1  TO INCR
           ELSE
              MOVE 1   TO INCR.
           PERFORM MOVE-KEY THRU EX-MOVE-KEY.
           IF IDX = 1 PERFORM START-IDX1.
           IF EOF > ZERO GO TO ENDATI.

      * cerca primo record nel range richiesto
       CERCA.
           PERFORM READ-N-P.
           IF EOF > ZERO GO TO ENDATI.
           IF FUN = 'F' OR 'L' OR 'C' GO TO CARBUF.
           IF IDX = 1 GO TO CER90.
      *    ( controlla tramite chiave primaria se il record letto da
      *      secondario e' quello richiesto )
           IF KEYTB NOT = KRIFER GO TO CERCA.
       CER90.
           PERFORM READ-N-P.
           IF EOF > ZERO GO TO ENDATI.

      * carica buffer
       CARBUF.
           PERFORM TEST-EOL THRU EX-TEST-EOL.
           IF EOF > ZERO GO TO ENDATI.
       CARB10.
           PERFORM MOVE-REC THRU EX-MOVE-REC.
           IF LETTI >= NUMC GO TO ENDATI.
           PERFORM READ-N-P.
           IF EOF > ZERO GO TO ENDATI.
           GO TO CARBUF.

      * fine ciclo di letture / caricamento buffer
       ENDATI.
           SUBTRACT INCR FROM NR.
           IF FUN = 'F' MOVE 1 TO RX-TAB-EOF.
           IF FUN = 'L' MOVE 3 TO RX-TAB-EOF.
           ADD EOF   TO RX-TAB-EOF.
           ADD LETTI TO RX-TAB-LETTI.
           IF RX-TAB-LETTI = NUM  GO TO QUIT.
           IF RX-TAB-EOF = 4 GO TO ENDBUF.
     
      * incontrato BOF/EOF prima di aver letto NUM records o
      *    funzione C da completare: shift buffer indietro/avanti
      *    e tenta di inserire altri record in coda/testa
           IF RX-TAB-LETTI > ZERO GO TO SHIFT.
           IF FUN = 'T' OR 'L'
              MOVE 'F' TO FUN
              MOVE 1   TO NR
           ELSE
              MOVE 'L' TO FUN
              MOVE NUM TO NR.
           MOVE NUM TO NUMC.
           GO TO INI00.
       SHIFT.
           IF FUN = 'T' OR 'L'
              PERFORM SHIFT-BUF-INDIETRO
              MOVE RX-TAB-LETTI TO RIGRIF
              COMPUTE NR = RIGRIF + 1
              MOVE 'B' TO FUN
           ELSE
              PERFORM SHIFT-BUF-AVANTI
              COMPUTE NR = NUM - RX-TAB-LETTI
              COMPUTE RIGRIF = NR + 1
              MOVE 'T' TO FUN.
           COMPUTE NUMC = NUM - RX-TAB-LETTI.
           GO TO INI00.

      * buffer completato
       ENDBUF.
           IF FUN = 'T' OR 'L' PERFORM SHIFT-BUF-INDIETRO.
           PERFORM BLANK-BUF.

       QUIT.
           MOVE RX-TAB-LETTI TO KMAX.
           IF RX-TAB-EOF = 4 MOVE 2 TO RX-TAB-EOF.
           IF RX-TAB-POS = ZERO
              IF FUN = 'T' OR 'L'
                 MOVE RX-TAB-LETTI TO RX-TAB-POS
              ELSE
                 MOVE 1 TO RX-TAB-POS.
       QUIT1.
           PERFORM LENGTH-SEZ.
           COMPUTE RX-TAB-NBYTE = LNSEZ * RX-TAB-LETTI.
           GO TO FINE.
      *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO RX-TAB-ST.
       FINE.
           CLOSE TABELL.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO RX-TAB-ST.
           EXIT PROGRAM.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *--------
      *LCK.
      *    MOVE ZERO TO X-WIND.
      *    CALL 'rxcnf' USING PARX CNFLCK.
      *    MOVE X-COD TO RISP.
      *    MOVE ZERO TO X-COD.
      *    MOVE SPACE TO X-COX.
      *    MOVE 1 TO X-ST.
      *EX-LCK.
      *    EXIT.
      *------------------
       CONTROLLA-KMAX.
           IF KMAX = ZERO
              MOVE 'vrxt50: Funzione non ammessa' TO MESS
              GO TO ERRIO.
      *------------------
       CONTROLLA-POS.
           PERFORM CONTROLLA-KMAX.
           IF RX-TAB-POS = ZERO OR RX-TAB-POS > KMAX
              MOVE 'vrxt50: Parametro POS non corretto' TO MESS
              GO TO ERRIO.
      *------------------
       SHIFT-BUF-INDIETRO.
           IF RX-TAB-POS = ZERO MOVE NUM TO RX-TAB-POS.
           MOVE 1 TO K1.
           PERFORM UNTIL K1 > RX-TAB-LETTI
              MOVE RIG1(NR) TO RIG1(K1)
              MOVE TABK(NR) TO TABK(K1)
              ADD 1 TO K1 NR
           END-PERFORM.
           COMPUTE RX-TAB-POS = RX-TAB-POS - ( NUM - RX-TAB-LETTI ).
      *------------------
       SHIFT-BUF-AVANTI.
           IF RX-TAB-POS = ZERO MOVE 1 TO RX-TAB-POS.
           MOVE NUM TO K1.
           PERFORM UNTIL NR = ZERO
              MOVE RIG1(NR) TO RIG1(K1)
              MOVE TABK(NR) TO TABK(K1)
              SUBTRACT 1 FROM K1 NR
           END-PERFORM.
           COMPUTE RX-TAB-POS = RX-TAB-POS + ( NUM - RX-TAB-LETTI ).
      *------------------
      * pulisce righe buffer non caricate
       BLANK-BUF.
           COMPUTE NR = RX-TAB-LETTI + 1.
           PERFORM UNTIL NR > NUM
              MOVE SPACE TO RIG1(NR)
              ADD 1 TO NR
           END-PERFORM.
      *------------------
       LENGTH-SEZ.
           IF RX-TAB-LETTI = ZERO
              MOVE ZERO TO LNSEZ
           ELSE
              MOVE 1 TO LNSEZ
              PERFORM UNTIL IF-BUFF(LNSEZ:1) = LF ADD 1 TO LNSEZ.
      *------------------
       START-IDX1.
           IF FUN = 'T' OR 'L'
              START TABELL KEY <= KEYTB INVALID MOVE 1 TO EOF
           ELSE
              START TABELL KEY >= KEYTB INVALID MOVE 3 TO EOF.
      *------------------
       READ-N-P.
           IF FUN = 'T' OR 'L'
              READ TABELL PREVIOUS INTO REKT50 AT END MOVE 1 TO EOF
           ELSE
              READ TABELL NEXT INTO REKT50 AT END MOVE 3 TO EOF.
      *------------------
       MOVE-KEY.
           MOVE LOW-VALUE TO KEYTB.
           IF FUN = 'L' MOVE HIGH-VALUE TO KEYTB.
      * caricamento campi chiave fissi
           MOVE GS-TAB-TIP TO KTB-TIP.
      * ---
           IF FUN = 'C'        GO TO MOVE-KEY-C.
           IF FUN = 'B' OR 'T' GO TO MOVE-KEY-N-P.
           GO TO EX-MOVE-KEY.
       MOVE-KEY-C.
           IF IDX = 1 MOVE GS-TAB-VAL-1  TO KTB-COD.
           GO TO EX-MOVE-KEY.
       MOVE-KEY-N-P.
           MOVE TABK(RIGRIF) TO KTB-COD.
           MOVE KEYTB TO KRIFER.
           IF IDX = 1 GO TO EX-MOVE-KEY.
      * acquisizione chiavi secondarie tramite lettura da primario
       EX-MOVE-KEY.
           EXIT.
      *------------------
      * test End Of File logico
      *    Nota: testare anche chiave < (per read previous)
      *
       TEST-EOL.
           IF RF-TAB = LOW-VALUE GO TO EX-TEST-EOL.
           IF IDX > 1 GO TO TEST-EOL-IDX2.
           IF KTB-TIP = GS-TAB-TIP GO TO EX-TEST-EOL.
           IF FUN = 'T' OR 'L'
              MOVE 1 TO EOF
           ELSE
              MOVE 3 TO EOF.
           GO TO EX-TEST-EOL.
       TEST-EOL-IDX2.
       EX-TEST-EOL.
           EXIT.
      *------------------
       MOVE-REC.
           IF RF-TAB = LOW-VALUE GO TO EX-MOVE-REC.
      *
      *    ( inserire qui controlli se ci sono records
      *      da escludere prima di incontrare BOF/EOF:
      *      per skip record GO TO EX-MOVE-REC )
      *

      **** rel 1.2
           IF SWTROVA > ZERO
              MOVE T50-DESCR    TO MC-STR
              MOVE GS-TAB-VAL-2 TO MC-EXP
              CALL 'rmatch' USING PARMC
              IF MC-ST > ZERO GO TO EX-MOVE-REC.
      ************
      *
       MOVE-SEZ1.
           MOVE SPACE      TO RIG1(NR).
           MOVE 'MP'       TO CODF1(NR).
           MOVE KTB-COD    TO COD1(NR).
           MOVE T50-DESCR  TO DESCR(NR).
       MOVE-END.

           MOVE LF TO LF1(NR).
           MOVE KTB-COD TO TABK(NR).
           ADD 1 TO LETTI.
           ADD INCR TO NR.
       EX-MOVE-REC.
           EXIT.
      *------------------
       CAMBIA-SEZ.
       EX-CAMBIA-SEZ.
           EXIT.
      *------------------
