       IDENTIFICATION DIVISION.
       PROGRAM-ID. VFAT160.
      *
      * OGGETTO: Aggancio fatture in contabilita'
      *
      * Nota: IF-CAMPO puo' restituire 'AMM-SI' durante la RUN-ELABORA
      *       per fare in modo che l'interfaccia lanci l'aggancio
      *       ai cespiti.
      *
      **** rel 5.0
      * Ricompilato per variazione tracciato EFFETT
      ************
      **** rel 5.2
      * Nota: IF-CAMPO2 puo' restituire 'AVE-SI' durante la RUN-ELABORA
      *       per fare in modo che l'interfaccia lanci il vcon110 per
      *       aprire Inserimento Prima Nota V. ES.
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griconsl'.
      **** rel 7.1
           COPY 'griacosl'.
      ************
           COPY 'grifatsl'.
           COPY 'grieffsl'.
           COPY 'griclfsl'.
           COPY 'gricamsl'.
           COPY 'griaccsl'.
           COPY 'gribctsl'.
      **** rel 1.2
      *    COPY 'gricggsl'.
      ************
      **** rel 5.0
           COPY 'griscasl'.
      ************
           COPY 'gritabsl'.
           COPY 'gri135sl'.
      **** rel 5.2
           SELECT WDSLA3 ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYL3 STATUS SF-LA3.
      ************
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gricon'.
      **** rel 7.1
           COPY 'griaco'.
      ************
           COPY 'grifat'.
           COPY 'grieff'.
           COPY 'griclf'.
           COPY 'gricam'.
           COPY 'griacc'.
           COPY 'gribct'.
      **** rel 1.2
      *    COPY 'gricgg'.
      ************
      **** rel 5.0
           COPY 'grisca'.
      ************
           COPY 'gritab'.
           COPY 'gri135'.
      **** rel 5.2
       FD  WDSLA3 LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LA3
           RECORD 71 DATA RECORD RF-LA3.
       01  RF-LA3.
           05 KEYL3.
              10 KL3-PROGR   PIC 9(3).
              10 KL3-DTREG   PIC 9(5).
           05 RECLA3.
              10 LA3-CAUS    PIC 9(3).
              10 LA3-CPART   PIC 9(7).
              10 LA3-IMPOR   PIC S9(11)V99.
              10 LA3-DESAG   PIC X(30).
              10 LA3-DOCUM   PIC 9(5).
              10 LA3-DTDOC   PIC 9(5).
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'gritabrk'.
           COPY 'rekt23'.
           COPY 'griclfrk'.
           COPY 'grit35rk'.
           COPY 'griazirk'.
           COPY 'grit25rk'.
      **** rel 7.1
           COPY 'griconrk'.
      ************
           COPY 'grit14h'.
           COPY 'paraf'.
           COPY 'parcf'.
           COPY 'parcdt'.
      **** rel 1.2
      *    COPY 'parsv'.
      ************
           COPY 'parzf'.
           COPY 'parmb'.
      **** rel 1.2
           COPY 'parer'.
           COPY 'parrb'.
           COPY 'parlk'.
      ************
      **** rel 6.1
           COPY 'parrd'.
      ************
           COPY 'wrklav'.
       01  SWOPN   PIC X VALUE SPACE.
       01  DTCON   PIC 9(5) COMP-3.
       01  RET     PIC XXX VALUE SPACE.
      **** rel 5.0
       01  MNREG   PIC 9(5) VALUE ZERO.
      ************
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-FAT PIC X(15) VALUE 'fattur'.
       01  ID-EFF PIC X(15) VALUE 'effett'.
       01  ID-CON PIC X(15) VALUE 'anacon'.
      **** rel 7.1
       01  ID-ACO PIC X(15) VALUE 'appcon'.
      ************
       01  ID-MOV PIC X(15) VALUE 'movime'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-TAC PIC X(15) VALUE 'tacoam'.
       01  ID-ACC PIC X(15) VALUE 'accont'.
       01  ID-BCT PIC X(15) VALUE 'bolcte'.
      **** rel 1.2
      *01  ID-CGG PIC X(15) VALUE 'camgio'.
      ************
      **** rel 5.0
       01  ID-SCA PIC X(15) VALUE 'anasca'.
      ************
       01  ID-135 PIC X(15) VALUE 'wds135'.
      **** rel 5.2
       01  ID-LA3  PIC X(15).
      ************
       01  COMODI.
           05 SF-TAB PIC XX.
           05 SF-AZI PIC XX.
           05 SF-FAT PIC XX.
           05 SF-EFF PIC XX.
           05 SF-CON PIC XX.
      **** rel 7.1
           05 SF-ACO PIC XX.
      ************
           05 SF-CLF PIC XX.
           05 SF-TAC PIC XX.
           05 SF-ACC PIC XX.
           05 SF-BCT PIC XX.
      **** rel 1.2
      *    05 SF-CGG PIC XX.
      ************
      **** rel 5.0
           05 SF-SCA PIC XX.
      ************
           05 SF-135 PIC XX.
      **** rel 5.2
           05 SF-LA3 PIC XX.
      ************
           05 MESS     PIC X(40) VALUE SPACE.
      *
      **** rel 6.2
           05 FLGFTP PIC 9.
           05 ETOT1    PIC S9(11)V99  VALUE ZERO.
           05 TOT1     PIC S9(11)V99  VALUE ZERO.
           05 SAV-SCADE OCCURS 12.
              10 SAV-DTSCA PIC 9(5).
              10 SAV-EIMPOR PIC S9(11)V99.
              10 SAV-TPAG PIC 9.
      ************
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
      **** rel 4.0
      *    05 TOTACC PIC S9(11) VALUE ZERO.
      *    05 TOTACR PIC S9(11) VALUE ZERO.
      *    05 TOTACCZ PIC ZZZZZ.ZZZ.ZZ9- VALUE ZERO.
           05 TOTACC PIC S9(11)V99 VALUE ZERO.
           05 TOTACR PIC S9(11)V99 VALUE ZERO.
           05 TOTACCZ PIC ZZ.ZZZ.ZZ9,99- VALUE ZERO.
      ************
           05 FATT PIC 9(5) VALUE ZERO.
           05 FATTZ PIC ZZZZ9 VALUE ZERO.
           05 RICAV PIC 9(7) VALUE ZERO.
      **** rel 5.2
           05 RICCGR PIC 9(7) VALUE ZERO.
           05 RICSCM PIC 9(7) VALUE ZERO.
      ************
           05 CODCLI.
              10 MAS PIC 99 VALUE ZERO.
              10 COD PIC 9(5) VALUE ZERO.
           05 CODCLR REDEFINES CODCLI PIC 9(7).
      **** rel 4.0
      *    05 COMIMP PIC S9(11) VALUE ZERO.
           05 COMIMP PIC S9(11)V99 VALUE ZERO.
      ************
           05 IND PIC 99 VALUE ZERO.
           05 IND1 PIC 99 VALUE ZERO.
           05 IND2 PIC 99 VALUE ZERO.
           05 K  PIC 9(5) VALUE ZERO.
           05 K1 PIC 9    VALUE ZERO.
           05 DESAG PIC X(30) VALUE SPACE.
           05 RDESA REDEFINES DESAG.
              10 DES1 PIC X(9).
              10 DES2 PIC X(21).
           05 NFAT1  PIC X(5) VALUE SPACE.
           05 XNFAT1 REDEFINES NFAT1 PIC Z(5).
           05 NFAT2  PIC X(5) VALUE SPACE.
           05 XNFAT2 REDEFINES NFAT2 PIC Z(5).
           05 NFAT3  PIC X(5) VALUE SPACE.
           05 XNFAT3 REDEFINES NFAT3 PIC Z(5).
           05 NFAT4  PIC X(5) VALUE SPACE.
           05 XNFAT4 REDEFINES NFAT4 PIC Z(5).
           05 NFAT5  PIC X(5) VALUE SPACE.
           05 XNFAT5 REDEFINES NFAT5 PIC Z(5).
           05 NFAT   PIC X(5) VALUE SPACE.
           05 WNFAT1 REDEFINES NFAT.
              10 WFL1 PIC X.
              10 WNF1 PIC X(4).
           05 WNFAT2 REDEFINES NFAT.
              10 WFL2 PIC XX.
              10 WNF2 PIC XXX.
           05 WNFAT3 REDEFINES NFAT.
              10 WFL3 PIC XXX.
              10 WNF3 PIC XX.
           05 WNFAT4 REDEFINES NFAT.
              10 WFL4 PIC X(4).
              10 WNF4 PIC X.
      **** rel 5.2
           05 EFF-RAGGRU OCCURS 5.
              10 NUFAT PIC 9(5).
              10 DTFAT PIC 9(5).
              10 IMPEF PIC S9(11)V99.
              10 FLGS  PIC 9.
      ************
           05 L       PIC 99 VALUE ZERO.
           05 WFLGSC  PIC 9  VALUE ZERO.
           05 WDA     PIC X  VALUE SPACE.
           05 WSEGNO  PIC 9  VALUE ZERO.
           05 T14FATT PIC 999 VALUE ZERO.
           05 T14SPBOL PIC 9(7) VALUE ZERO.
           05 T14SPBAN PIC 9(7) VALUE ZERO.
           05 T14TRT   PIC 999 VALUE ZERO.
           05 T14RB    PIC 999 VALUE ZERO.
           05 T14TRATT PIC 9(7) VALUE ZERO.
           05 T14RIBAN PIC 9(7) VALUE ZERO.
           05 T14CSGR  PIC 9(7) VALUE ZERO.
           05 T14IVGR  PIC 9(7) VALUE ZERO.
           05 T14SCON  PIC 9(7) VALUE ZERO.
           05 T14RIC.
              10 T14RIC1 PIC 9(7) VALUE ZERO.
              10 T14RIC2 PIC 9(7) VALUE ZERO.
              10 T14RIC3 PIC 9(7) VALUE ZERO.
              10 T14RIC4 PIC 9(7) VALUE ZERO.
              10 T14RIC5 PIC 9(7) VALUE ZERO.
              10 T14RIC6 PIC 9(7) VALUE ZERO.
              10 T14RIC7 PIC 9(7) VALUE ZERO.
              10 T14RIC8 PIC 9(7) VALUE ZERO.
              10 T14RIC9 PIC 9(7) VALUE ZERO.
           05 T14RIC0 REDEFINES T14RIC PIC 9(7) OCCURS 9.
           05 T14ACCR  PIC 999.
           05 T14FTSO  PIC 999.
           05 T14ACSO  PIC 999.
      **** rel 7.2
           05 T01CIVSO PIC 9999999.
           05 TOTIMP   PIC S9(11)V9(6).
      ************
           05 DTM   PIC 9(6) VALUE ZERO.
           05 DTMB  PIC X(8)   VALUE SPACE.
           05 DTP   PIC 9(4) VALUE ZERO.
           05 DTPB  PIC ZZ/ZZZ9.
           05 DTP6.
              10 MM6 PIC 99 VALUE ZERO.
              10 AA6.
                 15 AA61 PIC 99 VALUE ZERO.
                 15 AA62 PIC 99 VALUE ZERO.
           05 TPL   PIC 9    VALUE ZERO.
           05 ANDOC PIC 9(4) VALUE ZERO.
           05 ANREG PIC 9(4) VALUE ZERO.
           05 PER99 PIC 9(6) VALUE ZERO.
           05 PERYY REDEFINES PER99.
              10 P99M PIC 99.
              10 P99A PIC 9(4).
           05 DTAIVA   PIC 9(5) COMP-3 VALUE ZERO.
           05 DATIVB   PIC X(8)  VALUE SPACE.
           05 T14ACCO  PIC 999   VALUE ZERO.
           05 T14CACC  PIC 9(7)  VALUE ZERO.
      **** rel 5.2
      *> comodi tabella 14L per conti fatt da emettere/ricevere
           05 VET-CONTI OCCURS 3.
              10 CP-FTEM   PIC 9(7).
              10 CP-NAEM   PIC 9(7).
           05 CAU-FTEM     PIC 999.
           05 FLAVE PIC 9    VALUE ZERO.
           05 CONT  PIC 99   VALUE ZERO.
           05 CONT1 PIC 9(5) VALUE ZERO.
      ************
           05 J        PIC 999   VALUE ZERO.
           05 J2       PIC 999   VALUE ZERO.
           05 FLAMM    PIC 9     VALUE ZERO.
           05 FLCNT    PIC 9     VALUE ZERO.
           05 MXNUM    PIC 9(5)  VALUE ZERO.
           05 SWGIS    PIC 9     VALUE ZERO.
           05 CTGIS    PIC 9     VALUE ZERO.
           05 NUMERO   PIC 9(5)  VALUE ZERO.
           05 NUM      PIC 9(5)  VALUE ZERO.
           05 DSFAT    PIC X(18) VALUE SPACE.
           05 CTCNT    PIC 9(5)  VALUE ZERO.
           05 VTCNT    PIC 9 OCCURS 200.
           05 PERIO PIC 9(6) VALUE ZERO.
           05 PERIX REDEFINES PERIO.
              10 PERM PIC 99.
              10 PERA PIC 9(4).
           05 DTCT1.
              10 PERAA PIC 9(4) VALUE ZERO.
              10 PERMA PIC 99   VALUE ZERO.
           05 DTCT2.
              10 PLFAA PIC 9(4) VALUE ZERO.
              10 PLFMM PIC 99   VALUE ZERO.
      **** rel 4.0
           05 COMEURO PIC 9(3).
           05 DTBIG   PIC 9(5).
      ************
      **** rel 5.0
           05 FLGTRA   PIC 9     VALUE ZERO.
           05 CLFIVA   PIC 9     VALUE ZERO.
           05 FLGSCA   PIC 9     VALUE ZERO.
           05 NEFFZ    PIC ZZZZ9 VALUE ZERO.
           05 DTEFF    PIC X(8)  VALUE SPACE.
      ************
      **** rel 5.0-2
           05 NUMFAT  PIC ZZZZ9  VALUE ZERO.
           05 TDOC    PIC 9      VALUE ZERO.
      **************
      **** rel 6.1
           05 IMPRIT    PIC S9(11)V99 VALUE ZERO.
           05 RITE      PIC S9(11)V99 VALUE ZERO.
           05 IMPO      PIC S9(11)V99 VALUE ZERO.
           05 COM-ALIVA PIC 9(3)V99   VALUE ZERO.
           05 COMR      PIC S9(11)V99 VALUE ZERO.
           05 COMUR     PIC S9(11)V99 VALUE ZERO.
           05 COM1      PIC 9(3) VALUE ZERO.
           05 L1        PIC 99 VALUE ZERO.
      **************
       01  REKTE14.
           05 FILLER    PIC X(5).
           05 T14IVER  PIC 9(7).
           05 T14RICO  PIC 9(7).
           05 T14GIIV  PIC 9(3).
           05 T14GICO  PIC 9(3).
           05 T14IDIR  PIC 9(3).
           05 T14ITRI  PIC 9(3).
           05 T14IIND  PIC 9(3).
           05 T14ISCV  PIC 9(3).
           05 T14IRSM  PIC 9(3).
           05 T14IASS  PIC 9(3).
           05 T14ISIN  PIC 9(3).
           05 T141ACQ  PIC 9(3).
           05 T141ACR  PIC 9(3).
           05 T141ACT  PIC 9(3).
           05 T142ACQ  PIC 9(3).
           05 T143ACQ  PIC 9(3).
      **** rel 7.2
      *    05 FILLER    PIC X(11).
           05 T14IPOS  PIC 9(3).
           05 T14GISO  PIC 9(3).
           05 FILLER    PIC X(5).
      ************
      **** rel NT 0.0
      *01  AM-PAR.
      *    05  AM-CDAZ     PIC 999.
      *    05  AM-DAZI     PIC X(36).
      *    05  AM-WPART    PIC 9(7).
      *    05  AM-WCAUSA   PIC 9(3).
      *    05  AM-WTIPRG   PIC 9.
      *    05  AM-WSEGNO   PIC 9.
      *    05  AM-WTIPOP   PIC 99.
      *    05  AM-WDTDOC   PIC 9(5) COMP-3.
      *    05  AM-WDOCUM   PIC 9(5).
      *    05  AM-WNPRGI   PIC 9(5).
      *    05  AM-REC.
      *        10  AM-DCON     PIC X(36)  OCCURS 15.
      *        10  AM-WCPART   PIC 9(7)   OCCURS 15.
      *        10  AM-WIMPCP   PIC S9(11) OCCURS 15.
      *        10  AM-WCAUS2   PIC 9(3)   OCCURS 15.
      ***************
       01  CM-XX.
           05  CM-PAR OCCURS 50.
               10  CM-AZI      PIC 999.
               10  CM-TDOC     PIC 9.
               10  CM-NUM      PIC 9(5) COMP-3.
      **** rel 5.2
       01  CP-XX.
           05  CP-PAR OCCURS 200.
               10  CP-AZI      PIC 999.
               10  CP-TDOC     PIC 9.
               10  CP-NUM      PIC 9(5) COMP-3.
      ************
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI          PIC 999.
           05 IF-CATT         PIC X.
           05 IF-FUN          PIC X.
           05 IF-CAMPO        PIC X(20).
      **** rel 5.2
           05 IF-CAMPO2       PIC X(20).
      ************
           05 IF-ST           PIC 9.
           05 IF-FL           PIC 9.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D        PIC X(36).
           05 IF-DTAZI        PIC 9(6).
           05 IF-TPELA        PIC 9.
      **** rel 5.2
           05 IF-TPPAG        PIC 9.
      ************
           05 IF-FAT-1        PIC 9(5).
           05 IF-FAT-2        PIC 9(5).
           05 IF-FTSO-1       PIC 9(5).
           05 IF-FTSO-2       PIC 9(5).
           05 IF-PRSOS        PIC 9(5).
           05 IF-PER99        PIC 9(6).
           05 IF-PLAVET.
              10 IF-FAT-11    PIC 9(5).
              10 IF-FAT-21    PIC 9(5).
              10 IF-PER-01    PIC 9(6).
              10 IF-FAT-12    PIC 9(5).
              10 IF-FAT-22    PIC 9(5).
              10 IF-PER-02    PIC 9(6).
              10 IF-FAT-13    PIC 9(5).
              10 IF-FAT-23    PIC 9(5).
              10 IF-PER-03    PIC 9(6).
              10 IF-FAT-14    PIC 9(5).
              10 IF-FAT-24    PIC 9(5).
              10 IF-PER-04    PIC 9(6).
              10 IF-FAT-15    PIC 9(5).
              10 IF-FAT-25    PIC 9(5).
              10 IF-PER-05    PIC 9(6).
           05 FILLER REDEFINES IF-PLAVET OCCURS 5.
              10 IF-FAT10     PIC 9(5).
              10 IF-FAT20     PIC 9(5).
              10 IF-PER00     PIC 9(6).
              10 FILLER REDEFINES IF-PER00.
                 15 IF-PMES   PIC 99.
                 15 IF-PANN   PIC 9(4).
           05 IF-CTRNUM       PIC 9.
           05 IF-RICEST       PIC 9.
      * flag occorrenti all'interfaccia per hide/show
           05 IF-FLGIS        PIC 9.
           05 IF-FLTIG        PIC 9.
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclcon'.
           COPY 'dclfat'.
           COPY 'dcleff'.
           COPY 'dclclf'.
           COPY 'dclcam'.
           COPY 'dclacc'.
           COPY 'dclbct'.
      **** rel 1.2
      *    COPY 'dclcgg'.
      ************
      **** rel 5.0
           COPY 'dclsca'.
      ************
           COPY 'dcltab'.
           COPY 'dcl135'.
           COPY 'dclla3'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        GO TO FINE.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vfat160: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
      **** rel 1.2
      *    CLOSE CAMGIO.
      ************
           CLOSE ANACON.
      **** rel 7.1
           CLOSE APPCON.
      ************
           CLOSE EFFETT.
           CLOSE FATTUR.
           CLOSE ANAAZI.
           CLOSE TABELL.
      **** rel 5.0
           CLOSE ANASCA.
      ************
      **** rel 5.2
           CLOSE WDSLA3.
      ************
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
      **** rel 1.2
           COPY 'erreur'.
      ************
           COPY 'griazier'.
           COPY 'griconer'.
           COPY 'grifater'.
           COPY 'grieffer'.
           COPY 'griclfer'.
           COPY 'gricamer'.
           COPY 'griaccer'.
           COPY 'gribcter'.
      **** rel 1.2
      *    COPY 'gricgger'.
      ************
      **** rel 5.0
           COPY 'griscaer'.
      ************
           COPY 'gritaber'.
           COPY 'gri135er'.
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           MOVE ZERO TO J2.
       VAI-00.
           ADD 1 TO J2.
      **** rel 5.2
      *    MOVE ZERO TO CM-AZI(J2).
      *    MOVE ZERO TO CM-TDOC(J2).
      *    MOVE ZERO TO CM-NUM(J2).

           IF J2 < 51 MOVE ZERO TO CM-AZI(J2)
                                   CM-TDOC(J2)
                                   CM-NUM(J2).

           IF J2 < 201 MOVE ZERO TO CP-AZI(J2)
                                    CP-TDOC(J2)
                                    CP-NUM(J2).
      ************
      **** rel 1.2
      *    IF J2 < 6 MOVE ZERO TO IF-FAT10(J2) IF-FAT20(J2) IF-PER00(J2).
           IF J2 < 6 MOVE ZERO TO IF-FAT10(J2)
                                  IF-FAT20(J2)
                                  IF-PER00(J2).
      ************
      **** rel 5.2
      *    IF J2 < 50 GO TO VAI-00.
           IF J2 < 200 GO TO VAI-00.
      ************
      *
      **** rel 2.0
           MOVE 'fattur' TO ID-FAT.
      ************
           IF IF-CATT NOT = ZERO
              MOVE SPACE TO ID-FAT
              STRING 'fattur' IF-CATT DELIMITED SIZE INTO ID-FAT.
      *
           IF IF-FL = ZERO
              MOVE 'anaazi' TO ID-AZI
              MOVE 'tabell' TO ID-TAB
              MOVE 'anacon' TO ID-CON
      **** rel 7.1
              MOVE 'appcon' TO ID-ACO
      ************
              MOVE 'anaclf' TO ID-CLF
              MOVE 'movime' TO ID-MOV
      **** rel 1.2
              MOVE SPACE    TO RET
      ************
           ELSE
              MOVE 'anazol' TO ID-AZI
              MOVE 'tabold' TO ID-TAB
              MOVE 'anacol' TO ID-CON
      **** rel 7.1
              MOVE 'appcol' TO ID-ACO
      ************
              MOVE 'anacfx' TO ID-CLF
      **** rel 1.2
      *       MOVE 'movmol' TO ID-MOV.
              MOVE 'movmol' TO ID-MOV
              MOVE 'OLD'    TO RET.
      ************
      *
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
      **** rel 1.2
      *    OPEN INPUT TABELL ANACON CAMGIO.
           OPEN INPUT TABELL ANACON.
      ************
      **** rel 7.1
           OPEN INPUT APPCON.
      ************
           OPEN I-O EFFETT FATTUR ANAAZI.
      **** rel 5.0
           OPEN I-O ANASCA.
      ************
      *
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MCLI TO MAS.
      **** rel 7.2
           MOVE T01-CIVSO TO T01CIVSO.
      ************
      *
       INI-ELAB-10.
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID
                PERFORM INVK-AZI
                GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
      *
           MOVE AZI-FLAMM TO FLAMM.
           IF FLAMM = ZERO GO TO INI-ELAB-30.
           OPEN INPUT TACOAM.
           IF SF-TAC NOT = ZERO
              MOVE ZERO TO FLAMM
              GO TO INI-ELAB-30.
           MOVE ZERO    TO KTC-CAT.
           MOVE KAZ-COD TO KTC-AZI.
           READ TACOAM INVALID GO TO INI-ELAB-20.
           IF TAC-AMORD = ZERO GO TO INI-ELAB-20.
           CLOSE TACOAM.
           GO TO INI-ELAB-30.
       INI-ELAB-20.
           MOVE ZERO TO FLAMM.
           CLOSE TACOAM.
       INI-ELAB-30.
      *
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '0'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE T25-DUP TO DTAIVA.
           MOVE 2 TO TIPOP1.
           MOVE DTAIVA TO AAGGG.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO DATIVB.
      **** rel 5.0
           MOVE T25-INTRA TO FLGTRA.
      ************
      **** rel 5.2
           MOVE 14 TO KTB-TIP.
           MOVE 10 TO KTB-COD.
           READ TABELL INTO RKTB14L INVALID
                        MOVE ZERO TO RKTB14L
                        T14-CFTEM1 T14-CFTEM2 T14-CFTEM3
                        T14-CNAEM1 T14-CNAEM2 T14-CNAEM3
                        T14-CFTRC1 T14-CFTRC2 T14-CFTRC3
                        T14-CNARC1 T14-CNARC2 T14-CNARC3
                        T14-CAUFEM T14-CAUFRC.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO RKTB14L.
           MOVE T14-CFTEM1    TO CP-FTEM(1).
           MOVE T14-CFTEM2    TO CP-FTEM(2).
           MOVE T14-CFTEM3    TO CP-FTEM(3).
           MOVE T14-CNAEM1    TO CP-NAEM(1).
           MOVE T14-CNAEM2    TO CP-NAEM(2).
           MOVE T14-CNAEM3    TO CP-NAEM(3).
           MOVE T14-CAUFEM    TO CAU-FTEM.
      ************
      **** rel 4.0
           CALL 'rveur' USING COMEURO.
      ************
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE AZRGSOC TO IF-AZI-D.
           MOVE ZERO    TO IF-DTAZI
                           IF-FAT-1
                           IF-FAT-2
                           IF-FTSO-1
                           IF-FTSO-2
                           IF-PRSOS
                           IF-PER99
                           IF-CTRNUM
                           IF-RICEST.
           MOVE 3       TO IF-TPELA.
      **** rel 5.2
           MOVE 1       TO IF-TPPAG.
      ************
      *
           MOVE 1 TO K1.
           PERFORM UNTIL K1 > 5
              MOVE ZERO TO IF-FAT10(K1) IF-FAT20(K1) IF-PER00(K1)
              ADD 1 TO K1
           END-PERFORM.
      *
           MOVE AZI-ULTDT TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO IF-DTAZI.
           MOVE AZI-FLGIS TO IF-FLGIS.
           MOVE ZERO      TO IF-FLTIG.
      *
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-DTAZI.
           MOVE 'IF-DTAZI' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTAZI.
           MOVE 1 TO TIPOP1.
           MOVE IF-DTAZI TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
      **** rel 4.0
           CALL 'vrdtbigb' USING DTBIG.
           IF AAGGG <= DTBIG
              MOVE 'Data minore/uguale del Big-bang'  TO F-MES1
              MOVE 1 TO F-NMES
              GO TO V-ERROR.
      ************
           MOVE AAGGG TO AZI-ULTDT.
       E-DTAZI.
      *
       V-TPELA.
           MOVE 'IF-TPELA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TPELA.
           IF NOT (IF-TPELA = 1 OR 2 OR 3)
              PERFORM ERR-RADIO
              GO TO V-ERROR.
           IF IF-TPELA = 2 GO TO E-TPELA.
           MOVE IF-DTAZI TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF AAGGG NOT > DTAIVA
              MOVE 'Totali IVA aggiornati al' TO F-MES1
              MOVE DATIVB TO F-MES2
              MOVE 2 TO F-NMES
              GO TO V-ERROR.
      *
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '1'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           IF T25-PLA = ZERO MOVE ZERO TO T25-ATT T25-TIG
                                          T25-DTP T25-TPL.
           MOVE T25-TIG TO IF-FLTIG.
           IF T25-PLA = ZERO MOVE ZERO TO IF-FLTIG
                             GO TO E-TPELA.
           MOVE T25-DTM TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO DTM.
           MOVE GBMMBA TO DTMB.
           MOVE 14 TO KTB-TIP.
           MOVE 5  TO KTB-COD.
           READ TABELL INTO REKTE14 INVALID PERFORM INVK-TAB
                                            GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTE14.
           IF T14IDIR = ZERO AND T14ITRI = ZERO AND
              T14IIND = ZERO AND T14ISCV = ZERO AND
              T14IRSM = ZERO AND T14IASS = ZERO AND
              T14ISIN = ZERO
              MOVE 'Codice IVA plafond' TO MESS
              GO TO V-ERROR.
           IF T25-ATT = ZERO MOVE T25-TIG TO IF-FLTIG
                             MOVE T25-TPL TO TPL
                             MOVE T25-DTP TO DTP
                             PERFORM CONV-DTP-A6
                             MOVE DTP6 TO DTPB
                             IF IF-FLTIG = ZERO
                                GO TO E-TPELA
                             ELSE
                                GO TO ACPL-00.
           IF IF-CATT = '0' MOVE T25-TIG TO IF-FLTIG
                            MOVE T25-TPL TO TPL
                            MOVE T25-DTP TO DTP
                            PERFORM CONV-DTP-A6
                            MOVE DTP6 TO DTPB
                            IF IF-FLTIG = ZERO
                               GO TO E-TPELA
                            ELSE
                               GO TO ACPL-00.
           MOVE 35      TO T35-TIP.
           MOVE KAZ-COD TO T35-CDAZ.
           MOVE IF-CATT TO T35-CATT.
           MOVE T35-KEYID TO KEYTB.
           READ TABELL INTO REKT35 INVALID KEY PERFORM INVK-TAB
                                               GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT35.
           IF T35-GES = ZERO
              MOVE T25-TIG TO IF-FLTIG
              MOVE T25-TPL TO TPL
              MOVE T25-DTP TO DTP
              PERFORM CONV-DTP-A6
              MOVE DTP6 TO DTPB
           ELSE
              MOVE T35-TIG TO IF-FLTIG
              MOVE T35-TPL TO TPL
              MOVE T35-DTP TO DTP
              PERFORM CONV-DTP-A6
              MOVE DTP6 TO DTPB.
           IF IF-FLTIG = ZERO GO TO E-TPELA.
       ACPL-00.
           IF AZI-ULTDT NOT > T25-DTM
              MOVE 2 TO F-NMES
              MOVE 'Movimenti plafond aggiornati al' TO F-MES1
              MOVE DTMB TO F-MES2
              IF IF-FLGIS = ZERO GO TO V-ERROR.
       E-TPELA.
      *
      **** rel 5.2
       V-TPPAG.
           MOVE 'IF-TPPAG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TPPAG.
           IF NOT (IF-TPPAG = 1 OR 2)
              PERFORM ERR-RADIO
              GO TO V-ERROR.
       E-TPPAG.
      *
      ************
       V-FAT-2.
           MOVE 'IF-FAT-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FAT-2.
           IF IF-FAT-2 < IF-FAT-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
      **** rel 4.1a-1
           IF IF-TPELA = 2 GO TO E-FAT-2.
           MOVE IF-DTAZI TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF AAGGG NOT > DTAIVA
              MOVE 'Totali IVA aggiornati al' TO F-MES1
              MOVE DATIVB TO F-MES2
              MOVE 2 TO F-NMES
              GO TO V-ERROR.
      *
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '1'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           IF T25-PLA = ZERO MOVE ZERO TO T25-ATT T25-TIG
                                          T25-DTP T25-TPL.
           MOVE T25-TIG TO IF-FLTIG.
           IF T25-PLA = ZERO MOVE ZERO TO IF-FLTIG
                             GO TO E-FAT-2.
           MOVE T25-DTM TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO DTM.
           MOVE GBMMBA TO DTMB.
           MOVE 14 TO KTB-TIP.
           MOVE 5  TO KTB-COD.
           READ TABELL INTO REKTE14 INVALID PERFORM INVK-TAB
                                            GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTE14.
           IF T14IDIR = ZERO AND T14ITRI = ZERO AND
              T14IIND = ZERO AND T14ISCV = ZERO AND
              T14IRSM = ZERO AND T14IASS = ZERO AND
              T14ISIN = ZERO
              MOVE 'Codice IVA plafond' TO MESS
              GO TO V-ERROR.
           IF T25-ATT = ZERO MOVE T25-TIG TO IF-FLTIG
                             MOVE T25-TPL TO TPL
                             MOVE T25-DTP TO DTP
                             PERFORM CONV-DTP-A6
                             MOVE DTP6 TO DTPB
                             IF IF-FLTIG = ZERO
                                GO TO E-FAT-2
                             ELSE
                                GO TO ACPL-01.
           IF IF-CATT = '0' MOVE T25-TIG TO IF-FLTIG
                            MOVE T25-TPL TO TPL
                            MOVE T25-DTP TO DTP
                            PERFORM CONV-DTP-A6
                            MOVE DTP6 TO DTPB
                            IF IF-FLTIG = ZERO
                               GO TO E-FAT-2
                            ELSE
                               GO TO ACPL-01.
           MOVE 35      TO T35-TIP.
           MOVE KAZ-COD TO T35-CDAZ.
           MOVE IF-CATT TO T35-CATT.
           MOVE T35-KEYID TO KEYTB.
           READ TABELL INTO REKT35 INVALID KEY PERFORM INVK-TAB
                                               GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT35.
           IF T35-GES = ZERO
              MOVE T25-TIG TO IF-FLTIG
              MOVE T25-TPL TO TPL
              MOVE T25-DTP TO DTP
              PERFORM CONV-DTP-A6
              MOVE DTP6 TO DTPB
           ELSE
              MOVE T35-TIG TO IF-FLTIG
              MOVE T35-TPL TO TPL
              MOVE T35-DTP TO DTP
              PERFORM CONV-DTP-A6
              MOVE DTP6 TO DTPB.
           IF IF-FLTIG = ZERO GO TO E-FAT-2.
       ACPL-01.
           IF AZI-ULTDT NOT > T25-DTM
              MOVE 2 TO F-NMES
              MOVE 'Movimenti plafond aggiornati al' TO F-MES1
              MOVE DTMB TO F-MES2
              IF IF-FLGIS = ZERO GO TO V-ERROR.
      **************
       E-FAT-2.
      *
       V-FTSO-2.
           MOVE 'IF-FTSO-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FTSO-2.
           IF IF-FLGIS NOT = 1 GO TO E-FTSO-2.
           IF IF-FTSO-2 < IF-FTSO-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-FTSO-2.
      *
      *** rel 5.1
      *V-PRSOS.
      *    MOVE 'IF-PRSOS' TO VCAMPO.
      *    IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PRSOS.
      *    IF IF-FLGIS NOT = 2 GO TO E-PRSOS.
      *    IF IF-PRSOS < T23-PRSOS
      *       PERFORM ERR-DINV
      *       GO TO V-ERROR.
      *E-PRSOS.
      ***********
      *
       V-PER99.
           MOVE 'IF-PER99' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PER99.
           IF IF-FLTIG = ZERO OR IF-TPELA = 2 GO TO E-PER99.
           IF IF-PER99 = ZERO
              PERFORM ERR-DINV
              GO TO V-ERROR.
           IF IF-PER99 = 9 GO TO E-PER99.
           IF IF-PER99 < 011901 OR > 122099
              PERFORM ERR-DINV
              GO TO V-ERROR.
           IF DTP6 = ZERO GO TO E-PER99.
           MOVE DTP6 TO PERIO.
           MOVE PERM TO PERMA.
           MOVE PERA TO PERAA.
      **** rel 1.2
      *    MOVE PER99 TO PERIO.
           MOVE IF-PER99 TO PERIO.
      ************
           MOVE PERM TO PLFMM.
           MOVE PERA TO PLFAA.
           IF DTCT2 NOT > DTCT1
              MOVE 2 TO F-NMES
              MOVE 'Plafond aggiornato al' TO F-MES1
              MOVE DTPB                    TO F-MES2
              GO TO V-ERROR.
       E-PER99.
      *
       V-FAT10.
           MOVE ZERO TO K1.
       V-FAT10-10.
           ADD 1 TO K1.
           IF K1 > 5 GO TO E-FAT10.
           MOVE SPACE TO VCAMPO.
           STRING 'IF-FAT-1' K1 DELIMITED SIZE INTO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO V-FAT10-10.
           IF IF-FLTIG = ZERO OR IF-TPELA = 2 GO TO V-FAT10-10.
           IF IF-FAT10(K1) = ZERO
              PERFORM UNTIL K1 > 5
                 MOVE ZERO TO IF-FAT10(K1) IF-FAT20(K1) IF-PER00(K1)
                 ADD 1 TO K1
              END-PERFORM
              GO TO V-FAT10-10.
           IF IF-FAT10(K1) < IF-FAT-1 OR > IF-FAT-2
              PERFORM ERR-DINV
              GO TO V-ERROR.
           IF K1 > 1
              IF IF-FAT10(K1) NOT > IF-FAT20(K1 - 1)
                 PERFORM ERR-DINV
                 GO TO V-ERROR.
           GO TO V-FAT10-10.
       E-FAT10.
      *
       V-FAT20.
           MOVE ZERO TO K1.
       V-FAT20-10.
           ADD 1 TO K1.
           IF K1 > 5 GO TO E-FAT20.
           MOVE SPACE TO VCAMPO.
           STRING 'IF-FAT-2' K1 DELIMITED SIZE INTO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO V-FAT20-10.
           IF IF-FLTIG = ZERO OR IF-TPELA = 2 GO TO V-FAT20-10.
           IF IF-FAT20(K1) < IF-FAT10(K1) OR > IF-FAT-2
              PERFORM ERR-DINV
              GO TO V-ERROR.
           GO TO V-FAT20-10.
       E-FAT20.
      *
       V-PER00.
           MOVE ZERO TO K1.
       V-PER00-10.
           ADD 1 TO K1.
           IF K1 > 5 GO TO E-PER00.
           MOVE SPACE TO VCAMPO.
           STRING 'IF-PER-0' K1 DELIMITED SIZE INTO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO V-PER00-10.
           IF IF-FLTIG = ZERO OR IF-TPELA = 2 GO TO V-PER00-10.
           IF IF-PER00(K1) = ZERO AND
              IF-FAT10(K1) = ZERO AND
              IF-FAT20(K1) = ZERO GO TO V-PER00-10.
           IF IF-PER00(K1) > 122099 OR
              (IF-PER00(K1) > ZERO AND < 011901)
              GO TO V-ERROR.
           IF DTP6 = ZERO GO TO V-PER00-10.
           MOVE IF-PER00(K1) TO PERIO.
           MOVE PERM TO PLFMM.
           MOVE PERA TO PLFAA.
           IF DTCT2 NOT > DTCT1
              MOVE 2 TO F-NMES
              MOVE 'Plafond aggiornato al' TO F-MES1
              MOVE DTPB                    TO F-MES2
              GO TO V-ERROR.
           GO TO V-PER00-10.
       E-PER00.
      *
       V-CTRNUM.
           MOVE 'IF-CTRNUM' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CTRNUM.
           IF IF-CTRNUM > 1
              PERFORM ERR-DINV
              GO TO V-ERROR.
       E-CTRNUM.
      *
       V-RICEST.
           MOVE 'IF-RICEST' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-RICEST.
           IF IF-RICEST > 1
              PERFORM ERR-DINV
              GO TO V-ERROR.
       E-RICEST.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI KEPT LOCK INVALID
                PERFORM INVK-AZI
                GO TO ERRIO.
           IF SF-AZI NOT = ZERO PERFORM REC-LOCK
                                GO TO RUN-ELABORA.
      *
           MOVE IF-DTAZI TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO AZI-ULTDT.
      *
           REWRITE RF-AZI FROM REKAZI INVALID PERFORM INVK-AZI
                                              GO TO ERRIO.
           UNLOCK ANAAZI.
      *
           IF IF-TPELA  = 2    GO TO CONT-2.
           IF IF-CTRNUM = ZERO GO TO CONT-2.
           MOVE ZERO TO SWGIS.
           MOVE 'Controllo fatture' TO DSFAT.
           PERFORM A00-CNT-NUM THRU A99.
           IF FLCNT = ZERO AND CTGIS = ZERO
                           MOVE 'Nessuna fattura' TO F-MES1
                           MOVE 1 TO F-NMES
                           CALL 'vrmbox' USING PARMB
                           GO TO EX-RUN-ELABORA.
           IF FLCNT = 1 AND CTGIS NOT = 2
                        MOVE 'Numerazione corretta' TO F-MES1
                        MOVE 1 TO F-NMES
                        CALL 'vrmbox' USING PARMB.
           MOVE 'Vuoi contabilizzare ?' TO F-MES1.
           MOVE 1   TO F-NMES.
           MOVE 'Q' TO MB-TIPO.
           MOVE '2' TO MB-DEFAULT.
           CALL 'vrmbox' USING PARMB.
           IF MB-RISP NOT = 'S' GO TO EX-RUN-ELABORA.
       CONT-2.
           MOVE 1 TO KTB-COD.
           MOVE 1 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID KEY PERFORM INVK-TAB
                                               GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MCLI TO MAS.
           IF IF-CATT = '0' GO TO ACCTAB-1.
           MOVE 35      TO T35-TIP.
           MOVE KAZ-COD TO T35-CDAZ.
           MOVE IF-CATT TO T35-CATT.
           MOVE T35-KEYID TO KEYTB.
           READ TABELL INTO REKT35 INVALID KEY PERFORM INVK-TAB
                                               GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT35.
           MOVE T35-RICAV TO RICAV.
       ACCTAB-1.
           MOVE 14 TO KTB-TIP.
           MOVE 1  TO KTB-COD.
           READ TABELL INTO REKTAB INVALID KEY PERFORM INVK-TAB
                                               GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF IF-CATT NOT = '0' GO TO ACCTAB-2.
           MOVE T14-RICAV TO RICAV.
       ACCTAB-2.
           MOVE KAZ-COD TO KPC-AZI.
           MOVE RICAV   TO KPC-COD.
           READ ANACON INVALID KEY
                MOVE 'Manca conto ricavi' TO MESS
                GO TO ERRIO.
           MOVE T14-FATT  TO T14FATT.
           MOVE T14-SPBOL TO T14SPBOL.
           MOVE T14-SPBAN TO T14SPBAN.
           MOVE T14-TRT   TO T14TRT.
           MOVE T14-RB    TO T14RB.
           MOVE T14-TRATT TO T14TRATT.
           MOVE T14-RIBAN TO T14RIBAN.
           MOVE 2 TO KTB-COD.
           READ TABELL INTO REKTAB INVALID KEY PERFORM INVK-TAB
                                               GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T14-ACCR TO T14ACCR.
           MOVE T14-FTSO TO T14FTSO.
           MOVE T14-ACSO TO T14ACSO.
           MOVE T14-ACCO TO T14ACCO.
           MOVE T14-CACC TO T14CACC.
           MOVE KAZ-COD  TO KPC-AZI.
           MOVE T14CACC  TO KPC-COD.
           READ ANACON INVALID KEY
                MOVE 'Manca conto acconti' TO MESS
                GO TO ERRIO.
           MOVE T14-CSGR TO T14CSGR.
           MOVE T14-IVGR TO T14IVGR.
           MOVE T14-SCON TO T14SCON.
           MOVE T14-RIC1 TO T14RIC1.
           MOVE T14-RIC2 TO T14RIC2.
           MOVE T14-RIC3 TO T14RIC3.
           MOVE 8 TO KTB-COD.
           READ TABELL INTO RKTB14H INVALID KEY PERFORM INVK-TAB
                                                GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO RKTB14H.
           MOVE T14-RIC4 TO T14RIC4.
           MOVE T14-RIC5 TO T14RIC5.
           MOVE T14-RIC6 TO T14RIC6.
           MOVE T14-RIC7 TO T14RIC7.
           MOVE T14-RIC8 TO T14RIC8.
           MOVE T14-RIC9 TO T14RIC9.
      **** rel 5.2
      * lettura conti ricavi cessioni gratuite e sconti merce
           MOVE 14 TO KTB-TIP.
           MOVE 10 TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE 'Caricare conti ric.cess.gr.e sconti' TO MESS
                GO TO ERRIO.
           MOVE T14-CRCGR TO RICCGR.
           MOVE T14-CRSCM TO RICSCM.

           MOVE KAZ-COD TO KPC-AZI.
           MOVE RICCGR  TO KPC-COD.
           READ ANACON INVALID KEY
                MOVE 'Manca conto ricavi cess.gratuite' TO MESS
                GO TO ERRIO.

           MOVE KAZ-COD TO KPC-AZI.
           MOVE RICSCM  TO KPC-COD.
           READ ANACON INVALID KEY
                MOVE 'Manca conto ricavi sconti merci' TO MESS
                GO TO ERRIO.
      ************
           MOVE ZERO TO K.
       RIC00.
           ADD 1 TO K.
           MOVE KAZ-COD    TO KPC-AZI.
           MOVE T14RIC0(K) TO KPC-COD.
           READ ANACON INVALID KEY MOVE ZERO TO T14RIC0(K).
           IF K < 9 GO TO RIC00.
           MOVE ZERO TO K.
           IF IF-TPELA = 2 MOVE ZERO TO FLAMM GO TO LOOPE.
      *
      * CONTROLLO ESISTENZA FATTURE ESTERE *
      *
           MOVE ZERO TO KEYFT KFT-NUM.
           MOVE KAZ-COD  TO KFT-AZI.
           MOVE 2        TO KFT-TDOC.
           MOVE IF-FAT-1 TO KFT-NUM.
           START FATTUR KEY NOT < KEYFT INVALID GO TO INICON.
       RDFTE.
           READ FATTUR NEXT AT END GO TO INICON.
           IF SF-FAT = '9D' OR '9A' OR '35' GO TO RDFTE.
           IF KFT-AZI   > KAZ-COD  GO TO INICON.
           IF KFT-TDOC  > 2        GO TO INICON.
           IF KFT-NUM   > IF-FAT-2 GO TO INICON.
           IF FAT-STATU = 1        GO TO RDFTE.
      **** rel 5.2
           IF IF-TPPAG = 2
              IF NOT ( FAT-TIPAG = 1 OR 2 ) GO TO RDFTE.
      ************
      *
           IF IF-RICEST = ZERO GO TO INICON.
      *
           MOVE 'Il  ricalcolo  e'' possibile  solo  se' TO F-MES1.
           MOVE 'sono ancora presenti le bolle e se le'  TO F-MES2.
           MOVE 'date delle fatture trovano  riscontro'  TO F-MES3.
           MOVE 'sulla tabella cambi.'                   TO F-MES4.
           MOVE 'Le note di accredito sono ignorate.'    TO F-MES5.
           MOVE 5 TO F-NMES.
           CALL 'vrmbox' USING PARMB.
       RIC10.
           MOVE 'Vuoi continuare ?' TO F-MES1.
           MOVE 1   TO F-NMES.
           MOVE 'Q' TO MB-TIPO.
           MOVE '2' TO MB-DEFAULT.
           CALL 'vrmbox' USING PARMB.
           IF MB-RISP NOT = 'S' GO TO EX-RUN-ELABORA.
      *
      * INIZIO RICALCOLO FATTURE ESTERE *
      *
        RIC20.
           MOVE ZERO TO KEYFT KFT-NUM.
           MOVE KAZ-COD  TO KFT-AZI.
           MOVE 2        TO KFT-TDOC.
           MOVE IF-FAT-1 TO KFT-NUM.
           START FATTUR KEY NOT < KEYFT INVALID GO TO FNRIC.
       RDFTER.
           READ FATTUR NEXT AT END GO TO FNRIC.
           IF SF-FAT = '9D' OR '9A' OR '35' GO TO RDFTER.
           IF KFT-AZI  > KAZ-COD  GO TO FNRIC.
           IF KFT-TDOC > 2        GO TO FNRIC.
           IF KFT-NUM  > IF-FAT-2 GO TO FNRIC.
           IF FAT-STATU = 1 GO TO RDFTER.
      **** rel 5.2
           IF IF-TPPAG = 2
              IF NOT ( FAT-TIPAG = 1 OR 2 ) GO TO RDFTER.
      ************
      **** rel 4.0
      *    IF FAT-VALUT = 1 GO TO RDFTER.
           IF FAT-VALUT = COMEURO GO TO RDFTER.
      ************
      **** rel 1.2
      *    MOVE FAT-VALUT TO KCG-VAL.
      *    MOVE FAT-DATA TO AAGGG.
      *    COMPUTE AAGGG = 99999 - AAGGG.
      *    MOVE AAGGG TO KCG-GIO.
      *    READ CAMGIO INVALID PERFORM INVK-CGG
      *                        GO TO ERRIO.
      *    IF CGG-CAMBIO = FAT-CADOC GO TO RDFTER.
           MOVE FAT-VALUT TO ER-VALUT.
           CALL 'rvalut' USING ER-VALUT FAT-DATA CG-PAR.
           IF CG-ST > ZERO PERFORM ERR-EURO
                           GO TO ERRIO.
           IF CG-CAMBIO = FAT-CADOC GO TO RDFTER.
      ************
           MOVE KFT-AZI  TO CF-AZI.
           MOVE ZERO     TO CF-GGESC.
           MOVE FAT-DATA TO CF-DTFAT.
           MOVE KFT-NUM  TO CF-NUMFAT.
           MOVE ZERO     TO CF-SIMUL.
           MOVE IF-CATT  TO CF-ATTIV.
           MOVE ZERO     TO CF-VIDEO.
           MOVE ZERO     TO CF-ST.
           IF IF-FL = 1 MOVE 1 TO CF-FL.
      **** rel 1.2
           CALL 'rdbfa' USING FAT-CATT KEYFT PARRB.
      *    MOVE ZERO TO K.
      *LPBOL.
      *    ADD 1 TO K.
      *    IF K > 15 GO TO LPANN.
      *    MOVE FAT-TNUM (K) TO CF-VTNUM (K).
      *    MOVE FAT-NBOL (K) TO CF-VNBOL (K).
      *    IF FAT-TNUM (K) = ZERO  GO TO LPBOL.
      *    IF K > 1                GO TO LPBOL.
      *    IF CF-VTNUM (K) NOT > 6 GO TO LPBOL.
      *    OPEN I-O BOLCTE.
      *    MOVE KFT-AZI      TO KBC-AZI.
      *    MOVE FAT-TNUM (K) TO KBC-NUM.
      *    MOVE FAT-NBOL (K) TO KBC-BOL.
      *    READ BOLCTE INVALID PERFORM INVK-BCT
      *                        PERFORM VISK-FAT
      *                        CLOSE BOLCTE
      *                        GO TO ERRIO.
      *    MOVE CGG-CAMBIO TO BCT-CAMGG.
      *    REWRITE RF-BCT INVALID PERFORM INVK-BCT
      *                           PERFORM VISK-FAT
      *                           CLOSE BOLCTE
      *                           GO TO ERRIO.
      *    CLOSE BOLCTE.
      *    GO TO LPBOL.
      ************
      *  FASE DI ANNULLAMENTO *
       LPANN.
           MOVE KFT-AZI  TO AF-AZI.
           MOVE KFT-TDOC TO AF-TDOC.
           MOVE KFT-NUM  TO AF-NUMFAT.
           IF IF-FL = 1 MOVE 1 TO AF-FL
           ELSE         MOVE ZERO TO AF-FL.
           MOVE ZERO     TO AF-ST.
      **** rel 6.2
           MOVE 1 TO K.
           PERFORM UNTIL K > 12
              MOVE FAT-DTSCA(K)  TO SAV-DTSCA(K)
              MOVE FAT-EIMPOR(K) TO SAV-EIMPOR(K)
              MOVE FAT-TPAG(K)   TO SAV-TPAG(K)
              ADD 1 TO K.
      ************
           CALL 'vfat200' USING ID-FAT PARAF.
           IF ERRIO-ST NOT = ZERO GO TO ERRIO.
           IF AF-ST = ZERO GO TO RICAL.
           MOVE 'Annullamento non effettuato'              TO F-MES1.
           IF AF-ST = 9 MOVE 'Fattura non trovata'         TO F-MES2.
           IF AF-ST = 8 MOVE 'Bolle non trovate'           TO F-MES2.
           IF AF-ST = 7 MOVE 'Effetti raggruppati'         TO F-MES2.
           IF AF-ST = 6 MOVE 'Effetti contabilizzati'      TO F-MES2.
           IF AF-ST = 5 MOVE 'Errore aggiornamento bolle'  TO F-MES2.
           IF AF-ST = 4 MOVE 'Errore tabella pagamenti'    TO F-MES2.
           IF AF-ST = 3
                   MOVE 'Errore aggiornamento statistiche' TO F-MES2.
           IF AF-ST = 2 MOVE 'Errore annullamento effetti' TO F-MES2.
           IF AF-ST = 1 MOVE 'Errore annullamento fattura' TO F-MES2.
           MOVE 2 TO F-NMES.
           CALL 'vrmbox' USING PARMB.
           GO TO EX-RUN-ELABORA.
       RICAL.
      *  FASE DI RICALCOLO *
      **** rel 1.2
      *    CALL 'vfat190' USING PARCF RF-FAT.
           CALL 'vfat190' USING PARCF PARRB RF-FAT.
      ************
           CANCEL 'vfat190'.
           IF CF-ST = ZERO GO TO RDFTER.
           GO TO EX-RUN-ELABORA.
       FNRIC.
           MOVE 'Fine Ricalcolo' TO MB-TITOLO.
           MOVE 'Vuoi effettuare la contabilizzazione ?' TO F-MES1.
           MOVE 1   TO F-NMES.
           MOVE 'Q' TO MB-TIPO.
           MOVE '2' TO MB-DEFAULT.
           CALL 'vrmbox' USING PARMB.
           IF MB-RISP NOT = 'S' GO TO EX-RUN-ELABORA.
      *
       INICON.
           MOVE ZERO TO J.
      **** rel 5.2
           MOVE ZERO TO CONT1.
      ************
           MOVE ZERO TO KEYFT KFT-NUM.
           MOVE KAZ-COD  TO KFT-AZI.
           MOVE 1        TO KFT-TDOC.
           MOVE IF-FAT-1 TO KFT-NUM.
           START FATTUR KEY NOT < KEYFT INVALID GO TO LOOPE.
       RDFAT.
           READ FATTUR NEXT AT END GO TO LOOPE.
           IF SF-FAT = '9D' OR '9A' OR '35' GO TO RDFAT.
           IF KFT-AZI > KAZ-COD GO TO LOOPE.
           IF FAT-STATU = 1 GO TO RDFAT.
      **** rel 5.2
           IF IF-TPPAG = 2
              IF NOT ( FAT-TIPAG = 1 OR 2 ) GO TO RDFAT.
      ************
           MOVE KFT-NUM TO FATT.
           IF IF-FLGIS NOT = 1 OR KFT-TDOC < 4 GO TO RDFA1.
           IF FATT < IF-FTSO-1 OR > IF-FTSO-2 GO TO RDFAT.
           IF FAT-DATA > AZI-ULTDT GO TO RDFAT.
           GO TO NOOK.
       RDFA1.
           IF FATT < IF-FAT-1 GO TO RDFAT.
           IF FATT > IF-FAT-2 GO TO RDFAT.
           IF FAT-DATA > AZI-ULTDT GO TO RDFAT.
       NOOK.
      **** rel 4.0
           CALL 'vrdtbigb' USING DTBIG.
           IF FAT-DATA <= DTBIG
              MOVE 'Data minore/uguale del Big-bang'  TO F-MES1
              MOVE HIGH-VALUE TO F-MES2
              MOVE FATT TO FATTZ
              STRING 'Fattura '
                      FATTZ '       non contabilizzata *'
                      DELIMITED HIGH-VALUE INTO F-MES2
              MOVE 2 TO F-NMES
              CALL 'vrmbox' USING PARMB
              GO TO RDFAT.
      ************
      **** rel 5.2
           IF FAT-DATA < AZI-DTAPE
              MOVE 'Data inferiore a Data Apertura' TO F-MES1
              MOVE HIGH-VALUE TO F-MES2
              MOVE FATT TO FATTZ
              STRING 'Fattura ' 
                      FATTZ '       non contabilizzata *'
                      DELIMITED HIGH-VALUE INTO F-MES2
              MOVE 2 TO F-NMES
              CALL 'vrmbox' USING PARMB
              GO TO RDFAT.
      ************
           IF FAT-DATA NOT > DTAIVA
                            MOVE HIGH-VALUE TO F-MES1
                            STRING '* Totali  iva  aggiornati  al   '
                                   DATIVB DELIMITED HIGH-VALUE
                                   INTO F-MES1
                            MOVE HIGH-VALUE TO F-MES2
                            MOVE FATT TO FATTZ
                            STRING 'Fattura '
                              FATTZ '       non contabilizzata *'
                                   DELIMITED HIGH-VALUE INTO F-MES2
                            MOVE 2 TO F-NMES
                            CALL 'vrmbox' USING PARMB
                            GO TO RDFAT.
           IF IF-FLTIG > ZERO AND KFT-TDOC < 4 AND
                            ( FAT-DATA NOT > T25-DTM )
                            MOVE HIGH-VALUE TO F-MES1
                            STRING 'Movimenti plafond aggiornati al '
                                   DTMB DELIMITED HIGH-VALUE
                                   INTO F-MES1
                            MOVE HIGH-VALUE TO F-MES2
                            MOVE FATT TO FATTZ
                            STRING 'Fattura '
                              FATTZ '       non contabilizzata *'
                                   DELIMITED HIGH-VALUE INTO F-MES2
                            MOVE 2 TO F-NMES
                            CALL 'vrmbox' USING PARMB
                            GO TO RDFAT.
      **** rel 4.0
      *    IF KFT-TDOC NOT = 1 GO TO NOCALL.
      *    COMPUTE TOTACC = FAT-IMPOR (1) + FAT-IMPOR (2) +
      *                     FAT-IMPOR (3) + FAT-IMPOR (4) +
      *                     FAT-IMPOR (5) + FAT-IMPOR (6).
      *    COMPUTE TOTACC = FAT-TOTFT - TOTACC.
      **** rel 7.2
           IF (KFT-TDOC = 6 OR KFT-TDOC = 4) AND
              FAT-DATA >= 42005 
              GO TO NOSAC.
      ************
           IF FAT-VALUT = ZERO OR COMEURO
              COMPUTE TOTACC = FAT-IMPOR (1) + FAT-IMPOR (2) +
                               FAT-IMPOR (3) + FAT-IMPOR (4) +
      **** rel 6.0
      *                        FAT-IMPOR (5) + FAT-IMPOR (6)
                               FAT-IMPOR (5) + FAT-IMPOR (6) +
                               FAT-IMPOR (7) + FAT-IMPOR (8) +
                               FAT-IMPOR (9) + FAT-IMPOR (10) +
                               FAT-IMPOR (11) + FAT-IMPOR (12)
      ************
              COMPUTE TOTACC = FAT-TOTFT - TOTACC
           ELSE
              COMPUTE TOTACC = FAT-EIMPOR (1) + FAT-EIMPOR (2) +
                               FAT-EIMPOR (3) + FAT-EIMPOR (4) +
      **** rel 6.0
      *                        FAT-EIMPOR (5) + FAT-EIMPOR (6)
                               FAT-EIMPOR (5) + FAT-EIMPOR (6) +
                               FAT-EIMPOR (7) + FAT-EIMPOR (8) +
                               FAT-EIMPOR (9) + FAT-EIMPOR (10) +
                               FAT-EIMPOR (11) + FAT-EIMPOR (12)
      ************
              COMPUTE TOTACC = FAT-TOVAL - TOTACC
              MOVE FAT-CADOC TO ER-CAMBIO
              MOVE FAT-VALUT TO ER-VALUT
              MOVE TOTACC    TO ER-IMPORTO
              CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT ER-CAMBIO
              MOVE ER-IMPORTO TO TOTACC.
      ************
      **** rel 7.2
       NOSAC.
      ************
      **** rel 6.1
           PERFORM CALC-RITE THRU EX-CALC-RITE.
      ************
           IF TOTACC = ZERO GO TO NOCALL.
           MOVE 2       TO KTB-TIP.
           MOVE T14ACCO TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           CLOSE ANACON.
           CLOSE EFFETT.
           CLOSE FATTUR.
           CLOSE ANAAZI.
           CLOSE TABELL.
           PERFORM RACCON THRU EX-RACCON.
           OPEN INPUT TABELL ANACON.
           OPEN I-O FATTUR EFFETT ANAAZI.
           READ FATTUR INVALID PERFORM INVK-FAT
                               GO TO ERRIO.
       NOCALL.
      **** rel 6.2
           MOVE 1 TO FLGFTP.
           MOVE 1 TO K.
           IF FAT-TPAG(K) = ZERO 
              PERFORM UNTIL K > 12 
                 MOVE ZERO TO FAT-TPAG(K)
                 ADD 1 TO K
              END-PERFORM
              MOVE ZERO TO FLGFTP.
      ************
           MOVE ZERO TO WRKLAV.
           MOVE ZERO TO WTDOC.
           MOVE ZERO TO WIMVAL WVALUT WCAMGG.
           MOVE ZERO TO WISC (1) WISC (2) WISC (3) WISC (4).
           MOVE ZERO TO WISC (5) WISC (6).
           MOVE ZERO TO WVSC (1) WVSC (2) WVSC (3) WVSC (4)
                        WVSC (5) WVSC (6).
           MOVE ZERO TO WIMP (1) WIVA (1)
                        WIMP (2) WIVA (2)
                        WIMP (3) WIVA (3)
                        WIMP (4) WIVA (4)
                        WIMP (5) WIVA (5)
                        WIMP (6) WIVA (6).
           MOVE ZERO TO WPLAM (1) WPLAM (2) WPLAM (3) WPLAM (4)
                        WPLAM (5) WPLAM (6) WPLAN (1) WPLAN (2)
                        WPLAN (3) WPLAN (4) WPLAN (5) WPLAN (6).
           MOVE SPACE TO WDES (1) WDES (2) WDES (3)
                         WDES (4) WDES (5) WDES (6).
           MOVE SPACE TO WCCOST (1) WCCOST (2) WCCOST (3)
                         WCCOST (4) WCCOST (5) WCCOST (6).
           MOVE WCORP TO WCOR(1) WCOR(2) WCOR(3) WCOR(4)
                         WCOR(5) WCOR(6) WCOR(7) WCOR(8).
           MOVE SPACE TO WDESC.
           MOVE ZERO TO WFLAG WCDPAG WNRATE.
           MOVE ZERO TO WCDBAN.
           MOVE ZERO TO L.
       AZZSCA.
           ADD 1 TO L.
           IF L > 12 GO TO AZZ10.
           MOVE ZERO TO WTPAG (L) WDTSCA (L) WIMRATA (L).
           MOVE ZERO TO WVALRATA (L).
      **** rel 6.2
           MOVE SPACE TO WNOTE(L) WNOTEA(L).
      ************
           GO TO AZZSCA.
       AZZ10.
           MOVE KAZ-COD TO CDAZ.
           MOVE 4 TO TREG.
           MOVE T14FATT TO WCAUS.
           IF KFT-TDOC = 3 MOVE T14ACCR TO WCAUS.
           IF KFT-TDOC = 4 MOVE T14FTSO TO WCAUS.
           IF KFT-TDOC = 6 MOVE T14ACSO TO WCAUS.
           MOVE 2     TO KTB-TIP.
           MOVE WCAUS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T02-FLGIS > 1 PERFORM ERTB THRU EX-ERTB
                            GO TO EX-RUN-ELABORA.
           IF T02-FLGIS = ZERO  AND (KFT-TDOC = 4 OR 6)
              PERFORM ERTB THRU EX-ERTB
              GO TO EX-RUN-ELABORA.
           IF T02-FLGIS = 1 AND NOT (KFT-TDOC = 4 OR 6)
              PERFORM ERTB THRU EX-ERTB
              GO TO EX-RUN-ELABORA.
           OPEN INPUT ANACLF.
           MOVE KAZ-COD TO KCF-AZI.
           MOVE FAT-CDCLI TO COD.
           MOVE CODCLI TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID PERFORM INVK-CLF
                                           PERFORM VISK-FAT
                                           CLOSE ANACLF
                                           GO TO ERRIO.
           CLOSE ANACLF.
      **** rel 5.0
           MOVE CLF-13IVA TO CLFIVA.
      ************
           MOVE T02-FLGSC TO WFLGSC.
           MOVE T02-D-A   TO WDA.
           MOVE T02-SEGNO TO WSEGNO.
           MOVE FAT-CDCLI TO COD.
           MOVE CODCLR    TO WPART.
           MOVE ZERO      TO WDTSCD.
           MOVE KFT-NUM   TO WNPRGI.
      *    IF IF-FLGIS = 2 AND (KFT-TDOC = 4 OR 6)
      *       ADD 1 TO IF-PRSOS
      *       MOVE IF-PRSOS TO WNPRGI.
           MOVE KFT-NUM   TO WNDOC.
           MOVE FAT-DATA  TO WDATA.
           MOVE FAT-TOTFT TO WTDOC.
           IF FAT-DTVAL NOT = ZERO MOVE FAT-TOVAL TO WIMVAL
                                   MOVE FAT-VALUT TO WVALUT
                                   MOVE FAT-CADOC TO WCAMGG.
           MOVE FAT-CATT  TO WCATT.
           MOVE ZERO TO IND.
      **** rel 7.2
           MOVE ZERO TO TOTIMP.
      ************
       LPIND.
           ADD 1 TO IND.
           IF IND > 6 GO TO LPRIC.
           IF FAT-CDIVA (IND) = ZERO GO TO LPRIC.
           MOVE 3 TO KTB-TIP.
           MOVE FAT-CDIVA (IND) TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE FAT-CDIVA (IND) TO WCOD (IND).
           MOVE FAT-IMPON (IND) TO WIMP (IND).
           MOVE FAT-IMPOS (IND) TO WIVA (IND).
      **** rel 7.2
           ADD FAT-IMPOS(IND) TO TOTIMP.
      ************
           MOVE 9999999 TO WCON (IND).
           IF T25-PLA  = ZERO GO TO LPIND.
           IF IF-FLTIG = ZERO GO TO LPIND.
           IF NOT ( FAT-CDIVA (IND) = T14IDIR OR
                                      T14ITRI OR
                                      T14IIND OR
                                      T14ISCV OR
                                      T14IRSM OR
                                      T14IASS OR
                                      T14ISIN )
                                      AND T03-TSPLA = ZERO
                                      GO TO LPIND.
           IF TPL = 2 AND FAT-CDIVA (IND) NOT = T14IASS
                      AND T03-TSPLA NOT = TPL
                      GO TO LPIND.
           IF TPL = 3 AND FAT-CDIVA (IND) NOT = T14ISIN
                      AND T03-TSPLA NOT = TPL
                      GO TO LPIND.
           MOVE FAT-DATA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AA4 TO ANDOC.
      **** rel 1.2
           MOVE IF-PER99 TO PER99.
      ************
           IF PER99 = 9 MOVE MM9 TO P99M
                        MOVE AA4 TO P99A.
           MOVE ZERO TO K.
       LPVET.
           ADD 1 TO K.
           IF K > 5 GO TO LPVE1.
           IF KFT-NUM < IF-FAT10 (K) OR > IF-FAT20 (K) GO TO LPVET.
           IF IF-PER00 (K) = 9 MOVE MM9  TO WPLAM (IND)
                              MOVE ZERO TO WPLAN (IND)
                              GO TO LPIND.
           IF IF-PER00 (K) = ZERO
              MOVE ZERO TO WPLAM (IND) WPLAN (IND)
              GO TO LPIND.
           MOVE IF-PMES (K) TO WPLAM (IND).
           MOVE IF-PANN(K)  TO ANREG.
           GO TO LPVE2.
       LPVE1.
           MOVE P99M TO WPLAM (IND).
           MOVE P99A TO ANREG.
       LPVE2.
           MOVE ZERO TO WPLAN (IND).
           IF ANREG > ANDOC COMPUTE WPLAN (IND) = ANREG - ANDOC + 1.
           IF ANREG < ANDOC MOVE 1 TO WPLAN (IND).
           GO TO LPIND.
       LPRIC.
           PERFORM RCONTR THRU EX-RCONTR.
           MOVE FAT-SPBOL TO COMIMP.
           IF COMIMP = ZERO GO TO LPBAN.
           MOVE ZERO      TO WCOD (IND).
           MOVE FAT-SPBOL TO WIMP (IND).
           MOVE ZERO      TO WIVA (IND).
           MOVE T14SPBOL  TO WCON (IND).
           ADD 1 TO IND.
       LPBAN.
           MOVE FAT-SPBAN TO COMIMP.
           IF COMIMP = ZERO GO TO EXBAN.
           MOVE ZERO      TO WCOD (IND).
           MOVE FAT-SPBAN TO WIMP (IND).
           MOVE ZERO      TO WIVA (IND).
           MOVE T14SPBAN  TO WCON (IND).
           ADD 1 TO IND.
       EXBAN.
           MOVE FAT-OMAGG TO COMIMP.
      **** rel 5.0-2
      *    IF COMIMP = ZERO OR T14CSGR = ZERO GO TO LPSCON.
           IF COMIMP = ZERO GO TO LPSCON.
           IF T14CSGR = ZERO
              MOVE 'Manca conto ricavi cessioni gratuite !' TO F-MES1
              MOVE 'Sistemare tabella parametri'     TO F-MES2
              MOVE 'e verificare registrazione '     TO F-MES3
              MOVE KFT-NUM  TO NUMFAT
              MOVE KFT-TDOC TO TDOC
              STRING 'fattura : ' TDOC '/' NUMFAT DELIMITED SIZE
                      INTO F-MES4
              MOVE 4 TO F-NMES
              CALL 'vrmbox' USING PARMB
              GO TO LPSCON.
      **************
           MOVE KAZ-COD TO KPC-AZI.
           MOVE T14CSGR TO KPC-COD.
           READ ANACON INVALID KEY GO TO LPSCON.
           MOVE ZERO      TO WCOD (IND).
           MOVE FAT-OMAGG TO WIMP (IND).
           MOVE ZERO      TO WIVA (IND).
           MOVE T14CSGR   TO WCON (IND).
           MOVE WDA       TO WD-A (IND).
      **** rel 5.2
      *    IF K > ZERO ADD FAT-OMAGG TO WIMP (K)
           IF K > ZERO AND WCON(K) = RICCGR
                       ADD FAT-OMAGG TO WIMP (K)
      ************
                       ADD 1 TO IND
                       GO TO LPSCON.
           ADD 1 TO IND.
           MOVE IND TO K.
      **** rel 5.2
      *    MOVE RICAV     TO WCON (IND).
           MOVE RICCGR    TO WCON(IND).
      ************
           MOVE FAT-OMAGG TO WIMP (IND).
           ADD 1 TO IND.
       LPSCON.
           MOVE FAT-SCONT TO COMIMP.
      **** rel 5.0-2
      *    IF COMIMP = ZERO OR T14SCON = ZERO GO TO LPNORI.
           IF COMIMP  = ZERO GO TO LPNORI.
           IF T14SCON = ZERO
              MOVE 'Manca conto ricavi sconti in merce !' TO F-MES1
              MOVE 'Sistemare tabella parametri'   TO F-MES2
              MOVE 'e verificare registrazione '   TO F-MES3
              MOVE KFT-NUM  TO NUMFAT
              MOVE KFT-TDOC TO TDOC
              STRING 'fattura : ' TDOC '/' NUMFAT DELIMITED SIZE
                      INTO F-MES4
              MOVE 4 TO F-NMES
              CALL 'vrmbox' USING PARMB
              GO TO LPNORI.
      **************
           MOVE KAZ-COD TO KPC-AZI.
           MOVE T14SCON TO KPC-COD.
           READ ANACON INVALID KEY GO TO LPNORI.
           MOVE ZERO      TO WCOD (IND).
           MOVE FAT-SCONT TO WIMP (IND).
           MOVE ZERO      TO WIVA (IND).
           MOVE T14SCON   TO WCON (IND).
           MOVE WDA       TO WD-A (IND).
      **** rel 5.2
      *    IF K > ZERO ADD FAT-SCONT TO WIMP (K)
           IF K > ZERO AND WCON(K) = RICSCM
                       ADD FAT-SCONT TO WIMP (K)
      ************
                       ADD 1 TO IND
                       GO TO LPNORI.
           ADD 1 TO IND.
           MOVE IND TO K.
      **** rel 5.2
      *    MOVE RICAV     TO WCON (IND).
           MOVE RICSCM    TO WCON(IND).
      ************
           MOVE FAT-SCONT TO WIMP (IND).
           ADD 1 TO IND.
       LPNORI.
      **** rel 7.2
      * creazione scrittura automatica split payment
           IF T14GISO NOT = ZERO
              IF (KFT-TDOC = 6 OR KFT-TDOC = 4) AND
                 FAT-DATA >= 42005 
                 PERFORM GIRO-SPLITP THRU EX-GIRO-SPLITP.
      ************
           MOVE FAT-IVRIV TO COMIMP.
           IF COMIMP = ZERO OR T14IVGR = ZERO GO TO LPESCI.
           MOVE KAZ-COD TO KPC-AZI.
           MOVE T14IVGR TO KPC-COD.
           READ ANACON INVALID KEY PERFORM INVK-CON
                                   GO TO ERRIO.
           MOVE ZERO      TO WCOD (IND).
           MOVE FAT-IVRIV TO WIMP (IND).
           MOVE ZERO      TO WIVA (IND).
           MOVE T14IVGR   TO WCON (IND).
           MOVE WDA       TO WD-A (IND).
       LPESCI.
           MOVE ZERO TO IND IND1.
       LPZER.
           ADD 1 TO IND.
           IF IND > 6 MOVE ZERO TO IND GO TO LPSCAD.
           MOVE ZERO TO WDSC (IND).
           MOVE ZERO TO WISC (IND).
           MOVE ZERO TO WVSC (IND).
           GO TO LPZER.
       LPSCAD.
           ADD 1 TO IND1.
      **** rel 1.2
      *    IF IND1 > 6 GO TO LPCALL.
           IF IND1 > 12 GO TO LPCALL.
      ************
           IF FAT-DTSCA (IND1) = ZERO GO TO LPCALL.
      **** rel 1.2
      *    MOVE FAT-DTSCA (IND1) TO WDSC (IND1).
      *    MOVE FAT-IMPOR (IND1) TO WISC (IND1).
           IF IND1 <= 6
              MOVE FAT-DTSCA(IND1)  TO WDSC(IND1)
              MOVE FAT-IMPOR(IND1)  TO WISC(IND1)
              MOVE FAT-EIMPOR(IND1) TO WVSC(IND1)
           ELSE
              ADD FAT-IMPOR(IND1)  TO WISC(6)
              ADD FAT-EIMPOR(IND1) TO WVSC(6).
      ************
           GO TO LPSCAD.
       LPCALL.
      **** rel 1.2
      *    PERFORM SCAVAL THRU EX-SCAVAL.
      *    MOVE SV-IMVAL(1) TO WVSC(1).
      *    MOVE SV-IMVAL(2) TO WVSC(2).
      *    MOVE SV-IMVAL(3) TO WVSC(3).
      *    MOVE SV-IMVAL(4) TO WVSC(4).
      *    MOVE SV-IMVAL(5) TO WVSC(5).
      *    MOVE SV-IMVAL(6) TO WVSC(6).
      ************
           MOVE WDATA TO DTCON.
           IF NOT ( WFLGSC = 1 OR 3 ) GO TO LCALL.
           MOVE 1 TO WFLAG.
           MOVE 4 TO KTB-TIP.
           MOVE FAT-CDPAG TO WCDPAG KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T04-NRATE TO WNRATE.
      **** rel 6.2
           IF WNRATE = ZERO
              PERFORM CALCOLA-RATE THRU EX-CALCOLA-RATE.
      *
           MOVE FAT-CDBAN TO WCDBAN.
      ************
      **** rel 6.1
           IF RITE NOT = ZERO
              PERFORM CREA-SCADENZE-RITE THRU EX-CREA-SCADENZE-RITE.
      ************
           MOVE ZERO TO L.
       LP10.
           ADD 1 TO L.
      **** rel 1.2
      *    IF L > 6 GO TO LCALL.
           IF L > 12 GO TO LCALL.
      ************
           IF FAT-DTSCA (L) = ZERO GO TO LCALL.
      **** rel 6.2
      *    MOVE T04-TIPAG     TO WTPAG (L).
           IF FLGFTP = 1
              MOVE FAT-TPAG (L)  TO WTPAG (L)
           ELSE
              MOVE T04-TIPAG     TO WTPAG (L).
      ***********
           MOVE FAT-DTSCA (L) TO WDTSCA (L).
           MOVE FAT-IMPOR (L) TO WIMRATA (L).
      **** rel 6.1
           IF RITE NOT = ZERO
             IF L < WNRATE SUBTRACT COMR  FROM WIMRATA(L)
             ELSE          SUBTRACT COMUR FROM WIMRATA(L).
      ************
           IF WDA = 'A' MULTIPLY -1 BY WIMRATA (L).
           IF WDA = 'D' AND WSEGNO = 1 MULTIPLY -1 BY WIMRATA (L).
      **** rel 6.1
           IF RITE = ZERO GO TO LP10.
           COMPUTE L1 = L + WNRATE.
           IF L1 > 12 GO TO LP10.
           MOVE 3             TO WTPAG (L1).
           MOVE FAT-DTSCA (L) TO WDTSCA (L1).
           MOVE COMUR         TO WIMRATA (L1).
           IF L < WNRATE MOVE COMR TO WIMRATA(L1)
           IF WDA = 'A' MULTIPLY -1 BY WIMRATA (L1).
           IF WDA = 'D' AND WSEGNO = 1 MULTIPLY -1 BY WIMRATA (L1).
      ************
           GO TO LP10.
       LCALL.
      **** rel 1.2
      *    PERFORM SCAVAL THRU EX-SCAVAL.
      *    MOVE ZERO TO J2.
      *LOOPV.
      *    ADD 1 TO J2.
      *    IF J2 > 6 GO TO EXLV.
      *    MOVE SV-IMVAL(J2) TO WVALRATA(J2).
      *    IF WDA = 'A'
      *       IF WVALRATA(J2) NOT = ZERO MULTIPLY -1 BY WVALRATA(J2).
      *    IF WDA = 'D' AND WSEGNO = 1
      *       IF WVALRATA(J2) NOT = ZERO MULTIPLY -1 BY WVALRATA(J2).
      *    GO TO LOOPV.
      *EXLV.
           MOVE 1 TO J2.
           PERFORM UNTIL J2 > 12
              MOVE FAT-EIMPOR(J2) TO WVALRATA(J2)
              IF WDA = 'A'
                 IF WVALRATA(J2) NOT = ZERO
                    MULTIPLY -1 BY WVALRATA(J2)
                 END-IF
              END-IF
              IF WDA = 'D' AND WSEGNO = 1
                 IF WVALRATA(J2) NOT = ZERO
                    MULTIPLY -1 BY WVALRATA(J2)
                 END-IF
              END-IF
              ADD 1 TO J2
           END-PERFORM.
      *
      ************
      **** rel 7.1
           PERFORM LEGGI-CCOST THRU EX-LEGGI-CCOST.
      ************
           CLOSE ANACON.
      **** rel 7.1
           CLOSE APPCON.
      ************
           CLOSE EFFETT.
           CLOSE FATTUR.
           CLOSE ANAAZI.
           CLOSE TABELL.
      **** rel 5.0
           MOVE ZERO TO MNREG.
      ************
           CALL 'vcon113' USING SWOPN DTCON WRKLAV WRKSCA
      **** rel 5.0
      *                        RET ID-AZI ID-CON ID-MOV.
                               RET ID-AZI ID-CON ID-MOV MNREG.
      ************
           CANCEL 'vcon113'.
           IF NOT (ERRIO-ST = ZERO OR 8) GO TO ERRIO.
           OPEN INPUT TABELL ANACON.
      **** rel 7.1
           OPEN INPUT APPCON.
      ************
           OPEN I-O FATTUR EFFETT ANAAZI.
           READ FATTUR INVALID PERFORM INVK-FAT
                               GO TO ERRIO.
           MOVE 1 TO FAT-STATU.
           REWRITE RF-FAT INVALID KEY PERFORM INVK-FAT GO TO ERRIO.
      **** rel 5.0
           IF FLGTRA NOT = 1 GO TO NO-INTRA.
           IF CLFIVA NOT = 4 GO TO NO-INTRA.
           MOVE KFT-AZI  TO AF-AZI.
           MOVE KFT-TDOC TO AF-TDOC.
           MOVE KFT-NUM  TO AF-NUMFAT.
           IF IF-FL = 1  MOVE 1 TO AF-FL
           ELSE          MOVE ZERO TO AF-FL.
           MOVE ZERO     TO AF-ST.
           CALL 'vfat180' USING ID-FAT PARAF DTCON.
           IF NOT (ERRIO-ST = ZERO OR 8) GO TO ERRIO.
       NO-INTRA.
      ************
           GO TO RDFAT.
       LOOPE.
           IF IF-TPELA = 1 GO TO AGGANCIO-AMM.
           MOVE ZERO TO KEYEF.
           MOVE KAZ-COD TO KEF-AZI.
           START EFFETT KEY NOT < KEYEF INVALID GO TO AGGANCIO-AMM.
       RDEFF.
           READ EFFETT NEXT AT END GO TO AGGANCIO-AMM.
           IF SF-EFF = '9D' OR '9A' OR '35' GO TO RDEFF.
           IF KEF-AZI > KAZ-COD GO TO AGGANCIO-AMM.
           IF EFF-STATU = 1        GO TO RDEFF.
           IF EFF-NUFAT < IF-FAT-1 GO TO RDEFF.
           IF EFF-NUFAT > IF-FAT-2 GO TO RDEFF.
           IF EFF-CATT NOT = IF-CATT GO TO RDEFF.
           IF EFF-DTCON = ZERO MOVE EFF-DTFAT TO DTCON
           ELSE                MOVE EFF-DTCON TO DTCON.
           IF DTCON > AZI-ULTDT GO TO RDEFF.
       NOOK1.
      **** rel 6.0
           CALL 'vrdtbigb' USING DTBIG.
           IF IF-TPELA = 3 AND EFF-DTFAT <= DTBIG
              MOVE 'Data minore/uguale del Big-bang'  TO F-MES1
              MOVE HIGH-VALUE TO F-MES2
              MOVE KEF-NUM TO FATTZ
              STRING 'Effetto '
                      FATTZ '       non contabilizzato *'
                      DELIMITED HIGH-VALUE INTO F-MES2
              MOVE 2 TO F-NMES
              CALL 'vrmbox' USING PARMB
              GO TO RDEFF.
      ************
      **** rel 5.2
      **** rel 7.1
      *    IF IF-TPELA = 3 AND EFF-DTFAT < AZI-DTAPE
           IF (IF-TPELA = 2 OR 3) AND EFF-DTFAT < AZI-DTAPE
      ************
              MOVE 'Data inferiore a Data Apertura' TO F-MES1
              MOVE HIGH-VALUE TO F-MES2
              MOVE KEF-NUM TO FATTZ
              STRING 'Effetto '
                      FATTZ '       non contabilizzato *'
                      DELIMITED HIGH-VALUE INTO F-MES2
              MOVE 2 TO F-NMES
              CALL 'vrmbox' USING PARMB
              GO TO RDEFF.
      ************
           IF IF-TPELA = 3 AND EFF-DTFAT NOT > DTAIVA
                            MOVE HIGH-VALUE TO F-MES1
                            STRING '* Totali  iva  aggiornati  al   '
                                   DATIVB DELIMITED HIGH-VALUE
                                   INTO F-MES1
                            MOVE HIGH-VALUE TO F-MES2
                            MOVE KEF-NUM TO FATTZ
                            STRING 'Effetto '
                              FATTZ '       non contabilizzato *'
                                   DELIMITED HIGH-VALUE INTO F-MES2
                            MOVE HIGH-VALUE TO F-MES3
                            MOVE EFF-NUFAT TO FATTZ
                            STRING 'Fattura '
                              FATTZ '       non contabilizzata *'
                                   DELIMITED HIGH-VALUE INTO F-MES3
                            MOVE 3 TO F-NMES
                            CALL 'vrmbox' USING PARMB
                            GO TO RDEFF.
           IF IF-FLTIG > ZERO AND
                    IF-TPELA = 3 AND ( EFF-DTFAT NOT > T25-DTM )
                            MOVE HIGH-VALUE TO F-MES1
                            STRING 'Movimenti plafond aggiornati al '
                                   DTMB DELIMITED HIGH-VALUE
                                   INTO F-MES1
                            MOVE HIGH-VALUE TO F-MES2
                            MOVE KEF-NUM TO FATTZ
                            STRING 'Effetto '
                              FATTZ '       non contabilizzato *'
                                   DELIMITED HIGH-VALUE INTO F-MES2
                            MOVE HIGH-VALUE TO F-MES3
                            MOVE EFF-NUFAT TO FATTZ
                            STRING 'Fattura '
                              FATTZ '       non contabilizzata *'
                                   DELIMITED HIGH-VALUE INTO F-MES3
                            MOVE 3 TO F-NMES
                            CALL 'vrmbox' USING PARMB
                            GO TO RDEFF.
           MOVE ZERO TO WRKLAV.
           MOVE ZERO TO WTDOC.
           MOVE ZERO TO WIMVAL WVALUT WCAMGG.
           MOVE ZERO TO WISC (1) WISC (2) WISC (3) WISC (4).
           MOVE ZERO TO WISC (5) WISC (6)
                        WVSC (1) WVSC (2) WVSC (3) WVSC (4)
                        WVSC (5) WVSC (6).
           MOVE ZERO TO WIMP (1) WIVA (1)
                        WIMP (2) WIVA (2)
                        WIMP (3) WIVA (3)
                        WIMP (4) WIVA (4)
                        WIMP (5) WIVA (5)
                        WIMP (6) WIVA (6).
           MOVE SPACE TO WDES (1) WDES (2) WDES (3)
                         WDES (4) WDES (5) WDES (6).
           MOVE SPACE TO WCCOST (1) WCCOST (2) WCCOST (3)
                         WCCOST (4) WCCOST (5) WCCOST (6).
           MOVE SPACE TO WDESC.
           MOVE ZERO TO IND.
       LPAZ1.
           ADD 1 TO IND.
           IF IND > 6 GO TO EXAZ1.
           MOVE ZERO TO WDSC (IND).
           MOVE ZERO TO WISC (IND).
           MOVE ZERO TO WVSC (IND).
           GO TO LPAZ1.
       EXAZ1.
           MOVE ZERO TO WFLAG WCDPAG WNRATE.
      **** rel 6.2
           MOVE ZERO TO WCDBAN.
      ************
           MOVE ZERO TO L.
       AZZSCA1.
           ADD 1 TO L.
           IF L > 12 GO TO AZZ20.
           MOVE ZERO TO WTPAG (L) WDTSCA (L) WIMRATA (L).
           MOVE ZERO TO WVALRATA (L).
      **** rel 6.2
           MOVE SPACE TO WNOTE(L) WNOTEA(L).
      ************
           GO TO AZZSCA1.
       AZZ20.
           MOVE AZI-COD TO CDAZ.
           MOVE 4 TO TREG.
           MOVE T14TRT TO WCAUS.
           IF KEF-TIPO = 2
              MOVE T14RB TO WCAUS.
           MOVE EFF-CDCLI TO COD.
           MOVE CODCLR    TO WPART.
           MOVE EFF-DTSCA TO WDTSCD.
           MOVE ZERO      TO WNPRGI.
           MOVE EFF-NUFAT TO WNDOC.
           MOVE EFF-DTFAT TO WDATA.
           MOVE EFF-IMPOR TO WTDOC.
           MOVE EFF-CATT  TO WCATT.
           MOVE SPACE TO DESAG.
           MOVE 'NS.FATT.' TO DES1.
           MOVE SPACE TO NFAT NFAT1 NFAT2 NFAT3 NFAT4 NFAT5.
           MOVE EFF-NUFAT TO XNFAT1.
           IF EFF-NUFT2 NOT = ZERO
              MOVE EFF-NUFT2 TO XNFAT2.
           IF EFF-NUFT3 NOT = ZERO
              MOVE EFF-NUFT3 TO XNFAT3.
           IF EFF-NUFT4 NOT = ZERO
              MOVE EFF-NUFT4 TO XNFAT4.
           IF EFF-NUFT5 NOT = ZERO
              MOVE EFF-NUFT5 TO XNFAT5.
           MOVE NFAT1 TO NFAT.
           IF WFL1 = SPACE MOVE WNF1 TO NFAT1.
           IF WFL2 = SPACE MOVE WNF2 TO NFAT1.
           IF WFL3 = SPACE MOVE WNF3 TO NFAT1.
           IF WFL4 = SPACE MOVE WNF4 TO NFAT1.
           IF NFAT2 = SPACE GO TO LPSTR.
           MOVE NFAT2 TO NFAT.
           IF WFL1 = SPACE MOVE WNF1 TO NFAT2.
           IF WFL2 = SPACE MOVE WNF2 TO NFAT2.
           IF WFL3 = SPACE MOVE WNF3 TO NFAT2.
           IF WFL4 = SPACE MOVE WNF4 TO NFAT2.
           IF NFAT3 = SPACE GO TO LPSTR.
           MOVE NFAT3 TO NFAT.
           IF WFL1 = SPACE MOVE WNF1 TO NFAT3.
           IF WFL2 = SPACE MOVE WNF2 TO NFAT3.
           IF WFL3 = SPACE MOVE WNF3 TO NFAT3.
           IF WFL4 = SPACE MOVE WNF4 TO NFAT3.
           IF NFAT4 = SPACE GO TO LPSTR.
           MOVE NFAT4 TO NFAT.
           IF WFL1 = SPACE MOVE WNF1 TO NFAT4.
           IF WFL2 = SPACE MOVE WNF2 TO NFAT4.
           IF WFL3 = SPACE MOVE WNF3 TO NFAT4.
           IF WFL4 = SPACE MOVE WNF4 TO NFAT4.
           IF NFAT5 = SPACE GO TO LPSTR.
           MOVE NFAT5 TO NFAT.
           IF WFL1 = SPACE MOVE WNF1 TO NFAT5.
           IF WFL2 = SPACE MOVE WNF2 TO NFAT5.
           IF WFL3 = SPACE MOVE WNF3 TO NFAT5.
           IF WFL4 = SPACE MOVE WNF4 TO NFAT5.
       LPSTR.
           STRING NFAT1 DELIMITED '  '
                  SPACE
                  NFAT2 DELIMITED '  '
                  SPACE
                  NFAT3 DELIMITED '  '
                  SPACE
                  NFAT4 DELIMITED '  '
                  SPACE
                  NFAT5 DELIMITED SIZE INTO DES2.
           MOVE DESAG TO WDESC.
           MOVE 1 TO IND.
           MOVE ZERO TO WCOD (IND).
           MOVE ZERO TO WIMP (IND).
           MOVE EFF-IMPOR TO WIVA (IND).
           MOVE T14TRATT TO WCON (IND).
           IF KEF-TIPO = 2
               MOVE T14RIBAN TO WCON (IND).
      **** rel 7.1
           PERFORM LEGGI-CCOST THRU EX-LEGGI-CCOST.
      ************
           CLOSE ANACON.
      **** rel 7.1
           CLOSE APPCON.
      ************
           CLOSE EFFETT.
           CLOSE FATTUR.
           CLOSE ANAAZI.
           CLOSE TABELL.
      **** rel 5.0
           MOVE ZERO TO MNREG.
      ************
           CALL 'vcon113' USING SWOPN DTCON WRKLAV WRKSCA
      **** rel 5.0
      *                        RET ID-AZI ID-CON ID-MOV.
                               RET ID-AZI ID-CON ID-MOV MNREG.
      ************
           CANCEL 'vcon113'.
           IF NOT (ERRIO-ST = ZERO OR 8) GO TO ERRIO.
           OPEN INPUT TABELL ANACON.
      **** rel 7.1
           OPEN INPUT APPCON.
      ************
           OPEN I-O EFFETT FATTUR ANAAZI.
           READ EFFETT INVALID PERFORM INVK-EFF GO TO ERRIO.
           MOVE 1 TO EFF-STATU.
      **** rel 5.0
           MOVE MNREG TO EFF-NREG.
      ************
           REWRITE RF-EFF INVALID KEY PERFORM INVK-EFF GO TO ERRIO.
      **** rel 5.0
      **** rel 5.2
      *    PERFORM S00-AGGIO-SCA THRU S99.
           IF EFF-NUFT2 = ZERO
              MOVE 1 TO K1
              MOVE EFF-NUFAT TO NUFAT(K1)
              MOVE EFF-DTFAT TO DTFAT(K1)
              MOVE EFF-IMPOR TO IMPEF(K1)
              PERFORM S00-AGGIO-SCA THRU S99
           ELSE
              PERFORM EFFETTI-RAGGRUPPATI THRU EX-EFFETTI-RAGGRUPPATI.
      ************
      ************
           GO TO RDEFF.
      *
       AGGANCIO-AMM.
           PERFORM AMM-00 THRU EX-AMM-00.
      **** rel 5.2
           PERFORM VER-FATT-DA-EM THRU EX-VER-FATT-DA-EM.
      ************
      *
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       RCONTR.
           MOVE ZERO TO FLCNT.
      **** rel 5.2
           MOVE ZERO TO FLAVE.
      ************
           MOVE ZERO TO K.
           MOVE ZERO TO IND2.
       LPRIC1.
           ADD 1 TO IND2.
           IF IND2 > 15 GO TO EX-RCONTR.
           IF FAT-IMPCP (IND2) = ZERO GO TO LPRIC1.
           MOVE ZERO TO WCOD (IND).
           MOVE ZERO TO WIVA (IND).
           IF FAT-CPART (IND2) = ZERO GO TO RICAVI.
           MOVE KAZ-COD TO KPC-AZI.
           MOVE FAT-CPART (IND2) TO KPC-COD.
           READ ANACON INVALID KEY GO TO RICAVI.
           MOVE FAT-IMPCP (IND2) TO WIMP (IND).
           MOVE FAT-CPART (IND2) TO WCON (IND).
      **** rel 5.2
           IF IF-FL = ZERO AND KFT-TDOC = 3
              PERFORM VER-CP THRU EX-VER-CP.
      ************
           IF FLAMM = ZERO GO TO RICAV-10.
           IF FLCNT NOT = ZERO GO TO LPRIC2.
           OPEN INPUT TACOAM.
           MOVE FAT-CPART (IND2) TO TAC-CONTO.
           MOVE KAZ-COD          TO TAC-AZI.
           READ TACOAM KEY KEYTC2 INVALID GO TO RICAV-00.
           ADD 1 TO J.
           IF J > 50 GO TO RICAV-00.
           MOVE 1 TO FLCNT.
           MOVE KFT-AZI  TO CM-AZI (J).
           MOVE KFT-TDOC TO CM-TDOC (J).
           MOVE KFT-NUM  TO CM-NUM (J).
       RICAV-00.
           CLOSE TACOAM.
       RICAV-10.
           IF FAT-TOTFT NOT < ZERO AND WIMP (IND) < ZERO
                                   MULTIPLY -1 BY WIMP (IND)
                                   MOVE WDA TO WD-A (IND).
           IF FAT-TOTFT < ZERO AND WIMP (IND) > ZERO
                                   MULTIPLY -1 BY WIMP (IND)
                                   MOVE WDA TO WD-A (IND).
           GO TO LPRIC2.
       RICAVI.
           IF K > ZERO ADD FAT-IMPCP (IND2) TO WIMP (K) GO TO LPRIC1.
           MOVE IND TO K.
           IF CLF-CATCON = ZERO MOVE 1 TO CLF-CATCON.
           IF T14RIC0 (CLF-CATCON) = ZERO MOVE RICAV TO WCON (IND)
                           ELSE
                           MOVE T14RIC0 (CLF-CATCON) TO WCON (IND).
           MOVE FAT-IMPCP (IND2) TO WIMP (IND).
       LPRIC2.
           ADD 1 TO IND.
           GO TO LPRIC1.
       EX-RCONTR.
           EXIT.
      *------------------
      *---- Contabilizzazione acconti su merce da fatturare
       RACCON.
           OPEN INPUT BOLCTE.
           OPEN I-O ACCONT.
           MOVE ZERO TO TOTACR.
      **** rel 1.2
           CALL 'rdbfa' USING FAT-CATT KEYFT PARRB.
      ************
           MOVE ZERO TO K.
       RDACC.
           ADD 1 TO K.
      **** rel 1.2
      *    IF K > 15 GO TO FIBOL.
      *    IF FAT-TNUM (K) = ZERO AND FAT-NBOL (K) = ZERO GO TO FIBOL.
           IF K > RB-ULTBOL GO TO FIBOL.
           IF RB-TNUM(K) = ZERO AND RB-NBOL(K) = ZERO GO TO FIBOL.
      ************
           MOVE KAZ-COD      TO KAC-AZI.
      **** rel 1.2
      *    MOVE FAT-TNUM (K) TO KAC-NUM.
      *    MOVE FAT-NBOL (K) TO KAC-BOL.
           MOVE RB-TNUM(K) TO KAC-NUM.
           MOVE RB-NBOL(K) TO KAC-BOL.
      ************
           READ ACCONT INVALID GO TO RDACC.
           ADD ACC-IMPOR TO TOTACR.
           DELETE ACCONT INVALID PERFORM INVK-ACC
                                 GO TO ERRIO.
           IF ACC-IMPOR NOT = ZERO GO TO RDACC.
           MOVE KAZ-COD      TO KBC-AZI.
      **** rel 1.2
      *    MOVE FAT-TNUM (K) TO KBC-NUM.
      *    MOVE FAT-NBOL (K) TO KBC-BOL.
           MOVE RB-TNUM(K) TO KBC-NUM.
           MOVE RB-NBOL(K) TO KBC-BOL.
      ************
           READ BOLCTE INVALID GO TO RDACC.
           IF BCT-ACCON = ZERO GO TO RDACC.
           IF BCT-FLACC = ZERO GO TO RDACC.
      **** rel 4.0
      *    ADD BCT-ACCON TO TOTACR.
           IF BCT-VALUT = ZERO OR COMEURO
              ADD BCT-ACCON TO TOTACR
           ELSE
              MOVE BCT-CAMGG TO ER-CAMBIO
              MOVE BCT-VALUT TO ER-VALUT
              MOVE BCT-ACCON TO ER-IMPORTO
              CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT ER-CAMBIO
              ADD ER-IMPORTO TO TOTACR.
      ************
           MOVE ZERO TO WRKLAV.
           MOVE ZERO TO WTDOC.
           MOVE ZERO TO WIMVAL WVALUT WCAMGG.
           MOVE ZERO TO WPLAM (1) WPLAM (2) WPLAM (3) WPLAM (4)
                        WPLAM (5) WPLAM (6) WPLAN (1) WPLAN (2)
                        WPLAN (3) WPLAN (4) WPLAN (5) WPLAN (6).
           MOVE ZERO TO WISC (1) WISC (2) WISC (3) WISC (4).
           MOVE ZERO TO WISC (5) WISC (6)
                        WVSC (1) WVSC (2) WVSC (3) WVSC (4)
                        WVSC (5) WVSC (6).
           MOVE ZERO TO WIMP (1) WIVA (1)
                        WIMP (2) WIVA (2)
                        WIMP (3) WIVA (3)
                        WIMP (4) WIVA (4)
                        WIMP (5) WIVA (5)
                        WIMP (6) WIVA (6).
           MOVE SPACE TO WDES (1) WDES (2) WDES (3)
                         WDES (4) WDES (5) WDES (6).
           MOVE SPACE TO WCCOST (1) WCCOST (2) WCCOST (3)
                         WCCOST (4) WCCOST (5) WCCOST (6).
           MOVE SPACE TO WDESC.
           MOVE ZERO TO IND.
       LPAZ2.
           ADD 1 TO IND.
           IF IND > 6 GO TO EXAZ2.
           MOVE ZERO TO WDSC (IND).
           MOVE ZERO TO WISC (IND).
           MOVE ZERO TO WVSC (IND).
           GO TO LPAZ2.
       EXAZ2.
           MOVE WCORP TO WCOR(1) WCOR(2) WCOR(3) WCOR(4)
                         WCOR(5) WCOR(6) WCOR(7) WCOR(8).
           MOVE SPACE TO WDESC.
           MOVE ZERO TO WCDBAN.
           MOVE ZERO TO WFLAG WCDPAG WNRATE.
           MOVE ZERO TO L.
       AZZSCA2.
           ADD 1 TO L.
           IF L > 12 GO TO AZZ22.
           MOVE ZERO TO WTPAG (L) WDTSCA (L) WIMRATA (L).
           MOVE ZERO TO WVALRATA (L).
      **** rel 6.2
           MOVE SPACE TO WNOTE(L) WNOTEA(L).
      ************
           GO TO AZZSCA2.
       AZZ22.
           MOVE KAZ-COD   TO CDAZ.
           MOVE 4         TO TREG.
           MOVE T14ACCO   TO WCAUS.
           MOVE FAT-CDCLI TO COD.
           MOVE CODCLR    TO WPART.
      **** rel 5.2
      *    MOVE FAT-DATA  TO DTCON.
           MOVE BCT-DATA  TO DTCON.
      ************
           MOVE ZERO      TO WNPRGI.
           MOVE KFT-NUM   TO WNDOC.
           MOVE FAT-DATA  TO WDATA.
      **** rel 4.0
      *    MOVE BCT-ACCON TO WTDOC.
           IF BCT-VALUT = ZERO OR COMEURO
              MOVE BCT-ACCON TO WTDOC
           ELSE
              MOVE BCT-CAMGG TO ER-CAMBIO
              MOVE BCT-VALUT TO ER-VALUT
              MOVE BCT-ACCON TO ER-IMPORTO
              CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT ER-CAMBIO
              MOVE ER-IMPORTO TO WTDOC.
      ************
           MOVE ZERO      TO WCATT.
           MOVE SPACE     TO WDESC.
           MOVE ZERO      TO WDTSCD.
           MOVE 1 TO IND.
           MOVE ZERO      TO WCOD (IND).
           MOVE ZERO      TO WIMP (IND).
      **** rel 4.0
      *    MOVE BCT-ACCON TO WIVA (IND).
           IF BCT-VALUT = ZERO OR COMEURO
              MOVE BCT-ACCON TO WIVA (IND)
           ELSE
              MOVE BCT-CAMGG TO ER-CAMBIO
              MOVE BCT-VALUT TO ER-VALUT
              MOVE BCT-ACCON TO ER-IMPORTO
              CALL 're2imp' USING ER-IMPORTO VAL-EUR ER-VALUT ER-CAMBIO
              MOVE ER-IMPORTO TO WIVA (IND).
      ************
           MOVE T14CACC   TO WCON (IND).
           CLOSE BOLCTE ACCONT.
      **** rel 5.0
           MOVE ZERO TO MNREG.
      ************
           CALL 'vcon113' USING SWOPN DTCON WRKLAV WRKSCA
      **** rel 5.0
      *                        RET ID-AZI ID-CON ID-MOV.
                               RET ID-AZI ID-CON ID-MOV MNREG.
      ************
           CANCEL 'vcon113'.
           IF NOT (ERRIO-ST = ZERO OR 8) GO TO ERRIO.
           OPEN INPUT BOLCTE.
           OPEN I-O ACCONT.
           GO TO RDACC.
       FIBOL.
           CLOSE BOLCTE ACCONT.
           IF TOTACC = TOTACR GO TO EX-RACCON.
           MOVE HIGH-VALUE TO F-MES1.
           MOVE FATT TO FATTZ.
           STRING 'ATTENZIONE !!!!!   Fattura numero '
                  FATTZ ' ' DELIMITED HIGH-VALUE INTO F-MES1.
           MOVE HIGH-VALUE TO F-MES2.
           MOVE TOTACC TO TOTACCZ.
      **** rel 4.0
      *    STRING 'Acconti in fattura lire   ' TOTACCZ
           STRING 'Acconti in fattura euro   ' TOTACCZ
      ************
                  DELIMITED HIGH-VALUE INTO F-MES2.
           MOVE HIGH-VALUE TO F-MES3.
           MOVE TOTACR TO TOTACCZ.
      **** rel 4.0
      *    STRING 'Contab.in automatico lire ' TOTACCZ
           STRING 'Contab.in automatico euro ' TOTACCZ
      ************
                  DELIMITED HIGH-VALUE INTO F-MES3.
           MOVE 3 TO F-NMES.
           CALL 'vrmbox' USING PARMB.
       EX-RACCON.
           EXIT.
      *------------------
      **** rel 1.2
      *SCAVAL.
      *    MOVE ZERO TO J2.
      *SVAL10.
      *    ADD 1 TO J2.
      *    IF J2 > 6 GO TO SVAL50.
      *    MOVE FAT-DTSCA(J2) TO SV-DTSCA(J2).
      *    MOVE FAT-IMPOR(J2) TO SV-IMPOR(J2).
      *    GO TO SVAL10.
      *SVAL50.
      *    MOVE FAT-DTVAL    TO SV-DTVAL.
      *    CALL 'vrscadv' USING PARSV.
      *EX-SCAVAL.
      *    EXIT.
      ************
      *------------------
       A00-CNT-NUM.
           MOVE ZERO TO MXNUM.
           MOVE ZERO TO K.
       A05.
           ADD 1 TO K.
           MOVE ZERO TO VTCNT (K).
           IF K < 200 GO TO A05.
           MOVE ZERO TO NUM.
           IF SWGIS = 1
              MOVE ZERO TO CTGIS
              MOVE 4 TO KFT-TDOC
              MOVE IF-FTSO-1 TO CTCNT
           ELSE
              MOVE ZERO TO FLCNT
              MOVE 1 TO KFT-TDOC
              MOVE IF-FAT-1 TO CTCNT.
       A10.
           MOVE KAZ-COD TO KFT-AZI.
           MOVE CTCNT   TO KFT-NUM.
           START FATTUR KEY NOT < KEYFT INVALID GO TO A40.
       A15.
           READ FATTUR NEXT AT END GO TO A40.
           IF KFT-AZI > KAZ-COD GO TO A40.
           IF KFT-NUM < CTCNT GO TO A15.
           IF SWGIS     = 1 AND KFT-NUM > IF-FTSO-2 GO TO A15.
           IF SWGIS NOT = 1 AND KFT-NUM > IF-FAT-2  GO TO A15.
           IF SWGIS = ZERO
              IF IF-FLGIS = 1 AND KFT-TDOC > 3 GO TO A40.
           IF SWGIS = 1 AND CTGIS = ZERO MOVE 1 TO CTGIS.
           IF FLCNT = ZERO MOVE 1 TO FLCNT.
           IF KFT-NUM > MXNUM MOVE KFT-NUM TO MXNUM.
           COMPUTE K = KFT-NUM - CTCNT + 1.
           IF K > 200 GO TO A20.
           MOVE KFT-NUM TO NUM.
           ADD 1 TO VTCNT (K).
           GO TO A15.
       A20.
           ADD 1 TO KFT-TDOC.
           IF SWGIS = ZERO
              IF IF-FLGIS = 1 AND KFT-TDOC > 3 GO TO A30.
           IF KFT-TDOC > 6 GO TO A30.
           MOVE KAZ-COD TO KFT-AZI.
           MOVE CTCNT   TO KFT-NUM.
           START FATTUR KEY NOT < KEYFT INVALID GO TO A30.
       A25.
           READ  FATTUR NEXT AT END GO TO A30.
           IF KFT-AZI > KAZ-COD GO TO  A30.
           IF KFT-NUM < CTCNT GO TO A25.
           IF SWGIS     = 1 AND KFT-NUM > IF-FTSO-2 GO TO A25.
           IF SWGIS NOT = 1 AND KFT-NUM > IF-FAT-2  GO TO A25.
           IF SWGIS = ZERO
              IF IF-FLGIS = 1 AND KFT-TDOC > 3 GO TO A30.
           IF KFT-NUM > MXNUM MOVE KFT-NUM TO MXNUM.
           COMPUTE K = KFT-NUM - CTCNT + 1.
           IF K > 200 GO TO A20.
           MOVE KFT-NUM TO NUM.
           ADD 1 TO VTCNT (K).
           GO TO A25.
       A30.
           MOVE MXNUM TO NUM.
           MOVE 200 TO K.
           MOVE SPACE TO MB-RISP.
           PERFORM B00-VIS-ERR THRU B99.
           IF MB-RISP = 'N' GO TO A99.
           COMPUTE CTCNT = CTCNT + 200.
           IF SWGIS = 1 MOVE 4 TO KFT-TDOC
                   ELSE MOVE 1 TO KFT-TDOC.
           GO TO A10.
       A40.
           IF FLCNT = ZERO AND IF-FLGIS NOT = 1 GO TO A99.
           IF FLCNT = ZERO GO TO A45.
           IF SWGIS = 1 AND CTGIS = ZERO GO TO A45.
           MOVE MXNUM TO NUM.
           COMPUTE K = MXNUM - CTCNT + 1.
           MOVE SPACE TO MB-RISP.
           PERFORM B00-VIS-ERR THRU B99.
           IF MB-RISP = 'N' GO TO A99.
       A45.
           IF SWGIS = 1 MOVE ZERO TO SWGIS
                        GO TO A99.
           IF IF-FLGIS NOT = 1 GO TO A99.
           IF IF-FTSO-2 = ZERO GO TO A99.
           MOVE IF-FLGIS TO SWGIS.
           MOVE 'Controllo fatture in sospeso' TO DSFAT.
           GO TO A00-CNT-NUM.
       A99.
           EXIT.
      *------------------
       B00-VIS-ERR.
           MOVE ZERO TO J2.
       B10.
           ADD 1 TO J2.
           IF J2 > K GO TO B30.
           COMPUTE NUMERO = CTCNT + J2 - 1.
           IF VTCNT (J2) = 1 GO TO B10.
           IF SWGIS = 1 AND CTGIS = 1
                        MOVE 2 TO CTGIS.
           IF FLCNT = 1 MOVE 2 TO FLCNT.
           MOVE SPACE TO F-MES1.
           IF VTCNT (J2) = ZERO
              STRING 'Fattura n. ' NUMERO ' mancante'
                     DELIMITED SIZE INTO F-MES1
           ELSE
              STRING 'Fattura n. ' NUMERO ' doppia'
                     DELIMITED SIZE INTO F-MES1.
           MOVE 'Vuoi continuare il controllo ?' TO F-MES2.
           MOVE 2 TO F-NMES.
           MOVE DSFAT TO MB-TITOLO.
           MOVE 'Q'   TO MB-TIPO.
           CALL 'vrmbox' USING PARMB.
           IF MB-RISP = 'N' GO TO B99.
       B20.
           IF SWGIS = 1 AND CTGIS = 1 GO TO B30.
           IF FLCNT = 1 GO TO B30.
           GO TO B10.
       B30.
           MOVE ZERO TO K.
       B40.
           ADD 1 TO K.
           MOVE ZERO TO VTCNT (K).
           IF K < 200 GO TO B40.
       B99.
           EXIT.
      *------------------
       CONV-DTP-A6.
           IF DTP = ZERO
              MOVE ZERO TO DTP6
           ELSE
              MOVE DTP TO DTP6
              MOVE AA61 TO AA62
              MOVE ZERO TO AA61
              CALL 'ranno4' USING AA6.
      *------------------
       ERTB.
           MOVE 'Causale non valida' TO F-MES1.
           MOVE 1 TO F-NMES.
           CALL 'vrmbox' USING PARMB.
       EX-ERTB.
           EXIT.
      *------------------
       REC-LOCK.
      **** rel 1.2
           CALL 'rlock' USING PARLK.
      ************
           EXIT.
      *------------------
      *
      * genera file di lavoro con movimenti da inserire su cespiti
      *
       AMM-00.
           OPEN OUTPUT WDS135.
           CLOSE WDS135.
           OPEN I-O WDS135.
      *
           MOVE ZERO TO K135-PROG.
           IF FLAMM = ZERO GO TO AMM-99.
      **** rel 6.2
      * serve ad interfaccia per abilitare aggancio ai cespiti
      *    MOVE 'AMM-SI' TO IF-CAMPO.
      ************
      *
           MOVE KAZ-COD TO L135-CDAZ.
           MOVE AZRGSOC TO L135-DAZI.
           MOVE ZERO TO J2.
       AMM-10.
           ADD 1 TO J2.
           IF J2 > 50 GO TO AMM-99.
           IF CM-AZI(J2) = ZERO GO TO AMM-99.
           MOVE CM-PAR(J2) TO KEYFT.
           READ FATTUR INVALID GO TO AMM-10.
           MOVE FAT-CDCLI TO COD.
           MOVE CODCLR TO L135-WPART.
           MOVE KFT-NUM TO L135-WNPRGI L135-WDOCUM.
      *
           MOVE FAT-DATA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO L135-DTCON L135-WDTDOC.
      *
           MOVE T14FATT TO L135-WCAUSA.
           IF KFT-TDOC = 3 MOVE T14ACCR TO L135-WCAUSA.
           IF KFT-TDOC = 4 MOVE T14FTSO TO L135-WCAUSA.
           IF KFT-TDOC = 6 MOVE T14ACSO TO L135-WCAUSA.
      *
           MOVE 2           TO KTB-TIP.
           MOVE L135-WCAUSA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID GO TO AMM-10.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T02-TIPRG TO L135-WTIPRG.
           MOVE T02-SEGNO TO L135-WSEGNO.
           MOVE T02-TIPOP TO L135-WTIPOP.
      *
           MOVE ZERO TO K.
       AMM-20.
           ADD 1 TO K.
           MOVE ZERO  TO L135-WCPART(K)
                         L135-WIMPCP(K)
                         L135-WCAUS2(K).
           MOVE SPACE TO L135-DCON(K).
           IF K < 15 GO TO AMM-20.
           OPEN INPUT TACOAM.
           MOVE ZERO TO K IND2.
       AMM-30.
           ADD 1 TO IND2.
           IF IND2 > 15 GO TO AMM-90.
           IF FAT-IMPCP(IND2) = ZERO GO TO AMM-30.
           IF FAT-CPART(IND2) = ZERO GO TO AMM-30.
           MOVE KAZ-COD TO KPC-AZI TAC-AZI.
           MOVE FAT-CPART(IND2) TO KPC-COD TAC-CONTO.
           READ ANACON INVALID GO TO AMM-30.
           READ TACOAM KEY KEYTC2 INVALID GO TO AMM-30.
           ADD 1 TO K.
           MOVE FAT-CPART(IND2) TO L135-WCPART(K).
           MOVE FAT-IMPCP(IND2) TO L135-WIMPCP(K).
           MOVE CON-DSC         TO L135-DCON(K).
           GO TO AMM-30.
       AMM-90.
           CLOSE TACOAM.
           IF K = ZERO GO TO AMM-10.
           ADD 1 TO K135-PROG.
           WRITE RF-135 INVALID PERFORM INVK-135
                                CLOSE WDS135
                                GO TO ERRIO.
      **** rel 6.2
      * serve ad interfaccia per abilitare aggancio ai cespiti
           MOVE 'AMM-SI' TO IF-CAMPO.
      ************
           GO TO AMM-10.
       AMM-99.
           CLOSE WDS135.
       EX-AMM-00.
           EXIT.
      *------------------
      **** rel 5.0
      *> aggiorna numero di registrazione contabile
      *  sul rispettivo record dello scadenzario.
       S00-AGGIO-SCA.
           MOVE ZERO TO FLGSCA.
           MOVE EFF-CDCLI TO COD.
           MOVE CODCLR    TO KS2-CODCF.
           MOVE EFF-DTSCA TO KS2-DTSCA.
           START ANASCA KEY NOT < KEYS2 INVALID GO TO S20.
       S10.
           READ ANASCA NEXT AT END GO TO S20.
           IF SF-SCA = '9D' OR '9A' OR '35' GO TO S10.
           IF KS2-CODCF  NOT = CODCLI     GO TO S20.
           IF KS2-DTSCA  NOT = EFF-DTSCA  GO TO S20.
           IF KSC-AZI    NOT = KEF-AZI    GO TO S10.
           IF KSC-TIPO   NOT = 1          GO TO S10.
      **** rel 5.2
      *    IF SCA-NDOC   NOT = EFF-NUFAT  GO TO S10.
      *    IF SCA-DTDOC  NOT = EFF-DTFAT  GO TO S10.
      *    IF SCA-IMRATA NOT = EFF-IMPOR  GO TO S10.
           IF SCA-NDOC   NOT = NUFAT(K1)  GO TO S10.
           IF SCA-DTDOC  NOT = DTFAT(K1)  GO TO S10.
           IF SCA-IMRATA NOT = IMPEF(K1)  GO TO S10.
      ************
           IF SCA-NREG > ZERO MOVE 1 TO FLGSCA
                              GO TO S10.

           MOVE EFF-NREG TO SCA-NREG.
           REWRITE RF-SCA INVALID
                 PERFORM INVK-SCA
                 GO TO ERRIO.
           MOVE 1 TO FLGSCA.
       S20.
           IF FLGSCA = 1 GO TO S99.
           MOVE KEF-NUM TO NEFFZ.
           MOVE EFF-DTSCA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO DTEFF.
           MOVE SPACE      TO F-MES1.
           STRING 'Effetto n. ' NEFFZ ' del ' DTEFF
                   DELIMITED HIGH-VALUE INTO F-MES1.
           MOVE 'Scadenza non trovata: num. registrazione' TO F-MES2.
           MOVE 'contabile non aggiornato su scadenzario.' TO F-MES3.
           MOVE 3 TO F-NMES.
           CALL 'vrmbox' USING PARMB.
       S99.
           EXIT.
      *------------------
      ************
       CREA-IDLAV.
           MOVE SPACE TO ID-135.
           STRING 'wz' PID DELIMITED SPACE INTO ID-135.
      **** rel 5.2
           MOVE SPACE TO ID-LA3.
           STRING 'wh' PID DELIMITED SPACE INTO ID-LA3.
      ************
       EX-CREA-IDLAV.
           EXIT.
      *------------------
      **** rel 5.2
       EFFETTI-RAGGRUPPATI.
           PERFORM AZZ-EFF-RAGGRU THRU EX-AZZ-EFF-RAGGRU.
           MOVE EFF-NUFAT TO NUFAT(1).
           MOVE EFF-DTFAT TO DTFAT(1).
           MOVE EFF-IMEF1 TO IMPEF(1).
           MOVE EFF-NUFT2 TO NUFAT(2).
           MOVE EFF-DTFT2 TO DTFAT(2).
           MOVE EFF-IMEF2 TO IMPEF(2).
           IF EFF-NUFT3 NOT = ZERO
              MOVE EFF-NUFT3 TO NUFAT(3)
              MOVE EFF-DTFT3 TO DTFAT(3)
              MOVE EFF-IMEF3 TO IMPEF(3).
           IF EFF-NUFT4 NOT = ZERO
              MOVE EFF-NUFT4 TO NUFAT(4)
              MOVE EFF-DTFT4 TO DTFAT(4)
              MOVE EFF-IMEF4 TO IMPEF(4).
           IF EFF-NUFT5 NOT = ZERO
              MOVE EFF-NUFT5 TO NUFAT(5)
              MOVE EFF-DTFT5 TO DTFAT(5)
              MOVE EFF-IMEF5 TO IMPEF(5).

           MOVE ZERO TO K1.
       LP-EFF-RGR.
           ADD 1 TO K1.
           IF K1 > 5 GO TO EX-EFFETTI-RAGGRUPPATI.
           IF NUFAT(K1) = ZERO GO TO LP-EFF-RGR.
           PERFORM S00-AGGIO-SCA THRU S99.
           GO TO LP-EFF-RGR.
       EX-EFFETTI-RAGGRUPPATI.
           EXIT.
      *------------------
       AZZ-EFF-RAGGRU.
           MOVE ZERO TO K1.
       LP-AZZ.
           ADD 1 TO K1.
           IF K1 > 5 GO TO EX-AZZ-EFF-RAGGRU.
           MOVE ZERO TO NUFAT(K1)
                        DTFAT(K1)
                        IMPEF(K1)
                        FLGS(K1).
           GO TO LP-AZZ.
       EX-AZZ-EFF-RAGGRU.
           EXIT.
      *------------------
      *> per ogni N.Accr. verifica se la contropartita e' del
      *> tipo fatture da emettere (tabellate in T14L) e salva
      *> la chiave del documento trovato.
      *> Chiamata con flave = 2 deve solo controllare la c/p
      *> xche' e' gia' nel loop che scrive il file di sort.
       VER-CP.
           IF FLAVE = 1 GO TO EX-VER-CP.
      *
           MOVE ZERO TO CONT.
       LP-CP.
           ADD 1 TO CONT.
           IF CONT > 3 GO TO EX-VER-CP.
           IF CP-FTEM(CONT) = ZERO AND
              CP-NAEM(CONT) = ZERO GO TO LP-CP.
      *    IF FAT-CPART(IND2) NOT = CP-FTEM(CONT) GO TO LP-CP.
           IF (FAT-CPART(IND2) = CP-FTEM(CONT) OR CP-NAEM(CONT))
               GO TO LP-CP-02
           ELSE
               GO TO LP-CP.

       LP-CP-02.

           IF FLAVE = 2 GO TO LP-CP-05.

           ADD 1 TO CONT1.
           IF CONT1 > 200 GO TO EX-VER-CP.
           MOVE KFT-AZI  TO CP-AZI (CONT1).
           MOVE KFT-TDOC TO CP-TDOC (CONT1).
           MOVE KFT-NUM  TO CP-NUM (CONT1).
      *
       LP-CP-05.
           MOVE 1 TO FLAVE.
       EX-VER-CP.
           EXIT.
      *------------------
       VER-FATT-DA-EM.
           OPEN OUTPUT WDSLA3.
           CLOSE WDSLA3.
           OPEN I-O WDSLA3.
           OPEN INPUT ANACLF.

           MOVE SPACE TO IF-CAMPO2.
           MOVE ZERO  TO K.
           MOVE ZERO  TO J2.
       AVE-10.
           ADD 1 TO J2.
           IF J2 > 200 GO TO AVE-99.
           IF CP-AZI(J2) = ZERO GO TO AVE-99.
           MOVE CP-PAR(J2) TO KEYFT.
           READ FATTUR INVALID GO TO AVE-10.

           MOVE KFT-AZI   TO KCF-AZI.
           MOVE FAT-CDCLI TO COD.
           MOVE CODCLI    TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID MOVE SPACE TO CLF-RGSOC.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.

           MOVE ZERO TO IND2.
       AVE-30.
           ADD 1 TO IND2.
           IF IND2 > 15 GO TO AVE-90.
           IF FAT-IMPCP(IND2) = ZERO GO TO AVE-30.
           IF FAT-CPART(IND2) = ZERO GO TO AVE-30.

      *> controllo contropartita con quelle tabellate in T14L
           MOVE 2 TO FLAVE.
           PERFORM VER-CP THRU EX-VER-CP.
           IF FLAVE NOT = 1 GO TO AVE-30.

           ADD 1 TO K.
       CARICA-REC-LA3.
           MOVE ZERO  TO RF-LA3.
           MOVE SPACE TO LA3-DESAG.
      *> key
           MOVE K         TO KL3-PROGR.
           MOVE FAT-DATA  TO KL3-DTREG.

           MOVE CAU-FTEM  TO LA3-CAUS.
           MOVE CLF-RGSOC TO LA3-DESAG.
           MOVE KFT-NUM   TO LA3-DOCUM.
           MOVE FAT-DATA  TO LA3-DTDOC.
           MOVE FAT-CPART(IND2) TO LA3-CPART.
           MOVE FAT-IMPCP(IND2) TO LA3-IMPOR.
           WRITE RF-LA3 INVALID
                 MOVE 'Errore scrittura wdsla3' TO MESS
                 CLOSE WDSLA3
                 GO TO ERRIO.

      * serve ad interfaccia per aprire inserimento prima nota V.ES.
           MOVE 'AVE-SI' TO IF-CAMPO2.
      *
           GO TO AVE-30.
       AVE-90.
           GO TO AVE-10.
       AVE-99.
           CLOSE WDSLA3.
           CLOSE ANACLF.
       EX-VER-FATT-DA-EM.
           EXIT.
      *------------------
      ************
      **** rel 6.1
       CALC-RITE.
           MOVE ZERO TO IMPRIT.
           MOVE ZERO TO RITE.
      *
           MOVE 4 TO KTB-TIP.
           MOVE FAT-CDPAG TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF NOT (T04-TIPAG = 1 OR 2) GO TO EX-CALC-RITE.
      *
           MOVE ZERO TO K.
       LSCA.
           ADD 1 TO K.
           IF K > 6 GO TO GSCA.
           IF FAT-CDIVA (K) = ZERO GO TO GSCA.
           MOVE FAT-CDIVA (K) TO KTB-COD.
           MOVE 3 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      **** rel 6.3
      *    IF T03-TPIVA NOT = ZERO GO TO LSCA.
           IF T03-TPIVA = 5 GO TO LSCA.
      ************
           IF FAT-VALUT = ZERO OR COMEURO
              ADD  FAT-IMPON(K) TO IMPRIT
           ELSE
              ADD  FAT-EIMPON(K) TO IMPRIT.
      *
           GO TO LSCA.
       GSCA.
      *
           OPEN INPUT BOLCTE.
           CALL 'rdbfa' USING FAT-CATT KEYFT PARRB.
      *
           MOVE ZERO TO K.
       RD-RITE.
           ADD 1 TO K.
           IF K > RB-ULTBOL GO TO FINE-RITE.
           IF RB-TNUM(K) = ZERO AND RB-NBOL(K) = ZERO GO TO FINE-RITE.
           MOVE KFT-AZI    TO KBC-AZI.
           MOVE RB-TNUM(K) TO KBC-NUM.
           MOVE RB-NBOL(K) TO KBC-BOL.
           READ BOLCTE INVALID GO TO RD-RITE.
      *
           IF NOT ((BCT-PBASE = ZERO) AND (BCT-PRACC = ZERO))
              COMPUTE IMPO = (IMPRIT / 100) * BCT-PBASE
              MOVE IMPO      TO ER-IMPORTO
              MOVE ZERO      TO ER-VALUT
              MOVE BCT-PRACC TO COM-ALIVA
              CALL 're2iva' USING ER-IMPORTO ER-VALUT COM-ALIVA
              MOVE ER-IMPORTO TO RITE.
      *
       FINE-RITE.
           CLOSE BOLCTE.
       EX-CALC-RITE.
           EXIT.
      *------------------
       CREA-SCADENZE-RITE.
           COMPUTE RD-NUM = RITE / WNRATE.
           CALL 'vrround' USING NNN-E PARRD DEC-2.
           MOVE RD-NUM TO COMR.
           COMPUTE COM1 = WNRATE - 1.
           COMPUTE COMUR = RITE - (COMR * COM1).
       EX-CREA-SCADENZE-RITE.
           EXIT.
      *------------------
      ************
      **** rel 6.2
      *------------------
       CALCOLA-RATE.
           MOVE 1 TO J2.
           PERFORM UNTIL J2 > 12
              IF FAT-DTSCA(J2) = ZERO
                 MOVE 12 TO J2
              ELSE
                 ADD 1 TO WNRATE
              END-IF
              ADD 1 TO J2
           END-PERFORM.
       EX-CALCOLA-RATE.
           EXIT.
      *------------------
      ************
      **** rel 7.1
       LEGGI-CCOST.
           MOVE ZERO TO K.
       LEGGI-CCOST-10.
           ADD 1 TO K.
           IF K > 54 GO TO LEGGI-CCOST-90.
           IF WCON(K) = ZERO GO TO LEGGI-CCOST-10.
           IF WCON(K) = 9999999 GO TO LEGGI-CCOST-10.
      *
           MOVE KAZ-COD TO KPC-AZI.
           MOVE WCON(K) TO KPC-COD.
           READ ANACON INTO REKCON INVALID GO TO LEGGI-CCOST-10.
           IF SF-CON = '9D' OR '9A' OR '35' MOVE RF-CON TO REKCON.
      *
           MOVE KAZ-COD TO KACO-AZI.
           MOVE WCON(K) TO KACO-COD.
           READ APPCON INVALID MOVE SPACE TO ACO-CDC.
      *
           IF CON-TRIP = ZERO
              MOVE ACO-CDC TO WCCOST(K)
           ELSE
             MOVE CON-TTIP TO WCCOST(K).
      *
           GO TO LEGGI-CCOST-10.
       LEGGI-CCOST-90.
      *
       EX-LEGGI-CCOST.
           EXIT.
      *------------------
      **** rel 7.2
       GIRO-SPLITP.
      *
            MOVE ZERO      TO WCOD(IND).
            MOVE TOTIMP    TO WIMP(IND).
            MOVE ZERO      TO WIVA(IND).
            MOVE T01CIVSO  TO WCON(IND).
            MOVE 'D'       TO WD-A(IND).
            IF KFT-TDOC = 6
               MOVE 'A'       TO WD-A(IND).
            MOVE 'X'       TO WFIL(IND).
            ADD 1 TO IND.
      *
            MOVE ZERO      TO WCOD(IND).
            MOVE TOTIMP    TO WIMP(IND).
            MOVE ZERO      TO WIVA(IND).
            MOVE CODCLI    TO WCON(IND). 
            MOVE 'A'       TO WD-A(IND).
            IF KFT-TDOC = 6
               MOVE 'D'       TO WD-A(IND).
            MOVE 'Y'       TO WFIL(IND).
            ADD 1 TO IND.
      *
       EX-GIRO-SPLITP.
           EXIT.
      *------------------
      ************
