       IDENTIFICATION DIVISION.
       PROGRAM-ID. VORDWRD.
      *
      * Stampa ordini clienti con MS-Word
      *
      * Versione per pubblicazione documenti
      *
      **** rel 5.1
      * nuovo: sostituisce VORD200W.CBL
      ************
      **** rel 6.1
      * spostata scrittura file D- nella routine VRWORD
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griclfsl'.
           COPY 'gribansl'.
      **** rel 6.2
           COPY 'griabasl'.
      ************
           COPY 'griordsl'.
           COPY 'gririgsl'.
           COPY 'grilinsl'.
           COPY 'gritabsl'.
           COPY 'grinrisl'.
      **** rel 6.3
           COPY 'griirisl'.
      ************
      **** rel 7.1
           COPY 'griaorsl'.
      ************
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'griclf'.
           COPY 'griban'.
      **** rel 6.2
           COPY 'griaba'.
      ************
           COPY 'griord'.
           COPY 'gririg'.
           COPY 'grilin'.
           COPY 'gritab'.
           COPY 'grinri'.
      *
      **** rel 6.3
           COPY 'griiri'.
      ************
      **** rel 7.1
           COPY 'griaor'.
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-71'.
           COPY 'gritabrk'.
           COPY 'griclfrk'.
           COPY 'griordrk'.
           COPY 'gririgrk'.
           COPY 'griazirk'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parim'.
           COPY 'parer'.
           COPY 'parwo'.
           COPY 'parop'.
           COPY 'parrd'.
           COPY 'parpcfa'.
      **** rel 6.2
           COPY 'pariban'.
      ************
      **** rel 7.1
           COPY 'pardp'.
      ************
       01  ID-ARL PIC X(15) VALUE 'artlin'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-ART PIC X(15) VALUE 'magart'.
       01  ID-BAN PIC X(15) VALUE 'anaban'.
      **** rel 6.2
       01  ID-ABA PIC X(15) VALUE 'appban'.
      ************
       01  ID-ORD PIC X(15) VALUE 'ordcli'.
       01  ID-RIG PIC X(15) VALUE 'ordrig'.
       01  ID-NRI PIC X(15) VALUE 'notrig'.
      **** rel 6.3
       01  ID-IRI PIC X(15) VALUE 'indiri'.
      ************
      **** rel 7.1
       01  ID-AOR PIC X(15) VALUE 'appord'.
      ************
      *
       01  COMODI.
           05 SF-ARL PIC XX.
           05 SF-AZI PIC XX.
           05 SF-TAB PIC XX.
           05 SF-CLF PIC XX.
           05 SF-ART PIC XX.
           05 SF-BAN PIC XX.
      **** rel 6.2
           05 SF-ABA  PIC XX.
      ************
           05 SF-ORD PIC XX.
           05 SF-RIG PIC XX.
           05 SF-NRI PIC XX.
      **** rel 6.3
           05 SF-IRI PIC XX.
      ************
      **** rel 7.1
           05 SF-AOR PIC XX.
      ************

           05 MESS       PIC X(40) VALUE SPACE.
           05 FSC        PIC 9.
           05 CODCLI.
              10 MAS PIC 99.
              10 COD PIC 9(5).
           05 SCONTO    PIC S9(11)V99.
           05 WTOT      PIC S9(11)V99.
           05 COMA      PIC S9(11)V99 VALUE ZERO.
           05 COMMER    PIC S9(11)V99 VALUE ZERO.
           05 NPAG      PIC 99.
           05 FLGTES    PIC 9     VALUE ZERO.
      **** rel 6.2
           05 KN         PIC 9(4)  VALUE ZERO.
           05 GGS       PIC 99    VALUE ZERO.
           05 I         PIC 99    VALUE ZERO.
      ************
      **** rel 7.1
           05 COMEURO  PIC 9(3).
           05 WTOTIVA   PIC S9(11)V99.
           05 WTOTTOT   PIC S9(11)V99.
           05 COMPZLOR  PIC S9(11)V999999 VALUE ZERO.
           05 COMPZNET  PIC S9(11)V999999 VALUE ZERO.
      ************

       01  PAR-P-MDT.
           05 P-MDT-AZI   PIC 999.
           05 P-MDT-TDOC  PIC 9.
           05 P-MDT-KEY   PIC X(15).
           05 P-MDT-FLGS  PIC 9.
           05 P-MDT-DATA  PIC 9(5).
           05 P-MDT-NCOL  PIC 99.
           05 P-MDT-TESTO PIC X(76).
           05 P-MDT-FLGE  PIC 9.

           COPY 'vordwrd.cpy'.
       LINKAGE SECTION.
           COPY 'parword'.
       PROCEDURE DIVISION USING PARWORD PARCCD.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclclf'.
           COPY 'dclban'.
      **** rel 6.2
           COPY 'dclaba'.
      ************
           COPY 'dclord'.
           COPY 'dclrig'.
           COPY 'dcllin'.
           COPY 'dcltab'.
           COPY 'dclnri'.
      **** rel 6.3
           COPY 'dcliri'.
      ************
      **** rel 7.1
           COPY 'dclaor'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
      *
           MOVE ZERO TO PCCD-ERR.

      * Inizializza
           IF PCCD-FUN = 'T' OR 'I'
              PERFORM PGM-INI THRU EX-PGM-INI.

      * Esegue
           IF PCCD-FUN = 'T' OR 'R'
              PERFORM PGM-RUN THRU EX-PGM-RUN.

      * Chiude
           IF PCCD-FUN = 'T' OR 'E'
              PERFORM PGM-END THRU EX-PGM-END
              GO TO CHIUDI.

           GO TO FINE.
       ERRIO.
           COPY 'errsub'.
           MOVE 9 TO PCCD-ERR.
           PERFORM WRD-CL.
       CHIUDI.
           CLOSE ANAAZI TABELL ANACLF NOTRIG
                 ANABAN ORDCLI ORDRIG ARTLIN.
      **** rel 6.2
           CLOSE APPBAN.
      ************
      **** rel 6.3
           CLOSE INDIRI.
      ************
      **** rel 7.1
           CLOSE APPORD.
      ************
       FINE.
           EXIT PROGRAM.
      *-------------------*
           COPY 'griwrd'.
      *-------------------*
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'griclfer'.
           COPY 'gribaner'.
      **** rel 6.2
           COPY 'griabaer'.
      ************
           COPY 'griorder'.
           COPY 'gririger'.
           COPY 'griliner'.
           COPY 'gritaber'.
           COPY 'grinrier'.
      **** rel 6.3
           COPY 'griirier'.
      ************
      **** rel 7.1
           COPY 'griaorer'.
      ************
           COPY 'grixxxer'.
      *------------------------------------------*
       PGM-END.
           PERFORM WRD-END.
       EX-PGM-END.
           EXIT.
      *------------------------------------------*
       PGM-INI.
      *
           OPEN INPUT ANAAZI TABELL ANACLF NOTRIG
                      ANABAN ORDCLI ORDRIG ARTLIN.
      **** rel 6.2
           OPEN INPUT APPBAN.
      ************
      **** rel 6.3
           OPEN INPUT INDIRI.
      ************
      **** rel 7.1
           OPEN INPUT APPORD.
      ************
      *
           MOVE PWORD-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
      *
           MOVE 1 TO KTB-TIP.
           MOVE 1 TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MCLI TO MAS.
      *
      **** rel 7.1
           CALL 'rveur' USING COMEURO.
      ************
           MOVE 'ordcli'  TO WO-IDDOC.
           MOVE PWORD-AZI TO WO-AZI.
           PERFORM WRD-INI.
      *
       EX-PGM-INI.
           EXIT.
      *------------------------------------------*
       PGM-RUN.
      *
           MOVE ZERO TO KEYOR.
           MOVE PWORD-AZI  TO KOR-AZI.
           MOVE PWORD-NORD TO KOR-NUM.
           READ ORDCLI INTO REKORD INVALID GO TO NOORD.
           IF SF-ORD = '9D' OR '9A' OR '35' MOVE RF-ORD TO REKORD.
      *
           IF SAVPATH = SPACE AND PCCD-PATH NOT = SPACE
              MOVE ORD-DAT TO AAGGG
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              STRING PCCD-PATH DELIMITED SPACE
                     '\ord'
                     KOR-AZI
                     AA9
                     KOR-NUM
                     '.doc'
                     DELIMITED SIZE INTO SAVPATH
              MOVE SAVPATH TO PCCD-PATH.
      *
           MOVE ZERO TO NPAG WTOT.
      **** rel 7.1
           MOVE ZERO TO WTOTIVA WTOTTOT.
      ************
      *
           MOVE ZERO TO COMA COMMER.
      *
           PERFORM A00-STAMPA-TESTATA THRU A99.
      *
           MOVE 10        TO KTB-TIP.
           MOVE ORD-VALUT TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE ZERO TO T10-FSC.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T10-FSC TO FSC.
      *
           IF ORD-PERSC NOT = ZERO 
              MOVE 'SCONTO BASE' TO RDSCB(INDR)
              MULTIPLY ORD-PERSC BY -1 GIVING RPERSC(INDR)
              MOVE '%' TO RTPERC1(INDR)
              ADD 1 TO INDR.  

           MOVE LOW-VALUE TO KEYRI.
           MOVE KOR-AZI   TO KRI-AZI.
           MOVE KOR-NUM   TO KRI-NUM.
           START ORDRIG KEY NOT < KEYRI INVALID GO TO ENDORD.
       RIGO.
           READ ORDRIG NEXT INTO REKRIG AT END GO TO ENDORD.
           IF SF-RIG = '9D' OR '9A' OR '35' GO TO RIGO.
           IF KRI-AZI NOT = KOR-AZI GO TO ENDORD.
           IF KRI-NUM     > KOR-NUM GO TO ENDORD.
           IF RIG-TPRIG = 3 AND RIG-FSC = ZERO GO TO RIGO.
      *
           IF INDR > MAXR 
              PERFORM SCR-REC THRU EX-SCR-REC   
              PERFORM A00-STAMPA-TESTATA THRU A99.
      *
           IF RIG-TPRIG NOT = 3 GO TO RIG05.

           MOVE 11 TO KTB-TIP.
           MOVE RIG-CDSPE TO KTB-COD.
           READ TABELL INTO REKTAB INVALID GO TO RIGO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.

      *> importo diretto
           IF T11-TIMP = ZERO
              MOVE RIG-PREZZ TO COMA
              IF T11-TACC = 2 AND COMA > ZERO MULTIPLY -1 BY COMA
              END-IF
              MOVE COMA TO IM-NETRG.

      *> importo %
           IF T11-TIMP NOT = ZERO 
              COMPUTE RD-NUM = ( COMMER * RIG-PROVV ) / 100
              CALL 'vrround' USING NNN-M PARRD DEC-2
              MOVE RD-NUM TO COMA
              IF T11-TACC = 2 AND COMA > ZERO MULTIPLY -1 BY COMA
              END-IF
              MOVE COMA TO IM-NETRG.

           MOVE RIG-DESAR TO D-ART-D(INDR).
           MOVE IM-NETRG  TO RPREZZ1(INDR).
           ADD IM-NETRG TO WTOT.
      **** rel 7.1
           IF ORD-CDESE NOT = ZERO
              MOVE ORD-CDESE TO RIG-CDIVA.
           MOVE 3         TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID MOVE ZERO TO T03-ALIVA.
           CALL 're2iva' USING IM-NETRG ORD-VALUT T03-ALIVA.
           ADD IM-NETRG TO WTOTIVA.
      ************
           ADD 1 TO INDR.
           GO TO RIGO.
       RIG05.
           MOVE RIG-DESAR TO D-ART-D(INDR).
           IF RIG-TPRIG = 2    GO TO RIG10.
           IF AZI-FLING = ZERO GO TO RIG10.
           IF CLF-FLING = ZERO GO TO RIG10.
           MOVE KAZ-COD   TO KAL-AZI.
           MOVE RIG-ARTIC TO KAL-ART.
           READ ARTLIN INVALID GO TO RIG10.
           IF CLF-FLING = 1
              IF ARL-DES1 = SPACE
                 GO TO RIG10
              ELSE
                 MOVE ARL-DES1 TO D-ART-D(INDR).
           IF CLF-FLING = 2
              IF ARL-DES2 = SPACE
                 GO TO RIG10
              ELSE
                 MOVE ARL-DES2 TO D-ART-D(INDR).
           IF CLF-FLING = 3
              IF ARL-DES3 = SPACE
                 GO TO RIG10
              ELSE
                 MOVE ARL-DES3 TO D-ART-D(INDR).
       RIG10.
           IF RIG-TPRIG = 1 GO TO RIG100.
           IF RIG-TPRIG NOT = 2 MOVE RIG-ARTIC TO D-ART(INDR).
           MOVE RIG-UNMIS TO D-UM(INDR).
           IF RIG-TQUAN = ZERO 
              MOVE RIG-QUANT TO RQUANT(INDR)
           ELSE
              IF RIG-TQUAN = 1
                 MOVE RIG-QUANT TO RQUANT1(INDR)
              ELSE
                 MOVE RIG-QUANT TO RQUANT2(INDR).

           IF RIG-DTCSC NOT = ZERO
              MOVE RIG-DTCSC TO AAGGG 
      **** rel 6.2
              PERFORM SOMMA-GG THRU EX-SOMMA-GG
      ************
              MOVE 2 TO TIPOP1 
              CALL 'rdata' USING PARCDT 
              MOVE GBMMBA TO D-DTCSC(INDR).

           IF RIG-DTCSR NOT = ZERO
              MOVE RIG-DTCSR TO AAGGG 
              MOVE 2 TO TIPOP1 
              CALL 'rdata' USING PARCDT 
              MOVE GBMMBA TO D-DTCSR(INDR).

           IF RIG-TPRIG = 4 
              MOVE 'CES.GRATUITA' TO RGOMG(INDR)
              GO TO RIG100.
           IF RIG-TPRIG = 5
              MOVE 'SCONTO MERCE' TO RGOMG(INDR)
              GO TO RIG100.
           IF RIG-TPRIG = 6 
              MOVE 'CESS.IN GAR.' TO RGOMG(INDR)
              GO TO RIG100.
           MOVE RIG-AZI     TO OP-AZI
           MOVE ORD-VALUT   TO OP-VALUT.
           MOVE RIG-PREZZ   TO OP-PREZZO.
           MOVE RIG-FSC     TO OP-FSC.
           CALL 'routprz' USING PAROP OP-VEN.
           MOVE OP-PREZZO   TO RPREZZ(INDR).
           IF OP-NDEC = 2 MOVE OP-PREZZO TO RPREZZ1(INDR).
           IF OP-NDEC = 3 MOVE OP-PREZZO TO RPREZZ3(INDR).
           IF OP-NDEC = 4 MOVE OP-PREZZO TO RPREZZ4(INDR).
           IF OP-NDEC = 5 MOVE OP-PREZZO TO RPREZZ5(INDR).
           IF OP-NDEC = 6 MOVE OP-PREZZO TO RPREZZ6(INDR).
      **** rel 7.1
           IF ORD-CDESE NOT = ZERO
              MOVE ORD-CDESE TO RIG-CDIVA.
           MOVE RIG-CDIVA TO D-IVA(INDR).
      *
           COMPUTE COMPZLOR = RIG-PREZZ * RIG-QUANT.
           MOVE RIG-AZI     TO OP-AZI
           MOVE ORD-VALUT   TO OP-VALUT.
           MOVE COMPZLOR   TO OP-PREZZO.
           MOVE RIG-FSC     TO OP-FSC.
           CALL 'routprz' USING PAROP OP-VEN.
           MOVE OP-PREZZO   TO RPZLOR(INDR).
           IF OP-NDEC = 2 MOVE OP-PREZZO TO RPZLOR1(INDR).
           IF OP-NDEC = 3 MOVE OP-PREZZO TO RPZLOR3(INDR).
           IF OP-NDEC = 4 MOVE OP-PREZZO TO RPZLOR4(INDR).
           IF OP-NDEC = 5 MOVE OP-PREZZO TO RPZLOR5(INDR).
           IF OP-NDEC = 6 MOVE OP-PREZZO TO RPZLOR6(INDR).
      *
           PERFORM C00-CAL-SCAPP.
           MOVE RIG-AZI     TO OP-AZI
           MOVE ORD-VALUT   TO OP-VALUT.
           MOVE IM-NETRG   TO OP-PREZZO.
           MOVE RIG-FSC     TO OP-FSC.
           CALL 'routprz' USING PAROP OP-VEN.
           MOVE OP-PREZZO   TO RPZNET(INDR).
           IF OP-NDEC = 2 MOVE OP-PREZZO TO RPZNET1(INDR).
           IF OP-NDEC = 3 MOVE OP-PREZZO TO RPZNET3(INDR).
           IF OP-NDEC = 4 MOVE OP-PREZZO TO RPZNET4(INDR).
           IF OP-NDEC = 5 MOVE OP-PREZZO TO RPZNET5(INDR).
           IF OP-NDEC = 6 MOVE OP-PREZZO TO RPZNET6(INDR).
      ************
           IF RIG-1SCON NOT = ZERO 
              MULTIPLY -1 BY RIG-1SCON GIVING SCONTO
              IF AZI-FLSCC = ZERO
                 MOVE SCONTO TO R1SCON0(INDR)
              ELSE
                 MOVE SCONTO TO R1SCON(INDR)
              END-IF
              MOVE '%' TO RTPERC1(INDR).
           IF RIG-2SCON NOT = ZERO 
              MULTIPLY -1 BY RIG-2SCON GIVING SCONTO
              IF AZI-FLSCC = ZERO
                 MOVE SCONTO TO R2SCON0(INDR)
              ELSE
                 MOVE SCONTO TO R2SCON(INDR)
              END-IF
              MOVE '%' TO RTPERC2(INDR).

           MOVE "V"       TO IM-TIPO.
           MOVE RIG-PREZZ TO IM-PZLOR.
           MOVE RIG-QUANT TO IM-QTA.
           MOVE ORD-PERSC TO IM-SCBAS.
           MOVE RIG-1SCON TO IM-SC1.
           MOVE RIG-2SCON TO IM-SC2.
           MOVE ORD-VALUT TO IM-VALUT.
           MOVE RIG-TPRIG TO IM-TCOR.
           MOVE RIG-TQUAN TO IM-TQUAN.
           MOVE RIG-FSC   TO IM-FSC.
           MOVE RIG-FPNET TO IM-FPNET.
           CALL 'vrimpor' USING PARIM.
           ADD IM-NETRG TO WTOT.
           ADD IM-NETRG TO COMMER.
      **** rel 7.1
           IF ORD-CDESE NOT = ZERO
              MOVE ORD-CDESE TO RIG-CDIVA.
           MOVE RIG-CDIVA TO KTB-COD.
           MOVE 3         TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID MOVE ZERO TO T03-ALIVA.
           CALL 're2iva' USING IM-NETRG ORD-VALUT T03-ALIVA.
           ADD IM-NETRG TO WTOTIVA.
      ************
       RIG100.
      **** rel 6.2
      *    ADD 1 TO INDR.
           IF RIG-TPRIG NOT = 1 ADD 1 TO INDR.
      ************
      * stampa note aggiuntive
           MOVE KRI-AZI TO KNRI-AZI.
           MOVE KRI-NUM TO KNRI-NUM.
           MOVE KRI-PRG TO KNRI-PRG.
           MOVE ZERO    TO KNRI-PRGN.
           START NOTRIG KEY > KEYNRI INVALID GO TO RIG300.
       RDN-NRI.
           READ NOTRIG NEXT AT END GO TO RIG300.
           IF KNRI-AZI > KRI-AZI GO TO RIG300.
           IF KNRI-NUM > KRI-NUM GO TO RIG300.
           IF KNRI-PRG > KRI-PRG GO TO RIG300.
      *
           IF INDR > MAXR 
              PERFORM SCR-REC THRU EX-SCR-REC   
              PERFORM A00-STAMPA-TESTATA THRU A99.
      *
           MOVE NRI-DESCR TO D-ART-D(INDR).
           ADD 1 TO INDR.
           GO TO RDN-NRI.
       RIG300.
           IF RIG-ARTIC NOT = SPACE
              MOVE ZERO     TO PCFA-FUN
              MOVE KRI-AZI  TO PCFA-AZI
              MOVE 'C'      TO PCFA-TIP
              MOVE ORD-CDCLI TO PCFA-CLF
              MOVE RIG-ARTIC TO PCFA-ART
              MOVE CLF-FLING TO PCFA-LIN
              CALL 'vrrcfa' USING PARPCFA
              IF PCFA-ST = ZERO
                 IF PCFA-DEST NOT = SPACE
                    IF INDR > MAXR 
                       PERFORM SCR-REC THRU EX-SCR-REC   
                       PERFORM A00-STAMPA-TESTATA THRU A99
                    END-IF
                    MOVE PCFA-DEST TO D-ART-D(INDR)
                    ADD 1 TO INDR
                 END-IF
                 IF PCFA-DDIS NOT = SPACE
                    IF INDR > MAXR 
                       PERFORM SCR-REC THRU EX-SCR-REC   
                       PERFORM A00-STAMPA-TESTATA THRU A99
                    END-IF
                    MOVE PCFA-DDIS TO D-ART-D(INDR)
                    ADD 1 TO INDR.
           GO TO RIGO.
       ENDORD.
           PERFORM H00-STAMPA-MESSAGG THRU H99.
           IF FLGTES = ZERO SUBTRACT 1 FROM INDR.

           PERFORM B00-STAMPA-PIEDE THRU B99.
       NOORD.

       EX-PGM-RUN.
           EXIT.
      *------------------------------------------*
       A00-STAMPA-TESTATA.
           PERFORM WRD-AZZ.
      *
           ADD 1 TO NPAG.
           MOVE KAZ-COD TO KCF-AZI.
           MOVE ORD-CDCLI TO COD.
           MOVE CODCLI TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID PERFORM INVK-CLF
                                           PERFORM VISK-ORD
                                           GO TO ERRIO.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
           MOVE CLF-RGSOC  TO D-RGSOC1.
           MOVE CLF-RGSOC2 TO D-RGSOC2.
           MOVE CLF-INDIR  TO D-INDIR1.
           MOVE CLF-INDIR2 TO D-INDIR2.
           MOVE CLF-CAP    TO D-CAP.
           MOVE CLF-CITTA  TO D-CITTA.
      **** rel 6.3
           IF ORD-LCONS = ZERO
              MOVE CLF-RGSOC  TO D-LRGSOC1
              MOVE CLF-RGSOC2 TO D-LRGSOC2
              MOVE CLF-INDIR  TO D-LINDIR1
              MOVE CLF-INDIR2 TO D-LINDIR2
              MOVE CLF-CAP    TO D-LCAP
              MOVE CLF-CITTA  TO D-LCITTA
              MOVE SPACE TO D-LDESDI
              GO TO NO-LCONS.
      *
           MOVE KOR-AZI    TO KII-AZI.
           MOVE MAS        TO KII-MS.
           MOVE ORD-CDCLI  TO KII-CD.
           MOVE ORD-LCONS  TO KII-PRG.
           READ INDIRI INVALID
              MOVE CLF-RGSOC TO D-LRGSOC1
              MOVE CLF-RGSOC2 TO D-LRGSOC2
              MOVE CLF-INDIR TO D-LINDIR1
              MOVE CLF-INDIR2 TO D-LINDIR2
              MOVE CLF-CAP  TO D-LCAP
              MOVE CLF-CITTA TO D-LCITTA
              MOVE SPACE TO D-LDESDI
              GO TO NO-LCONS.
      *
           MOVE IRI-RGSOC  TO D-LRGSOC1.
           MOVE IRI-RGSOC2 TO D-LRGSOC2.
           MOVE IRI-INDIR  TO D-LINDIR1.
           MOVE IRI-INDIR2 TO D-LINDIR2.
           MOVE IRI-CAP    TO D-LCAP.
           MOVE IRI-CITTA  TO D-LCITTA.
           MOVE IRI-DESDI  TO D-LDESDI.
      *
       NO-LCONS.
      **************
      **** rel 6.2
           MOVE ORD-GGS    TO GGS.
      ************
           MOVE ORD-CDCLI  TO D-CDCLI.
           MOVE ORD-NUM    TO D-NUMORD.
           MOVE ORD-DAT TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA     TO D-DTORD.
           MOVE ORD-VSORD  TO D-VSORD.
           MOVE NPAG       TO D-NPAG.
      **** rel 7.1
           MOVE KOR-AZI TO KAOR-AZI.
           MOVE KOR-NUM TO KAOR-NUM.
           READ APPORD INVALID
                MOVE SPACE TO AOR-IPA AOR-CIG AOR-CUP. 
           MOVE AOR-IPA TO D-IPA.
           MOVE AOR-CIG TO D-CIG.
           MOVE AOR-CUP TO D-CUP.
      ************
           MOVE ORD-CDSPE TO KTB-COD.
           MOVE 6 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           PERFORM VISK-ORD
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO D-SPEDIZ.
           MOVE ORD-CDPOR TO KTB-COD.
           MOVE 5         TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           PERFORM VISK-ORD
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO D-PORTO.
           MOVE ORD-CDPAG TO D-CDPAG KTB-COD.
           MOVE 4 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           PERFORM VISK-ORD
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO D-PAGAM.
       NO-PAG. 
           IF ORD-CDBAN = ZERO MOVE SPACE TO BAN-RGSOC GO TO A90.
           MOVE ORD-CDBAN TO KBA-BAN.
           READ ANABAN INVALID PERFORM INVK-BAN
                               PERFORM VISK-ORD
                               GO TO ERRIO.
      **** rel 6.2
           IF T04-TIPAG NOT = 5
              MOVE SPACE TO D-IBAN
              MOVE 1 TO KN
              IF BAN-CODAZ NOT = '00000'
                 STRING 'ABI: ' BAN-CODAZ ' ' DELIMITED SIZE
                        INTO D-IBAN POINTER KN
              END-IF
              IF BAN-CODSP NOT = '00000'
                 STRING 'CAB: ' BAN-CODSP DELIMITED SIZE
                        INTO D-IBAN POINTER KN
              END-IF
              GO TO NO-CCOR.
      **** rel 6.3
      *    MOVE KEYBA TO KEYABA.
           MOVE KAZ-COD TO KABA-AZI.
           MOVE KBA-BAN TO KABA-BAN.
      ************
           READ APPBAN INVALID MOVE SPACE TO ABA-CIBAN.
           MOVE ZERO      TO PARIBAN.
           MOVE ABA-CIBAN TO IBAN.
           CALL 'riban' USING PARIBAN PARBBAN.
           IF NOT (IBAN-FLG = 9)
              MOVE IBAN-P TO D-IBAN.
       NO-CCOR.
      ************
       A90. 
           MOVE BAN-RGSOC TO D-BANCA.
           IF ORD-DTCSR NOT = ZERO
              MOVE ORD-DTCSR TO AAGGG
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE GBMMBA TO D-DTCSR0.
           IF ORD-DTCSC NOT = ZERO
              MOVE ORD-DTCSC TO AAGGG
      **** rel 6.2
              PERFORM SOMMA-GG THRU EX-SOMMA-GG
      ************
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE GBMMBA TO D-DTCSC0.

           MOVE 1 TO INDR.
       A99. EXIT.
      *------------------
       B00-STAMPA-PIEDE.
           MOVE ORD-COMME TO D-COMME.
      **** rel 7.1
      *    IF ORD-VALUT = ZERO
      *       MOVE 'EUR.' TO D-DIVISA
      *       GO TO B10.
      ************
           MOVE 10        TO KTB-TIP.
           MOVE ORD-VALUT TO KTB-COD.
      **** rel 7.1
           IF ORD-VALUT = ZERO MOVE COMEURO TO KTB-COD.
      ************
           READ TABELL INTO REKTAB INVALID 
                MOVE SPACE TO D-DIVISA
                GO TO B10.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T10-DSINT TO D-DIVISA.
       B10.
           MOVE WTOT TO RTTOTA1.
           IF ORD-VALUT = 1 MOVE WTOT TO RTTOTAL.
      **** rel 7.1
           MOVE WTOTIVA TO RTOTI1.
           IF ORD-VALUT = 1 MOVE WTOTIVA TO RTOTI.
           COMPUTE WTOTTOT = WTOT + WTOTIVA.
           MOVE WTOTTOT TO RTOT1.
           IF ORD-VALUT = 1 MOVE WTOTTOT TO RTOT.
      ************
      ****
           MOVE WD-TIPS TO D-TIPS.
      ****
           MOVE 1       TO D-NCOP.
           MOVE CLF-FAX TO D-FAX.
           MOVE NPAG    TO D-TOTPAG.

           PERFORM SCR-REC THRU EX-SCR-REC.
       B99.
           EXIT.
      *--------------*
      *-------------------------------
       SCR-REC.
           MOVE SPACE TO D-FLGS.
           IF PCCD-FLGS = 0
              MOVE 'S' TO D-FLGS.
           MOVE PCCD-PATH TO D-IDDOC.
      *
           PERFORM WRD-WR.
       EX-SCR-REC.
      *-------------------------------
       H00-STAMPA-MESSAGG.
           MOVE ZERO TO FLGTES.
           ADD 1 TO INDR.
           MOVE KOR-AZI TO P-MDT-AZI.
           MOVE 4       TO P-MDT-TDOC.
           MOVE KEYOR   TO P-MDT-KEY.
           MOVE ZERO    TO P-MDT-FLGS.
           MOVE ORD-DAT TO P-MDT-DATA.
           MOVE ZERO    TO P-MDT-FLGE.
       H10.
           CALL 'vrpmdt' USING PAR-P-MDT.
           IF P-MDT-FLGE NOT = 1 GO TO H99.
           ADD 1 TO INDR.
           IF INDR > MAXR
              PERFORM SCR-REC THRU EX-SCR-REC
              PERFORM A00-STAMPA-TESTATA THRU A99.
           MOVE P-MDT-TESTO(1:P-MDT-NCOL) TO D-ART-D(INDR).
           MOVE 1 TO FLGTES.
           GO TO H10.
       H99.
           EXIT.
      **** rel 6.2
      *-------------------------------
       SOMMA-GG.
           IF GGS = ZERO OR AAGGG = ZERO GO TO EX-SOMMA-GG.
      * somma giorni escludendo sabati e domeniche
           MOVE GGS TO I.
           PERFORM UNTIL I = ZERO
              ADD 1 TO AAGGG
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              IF SWRET1 > ZERO
                 MOVE ZERO TO I
              ELSE
                 IF GGSET <= 5
                    SUBTRACT 1 FROM I.
       EX-SOMMA-GG.
           EXIT.
      *-------------------------------
      ************
      **** rel 7.1
       C00-CAL-SCAPP.

           MOVE "V"       TO IM-TIPO.
           MOVE RIG-FSC   TO DP-FSC.
           MOVE RIG-PREZZ TO DP-PREZZO.
           CALL 'rforprz' USING DP-PREZZO DP-FSC FSC-UNI.
           MOVE DP-PREZZO    TO IM-PZLOR.   
      * 
           MOVE RIG-QUANT TO IM-QTA.
           IF RIG-QUANT = ZERO AND RIG-TPRIG = 2
              MOVE 1 TO IM-QTA.
           MOVE ORD-PERSC TO IM-SCBAS.
           MOVE RIG-1SCON TO IM-SC1.
           MOVE RIG-2SCON TO IM-SC2.
           MOVE ORD-VALUT TO IM-VALUT.
           MOVE RIG-TPRIG TO IM-TCOR.
           MOVE RIG-TQUAN TO IM-TQUAN.
           MOVE RIG-FSC  TO IM-FSC.
           MOVE RIG-FPNET TO IM-FPNET.
           CALL 'vrimpor' USING PARIM.
      *------------------*
      ************
