#
# Ordini clienti
#
# Programma: exp610
#
DSC  ordcli
FLD  D-ORD-AZI       3.0   NU  S  # Codice azienda
FLD  D-ORD-AZI-D     36    AN  S  # Ragione Sociale azienda
FLD  D-ORD-NUM       5.0   NU  S  # Numero ordine
FLD  D-ORD-NRORC     5.0   NU  S  # Numero ordine a programma
FLD  D-ORD-FLGP      1     AN  S  # Tipo ordine
#                                 # P = a programma
FLD  D-ORD-DAT       8     AN  S  # Data ordine
FLD  D-ORD-CDCLI     5.0   NU  S  # Codice cliente
FLD  D-ORD-RGSOC     36    AN  S  # Ragione Sociale
FLD  D-ORD-RGSOC2    36    AN  S  # Ragione Sociale 2
FLD  D-ORD-ESTER     1.0   NU  S  # Non gestito
FLD  D-ORD-ZONA      3     AN  S  # Codice zona
FLD  D-ORD-ZONA-D    24    AN  S  # Descrizione zona
FLD  D-ORD-CDAGE     3.0   NU  S  # Codice agente
FLD  D-ORD-CDAGE-D   24    AN  S  # Descrizione agente
FLD  D-ORD-PROVV     5.2   NU  S  # Percentuale provvigione di testata
FLD  D-ORD-CDPAG     3.0   NU  S  # Codice pagamento
FLD  D-ORD-CDPAG-D   24    AN  S  # Descrizione pagamento
FLD  D-ORD-TPAG      1.0   NU  S  # Tipo pagamento
FLD  D-ORD-TPAG-D    24    AN  S  # Descrizione tipo pagamento
FLD  D-ORD-CDBAN     5.0   NU  S  # Codice banca
FLD  D-ORD-CDBAN-D   36    AN  S  # Descrizione banca
FLD  D-ORD-ABI       5     AN  S  # ABI
FLD  D-ORD-CAB       8     AN  S  # CAB
FLD  D-ORD-CDSPE     3.0   NU  S  # Codice spedizione
FLD  D-ORD-CDSPE-D   24    AN  S  # Descrizione spedizione
FLD  D-ORD-CDPOR     3.0   NU  S  # Codice porto
FLD  D-ORD-CDPOR-D   24    AN  S  # Descrizione porto
FLD  D-ORD-PERSC     5.2   NU  S  # Percentuale sconto base
FLD  D-ORD-SCONT     7.0   NU  S  # Non gestito
FLD  D-ORD-DTCSR     8     AN  S  # Data consegna richiesta di testata
FLD  D-ORD-DTCSC     8     AN  S  # Data consegna confermata di testata
FLD  D-ORD-CDESE     3.0   NU  S  # Codice esenzione
FLD  D-ORD-CDESE-D   24    AN  S  # Descrizione esenzione
FLD  D-ORD-VSORD     10    AN  S  # Descrizione ordine
FLD  D-ORD-COMME     24    AN  S  # Commento
FLD  D-ORD-CDEP      2.0   NU  S  # Codice deposito
FLD  D-ORD-CDEP-D    24    AN  S  # Descrizione deposito
FLD  D-ORD-VALUT     3.0   NU  S  # Codice valuta
FLD  D-ORD-VALUT-D   24    AN  S  # Descrizione valuta
FLD  D-ORD-LCONS     2.0   NU  S  # Codice destinatario o destinazione diversa
FLD  D-ORD-DRAG      36    AN  S  # Rag.sociale destinatario diverso 
FLD  D-ORD-DRAG2     36    AN  S  # Seconda rag.sociale destinatario diverso 
FLD  D-ORD-DIND      24    AN  S  # Indirizzo destinatario diverso 
FLD  D-ORD-DIND2     24    AN  S  # Secondo indirizzo destinatario diverso 
FLD  D-ORD-DCAP      5.0   NU  S  # CAP         destinatario diverso 
FLD  D-ORD-DCIT      26    AN  S  # Citta`      destinatario diverso 
FLD  D-ORD-DEST      40    AN  S  # Luogo di destinazione 
FLD  D-ORD-CATT      1     AN  S  # Codice attivita'
FLD  D-ORD-CATT-D    24    AN  S  # Descrizione attivita'
FLD  D-ORD-LISRF     3.0   NU  S  # Codice listino di riferimento
FLD  D-ORD-LISRF-D   24    AN  S  # Descrizione listino di riferimento
FLD  D-ORD-PRG       3.0   NU  S  # Progressivo ordine
FLD  D-ORD-TPRIG     2.0   NU  S  # Tipo rigo (0/1/>10)
#                                 # 0 = articolo
#                                 # 1 = descrittivo
#                                 # > 10 = spesa aggiuntiva
FLD  D-ORD-TPRIG-D   24    AN  S  # Descrizione tipo rigo
FLD  D-ORD-ARTIC     18    AN  S  # Codice articolo (se tipo rigo = 0)
FLD  D-ORD-GMERC     2.0   NU  S  # Gruppo merceologico
FLD  D-ORD-GMERC-D   24    AN  S  # Descrizione gruppo merceologico
FLD  D-ORD-GSTAT     2.0   NU  S  # Gruppo statistico
FLD  D-ORD-GSTAT-D   24    AN  S  # Descrizione gruppo statistico
FLD  D-ORD-TPART     1.0   NU  S  # Tipo articolo
#                                 # Esempio: 1=Prodotto finito
#                                 #          2=Semilavorato
#                                 #          3=Materia prima
FLD  D-ORD-TPART-D   24    AN  S  # Descrizione tipo articolo
FLD  D-ORD-LOTTO     1.0   NU  S  # Lotto
FLD  D-ORD-POPC      3.0   NU  S  # Progressivo ordine a programma
FLD  D-ORD-QTPRE     13.2  NS  S  # Quantita' prevista (ord. a programma)
FLD  D-ORD-QUANT     13.2  NS  S  # Quantita'
FLD  D-ORD-DTRSR     8     AN  S  # Data consegna richiesta di rigo
FLD  D-ORD-DTRSC     8     AN  S  # Data consegna confermata di rigo
FLD  D-ORD-DDATA     12    AN  S  # Descrizione data consegna (ord. a progr)
FLD  D-ORD-UNMIS     2     AN  S  # Unita' di misura
FLD  D-ORD-PREZZ     19.6  NU  S  # Prezzo
FLD  D-ORD-PREZFSC   16.3  NU  S  # Prezzo secondo fattore di scala
FLD  D-ORD-PREZN     19.6  NU  S  # Prezzo Netto
FLD  D-ORD-PRENFSC   16.3  NU  S  # Prezzo Netto secondo fattore di scala
FLD  D-ORD-FSC       1.0   NU  S  # Fattore di scala
FLD  D-ORD-FPNET     1.0   NU  S  # Prezzo netto (0-no / 1-si)
FLD  D-ORD-1SCON     6.2   NS  S  # Primo sconto
FLD  D-ORD-2SCON     6.2   NS  S  # Secondo sconto
FLD  D-ORD-SPESA     3.0   NU  S  # Codice spesa
FLD  D-ORD-PERSPE    5.2   NU  S  # Percentuale spesa
FLD  D-ORD-RPROVV    5.2   NU  S  # Percentuale provvigione di rigo
FLD  D-ORD-CDIVA     3.0   NU  S  # Codice I.V.A.
FLD  D-ORD-CDIVA-D   24    AN  S  # Descrizione I.V.A.
FLD  D-ORD-DESAR     30    AN  S  # Descrizione
FLD  D-ORD-QSPED     13.2  NS  S  # Quantita' spedita
FLD  D-ORD-QRES      13.2  NS  S  # Quantita' residua
FLD  D-ORD-NETRIG    15.2  NS  S  # Netto di rigo
FLD  D-ORD-NETRES    15.2  NS  S  # Netto di rigo - residuo
FLD  D-ORD-IPROV     8.0   NS  S  # Importo provvigioni
FLD  D-ORD-SALDO     1.0   NU  S  # Flag saldo (0=in conto  1=saldato)
FLD  D-ORD-SALDO-D   24    AN  S  # Descrizione flag saldo
FLD  D-ORD-RIVAL     1.0   NU  S  # Test rivalsa IVA su cessioni gratuite (0/1)
#                                 # 0 = si  1 = no
FLD  D-ORD-RIVGR     3.0   NU  S  # Cod. IVA su cess.grat. e sconti in merce
FLD  D-ORD-CDSPE1    3.0   NU  S  # Codice voce spesa
FLD  D-ORD-CONTR     7.0   NU  S  # Codice conto di contropartita
FLD  D-ORD-CONTR-D   36    AN  S  # Descrizione contropartita
# rel 5.2
FLD  D-ORD-PRGC      3.0   NU  S  # Progressivo consegna
FLD  D-ORD-BNUM      1.0   NU  S  # Bollettario
FLD  D-ORD-BBOL      5.0   NU  S  # Numero bolla
FLD  D-ORD-DTBOL     8     AN  S  # Data bolla
FLD  D-ORD-QBOL      13.2  NS  S  # Quantita' bolla
FLD  D-ORD-GGLEAD    4.0   NS  S  # Giorni lead time consegna
FLD  D-ORD-GGRIT     4.0   NS  S  # Giorni ritardo consegna
FLD  D-ORD-NOFF      5.0   NU  S  # Numero offerta
FLD  D-ORD-DTOFF     8     AN  S  # Data offerta
FLD  D-ORD-IPA       6     AN  S  # Codice IPA   
FLD  D-ORD-CIG       10    AN  S  # Codice CIG   
FLD  D-ORD-CUP       15    AN  S  # Codice CUP  
FLD  D-ORD-TAPPO     1     AN  S  # Carattere di fine record
