       IDENTIFICATION DIVISION.
       PROGRAM-ID. VEXP610.
      *
      * Esportazione ordini clienti
      *
      **** rel 6.2
      * ricompilato
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griartsl'.
           COPY 'griordsl'.
           COPY 'gririgsl'.
      **** rel 5.2
           COPY 'gritprsl'.
           COPY 'griopcsl'.
           COPY 'griobcsl'.
           COPY 'gribctsl'.
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLAV STATUS SF-LAV.
      ************
           COPY 'gritabsl'.
      **** rel 6.0
           COPY 'griclfsl'.
      ************
      **** rel 6.3
           COPY 'griconsl'.
           COPY 'griirisl'.
           COPY 'griorcsl'.
           COPY 'gribansl'.
           COPY 'grifctsl'.
      ************
      **** rel 7.1
           COPY 'griaorsl'.
      ************
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'griart'.
           COPY 'griord'.
           COPY 'gririg'.
      **** rel 5.2
           COPY 'gritpr'.
           COPY 'griopc'.
           COPY 'griobc'.
           COPY 'gribct'.
       FD  WDSLAV LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LAV
           RECORD 53 DATA RECORD RF-LAV.
       01  RF-LAV.
           02 KEYLAV.
              05 KLV-OPC-PROG  PIC 9(4).
              05 KLV-BPC-DTBOL PIC 9(5).
              05 KLV-BPC-TBOL  PIC 9.
              05 KLV-BPC-NBOL  PIC 9(5).
              05 KLV-BPC-PBOL  PIC 999.
              05 KLV-BPC-PRG   PIC 99.
              05 KLV-BPC-PROG  PIC 9(7).
           02 REKLAV.
              05 LAV-QTA-OPC   PIC S9(10)V999.
              05 LAV-QTA-BPC   PIC S9(10)V999.
      ************
           COPY 'gritab'.
      **** rel 6.0
           COPY 'griclf'.
      ************
      **** rel 6.3
           COPY 'gricon'.
           COPY 'griiri'.
           COPY 'griorc'.
           COPY 'griban'.
           COPY 'grifct'.
      ************
      **** rel 7.1
           COPY 'griaor'.
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-71'.
           COPY 'gritabrk'.
           COPY 'griartrk'.
           COPY 'griordrk'.
           COPY 'gririgrk'.
      **** rel 6.0
           COPY 'griclfrk'.
      ************
      **** rel 6.3
           COPY 'grit35rk'.
           COPY 'grifctrk'.
      ************
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'pardp'.
      **** rel 5.2
           COPY 'gritpr12'.
           COPY 'paroc'.
           COPY 'parpdop'.
           COPY 'parcop'.
      ************
      **** rel 6.0
           COPY '_parx'.
      ************
      **** rel 6.2
           COPY 'parpdef'.
           COPY 'parim'.
      ************
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-ART PIC X(15) VALUE 'magart'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-ORD PIC X(15) VALUE 'ordcli'.
       01  ID-RIG PIC X(15) VALUE 'ordrig'.
      **** rel 5.2
       01  ID-TPR PIC X(15) VALUE 'tabpro'.
       01  ID-OPC PIC X(15) VALUE 'ordprc'.
       01  ID-OBC PIC X(15) VALUE 'bolord'.
       01  ID-BCT PIC X(15) VALUE 'bolcte'.
       01  ID-LAV PIC X(15) VALUE 'wdslav'.
      ************
      **** rel 6.0
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
      ************
      **** rel 6.3
       01  ID-CON PIC X(15) VALUE 'anacon'.
       01  ID-IRI PIC X(15) VALUE 'indiri'.
       01  ID-ORC PIC X(15) VALUE 'ordric'.
       01  ID-BAN PIC X(15) VALUE 'anaban'.
       01  ID-FCT PIC X(15) VALUE 'offcli'.
      ************
      **** rel 7.1
       01  ID-AOR PIC X(15) VALUE 'appord'.
      ************
       01  COMODI.
           05 SF-TAB  PIC XX.
           05 SF-ART  PIC XX.
           05 SF-AZI  PIC XX.
           05 SF-ORD  PIC XX.
           05 SF-RIG  PIC XX.
      **** rel 5.2
           05 SF-TPR  PIC XX.
           05 SF-OPC  PIC XX.
           05 SF-OBC  PIC XX.
           05 SF-BCT  PIC XX.
           05 SF-LAV  PIC XX.
      ************
      **** rel 6.0
           05 SF-CLF   PIC XX.
      ************
      **** rel 6.3
           05 SF-CON   PIC XX.
           05 SF-IRI   PIC XX.
           05 SF-ORC   PIC XX.
           05 SF-BAN   PIC XX.
           05 SF-FCT   PIC XX.
      ************
      **** rel 7.1
           05 SF-AOR   PIC XX.
      ************
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 COMTP1   PIC 9.
      **** rel 5.2
           05 FLGC     PIC 9 VALUE ZERO.
           05 GGDIF    PIC S999 VALUE ZERO.
           05 POPC     PIC 999 VALUE ZERO.
           05 PRGC     PIC 999 VALUE ZERO.
           05 RESID    PIC S9(10)V999 VALUE ZERO.
           05 QTOPC    PIC S9(10)V999 VALUE ZERO.
           05 DAT1    PIC 9(5).
           05 DAT2    PIC 9(5).
      ************
      **** rel 6.0
           05 PKDTORD1 PIC 9(5)  COMP-3 VALUE ZERO.
           05 PKDTORD2 PIC 9(5)  COMP-3 VALUE ZERO.
           05 PKDTCON1 PIC 9(5)  COMP-3 VALUE ZERO.
           05 PKDTCON2 PIC 9(5)  COMP-3 VALUE ZERO.
           05 CODCLF.
              10 MAS PIC 99.
              10 COD PIC 9(5).
      ************
      **** rel 6.3
           05 COMEURO PIC 9(3) VALUE ZERO.
      ************

      **** rel 6.0
       01  CODART PIC X(18) VALUE SPACE.
      ************

      **** rel 5.2
      *01  RICOM.
      *    05 COM-ORD-AZI      PIC 9(3)         VALUE ZERO.
      *    05 COM-ORD-NUM      PIC 9(5)         VALUE ZERO.
      *    05 COM-ORD-DAT      PIC X(8)         VALUE SPACE.
      *    05 COM-ORD-CDCLI    PIC 9(5)         VALUE ZERO.
      *    05 COM-ORD-ESTER    PIC 9            VALUE ZERO.
      *    05 COM-ORD-ZONA     PIC X(3)         VALUE SPACE.
      *    05 COM-ORD-CDAGE    PIC 9(3)         VALUE ZERO.
      *    05 COM-ORD-PROVV    PIC 99V99        VALUE ZERO.
      *    05 COM-ORD-CDPAG    PIC 9(3)         VALUE ZERO.
      *    05 COM-ORD-CDBAN    PIC 9(5)         VALUE ZERO.
      *    05 COM-ORD-CDSPE    PIC 9(3)         VALUE ZERO.
      *    05 COM-ORD-CDPOR    PIC 9(3)         VALUE ZERO.
      *    05 COM-ORD-PERSC    PIC 99V99        VALUE ZERO.
      *    05 COM-ORD-SCONT    PIC 9(7)         VALUE ZERO.
      *    05 COM-ORD-DTCSR    PIC X(8)         VALUE SPACE.
      *    05 COM-ORD-DTCSC    PIC X(8)         VALUE SPACE.
      *    05 COM-ORD-CDESE    PIC 9(3)         VALUE ZERO.
      *    05 COM-ORD-VSORD    PIC X(10)        VALUE SPACE.
      *    05 COM-ORD-COMME    PIC X(24)        VALUE SPACE.
      *    05 COM-ORD-CDEP     PIC 9(2)         VALUE ZERO.
      *    05 COM-ORD-VALUT    PIC 9(3)         VALUE ZERO.
      *    05 COM-ORD-LCONS    PIC 99           VALUE ZERO.
      *    05 COM-ORD-CATT     PIC X            VALUE SPACE.
      ************

      *
      * Area generata da file '../dsc/ordcli.dsc'
      *
       01  RIGXP.
           05 D-ORD-AZI      PIC 9(3)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      **** rel 6.3
           05 D-ORD-AZI-D    PIC X(36)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      ************
           05 D-ORD-NUM      PIC 9(5)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      **** rel 6.3
           05 D-ORD-NRORC    PIC 9(5)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      ************
      **** rel 5.2
           05 D-ORD-FLGP     PIC X(1)         VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      ************
           05 D-ORD-DAT      PIC X(8)         VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-CDCLI    PIC 9(5)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      **** rel 6.2
           05 D-ORD-RGSOC    PIC X(36)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-RGSOC2   PIC X(36)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      ************
           05 D-ORD-ESTER    PIC 9(1)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-ZONA     PIC X(3)         VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      **** rel 6.3
           05 D-ORD-ZONA-D   PIC X(24)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      ************
           05 D-ORD-CDAGE    PIC 9(3)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      **** rel 6.3
           05 D-ORD-CDAGE-D  PIC X(24)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      ************
           05 D-ORD-PROVV    PIC 9(2),9(2)+   VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-CDPAG    PIC 9(3)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      **** rel 6.3
           05 D-ORD-CDPAG-D  PIC X(24)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-TPAG     PIC 9+           VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-TPAG-D   PIC X(24)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      ************
           05 D-ORD-CDBAN    PIC 9(5)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      **** rel 6.3
           05 D-ORD-CDBAN-D  PIC X(36)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-ABI      PIC X(5)         VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-CAB      PIC X(8)         VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      ************
           05 D-ORD-CDSPE    PIC 9(3)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      **** rel 6.3
           05 D-ORD-CDSPE-D  PIC X(24)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      ************
           05 D-ORD-CDPOR    PIC 9(3)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      **** rel 6.3
           05 D-ORD-CDPOR-D  PIC X(24)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      ************
           05 D-ORD-PERSC    PIC 9(2),9(2)+   VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-SCONT    PIC 9(7)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-DTCSR    PIC X(8)         VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-DTCSC    PIC X(8)         VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-CDESE    PIC 9(3)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      **** rel 6.3
           05 D-ORD-CDESE-D  PIC X(24)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      ************
           05 D-ORD-VSORD    PIC X(10)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-COMME    PIC X(24)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-CDEP     PIC 9(2)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      **** rel 6.3
           05 D-ORD-CDEP-D   PIC X(24)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      ************
           05 D-ORD-VALUT    PIC 9(3)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      **** rel 6.3
           05 D-ORD-VALUT-D  PIC X(24)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      ************
           05 D-ORD-LCONS    PIC 9(2)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      **** rel 6.3
           05 D-ORD-DRAG     PIC X(36)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-DRAG2    PIC X(36)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-DIND     PIC X(24)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-DIND2    PIC X(24)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-DCAP     PIC 9(5)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-DCIT     PIC X(26)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-DEST     PIC X(40)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      ************
           05 D-ORD-CATT     PIC X(1)         VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      **** rel 6.3
           05 D-ORD-CATT-D   PIC X(24)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      ************
           05 D-ORD-LISRF    PIC 9(3)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      **** rel 6.3
           05 D-ORD-LISRF-D  PIC X(24)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      ************
           05 D-ORD-PRG      PIC 9(3)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-TPRIG    PIC 9(2)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      **** rel 6.3
           05 D-ORD-TPRIG-D  PIC X(24)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      ************
      **** rel 6.0
      *    05 D-ORD-ARTIC    PIC X(12)        VALUE SPACE.
           05 D-ORD-ARTIC    PIC X(18)        VALUE SPACE.
      ************
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-GMERC    PIC 9(2)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      **** rel 6.3
           05 D-ORD-GMERC-D  PIC X(24)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      ************
           05 D-ORD-GSTAT    PIC 9(2)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      **** rel 6.3
           05 D-ORD-GSTAT-D  PIC X(24)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      ************
           05 D-ORD-TPART    PIC 9(1)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      **** rel 6.3
           05 D-ORD-TPART-D  PIC X(24)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      ************
           05 D-ORD-LOTTO    PIC 9(1)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      **** rel 5.2
           05 D-ORD-POPC     PIC 9(3)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-QTPRE    PIC 9(9),9(2)+   VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      ************
           05 D-ORD-QUANT    PIC 9(9),9(2)+   VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-DTRSR    PIC X(8)         VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-DTRSC    PIC X(8)         VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      **** rel 5.2
           05 D-ORD-DDATA    PIC X(12)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      ************
           05 D-ORD-UNMIS    PIC X(2)         VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-PREZZ    PIC 9(11),9(6)+  VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-PREZFSC  PIC 9(11),9(3)+  VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      **** rel 6.3
           05 D-ORD-PREZN    PIC 9(11),9(6)+  VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-PRENFSC  PIC 9(11),9(3)+  VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      ************
           05 D-ORD-FSC      PIC 9(1)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      **** rel 6.0a
           05 D-ORD-FPNET    PIC 9(1)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      *************
           05 D-ORD-1SCON    PIC 9(2),9(2)+   VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-2SCON    PIC 9(2),9(2)+   VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-SPESA    PIC 9(3)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-PERSPE   PIC 9(2),9(2)+   VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-RPROVV   PIC 9(2),9(2)+   VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-CDIVA    PIC 9(3)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      **** rel 6.3
           05 D-ORD-CDIVA-D  PIC X(24)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      ************
           05 D-ORD-DESAR    PIC X(30)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-QSPED    PIC 9(9),9(2)+   VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      **** rel 5.2
           05 D-ORD-QRES     PIC 9(9),9(2)+   VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      ************
      **** rel 6.2
           05 D-ORD-NETRIG   PIC 9(11),9(2)+  VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      ************
      **** rel 6.3
           05 D-ORD-NETRES   PIC 9(11),9(2)+  VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      ************
           05 D-ORD-IPROV    PIC 9(7)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-SALDO    PIC 9(1)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      **** rel 6.3
           05 D-ORD-SALDO-D  PIC X(10)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      ************
           05 D-ORD-RIVAL    PIC 9(1)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-RIVGR    PIC 9(3)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-CDSPE1   PIC 9(3)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-CONTR    PIC 9(7)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      **** rel 6.3
           05 D-ORD-CONTR-D  PIC X(36)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      ************
      **** rel 5.2
           05 D-ORD-PRGC     PIC 9(3)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-BNUM     PIC 9(1)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-BBOL     PIC 9(5)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-DTBOL    PIC X(8)         VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-QBOL     PIC 9(9),9(2)+   VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-GGLEAD   PIC 9(3)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-GGRIT    PIC 9(3)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      ************
      **** rel 6.0
           05 D-ORD-NOFF     PIC 9(5)+        VALUE ZERO.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      ************
      **** rel 6.3
           05 D-ORD-DTOFF    PIC X(8)         VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      ************
      **** rel 7.1
           05 D-ORD-IPA      PIC X(6)         VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-CIG      PIC X(10)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
           05 D-ORD-CUP      PIC X(15)        VALUE SPACE.
           05 FILLER         PIC X            VALUE HIGH-VALUE.
      ************
           05 D-ORD-TAPPO    PIC X(1)         VALUE SPACE.
           05 FILLER         PIC X            VALUE LOW-VALUE.

       LINKAGE SECTION.
      **** rel 6.2
           COPY 'pexp610'.
      ************   
      *
           COPY 'parxpls'.
      *
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS
                                PARXP.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclart'.
           COPY 'dclord'.
           COPY 'dclrig'.
      **** rel 5.2
           COPY 'dcltpr'.
           COPY 'dclopc'.
           COPY 'dclobc'.
           COPY 'dclbct'.
      ************
           COPY 'dcltab'.
      **** rel 6.0
           COPY 'dclclf'.
      ************
      **** rel 6.3
           COPY 'dclcon'.
           COPY 'dcliri'.
           COPY 'dclorc'.
           COPY 'dclban'.
           COPY 'dclfct'.
      ************
      **** rel 7.1
           COPY 'dclaor'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vexp610: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE TABELL.
           CLOSE MAGART.
           CLOSE ORDCLI.
           CLOSE ORDRIG.
           CLOSE ANAAZI.
      **** rel 6.0
           CLOSE ANACLF.
      ************
      **** rel 6.3
           CLOSE ANACON.
           CLOSE INDIRI.
           CLOSE ORDRIC.
           CLOSE ANABAN.
           CLOSE OFFCLI.
      ************
      **** rel 7.1
           CLOSE APPORD.
      ************
      **** rel 5.2
           CLOSE WDSLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
      ************
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'griarter'.
           COPY 'griorder'.
           COPY 'gririger'.
           COPY 'gritaber'.
      **** rel 5.2
           COPY 'gritprer'.
      ************
      **** rel 7.1
           COPY 'griaorer'.
      ************
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
      **** rel 5.2
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
      ************
           OPEN INPUT ORDCLI.
           OPEN INPUT ORDRIG.
           OPEN INPUT TABELL.
           OPEN INPUT MAGART.
           OPEN INPUT ANAAZI.
      **** rel 6.0
           OPEN INPUT ANACLF.
      ************
      **** rel 6.3
           OPEN INPUT ANACON.
           OPEN INPUT INDIRI.
           OPEN INPUT ORDRIC.
           OPEN INPUT ANABAN.
           OPEN INPUT OFFCLI.
      ************
      **** rel 7.1
           OPEN INPUT APPORD.
      ************
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INVALID PERFORM INVK-AZI
                               GO TO ERRIO.
      *
      **** rel 5.2
           OPEN INPUT TABPRO.
           MOVE IF-AZI TO KTR-AZI.
           MOVE 12     TO KTR-TIP.
           READ TABPRO INTO REKTPR12 INVALID
                PERFORM INVK-TPR
                GO TO ERRIO.
           IF SF-TPR = '9A' OR '9D' OR '35' MOVE RF-TPR TO REKTPR12.
           CLOSE TABPRO.
      ************
      **** rel 6.0
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MCLI TO MAS.
      **********
      **** rel 6.3
           CALL 'rveur' USING COMEURO.
      ************
           MOVE ZERO  TO PARXP.
           MOVE SPACE TO XP-DSC
                         XP-NFILE
                         XP-FORMA
                         XP-SUFFI
                         XP-SEPAR
                         XP-FILNU
                         XP-PUNTO
                         XP-POSEG.
      *
           MOVE 'ordcli' TO XP-DSC.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
      *
           MOVE AZRGSOC TO IF-AZI-D.
      *
      **** rel 6.0
      *    MOVE ZERO    TO IF-COD-1
      *                    IF-COD-2
      *                    IF-CONT.

           MOVE ZERO    TO IF-COD-1.
           MOVE 99999   TO IF-COD-2.
           MOVE ZERO    TO IF-CONT.
      *
           MOVE ZERO TO IF-DTORD-1.

           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO AAGGG.
           MOVE AA9 TO GG9.
           MOVE AAGGG TO AA9.
           MOVE GGMMAA TO IF-DTORD-2.

           MOVE ZERO TO IF-DEP-1.
           MOVE 99   TO IF-DEP-2.
           MOVE ZERO TO IF-OFF-1.
           MOVE 99999 TO IF-OFF-2.
           MOVE ZERO TO IF-CLF-1.
           MOVE 99999 TO IF-CLF-2.
           MOVE SPACE TO IF-ZONORD-1.
           MOVE ALL 'z' TO IF-ZONORD-2.
           MOVE ZERO TO IF-AGEORD-1.
           MOVE 999 TO IF-AGEORD-2.
           MOVE ZERO TO IF-PAGORD-1.
           MOVE 999 TO IF-PAGORD-2.
      *
           MOVE ZERO TO IF-CONS-1.
           MOVE 99 TO IF-CONS-2.
           MOVE ZERO TO IF-DTCON-1.
           MOVE ZERO TO IF-DTCON-2.
      *
           MOVE 1 TO IF-TIPO0.
           MOVE 1 TO IF-TIPO1.
           MOVE 1 TO IF-TIPO2.
           MOVE 1 TO IF-TIPO3.
           MOVE 1 TO IF-TIPO4.
           MOVE 1 TO IF-TIPO5.
           MOVE 1 TO IF-TIPO6.
           MOVE 2 TO IF-SALDO.
      *
           MOVE SPACE TO IF-ART-1.
           MOVE ALL 'z' TO IF-ART-2.
           MOVE ZERO TO IF-CMERC-1.
           MOVE 99 TO IF-CMERC-2.
           MOVE ZERO TO IF-GSTA-1.
           MOVE 99 TO IF-GSTA-2.
           MOVE ZERO TO IF-TPART-1.
           MOVE 9 TO IF-TPART-2.
      *
           MOVE ZERO TO IF-AGECLI-1.
           MOVE 999 TO IF-AGECLI-2.
           MOVE SPACE TO IF-ZONCLI-1.
           MOVE ALL 'z' TO IF-ZONCLI-2.
           MOVE SPACE TO IF-GRU-1.
           MOVE ALL 'z' TO IF-GRU-2.
           MOVE ZERO TO IF-GRM-1.
           MOVE 9 TO IF-GRM-2.
           MOVE ZERO TO IF-CATC-1.
           MOVE 9 TO IF-CATC-2.
      ************
      **** rel 5.2
           MOVE ZERO TO IF-FLGP.
           MOVE 1 TO IF-FLGC.
      ************
      **** rel 6.2
      *
           MOVE SPACE TO PARPDEF.
           IF EX-CMD-LINE NOT = SPACE PERFORM CDEF THRU EX-CDEF.
      *
      ************
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-COD-2.
           MOVE 'IF-COD-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-COD-2.
           IF IF-COD-2 < IF-COD-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-COD-2.
      *
      **** rel 6.0
      *
       V-DTORD-1.
           MOVE 'IF-DTORD-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTORD-1.
           MOVE 1 TO TIPOP1.
           MOVE IF-DTORD-1 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO PERFORM ERR-DATA GO TO V-ERROR.
           MOVE AAGGG TO PKDTORD1.
       E-DTORD-1.
      *
       V-DTORD-2.
           MOVE 'IF-DTORD-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTORD-2.
           MOVE 1 TO TIPOP1.
           MOVE IF-DTORD-2 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO PERFORM ERR-DATA GO TO V-ERROR.
           MOVE AAGGG TO PKDTORD2.
           IF PKDTORD1 > PKDTORD2 PERFORM ERR-DINC GO TO V-ERROR.
       E-DTORD-2.
      *
       V-DEP-2.
           MOVE 'IF-DEP-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DEP-2.
           IF IF-DEP-2 < IF-DEP-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-DEP-2.
      *
       V-OFF-2.
           MOVE 'IF-OFF-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-OFF-2.
           IF IF-OFF-2 < IF-OFF-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-OFF-2.
      *
       V-CLF-2.
           MOVE 'IF-CLF-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CLF-2.
           IF IF-CLF-2 < IF-CLF-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-CLF-2.
      *
       V-ZONORD-2.
           MOVE 'IF-ZONORD-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ZONORD-2.
           IF IF-ZONORD-2 < IF-ZONORD-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-ZONORD-2.
      *
       V-AGEORD-2.
           MOVE 'IF-AGEORD-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-AGEORD-2.
           IF IF-AGEORD-2 < IF-AGEORD-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-AGEORD-2.
      *
       V-PAGORD-2.
           MOVE 'IF-PAGORD-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PAGORD-2.
           IF IF-PAGORD-2 < IF-PAGORD-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-PAGORD-2.
      *
       V-CONS-2.
           MOVE 'IF-CONS-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CONS-2.
           IF IF-CONS-2 < IF-CONS-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-CONS-2.
      *
       V-DTCON-1.
           MOVE 'IF-DTCON-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTCON-1.
           MOVE 1 TO TIPOP1.
           MOVE IF-DTCON-1 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO PERFORM ERR-DATA GO TO V-ERROR.
           MOVE AAGGG TO PKDTCON1.
       E-DTCON-1.
      *
       V-DTCON-2.
           MOVE 'IF-DTCON-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTCON-2.
           MOVE 1 TO TIPOP1.
           MOVE IF-DTCON-2 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO PERFORM ERR-DATA GO TO V-ERROR.
           MOVE AAGGG TO PKDTCON2.
           IF PKDTCON1 > PKDTCON2 PERFORM ERR-DINC GO TO V-ERROR.
       E-DTCON-2.
      *
       V-SALDO.
           MOVE 'IF-SALDO' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-SALDO.
           IF NOT (IF-SALDO = ZERO OR 1 OR 2)
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-SALDO.
      *
       V-ART-1.
           MOVE 'IF-ART-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ART-1.
           MOVE IF-ART-1 TO CODART.
           CALL 'vrcartb' USING PARX CODART.
           MOVE CODART TO IF-ART-1.
       E-ART-1.
      *
      *
       V-ART-2.
           MOVE 'IF-ART-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ART-2.
           MOVE IF-ART-2 TO CODART.
           CALL 'vrcartb' USING PARX CODART.
           MOVE CODART TO IF-ART-2.
           IF IF-ART-2 < IF-ART-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-ART-2.
      *
       V-CMERC-2.
           MOVE 'IF-CMERC-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CMERC-2.
           IF IF-CMERC-2 < IF-CMERC-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-CMERC-2.
      *
       V-GSTA-2.
           MOVE 'IF-GSTA-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-GSTA-2.
           IF IF-GSTA-2 < IF-GSTA-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-GSTA-2.
      *
       V-TPART-2.
           MOVE 'IF-TPART-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TPART-2.
           IF IF-TPART-2 < IF-TPART-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-TPART-2.
      *
       V-AGECLI-2.
           MOVE 'IF-AGECLI-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-AGECLI-2.
           IF IF-AGECLI-2 < IF-AGECLI-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-AGECLI-2.
      *
       V-ZONCLI-2.
           MOVE 'IF-ZONCLI-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ZONCLI-2.
           IF IF-ZONCLI-2 < IF-ZONCLI-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-ZONCLI-2.
      *
       V-GRU-2.
           MOVE 'IF-GRU-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-GRU-2.
           IF IF-GRU-2 < IF-GRU-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-GRU-2.
      *
       V-GRM-2.
           MOVE 'IF-GRM-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-GRM-2.
           IF IF-GRM-2 < IF-GRM-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-GRM-2.
      *
       V-CATC-2.
           MOVE 'IF-CATC-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CATC-2.
           IF IF-CATC-2 < IF-CATC-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-CATC-2.
      *
      ************
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
      *
           COPY 'dfdata'.
      *
           MOVE ZERO TO IF-CONT.

           MOVE IF-AZI   TO KOR-AZI.
           MOVE IF-COD-1 TO KOR-NUM.
      **** rel 5.2
      *RSTA1.
      ************
           START ORDCLI KEY NOT < KEYOR INVALID GO TO FINE-EXP.
       RDTST.
           READ ORDCLI NEXT INTO REKORD AT END GO TO FINE-EXP.
           IF SF-ORD = '9D' OR '9A' OR '35' MOVE RF-ORD TO REKORD.
           IF KOR-AZI > IF-AZI   GO TO FINE-EXP.
           IF KOR-NUM > IF-COD-2 GO TO FINE-EXP.
      **** rel 5.2
      *    MOVE KOR-AZI   TO COM-ORD-AZI.
      *    MOVE KOR-NUM   TO COM-ORD-NUM.
      *    MOVE COMTP1 TO TIPOP1.
      *    MOVE ORD-DAT   TO AAGGG.
      *    CALL 'vramg' USING PARCDT.
      *    MOVE GGMMAA4    TO COM-ORD-DAT.
      *    MOVE ORD-CDCLI TO COM-ORD-CDCLI.
      *    MOVE ORD-ESTER TO COM-ORD-ESTER.
      *    MOVE ORD-ZONA  TO COM-ORD-ZONA.
      *    MOVE ORD-CDAGE TO COM-ORD-CDAGE.
      *    MOVE ORD-PROVV TO COM-ORD-PROVV.
      *    MOVE ORD-CDPAG TO COM-ORD-CDPAG.
      *    MOVE ORD-CDBAN TO COM-ORD-CDBAN.
      *    MOVE ORD-CDSPE TO COM-ORD-CDSPE.
      *    MOVE ORD-CDPOR TO COM-ORD-CDPOR.
      *    MOVE ORD-PERSC TO COM-ORD-PERSC.
      *    MOVE ORD-SCONT TO COM-ORD-SCONT.
      *    MOVE COMTP1 TO TIPOP1.
      *    MOVE ORD-DTCSR TO AAGGG.
      *    CALL 'vramg' USING PARCDT.
      *    MOVE GGMMAA4    TO COM-ORD-DTCSR.
      *    MOVE ORD-DTCSC TO AAGGG.
      *    CALL 'vramg' USING PARCDT.
      *    MOVE GGMMAA4    TO COM-ORD-DTCSC.
      *    MOVE ORD-CDESE TO COM-ORD-CDESE.
      *    MOVE ORD-VSORD TO COM-ORD-VSORD.
      *    MOVE ORD-COMME TO COM-ORD-COMME.
      *    MOVE ORD-CDEP  TO COM-ORD-CDEP.
      *    MOVE ORD-VALUT TO COM-ORD-VALUT.
      *    MOVE ORD-LCONS TO COM-ORD-LCONS.
      *    MOVE ORD-CATT  TO COM-ORD-CATT.

           MOVE KOR-AZI TO OC-AZI.
           MOVE KOR-NUM TO OC-NUM.
           CALL 'vrvopc' USING PAROC.

           IF IF-FLGP = 1 AND OC-FLG = 1    GO TO RDTST.
           IF IF-FLGP = 2 AND OC-FLG = ZERO GO TO RDTST.
      ************
      **** rel 6.0
           IF ORD-DAT < PKDTORD1 OR > PKDTORD2 GO TO RDTST.
           IF ORD-CDEP < IF-DEP-1 OR > IF-DEP-2 GO TO RDTST.
           IF ORD-NOFF < IF-OFF-1 OR > IF-OFF-2 GO TO RDTST.
           IF ORD-CDCLI < IF-CLF-1 OR > IF-CLF-2 GO TO RDTST.
           IF ORD-ZONA < IF-ZONORD-1 OR > IF-ZONORD-2 GO TO RDTST.
           IF ORD-CDAGE < IF-AGEORD-1 OR > IF-AGEORD-2 GO TO RDTST.
           IF ORD-CDPAG < IF-PAGORD-1 OR > IF-PAGORD-2 GO TO RDTST.
           IF ORD-LCONS < IF-CONS-1 OR > IF-CONS-2 GO TO RDTST.

           MOVE KOR-AZI TO KCF-AZI.
           MOVE ORD-CDCLI TO COD.
           MOVE CODCLF TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID
                       MOVE ALL '*' TO CLF-RGSOC
                       MOVE ALL '*' TO CLF-RGSOC2
      **** rel 6.3
      *                MOVE SPACE TO ART-DTECN
      ************
                       MOVE ZERO  TO CLF-SCBS CLF-BANC CLF-CPAG
                                     CLF-VETT CLF-MSPE CLF-PORT
                                     CLF-CATCON.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.

           IF (CLF-AGEN < IF-AGECLI-1 OR > IF-AGECLI-2) GO TO RDTST.
           IF (CLF-ZONA < IF-ZONCLI-1 OR > IF-ZONCLI-2) GO TO RDTST.
           IF (CLF-GRU < IF-GRU-1 OR > IF-GRU-2) GO TO RDTST.
           IF (CLF-GRM < IF-GRM-1 OR > IF-GRM-2) GO TO RDTST.
           IF (CLF-CATCON < IF-CATC-1 OR > IF-CATC-2) GO TO RDTST.

           MOVE ORD-NOFF       TO D-ORD-NOFF.
      ************
      **** rel 6.3
           MOVE ZERO TO FCT-DAT.
           IF ORD-NOFF NOT = ZERO
              MOVE ORD-AZI  TO KFCT-AZI
              MOVE ORD-NOFF TO KFCT-NUM
              READ OFFCLI INTO REKFCT INVALID MOVE ZERO TO FCT-DAT
              END-READ
              IF SF-FCT = '9D' OR '9A' OR '35' MOVE RF-FCT TO REKFCT.
      *
           MOVE COMTP1  TO TIPOP1.
           MOVE FCT-DAT TO AAGGG.
           CALL 'vramg' USING PARCDT.
           MOVE GGMMAA4 TO D-ORD-DTOFF.
      ************
      **** rel 7.1
           MOVE KOR-AZI TO KAOR-AZI.
           MOVE KOR-NUM TO KAOR-NUM.
           READ APPORD INVALID
                MOVE SPACE TO AOR-IPA AOR-CIG AOR-CUP.
                
           MOVE AOR-IPA        TO D-ORD-IPA.
           MOVE AOR-CIG        TO D-ORD-CIG.
           MOVE AOR-CUP        TO D-ORD-CUP.
      ************
           MOVE KOR-AZI TO KRI-AZI.
           MOVE KOR-NUM TO KRI-NUM.
           MOVE ZERO TO KRI-PRG.
           START ORDRIG KEY NOT < KEYRI INVALID GO TO RDTST.
       RDNXT.
           READ ORDRIG NEXT INTO REKRIG AT END  GO TO RDTST.
           IF SF-RIG = '9D' OR '9A' OR '35' MOVE RF-RIG TO REKRIG.
           IF KRI-AZI NOT = KAZ-COD GO TO RDTST.
           IF KRI-NUM NOT = KOR-NUM GO TO RDTST.
      **** rel 6.0
      *
      **** rel 6.1
      *    IF RIG-DTCSR NOT = ZERO
      *        IF RIG-DTCSR < PKDTORD1 OR > PKDTORD2 GO TO RDNXT
      *    ELSE
      *        IF RIG-DTCSC NOT = ZERO
      *           IF RIG-DTCSC < PKDTORD1 OR > PKDTORD2 GO TO RDNXT.
           IF RIG-DTCSC NOT = ZERO
               IF RIG-DTCSC < PKDTCON1 OR > PKDTCON2
                  GO TO RDNXT
               END-IF
           ELSE
               IF RIG-DTCSR NOT = ZERO
                  IF RIG-DTCSR < PKDTCON1 OR > PKDTCON2
                     GO TO RDNXT.
      ************
      *
           IF (IF-TIPO0 NOT = 1) AND (RIG-TPRIG = 0) GO TO RDNXT.
           IF (IF-TIPO1 NOT = 1) AND (RIG-TPRIG = 1) GO TO RDNXT.
           IF (IF-TIPO2 NOT = 1) AND (RIG-TPRIG = 2) GO TO RDNXT.
           IF (IF-TIPO3 NOT = 1) AND (RIG-TPRIG = 3) GO TO RDNXT.
           IF (IF-TIPO4 NOT = 1) AND (RIG-TPRIG = 4) GO TO RDNXT.
           IF (IF-TIPO5 NOT = 1) AND (RIG-TPRIG = 5) GO TO RDNXT.
           IF (IF-TIPO6 NOT = 1) AND (RIG-TPRIG = 6) GO TO RDNXT.
           IF RIG-ARTIC < IF-ART-1 OR > IF-ART-2 GO TO RDNXT.
           IF IF-SALDO NOT = 2
               IF RIG-SALDO NOT = IF-SALDO GO TO RDNXT.
      *
           MOVE KAZ-COD        TO KMA-AZI.
           MOVE RIG-ARTIC      TO KMA-ART.
           READ MAGART INTO REKART INVALID
                       MOVE ZERO TO ART-GMERC ART-GSTAT ART-TPART.
           IF SF-ART = '9D' OR '9A' OR '35' MOVE RF-ART TO REKART.
           IF ART-GMERC < IF-CMERC-1 OR > IF-CMERC-2 GO TO RDNXT.
           IF ART-GSTAT < IF-GSTA-1 OR > IF-GSTA-2 GO TO RDNXT.
           IF ART-TPART < IF-TPART-1 OR > IF-TPART-2 GO TO RDNXT.
      ************
      **** rel 5.2
      *    MOVE COM-ORD-AZI        TO D-ORD-AZI.
      *    MOVE COM-ORD-NUM        TO D-ORD-NUM.
      *    MOVE COM-ORD-DAT        TO D-ORD-DAT.
      *    MOVE COM-ORD-CDCLI      TO D-ORD-CDCLI.
      *    MOVE COM-ORD-ESTER      TO D-ORD-ESTER.
      *    MOVE COM-ORD-ZONA       TO D-ORD-ZONA.
      *    MOVE COM-ORD-CDAGE      TO D-ORD-CDAGE.
      *    MOVE COM-ORD-PROVV      TO D-ORD-PROVV.
      *    MOVE COM-ORD-CDPAG      TO D-ORD-CDPAG.
      *    MOVE COM-ORD-CDBAN      TO D-ORD-CDBAN.
      *    MOVE COM-ORD-CDSPE      TO D-ORD-CDSPE.
      *    MOVE COM-ORD-CDPOR      TO D-ORD-CDPOR.
      *    MOVE COM-ORD-PERSC      TO D-ORD-PERSC.
      *    MOVE COM-ORD-SCONT      TO D-ORD-SCONT.
      *    MOVE COM-ORD-DTCSR      TO D-ORD-DTCSR.
      *    MOVE COM-ORD-DTCSC      TO D-ORD-DTCSC.
      *    MOVE COM-ORD-CDESE      TO D-ORD-CDESE.
      *    MOVE COM-ORD-VSORD      TO D-ORD-VSORD.
      *    MOVE COM-ORD-COMME      TO D-ORD-COMME.
      *    MOVE COM-ORD-CDEP       TO D-ORD-CDEP.
      *    MOVE COM-ORD-VALUT      TO D-ORD-VALUT.
      *    MOVE COM-ORD-LCONS      TO D-ORD-LCONS.
      *    MOVE COM-ORD-CATT       TO D-ORD-CATT.

           MOVE ZERO TO POPC.

           IF OC-FLG = ZERO GO TO NOOPC.

      * ordini a programma
           OPEN INPUT ORDPRC.

           MOVE KRI-AZI TO COP-AZI.
           MOVE KRI-NUM TO COP-NUM.
           MOVE KRI-PRG TO COP-PRG.
           MOVE ID-LAV  TO COP-IDLAV.
           CALL 'vrcalopc' USING PARCOP.

           OPEN INPUT WDSLAV.

           MOVE KRI-AZI TO KOPC-AZI.
           MOVE KRI-NUM TO KOPC-NUM.
           MOVE KRI-PRG TO KOPC-PRG.
           MOVE TPR12-DATC TO OPC-DATA.
           MOVE ZERO    TO KOPC-PROG.
           START ORDPRC KEY NOT < KEYOPC2 INVALID GO TO ENDOPC.
       LOOPOPC.
           READ ORDPRC NEXT AT END GO TO ENDOPC.
           IF SF-OPC = '9D' OR '9A' OR '35' GO TO LOOPOPC.
           IF KOPC-AZI > KRI-AZI GO TO ENDOPC.
           IF KOPC-NUM > KRI-NUM GO TO ENDOPC.
           IF KOPC-PRG > KRI-PRG GO TO ENDOPC.

           ADD 1 TO POPC.

           MOVE ZERO TO QTOPC.
           MOVE KOPC-PROG TO KLV-OPC-PROG.
           MOVE ZERO      TO KLV-BPC-DTBOL.
           MOVE ZERO      TO KLV-BPC-TBOL.
           MOVE ZERO      TO KLV-BPC-NBOL.
           MOVE ZERO      TO KLV-BPC-PBOL.
           MOVE ZERO      TO KLV-BPC-PRG.
           MOVE ZERO      TO KLV-BPC-PROG.
           START WDSLAV KEY NOT < KEYLAV INVALID GO TO ENDLAV.
       LOOPLAV.
           READ WDSLAV NEXT AT END GO TO ENDLAV.
           IF SF-LAV = '9A' OR '9D' OR '35' GO TO LOOPLAV.
           IF KLV-OPC-PROG > KOPC-PROG GO TO ENDLAV.

           ADD LAV-QTA-OPC TO QTOPC.

           GO TO LOOPLAV.
       ENDLAV.

       NOOPC.

           MOVE ZERO TO FLGC.
       LOOP-R.
           MOVE KOR-AZI            TO D-ORD-AZI.
      **** rel 6.3
           MOVE AZRGSOC            TO D-ORD-AZI-D.
      ************
           MOVE KOR-NUM            TO D-ORD-NUM.
      **** rel 6.3
           MOVE ZERO               TO D-ORD-NRORC.
           MOVE KOR-AZI TO KORC-AZI.
           MOVE KOR-NUM TO KORC-ORD.
           READ ORDRIC NOT INVALID MOVE ORC-ORD TO D-ORD-NRORC.
      ************

           MOVE SPACE TO D-ORD-FLGP.
           IF OC-FLG = 1 MOVE 'P' TO D-ORD-FLGP.

           MOVE COMTP1 TO TIPOP1.
           MOVE ORD-DAT   TO AAGGG.
           CALL 'vramg' USING PARCDT.
           MOVE GGMMAA4            TO D-ORD-DAT.
           MOVE ORD-CDCLI          TO D-ORD-CDCLI.
      **** rel 6.2
           MOVE CLF-RGSOC          TO D-ORD-RGSOC.
           MOVE CLF-RGSOC2         TO D-ORD-RGSOC2.
      ************
           MOVE ORD-ESTER          TO D-ORD-ESTER.
           MOVE ORD-ZONA           TO D-ORD-ZONA.
      **** rel 6.3
           MOVE SPACE     TO D-ORD-ZONA-D.
           IF ORD-ZONA NOT = SPACE
              MOVE 17        TO T17-TIP
              MOVE ORD-ZONA  TO T17-COD
              MOVE T17-KEYID TO KEYTB
              READ TABELL INVALID MOVE ALL '*' TO TAB-RST
              END-READ
              MOVE TAB-RST        TO D-ORD-ZONA-D.
      ************
           MOVE ORD-CDAGE          TO D-ORD-CDAGE.
      **** rel 6.3
           MOVE 9              TO KTB-TIP.
           MOVE ORD-CDAGE      TO KTB-COD.
           READ TABELL INVALID MOVE ALL '*' TO TAB-RST.
           MOVE TAB-RST        TO D-ORD-CDAGE-D.
      ************
           MOVE ORD-PROVV          TO D-ORD-PROVV.
           MOVE ORD-CDPAG          TO D-ORD-CDPAG.
      **** rel 6.3
           MOVE 4         TO KTB-TIP.
           MOVE ORD-CDPAG TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE ALL '*' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO D-ORD-CDPAG-D.
      *
           MOVE T04-TIPAG TO D-ORD-TPAG.
      *
           MOVE SPACE TO D-ORD-TPAG-D.
           IF T04-TIPAG = 1 MOVE 'TRATTA'             TO D-ORD-TPAG-D.
           IF T04-TIPAG = 2 MOVE 'RICEVUTA BANCARIA'  TO D-ORD-TPAG-D.
           IF T04-TIPAG = 3 MOVE 'RIMESSA DIRETTA'    TO D-ORD-TPAG-D.
           IF T04-TIPAG = 4 MOVE 'CESSIONE'           TO D-ORD-TPAG-D.
           IF T04-TIPAG = 5 MOVE 'BONIFICO'           TO D-ORD-TPAG-D.
           IF T04-TIPAG = 6 MOVE 'LETTERA DI CREDITO' TO D-ORD-TPAG-D.
           IF T04-TIPAG = 9 MOVE 'AVVENUTO'           TO D-ORD-TPAG-D.
      ************
           MOVE ORD-CDBAN          TO D-ORD-CDBAN.
      **** rel 6.3
           MOVE ORD-CDBAN TO KBA-BAN.
           READ ANABAN INVALID KEY MOVE SPACE TO BAN-RGSOC.
           MOVE BAN-RGSOC          TO D-ORD-CDBAN-D.
           MOVE BAN-CODAZ          TO D-ORD-ABI.
           MOVE BAN-CODSP          TO D-ORD-CAB.
      ************
           MOVE ORD-CDSPE          TO D-ORD-CDSPE.
      **** rel 6.3
           MOVE 6         TO KTB-TIP.
           MOVE ORD-CDSPE TO KTB-COD.
           READ TABELL INVALID MOVE ALL '*' TO TAB-RST.
           MOVE TAB-RST            TO D-ORD-CDSPE-D.
      ************
           MOVE ORD-CDPOR          TO D-ORD-CDPOR.
      **** rel 6.3
           MOVE 5         TO KTB-TIP.
           MOVE ORD-CDPOR TO KTB-COD.
           READ TABELL INVALID MOVE ALL '*' TO TAB-RST.
           MOVE TAB-RST            TO D-ORD-CDPOR-D.
      ************
           MOVE ORD-PERSC          TO D-ORD-PERSC.
           MOVE ORD-SCONT          TO D-ORD-SCONT.
           MOVE COMTP1 TO TIPOP1.
           MOVE ORD-DTCSR TO AAGGG.
           CALL 'vramg' USING PARCDT.
           MOVE GGMMAA4            TO D-ORD-DTCSR.
      **** rel 6.1
           MOVE COMTP1 TO TIPOP1.
      ************
           MOVE ORD-DTCSC TO AAGGG.
           CALL 'vramg' USING PARCDT.
           MOVE GGMMAA4            TO D-ORD-DTCSC.
           MOVE ORD-CDESE          TO D-ORD-CDESE.
      **** rel 6.3
           MOVE 'SOGGETTO AD IVA'  TO D-ORD-CDESE-D.
           IF ORD-CDESE NOT = ZERO
              MOVE 3         TO KTB-TIP
              MOVE ORD-CDESE TO KTB-COD
              READ TABELL INVALID MOVE ALL '*' TO TAB-RST
              END-READ
              MOVE TAB-RST   TO D-ORD-CDESE-D.
      ************
           MOVE ORD-VSORD          TO D-ORD-VSORD.
           MOVE ORD-COMME          TO D-ORD-COMME.
           MOVE ORD-CDEP           TO D-ORD-CDEP.
      **** rel 6.3
           MOVE ORD-CDEP TO KTB-COD.
           MOVE 12       TO KTB-TIP.
           READ TABELL INVALID MOVE ALL '*' TO TAB-RST.
           MOVE TAB-RST            TO D-ORD-CDEP-D.
      ************
           MOVE ORD-VALUT          TO D-ORD-VALUT.
      **** rel 6.3
           MOVE SPACE              TO D-ORD-VALUT-D.
      *
           MOVE 10        TO KTB-TIP.
           MOVE ORD-VALUT TO KTB-COD.
           IF ORD-VALUT = ZERO MOVE COMEURO TO KTB-COD.
           READ TABELL INVALID MOVE ALL '*' TO TAB-RST.
           MOVE TAB-RST            TO D-ORD-VALUT-D.
      ************
           MOVE ORD-LCONS          TO D-ORD-LCONS.
      **** rel 6.3
           MOVE SPACE TO D-ORD-DRAG  D-ORD-DIND D-ORD-DRAG2
                         D-ORD-DIND2 D-ORD-DCIT D-ORD-DEST.
           MOVE ZERO  TO D-ORD-DCAP.
      *
           IF ORD-LCONS = ZERO GO TO NO-IRI.
      *
           MOVE ORD-AZI   TO KII-AZI.
           MOVE CODCLF    TO KII-COD.
           MOVE ORD-LCONS TO KII-PRG.
           READ INDIRI INVALID GO TO NO-IRI.
           IF IRI-TIPO = 'L' MOVE CLF-RGSOC  TO D-ORD-DRAG
                             MOVE CLF-INDIR  TO D-ORD-DIND
                             MOVE CLF-RGSOC2 TO D-ORD-DRAG2
                             MOVE CLF-INDIR2 TO D-ORD-DIND2
                             MOVE CLF-CITTA  TO D-ORD-DCIT
                             MOVE CLF-CAP    TO D-ORD-DCAP
                         ELSE
                             MOVE IRI-RGSOC  TO D-ORD-DRAG
                             MOVE IRI-INDIR  TO D-ORD-DIND
                             MOVE IRI-RGSOC2 TO D-ORD-DRAG2
                             MOVE IRI-INDIR2 TO D-ORD-DIND2
                             MOVE IRI-CAP    TO D-ORD-DCAP
                             MOVE IRI-CITTA  TO D-ORD-DCIT.
           MOVE IRI-DESDI TO D-ORD-DEST.
       NO-IRI.
      ************
           MOVE ORD-CATT           TO D-ORD-CATT.
      ************
      **** rel 6.3
           IF ORD-CATT = ZERO OR SPACE
              MOVE "ATTIVITA' PRINCIPALE" TO D-ORD-CATT-D
           ELSE
              MOVE 35        TO T35-TIP
              MOVE KAZ-COD   TO T35-CDAZ
              MOVE ORD-CATT  TO T35-CATT
              MOVE T35-KEYID TO KEYTB
              READ TABELL INVALID MOVE ALL '*' TO TAB-RST
              END-READ
              MOVE TAB-RST   TO D-ORD-CATT-D.
      ************
      **** rel 6.3
      *    MOVE ZERO               TO D-ORD-LISRF.
           MOVE ORD-LISRF          TO D-ORD-LISRF.
           MOVE SPACE              TO D-ORD-LISRF-D.
           IF ORD-LISRF > 3
              MOVE ORD-LISRF   TO KTB-COD
              MOVE 52          TO KTB-TIP
              READ TABELL INVALID MOVE ALL '*' TO TAB-RST
              END-READ
              MOVE TAB-RST     TO D-ORD-LISRF-D.
      ************
      *
      * Istruzioni generate da file '../dsc/ordcli.dsc'
      *
           MOVE KRI-PRG        TO D-ORD-PRG.
           MOVE RIG-TPRIG      TO D-ORD-TPRIG.
      **** rel 6.3
           MOVE 'ARTICOLO'     TO D-ORD-TPRIG-D.
           IF RIG-TPRIG = 1 
              MOVE 'DESCRITTIVO'           TO D-ORD-TPRIG-D.
           IF RIG-TPRIG = 2 
              MOVE 'OCCASIONALE'           TO D-ORD-TPRIG-D.
           IF RIG-TPRIG = 3 
              MOVE 'VOCE SPESA'            TO D-ORD-TPRIG-D.
           IF RIG-TPRIG = 4 
              MOVE 'CESSIONE GRATUITA'     TO D-ORD-TPRIG-D.
           IF RIG-TPRIG = 5 
              MOVE 'SCONTO IN MERCE'       TO D-ORD-TPRIG-D.
           IF RIG-TPRIG = 6 
              MOVE 'SOSTITUZ. IN GARANZIA' TO D-ORD-TPRIG-D.
      ************
           MOVE RIG-ARTIC      TO D-ORD-ARTIC.
      **** rel 6.0
      *    MOVE KAZ-COD        TO KMA-AZI.
      *    MOVE RIG-ARTIC      TO KMA-ART.
      *    READ MAGART INTO REKART INVALID
      *                MOVE ZERO TO ART-GMERC ART-GSTAT ART-TPART.
      *    IF SF-ART = '9D' OR '9A' OR '35' MOVE RF-ART TO REKART.
      ************
           MOVE ART-GMERC      TO D-ORD-GMERC.
      **** rel 6.3
           MOVE 32             TO KTB-TIP.
           MOVE ART-GMERC      TO KTB-COD.
           READ TABELL INVALID MOVE ALL '*' TO TAB-RST.
           MOVE TAB-RST        TO D-ORD-GMERC-D.
      ************
           MOVE ART-GSTAT      TO D-ORD-GSTAT.
      **** rel 6.3
           MOVE 13             TO KTB-TIP.
           MOVE ART-GSTAT      TO KTB-COD.
           READ TABELL INVALID MOVE ALL '*' TO TAB-RST.
           MOVE TAB-RST        TO D-ORD-GSTAT-D.
      ************
           MOVE ART-TPART      TO D-ORD-TPART.
      **** rel 6.3
           MOVE 38             TO KTB-TIP.
           MOVE ART-TPART      TO KTB-COD.
           READ TABELL INVALID MOVE ALL '*' TO TAB-RST.
           MOVE TAB-RST        TO D-ORD-TPART-D.
      ************
           MOVE RIG-LOTTO      TO D-ORD-LOTTO.
           MOVE RIG-QUANT      TO D-ORD-QUANT.
           MOVE COMTP1 TO TIPOP1.
           MOVE RIG-DTCSR      TO AAGGG.
           CALL 'vramg' USING PARCDT.
           MOVE GGMMAA4         TO D-ORD-DTRSR.
      **** rel 6.1
           MOVE COMTP1 TO TIPOP1.
      ************
           MOVE RIG-DTCSC TO AAGGG.
           CALL 'vramg' USING PARCDT.
           MOVE GGMMAA4         TO D-ORD-DTRSC.
           MOVE RIG-UNMIS      TO D-ORD-UNMIS.

           IF RIG-TPRIG = 3
              MOVE RIG-PREZZ TO D-ORD-PREZZ
                                D-ORD-PREZFSC
           ELSE
              MOVE RIG-PREZZ      TO D-ORD-PREZZ
              MOVE RIG-FSC        TO DP-FSC
              MOVE RIG-PREZZ      TO DP-PREZZO
              CALL 'rforprz' USING DP-PREZZO DP-FSC UNI-FSC
              MOVE DP-PREZZO      TO D-ORD-PREZFSC.

           MOVE RIG-FSC        TO D-ORD-FSC.
      **** rel 6.0a
           MOVE RIG-FPNET      TO D-ORD-FPNET.
      *************
           MOVE RIG-1SCON      TO D-ORD-1SCON.
           MOVE RIG-2SCON      TO D-ORD-2SCON.
           IF RIG-TPRIG > 10   MOVE RIG-TPRIG TO D-ORD-SPESA
                               MOVE RIG-PROVV TO D-ORD-PERSPE
                               MOVE ZERO TO RIG-PROVV
                               ELSE
                               MOVE ZERO TO D-ORD-SPESA
                                            D-ORD-PERSPE.
           MOVE RIG-PROVV      TO D-ORD-RPROVV.
           MOVE RIG-CDIVA      TO D-ORD-CDIVA.
      **** rel 6.3
           MOVE 3              TO KTB-TIP.
           MOVE RIG-CDIVA      TO KTB-COD.
           READ TABELL INVALID MOVE ALL '*' TO TAB-RST.
           MOVE TAB-RST        TO D-ORD-CDIVA-D.
      ************
           MOVE RIG-DESAR      TO D-ORD-DESAR.
           MOVE RIG-QSPED      TO D-ORD-QSPED.
      **** rel 5.2
           MOVE ZERO           TO D-ORD-QRES.
           IF RIG-SALDO = ZERO AND RIG-QUANT > RIG-QSPED
              COMPUTE RESID = RIG-QUANT - RIG-QSPED
              MOVE RESID TO D-ORD-QRES.

           MOVE SPACE          TO D-ORD-DDATA.
           MOVE POPC           TO D-ORD-POPC.
           MOVE ZERO           TO D-ORD-QTPRE.

           IF OC-FLG = 1
              MOVE OPC-QTAPR      TO D-ORD-QTPRE
              MOVE OPC-QTACF      TO D-ORD-QUANT
              MOVE QTOPC          TO D-ORD-QSPED

              COMPUTE RESID = OPC-QTACF - QTOPC
              MOVE RESID          TO D-ORD-QRES

              MOVE COMTP1 TO TIPOP1
              MOVE OPC-DATA       TO AAGGG
              CALL 'vramg' USING PARCDT
              MOVE GGMMAA4         TO D-ORD-DTRSR D-ORD-DTRSC

              MOVE OPC-TIPO TO PDOP-TIPO
              MOVE OPC-DATA TO PDOP-DATA
              CALL 'vrdopr' USING PAR-PDOP
              MOVE PDOP-DDAT       TO D-ORD-DDATA.

      ************

      **** rel 6.2
           MOVE "V"        TO IM-TIPO.
      *
           MOVE RIG-FSC    TO DP-FSC.
           MOVE RIG-PREZZ  TO DP-PREZZO.
           CALL 'rforprz'  USING DP-PREZZO DP-FSC FSC-UNI.
           MOVE DP-PREZZO  TO IM-PZLOR.
      *
           MOVE RIG-QUANT  TO IM-QTA.
           MOVE ORD-PERSC  TO IM-SCBAS.
           MOVE RIG-1SCON  TO IM-SC1.
           MOVE RIG-2SCON  TO IM-SC2.
           MOVE ORD-VALUT  TO IM-VALUT.
           MOVE RIG-TPRIG  TO IM-TCOR.
           MOVE RIG-TQUAN  TO IM-TQUAN.
           MOVE RIG-FSC    TO IM-FSC.
           MOVE RIG-FPNET  TO IM-FPNET.
           CALL 'vrimpor' USING PARIM.
      *
           MOVE IM-NETRG   TO D-ORD-NETRIG.
      ************
      **** rel 6.3
           IF RIG-TPRIG = 3
              MOVE IM-PZNET TO D-ORD-PREZN
                               D-ORD-PRENFSC
           ELSE
              MOVE IM-PZNET      TO D-ORD-PREZN
              MOVE RIG-FSC       TO DP-FSC
              MOVE IM-PZNET      TO DP-PREZZO
              CALL 'rforprz' USING DP-PREZZO DP-FSC UNI-FSC
              MOVE DP-PREZZO      TO D-ORD-PRENFSC.
      *
           MOVE "V"       TO IM-TIPO.
           MOVE RIG-PREZZ TO IM-PZLOR.
           MOVE RESID     TO IM-QTA.
           MOVE ORD-PERSC TO IM-SCBAS.
           MOVE RIG-1SCON TO IM-SC1.
           MOVE RIG-2SCON TO IM-SC2.
           MOVE ORD-VALUT TO IM-VALUT.
           MOVE RIG-TPRIG TO IM-TCOR.
           MOVE RIG-TQUAN TO IM-TQUAN.
           MOVE RIG-FSC   TO IM-FSC.
           MOVE RIG-FPNET TO IM-FPNET.
           CALL 'vrimpor' USING PARIM.
           MOVE IM-NETRG TO D-ORD-NETRES.
      ************

           MOVE RIG-IPROV      TO D-ORD-IPROV.
           MOVE RIG-SALDO      TO D-ORD-SALDO.
      **** rel 6.3
           IF RIG-SALDO = ZERO MOVE 'IN CONTO' TO D-ORD-SALDO-D
           ELSE                MOVE 'SALDATO'  TO D-ORD-SALDO-D.
      ************

           MOVE RIG-RIVAL      TO D-ORD-RIVAL.
           MOVE RIG-RIVGR      TO D-ORD-RIVGR.
           MOVE RIG-CDSPE      TO D-ORD-CDSPE1.
           MOVE RIG-CONTR      TO D-ORD-CONTR.
      **** rel 6.3
           MOVE SPACE TO D-ORD-CONTR-D.
           IF RIG-CONTR NOT = ZERO
              MOVE KAZ-COD   TO KPC-AZI
              MOVE RIG-CONTR TO KPC-COD
              READ ANACON INVALID MOVE ALL '*' TO CON-DSC
              END-READ
              MOVE CON-DSC     TO D-ORD-CONTR-D.
      ************
      **** rel 5.2
           MOVE ZERO           TO D-ORD-PRGC.
           MOVE ZERO           TO D-ORD-BNUM.
           MOVE ZERO           TO D-ORD-BBOL.
           MOVE ZERO           TO D-ORD-DTBOL.
           MOVE ZERO           TO D-ORD-QBOL.
           MOVE ZERO           TO D-ORD-GGLEAD.
           MOVE ZERO           TO D-ORD-GGRIT.
           IF IF-FLGC NOT = ZERO
              PERFORM CAL-DTC THRU EX-CAL-DTC
              IF FLGC = 9 GO TO END-R.
      ************
           MOVE 'X'            TO D-ORD-TAPPO.
           ADD 1 TO IF-CONT.
           CALL 'vrexpo' USING PARXP RIGXP.
           IF XP-ST > ZERO
                 MOVE SPACE TO MESS
                 STRING 'vrexpo: status ' XP-ST DELIMITED SIZE INTO MESS
                 GO TO ERRIO.
      * --- fine istruzioni generate da '../dsc/ordcli.dsc'
      **** rel 5.2
           IF FLGC = 1 GO TO LOOP-R.
       END-R.

           IF OC-FLG = ZERO GO TO NOOPC-9.

           GO TO LOOPOPC.
       ENDOPC.
           CLOSE WDSLAV.
           CLOSE ORDPRC.
       NOOPC-9.
      ************
           GO TO RDNXT.
       FINE-EXP.
           MOVE 9 TO XP-FUN.
           CALL 'vrexpo' USING PARXP RIGXP.
      **** rel 6.2
           IF P-BAT NOT = SPACE
              DISPLAY P-BAT UPON COMMAND-LINE
              CALL 'grcmd'.
      ************
       EX-RUN-ELABORA.
           EXIT.
      *------------------
      **** rel 5.2
      * calcolo dettaglio consegne
       CAL-DTC.
           IF OC-FLG = 1 GO TO LORP.

           IF FLGC = 1 GO TO LOOPOBC.

           OPEN INPUT BOLORD.
           OPEN INPUT BOLCTE.

           MOVE ZERO TO PRGC.

           MOVE KRI-AZI TO OBC-AZI.
           MOVE KRI-NUM TO OBC-NORD.
           MOVE KRI-PRG TO OBC-RGOR.
           MOVE ZERO    TO OBC-ANNO.
           MOVE ZERO    TO OBC-NUM.
           MOVE ZERO    TO OBC-BOL.
           START BOLORD KEY NOT < KEYBO2 INVALID GO TO ENDOBC.
       LOOPOBC.
           READ BOLORD NEXT AT END GO TO ENDOBC.
           IF SF-OBC = '9A' OR '9D' OR '35' GO TO LOOPOBC.
           IF OBC-AZI  > KRI-AZI GO TO ENDOBC.
           IF OBC-NORD > KRI-NUM GO TO ENDOBC.
           IF OBC-RGOR > KRI-PRG GO TO ENDOBC.

           MOVE 1 TO FLGC.

           ADD 1 TO PRGC.
           MOVE PRGC      TO D-ORD-PRGC.

           MOVE ORD-DAT  TO DAT1.
           MOVE ZERO     TO DAT2.

           MOVE OBC-AZI TO KBC-AZI.
           MOVE OBC-NUM TO KBC-NUM.
           MOVE OBC-BOL TO KBC-BOL.
           READ BOLCTE INVALID MOVE ZERO TO BCT-DATA.
           MOVE BCT-DATA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF AA4 = OBC-ANNO
              MOVE BCT-DATA TO DAT2
           ELSE
              IF OBC-DATA NOT = ZERO
                 MOVE OBC-DATA TO DAT2.

           IF DAT2 NOT = ZERO
              MOVE DAT2 TO AAGGG
              MOVE COMTP1 TO TIPOP1
      **** rel 6.1
      *       MOVE GGMMAA4 TO D-ORD-DTBOL.
      ************
              CALL 'vramg' USING PARCDT
              MOVE GGMMAA4 TO D-ORD-DTBOL.
           MOVE OBC-NUM TO D-ORD-BNUM.
           MOVE OBC-BOL TO D-ORD-BBOL.

           MOVE OBC-QUANT TO D-ORD-QBOL.

           MOVE ZERO TO GGDIF.
           IF DAT2 NOT = ZERO AND DAT1 NOT = ZERO
              COMPUTE GGDIF = DAT2 - DAT1.
           MOVE GGDIF      TO D-ORD-GGLEAD.

           MOVE ZERO TO GGDIF.
           MOVE RIG-DTCSC TO DAT1.
           IF DAT1 = ZERO
              MOVE RIG-DTCSR TO DAT1.

           MOVE ZERO TO GGDIF.
           IF DAT2 NOT = ZERO AND DAT1 NOT = ZERO
              COMPUTE GGDIF = DAT2 - DAT1.
           MOVE GGDIF      TO D-ORD-GGRIT.


           GO TO EX-CAL-DTC.
       ENDOBC.
           CLOSE BOLORD.
           CLOSE BOLCTE.

           IF FLGC NOT = ZERO MOVE 9 TO FLGC.

           GO TO EX-CAL-DTC.
      * ordini a programma
       LORP.
           IF FLGC = 1 GO TO LOOPLAV1.

           MOVE ZERO TO PRGC.

           MOVE KOPC-PROG TO KLV-OPC-PROG.
           MOVE ZERO      TO KLV-BPC-DTBOL.
           MOVE ZERO      TO KLV-BPC-TBOL.
           MOVE ZERO      TO KLV-BPC-NBOL.
           MOVE ZERO      TO KLV-BPC-PBOL.
           MOVE ZERO      TO KLV-BPC-PRG.
           MOVE ZERO      TO KLV-BPC-PROG.
           START WDSLAV KEY NOT < KEYLAV INVALID GO TO ENDLAV1.
       LOOPLAV1.
           READ WDSLAV NEXT AT END GO TO ENDLAV1.
           IF SF-LAV = '9A' OR '9D' OR '35' GO TO LOOPLAV1.
           IF KLV-OPC-PROG > KOPC-PROG GO TO ENDLAV1.

           MOVE 1 TO FLGC.

           ADD 1 TO PRGC.
           MOVE PRGC         TO D-ORD-PRGC.

           MOVE KLV-BPC-DTBOL TO AAGGG DAT2.
           MOVE COMTP1 TO TIPOP1.
           CALL 'vramg' USING PARCDT.
           MOVE GGMMAA4      TO D-ORD-DTBOL.
           MOVE KLV-BPC-TBOL TO D-ORD-BNUM.
           MOVE KLV-BPC-NBOL TO D-ORD-BBOL.
           MOVE LAV-QTA-OPC  TO D-ORD-QBOL.

           MOVE ZERO         TO D-ORD-GGLEAD.

           MOVE OPC-DATA TO DAT1.

           MOVE ZERO TO GGDIF.
           IF DAT2 NOT = ZERO AND DAT1 NOT = ZERO
              COMPUTE GGDIF = DAT2 - DAT1.
           MOVE GGDIF        TO D-ORD-GGRIT.


           GO TO EX-CAL-DTC.
       ENDLAV1.

           IF FLGC NOT = ZERO MOVE 9 TO FLGC.

       EX-CAL-DTC.
           EXIT.
      *------------------
      * ID-LAV: deve essere identico a quello dichiarato
      *         nella routine vrcalopc
       CREA-IDLAV.
           MOVE SPACE TO ID-LAV.
           STRING 'w7' PID DELIMITED SPACE INTO ID-LAV.
       EX-CREA-IDLAV.
           EXIT.
      *------------------
      ************
      **** rel 6.2
       CDEF.
           MOVE 1 TO XP-FUN.
           MOVE SPACE TO P-NOME.
           UNSTRING EX-CMD-LINE DELIMITED SPACE INTO P-NOME.
           CALL 'vrcdef' USING PARPDEF PARXP.
      *
           IF R1(1) NOT = LOW-VALUE MOVE R1(1)(1:5) TO IF-COD-1.
           IF R2(1) NOT = LOW-VALUE MOVE R2(1)(1:5) TO IF-COD-2.
      *
           IF R1(2) NOT = LOW-VALUE MOVE R1(2)(1:6) TO IF-DTORD-1.
           IF R2(2) NOT = LOW-VALUE MOVE R2(2)(1:6) TO IF-DTORD-2.
      *
           IF R1(3) NOT = LOW-VALUE MOVE R1(3)(1:2) TO IF-DEP-1.
           IF R2(3) NOT = LOW-VALUE MOVE R2(3)(1:2) TO IF-DEP-2.
      *
           IF R1(4) NOT = LOW-VALUE MOVE R1(4)(1:5) TO IF-OFF-1.
           IF R2(4) NOT = LOW-VALUE MOVE R2(4)(1:5) TO IF-OFF-2.
      *
           IF R1(5) NOT = LOW-VALUE MOVE R1(5)(1:5) TO IF-CLF-1.
           IF R2(5) NOT = LOW-VALUE MOVE R2(5)(1:5) TO IF-CLF-2.
      *
           IF R1(6) NOT = LOW-VALUE MOVE R1(6)(1:3) TO IF-ZONORD-1.
           IF R2(6) NOT = LOW-VALUE MOVE R2(6)(1:3) TO IF-ZONORD-2.
      *
           IF R1(7) NOT = LOW-VALUE MOVE R1(7)(1:3) TO IF-AGEORD-1.
           IF R2(7) NOT = LOW-VALUE MOVE R2(7)(1:3) TO IF-AGEORD-2.
      *
           IF R1(8) NOT = LOW-VALUE MOVE R1(8)(1:3) TO IF-PAGORD-1.
      **** rel 7.1
      *    IF R1(8) NOT = LOW-VALUE MOVE R1(8)(1:3) TO IF-PAGORD-2.
           IF R2(8) NOT = LOW-VALUE MOVE R2(8)(1:3) TO IF-PAGORD-2.
      ************
      *
           IF R1(9) NOT = LOW-VALUE MOVE R1(9)(1:2) TO IF-CONS-1.
      **** rel 7.1
      *    IF R1(9) NOT = LOW-VALUE MOVE R1(9)(1:2) TO IF-CONS-2.
           IF R2(9) NOT = LOW-VALUE MOVE R2(9)(1:2) TO IF-CONS-2.
      ************
      *           
           IF R1(10) NOT = LOW-VALUE MOVE R1(10)(1:6) TO IF-DTCON-1.
           IF R2(10) NOT = LOW-VALUE MOVE R2(10)(1:6) TO IF-DTCON-2.
      *
           IF R1(11) NOT = LOW-VALUE MOVE R1(11)(1:1) TO IF-TIPO0.
      *
           IF R1(12) NOT = LOW-VALUE MOVE R1(12)(1:1) TO IF-TIPO1.
      *
           IF R1(13) NOT = LOW-VALUE MOVE R1(13)(1:1) TO IF-TIPO2.
      *
           IF R1(14) NOT = LOW-VALUE MOVE R1(14)(1:1) TO IF-TIPO3.
      *
           IF R1(15) NOT = LOW-VALUE MOVE R1(15)(1:1) TO IF-TIPO4.
      *
           IF R1(16) NOT = LOW-VALUE MOVE R1(16)(1:1) TO IF-TIPO5.
      *
           IF R1(17) NOT = LOW-VALUE MOVE R1(17)(1:1) TO IF-TIPO6.
      *
           IF R1(18) NOT = LOW-VALUE MOVE R1(18)(1:18) TO IF-ART-1.
           IF R2(18) NOT = LOW-VALUE MOVE R2(18)(1:18) TO IF-ART-2.
      *
           IF R1(19) NOT = LOW-VALUE MOVE R1(19)(1:2) TO IF-CMERC-1.
           IF R2(19) NOT = LOW-VALUE MOVE R2(19)(1:2) TO IF-CMERC-2.
      *
           IF R1(20) NOT = LOW-VALUE MOVE R1(20)(1:2) TO IF-GSTA-1.
           IF R2(20) NOT = LOW-VALUE MOVE R2(20)(1:2) TO IF-GSTA-2.
      *
           IF R1(21) NOT = LOW-VALUE MOVE R1(21)(1:1) TO IF-TPART-1.
           IF R2(21) NOT = LOW-VALUE MOVE R2(21)(1:1) TO IF-TPART-2.
      *
           IF R1(22) NOT = LOW-VALUE MOVE R1(22)(1:3) TO IF-AGECLI-1.
           IF R2(22) NOT = LOW-VALUE MOVE R2(22)(1:3) TO IF-AGECLI-2.
      *
           IF R1(23) NOT = LOW-VALUE MOVE R1(23)(1:3) TO IF-ZONCLI-1.
           IF R2(23) NOT = LOW-VALUE MOVE R2(23)(1:3) TO IF-ZONCLI-2.
      *
           IF R1(24) NOT = LOW-VALUE MOVE R1(24)(1:3) TO IF-GRU-1.
           IF R2(24) NOT = LOW-VALUE MOVE R2(24)(1:3) TO IF-GRU-2.
      *
           IF R1(25) NOT = LOW-VALUE MOVE R1(25)(1:1) TO IF-GRM-1.
           IF R2(25) NOT = LOW-VALUE MOVE R2(25)(1:1) TO IF-GRM-2.
      *
           IF R1(26) NOT = LOW-VALUE MOVE R1(26)(1:1) TO IF-CATC-1.
           IF R2(26) NOT = LOW-VALUE MOVE R2(26)(1:1) TO IF-CATC-2.
      *
           IF R1(27) NOT = LOW-VALUE MOVE R1(27)(1:1) TO IF-SALDO.
      *
           IF R1(28) NOT = LOW-VALUE MOVE R1(28)(1:1) TO IF-FLGP.
      *
           IF R1(29) NOT = LOW-VALUE MOVE R1(29)(1:1) TO IF-FLGC.
      *
       EX-CDEF.
           EXIT.
      *------------------
      ************
