#
# Fatture
#
# Programma: exp660
#
DSC  fattur
FLD  D-FAT-AZI       3.0   NU  S  # Codice azienda
FLD  D-FAT-AZI-D     36    AN  S  # Ragione sociale azienda
FLD  D-FAT-TDOC      1.0   NU  S  # Tipo documento (1/2/3/4/6)
#                                 # 1 = fattura normale
#                                 # 2 = fattura estero
#                                 # 3 = nota accredito 
#                                 # 4 = fattura in sospeso
#                                 # 6 = accredito sospeso 
FLD  D-FAT-TDOC-D    20    AN  S  # Descrizione tipo documento
FLD  D-FAT-NUM       5.0   NU  S  # Numero fattura
FLD  D-FAT-DATA      8     AN  S  # Data fattura 
FLD  D-FAT-STATU     1.0   NU  S  # Stato fattura (0/1)
#                                 # 0 = non contabilizzata
#                                 # 1 = contabilizzata 
FLD  D-FAT-STATU-D   20    AN  S  # Descrizione stato fattura
FLD  D-FAT-CDCLI     5.0   NU  S  # Codice cliente
FLD  D-FAT-RGSOC     36    AN  S  # Ragione sociale cliente
FLD  D-FAT-RGSOC2    36    AN  S  # 2^ Ragione sociale cliente
FLD  D-FAT-CDPAG     3.0   NU  S  # Codice pagamento
FLD  D-FAT-DPAG      24    AN  S  # Descrizione pagamento
FLD  D-FAT-CDBAN     5.0   NU  S  # Codice banca
FLD  D-FAT-CDBAN-D   36    AN  S  # Descrizione banca
FLD  D-FAT-TIPAG     1.0   NU  S  # Tipo pagamento
FLD  D-FAT-TIPAG-D   18    AN  S  # Descrizione tipo pagamento
FLD  D-FAT-DTPAG     8     AN  S  # Data pagamento
FLD  D-FAT-CDESE     3.0   NU  S  # Codice esenzione IVA
FLD  D-FAT-CDESE-D   24    AN  S  # Descrizione esenzione IVA
FLD  D-FAT-CDAGE     3.0   NU  S  # Codice agente
FLD  D-FAT-CDAGE-D   24    AN  S  # Descrizione agente
FLD  D-BLT-IPA       6     AN  S  # Codice IPA
FLD  D-BLT-CIG       10    AN  S  # Codice CIG
FLD  D-BLT-CUP       15    AN  S  # Codice CUP
FLD  D-BLT-TIPO      20    AN  S  # Tipo fattura
FLD  D-FAT-SCBAS     5.2   NU  S  # Sconto base
FLD  D-FAT-NTMER     15.2  NS  S  # Netto merce      
FLD  D-FAT-IVRIV     15.2  NS  S  # Importo IVA non addebitato per rivalsa
FLD  D-FAT-SPBOL     15.2  NS  S  # Spese bollo
FLD  D-FAT-SPBAN     15.2  NS  S  # Spese banca
FLD  D-FAT-SCFIN     15.2  NS  S  # Sconto di chiusura
FLD  D-FAT-OMAGG     15.2  NS  S  # Importo cess. gratuite
FLD  D-FAT-SCONT     15.2  NS  S  # Importo sconto in merce
FLD  D-FAT-TOTFT     15.2  NS  S  # Totale fattura
FLD  D-FAT-CDIVA01   3.0   NU  S  # Codice IVA  01
FLD  D-FAT-CDIVA01-D 24    AN  S  # Descrizione IVA 01
FLD  D-FAT-IMPON01   15.2  NS  S  # Imponibile  01
FLD  D-FAT-IMPOS01   15.2  NS  S  # Imposta     01
FLD  D-FAT-CDIVA02   3.0   NU  S  # Codice IVA  02
FLD  D-FAT-CDIVA02-D 24    AN  S  # Descrizione IVA 02
FLD  D-FAT-IMPON02   15.2  NS  S  # Imponibile  02
FLD  D-FAT-IMPOS02   15.2  NS  S  # Imposta     02
FLD  D-FAT-CDIVA03   3.0   NU  S  # Codice IVA  03
FLD  D-FAT-CDIVA03-D 24    AN  S  # Descrizione IVA 03
FLD  D-FAT-IMPON03   15.2  NS  S  # Imponibile  03
FLD  D-FAT-IMPOS03   15.2  NS  S  # Imposta     03
FLD  D-FAT-CDIVA04   3.0   NU  S  # Codice IVA  04
FLD  D-FAT-CDIVA04-D 24    AN  S  # Descrizione IVA 04
FLD  D-FAT-IMPON04   15.2  NS  S  # Imponibile  04
FLD  D-FAT-IMPOS04   15.2  NS  S  # Imposta     04
FLD  D-FAT-CDIVA05   3.0   NU  S  # Codice IVA  05
FLD  D-FAT-CDIVA05-D 24    AN  S  # Descrizione IVA 05
FLD  D-FAT-IMPON05   15.2  NS  S  # Imponibile  05
FLD  D-FAT-IMPOS05   15.2  NS  S  # Imposta     05
FLD  D-FAT-CDIVA06   3.0   NU  S  # Codice IVA  06
FLD  D-FAT-CDIVA06-D 24    AN  S  # Descrizione IVA 06
FLD  D-FAT-IMPON06   15.2  NS  S  # Imponibile  06
FLD  D-FAT-IMPOS06   15.2  NS  S  # Imposta     06
FLD  D-FAT-DTSCA01   8     AN  S  # Data scadenza   01
FLD  D-FAT-IMPOR01   15.2  NS  S  # Importo effetto 01
FLD  D-FAT-DTSCA02   8     AN  S  # Data scadenza   02
FLD  D-FAT-IMPOR02   15.2  NS  S  # Importo effetto 02
FLD  D-FAT-DTSCA03   8     AN  S  # Data scadenza   03
FLD  D-FAT-IMPOR03   15.2  NS  S  # Importo effetto 03
FLD  D-FAT-DTSCA04   8     AN  S  # Data scadenza   04
FLD  D-FAT-IMPOR04   15.2  NS  S  # Importo effetto 04
FLD  D-FAT-DTSCA05   8     AN  S  # Data scadenza   05
FLD  D-FAT-IMPOR05   15.2  NS  S  # Importo effetto 05
FLD  D-FAT-DTSCA06   8     AN  S  # Data scadenza   06
FLD  D-FAT-IMPOR06   15.2  NS  S  # Importo effetto 06
FLD  D-FAT-DTSCA07   8     AN  S  # Data scadenza   07
FLD  D-FAT-IMPOR07   15.2  NS  S  # Importo effetto 07
FLD  D-FAT-DTSCA08   8     AN  S  # Data scadenza   08
FLD  D-FAT-IMPOR08   15.2  NS  S  # Importo effetto 08
FLD  D-FAT-DTSCA09   8     AN  S  # Data scadenza   09
FLD  D-FAT-IMPOR09   15.2  NS  S  # Importo effetto 09
FLD  D-FAT-DTSCA10   8     AN  S  # Data scadenza   10
FLD  D-FAT-IMPOR10   15.2  NS  S  # Importo effetto 10
FLD  D-FAT-DTSCA11   8     AN  S  # Data scadenza   11
FLD  D-FAT-IMPOR11   15.2  NS  S  # Importo effetto 11
FLD  D-FAT-DTSCA12   8     AN  S  # Data scadenza   12
FLD  D-FAT-IMPOR12   15.2  NS  S  # Importo effetto 12
FLD  D-FAT-CPART01   7.0   NU  S  # Codice contropartita  01
FLD  D-FAT-CPART01-D 36    AN  S  # Descrizione controp.  01
FLD  D-FAT-IMPCP01   15.2  NS  S  # Importo contropartita 01
FLD  D-FAT-CPART02   7.0   NU  S  # Codice contropartita  02
FLD  D-FAT-CPART02-D 36    AN  S  # Descrizione controp.  02
FLD  D-FAT-IMPCP02   15.2  NS  S  # Importo contropartita 02
FLD  D-FAT-CPART03   7.0   NU  S  # Codice contropartita  03
FLD  D-FAT-CPART03-D 36    AN  S  # Descrizione controp.  03
FLD  D-FAT-IMPCP03   15.2  NS  S  # Importo contropartita 03
FLD  D-FAT-CPART04   7.0   NU  S  # Codice contropartita  04
FLD  D-FAT-CPART04-D 36    AN  S  # Descrizione controp.  04
FLD  D-FAT-IMPCP04   15.2  NS  S  # Importo contropartita 04
FLD  D-FAT-CPART05   7.0   NU  S  # Codice contropartita  05
FLD  D-FAT-CPART05-D 36    AN  S  # Descrizione controp.  05
FLD  D-FAT-IMPCP05   15.2  NS  S  # Importo contropartita 05
FLD  D-FAT-CPART06   7.0   NU  S  # Codice contropartita  06
FLD  D-FAT-CPART06-D 36    AN  S  # Descrizione controp.  06
FLD  D-FAT-IMPCP06   15.2  NS  S  # Importo contropartita 06
FLD  D-FAT-CPART07   7.0   NU  S  # Codice contropartita  07
FLD  D-FAT-CPART07-D 36    AN  S  # Descrizione controp.  07
FLD  D-FAT-IMPCP07   15.2  NS  S  # Importo contropartita 07
FLD  D-FAT-CPART08   7.0   NU  S  # Codice contropartita  08
FLD  D-FAT-CPART08-D 36    AN  S  # Descrizione controp.  08
FLD  D-FAT-IMPCP08   15.2  NS  S  # Importo contropartita 08
FLD  D-FAT-CPART09   7.0   NU  S  # Codice contropartita  09
FLD  D-FAT-CPART09-D 36    AN  S  # Descrizione controp.  09
FLD  D-FAT-IMPCP09   15.2  NS  S  # Importo contropartita 09
FLD  D-FAT-CPART10   7.0   NU  S  # Codice contropartita  10
FLD  D-FAT-CPART10-D 36    AN  S  # Descrizione controp.  10
FLD  D-FAT-IMPCP10   15.2  NS  S  # Importo contropartita 10
FLD  D-FAT-CPART11   7.0   NU  S  # Codice contropartita  11
FLD  D-FAT-CPART11-D 36    AN  S  # Descrizione controp.  11
FLD  D-FAT-IMPCP11   15.2  NS  S  # Importo contropartita 11
FLD  D-FAT-CPART12   7.0   NU  S  # Codice contropartita  12
FLD  D-FAT-CPART12-D 36    AN  S  # Descrizione controp.  12
FLD  D-FAT-IMPCP12   15.2  NS  S  # Importo contropartita 12
FLD  D-FAT-CPART13   7.0   NU  S  # Codice contropartita  13
FLD  D-FAT-CPART13-D 36    AN  S  # Descrizione controp.  13
FLD  D-FAT-IMPCP13   15.2  NS  S  # Importo contropartita 13
FLD  D-FAT-CPART14   7.0   NU  S  # Codice contropartita  14
FLD  D-FAT-CPART14-D 36    AN  S  # Descrizione controp.  14
FLD  D-FAT-IMPCP14   15.2  NS  S  # Importo contropartita 14
FLD  D-FAT-CPART15   7.0   NU  S  # Codice contropartita  15
FLD  D-FAT-CPART15-D 36    AN  S  # Descrizione controp.  15
FLD  D-FAT-IMPCP15   15.2  NS  S  # Importo contropartita 15
FLD  D-FAT-CATT      1     AN  S  # Codice attivita
FLD  D-FAT-CATT-D    24    AN  S  # Descrizione attivit
FLD  D-FAT-FLGPR     1.0   NU  S  # Flag Calcolo Provvigioni (0/1)
#                                 # 0=non calcolate 1=calc.
FLD  D-FAT-FLGPR-D   25    AN  S  # Descrizione Flag Calcolo Provv.
FLD  D-FAT-TOVAL     15.2  NS  S  # Totale fattura in valuta 
FLD  D-FAT-VALUT     3.0   NU  S  # Codice valuta
FLD  D-FAT-VALUT-D   24    AN  S  # Descrizione valuta
FLD  D-FAT-CADOC     12.6  NU  S  # Coefficiente di cambio 
FLD  D-FAT-ENTMER    15.2  NS  S  # Netto merce in valuta
FLD  D-FAT-EIVRIV    15.2  NS  S  # Importo IVA in valuta non addebitato per rivalsa
FLD  D-FAT-ESPBOL    15.2  NS  S  # Spese bollo in valuta
FLD  D-FAT-ESPBAN    15.2  NS  S  # Spese banca in valuta
FLD  D-FAT-ESCFIN    15.2  NS  S  # Sconto di chiusura in valuta
FLD  D-FAT-EOMAGG    15.2  NS  S  # Importo cess. gratuite in valuta
FLD  D-FAT-ESCONT    15.2  NS  S  # Importo sconto in merce in valuta
FLD  D-FAT-EIMPON01  15.2  NS  S  # Imponibile in valuta 01
FLD  D-FAT-EIMPOS01  15.2  NS  S  # Imposta in valuta    01
FLD  D-FAT-EIMPON02  15.2  NS  S  # Imponibile in valuta 02
FLD  D-FAT-EIMPOS02  15.2  NS  S  # Imposta in valuta    02
FLD  D-FAT-EIMPON03  15.2  NS  S  # Imponibile in valuta 03
FLD  D-FAT-EIMPOS03  15.2  NS  S  # Imposta in valuta    03
FLD  D-FAT-EIMPON04  15.2  NS  S  # Imponibile in valuta 04
FLD  D-FAT-EIMPOS04  15.2  NS  S  # Imposta in valuta    04
FLD  D-FAT-EIMPON05  15.2  NS  S  # Imponibile in valuta 05
FLD  D-FAT-EIMPOS05  15.2  NS  S  # Imposta in valuta    05
FLD  D-FAT-EIMPON06  15.2  NS  S  # Imponibile in valuta 06
FLD  D-FAT-EIMPOS06  15.2  NS  S  # Imposta in valuta    06
FLD  D-FAT-EIMPOR01  15.2  NS  S  # Importo effetto in valuta 01
FLD  D-FAT-EIMPOR02  15.2  NS  S  # Importo effetto in valuta 02
FLD  D-FAT-EIMPOR03  15.2  NS  S  # Importo effetto in valuta 03
FLD  D-FAT-EIMPOR04  15.2  NS  S  # Importo effetto in valuta 04
FLD  D-FAT-EIMPOR05  15.2  NS  S  # Importo effetto in valuta 05
FLD  D-FAT-EIMPOR06  15.2  NS  S  # Importo effetto in valuta 06
FLD  D-FAT-EIMPOR07  15.2  NS  S  # Importo effetto in valuta 07
FLD  D-FAT-EIMPOR08  15.2  NS  S  # Importo effetto in valuta 08
FLD  D-FAT-EIMPOR09  15.2  NS  S  # Importo effetto in valuta 09
FLD  D-FAT-EIMPOR10  15.2  NS  S  # Importo effetto in valuta 10
FLD  D-FAT-EIMPOR11  15.2  NS  S  # Importo effetto in valuta 11
FLD  D-FAT-EIMPOR12  15.2  NS  S  # Importo effetto in valuta 12
FLD  D-FAT-ECONV     1.0   NU  S  # Flag creazione record (0/1)
#                                 # 1=record convertito da rel. Primula < NT 1.2
#                                 # 0=record generato da Primula Nt Rel. 1.2 
FLD  D-FAT-TAPPO     1     AN  S  # Carattere di fine record
