      *
      * Parametri locali di controllo interfaccia
      *
       01  RG-T-CTRL.
           05 RG-T-AZI     PIC 999.
           05 RG-T-FUN     PIC X.
           05 RG-T-CAMPO   PIC X(20).
           05 RG-T-NWIN    PIC 99.
           05 RG-T-ST      PIC 9.
           05 RG-T-FL      PIC 9.
      *----------------------
      * Note: AZI  non gestita
      *       NWIN rappresenta il n. della maschera richiesta
      *----------------------

      *
      * Record di interfaccia
      *
      **** rel 6.0a
      * IMPORTANTE: da questa release in avanti, per evitare il problema
      *             di dover modificare tutti gli screenset delle
      *             tabelle parametri nel caso di aggiunta di un
      *             parametro specifico in una sola finestra, creare
      *             un programma specifico di gestione per ogni finestra
      *             (vedere in 6.0a VRGT01H.CBL derivato da VARC122.CBL)
      *************
       01  RG-T-REC.

      * finestra 1
           05 RG-T14E-IVER    PIC 9(7).
           05 RG-T01-CIVAV    PIC 9(7).
           05 RG-T01-CIVAQ    PIC 9(7).
           05 RG-T01-CIVSO    PIC 9(7).
           05 RG-T01-MCLI     PIC 99.
           05 RG-T01-MFOR     PIC 99.
           05 RG-T14A-COSTI   PIC 9(7).
           05 RG-T14A-RICAV   PIC 9(7).
           05 RG-T14A-CDCOR   PIC 9(7).
      **** rel 5.0
           05 RG-T14A-FLGINC  PIC 9.
      ************
           05 RG-T14E-RICO    PIC 9(7).

      * finestra 2
           05 RG-T14B-CSGR    PIC 9(7).
           05 RG-T14B-IVGR    PIC 9(7).
           05 RG-T14B-SCON    PIC 9(7).
      **** rel 5.2
           05 RG-T14L-CRCGR   PIC 9(7).
           05 RG-T14L-CRSCM   PIC 9(7).
      ************
           05 RG-T14A-SPBOL   PIC 9(7).
           05 RG-T14A-SPBAN   PIC 9(7).
           05 RG-T14A-RIBAN   PIC 9(7).
           05 RG-T14A-TRATT   PIC 9(7).
           05 RG-T14B-CACC    PIC 9(7).
           05 RG-T14A-FATT    PIC 999.
           05 RG-T14B-ACCR    PIC 999.
           05 RG-T14B-FTSO    PIC 999.
           05 RG-T14B-ACSO    PIC 999.
           05 RG-T14A-RB      PIC 999.
           05 RG-T14A-TRT     PIC 999.
           05 RG-T14B-ACCO    PIC 999.
           05 RG-T14E-GICO    PIC 999.
           05 RG-T14E-GIIV    PIC 999.
      **** rel 7.2
           05 RG-T14E-GISO    PIC 999.
      ************
           05 RG-T14A-IVABL   PIC 999.
           05 RG-T14A-IVABA   PIC 999.

      * finestra 3
           05 RG-T14F-CAVC    PIC 999.
           05 RG-T14F-CARC    PIC 999.
           05 RG-T14F-CAOC    PIC 999.
           05 RG-T14F-CASC    PIC 999.
           05 RG-T14F-CAGC    PIC 999.
           05 RG-T14F-CAAF    PIC 999.
           05 RG-T14F-CARF    PIC 999.

      * finestra 4
           05 RG-T14E-1ACQ    PIC 999.
           05 RG-T14E-1ACR    PIC 999.
           05 RG-T14E-1ACT    PIC 999.
           05 RG-T14E-2ACQ    PIC 999.
           05 RG-T14E-3ACQ    PIC 999.
           05 RG-T14E-IDIR    PIC 999.
           05 RG-T14E-ITRI    PIC 999.
           05 RG-T14E-IIND    PIC 999.
           05 RG-T14E-ISCV    PIC 999.
           05 RG-T14E-IRSM    PIC 999.
           05 RG-T14E-IPOS    PIC 999.
           05 RG-T14E-IASS    PIC 999.
           05 RG-T14E-ISIN    PIC 999.

      * finestra 5
      **** rel 4.0
      *    05 RG-T14C-IMPS1   PIC 9(9).
      *    05 RG-T14C-IMPB1   PIC 9(6).
      *    05 RG-T14C-IMPS2   PIC 9(9).
      *    05 RG-T14C-IMPB2   PIC 9(6).
      *    05 RG-T14C-IMPS3   PIC 9(9).
      *    05 RG-T14C-IMPB3   PIC 9(6).
      *    05 RG-T14C-IMPS4   PIC 9(9).
      *    05 RG-T14C-IMPB4   PIC 9(6).
      *    05 RG-T14C-IMPS5   PIC 9(9).
      *    05 RG-T14C-IMPB5   PIC 9(6).
      *    05 RG-T14C-IMPS6   PIC 9(9).
      *    05 RG-T14C-IMPB6   PIC 9(6).
           05 RG-T14C-IMPS1   PIC 9(7)V99.
           05 RG-T14C-IMPB1   PIC 9(4)V99.
           05 RG-T14C-IMPS2   PIC 9(7)V99.
           05 RG-T14C-IMPB2   PIC 9(4)V99.
           05 RG-T14C-IMPS3   PIC 9(7)V99.
           05 RG-T14C-IMPB3   PIC 9(4)V99.
           05 RG-T14C-IMPS4   PIC 9(7)V99.
           05 RG-T14C-IMPB4   PIC 9(4)V99.
           05 RG-T14C-IMPS5   PIC 9(7)V99.
           05 RG-T14C-IMPB5   PIC 9(4)V99.
           05 RG-T14C-IMPS6   PIC 9(7)V99.
           05 RG-T14C-IMPB6   PIC 9(4)V99.
      ************
           05 RG-T14C-ALIQ    PIC 999V99.
      **** rel 5.2
           05 RG-T14C-IMBOL   PIC 9(5)V99.
           05 RG-T14C-IMPSC   PIC 9(7)V99.
      ************

      * finestra 6
           05 RG-T14I-CA1DC   PIC 999.
           05 RG-T14I-CA2DC   PIC 999.
           05 RG-T14I-CA3DC   PIC 999.
           05 RG-T14I-UTCAM   PIC 9(7).
           05 RG-T14I-PECAM   PIC 9(7).

      * finestra 7
           05 RG-T01-CRPFR    PIC 9(7).
           05 RG-T01-CRPCL    PIC 9(7).
           05 RG-T14B-RIC1    PIC 9(7).
           05 RG-T01-CRPF1    PIC 9(7).
           05 RG-T01-CRPC1    PIC 9(7).
           05 RG-T14B-RIC2    PIC 9(7).
           05 RG-T01-CRPF2    PIC 9(7).
           05 RG-T01-CRPC2    PIC 9(7).
           05 RG-T14B-RIC3    PIC 9(7).
           05 RG-T14G-CRPF3   PIC 9(7).
           05 RG-T14G-CRPC3   PIC 9(7).
           05 RG-T14H-RIC4    PIC 9(7).
           05 RG-T14G-CRPF4   PIC 9(7).
           05 RG-T14G-CRPC4   PIC 9(7).
           05 RG-T14H-RIC5    PIC 9(7).
           05 RG-T14G-CRPF5   PIC 9(7).
           05 RG-T14G-CRPC5   PIC 9(7).
           05 RG-T14H-RIC6    PIC 9(7).
           05 RG-T14G-CRPF6   PIC 9(7).
           05 RG-T14G-CRPC6   PIC 9(7).
           05 RG-T14H-RIC7    PIC 9(7).
           05 RG-T14G-CRPF7   PIC 9(7).
           05 RG-T14G-CRPC7   PIC 9(7).
           05 RG-T14H-RIC8    PIC 9(7).
           05 RG-T14G-CRPF8   PIC 9(7).
           05 RG-T14G-CRPC8   PIC 9(7).
           05 RG-T14H-RIC9    PIC 9(7).

      * finestra 8
      **** rel 6.0a
      * spostata gestione da VARC122 a VRGT01H
           05 FILLER          PIC 9.  *> ex rg-t14-cmag
           05 FILLER          PIC 9.  *> ex rg-t14-ftri
           05 FILLER          PIC 9.  *> ex rg-t14-ivrb
           05 FILLER          PIC 9.  *> ex rg-t14-notrif
           05 FILLER          PIC 9.  *> ex rg-t14-notffr
           05 FILLER          PIC 9.  *> ex rg-t14-notfcr
           05 FILLER          PIC 9.  *> ex rg-t14-notrig
           05 FILLER          PIC 9.  *> ex rg-t14-notbcr
      *************

      **** rel 5.2
      * finestra 10
           05 RG-T14L-CFTEM1  PIC 9(7).
           05 RG-T14L-CFTEM2  PIC 9(7).
           05 RG-T14L-CFTEM3  PIC 9(7).
           05 RG-T14L-CNAEM1  PIC 9(7).
           05 RG-T14L-CNAEM2  PIC 9(7).
           05 RG-T14L-CNAEM3  PIC 9(7).
           05 RG-T14L-CFTRC1  PIC 9(7).
           05 RG-T14L-CFTRC2  PIC 9(7).
           05 RG-T14L-CFTRC3  PIC 9(7).
           05 RG-T14L-CNARC1  PIC 9(7).
           05 RG-T14L-CNARC2  PIC 9(7).
           05 RG-T14L-CNARC3  PIC 9(7).
           05 RG-T14L-CAUFEM  PIC 999.
           05 RG-T14L-CAUFRC  PIC 999.
      ************
