       IDENTIFICATION DIVISION.
       PROGRAM-ID. VFAT210.
      *
      * OGGETTO   :   Routine stampa fatture
      *
      **** rel 5.0
      * Ricompilato per variazione tracciato ANABAN
      ************
      **** rel 6.0
      * Ricompilato per variazione tracciato tabella pagamenti
      ************
      **** rel 7.1
      * Stampa diciture IVA
      **********
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griclfsl'.
           COPY 'gribansl'.
           COPY 'gribctsl'.
           COPY 'gribcrsl'.
           COPY 'grifatsl'.
           COPY 'grilinsl'.
           COPY 'gritabsl'.
      **** rel 2.0
           COPY 'grincrsl'.
           COPY 'gripbrsl'.
      ************
      **** rel 5.0
           COPY 'griaimsl'.
           COPY 'griwsisl'.
      ************
      **** rel 6.2
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLAV STATUS SF-LAV.
      ************
      **** rel 7.1
           COPY 'grintasl'.
      ************
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'griclf'.
           COPY 'griban'.
           COPY 'gribct'.
           COPY 'gribcr'.
           COPY 'grifat'.
           COPY 'grilin'.
           COPY 'gritab'.
      **** rel 2.0
           COPY 'grincr'.
           COPY 'gripbr'.
      ************
      **** rel 5.0
           COPY 'griaim'.
           COPY 'griwsi'.
      ************
      **** rel 6.2
       FD  WDSLAV LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LAV
           RECORD 2005 DATA RECORD RF-LAV.
       01  RF-LAV.
           02 KEYLAV.
              05 KLAV-CONTA  PIC 9(5).
           02 LAV-PARFAT  PIC X(1000).
           02 LAV-PARRB   PIC X(1000).
      ************
      **** rel 7.1
           COPY 'grinta'.
      ************
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'gritabrk'.
      **** rel 2.0
           COPY 'grit28rk'.
      ************
           COPY 'griclfrk'.
           COPY 'griazirk'.
           COPY 'parzf'.
           COPY 'parcdt'.
      **** rel 1.2
      *    COPY 'parsv'.
           COPY 'parer'.
           COPY 'parrb'.
      ************
      **** rel 2.0
           COPY 'parcf'.
           COPY 'parfat'.
      ************
      **** rel 4.0
           COPY 'parop'.
      ************
      **** rel 5.2
           COPY 'parpcfa'.
      ************
      **** rel 6.2
           COPY 'partdc'.
           COPY 'parml30'.
      ************
       01  ID-ARL PIC X(15) VALUE 'artlin'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-BAN PIC X(15) VALUE 'anaban'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-BCT PIC X(15) VALUE 'bolcte'.
       01  ID-BCR PIC X(15) VALUE 'bolcri'.
      **** rel 2.0
       01  ID-NCR PIC X(15) VALUE 'notbcr'.
       01  ID-PBR PIC X(15) VALUE 'probcr'.
      ************
      **** rel 5.0
       01  ID-AIM PIC X(15) VALUE 'anaimb'.
       01  ID-WSI PIC X(15).
      ************
       01  ID-FAT.
           05 FILLER PIC X(6) VALUE 'fattur'.
           05 FATTIV PIC X    VALUE SPACE.
           05 FILLER PIC X(8) VALUE SPACE.
      **** rel 6.2
       01  ID-LAV PIC X(15).
      ************
      **** rel 7.1
       01  ID-NTA PIC X(15) VALUE 'nottab'.
      ************
       01  AREE-LAV.
           05 SF-ARL  PIC XX.
           05 SF-AZI  PIC XX.
           05 SF-CLF  PIC XX.
           05 SF-BAN  PIC XX.
           05 SF-TAB  PIC XX.
           05 SF-BCT  PIC XX.
           05 SF-BCR  PIC XX.
           05 SF-FAT  PIC XX.
      **** rel 2.0
           05 SF-NCR  PIC XX.
           05 SF-PBR  PIC XX.
      ************
      **** rel 5.0
           05 SF-AIM  PIC XX.
           05 SF-WSI  PIC XX.
      ************
      **** rel 6.2
           05 SF-LAV  PIC XX.
      ************
      **** rel 7.1
           05 SF-NTA  PIC XX.
      ************
           05 MESS     PIC X(40)  VALUE SPACE.
      **** rel 1.2
      *    05 K        PIC 99     VALUE ZERO.
           05 K        PIC 9(4)   VALUE ZERO.
      ************
           05 J        PIC 99     VALUE ZERO.
           05 NPAG     PIC 9(3)   VALUE ZERO.
           05 VISTA    PIC 9      VALUE ZERO.
           05 VNTMER   PIC S9(11)V99 VALUE ZERO.
           05 VSCFIN   PIC S9(11)V99 VALUE ZERO.
      **** rel 4.0
      *    05 TOTACC   PIC S9(11) VALUE ZERO.
           05 TOTACC   PIC S9(11)V99 VALUE ZERO.
      ************
           05 SCONTO   PIC 999V99 VALUE ZERO.
           05 VALUT    PIC 999    VALUE ZERO.
           05 DSVAL    PIC X(4)   VALUE SPACE.
           05 IMPON    PIC S9(11)V99 VALUE ZERO.
           05 IMPOS    PIC S9(11)V99 VALUE ZERO.
           05 ZERPK    PIC 9(5) COMP-3 VALUE ZERO.
           05 SC       PIC S99V99 VALUE ZERO.
           05 WNUM     PIC 9      VALUE ZERO.
           05 SW-CARTA PIC 9      VALUE ZERO.
           05 SWSTA    PIC 9      VALUE ZERO.
           05 CIFRA    PIC 9      VALUE ZERO.
           05 COMODO   PIC 999    VALUE ZERO.
           05 COMOD1   PIC 999    VALUE ZERO.
           05 GARANZ   PIC S9(11)V99 VALUE ZERO.
           05 NOSCON   PIC S9(11)V99 VALUE ZERO.
      **** rel 1.2
      *    05 OMAGG    PIC S9(11)V99 VALUE ZERO.
      *    05 SCMER    PIC S9(11)V99 VALUE ZERO.
           05 FSC      PIC 9.
           05 ESTPIVA  PIC 9.
      ************
      **** rel 2.0
           05 FLGSTA   PIC 9.
           05 INDICE   PIC 999.
           05 ULTIND   PIC 999.
      **** rel 4.0
      *    05 IMPIMB   PIC 9(9).
           05 IMPIMB   PIC 9(9)V99.
      ************
      **** rel 5.0
      *    05 VETIMB   PIC 999  OCCURS 10.
      *    05 VETQTA   PIC 9(5) OCCURS 10.
           05 PREPAL   PIC 9(5).
           05 PRECOL   PIC 9(5).
           05 PREIMB   PIC X(12).
           05 COMNIMB  PIC 9(3).
           05 VETIMB   PIC X(12) OCCURS 30.
           05 VETQTA   PIC 9(5)  OCCURS 30.
      ************
           05 TNUM-PF PIC 9.
           05 JJ      PIC 999.
      ************
      **** rel 4.0
           05 COMEURO PIC 9(3).
      ************
      **** rel 4.0-2
           05 KATTESA  PIC 9(5) VALUE ZERO.
      ************
      **** rel 6.2
           05 SWSIM    PIC 9.
           05 CVET     PIC 99.
      ************
      **** rel 7.1
           05 FLGTES   PIC 9 VALUE ZERO.
      ************
       01  CODICE.
           05 MAS      PIC 99   VALUE ZERO.
           05 COD      PIC 9(5) VALUE ZERO.
       01  W-LINEE     PIC X(80) VALUE ALL '-'.
       01  WK-TESTA.
           05 WK-DATA  PIC 9(5) COMP-3.
           05 WK-CSPE  PIC 999.
           05 WK-CPOR  PIC 999.
           05 WK-DSORD PIC X(10).
           05 WK-DSFAT PIC X(30).
           05 WK-SCBAS PIC S99V99.
       01  KBOL.
           05 BOAZ PIC 999  VALUE ZERO.
           05 BONU PIC 9    VALUE ZERO.
           05 BOBO PIC 9(5) VALUE ZERO.
      **** rel 5.0
       01  PAR-P-MDT.
           05 P-MDT-AZI   PIC 999.
           05 P-MDT-TDOC  PIC 9.
           05 P-MDT-KEY   PIC X(15).
           05 P-MDT-FLGS  PIC 9.
           05 P-MDT-DATA  PIC 9(5).
           05 P-MDT-NCOL  PIC 99.
           05 P-MDT-TESTO PIC X(76).
           05 P-MDT-FLGE  PIC 9.
      ************
      *-------------------------------------------
      *    parametri per definire lunghezza modulo
      *    LMOD = 11 per modulo 11 pollici (default)
      *    LMOD = 12 per modulo 12 pollici
       01  PARMOD.
           05 LMOD     PIC 99 VALUE 11.
           05 NRIG00   PIC 99.
           05 NRIG01   PIC 99.
           05 SALT00   PIC 99.
           05 SALT01   PIC 99.
      *-------------------------------------------
       01  PARST.
           05 XCRR PIC 9 VALUE ZERO.
           05 RIGA PIC X(132) VALUE SPACE.
           05 RIG1 REDEFINES RIGA.
              10 FILLER PIC X(45).
              10 PRAG   PIC X(87).
           05 RIG2 REDEFINES RIGA.
              10 FILLER PIC XX.
              10 PNFAT  PIC ZZZZ9.
              10 FILLER PIC XX.
              10 PDFAT  PIC X(10).
              10 PPAG   PIC Z9.
              10 PNOTA  PIC X(24).
              10 PCAP   PIC 99999-.
              10 PCIT   PIC X(81).
           05 RIG3 REDEFINES RIGA.
              10 FILLER PIC XX.
              10 PCLI   PIC ZZZZ9.
              10 FILLER PIC X(5).
              10 PFISC  PIC X(17).
              10 PPIVA  PIC X(14).
              10 PAGEN  PIC ZZ9.
              10 FILLER PIC XXX.
              10 PSPED  PIC X(83).
           05 RIG4 REDEFINES RIGA.
              10 FILLER PIC XX.
              10 PPOR   PIC X(30).
              10 PDEST  PIC X(100).
           05 RIG5 REDEFINES RIGA.
              10 FILLER PIC XX.
              10 PCPAG  PIC ZZ9.
              10 FILLER PIC XX.
              10 PDPAG  PIC X(25).
              10 PSCON  PIC ZZ,ZZ.
              10 FILLER PIC X.
              10 PBAN   PIC X(44).
              10 PVAL   PIC X(50).
           05 RIG6 REDEFINES RIGA.
              10 FILLER PIC X(15).
              10 PAST   PIC XX.
              10 PCONF  PIC X(9).
              10 PTNUM  PIC 9.
              10 PBARRA PIC X.
              10 PNCONF PIC ZZZZ9-.
              10 PDEL   PIC X(4).
              10 PDCONF PIC X(94).
           05 RIG7 REDEFINES RIGA.
              10 FILLER PIC XX.
              10 PART   PIC X(13).
              10 PDES.
                 15 RDES1  PIC X(10).
                 15 SOUT   PIC ZZZZ9.
                 15 RDES2  PIC X(5).
                 15 SDEL   PIC X(10).
              10 PQTA   PIC ZZZZZZ9-.
              10 PQTA1  REDEFINES PQTA PIC ZZZZ9,9-.
              10 PQTA2  REDEFINES PQTA PIC ZZZ9,99-.
              10 PPRZ   PIC ZZZZZZ9-.
              10 PPRZ1  REDEFINES PPRZ PIC ZZZ9,99-.
      **** rel 1.2
              10 PPRZ3  REDEFINES PPRZ PIC ZZ9,999-.
              10 PPRZ4  REDEFINES PPRZ PIC Z9,9999-.
              10 PPRZ5  REDEFINES PPRZ PIC 9,99999-.
      ************
      **** rel 4.0
              10 PPRZ6  REDEFINES PPRZ PIC ,999999-.
      ************
              10 DSPRZ.
                 15 PSCO   PIC Z9+.
                 15 PPNET  PIC ZZZZZZ9-.
                 15 PPNET1 REDEFINES PPNET PIC ZZZ9,99-.
      **** rel 2.0
                 15 PPNET3 REDEFINES PPNET PIC ZZ9,999-.
                 15 PPNET4 REDEFINES PPNET PIC Z9,9999-.
                 15 PPNET5 REDEFINES PPNET PIC 9,99999-.
      ************
      **** rel 4.0
                 15 PPNET6 REDEFINES PPNET PIC ,999999-.
      ************
                 15 PTNET  PIC ZZZ.ZZZ.ZZ9-.
                 15 PTNET1 REDEFINES PTNET PIC ZZZZ.ZZ9,99-.
              10 DSGRA REDEFINES DSPRZ PIC X(23).
              10 PCIVA  PIC ZZ9.
              10 FILLER PIC X(45).
           05 RIG8 REDEFINES RIGA.
              10 FILLER PIC X.
              10 PCDIVA PIC ZZ9.
              10 PIMP   PIC ZZZ.ZZZ.ZZ9-.
              10 PIMP1 REDEFINES PIMP PIC ZZZZ.ZZ9,99-.
              10 FILLER PIC X.
              10 PALI1  PIC X(19).
              10 PALI2  REDEFINES PALI1.
                 15 PALI   PIC X(10).
                 15 PIMIVA PIC ZZZZZZZ9-.
      **** rel 1.2
                 15 EPIMIVA REDEFINES PIMIVA PIC ZZZZ9,99-.
      ************
              10 FILLER PIC X.
              10 PSCAD  PIC X(9).
              10 PSCIMP PIC ZZ.ZZZ.ZZ9-.
              10 PSCIM0 REDEFINES PSCIMP PIC ZZZZZZZZZ9-.
              10 PSCIM2 REDEFINES PSCIMP PIC ZZZZZZ9,99-.
              10 FILLER PIC X.
              10 PSCOMO.
                 15 PSPESA PIC X(11).
                 15 PSCFIN REDEFINES PSPESA.
                    20 PSFIN PIC X(4).
                    20 PSPER PIC ZZ9,99.
                    20 FILPE PIC X.
                 15 FILLER PIC X.
                 15 FILLUN PIC XX.
                 15 FILLER PIC XX.
              10 PSCOM1 REDEFINES PSCOMO.
                 15 PSCO1 PIC X(2).
                 15 PSCO2 PIC ZZZZ.ZZZ.ZZ9.
                 15 PSCO3 REDEFINES PSCO2 PIC Z.ZZZ.ZZ9,99.
                 15 FILLER PIC X(2).
              10 PSCOM2 REDEFINES PSCOMO.
                 15 FILLER PIC X(12).
                 15 PDSVAL PIC X(4).
              10 PTOT   PIC ZZZZ.ZZZ.ZZ9-.
              10 PTOT1 REDEFINES PTOT PIC Z.ZZZ.ZZ9,99-.
              10 FILLER PIC X(45).
           05 RIG9 REDEFINES RIGA.
              10 FILLER PIC X(2).
              10 RDSMO  PIC X(23).
              10 RDIMP  PIC ZZZ.ZZZ.ZZ9-.
              10 RDIMP1 REDEFINES RDIMP PIC ZZZZ.ZZ9,99-.
              10 RDOGA.
                 15 RDSIV  PIC X(23).
                 15 RDIVA  PIC ZZZ.ZZZ.ZZ9-.
      **** rel 1.2
                 15 ERDIVA REDEFINES RDIVA PIC ZZZZ.ZZ9,99-.
      ************
              10 FILLER PIC X(60).
      **** rel 2.0
           05 RIG11  REDEFINES RIGA.
      **** rel 5.0
      *       10 FILLER PIC X(8).
      *       10 PCDIMB PIC ZZ9.
      *       10 FILLER PIC X(4).
      *       10 PDIMB PIC X(24).
      *       10 FILLER PIC X(8).
              10 FILLER PIC XX.
              10 PCDIMB PIC X(12).
              10 FILLER PIC X.
              10 PDIMB  PIC X(32).
      ************
              10 PQTIMB PIC ZZZZ9-.
              10 PPZIMB PIC ZZZZZZ9-.
              10 PPZIMB1 REDEFINES PPZIMB PIC ZZZ9,99-.
              10 FILLER PIC X(11).
              10 PIMPNT PIC ZZZ.ZZZ.ZZ9-.
              10 PIMPNT1 REDEFINES PIMPNT PIC ZZZZ.ZZ9,99-.
              10 PIVAIM PIC ZZ9.
              10 FILLER PIC X(45).
           05 RIG12 REDEFINES RIGA.
              10 FILLER PIC X(15).
              10 PCONAI PIC X(117).
      ************
           05 NRGLF  PIC 9(4)  VALUE ZERO.
           05 NRIG   PIC 99    VALUE ZERO.
           05 FILLER PIC X(12) VALUE ZERO.
           05 SALT   PIC 99    VALUE ZERO.
      **** rel 6.2
       01  NRIGMAXL    PIC 9(3). 
       01  KNOT        PIC 9(5).
      ************
       LINKAGE SECTION.
           COPY 'parpfls'.
       PROCEDURE DIVISION USING PARPF.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclclf'.
           COPY 'dclban'.
           COPY 'dclbct'.
           COPY 'dclbcr'.
           COPY 'dclfat'.
           COPY 'dcllin'.
           COPY 'dcltab'.
      **** rel 2.0
           COPY 'dclncr'.
           COPY 'dclpbr'.
      ************
      **** rel 5.0
           COPY 'dclaim'.
           COPY 'dclwsi'.
      ************
      **** rel 7.1
           COPY 'dclnta'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strsub'.
           MOVE PF-ATTIV TO FATTIV.
           IF FATTIV = '0' MOVE SPACE TO FATTIV.
      **** rel 5.0
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           OPEN OUTPUT WDSSIB.
           CLOSE WDSSIB.
           OPEN I-O WDSSIB.
      ************
           OPEN INPUT ANACLF ANAAZI ANABAN TABELL
      **** rel 2.0
                      NOTBCR PROBCR
      ************
      **** rel 5.0
                      ANAIMB
      ************
                      BOLCTE BOLCRI FATTUR ARTLIN.
      **** rel 7.1
           OPEN INPUT NOTTAB.
      ************
      **** rel 6.2
           MOVE ZERO TO SWSIM.
           OPEN INPUT WDSLAV.
           READ WDSLAV NEXT.
           IF SF-LAV = ZERO MOVE 1 TO SWSIM.
      ************
           MOVE 1 TO KTB-COD KTB-TIP.
           READ TABELL INTO REKTAB INVALID KEY
                PERFORM INVK-TAB
                GO TO WARNING.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MCLI TO MAS.
           MOVE 6666 TO NRGLF.
           MOVE 36   TO NRIG00.
           MOVE 38   TO NRIG01.
           MOVE 37   TO SALT00.
           MOVE 42   TO SALT01.
           IF LMOD = 12
              MOVE 7272 TO NRGLF
              MOVE 42   TO NRIG00
              MOVE 44   TO NRIG01
              MOVE 43   TO SALT00
              MOVE 48   TO SALT01.
           MOVE PF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID KEY
                PERFORM INVK-AZI
                GO TO WARNING.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
      **** rel 2.0
           MOVE 28     TO T28-TIP.
           MOVE PF-AZI TO T28-COD.
           MOVE 'E'    TO T28-PRG.
           MOVE T28-KEYID TO KEYTB.
           READ TABELL INTO REKT28 INVALID MOVE ZERO TO T28-NUMPF.
           MOVE T28-NUMPF TO TNUM-PF.
      ************
           MOVE ZERO TO WNUM.
           MOVE 1 TO PF-ST.
      **** rel 4.0
           CALL 'rveur' USING COMEURO.
      ************
      **** rel 6.2
           MOVE PF-AZI TO PTDC-AZI.
           MOVE 'BOL'  TO PTDC-COD.
           CALL 'vrctdc' USING PARTDC.
           MOVE PTDC-NRIG TO NRIGMAXL.
      ************
       LRFT.
           ADD 1 TO WNUM.
           IF WNUM = ZERO OR
              WNUM > PF-COPIE MOVE ZERO TO SW-CARTA GO TO FINE.
           MOVE ZERO TO SWSTA.
      **** rel 6.2
           IF SWSIM = ZERO GO TO NO-SIM.
           MOVE LOW-VALUE TO KEYLAV.
           START WDSLAV KEY > KEYLAV INVALID GO TO FINES.
       RDN-LAV.
           READ WDSLAV NEXT AT END GO TO FINES.
           MOVE LAV-PARFAT TO RF-FAT.
           MOVE LAV-PARRB  TO PARRB.
           GO TO OK-PROFORMA.
       NO-SIM.
      ************
      **** rel 2.0
           IF NOT (PF-TDOC = 8 OR 9) GO TO NO-PROFORMA.
      * fattura proforma
           MOVE PF-AZI   TO KBC-AZI.
           MOVE TNUM-PF  TO KBC-NUM.
           MOVE PF-PRFAT TO KBC-BOL.
           READ BOLCTE INVALID PERFORM INVK-BCT GO TO ERRIO.
      **** rel 6.3
           IF BCT-CLI  < PF-CLI-1 OR > PF-CLI-2 GO TO FINES.
           IF BCT-CAGE < PF-AGE-1 OR > PF-AGE-2 GO TO FINES.
           IF BCT-DATA < PF-DAT-1 OR > PF-DAT-2 GO TO FINES.
      ************
           MOVE KBC-AZI     TO CF-AZI.
           MOVE BCT-GGESC   TO CF-GGESC.
           MOVE BCT-DATA    TO CF-DTFAT.
           MOVE PF-ATTIV    TO CF-ATTIV.
           MOVE ZERO        TO CF-NUMFAT.
           MOVE 1           TO CF-SIMUL.
           MOVE ZERO        TO CF-VIDEO.
           MOVE 1 TO JJ.
           PERFORM UNTIL JJ > RB-MAXBOL
              MOVE ZERO TO RB-TNUM(JJ)
                           RB-NBOL(JJ)
              ADD 1 TO JJ
           END-PERFORM.
           MOVE KBC-NUM   TO RB-TNUM(1).
           MOVE KBC-BOL   TO RB-NBOL(1).
           MOVE 1         TO RB-ULTBOL.
           CALL 'vfat190' USING PARCF PARRB CFT-FAT.
           CANCEL 'vfat190'.
           IF ERRIO-ST = 9 GO TO ERRIO.
           IF CF-ST = 9    GO TO ERR-PF.
           MOVE CFT-FAT TO RF-FAT.
           IF PF-TDOC = 8
              MOVE 1 TO KFT-TDOC
           ELSE
              MOVE 2 TO KFT-TDOC.
           MOVE KBC-BOL TO KFT-NUM.
           GO TO OK-PROFORMA.
       ERR-PF.
           MOVE 'ERRORE FAT. PROFORMA' TO MESS.
           GO TO ERRIO.
       NO-PROFORMA.
      ************
           MOVE ZERO TO KEYFT.
           MOVE KAZ-COD  TO KFT-AZI.
           MOVE PF-TDOC  TO KFT-TDOC.
           MOVE PF-PRFAT TO KFT-NUM.
           START FATTUR KEY NOT < KEYFT INVALID GO TO FINES.
       NEWFAT.
           READ FATTUR NEXT AT END GO TO FINES.
           IF SF-FAT = '9D' OR '9A' OR '35' GO TO NEWFAT.
           IF KFT-AZI NOT = KAZ-COD GO TO FINES.
           IF KFT-TDOC NOT = PF-TDOC GO TO FINES.
           IF KFT-NUM > PF-ULFAT     GO TO FINES.
      **** rel 6.3
           IF FAT-CDCLI < PF-CLI-1 OR > PF-CLI-2 GO TO NEWFAT.
           IF FAT-CDAGE < PF-AGE-1 OR > PF-AGE-2 GO TO NEWFAT.
           IF FAT-DATA  < PF-DAT-1 OR > PF-DAT-2 GO TO NEWFAT.
      ************
      **** rel 5.0
           PERFORM DL-LAV-IMB THRU EX-DL-LAV-IMB.
      ************
      **** rel 2.0
      *    MOVE ZERO TO PF-ST.
      *    MOVE ZERO TO NOSCON.
      ************
      **** rel 1.2
      *    MOVE ZERO TO OMAGG.
      *    MOVE ZERO TO SCMER.
           CALL 'rdbfa' USING FAT-CATT KEYFT PARRB.
      **** rel 6.3
           MOVE KFT-AZI    TO KBC-AZI.
           MOVE RB-TNUM(1) TO KBC-NUM.
           MOVE RB-NBOL(1) TO KBC-BOL.
           READ BOLCTE INVALID GO TO NEWFAT.

           IF BCT-TMODU = 1 GO TO NEWFAT.
      ************
      ************
      **** rel 2.0
       OK-PROFORMA.
           MOVE ZERO TO PF-ST.
           MOVE ZERO TO NOSCON.
      *
           MOVE ZERO TO ULTIND.
      **** rel 4.0
      *    IF FAT-VALUT > 1
           IF NOT (FAT-VALUT = ZERO OR COMEURO)
      ************
              MOVE FAT-VALUT TO ER-VALUT
              CALL 'rvalut' USING ER-VALUT FAT-DATA CG-PAR
              IF CG-ST > ZERO PERFORM ERR-EURO
                              GO TO WARNING.
      ************
           IF SWSTA = 1 GO TO NOCALL.
           MOVE ZERO TO XCRR.
           CALL 'rstam' USING PARST.
           MOVE 1 TO SWSTA.
       NOCALL.
           PERFORM RDCL THRU EX-RDCL.
      **** rel 1.2
           MOVE ZERO TO ESTPIVA.
           IF FAT-CDESE  = ZERO GO TO NOCALL-10.
           IF CLF-ENUIVA = ZERO GO TO NOCALL-10.
           MOVE 3         TO KTB-TIP.
           MOVE FAT-CDESE TO KTB-COD.
           READ TABELL INTO REKTAB INVALID GO TO NOCALL-10.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T03-TPIVA TO ESTPIVA.
       NOCALL-10.
      ************
           MOVE ZERO TO KBOL VNTMER.
           MOVE ZERO TO GARANZ.
           MOVE KFT-AZI TO BOAZ.
           MOVE 1 TO K.
           PERFORM NEWBOL THRU EX-NEWBOL.
           MOVE FAT-CDBAN TO KBA-BAN.
           READ ANABAN INVALID KEY MOVE SPACE TO BAN-RGSOC.
           MOVE ZERO TO NPAG.
           MOVE BCT-DATA  TO WK-DATA.
           MOVE BCT-CSPE  TO WK-CSPE.
           MOVE BCT-CPOR  TO WK-CPOR.
           MOVE BCT-DSORD TO WK-DSORD.
           MOVE BCT-DSFAT TO WK-DSFAT.
           MOVE BCT-SCBAS TO WK-SCBAS.
      *-------------------------------
       NWPG.
           ADD 1 TO NPAG.
           MOVE ZERO TO XCRR.
           MOVE CLF-RGSOC TO PRAG.
           CALL 'rstam' USING PARST.
           MOVE ZERO TO NRIG.
           MOVE CLF-RGSOC2 TO PRAG.
           MOVE 1 TO XCRR.
           CALL 'rstam' USING PARST.
           MOVE CLF-INDIR TO PRAG.
           CALL 'rstam' USING PARST.
           MOVE CLF-INDIR2 TO PRAG.
           CALL 'rstam' USING PARST.
           MOVE KFT-NUM TO PNFAT.
      **** rel 6.2
           IF SWSIM = 1 MOVE KLAV-CONTA TO PNFAT.
      ************
           MOVE FAT-DATA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO PDFAT.
           MOVE NPAG TO PPAG.
           IF KFT-TDOC = 3
              MOVE '   NOTA DI ACCREDITO' TO PNOTA.
           IF KFT-TDOC = 2
      **** rel 1.2
              MOVE '   FATTURA IN VALUTA' TO PNOTA.
      *       MOVE '   FATTURA ESTERO   ' TO PNOTA.
      ************
           IF KFT-TDOC = 4
      **** rel 7.2
      *       MOVE '  FATTURA IN SOSPESO' TO PNOTA.
              IF FAT-DATA < 42005 
                 MOVE '  FATTURA IN SOSPESO'
                      TO PNOTA
               ELSE
                 MOVE 'FATTURA SCISS. PAG.' TO PNOTA.
      ************
           IF KFT-TDOC = 6
      **** rel 7.2
      *       MOVE ' N.ACCREDITO SOSPESO' TO PNOTA.
              IF FAT-DATA < 42005 
                 MOVE ' N.ACCREDITO SOSPESO'
                      TO PNOTA
              ELSE
                 MOVE 'N.ACCREDITO SCISS. PAG.' TO PNOTA.
      ************
      **** rel 2.0
           IF PF-TDOC = 8 OR 9
              MOVE '    FATTURA PROFORMA' TO PNOTA.
      ************
      **** rel 6.2
           IF SWSIM = 1
              MOVE '    SIMULAZIONE     ' TO PNOTA.
      ************
           MOVE CLF-CAP TO PCAP.
           MOVE CLF-CITTA TO PCIT.
           CALL 'rstam' USING PARST.
           MOVE FAT-CDCLI TO PCLI.
           MOVE CLF-CFISC TO PFISC.
           IF CLF-PIVA > ZERO MOVE CLF-PIVA TO PPIVA.
           IF CLF-13IVA = 4
              MOVE SPACE TO PFISC
              MOVE CLF-CFISC TO PPIVA.
           MOVE FAT-CDAGE TO PAGEN.
           MOVE 6        TO KTB-TIP.
           MOVE WK-CSPE  TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                       MOVE SPACE TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO PSPED.
           MOVE 3 TO XCRR.
           CALL 'rstam' USING PARST.
           MOVE 5        TO KTB-TIP.
           MOVE WK-CPOR  TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                       MOVE SPACE TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO PPOR.
           MOVE 2 TO XCRR.
           CALL 'rstam' USING PARST.
           MOVE FAT-CDPAG TO PCPAG.
           MOVE 4 TO KTB-TIP.
           MOVE FAT-CDPAG TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                       MOVE SPACE TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE TAB-DESCR TO PDPAG.
           MOVE FAT-SCBAS TO PSCON.
           MOVE BAN-RGSOC TO PBAN.
           MOVE T04-SCASS TO SCONTO.
           IF T04-1SCAD = ZERO MOVE 1 TO VISTA
           ELSE MOVE ZERO TO VISTA.
           IF VALUT = ZERO MOVE SPACE TO DSVAL
                           GO TO NWPG001.
           MOVE 10 TO KTB-TIP.
           MOVE VALUT TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                        MOVE SPACE TO T10-DSINT.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T10-DSINT TO PVAL.
           MOVE T10-DSINT TO DSVAL.
       NWPG001.
           CALL 'rstam' USING PARST.
           MOVE 3 TO XCRR.
       EX-NWPG.
           EXIT.
      *-------------------------------
       VAI.
           GO TO LSTR.
       NXTB.
           ADD 1 TO K.
      **** rel 1.2
      *    IF K > 15 GO TO LFIN.
      *    MOVE FAT-TNUM (K) TO CIFRA.
           IF K > RB-ULTBOL GO TO LFIN.
           MOVE RB-TNUM(K) TO CIFRA.
      ************
           IF CIFRA = ZERO GO TO LFIN.
           PERFORM NEWBOL THRU EX-NEWBOL.
           MOVE 2 TO XCRR.
      * CAMBIO BOLLA *
       LSTR.
      **** rel 2.0
      *    IF KBC-NUM > 5 GO TO LP10.
           IF KBC-NUM > 5 OR (BCT-TDOC = 8 OR 9) GO TO LP10.
      ************
           IF NRIG > NRIG01 PERFORM NWPG THRU EX-NWPG.
           IF XCRR NOT = 3 MOVE 2 TO XCRR.
           MOVE '*' TO PAST.
           MOVE 'D.D.T. N.' TO PCONF.
           MOVE KBC-NUM TO PTNUM.
           MOVE '/' TO PBARRA.
           MOVE KBC-BOL TO PNCONF.
           MOVE 'DEL' TO PDEL.
           MOVE BCT-DATA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO PDCONF.
           CALL 'rstam' USING PARST.
           MOVE 2 TO XCRR.
       LP10.
           MOVE KBC-AZI TO KCR-AZI.
           MOVE KBC-NUM TO KCR-NUM.
           MOVE KBC-BOL TO KCR-BOL.
           MOVE ZERO    TO KCR-PGR.
      **** rel 5.0
      *    START BOLCRI KEY NOT < KEYCR INVALID GO TO NXTB.
           START BOLCRI KEY NOT < KEYCR INVALID GO TO END-TB.
      ************
       LART.
      **** rel 5.0
      *    READ BOLCRI NEXT AT END GO TO NXTB.
           READ BOLCRI NEXT AT END GO TO END-TB.
      ************
           IF SF-BCR = '9D' OR '9A' OR '35' GO TO LART.
      **** rel 5.0
      *    IF KCR-AZI > KBC-AZI GO TO NXTB.
      *    IF KCR-NUM > BONU GO TO NXTB.
      *    IF KCR-BOL > BOBO GO TO NXTB.
           IF KCR-AZI > KBC-AZI GO TO END-TB.
           IF KCR-NUM > BONU GO TO END-TB.
           IF KCR-BOL > BOBO GO TO END-TB.
      ************
      **** rel 4.0
      *    IF BCR-TCOR = 1 AND BCR-TPRZ = 2 GO TO LART.
           IF BCR-TCOR = 1 AND BCR-FSC  = 2 GO TO LART.
      ************
           IF NRIG > NRIG01 PERFORM NWPG THRU EX-NWPG.
           PERFORM B00-STAMPA-RIGO THRU B99.
           GO TO LART.
      **** rel 5.0
       END-TB.
           PERFORM H00-STAMPA-MESSAGG-BOLLA THRU H99.
           GO TO NXTB.
      ************
      * STAMPA PIEDE FATTURA *
       LFIN.
      **** rel 5.0
           PERFORM SOMMA-IMBALLI THRU EX-SOMMA-IMBALLI.
      ************
      **** rel 2.0
           PERFORM G00-STAMPA-IMBALLI THRU G99.
           IF ESTPIVA NOT = 3 PERFORM STAMPA-CONAI THRU EX-STAMPA-CONAI.
      ************
      **** rel 5.0
           PERFORM F00-STAMPA-MESSAGG-FATT THRU F99.
      ************
           MOVE NRIG00 TO COMODO.
           MOVE SALT00 TO COMOD1.
           IF FAT-OMAGG > ZERO SUBTRACT 1 FROM COMODO COMOD1.
           IF FAT-SCONT > ZERO SUBTRACT 1 FROM COMODO COMOD1.
      **** rel 1.2
      *    IF GARANZ    > ZERO AND PF-TDOC = 2
           IF GARANZ    > ZERO AND ESTPIVA = 3
      ************
                               SUBTRACT 1 FROM COMODO COMOD1.
      **** rel 1.2
      *    IF PF-TDOC = 2 GO TO LPPIEDE.
      *    IF VALUT > ZERO GO TO LPPIEDE.
      ************
      **** rel 7.1
           PERFORM I00-STAMPA-NOTEIVA THRU I99.
      ************
      **** rel 7.2
           IF (KFT-TDOC = 6 OR KFT-TDOC = 4) AND
              FAT-DATA >= 42005 
              PERFORM J00-STAMPA-SPLITPAY THRU J99.
      ************
           IF FAT-CDESE = ZERO GO TO LPPIEDE.
           IF CLF-ENUIVA = ZERO GO TO LPPIEDE.
      **** rel 1.2
      *    MOVE 3 TO KTB-TIP.
      *    MOVE FAT-CDESE TO KTB-COD.
      *    READ TABELL INTO REKTAB INVALID GO TO LPPIEDE.
      *    IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      *    IF T03-TPIVA NOT = 6 GO TO LPPIEDE.
           IF ESTPIVA NOT = 6 GO TO LPPIEDE.
      ************
           IF NRIG > COMODO PERFORM NWPG THRU EX-NWPG.
           MOVE COMOD1 TO SALT.
           MOVE 'Non imp. IVA art 8/2  DPR 633' TO PDES.
           CALL 'rstam' USING PARST.
           MOVE 1 TO XCRR.
           MOVE 'del 26/10/72 e succ. modifiche' TO PDES.
           CALL 'rstam' USING PARST.
           MOVE 'Vs aut. N.' TO RDES1.
           MOVE CLF-ENUIVA TO SOUT.
           MOVE ' del' TO RDES2.
           MOVE CLF-EDTIVA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO SDEL.
           CALL 'rstam' USING PARST.
           MOVE 'Ns protoc.' TO RDES1.
           MOVE CLF-INUIVA TO SOUT.
           MOVE ' del' TO RDES2.
           MOVE CLF-IDTIVA TO AAGGG.
      **** rel 6.1
           MOVE 2 TO TIPOP1.
      ************
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO SDEL.
           CALL 'rstam' USING PARST.
       LPPIEDE.
           COMPUTE COMODO = NRIG00 - COMODO.
           IF COMODO = ZERO GO TO LPPIE-99.
           COMPUTE COMOD1 = SALT00 + 4 - COMODO
           COMPUTE COMODO = COMODO + NRIG00.
           ADD 4 TO COMODO.
           IF NRIG > COMODO PERFORM NWPG THRU EX-NWPG.
           MOVE COMOD1 TO SALT.
           IF FAT-OMAGG = ZERO GO TO LPPIE-20.
           MOVE 'Cessione gratuita    = ' TO RDSMO.
      **** rel 4.0
      *    IF VALUT > 1
      ************
      **** rel 1.2
      *       MOVE OMAGG TO RDIMP1
      **** rel 4.0
      *       MOVE FAT-EOMAGG TO RDIMP1
      ************
      ************
      **** rel 4.0
      *    ELSE
      *       MOVE FAT-OMAGG TO RDIMP.
      ************
      **** rel 4.0
           IF VALUT = ZERO OR COMEURO
              MOVE FAT-OMAGG TO RDIMP1
           ELSE
              MOVE FAT-EOMAGG TO RDIMP1.
           IF VALUT = 1 MOVE FAT-EOMAGG TO RDIMP.
      ************
      **** rel 1.2
      *    IF KFT-TDOC = 2
           IF ESTPIVA = 3
      ************
           MOVE 'Valore ai soli fini Doganali' TO RDOGA
                                         GO TO LPPIE-10.
           IF FAT-IVRIV = ZERO GO TO LPPIE-10.
           MOVE 'Iva a nostro carico  = ' TO RDSIV.
      **** rel 1.2
      *    MOVE FAT-IVRIV TO RDIVA.
      **** rel 4.0
      *    IF VALUT > 1
      *       MOVE FAT-EIVRIV TO ERDIVA
      *    ELSE
      *       MOVE FAT-IVRIV TO RDIVA.
           IF VALUT = ZERO OR COMEURO
              MOVE FAT-IVRIV TO ERDIVA
           ELSE
              MOVE FAT-EIVRIV TO ERDIVA.
           IF VALUT = 1 MOVE FAT-EIVRIV TO RDIVA.
      ************
      ************
       LPPIE-10.
           CALL 'rstam' USING PARST.
       LPPIE-20.
           IF FAT-SCONT = ZERO GO TO LPPIE-30.
           MOVE 'Sconto in merce      = ' TO RDSMO.
      **** rel 4.0
      *    IF VALUT > 1
      ************
      **** rel 1.2
      *       MOVE SCMER TO RDIMP1
      **** rel 4.0
      *       MOVE FAT-ESCONT TO RDIMP1
      ************
      ************
      **** rel 4.0
      *    ELSE
      *       MOVE FAT-SCONT TO RDIMP.
      ************
      **** rel 4.0
           IF VALUT = ZERO OR COMEURO
              MOVE FAT-SCONT TO RDIMP1
           ELSE
              MOVE FAT-ESCONT TO RDIMP1.
           IF VALUT = 1 MOVE FAT-ESCONT TO RDIMP.
      ************
      **** rel 1.2
      *    IF KFT-TDOC = 2
           IF ESTPIVA = 3
      ************
           MOVE 'Valore ai soli fini Doganali' TO RDOGA.
           CALL 'rstam' USING PARST.
       LPPIE-30.
      **** rel 1.2
      *    IF GARANZ = ZERO OR KFT-TDOC NOT = 2 GO TO LPPIE-99.
           IF GARANZ = ZERO OR ESTPIVA NOT = 3 GO TO LPPIE-99.
      ************
           MOVE 'Cessione in garanzia = ' TO RDSMO.
           MOVE 'Valore ai soli fini Doganali' TO RDOGA.
      **** rel 4.0
      *    IF VALUT > 1
      *       MOVE GARANZ TO RDIMP1
      *    ELSE
      *       MOVE GARANZ TO RDIMP.
           MOVE GARANZ TO RDIMP1.
           IF VALUT = 1 MOVE GARANZ TO RDIMP.
      ************
           CALL 'rstam' USING PARST.
       LPPIE-99.
      **** rel 1.2
      *    IF VALUT > 1
      *       COMPUTE VSCFIN = (VNTMER - NOSCON) * SCONTO / 100
      *       PERFORM SCAVAL THRU EX-SCAVAL.
      **** rel 4.0
      *    IF VALUT > 1
           IF NOT (VALUT = ZERO OR COMEURO)
      ************
              COMPUTE VSCFIN = (VNTMER - NOSCON) * SCONTO / 100.
      ************
           MOVE SALT01 TO SALT.
      **** rel 4.0
      *    IF VALUT > 1
      *        MOVE VNTMER TO PTOT1
      *    ELSE
      *        MOVE FAT-NTMER TO PTOT.
           IF VALUT = ZERO OR COMEURO
              MOVE FAT-NTMER TO PTOT1
           ELSE
              MOVE VNTMER    TO PTOT1.
           IF VALUT = 1 MOVE VNTMER TO PTOT.
      ************
           CALL 'rstam' USING PARST.
           MOVE 1 TO XCRR.
           MOVE ZERO TO IMPON IMPOS.
           MOVE ZERO TO K.
       LSCA.
           ADD 1 TO K.
           IF K > 6 GO TO GSCA.
      **** rel 1.2
      *    IF VALUT > 1 AND K > 1 GO TO GSCA.
      ************
           IF FAT-CDIVA (K) = ZERO GO TO GSCA.
           MOVE FAT-CDIVA (K) TO KTB-COD.
           MOVE 3 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                       MOVE 'IVA INESISTENTE' TO TAB-DESCR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE FAT-CDIVA (K) TO PCDIVA.
      **** rel 1.2
      *    IF VALUT > 1
      *       MOVE FAT-TOVAL TO PIMP1
      *       ADD  FAT-TOVAL TO IMPON
      *       MOVE TAB-DESCR TO PALI1
      *       GO TO GSCA.
      *    MOVE FAT-IMPON (K) TO PIMP.
      *    ADD  FAT-IMPON (K) TO IMPON.
      *    IF T03-ALIVA = ZERO MOVE TAB-DESCR TO PALI1
      *    ELSE MOVE T03-DSIVA TO PALI
      *         MOVE FAT-IMPOS (K) TO PIMIVA.
      *    ADD  FAT-IMPOS (K) TO IMPOS.
      **** rel 4.0
      *    IF VALUT > 1
      *       MOVE FAT-EIMPON(K) TO PIMP1
      *       MOVE FAT-EIMPOS(K) TO EPIMIVA
      *       ADD  FAT-EIMPON(K) TO IMPON
      *       ADD  FAT-EIMPOS(K) TO IMPOS
      *    ELSE
      *       MOVE FAT-IMPON(K) TO PIMP
      *       MOVE FAT-IMPOS(K) TO PIMIVA
      *       ADD  FAT-IMPON(K) TO IMPON
      *       ADD  FAT-IMPOS(K) TO IMPOS.
           IF VALUT = ZERO OR COMEURO
              MOVE FAT-IMPON(K) TO PIMP1
              MOVE FAT-IMPOS(K) TO EPIMIVA
              ADD  FAT-IMPON(K) TO IMPON
              ADD  FAT-IMPOS(K) TO IMPOS
           ELSE
              MOVE FAT-EIMPON(K) TO PIMP1
              MOVE FAT-EIMPOS(K) TO EPIMIVA
              ADD  FAT-EIMPON(K) TO IMPON
              ADD  FAT-EIMPOS(K) TO IMPOS.
           IF VALUT = 1
              MOVE FAT-EIMPON(K) TO PIMP
              MOVE FAT-EIMPOS(K) TO PIMIVA.
      ************
           IF T03-ALIVA = ZERO
              MOVE TAB-DESCR TO PALI1
           ELSE
              MOVE T03-DSIVA TO PALI.
      ************
       GSCA.
           IF K = 1 GO TO LRIE.
           IF K > 7 GO TO ESCA.
           SUBTRACT 1 FROM K.
           IF FAT-DTSCA (K) = ZERPK GO TO GSCA1.
           IF VISTA = 1 MOVE 'A VISTA' TO PSCAD
                        MOVE ZERO TO VISTA
                        GO TO GSCA0.
           MOVE FAT-DTSCA (K) TO AAGGG.
      **** rel 6.1
           MOVE 2 TO TIPOP1.
      ************
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO PSCAD.
       GSCA0.
      **** rel 4.0
      *    IF FAT-IMPOR(K) > 99999999 OR < -99999999
      *       MOVE FAT-IMPOR(K) TO PSCIM0
      *    ELSE
      *    MOVE FAT-IMPOR (K) TO PSCIMP.
      ************
      **** rel 4.0
      *    IF VALUT > 1
      ************
      **** rel 1.2
      **** rel 4.0
      *       MOVE FAT-EIMPOR(K) TO PSCIM2.
      ************
      *       IF SV-IMVAL(K) NOT = ZERO MOVE SV-IMVAL(K) TO PSCIM2.
      ************
      **** rel 4.0
           IF VALUT = ZERO OR COMEURO
              MOVE FAT-IMPOR (K) TO PSCIM2
           ELSE
              MOVE FAT-EIMPOR (K) TO PSCIM2.
           IF VALUT = 1
              IF FAT-EIMPOR(K) > 99999999 OR < -99999999
                 MOVE FAT-EIMPOR(K) TO PSCIM0
              ELSE
                 MOVE FAT-EIMPOR (K) TO PSCIMP.
      ************
       GSCA1.
           ADD 1 TO K.
       LRIE.
           IF K = 1 AND FAT-SCFIN > ZERO
               MOVE 'SC.' TO PSFIN
               MOVE SCONTO    TO PSPER
               MOVE '%'  TO FILPE
               MOVE 'SU' TO FILLUN
               CALL 'rstam' USING PARST
               GO TO LSCA.
           IF K = 2 AND FAT-SCFIN > ZERO
      **** rel 4.0
              MOVE SPACE TO PSCO1
              IF VALUT = ZERO OR COMEURO
                 COMPUTE PSCO3 = FAT-NTMER - NOSCON
                 COMPUTE PTOT1 = - FAT-SCFIN
              ELSE
                  COMPUTE PSCO3 = VNTMER - NOSCON
                  COMPUTE PTOT1 = - VSCFIN
              END-IF
              IF VALUT = 1
                 COMPUTE PSCO2 = VNTMER - NOSCON
                 COMPUTE PTOT  = - VSCFIN.
      *        IF VALUT > 1
      *           MOVE SPACE TO PSCO1
      *           COMPUTE PSCO3 = VNTMER - NOSCON
      *           COMPUTE PTOT1 = - VSCFIN
      *        ELSE
      *           MOVE 'L.' TO PSCO1
      *           COMPUTE PSCO2 = FAT-NTMER - NOSCON
      *           COMPUTE PTOT  = - FAT-SCFIN.
      ************
           IF K = 4 AND FAT-SPBOL > ZERO
      **** rel 4.0
      *             AND VALUT <= 1
                    AND (VALUT = ZERO OR COMEURO)
      ************
               MOVE 'BOLLI' TO PSPESA
      **** rel 4.0
               MOVE FAT-SPBOL TO PTOT1.
      *        MOVE FAT-SPBOL TO PTOT.
      ************
      **** rel 4.0
           IF K = 4 AND FAT-ESPBOL > ZERO
                    AND VALUT = 1    MOVE 'BOLLI'    TO PSPESA
                                     MOVE FAT-ESPBOL TO PTOT.
      ************
      **** rel 1.2
      *    IF K = 6 AND FAT-SPBAN > ZERO
      *             AND VALUT <= 1
      *        MOVE 'SPESE BANCA' TO PSPESA
      *        MOVE FAT-SPBAN TO PTOT.
           IF K = 6 AND FAT-SPBAN > ZERO
              MOVE 'SPESE BANCA' TO PSPESA
      **** rel 4.0
              IF VALUT = ZERO OR COMEURO
                 MOVE FAT-SPBAN TO PTOT1
              ELSE
                 MOVE FAT-ESPBAN TO PTOT1
              END-IF
              IF VALUT = 1 MOVE FAT-ESPBAN TO PTOT.
      *       IF VALUT <= 1
      *          MOVE FAT-SPBAN TO PTOT
      *       ELSE
      *          MOVE FAT-ESPBAN TO PTOT1.
      ************
      ************
           CALL 'rstam' USING PARST.
           GO TO LSCA.
       ESCA.
      **** rel 4.0
      *    IF VALUT > 1
      *       MOVE IMPON TO PIMP1
      *    ELSE
      *       MOVE IMPON TO PIMP.
           MOVE IMPON TO PIMP1.
           IF VALUT = 1 MOVE IMPON TO PIMP.
      ************
      **** rel 4.0
      *    MOVE IMPOS TO PIMIVA.
      ************
      **** rel 1.2
      **** rel 4.0
      *    IF VALUT > 1 AND FAT-CDESE = ZERO
      *       MOVE IMPOS TO EPIMIVA.
      ************
      ************
      **** rel 4.0
           MOVE IMPOS TO EPIMIVA.
           IF VALUT = 1
              MOVE IMPOS TO PIMIVA.
      ************
      **** rel 7.2
           IF (KFT-TDOC = 6 OR KFT-TDOC = 4) AND
              FAT-DATA >= 42005 
              GO TO NOSAC.
      ************
      **** rel 4.0
      *    IF KFT-TDOC NOT = 1 GO TO NOSAC.
      *    COMPUTE TOTACC = FAT-TOTFT - FAT-IMPOR(1)
      *                               - FAT-IMPOR(2)
      *                               - FAT-IMPOR(3)
      *                               - FAT-IMPOR(4)
      *                               - FAT-IMPOR(5)
      *                               - FAT-IMPOR(6).
           IF FAT-VALUT = ZERO OR COMEURO
              COMPUTE TOTACC = FAT-TOTFT - FAT-IMPOR(1)
                                         - FAT-IMPOR(2)
                                         - FAT-IMPOR(3)
                                         - FAT-IMPOR(4)
                                         - FAT-IMPOR(5)
                                         - FAT-IMPOR(6)
           ELSE
              COMPUTE TOTACC = FAT-TOVAL - FAT-EIMPOR(1)
                                         - FAT-EIMPOR(2)
                                         - FAT-EIMPOR(3)
                                         - FAT-EIMPOR(4)
                                         - FAT-EIMPOR(5)
                                         - FAT-EIMPOR(6).
      ************
           IF TOTACC > ZERO MOVE 'ACCONTO' TO PSCAD
      **** rel 4.0
                         MOVE TOTACC TO PSCIM2
                         IF VALUT = 1
      ************
                            MOVE TOTACC TO PSCIMP.
       NOSAC.
      **** rel 4.0
      *    IF VALUT > 1
      *       MOVE DSVAL TO PDSVAL
      *       MOVE FAT-TOVAL TO PTOT1
      *    ELSE
      *       MOVE FAT-TOTFT TO PTOT.
           IF VALUT = ZERO OR COMEURO
              MOVE FAT-TOTFT TO PTOT1
           ELSE
              MOVE FAT-TOVAL TO PTOT1.
           IF VALUT = 1 MOVE FAT-TOVAL TO PTOT.
      ************
           CALL 'rstam' USING PARST.
      **** rel 2.0
           IF KFT-TDOC = 8 OR 9 GO TO FINES.
      ************
      **** rel 6.2
           IF SWSIM = 1 GO TO RDN-LAV.
      ************
           GO TO NEWFAT.
      *-------------------------------
       RDCL.
           MOVE FAT-CDCLI TO COD.
           MOVE KAZ-COD   TO KCF-AZI.
           MOVE CODICE    TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID KEY
                  PERFORM INVK-CLF
                  PERFORM VISK-FAT
                  GO TO WARNING.
           IF SF-CLF = '9D' OR '9A' OR '35' MOVE RF-CLF TO REKCLF.
       EX-RDCL.
           EXIT.
      *-------------------------------
       NEWBOL.
      **** rel 1.2
      *    MOVE FAT-NBOL (K) TO BOBO.
      *    MOVE FAT-TNUM (K) TO BONU.
           MOVE RB-NBOL(K) TO BOBO.
           MOVE RB-TNUM(K) TO BONU.
      ************
           MOVE KBOL TO KEYBC.
       L9D.
           READ BOLCTE INVALID
                  PERFORM INVK-BCT
                  PERFORM VISK-FAT
                  GO TO WARNING.
           IF SF-BCT = '9D' OR '9A' OR '35' GO TO L9D.
           MOVE BCT-VALUT TO VALUT.
      **** rel 1.2
           MOVE 10        TO KTB-TIP.
           MOVE BCT-VALUT TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE ZERO TO T10-FSC.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T10-FSC TO FSC.
      ************
       EX-NEWBOL.
           EXIT.
      *-------------------------------
       FINES.
           MOVE ZERO TO SW-CARTA.
           MOVE 9 TO XCRR.
           CALL 'rstam' USING PARST.
      **** rel 2.0
      *    IF PF-TDOC = 2 GO TO LRFT.
      **** rel 4.0-2
      *    IF PF-TDOC = 2 OR 9 GO TO LRFT.
      **** rel 5.0
      *    IF PF-TDOC = 2 OR 9
           IF PF-TDOC = 1 OR 2 OR 9 
      ************
              PERFORM ATTESA
              GO TO LRFT.
      ************
      ************
           GO TO FINE.
      *-------------------------------
       ERRIO.
           COPY 'errsub'.
           MOVE 9 TO PF-ST.
      *-------------------------------
       FINE.
           CLOSE FATTUR.
           CLOSE ANAAZI.
           CLOSE ANACLF.
           CLOSE ANABAN.
           CLOSE TABELL.
           CLOSE BOLCTE.
           CLOSE BOLCRI.
           CLOSE ARTLIN.
      **** rel 2.0
           CLOSE NOTBCR.
           CLOSE PROBCR.
      ************
      **** rel 5.0
           CLOSE ANAIMB.
           CLOSE WDSSIB.
           OPEN OUTPUT WDSSIB.
           CLOSE WDSSIB.
      ************
      **** rel 7.1
           CLOSE NOTTAB.
      ************
           EXIT PROGRAM.
      *-------------------------------
       B00-STAMPA-RIGO.
           MOVE BCR-ART TO PART.
           MOVE BCR-DESCR TO PDES.
           IF AZI-FLING = ZERO GO TO RIG10.
           IF CLF-FLING = ZERO GO TO RIG10.
           MOVE KAZ-COD   TO KAL-AZI.
           MOVE BCR-ART   TO KAL-ART.
           READ ARTLIN INVALID GO TO RIG10.
           IF CLF-FLING = 1
              IF ARL-DES1 = SPACE GO TO RIG10
              ELSE     MOVE ARL-DES1 TO PDES.
           IF CLF-FLING = 2
              IF ARL-DES2 = SPACE GO TO RIG10
              ELSE     MOVE ARL-DES2 TO PDES.
           IF CLF-FLING = 3
              IF ARL-DES3 = SPACE GO TO RIG10
              ELSE     MOVE ARL-DES3 TO PDES.
       RIG10.
      **** rel 6.2
      *    IF BCR-TCOR = 1 GO TO B90.
           IF BCR-TCOR = 1 GO TO B91.
      ************
           IF BCR-TCOR = 3 GO TO B75.
           MOVE BCR-QTA TO PQTA.
           IF BCR-TQUAN = 1 MOVE BCR-QTA TO PQTA1.
           IF BCR-TQUAN = 2 MOVE BCR-QTA TO PQTA2.
           IF BCR-TCOR = 6 GO TO B76.
      **** rel 1.2
      *    IF BCR-TPRZ = 1
      *       MOVE BCR-PZLOR TO PPRZ1
      *    ELSE
      *       MOVE BCR-PZLOR TO PPRZ.
      **** rel 4.0
      *    MOVE BCR-PZLOR TO ER-PREZZO.
      *    CALL 'rfscprz' USING ER-PREZZO BCR-TPRZ FSC ER-NDEC.
      *    MOVE ER-PREZZO TO PPRZ.
      *    IF ER-NDEC = 1 OR 2 MOVE ER-PREZZO TO PPRZ1.
      *    IF ER-NDEC = 3      MOVE ER-PREZZO TO PPRZ3.
      *    IF ER-NDEC = 4      MOVE ER-PREZZO TO PPRZ4.
      *    IF ER-NDEC = 5      MOVE ER-PREZZO TO PPRZ5.
           MOVE KCR-AZI     TO OP-AZI
           MOVE BCT-VALUT   TO OP-VALUT.
           MOVE BCR-PZLOR   TO OP-PREZZO.
           MOVE BCR-FSC     TO OP-FSC.
           CALL 'routprz' USING PAROP OP-VEN.
           MOVE OP-PREZZO   TO PPRZ.
           IF OP-NDEC = 2 MOVE OP-PREZZO TO PPRZ1.
           IF OP-NDEC = 3 MOVE OP-PREZZO TO PPRZ3.
           IF OP-NDEC = 4 MOVE OP-PREZZO TO PPRZ4.
           IF OP-NDEC = 5 MOVE OP-PREZZO TO PPRZ5.
           IF OP-NDEC = 6 MOVE OP-PREZZO TO PPRZ6.
      ************
      ************
           IF BCR-TCOR > 3 AND < 7 GO TO B76.
           MOVE BCR-SC1 TO SC.
           IF SC = ZERO MOVE BCR-SC2 TO SC
           ELSE IF BCR-SC2 NOT = ZERO
                MULTIPLY -1 BY SC GIVING PSCO
                CALL 'rstam' USING PARST
                MOVE 1 TO XCRR
                MOVE BCR-SC2 TO SC.
           IF SC NOT = ZERO
              MULTIPLY -1 BY SC GIVING PSCO.
      **** rel 2.0
      *    IF BCR-TPRZ = 1
      *       MOVE BCR-PZNET TO PPNET1
      *    ELSE
      *       MOVE BCR-PZNET TO PPNET.
      **** rel 4.0
      *    MOVE BCR-PZNET TO ER-PREZZO.
      *    CALL 'rfscprz' USING ER-PREZZO BCR-TPRZ FSC ER-NDEC.
      *    MOVE ER-PREZZO TO PPNET.
      *    IF ER-NDEC = 1 OR 2 MOVE ER-PREZZO TO PPNET1.
      *    IF ER-NDEC = 3      MOVE ER-PREZZO TO PPNET3.
      *    IF ER-NDEC = 4      MOVE ER-PREZZO TO PPNET4.
      *    IF ER-NDEC = 5      MOVE ER-PREZZO TO PPNET5.
           MOVE KCR-AZI     TO OP-AZI
           MOVE BCT-VALUT   TO OP-VALUT.
           MOVE BCR-PZNET   TO OP-PREZZO.
           MOVE BCR-FSC     TO OP-FSC.
           CALL 'routprz' USING PAROP OP-VEN.
           MOVE OP-PREZZO   TO PPNET.
           IF OP-NDEC = 2 MOVE OP-PREZZO TO PPNET1.
           IF OP-NDEC = 3 MOVE OP-PREZZO TO PPNET3.
           IF OP-NDEC = 4 MOVE OP-PREZZO TO PPNET4.
           IF OP-NDEC = 5 MOVE OP-PREZZO TO PPNET5.
           IF OP-NDEC = 6 MOVE OP-PREZZO TO PPNET6.
      ************
      ************
       B75.
      **** rel 4.0
      *    IF VALUT > 1
      *       MOVE BCR-NETRG TO PTNET1
      *    ELSE
      *       MOVE BCR-NETRG TO PTNET.
           MOVE BCR-NETRG TO PTNET1.
           IF VALUT = 1 MOVE BCR-NETRG TO PTNET.
      ************
       B76.
           IF BCR-TCOR = 6 MOVE 'CESSIONE IN GARANZIA' TO DSGRA.
           IF BCR-TCOR = 4 MOVE 'CESSIONE GRATUITA' TO DSGRA.
           IF BCR-TCOR = 5 MOVE 'SCONTO IN MERCE'   TO DSGRA.
           IF BCR-TCOR NOT = 3 GO TO B80.
           MOVE 11 TO KTB-TIP.
           MOVE BCR-SPESA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           PERFORM VISK-BCR
                                           GO TO WARNING.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T11-SCONT > ZERO ADD BCR-NETRG TO NOSCON.
           IF FAT-CDESE = ZERO GO TO B80.
           IF BCR-IVA = ZERO GO TO B80.
           MOVE BCR-IVA TO T11-CIVA.
           MOVE 3 TO KTB-TIP.
           MOVE T11-CIVA TO KTB-COD PCIVA.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           PERFORM VISK-BCR
                                           GO TO WARNING.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      **** rel 4.0
      *    IF VALUT > 1 GO TO B80.
           IF NOT (VALUT = ZERO OR COMEURO OR 1) GO TO B80.
      ************
           IF T03-ALIVA = ZERO GO TO B90.
       B80.
           IF BCR-TCOR = 4 OR 5 MOVE BCR-RIVGR TO PCIVA
              ELSE IF FAT-CDESE = ZERO MOVE BCR-IVA TO PCIVA
      **** rel 5.1
      *            ELSE MOVE FAT-CDESE TO PCIVA.
                   ELSE IF BCR-TCOR NOT = 3 MOVE FAT-CDESE TO PCIVA.
      ************
      **** rel 1.2
      *    IF KFT-TDOC = 2 AND (BCR-TCOR = 4 OR 5 OR 6)
           IF VALUT NOT = ZERO AND
              FAT-CDESE NOT = ZERO AND (BCR-TCOR = 4 OR 5 OR 6)
      ************
                MOVE FAT-CDESE TO PCIVA.
       B90.
      **** rel 1.2
      *    IF BCR-TCOR = 6 AND KFT-TDOC = 2
           IF BCR-TCOR = 6 AND ESTPIVA = 3
      ************
                           ADD BCR-NETRG TO GARANZ.
      **** rel 1.2
      *    IF VALUT > 1 AND BCR-TCOR = 4 ADD BCR-NETRG TO OMAGG.
      *    IF VALUT > 1 AND BCR-TCOR = 5 ADD BCR-NETRG TO SCMER.
      ************
      **** rel 4.0
      *    IF VALUT > 1 AND BCR-TCOR < 4 ADD BCR-NETRG TO VNTMER.
           IF NOT (VALUT = ZERO OR COMEURO) AND BCR-TCOR < 4
              ADD BCR-NETRG TO VNTMER.
      ************
      **** rel 2.0
           MOVE 1 TO FLGSTA.
           IF BCR-SC1 = ZERO OR BCR-SC2 = ZERO
              CALL 'rstam' USING PARST
              MOVE ZERO TO FLGSTA
              MOVE 1 TO XCRR.
      *
      **** rel 6.2
       B91.
           MOVE 1     TO KNOT.
           MOVE 1     TO ML-IND.
           MOVE SPACE TO ML-REC.
      ************
      * stampa note aggiuntive
           MOVE KCR-AZI TO KNCR-AZI.
           MOVE KCR-NUM TO KNCR-NUM.
           MOVE KCR-BOL TO KNCR-BOL.
           MOVE KCR-PGR TO KNCR-PGR.
           MOVE ZERO    TO KNCR-PGRN.
           START NOTBCR KEY > KEYNCR INVALID GO TO B95.
       RDN-NCR.
           READ NOTBCR NEXT AT END GO TO B95.
           IF KNCR-AZI > KCR-AZI GO TO B95.
           IF KNCR-NUM > KCR-NUM GO TO B95.
           IF KNCR-BOL > KCR-BOL GO TO B95.
           IF KNCR-PGR > KCR-PGR GO TO B95.
      **** rel 6.2
      *    IF NRIG > NRIG01 PERFORM NWPG THRU EX-NWPG.
      *    MOVE NCR-DESCR TO PDES.
      ************
      ************
      **** rel 6.2
      *    CALL 'rstam' USING PARST.
      *    MOVE 1 TO XCRR.
           STRING NCR-DESCR(1:ML-LRIG-I) DELIMITED SIZE
                  INTO ML-REC POINTER ML-IND.
      ************
      **** rel 2.0
           MOVE ZERO TO FLGSTA.
           GO TO RDN-NCR.
      *
       B95.
      **** rel 6.2
           MOVE ML-MRIG   TO ML-MAXRIG.
           MOVE ML-LRIG-I TO ML-LUNRIG.
           MOVE 2         TO ML-FUN.
           CALL 'vrmle' USING ML-CTRL ML-REC.
           IF ML-ST > ZERO MOVE 'ERRORE vrmle' TO MESS
                           GO TO ERRIO.
           COMPUTE ML-MAXRIG = ML-MRIG * ML-LRIG-I / ML-LRIG-O.
           MOVE ML-LRIG-O TO ML-LUNRIG.
           MOVE 1 TO ML-FUN.
           CALL 'vrmle' USING ML-CTRL ML-REC.
           IF ML-ST > ZERO AND NOT = 6
              MOVE 'ERRORE vrmle' TO MESS
              GO TO ERRIO.
      *
           MOVE ZERO TO KNOT.
           MOVE 1 TO ML-IND.
       LOOP-NOTE.
           ADD 1 TO KNOT.
           IF KNOT > ML-MAXRIG GO TO FINE-LOOP.
           IF NRIG > NRIG01 PERFORM NWPG THRU EX-NWPG.
           MOVE ML-REC(ML-IND:ML-LRIG-O) TO PDES.
           ADD ML-LRIG-O TO ML-IND.
           CALL 'rstam' USING PARST.
           MOVE 1 TO XCRR.
      *
           GO TO LOOP-NOTE.
       FINE-LOOP.
      *
      ************
      **** rel 5.2
           IF BCR-ART NOT = SPACE
              MOVE ZERO     TO PCFA-FUN
              MOVE KCR-AZI  TO PCFA-AZI
              MOVE 'C'      TO PCFA-TIP
              MOVE FAT-CDCLI TO PCFA-CLF
              MOVE BCR-ART TO PCFA-ART
              MOVE CLF-FLING TO PCFA-LIN
              CALL 'vrrcfa' USING PARPCFA
              IF PCFA-ST = ZERO
                 IF PCFA-DEST NOT = SPACE
                    IF NRIG > NRIG01
                       PERFORM NWPG THRU EX-NWPG
                    END-IF
                    MOVE PCFA-DEST TO PDES
                    CALL 'rstam' USING PARST
                    MOVE 1 TO XCRR
                    MOVE ZERO TO FLGSTA
                 END-IF
                 IF PCFA-DDIS NOT = SPACE
                    IF NRIG > NRIG01
                       PERFORM NWPG THRU EX-NWPG
                    END-IF
                    MOVE PCFA-DDIS TO PDES
                    CALL 'rstam' USING PARST
                    MOVE 1 TO XCRR
                    MOVE ZERO TO FLGSTA.
      ************
           IF FLGSTA = 1 CALL 'rstam' USING PARST
                         MOVE 1 TO XCRR.
      **** rel 5.0
      *    IF BCT-IMB = 1 PERFORM SOMMA-IMBALLI THRU EX-SOMMA-IMBALLI.
           IF BCT-IMB = 1 PERFORM WR-LAV-IMB THRU EX-WR-LAV-IMB.
      ************
      ************
       B99.
           EXIT.
      *-------------------------------
      **** rel 1.2
      *SCAVAL.
      *    MOVE ZERO TO J.
      *SVAL10.
      *    ADD 1 TO J.
      *    IF J > 6 GO TO SVAL50.
      *    MOVE FAT-DTSCA(J) TO SV-DTSCA(J).
      *    MOVE FAT-IMPOR(J) TO SV-IMPOR(J).
      *    GO TO SVAL10.
      *SVAL50.
      *    MOVE FAT-DTVAL    TO SV-DTVAL.
      *    CALL 'vrscadv' USING PARSV.
      *EX-SCAVAL.
      *    EXIT.
      ************
      *-------------------------------
           COPY 'errmes'.
      **** rel 2.0
           COPY 'erreur'.
      ************
           COPY 'griazier'.
           COPY 'griclfer'.
           COPY 'gribaner'.
           COPY 'gribcter'.
           COPY 'gribcrer'.
           COPY 'grifater'.
           COPY 'griliner'.
           COPY 'gritaber'.
      **** rel 2.0
           COPY 'grincrer'.
           COPY 'gripbrer'.
      ************
      **** rel 5.0
           COPY 'griaimer'.
      ************
      **** rel 7.1
           COPY 'grintaer'.
      ************
           COPY 'grixxxer'.
      *-------------------------------
      **** rel 5.0
       WR-LAV-IMB.
           IF NOT (BCR-TCOR = ZERO OR 2) GO TO EX-WR-LAV-IMB.
           MOVE KBC-AZI TO KPBR-AZI.
           MOVE KBC-NUM TO KPBR-TNUM.
           MOVE KBC-BOL TO KPBR-NBOL.
           MOVE KCR-PGR TO KPBR-RBOL.
           MOVE ZERO    TO KPBR-PGR.
           START PROBCR KEY NOT < KEYPBR INVALID GO TO EX-WR-LAV-IMB.
       LAV-IMB-10.
           READ PROBCR NEXT AT END GO TO EX-WR-LAV-IMB.
           IF SF-PBR = '9D' OR '9A' OR '35' GO TO LAV-IMB-10.
           IF KBC-AZI  NOT = KPBR-AZI GO TO EX-WR-LAV-IMB.
           IF KBC-NUM NOT = KPBR-TNUM GO TO EX-WR-LAV-IMB.
           IF KBC-BOL NOT = KPBR-NBOL GO TO EX-WR-LAV-IMB.
           IF KCR-PGR NOT = KPBR-RBOL GO TO EX-WR-LAV-IMB.
      *
           MOVE KBC-AZI TO KAIM-AZI.
           MOVE PBR-IMB TO KAIM-COD.
           READ ANAIMB INVALID PERFORM INVK-AIM
                               PERFORM VISK-PBR
                               GO TO ERRIO.
           IF AIM-FLGREND = 1 GO TO LAV-IMB-10.
      *
           MOVE PBR-NPAL TO KWSI-NPAL.
           MOVE PBR-NCOL TO KWSI-NCOL.
           MOVE PBR-IMB  TO KWSI-IMB.
           ADD 1         TO KWSI-PRG.
           MOVE PBR-NIMB TO WSI-NIMB.
           WRITE RF-WSI INVALID MOVE 'vfat210: WR-LAV WSI' TO MESS
                                GO TO ERRIO.
      *
           GO TO LAV-IMB-10.
       EX-WR-LAV-IMB.
           EXIT.
      *-------------------------------
       DL-LAV-IMB.
           CLOSE WDSSIB.
           OPEN OUTPUT WDSSIB.
           CLOSE WDSSIB.
           OPEN I-O WDSSIB.
           MOVE ZERO TO KWSI-PRG.
       EX-DL-LAV-IMB.
      *-------------------------------
       SOMMA-IMBALLI.
      * azzeramento vettore totali imballi
           MOVE 1 TO INDICE.
           PERFORM UNTIL INDICE > 30
              MOVE SPACE TO VETIMB(INDICE)
              MOVE ZERO  TO VETQTA(INDICE)
              ADD 1 TO INDICE
           END-PERFORM.
      *
           MOVE ZERO  TO PREPAL PRECOL.
           MOVE SPACE TO PREIMB.
           MOVE ZERO  TO ULTIND.
      *
           MOVE LOW-VALUE TO KEYWSI.
           START WDSSIB KEY > KEYWSI INVALID GO TO EX-SOMMA-IMBALLI.
       SOMMA-IMB-10.
           READ WDSSIB NEXT AT END GO TO EX-SOMMA-IMBALLI.
           IF KWSI-NCOL = ZERO
              MOVE WSI-NIMB TO COMNIMB
              GO TO SOMMA-IMB-20.
           IF KWSI-NPAL = PREPAL AND
              KWSI-NCOL = PRECOL AND
              KWSI-IMB  = PREIMB GO TO SOMMA-IMB-10.
           MOVE 1 TO COMNIMB.
       SOMMA-IMB-20.
           MOVE KWSI-NPAL TO PREPAL.
           MOVE KWSI-NCOL TO PRECOL.
           MOVE KWSI-IMB  TO PREIMB.
      *
           MOVE 1 TO INDICE.
           PERFORM UNTIL INDICE > 30
              IF VETIMB(INDICE) = SPACE
                 MOVE KWSI-IMB TO VETIMB(INDICE)
                 MOVE COMNIMB  TO VETQTA(INDICE)
                 MOVE INDICE TO ULTIND
                 MOVE 30 TO INDICE
              ELSE
                 IF VETIMB(INDICE) = KWSI-IMB
                     ADD COMNIMB TO VETQTA(INDICE)
                     MOVE 30 TO INDICE
                 END-IF
              END-IF
              ADD 1 TO INDICE
           END-PERFORM.
      *
           GO TO SOMMA-IMB-10.
       EX-SOMMA-IMBALLI.
           EXIT.
      *-------------------------------
      ************
      **** rel 2.0
      **** rel 5.0
      *SOMMA-IMBALLI.
      *    IF NOT (BCR-TCOR = ZERO OR 2) GO TO EX-SOMMA-IMBALLI.
      *    MOVE KBC-AZI TO KPBR-AZI.
      *    MOVE KBC-NUM TO KPBR-TNUM.
      *    MOVE KBC-BOL TO KPBR-NBOL.
      *    MOVE KCR-PGR TO KPBR-RBOL.
      *    MOVE ZERO    TO KPBR-PGR.
      *    START PROBCR KEY NOT < KEYPBR INVALID GO TO EX-SOMMA-IMBALLI.
      *SOMM-IMB-10.
      *    READ PROBCR NEXT AT END GO TO EX-SOMMA-IMBALLI.
      *    IF SF-PBR = '9D' OR '9A' OR '35' GO TO SOMM-IMB-10.
      *    IF KBC-AZI  NOT = KPBR-AZI GO TO EX-SOMMA-IMBALLI.
      *    IF KBC-NUM NOT = KPBR-TNUM GO TO EX-SOMMA-IMBALLI.
      *    IF KBC-BOL NOT = KPBR-NBOL GO TO EX-SOMMA-IMBALLI.
      *    IF KCR-PGR NOT = KPBR-RBOL GO TO EX-SOMMA-IMBALLI.
      *
      *    MOVE ZERO TO INDICE.
      *RIPETI.
      *    ADD 1 TO INDICE.
      *    IF INDICE > ULTIND GO TO NEWIMB.
      *    IF PBR-IMB = VETIMB(INDICE)
      *       ADD PBR-NIMB TO VETQTA(INDICE)
      *       GO TO SOMM-IMB-10.
      *    GO TO RIPETI.
      *NEWIMB.
      *    ADD 1 TO ULTIND.
      *    IF ULTIND > 10 GO TO EX-SOMMA-IMBALLI.
      *    MOVE PBR-IMB  TO VETIMB(ULTIND).
      *    MOVE PBR-NIMB TO VETQTA(ULTIND).
      *    GO TO SOMM-IMB-10.
      *EX-SOMMA-IMBALLI.
      *    EXIT.
      ************
      ************
      *-------------------------------
       G00-STAMPA-IMBALLI.
           MOVE ZERO TO INDICE.
       REPEAT.
           ADD 1 TO INDICE.
           IF INDICE > ULTIND GO TO G99.
           IF NRIG > NRIG01 PERFORM NWPG THRU EX-NWPG.
      **** rel 5.0
      *    MOVE 80             TO KTB-TIP.
      *    MOVE VETIMB(INDICE) TO KTB-COD.
      *    READ TABELL INTO REKTAB INVALID KEY PERFORM INVK-TAB
      *                                        GO TO ERRIO.
      *    IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE KAZ-COD        TO KAIM-AZI.
           MOVE VETIMB(INDICE) TO KAIM-COD.
           READ ANAIMB INVALID PERFORM INVK-AIM
                               GO TO ERRIO.
      ************
           MOVE VETIMB(INDICE) TO PCDIMB.
      **** rel 5.0
      *    MOVE TAB-DESCR      TO PDIMB.
           MOVE AIM-DESC       TO PDIMB.
      ************
           MOVE VETQTA(INDICE) TO PQTIMB.
      **** rel 4.0
      *    IF VALUT > 1
      *       MOVE T80-COSU TO ER-IMPORTO
      *       CALL 'rtriimp' USING ER-IMPORTO LIR-VAL CG-PAR
      *       MOVE ER-IMPORTO TO PPZIMB1
      *       COMPUTE ER-IMPORTO = ER-IMPORTO * VETQTA(INDICE)
      *       MOVE ER-IMPORTO TO PIMPNT1
      *    ELSE
      *       MOVE T80-COSU TO PPZIMB
      *       COMPUTE IMPIMB = VETQTA(INDICE) * T80-COSU
      *       MOVE IMPIMB TO PIMPNT.
           IF VALUT = ZERO OR COMEURO
      **** rel 5.0
      *       MOVE T80-COSU TO PPZIMB1
      *       COMPUTE IMPIMB = VETQTA(INDICE) * T80-COSU
              MOVE AIM-COSU TO PPZIMB1
              COMPUTE IMPIMB = VETQTA(INDICE) * AIM-COSU
      ************
              MOVE IMPIMB TO PIMPNT1
           ELSE
      **** rel 5.0
      *       MOVE T80-COSU TO ER-IMPORTO
              MOVE AIM-COSU TO ER-IMPORTO
      ************
              MOVE CG-CAMBIO TO ER-CAMBIO
              MOVE CG-VALUT  TO ER-VALUT
              CALL 're2imp' USING ER-IMPORTO EUR-VAL ER-VALUT ER-CAMBIO
              MOVE ER-IMPORTO TO PPZIMB1
              IF VALUT = 1
                 MOVE ER-IMPORTO TO PPZIMB
              END-IF
              COMPUTE ER-IMPORTO = ER-IMPORTO * VETQTA(INDICE)
              ADD ER-IMPORTO TO VNTMER
              MOVE ER-IMPORTO TO PIMPNT1
              IF VALUT = 1
                 MOVE ER-IMPORTO TO PIMPNT.
      ************
           IF FAT-CDESE = ZERO
      **** rel 5.0
      *       MOVE T80-CDIVA TO PIVAIM
              MOVE AIM-CDIVA TO PIVAIM
      ************
           ELSE
              MOVE FAT-CDESE TO PIVAIM.
           MOVE 1 TO XCRR.
           CALL 'rstam' USING PARST.
           GO TO REPEAT.
       G99.
           EXIT.
      *-------------------------------
       STAMPA-CONAI.
           IF CLF-CONAI NOT = 1 GO TO EX-STAMPA-CONAI.
           IF NRIG > NRIG01
              PERFORM NWPG THRU EX-NWPG
           ELSE
              MOVE 2 TO XCRR.
           MOVE 'CONTRIBUTO CONAI ASSOLTO' TO PCONAI.
           CALL 'rstam' USING PARST.
       EX-STAMPA-CONAI.
           EXIT.
      *-------------------------------
      ************
      **** rel 4.0-2
      * loop di attesa per dare tempo al visualizzatore di partire e
      * di lockare il file di stampa
       ATTESA.
           MOVE 1000 TO KATTESA.
           PERFORM UNTIL KATTESA = ZERO
              CALL 'CBL_YIELD_RUN_UNIT'
              SUBTRACT 1 FROM KATTESA
           END-PERFORM.
      *-------------------------------
      ************
      **** rel 5.0
      *------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-WSI.
           STRING 'w0' PID DELIMITED SPACE INTO ID-WSI.
      **** rel 6.2
           MOVE SPACE TO ID-LAV.
           STRING 'w3' PID DELIMITED SPACE INTO ID-LAV.
      ************
       EX-CREA-IDLAV.
           EXIT.
      *------------------
      ************
      **** rel 5.0
       H00-STAMPA-MESSAGG-BOLLA.
           MOVE 2 TO XCRR.
           MOVE KAZ-COD  TO P-MDT-AZI.
           MOVE 1        TO P-MDT-TDOC.
           MOVE KEYBC    TO P-MDT-KEY.
           MOVE 2        TO P-MDT-FLGS.
           MOVE BCT-DATA TO P-MDT-DATA.
           MOVE ZERO     TO P-MDT-FLGE.
       H10.
           CALL 'vrpmdt' USING PAR-P-MDT.
           IF P-MDT-FLGE NOT = 1 GO TO H99.
           IF NRIG > NRIG01 - XCRR + 1 PERFORM NWPG THRU EX-NWPG.
           STRING '* ' P-MDT-TESTO(1:P-MDT-NCOL) ' *'
                  DELIMITED SIZE INTO RIGA(2:).
           CALL 'rstam' USING PARST.
           MOVE 1 TO XCRR.
           GO TO H10.
       H99.
           EXIT.
      *------------------
       F00-STAMPA-MESSAGG-FATT.
           MOVE 2 TO XCRR.
           MOVE KAZ-COD  TO P-MDT-AZI.
           MOVE 3        TO P-MDT-TDOC.
           MOVE KEYFT    TO P-MDT-KEY.
           MOVE ZERO     TO P-MDT-FLGS.
           MOVE FAT-DATA TO P-MDT-DATA.
           MOVE ZERO     TO P-MDT-FLGE.
       F10.
           CALL 'vrpmdt' USING PAR-P-MDT.
           IF P-MDT-FLGE NOT = 1 GO TO F99.
           IF NRIG > NRIG01 - XCRR + 1 PERFORM NWPG THRU EX-NWPG.
           STRING '* ' P-MDT-TESTO(1:P-MDT-NCOL) ' *'
                  DELIMITED SIZE INTO RIGA(2:).
           CALL 'rstam' USING PARST.
           MOVE 1 TO XCRR.
           GO TO F10.
       F99.
           EXIT.
      ************
      **** rel 7.1
      *------------------
       I00-STAMPA-NOTEIVA.
      *
           MOVE ZERO TO FLGTES.
           MOVE 2 TO XCRR.
      *
           MOVE 3       TO KNTA-TIP.
           MOVE FAT-CDESE TO KNTA-COD.
           MOVE ZERO    TO KNTA-PRG.
           START NOTTAB KEY >= KEYNTA INVALID GO TO I20.
       I10.
           READ NOTTAB NEXT AT END GO TO I20.
           IF KNTA-TIP > 3         GO TO I20.
           IF KNTA-COD > FAT-CDESE GO TO I20.
      *
           MOVE 1 TO FLGTES.
      *
           IF NRIG > NRIG01 - XCRR + 1 PERFORM NWPG THRU EX-NWPG.
           STRING '* ' NTA-DESCR(1:30) ' *'
                  DELIMITED SIZE INTO RIGA(2:).
           CALL 'rstam' USING PARST.
           MOVE 1 TO XCRR.
      *
           GO TO I10.
       I20.
      *
           IF FLGTES = 1 GO TO I99.
           MOVE ZERO TO K.
      *
       LCIVA.
      *
           ADD 1 TO K.
           IF K > 6 GO TO I99.
      *
           IF FAT-CDIVA (K) = ZERO GO TO I99.
      *
           MOVE FAT-CDIVA (K) TO KNTA-COD.
           MOVE 3             TO KNTA-TIP.
           MOVE ZERO    TO KNTA-PRG.
           START NOTTAB KEY >= KEYNTA INVALID GO TO I98.
       I15.
           READ NOTTAB NEXT AT END GO TO I98.
           IF KNTA-TIP > 3         GO TO I98.
           IF KNTA-COD > FAT-CDIVA (K) GO TO I98.
      *
           IF NRIG > NRIG01 - XCRR + 1 PERFORM NWPG THRU EX-NWPG.
      *
           STRING '* ' NTA-DESCR(1:30) ' *'
                  DELIMITED SIZE INTO RIGA(2:).
           CALL 'rstam' USING PARST.
           MOVE 1 TO XCRR.
      *
           GO TO I15.
      *
       I98.
      *
           GO TO LCIVA.
       I99.
           EXIT.
      *------------------
      ************
      **** rel 7.2
       J00-STAMPA-SPLITPAY.
      *
           MOVE 2 TO XCRR.
           MOVE '- Scissione dei pagamenti -'  TO PDES.
           CALL 'rstam' USING PARST.
           MOVE 1 TO XCRR.
           MOVE 'Iva da versare a cura del'    TO PDES.
           CALL 'rstam' USING PARST.
           MOVE 'cessionario o committente ai' TO PDES.
           CALL 'rstam' USING PARST.
           MOVE 'sensi dell''Articolo 17-Ter'  TO PDES.
           CALL 'rstam' USING PARST.
           MOVE 'D.P.R n.633/1972 e '         TO PDES.
           CALL 'rstam' USING PARST.
           MOVE 'successive modifiche'         TO PDES.
           CALL 'rstam' USING PARST.
      *
       J99.
           EXIT.
      *-------------------------------
      ************
